/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/product/common/productService","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","fs","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],x=function($){for(var e=[],v=0,L=$.length;v<L;v++)e[v]=J[$[v]];return e};define(J[102],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,A){if(!L)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=v}),define(J[46],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(E){return(n,w,y)=>{let i=null,I=null;if(typeof y.value=="function"?(i="value",I=y.value):typeof y.get=="function"&&(i="get",I=y.get),!I)throw new Error("not supported");y[i]=E(I,w)}}e.createDecorator=v;function L(E,n,w){let y=null,i=null;if(typeof w.value=="function"?(y="value",i=w.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(y="get",i=w.get),!i)throw new Error("not supported");const I=`$memoize$${n}`;w[y]=function(...k){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,k)}),this[I]}}e.memoize=L;function A(E,n,w){return v((y,i)=>{const I=`$debounce$${i}`,k=`$debounce$result$${i}`;return function(...p){this[k]||(this[k]=w?w():void 0),clearTimeout(this[I]),n&&(this[k]=n(this[k],...p),p=[this[k]]),this[I]=setTimeout(()=>{y.apply(this,p),this[k]=w?w():void 0},E)}})}e.debounce=A;function S(E,n,w){return v((y,i)=>{const I=`$throttle$timer$${i}`,k=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,g=`$throttle$pending$${i}`;return function(...m){if(this[k]||(this[k]=w?w():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),n&&(this[k]=n(this[k],...m)),this[g])return;const D=this[p]+E;D<=Date.now()?(this[p]=Date.now(),y.apply(this,[this[k]]),this[k]=w?w():void 0):(this[g]=!0,this[I]=setTimeout(()=>{this[g]=!1,this[p]=Date.now(),y.apply(this,[this[k]]),this[k]=w?w():void 0},D-Date.now()))}})}e.throttle=S}),define(J[19],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function L(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=L;function A(a){w(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=A;function S(a){w(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=S;function E(a){if(a instanceof Error){let{name:t,message:r}=a;const s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s}}return a}e.transformErrorForSerialization=E;const n="Canceled";function w(a){return a instanceof Error&&a.name===n&&a.message===n}e.isPromiseCanceledError=w;class y extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=y;function i(){const a=new Error(n);return a.name=a.message,a}e.canceled=i;function I(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=I;function k(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=k;function p(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function g(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=g;function m(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=m;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class l extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=l;function u(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function o(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=o}),define(J[35],x([0,1,19]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(C,F=0){return C[C.length-(1+F)]}e.tail=L;function A(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=A;function S(C,F,R=(O,P)=>O===P){if(C===F)return!0;if(!C||!F||C.length!==F.length)return!1;for(let O=0,P=C.length;O<P;O++)if(!R(C[O],F[O]))return!1;return!0}e.equals=S;function E(C,F,R){let O=0,P=C.length-1;for(;O<=P;){const W=(O+P)/2|0,_=R(C[W],F);if(_<0)O=W+1;else if(_>0)P=W-1;else return W}return-(O+1)}e.binarySearch=E;function n(C,F){let R=0,O=C.length;if(O===0)return 0;for(;R<O;){const P=Math.floor((R+O)/2);F(C[P])?O=P:R=P+1}return R}e.findFirstInSorted=n;function w(C,F,R){if(C=C|0,C>=F.length)throw new TypeError("invalid index");let O=F[Math.floor(F.length*Math.random())],P=[],W=[],_=[];for(let q of F){const V=R(q,O);V<0?P.push(q):V>0?W.push(q):_.push(q)}return C<P.length?w(C,P,R):C<P.length+_.length?_[0]:w(C-(P.length+_.length),W,R)}e.quickSelect=w;function y(C,F){const R=[];let O;for(const P of C.slice(0).sort(F))!O||F(O[0],P)!==0?(O=[P],R.push(O)):O.push(P);return R}e.groupBy=y;function i(C,F,R){const O=[];function P(q,V,K){if(V===0&&K.length===0)return;const Z=O[O.length-1];Z&&Z.start+Z.deleteCount===q?(Z.deleteCount+=V,Z.toInsert.push(...K)):O.push({start:q,deleteCount:V,toInsert:K})}let W=0,_=0;for(;;){if(W===C.length){P(W,0,F.slice(_));break}if(_===F.length){P(W,C.length-W,[]);break}const q=C[W],V=F[_],K=R(q,V);K===0?(W+=1,_+=1):K<0?(P(W,1,[]),W+=1):K>0&&(P(W,0,[V]),_+=1)}return O}e.sortedDiff=i;function I(C,F,R){const O=i(C,F,R),P=[],W=[];for(const _ of O)P.push(...C.slice(_.start,_.start+_.deleteCount)),W.push(..._.toInsert);return{removed:P,added:W}}e.delta=I;function k(C,F,R){if(R===0)return[];const O=C.slice(0,R).sort(F);return g(C,F,O,R,C.length),O}e.top=k;function p(C,F,R,O,P){return R===0?Promise.resolve([]):new Promise((W,_)=>{(async()=>{const q=C.length,V=C.slice(0,R).sort(F);for(let K=R,Z=Math.min(R+O,q);K<q;K=Z,Z=Math.min(Z+O,q)){if(K>R&&await new Promise(ne=>setTimeout(ne)),P&&P.isCancellationRequested)throw v.canceled();g(C,F,V,K,Z)}return V})().then(W,_)})}e.topAsync=p;function g(C,F,R,O,P){for(const W=R.length;O<P;O++){const _=C[O];if(F(_,R[W-1])<0){R.pop();const q=n(R,V=>F(_,V)<0);R.splice(q,0,_)}}}function m(C){return C.filter(F=>!!F)}e.coalesce=m;function D(C){let F=0;for(let R=0;R<C.length;R++)C[R]&&(C[F]=C[R],F+=1);C.length=F}e.coalesceInPlace=D;function b(C,F,R){C.splice(R,0,C.splice(F,1)[0])}e.move=b;function l(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=l;function u(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=u;function o(C,F){if(!F)return C.filter((O,P)=>C.indexOf(O)===P);const R=Object.create(null);return C.filter(O=>{const P=F(O);return R[P]?!1:(R[P]=!0,!0)})}e.distinct=o;function a(C){const F=new Set;return C.filter(R=>F.has(R)?!1:(F.add(R),!0))}e.distinctES6=a;function t(C){const F=Object.create(null);return R=>{const O=C(R);return F[O]?!1:(F[O]=!0,!0)}}e.uniqueFilter=t;function r(C,F){for(let R=C.length-1;R>=0;R--){const O=C[R];if(F(O))return R}return-1}e.lastIndex=r;function s(C,F){return C.length>0?C[0]:F}e.firstOrDefault=s;function c(C,F,R=(O,P)=>O===P){let O=0;for(let P=0,W=Math.min(C.length,F.length);P<W&&R(C[P],F[P]);P++)O++;return O}e.commonPrefixLength=c;function d(C){return[].concat(...C)}e.flatten=d;function f(C,F){let R=typeof F=="number"?C:0;typeof F=="number"?R=C:(R=0,F=C);const O=[];if(R<=F)for(let P=R;P<F;P++)O.push(P);else for(let P=R;P>F;P--)O.push(P);return O}e.range=f;function h(C,F,R){return C.reduce((O,P)=>(O[F(P)]=R?R(P):P,O),Object.create(null))}e.index=h;function M(C,F){return C.push(F),()=>T(C,F)}e.insert=M;function T(C,F){const R=C.indexOf(F);if(R>-1)return C.splice(R,1),F}e.remove=T;function U(C,F,R){const O=C.slice(0,F),P=C.slice(F);return O.concat(R,P)}e.arrayInsert=U;function H(C,F){let R;if(typeof F=="number"){let O=F;R=()=>{const P=Math.sin(O++)*179426549;return P-Math.floor(P)}}else R=Math.random;for(let O=C.length-1;O>0;O-=1){const P=Math.floor(R()*(O+1)),W=C[O];C[O]=C[P],C[P]=W}}e.shuffle=H;function X(C,F){const R=C.indexOf(F);R>-1&&(C.splice(R,1),C.unshift(F))}e.pushToStart=X;function ee(C,F){const R=C.indexOf(F);R>-1&&(C.splice(R,1),C.push(F))}e.pushToEnd=ee;function B(C,F){return Array.isArray(C)?C.map(F):F(C)}e.mapArrayOrNot=B;function Y(C){return Array.isArray(C)?C:[C]}e.asArray=Y;function Q(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=Q;function N(C,F){for(const R of C){const O=F(R);if(O!==void 0)return O}}e.mapFind=N;function G(C,F){let R=Number.MAX_SAFE_INTEGER,O=0;return C.forEach((P,W)=>{const _=F(P);_<R&&(R=_,O=W)}),O}e.minIndex=G;function z(C,F){let R=Number.MIN_SAFE_INTEGER,O=0;return C.forEach((P,W)=>{const _=F(P);_>R&&(R=_,O=W)}),O}e.maxIndex=z}),define(J[42],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const A=this;let S=!1,E;return function(){return S||(S=!0,E=L.apply(A,arguments)),E}}e.once=v}),define(J[63],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function A(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}L.is=A;const S=Object.freeze([]);function E(){return S}L.empty=E;function*n(a){yield a}L.single=n;function w(a){return a||S}L.from=w;function y(a){return!a||a[Symbol.iterator]().next().done===!0}L.isEmpty=y;function i(a){return a[Symbol.iterator]().next().value}L.first=i;function I(a,t){for(const r of a)if(t(r))return!0;return!1}L.some=I;function k(a,t){for(const r of a)if(t(r))return r}L.find=k;function*p(a,t){for(const r of a)t(r)&&(yield r)}L.filter=p;function*g(a,t){let r=0;for(const s of a)yield t(s,r++)}L.map=g;function*m(...a){for(const t of a)for(const r of t)yield r}L.concat=m;function*D(a){for(const t of a)for(const r of t)yield r}L.concatNested=D;function b(a,t,r){let s=r;for(const c of a)s=t(s,c);return s}L.reduce=b;function*l(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}L.slice=l;function u(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const s=a[Symbol.iterator]();for(let c=0;c<t;c++){const d=s.next();if(d.done)return[r,L.empty()];r.push(d.value)}return[r,{[Symbol.iterator](){return s}}]}L.consume=u;function o(a,t,r=(s,c)=>s===c){const s=a[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const d=s.next(),f=c.next();if(d.done!==f.done)return!1;if(d.done)return!0;if(!r(d.value,f.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(J[43],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function E(t,r=!1){let s=0,c=t.length,d="",f=0,h=16,M=0;function T(Q){let N=0,G=0;for(;N<Q;){const z=t.charCodeAt(s);if(z>=48&&z<=57)G=G*16+z-48;else if(z>=65&&z<=70)G=G*16+z-65+10;else if(z>=97&&z<=102)G=G*16+z-97+10;else break;s++,N++}return N<Q&&(G=-1),G}function U(Q){s=Q,d="",f=0,h=16,M=0}function H(){const Q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&y(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&y(t.charCodeAt(s)))for(s++;s<t.length&&y(t.charCodeAt(s));)s++;else return M=3,t.substring(Q,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&y(t.charCodeAt(s))){for(s++;s<t.length&&y(t.charCodeAt(s));)s++;N=s}else M=3;return t.substring(Q,N)}function X(){let Q="",N=s;for(;;){if(s>=c){Q+=t.substring(N,s),M=2;break}const G=t.charCodeAt(s);if(G===34){Q+=t.substring(N,s),s++;break}if(G===92){if(Q+=t.substring(N,s),s++,s>=c){M=2;break}switch(t.charCodeAt(s++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const C=T(4);C>=0?Q+=String.fromCharCode(C):M=4;break;default:M=5}N=s;continue}if(G>=0&&G<=31)if(w(G)){Q+=t.substring(N,s),M=2;break}else M=6;s++}return Q}function ee(){if(d="",M=0,f=s,s>=c)return f=c,h=17;let Q=t.charCodeAt(s);if(n(Q)){do s++,d+=String.fromCharCode(Q),Q=t.charCodeAt(s);while(n(Q));return h=15}if(w(Q))return s++,d+=String.fromCharCode(Q),Q===13&&t.charCodeAt(s)===10&&(s++,d+=`
`),h=14;switch(Q){case 123:return s++,h=1;case 125:return s++,h=2;case 91:return s++,h=3;case 93:return s++,h=4;case 58:return s++,h=6;case 44:return s++,h=5;case 34:return s++,d=X(),h=10;case 47:const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<c&&!w(t.charCodeAt(s));)s++;return d=t.substring(N,s),h=12}if(t.charCodeAt(s+1)===42){s+=2;const G=c-1;let z=!1;for(;s<G;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,M=1),d=t.substring(N,s),h=13}return d+=String.fromCharCode(Q),s++,h=16;case 45:if(d+=String.fromCharCode(Q),s++,s===c||!y(t.charCodeAt(s)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=H(),h=11;default:for(;s<c&&B(Q);)s++,Q=t.charCodeAt(s);if(f!==s){switch(d=t.substring(f,s),d){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return d+=String.fromCharCode(Q),s++,h=16}}function B(Q){if(n(Q)||w(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Y(){let Q;do Q=ee();while(Q>=12&&Q<=15);return Q}return{setPosition:U,getPosition:()=>s,scan:r?Y:ee,getToken:()=>h,getTokenValue:()=>d,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>M}}e.createScanner=E;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,r){const s=[],c=new Object;let d;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function M(T,U,H,X){f.value=T,f.offset=U,f.length=H,f.type=X,f.colonOffset=void 0,d=f}try{u(t,{onObjectBegin:(T,U)=>{if(r<=T)throw c;d=void 0,h=r>T,s.push("")},onObjectProperty:(T,U,H)=>{if(r<U||(M(T,U,H,"property"),s[s.length-1]=T,r<=U+H))throw c},onObjectEnd:(T,U)=>{if(r<=T)throw c;d=void 0,s.pop()},onArrayBegin:(T,U)=>{if(r<=T)throw c;d=void 0,s.push(0)},onArrayEnd:(T,U)=>{if(r<=T)throw c;d=void 0,s.pop()},onLiteralValue:(T,U,H)=>{if(r<U||(M(T,U,H,a(T)),r<=U+H))throw c},onSeparator:(T,U,H)=>{if(r<=U)throw c;if(T===":"&&d&&d.type==="property")d.colonOffset=U,h=!1,d=void 0;else if(T===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(h=!0,s[s.length-1]=""),d=void 0}}})}catch(T){if(T!==c)throw T}return{path:s,previousNode:d,isAtPropertyKey:h,matches:T=>{let U=0;for(let H=0;U<T.length&&H<s.length;H++)if(T[U]===s[H]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=I;function k(t,r=[],s=S.DEFAULT){let c=null,d=[];const f=[];function h(T){Array.isArray(d)?d.push(T):c!==null&&(d[c]=T)}return u(t,{onObjectBegin:()=>{const T={};h(T),f.push(d),d=T,c=null},onObjectProperty:T=>{c=T},onObjectEnd:()=>{d=f.pop()},onArrayBegin:()=>{const T=[];h(T),f.push(d),d=T,c=null},onArrayEnd:()=>{d=f.pop()},onLiteralValue:h,onError:(T,U,H)=>{r.push({error:T,offset:U,length:H})}},s),d[0]}e.parse=k;function p(t,r=[],s=S.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(T){c.type==="property"&&(c.length=T-c.offset,c=c.parent)}function f(T){return c.children.push(T),T}u(t,{onObjectBegin:T=>{c=f({type:"object",offset:T,length:-1,parent:c,children:[]})},onObjectProperty:(T,U,H)=>{c=f({type:"property",offset:U,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:T,offset:U,length:H,parent:c})},onObjectEnd:(T,U)=>{c.length=T+U-c.offset,c=c.parent,d(T+U)},onArrayBegin:(T,U)=>{c=f({type:"array",offset:T,length:-1,parent:c,children:[]})},onArrayEnd:(T,U)=>{c.length=T+U-c.offset,c=c.parent,d(T+U)},onLiteralValue:(T,U,H)=>{f({type:a(T),offset:U,length:H,parent:c,value:T}),d(U+H)},onSeparator:(T,U,H)=>{c.type==="property"&&(T===":"?c.colonOffset=U:T===","&&d(U))},onError:(T,U,H)=>{r.push({error:T,offset:U,length:H})}},s);const M=c.children[0];return M&&delete M.parent,M}e.parseTree=p;function g(t,r){if(!t)return;let s=t;for(let c of r)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let d=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===c){s=f.children[1],d=!0;break}if(!d)return}else{const d=c;if(s.type!=="array"||d<0||!Array.isArray(s.children)||d>=s.children.length)return;s=s.children[d]}return s}e.findNodeAtLocation=g;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=m;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let s of t.children){const c=s.children[1];c&&(r[s.children[0].value]=D(c))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function l(t,r,s=!1){if(b(t,r,s)){const c=t.children;if(Array.isArray(c))for(let d=0;d<c.length&&c[d].offset<=r;d++){const f=l(c[d],r,s);if(f)return f}return t}}e.findNodeAtOffset=l;function u(t,r,s=S.DEFAULT){const c=E(t,!1);function d(_){return _?()=>_(c.getTokenOffset(),c.getTokenLength()):()=>!0}function f(_){return _?q=>_(q,c.getTokenOffset(),c.getTokenLength()):()=>!0}const h=d(r.onObjectBegin),M=f(r.onObjectProperty),T=d(r.onObjectEnd),U=d(r.onArrayBegin),H=d(r.onArrayEnd),X=f(r.onLiteralValue),ee=f(r.onSeparator),B=d(r.onComment),Y=f(r.onError),Q=s&&s.disallowComments,N=s&&s.allowTrailingComma;function G(){for(;;){const _=c.scan();switch(c.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:Q||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:Q?z(10):B();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,q=[],V=[]){if(Y(_),q.length+V.length>0){let K=c.getToken();for(;K!==17;){if(q.indexOf(K)!==-1){G();break}else if(V.indexOf(K)!==-1)break;K=G()}}}function C(_){const q=c.getTokenValue();return _?X(q):M(q),G(),!0}function F(){switch(c.getToken()){case 11:let _=0;try{_=JSON.parse(c.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch(q){z(2)}X(_);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return G(),!0}function R(){return c.getToken()!==10?(z(3,[],[2,5]),!1):(C(!1),c.getToken()===6?(ee(":"),G(),W()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function O(){h(),G();let _=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(_||z(4,[],[]),ee(","),G(),c.getToken()===2&&N)break}else _&&z(6,[],[]);R()||z(4,[],[2,5]),_=!0}return T(),c.getToken()!==2?z(7,[2],[]):G(),!0}function P(){U(),G();let _=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(_||z(4,[],[]),ee(","),G(),c.getToken()===4&&N)break}else _&&z(6,[],[]);W()||z(4,[],[4,5]),_=!0}return H(),c.getToken()!==4?z(8,[4],[]):G(),!0}function W(){switch(c.getToken()){case 3:return P();case 1:return O();case 10:return C(!0);default:return F()}}return G(),c.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):W()?(c.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=u;function o(t,r){let s=E(t),c=[],d,f=0,h;do switch(h=s.getPosition(),d=s.scan(),d){case 12:case 13:case 17:f!==h&&c.push(t.substring(f,h)),r!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,r)),f=s.getPosition();break}while(d!==17);return c.join("")}e.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(J[103],x([0,1,43]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(w,y,i){let I,k,p,g,m;if(y){for(g=y.offset,m=g+y.length,p=g;p>0&&!n(w,p-1);)p--;let f=m;for(;f<w.length&&!n(w,f);)f++;k=w.substring(p,f),I=S(k,i)}else k=w,I=0,p=0,g=0,m=w.length;const D=E(i,w);let b=!1,l=0,u;i.insertSpaces?u=A(" ",i.tabSize||4):u="	";const o=v.createScanner(k,!1);let a=!1;function t(){return D+A(u,I+l)}function r(){let f=o.scan();for(b=!1;f===15||f===14;)b=b||f===14,f=o.scan();return a=f===16||o.getTokenError()!==0,f}const s=[];function c(f,h,M){!a&&h<m&&M>g&&w.substring(h,M)!==f&&s.push({offset:h,length:M-h,content:f})}let d=r();if(d!==17){const f=o.getTokenOffset()+p,h=A(u,I);c(h,p,f)}for(;d!==17;){let f=o.getTokenOffset()+o.getTokenLength()+p,h=r(),M="";for(;!b&&(h===12||h===13);){const U=o.getTokenOffset()+p;c(" ",f,U),f=o.getTokenOffset()+o.getTokenLength()+p,M=h===12?t():"",h=r()}if(h===2)d!==1&&(l--,M=t());else if(h===4)d!==3&&(l--,M=t());else{switch(d){case 3:case 1:l++,M=t();break;case 5:case 12:M=t();break;case 13:b?M=t():M=" ";break;case 6:M=" ";break;case 10:if(h===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?M=" ":h!==5&&h!==17&&(a=!0);break;case 16:a=!0;break}b&&(h===12||h===13)&&(M=t())}const T=o.getTokenOffset()+p;c(M,f,T),d=h}return s}e.format=L;function A(w,y){let i="";for(let I=0;I<y;I++)i+=w;return i}function S(w,y){let i=0,I=0;const k=y.tabSize||4;for(;i<w.length;){const p=w.charAt(i);if(p===" ")I++;else if(p==="	")I+=k;else break;i++}return Math.floor(I/k)}function E(w,y){for(let i=0;i<y.length;i++){const I=y.charAt(i);if(I==="\r")return i+1<y.length&&y.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=E;function n(w,y){return`\r
`.indexOf(w.charAt(y))!==-1}e.isEOL=n}),define(J[104],x([0,1,43,103]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(y,i,I){return S(y,i,void 0,I)}e.removeProperty=A;function S(y,i,I,k,p){const g=i.slice(),m=[],D=v.parseTree(y,m);let b,l;for(;g.length>0&&(l=g.pop(),b=v.findNodeAtLocation(D,g),b===void 0&&I!==void 0);)typeof l=="string"?I={[l]:I}:I=[I];if(b)if(b.type==="object"&&typeof l=="string"&&Array.isArray(b.children)){const u=v.findNodeAtLocation(b,[l]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const o=b.children.indexOf(u.parent);let a,t=u.parent.offset+u.parent.length;if(o>0){const r=b.children[o-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return E(y,{offset:a,length:t-a,content:""},k)}else return E(y,{offset:u.offset,length:u.length,content:JSON.stringify(I)},k);else{if(I===void 0)return[];const o=`${JSON.stringify(l)}: ${JSON.stringify(I)}`,a=p?p(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+o}}else b.children.length===0?t={offset:b.offset+1,length:0,content:o}:t={offset:b.offset+1,length:0,content:o+","};return E(y,t,k)}}else if(b.type==="array"&&typeof l=="number"&&Array.isArray(b.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let o;if(b.children.length===0||l===0)o={offset:b.offset+1,length:0,content:b.children.length===0?u:u+","};else{const a=l===-1||l>b.children.length?b.children.length:l,t=b.children[a-1];o={offset:t.offset+t.length,length:0,content:","+u}}return E(y,o,k)}else{const u=l,o=b.children[u];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===u){const t=b.children[u-1],r=t.offset+t.length,s=b.offset+b.length;a={offset:r,length:s-2-r,content:""}}else a={offset:o.offset,length:b.children[u+1].offset-o.offset,content:""};return E(y,a,k)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return E(y,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(I)},k)}}e.setProperty=S;function E(y,i,I){let k=n(y,i),p=i.offset,g=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!L.isEOL(k,p-1);)p--;for(;g<k.length&&!L.isEOL(k,g);)g++}const m=L.format(k,{offset:p,length:g-p},I);for(let b=m.length-1;b>=0;b--){const l=m[b];k=n(k,l),p=Math.min(p,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const D=y.length-(k.length-g)-p;return[{offset:p,length:D,content:k.substring(p,g)}]}e.withFormatting=E;function n(y,i){return y.substring(0,i.offset)+i.content+y.substring(i.offset+i.length)}e.applyEdit=n;function w(y,i){let I=i.slice(0).sort((p,g)=>{const m=p.offset-g.offset;return m===0?p.length-g.length:m}),k=y.length;for(let p=I.length-1;p>=0;p--){let g=I[p];if(g.offset+g.length<=k)y=n(y,g);else throw new Error("Overlapping edit");k=g.offset}return y}e.applyEdits=w}),define(J[57],x([0,1,19]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(l){l[l.DependsOnKbLayout=-1]="DependsOnKbLayout",l[l.Unknown=0]="Unknown",l[l.Backspace=1]="Backspace",l[l.Tab=2]="Tab",l[l.Enter=3]="Enter",l[l.Shift=4]="Shift",l[l.Ctrl=5]="Ctrl",l[l.Alt=6]="Alt",l[l.PauseBreak=7]="PauseBreak",l[l.CapsLock=8]="CapsLock",l[l.Escape=9]="Escape",l[l.Space=10]="Space",l[l.PageUp=11]="PageUp",l[l.PageDown=12]="PageDown",l[l.End=13]="End",l[l.Home=14]="Home",l[l.LeftArrow=15]="LeftArrow",l[l.UpArrow=16]="UpArrow",l[l.RightArrow=17]="RightArrow",l[l.DownArrow=18]="DownArrow",l[l.Insert=19]="Insert",l[l.Delete=20]="Delete",l[l.KEY_0=21]="KEY_0",l[l.KEY_1=22]="KEY_1",l[l.KEY_2=23]="KEY_2",l[l.KEY_3=24]="KEY_3",l[l.KEY_4=25]="KEY_4",l[l.KEY_5=26]="KEY_5",l[l.KEY_6=27]="KEY_6",l[l.KEY_7=28]="KEY_7",l[l.KEY_8=29]="KEY_8",l[l.KEY_9=30]="KEY_9",l[l.KEY_A=31]="KEY_A",l[l.KEY_B=32]="KEY_B",l[l.KEY_C=33]="KEY_C",l[l.KEY_D=34]="KEY_D",l[l.KEY_E=35]="KEY_E",l[l.KEY_F=36]="KEY_F",l[l.KEY_G=37]="KEY_G",l[l.KEY_H=38]="KEY_H",l[l.KEY_I=39]="KEY_I",l[l.KEY_J=40]="KEY_J",l[l.KEY_K=41]="KEY_K",l[l.KEY_L=42]="KEY_L",l[l.KEY_M=43]="KEY_M",l[l.KEY_N=44]="KEY_N",l[l.KEY_O=45]="KEY_O",l[l.KEY_P=46]="KEY_P",l[l.KEY_Q=47]="KEY_Q",l[l.KEY_R=48]="KEY_R",l[l.KEY_S=49]="KEY_S",l[l.KEY_T=50]="KEY_T",l[l.KEY_U=51]="KEY_U",l[l.KEY_V=52]="KEY_V",l[l.KEY_W=53]="KEY_W",l[l.KEY_X=54]="KEY_X",l[l.KEY_Y=55]="KEY_Y",l[l.KEY_Z=56]="KEY_Z",l[l.Meta=57]="Meta",l[l.ContextMenu=58]="ContextMenu",l[l.F1=59]="F1",l[l.F2=60]="F2",l[l.F3=61]="F3",l[l.F4=62]="F4",l[l.F5=63]="F5",l[l.F6=64]="F6",l[l.F7=65]="F7",l[l.F8=66]="F8",l[l.F9=67]="F9",l[l.F10=68]="F10",l[l.F11=69]="F11",l[l.F12=70]="F12",l[l.F13=71]="F13",l[l.F14=72]="F14",l[l.F15=73]="F15",l[l.F16=74]="F16",l[l.F17=75]="F17",l[l.F18=76]="F18",l[l.F19=77]="F19",l[l.NumLock=78]="NumLock",l[l.ScrollLock=79]="ScrollLock",l[l.US_SEMICOLON=80]="US_SEMICOLON",l[l.US_EQUAL=81]="US_EQUAL",l[l.US_COMMA=82]="US_COMMA",l[l.US_MINUS=83]="US_MINUS",l[l.US_DOT=84]="US_DOT",l[l.US_SLASH=85]="US_SLASH",l[l.US_BACKTICK=86]="US_BACKTICK",l[l.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",l[l.US_BACKSLASH=88]="US_BACKSLASH",l[l.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",l[l.US_QUOTE=90]="US_QUOTE",l[l.OEM_8=91]="OEM_8",l[l.OEM_102=92]="OEM_102",l[l.NUMPAD_0=93]="NUMPAD_0",l[l.NUMPAD_1=94]="NUMPAD_1",l[l.NUMPAD_2=95]="NUMPAD_2",l[l.NUMPAD_3=96]="NUMPAD_3",l[l.NUMPAD_4=97]="NUMPAD_4",l[l.NUMPAD_5=98]="NUMPAD_5",l[l.NUMPAD_6=99]="NUMPAD_6",l[l.NUMPAD_7=100]="NUMPAD_7",l[l.NUMPAD_8=101]="NUMPAD_8",l[l.NUMPAD_9=102]="NUMPAD_9",l[l.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",l[l.NUMPAD_ADD=104]="NUMPAD_ADD",l[l.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",l[l.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",l[l.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",l[l.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",l[l.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",l[l.ABNT_C1=110]="ABNT_C1",l[l.ABNT_C2=111]="ABNT_C2",l[l.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class A{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,o){this._keyCodeToStr[u]=o,this._strToKeyCode[o.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const S=new A,E=new A,n=new A;(function(){function l(u,o,a=o,t=a){S.define(u,o),E.define(u,a),n.define(u,t)}l(0,"unknown"),l(1,"Backspace"),l(2,"Tab"),l(3,"Enter"),l(4,"Shift"),l(5,"Ctrl"),l(6,"Alt"),l(7,"PauseBreak"),l(8,"CapsLock"),l(9,"Escape"),l(10,"Space"),l(11,"PageUp"),l(12,"PageDown"),l(13,"End"),l(14,"Home"),l(15,"LeftArrow","Left"),l(16,"UpArrow","Up"),l(17,"RightArrow","Right"),l(18,"DownArrow","Down"),l(19,"Insert"),l(20,"Delete"),l(21,"0"),l(22,"1"),l(23,"2"),l(24,"3"),l(25,"4"),l(26,"5"),l(27,"6"),l(28,"7"),l(29,"8"),l(30,"9"),l(31,"A"),l(32,"B"),l(33,"C"),l(34,"D"),l(35,"E"),l(36,"F"),l(37,"G"),l(38,"H"),l(39,"I"),l(40,"J"),l(41,"K"),l(42,"L"),l(43,"M"),l(44,"N"),l(45,"O"),l(46,"P"),l(47,"Q"),l(48,"R"),l(49,"S"),l(50,"T"),l(51,"U"),l(52,"V"),l(53,"W"),l(54,"X"),l(55,"Y"),l(56,"Z"),l(57,"Meta"),l(58,"ContextMenu"),l(59,"F1"),l(60,"F2"),l(61,"F3"),l(62,"F4"),l(63,"F5"),l(64,"F6"),l(65,"F7"),l(66,"F8"),l(67,"F9"),l(68,"F10"),l(69,"F11"),l(70,"F12"),l(71,"F13"),l(72,"F14"),l(73,"F15"),l(74,"F16"),l(75,"F17"),l(76,"F18"),l(77,"F19"),l(78,"NumLock"),l(79,"ScrollLock"),l(80,";",";","OEM_1"),l(81,"=","=","OEM_PLUS"),l(82,",",",","OEM_COMMA"),l(83,"-","-","OEM_MINUS"),l(84,".",".","OEM_PERIOD"),l(85,"/","/","OEM_2"),l(86,"`","`","OEM_3"),l(110,"ABNT_C1"),l(111,"ABNT_C2"),l(87,"[","[","OEM_4"),l(88,"\\","\\","OEM_5"),l(89,"]","]","OEM_6"),l(90,"'","'","OEM_7"),l(91,"OEM_8"),l(92,"OEM_102"),l(93,"NumPad0"),l(94,"NumPad1"),l(95,"NumPad2"),l(96,"NumPad3"),l(97,"NumPad4"),l(98,"NumPad5"),l(99,"NumPad6"),l(100,"NumPad7"),l(101,"NumPad8"),l(102,"NumPad9"),l(103,"NumPad_Multiply"),l(104,"NumPad_Add"),l(105,"NumPad_Separator"),l(106,"NumPad_Subtract"),l(107,"NumPad_Decimal"),l(108,"NumPad_Divide")})();var w;(function(l){function u(s){return S.keyCodeToStr(s)}l.toString=u;function o(s){return S.strToKeyCode(s)}l.fromString=o;function a(s){return E.keyCodeToStr(s)}l.toUserSettingsUS=a;function t(s){return n.keyCodeToStr(s)}l.toUserSettingsGeneral=t;function r(s){return E.strToKeyCode(s)||n.strToKeyCode(s)}l.fromUserSettings=r})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var y;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl",l[l.KeyCode=255]="KeyCode"})(y||(y={}));var i;(function(l){l[l.CtrlCmd=2048]="CtrlCmd",l[l.Shift=1024]="Shift",l[l.Alt=512]="Alt",l[l.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function I(l,u){const o=(u&65535)<<16>>>0;return(l|o)>>>0}e.KeyChord=I;function k(l,u){if(l===0)return null;const o=(l&65535)>>>0,a=(l&4294901760)>>>16;return a!==0?new m([p(o,u),p(a,u)]):new m([p(o,u)])}e.createKeybinding=k;function p(l,u){const o=!!(l&2048),a=!!(l&256),t=u===2?a:o,r=!!(l&1024),s=!!(l&512),c=u===2?o:a,d=l&255;return new g(t,r,s,c,d)}e.createSimpleKeybinding=p;class g{constructor(u,o,a,t,r){this.ctrlKey=u,this.shiftKey=o,this.altKey=a,this.metaKey=t,this.keyCode=r}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",a=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${o}${a}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=g;class m{constructor(u){if(u.length===0)throw v.illegalArgument("parts");this.parts=u}getHashCode(){let u="";for(let o=0,a=this.parts.length;o<a;o++)o!==0&&(u+=";"),u+=this.parts[o].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(u.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class D{constructor(u,o,a,t,r,s){this.ctrlKey=u,this.shiftKey=o,this.altKey=a,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=D;class b{}e.ResolvedKeybinding=b}),define(J[2],x([0,1,42,63]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let S=null;function E(u){S=u}if(e.setDisposableTracker=E,A){const u="__is_disposable_tracked__";S=new class{trackDisposable(o){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[u]||console.log(a)},3e3)}markTracked(o){if(o&&o!==m.None)try{o[u]=!0}catch(a){}}}}function n(u){!S||S.markTracked(u)}function w(u){return S&&S.trackDisposable(u),u}e.trackDisposable=w;class y extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=y;function i(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=i;function I(u){if(L.Iterable.is(u)){let o=[];for(const a of u)if(a){n(a);try{a.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new y(o);return Array.isArray(u)?[]:u}else if(u)return n(u),u.dispose(),u}e.dispose=I;function k(...u){return u.forEach(n),p(()=>I(u))}e.combinedDisposable=k;function p(u){const o=w({dispose:()=>{n(o),u()}});return o}e.toDisposable=p;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return n(o),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new g,w(this)}dispose(){n(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var a;this._isDisposed||o===this._value||((a=this._value)===null||a===void 0||a.dispose(),o&&n(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,n(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=D;class b{constructor(){this.references=new Map}acquire(o,...a){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...a)},this.references.set(o,t));const{object:r}=t,s=v.once(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:r,dispose:s}}}e.ReferenceCollection=b;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l}),define(J[78],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let S=this._first;for(;S!==v.Undefined;){const E=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=E}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,E){const n=new v(S);if(this._first===v.Undefined)this._first=n,this._last=n;else if(E){const y=this._last;this._last=n,n.prev=y,y.next=n}else{const y=this._first;this._first=n,n.next=y,y.prev=n}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const E=S.prev;E.next=S.next,S.next.prev=E}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(){function $(A){const S=[];typeof A=="number"&&S.push("code/timeOrigin",A);function E(w){S.push(w,Date.now())}function n(){const w=[];for(let y=0;y<S.length;y+=2)w.push({name:S[y],startTime:S[y+1]});return w}return{mark:E,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const E of performance.getEntriesByType("mark"))S.push({name:E.name,startTime:Math.round(A+E.startTime)});return S}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function v(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(J[3],x([0,1]),function($,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let A=!1,S=!1,E=!1,n=!1,w=!1,y=!1,i=!1,I,k=L,p,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const D=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=D&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const c=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!D)g=navigator.userAgent,A=g.indexOf("Windows")>=0,S=g.indexOf("Macintosh")>=0,i=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,E=g.indexOf("Linux")>=0,y=!0,I=navigator.language,k=I;else if(typeof m=="object"){A=m.platform==="win32",S=m.platform==="darwin",E=m.platform==="linux",n=E&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,I=L,k=L;const c=m.env.VSCODE_NLS_CONFIG;if(c)try{const d=JSON.parse(c),f=d.availableLanguages["*"];I=d.locale,k=f||L,p=d._translationsConfigFile}catch(d){}w=!0}else console.error("Unable to resolve platform.");var b;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function l(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let u=0;S?u=1:A?u=3:E&&(u=2),e.isWindows=A,e.isMacintosh=S,e.isLinux=E,e.isLinuxSnap=n,e.isNative=w,e.isWeb=y,e.isIOS=i,e.platform=u,e.userAgent=g,e.language=k;var o;(function(c){function d(){return e.language}c.value=d;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=f;function h(){return e.language==="en"}c.isDefault=h})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=p,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",M=>{if(M.data&&M.data.vscodeSetImmediateId)for(let T=0,U=f.length;T<U;T++){const H=f[T];if(H.id===M.data.vscodeSetImmediateId){f.splice(T,1),H.callback();return}}});let h=0;return M=>{const T=++h;f.push({id:T,callback:M}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const d=Promise.resolve();return f=>d.then(f)}();var a;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||i?2:A?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,t=new Uint16Array(c.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(J[32],x([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const A=v.globals.vscode.process;L={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(S){return v.setImmediate(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(A){return v.setImmediate(A)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(J[8],x([0,1,32]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,A=97,S=90,E=122,n=46,w=47,y=92,i=58,I=63;class k extends Error{constructor(o,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const s=o.indexOf(".")!==-1?"property":"argument";let c=`The "${o}" ${s} ${r} of type ${a}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function p(u,o){if(typeof u!="string")throw new k(o,"string",u)}function g(u){return u===w||u===y}function m(u){return u===w}function D(u){return u>=L&&u<=S||u>=A&&u<=E}function b(u,o,a,t){let r="",s=0,c=-1,d=0,f=0;for(let h=0;h<=u.length;++h){if(h<u.length)f=u.charCodeAt(h);else{if(t(f))break;f=w}if(t(f)){if(!(c===h-1||d===1))if(d===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const M=r.lastIndexOf(a);M===-1?(r="",s=0):(r=r.slice(0,M),s=r.length-1-r.lastIndexOf(a)),c=h,d=0;continue}else if(r.length!==0){r="",s=0,c=h,d=0;continue}}o&&(r+=r.length>0?`${a}..`:"..",s=2)}else r.length>0?r+=`${a}${u.slice(c+1,h)}`:r=u.slice(c+1,h),s=h-c-1;c=h,d=0}else f===n&&d!==-1?++d:d=-1}return r}function l(u,o){if(o===null||typeof o!="object")throw new k("pathObject","Object",o);const a=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return a?a===o.root?`${a}${t}`:`${a}${u}${t}`:t}e.win32={resolve(...u){let o="",a="",t=!1;for(let r=u.length-1;r>=-1;r--){let s;if(r>=0){if(s=u[r],p(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===y)&&(s=`${o}\\`));const c=s.length;let d=0,f="",h=!1;const M=s.charCodeAt(0);if(c===1)g(M)&&(d=1,h=!0);else if(g(M))if(h=!0,g(s.charCodeAt(1))){let T=2,U=T;for(;T<c&&!g(s.charCodeAt(T));)T++;if(T<c&&T!==U){const H=s.slice(U,T);for(U=T;T<c&&g(s.charCodeAt(T));)T++;if(T<c&&T!==U){for(U=T;T<c&&!g(s.charCodeAt(T));)T++;(T===c||T!==U)&&(f=`\\\\${H}\\${s.slice(U,T)}`,d=T)}}}else d=1;else D(M)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),d=2,c>2&&g(s.charCodeAt(2))&&(h=!0,d=3));if(f.length>0)if(o.length>0){if(f.toLowerCase()!==o.toLowerCase())continue}else o=f;if(t){if(o.length>0)break}else if(a=`${s.slice(d)}\\${a}`,t=h,h&&o.length>0)break}return a=b(a,!t,"\\",g),t?`${o}\\${a}`:`${o}${a}`||"."},normalize(u){p(u,"path");const o=u.length;if(o===0)return".";let a=0,t,r=!1;const s=u.charCodeAt(0);if(o===1)return m(s)?"\\":u;if(g(s))if(r=!0,g(u.charCodeAt(1))){let d=2,f=d;for(;d<o&&!g(u.charCodeAt(d));)d++;if(d<o&&d!==f){const h=u.slice(f,d);for(f=d;d<o&&g(u.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&!g(u.charCodeAt(d));)d++;if(d===o)return`\\\\${h}\\${u.slice(f)}\\`;d!==f&&(t=`\\\\${h}\\${u.slice(f,d)}`,a=d)}}}else a=1;else D(s)&&u.charCodeAt(1)===i&&(t=u.slice(0,2),a=2,o>2&&g(u.charCodeAt(2))&&(r=!0,a=3));let c=a<o?b(u.slice(a),!r,"\\",g):"";return c.length===0&&!r&&(c="."),c.length>0&&g(u.charCodeAt(o-1))&&(c+="\\"),t===void 0?r?`\\${c}`:c:r?`${t}\\${c}`:`${t}${c}`},isAbsolute(u){p(u,"path");const o=u.length;if(o===0)return!1;const a=u.charCodeAt(0);return g(a)||o>2&&D(a)&&u.charCodeAt(1)===i&&g(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let o,a;for(let s=0;s<u.length;++s){const c=u[s];p(c,"path"),c.length>0&&(o===void 0?o=a=c:o+=`\\${c}`)}if(o===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&g(a.charCodeAt(0))){++r;const s=a.length;s>1&&g(a.charCodeAt(1))&&(++r,s>2&&(g(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<o.length&&g(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(u,o){if(p(u,"from"),p(o,"to"),u===o)return"";const a=e.win32.resolve(u),t=e.win32.resolve(o);if(a===t||(u=a.toLowerCase(),o=t.toLowerCase(),u===o))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===y;)r++;let s=u.length;for(;s-1>r&&u.charCodeAt(s-1)===y;)s--;const c=s-r;let d=0;for(;d<o.length&&o.charCodeAt(d)===y;)d++;let f=o.length;for(;f-1>d&&o.charCodeAt(f-1)===y;)f--;const h=f-d,M=c<h?c:h;let T=-1,U=0;for(;U<M;U++){const X=u.charCodeAt(r+U);if(X!==o.charCodeAt(d+U))break;X===y&&(T=U)}if(U!==M){if(T===-1)return t}else{if(h>M){if(o.charCodeAt(d+U)===y)return t.slice(d+U+1);if(U===2)return t.slice(d+U)}c>M&&(u.charCodeAt(r+U)===y?T=U:U===2&&(T=3)),T===-1&&(T=0)}let H="";for(U=r+T+1;U<=s;++U)(U===s||u.charCodeAt(U)===y)&&(H+=H.length===0?"..":"\\..");return d+=T,H.length>0?`${H}${t.slice(d,f)}`:(t.charCodeAt(d)===y&&++d,t.slice(d,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const o=e.win32.resolve(u);if(o.length<=2)return u;if(o.charCodeAt(0)===y){if(o.charCodeAt(1)===y){const a=o.charCodeAt(2);if(a!==I&&a!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(D(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===y)return`\\\\?\\${o}`;return u},dirname(u){p(u,"path");const o=u.length;if(o===0)return".";let a=-1,t=0;const r=u.charCodeAt(0);if(o===1)return g(r)?u:".";if(g(r)){if(a=t=1,g(u.charCodeAt(1))){let d=2,f=d;for(;d<o&&!g(u.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&g(u.charCodeAt(d));)d++;if(d<o&&d!==f){for(f=d;d<o&&!g(u.charCodeAt(d));)d++;if(d===o)return u;d!==f&&(a=t=d+1)}}}}else D(r)&&u.charCodeAt(1)===i&&(a=o>2&&g(u.charCodeAt(2))?3:2,t=a);let s=-1,c=!0;for(let d=o-1;d>=t;--d)if(g(u.charCodeAt(d))){if(!c){s=d;break}}else c=!1;if(s===-1){if(a===-1)return".";s=a}return u.slice(0,s)},basename(u,o){o!==void 0&&p(o,"ext"),p(u,"path");let a=0,t=-1,r=!0,s;if(u.length>=2&&D(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(a=2),o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let c=o.length-1,d=-1;for(s=u.length-1;s>=a;--s){const f=u.charCodeAt(s);if(g(f)){if(!r){a=s+1;break}}else d===-1&&(r=!1,d=s+1),c>=0&&(f===o.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=d))}return a===t?t=d:t===-1&&(t=u.length),u.slice(a,t)}for(s=u.length-1;s>=a;--s)if(g(u.charCodeAt(s))){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(a,t)},extname(u){p(u,"path");let o=0,a=-1,t=0,r=-1,s=!0,c=0;u.length>=2&&u.charCodeAt(1)===i&&D(u.charCodeAt(0))&&(o=t=2);for(let d=u.length-1;d>=o;--d){const f=u.charCodeAt(d);if(g(f)){if(!s){t=d+1;break}continue}r===-1&&(s=!1,r=d+1),f===n?a===-1?a=d:c!==1&&(c=1):a!==-1&&(c=-1)}return a===-1||r===-1||c===0||c===1&&a===r-1&&a===t+1?"":u.slice(a,r)},format:l.bind(null,"\\"),parse(u){p(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const a=u.length;let t=0,r=u.charCodeAt(0);if(a===1)return g(r)?(o.root=o.dir=u,o):(o.base=o.name=u,o);if(g(r)){if(t=1,g(u.charCodeAt(1))){let T=2,U=T;for(;T<a&&!g(u.charCodeAt(T));)T++;if(T<a&&T!==U){for(U=T;T<a&&g(u.charCodeAt(T));)T++;if(T<a&&T!==U){for(U=T;T<a&&!g(u.charCodeAt(T));)T++;T===a?t=T:T!==U&&(t=T+1)}}}}else if(D(r)&&u.charCodeAt(1)===i){if(a<=2)return o.root=o.dir=u,o;if(t=2,g(u.charCodeAt(2))){if(a===3)return o.root=o.dir=u,o;t=3}}t>0&&(o.root=u.slice(0,t));let s=-1,c=t,d=-1,f=!0,h=u.length-1,M=0;for(;h>=t;--h){if(r=u.charCodeAt(h),g(r)){if(!f){c=h+1;break}continue}d===-1&&(f=!1,d=h+1),r===n?s===-1?s=h:M!==1&&(M=1):s!==-1&&(M=-1)}return d!==-1&&(s===-1||M===0||M===1&&s===d-1&&s===c+1?o.base=o.name=u.slice(c,d):(o.name=u.slice(c,s),o.base=u.slice(c,d),o.ext=u.slice(s,d))),c>0&&c!==t?o.dir=u.slice(0,c-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let o="",a=!1;for(let t=u.length-1;t>=-1&&!a;t--){const r=t>=0?u[t]:v.cwd();p(r,"path"),r.length!==0&&(o=`${r}/${o}`,a=r.charCodeAt(0)===w)}return o=b(o,!a,"/",m),a?`/${o}`:o.length>0?o:"."},normalize(u){if(p(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===w,a=u.charCodeAt(u.length-1)===w;return u=b(u,!o,"/",m),u.length===0?o?"/":a?"./":".":(a&&(u+="/"),o?`/${u}`:u)},isAbsolute(u){return p(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let o;for(let a=0;a<u.length;++a){const t=u[a];p(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(u,o){if(p(u,"from"),p(o,"to"),u===o||(u=e.posix.resolve(u),o=e.posix.resolve(o),u===o))return"";const a=1,t=u.length,r=t-a,s=1,c=o.length-s,d=r<c?r:c;let f=-1,h=0;for(;h<d;h++){const T=u.charCodeAt(a+h);if(T!==o.charCodeAt(s+h))break;T===w&&(f=h)}if(h===d)if(c>d){if(o.charCodeAt(s+h)===w)return o.slice(s+h+1);if(h===0)return o.slice(s+h)}else r>d&&(u.charCodeAt(a+h)===w?f=h:h===0&&(f=0));let M="";for(h=a+f+1;h<=t;++h)(h===t||u.charCodeAt(h)===w)&&(M+=M.length===0?"..":"/..");return`${M}${o.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(p(u,"path"),u.length===0)return".";const o=u.charCodeAt(0)===w;let a=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===w){if(!t){a=r;break}}else t=!1;return a===-1?o?"/":".":o&&a===1?"//":u.slice(0,a)},basename(u,o){o!==void 0&&p(o,"ext"),p(u,"path");let a=0,t=-1,r=!0,s;if(o!==void 0&&o.length>0&&o.length<=u.length){if(o===u)return"";let c=o.length-1,d=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!r){a=s+1;break}}else d===-1&&(r=!1,d=s+1),c>=0&&(f===o.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=d))}return a===t?t=d:t===-1&&(t=u.length),u.slice(a,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!r){a=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":u.slice(a,t)},extname(u){p(u,"path");let o=-1,a=0,t=-1,r=!0,s=0;for(let c=u.length-1;c>=0;--c){const d=u.charCodeAt(c);if(d===w){if(!r){a=c+1;break}continue}t===-1&&(r=!1,t=c+1),d===n?o===-1?o=c:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===a+1?"":u.slice(o,t)},format:l.bind(null,"/"),parse(u){p(u,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return o;const a=u.charCodeAt(0)===w;let t;a?(o.root="/",t=1):t=0;let r=-1,s=0,c=-1,d=!0,f=u.length-1,h=0;for(;f>=t;--f){const M=u.charCodeAt(f);if(M===w){if(!d){s=f+1;break}continue}c===-1&&(d=!1,c=f+1),M===n?r===-1?r=f:h!==1&&(h=1):r!==-1&&(h=-1)}if(c!==-1){const M=s===0&&a?1:s;r===-1||h===0||h===1&&r===c-1&&r===s+1?o.base=o.name=u.slice(M,c):(o.name=u.slice(M,r),o.base=u.slice(M,c),o.ext=u.slice(r,c))}return s>0?o.dir=u.slice(0,s-1):a&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(J[105],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(S,...E){const n=E.reduce((i,I)=>(i[I]=!0,i),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!n[i]).forEach(i=>{for(let I=0;I<w.length;I++)if(i.search(w[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=A}),define(J[79],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],A=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>A[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class E{constructor(w,y,i,I,k){this.ctrlKey=w,this.shiftKey=y,this.altKey=i,this.metaKey=I,this.scanCode=k}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=E,function(){function n(w,y){L[w]=y,A[y]=w,S[y.toLowerCase()]=w}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function n(w,y){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=y,y!==0&&y!==3&&y!==5&&y!==4&&y!==6&&y!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[y]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(J[106],x([0,1,57,79]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class A{static _readModifiers(E){E=E.toLowerCase().trim();let n=!1,w=!1,y=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(E)&&(n=!0,E=E.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(E)&&(w=!0,E=E.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(E)&&(y=!0,E=E.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(E)&&(i=!0,E=E.substr("meta-".length),I=!0),/^win(\+|\-)/.test(E)&&(i=!0,E=E.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(E)&&(i=!0,E=E.substr("cmd-".length),I=!0);while(I);let k;const p=E.indexOf(" ");return p>0?(k=E.substring(0,p),E=E.substring(p)):(k=E,E=""),{remains:E,ctrl:n,shift:w,alt:y,meta:i,key:k}}static parseSimpleKeybinding(E){const n=this._readModifiers(E),w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseKeybinding(E,n){if(!E)return null;const w=[];let y;do[y,E]=this.parseSimpleKeybinding(E),w.push(y);while(E.length>0);return new v.ChordKeybinding(w)}static parseSimpleUserBinding(E){const n=this._readModifiers(E),w=n.key.match(/^\[([^\]]+)\]$/);if(w){const i=w[1],I=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,I),n.remains]}const y=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseUserBinding(E){if(!E)return[];const n=[];let w;for(;E.length>0;)[w,E]=this.parseSimpleUserBinding(E),n.push(w);return n}}e.KeybindingParser=A}),define(J[107],x([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class A{constructor(E){this._highResolution=L&&E,this._startTime=this._now(),this._stopTime=-1}static create(E=!0){return new A(E)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=A}),define(J[5],x([0,1,19,42,2,78,107]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(b){b.None=()=>A.Disposable.None;function l(Q){return(N,G=null,z)=>{let C=!1,F;return F=Q(R=>{if(!C)return F?F.dispose():C=!0,N.call(G,R)},null,z),C&&F.dispose(),F}}b.once=l;function u(Q,N){return c((G,z=null,C)=>Q(F=>G.call(z,N(F)),null,C))}b.map=u;function o(Q,N){return c((G,z=null,C)=>Q(F=>{N(F),G.call(z,F)},null,C))}b.forEach=o;function a(Q,N){return c((G,z=null,C)=>Q(F=>N(F)&&G.call(z,F),null,C))}b.filter=a;function t(Q){return Q}b.signal=t;function r(...Q){return(N,G=null,z)=>A.combinedDisposable(...Q.map(C=>C(F=>N.call(G,F),null,z)))}b.any=r;function s(Q,N,G){let z=G;return u(Q,C=>(z=N(z,C),z))}b.reduce=s;function c(Q){let N;const G=new k({onFirstListenerAdd(){N=Q(G.fire,G)},onLastListenerRemove(){N.dispose()}});return G.event}b.snapshot=c;function d(Q,N,G=100,z=!1,C){let F,R,O,P=0;const W=new k({leakWarningThreshold:C,onFirstListenerAdd(){F=Q(_=>{P++,R=N(R,_),z&&!O&&(W.fire(R),R=void 0),clearTimeout(O),O=setTimeout(()=>{const q=R;R=void 0,O=void 0,(!z||P>1)&&W.fire(q),P=0},G)})},onLastListenerRemove(){F.dispose()}});return W.event}b.debounce=d;function f(Q){const N=new Date().getTime();return u(l(Q),G=>new Date().getTime()-N)}b.stopwatch=f;function h(Q,N=(G,z)=>G===z){let G=!0,z;return a(Q,C=>{const F=G||!N(C,z);return G=!1,z=C,F})}b.latch=h;function M(Q,N){return[b.filter(Q,N),b.filter(Q,G=>!N(G))]}b.split=M;function T(Q,N=!1,G=[]){let z=G.slice(),C=Q(O=>{z?z.push(O):R.fire(O)});const F=()=>{z&&z.forEach(O=>R.fire(O)),z=null},R=new k({onFirstListenerAdd(){C||(C=Q(O=>R.fire(O)))},onFirstListenerDidAdd(){z&&(N?setTimeout(F):F())},onLastListenerRemove(){C&&C.dispose(),C=null}});return R.event}b.buffer=T;class U{constructor(N){this.event=N}map(N){return new U(u(this.event,N))}forEach(N){return new U(o(this.event,N))}filter(N){return new U(a(this.event,N))}reduce(N,G){return new U(s(this.event,N,G))}latch(){return new U(h(this.event))}debounce(N,G=100,z=!1,C){return new U(d(this.event,N,G,z,C))}on(N,G,z){return this.event(N,G,z)}once(N,G,z){return l(this.event)(N,G,z)}}function H(Q){return new U(Q)}b.chain=H;function X(Q,N,G=z=>z){const z=(...O)=>R.fire(G(...O)),C=()=>Q.on(N,z),F=()=>Q.removeListener(N,z),R=new k({onFirstListenerAdd:C,onLastListenerRemove:F});return R.event}b.fromNodeEventEmitter=X;function ee(Q,N,G=z=>z){const z=(...O)=>R.fire(G(...O)),C=()=>Q.addEventListener(N,z),F=()=>Q.removeEventListener(N,z),R=new k({onFirstListenerAdd:C,onLastListenerRemove:F});return R.event}b.fromDOMEventEmitter=ee;function B(Q){const N=new k;let G=!1;return Q.then(void 0,()=>null).then(()=>{G?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),G=!0,N.event}b.fromPromise=B;function Y(Q){return new Promise(N=>l(Q)(N))}b.toPromise=Y})(n=e.Event||(e.Event={}));class w{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${w._idPool++}`}start(l){this._stopWatch=new E.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let y=-1;function i(b){const l=y;return y=b,{dispose(){y=l}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(l,u=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let u=y;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||l<u)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(o)||0;if(this._stacks.set(o,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[s,c]of this._stacks)(!t||r<c)&&(t=s,r=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}class k{constructor(l){var u;this._disposed=!1,this._options=l,this._leakageMon=y>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(l,u,o)=>{var a;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[l,u]:l);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,u);const s=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let c;return c={dispose:()=>{s&&s(),c.dispose=k._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof A.DisposableStore?o.add(c):Array.isArray(o)&&o.push(c),c}),this._event}fire(l){var u,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,l]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){v.onUnexpectedError(r)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var l,u,o,a,t;this._disposed||(this._disposed=!0,(l=this._listeners)===null||l===void 0||l.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(a=(o=this._options)===null||o===void 0?void 0:o.onLastListenerRemove)===null||a===void 0||a.call(o),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=k,k._noop=function(){};class p extends k{constructor(l){super(l);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=l==null?void 0:l.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=p;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new k({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const u={event:l,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const o=()=>{this.hasListeners&&this.unhook(u);const a=this.events.indexOf(u);this.events.splice(a,1)};return A.toDisposable(L.once(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(u=>this.emitter.fire(u))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class m{constructor(){this.buffers=[]}wrapEvent(l){return(u,o,a)=>l(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(o,t)):u.call(o,t)},void 0,a)}bufferEvents(l){const u=[];this.buffers.push(u);const o=l();return this.buffers.pop(),u.forEach(a=>a()),o}}e.EventBufferer=m;class D{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=A.Disposable.None,this.emitter=new k({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=D}),define(J[25],x([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,w){const y=setTimeout(n.bind(w),0);return{dispose(){clearTimeout(y)}}});var A;(function(n){function w(y){return y===n.None||y===n.Cancelled||y instanceof S?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}n.isCancellationToken=w,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(A=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class E{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=A.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=E}),define(J[108],x([0,1,5]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const k=this._icons.get(I.id);k?I.description?k.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new L;e.iconRegistry=A;function S(i,I){return new n(i,I)}e.registerCodicon=S;function E(i){return i?i.replace(/\$\((.*?)\)/g,(I,k)=>` ${k} `).trim():""}e.getCodiconAriaLabel=E;class n{constructor(I,k,p){this.id=I,this.definition=k,this.description=p,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function w(i,I){const k=["codicon","codicon-"+i];return I&&k.push("codicon-modifier-"+I),k}e.getClassNamesArray=w;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function k(m){if(m instanceof n)return["codicon","codicon-"+m.id];const D=I.exec(m.id);if(!D)return k(n.error);let[,b,l]=D;const u=["codicon","codicon-"+b];return l&&u.push("codicon-modifier-"+l.substr(1)),u}i.asClassNameArray=k;function p(m){return k(m).join(" ")}i.asClassName=p;function g(m){return"."+k(m).join(".")}i.asCSSSelector=g})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(J[64],x([0,1,19,2]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(u){const o=u;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=A;function S(u){const o=u;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=S;function E(u,o){return new n(u,o)}e.newWriteableStream=E;class n{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var a;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((a=this.options)===null||a===void 0?void 0:a.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?v.onUnexpectedError(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,o){const a=[];let t;for(;(t=u.read())!==null;)a.push(t);return o(a)}e.consumeReadable=w;function y(u,o,a){const t=[];let r;for(;(r=u.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return u.read()}}}e.peekReadable=y;function i(u,o){return new Promise((a,t)=>{const r=[];I(u,{onData:s=>{o&&r.push(s)},onError:s=>{o?t(s):a(void 0)},onEnd:()=>{a(o?o(r):void 0)}})})}e.consumeStream=i;function I(u,o){u.on("error",a=>o.onError(a)),u.on("end",()=>o.onEnd()),u.on("data",a=>o.onData(a))}e.listenStream=I;function k(u,o){return new Promise((a,t)=>{const r=new L.DisposableStore,s=[],c=h=>{if(s.push(h),s.length>o)return r.dispose(),u.pause(),a({stream:u,buffer:s,ended:!1})},d=h=>t(h),f=()=>a({stream:u,buffer:s,ended:!0});r.add(L.toDisposable(()=>u.removeListener("error",d))),u.on("error",d),r.add(L.toDisposable(()=>u.removeListener("end",f))),u.on("end",f),r.add(L.toDisposable(()=>u.removeListener("data",c))),u.on("data",c)})}e.peekStream=k;function p(u,o){const a=E(o);return a.end(u),a}e.toStream=p;function g(){const u=E(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=g;function m(u){let o=!1;return{read:()=>o?null:(o=!0,u)}}e.toReadable=m;function D(u,o,a){const t=E(a);return I(u,{onData:r=>t.write(o.data(r)),onError:r=>t.error(o.error?o.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(u,o,a){let t=!1;return{read:()=>{const r=o.read();return t?r:(t=!0,r!==null?a([u,r]):u)}}}e.prefixedReadable=b;function l(u,o,a){let t=!1;const r=E(a);return I(o,{onData:s=>t?r.write(s):(t=!0,r.write(a([u,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=l}),define(J[23],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(j){return!j||typeof j!="string"?!0:j.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function A(j,...ie){return ie.length===0?j:j.replace(L,function(ae,ce){const fe=parseInt(ce,10);return isNaN(fe)||fe<0||fe>=ie.length?ae:ie[fe]})}e.format=A;function S(j){return j.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=S;function E(j){return j.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function n(j,ie){let ae=0;const ce=ie.charCodeAt(0);for(let fe=j.length-1;fe>=0;fe--)j.charCodeAt(fe)===ce&&ae++;return ae}e.count=n;function w(j,ie,ae="\u2026"){return j.length<=ie?j:`${j.substr(0,ie)}${ae}`}e.truncate=w;function y(j,ie=" "){const ae=i(j,ie);return I(ae,ie)}e.trim=y;function i(j,ie){if(!j||!ie)return j;const ae=ie.length;if(ae===0||j.length===0)return j;let ce=0;for(;j.indexOf(ie,ce)===ce;)ce=ce+ae;return j.substring(ce)}e.ltrim=i;function I(j,ie){if(!j||!ie)return j;const ae=ie.length,ce=j.length;if(ae===0||ce===0)return j;let fe=ce,be=-1;for(;be=j.lastIndexOf(ie,fe-1),!(be===-1||be+ae!==fe);){if(be===0)return"";fe=be}return j.substring(0,fe)}e.rtrim=I;function k(j){return j.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=k;function p(j){return j.replace(/\*/g,"")}e.stripWildcards=p;function g(j,ie,ae={}){if(!j)throw new Error("Cannot create regex from empty string");ie||(j=E(j)),ae.wholeWord&&(/\B/.test(j.charAt(0))||(j="\\b"+j),/\B/.test(j.charAt(j.length-1))||(j=j+"\\b"));let ce="";return ae.global&&(ce+="g"),ae.matchCase||(ce+="i"),ae.multiline&&(ce+="m"),ae.unicode&&(ce+="u"),new RegExp(j,ce)}e.createRegExp=g;function m(j){return j.source==="^"||j.source==="^$"||j.source==="$"||j.source==="^\\s*$"?!1:!!(j.exec("")&&j.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function D(j){return!!j.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function b(j){return(j.global?"g":"")+(j.ignoreCase?"i":"")+(j.multiline?"m":"")+(j.unicode?"u":"")}e.regExpFlags=b;function l(j){return j.split(/\r\n|\r|\n/)}e.splitLines=l;function u(j){for(let ie=0,ae=j.length;ie<ae;ie++){const ce=j.charCodeAt(ie);if(ce!==32&&ce!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function o(j,ie=0,ae=j.length){for(let ce=ie;ce<ae;ce++){const fe=j.charCodeAt(ce);if(fe!==32&&fe!==9)return j.substring(ie,ce)}return j.substring(ie,ae)}e.getLeadingWhitespace=o;function a(j,ie=j.length-1){for(let ae=ie;ae>=0;ae--){const ce=j.charCodeAt(ae);if(ce!==32&&ce!==9)return ae}return-1}e.lastNonWhitespaceIndex=a;function t(j,ie){return j<ie?-1:j>ie?1:0}e.compare=t;function r(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue<ze)return-1;if(Ue>ze)return 1}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=r;function s(j,ie){return c(j,ie,0,j.length,0,ie.length)}e.compareIgnoreCase=s;function c(j,ie,ae=0,ce=j.length,fe=0,be=ie.length){for(;ae<ce&&fe<be;ae++,fe++){let Ue=j.charCodeAt(ae),ze=ie.charCodeAt(fe);if(Ue===ze)continue;const de=Ue-ze;if(!(de===32&&f(ze))&&!(de===-32&&f(Ue)))return d(Ue)&&d(ze)?de:r(j.toLowerCase(),ie.toLowerCase(),ae,ce,fe,be)}const Me=ce-ae,Fe=be-fe;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=c;function d(j){return j>=97&&j<=122}e.isLowerAsciiLetter=d;function f(j){return j>=65&&j<=90}e.isUpperAsciiLetter=f;function h(j){return d(j)||f(j)}function M(j,ie){return j.length===ie.length&&T(j,ie)}e.equalsIgnoreCase=M;function T(j,ie,ae=j.length){for(let ce=0;ce<ae;ce++){const fe=j.charCodeAt(ce),be=ie.charCodeAt(ce);if(fe!==be){if(h(fe)&&h(be)){const Me=Math.abs(fe-be);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(be).toLowerCase())return!1}}return!0}function U(j,ie){const ae=ie.length;return ie.length>j.length?!1:T(j,ie,ae)}e.startsWithIgnoreCase=U;function H(j,ie){let ae,ce=Math.min(j.length,ie.length);for(ae=0;ae<ce;ae++)if(j.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return ce}e.commonPrefixLength=H;function X(j,ie){let ae,ce=Math.min(j.length,ie.length);const fe=j.length-1,be=ie.length-1;for(ae=0;ae<ce;ae++)if(j.charCodeAt(fe-ae)!==ie.charCodeAt(be-ae))return ae;return ce}e.commonSuffixLength=X;function ee(j){return 55296<=j&&j<=56319}e.isHighSurrogate=ee;function B(j){return 56320<=j&&j<=57343}e.isLowSurrogate=B;function Y(j,ie){return(j-55296<<10)+(ie-56320)+65536}e.computeCodePoint=Y;function Q(j,ie,ae){const ce=j.charCodeAt(ae);if(ee(ce)&&ae+1<ie){const fe=j.charCodeAt(ae+1);if(B(fe))return Y(ce,fe)}return ce}e.getNextCodePoint=Q;function N(j,ie){const ae=j.charCodeAt(ie-1);if(B(ae)&&ie>1){const ce=j.charCodeAt(ie-2);if(ee(ce))return Y(ce,ae)}return ae}function G(j,ie){const ae=Be.getInstance(),ce=ie,fe=j.length,be=Q(j,fe,ie);ie+=be>=65536?2:1;let Me=ae.getGraphemeBreakType(be);for(;ie<fe;){const Fe=Q(j,fe,ie),Ue=ae.getGraphemeBreakType(Fe);if(je(Me,Ue))break;ie+=Fe>=65536?2:1,Me=Ue}return ie-ce}e.nextCharLength=G;function z(j,ie){const ae=Be.getInstance(),ce=ie,fe=N(j,ie);ie-=fe>=65536?2:1;let be=ae.getGraphemeBreakType(fe);for(;ie>0;){const Me=N(j,ie),Fe=ae.getGraphemeBreakType(Me);if(je(Fe,be))break;ie-=Me>=65536?2:1,be=Fe}return ce-ie}e.prevCharLength=z;function C(j,ie){const ae=Be.getInstance(),ce=j.length,fe=ie,be=Q(j,ce,ie),Me=ae.getGraphemeBreakType(be);ie+=be>=65536?2:1;let Fe=Me;for(;ie<ce;){const ze=Q(j,ce,ie),de=ae.getGraphemeBreakType(ze);if(je(Fe,de))break;ie+=ze>=65536?2:1,Fe=de}const Ue=ie;for(ie=fe,Fe=Me;ie>0;){const ze=N(j,ie),de=ae.getGraphemeBreakType(ze);if(je(de,Fe))break;ie-=ze>=65536?2:1,Fe=de}return[ie,Ue]}function F(j,ie){return ie>0&&B(j.charCodeAt(ie))?C(j,ie-1):C(j,ie)}e.getCharContainingOffset=F;function R(j){const ie=j.length;let ae=0,ce=0;for(;ce<ie;){const Me=Q(j,ie,ce);ce+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const fe=new Uint8Array(ae);ce=0;let be=0;for(;ce<ie;){const Me=Q(j,ie,ce);ce+=Me>=65536?2:1,Me<128?fe[be++]=Me:Me<2048?(fe[be++]=192|(Me&1984)>>>6,fe[be++]=128|(Me&63)>>>0):Me<65536?(fe[be++]=224|(Me&61440)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0):(fe[be++]=240|(Me&1835008)>>>18,fe[be++]=128|(Me&258048)>>>12,fe[be++]=128|(Me&4032)>>>6,fe[be++]=128|(Me&63)>>>0)}return fe}e.encodeUTF8=R;function O(j){const ie=j.byteLength,ae=[];let ce=0;for(;ce<ie;){const fe=j[ce];let be;if(fe>=240&&ce+3<ie?be=(j[ce++]&7)<<18>>>0|(j[ce++]&63)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=224&&ce+2<ie?be=(j[ce++]&15)<<12>>>0|(j[ce++]&63)<<6>>>0|(j[ce++]&63)<<0>>>0:fe>=192&&ce+1<ie?be=(j[ce++]&31)<<6>>>0|(j[ce++]&63)<<0>>>0:be=j[ce++],be>=0&&be<=55295||be>=57344&&be<=65535)ae.push(String.fromCharCode(be));else if(be>=65536&&be<=1114111){const Me=be-65536,Fe=55296+((Me&1047552)>>>10),Ue=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(Ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const P=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(j){return P.test(j)}e.containsRTL=W;const _=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function q(j){return _.test(j)}e.containsEmoji=q;const V=/^[\t\n\r\x20-\x7E]*$/;function K(j){return V.test(j)}e.isBasicASCII=K,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(j){return e.UNUSUAL_LINE_TERMINATORS.test(j)}e.containsUnusualLineTerminators=Z;function ne(j){for(let ie=0,ae=j.length;ie<ae;ie++)if(re(j.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=ne;function re(j){return j=+j,j>=11904&&j<=55215||j>=63744&&j<=64255||j>=65281&&j<=65374}e.isFullWidthCharacter=re;function se(j){return j>=127462&&j<=127487||j===8986||j===8987||j===9200||j===9203||j>=9728&&j<=10175||j===11088||j===11093||j>=127744&&j<=128591||j>=128640&&j<=128764||j>=128992&&j<=129003||j>=129280&&j<=129535||j>=129648&&j<=129750}e.isEmojiImprecise=se;function le(j,ie){if(j.length<ie)return j;const ae=/\b/g;let ce=0;for(;ae.test(j)&&!(j.length-ae.lastIndex<ie);)ce=ae.lastIndex,ae.lastIndex+=1;return j.substring(ce).replace(/^\s/,"")}e.lcut=le;const oe=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Se(j){return j&&(j=j.replace(oe,""),j=j.replace(ue,""),j=j.replace(me,"")),j}e.removeAnsiEscapeCodes=Se,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(j){return!!(j&&j.length>0&&j.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function Ie(j){return Le(j)?j.substr(1):j}e.stripUTF8BOM=Ie;function we(j,ie){if(!j||!ie||j.length<ie.length)return!1;const ae=ie.length,ce=j.toLowerCase();let fe=0,be=-1;for(;fe<ae;){const Me=ce.indexOf(ie[fe],be+1);if(Me<0)return!1;be=Me,fe++}return!0}e.fuzzyContains=we;function ye(j,ie=!1){return j?(ie&&(j=j.replace(/\\./g,"")),j.toLowerCase()!==j):!1}e.containsUppercaseCharacter=ye;function Re(j){return j.charAt(0).toUpperCase()+j.slice(1)}e.uppercaseFirstLetter=Re;function Te(j,ie=1){if(ie===0)return"";let ae=-1;do ae=j.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?j:(j[ae-1]==="\r"&&ae--,j.substr(0,ae))}e.getNLines=Te;function $e(j){const ie=90-65+1;return j=j%(2*ie),j<ie?String.fromCharCode(97+j):String.fromCharCode(65+j-ie)}e.singleLetterHash=$e;function Ne(j){return Be.getInstance().getGraphemeBreakType(j)}e.getGraphemeBreakType=Ne;function je(j,ie){return j===0?ie!==5&&ie!==7:j===2&&ie===3?!1:j===4||j===2||j===3||ie===4||ie===2||ie===3?!0:!(j===8&&(ie===8||ie===9||ie===11||ie===12)||(j===11||j===9)&&(ie===9||ie===10)||(j===12||j===10)&&ie===10||ie===5||ie===13||ie===7||j===1||j===13&&ie===14||j===6&&ie===6)}e.breakBetweenGraphemeBreakType=je;var xe;(function(j){j[j.Other=0]="Other",j[j.Prepend=1]="Prepend",j[j.CR=2]="CR",j[j.LF=3]="LF",j[j.Control=4]="Control",j[j.Extend=5]="Extend",j[j.Regional_Indicator=6]="Regional_Indicator",j[j.SpacingMark=7]="SpacingMark",j[j.L=8]="L",j[j.V=9]="V",j[j.T=10]="T",j[j.LV=11]="LV",j[j.LVT=12]="LVT",j[j.ZWJ=13]="ZWJ",j[j.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=rt()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,ce=ae.length/3;let fe=1;for(;fe<=ce;)if(ie<ae[3*fe])fe=2*fe;else if(ie>ae[3*fe+1])fe=2*fe+1;else return ae[3*fe+2];return 0}}Be._INSTANCE=null;function rt(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function et(j,ie){if(j===0)return 0;const ae=ct(j,ie);if(ae!==void 0)return ae;const ce=N(ie,j);return j-=Ge(ce),j}e.getLeftDeleteOffset=et;function ct(j,ie){let ae=N(ie,j);for(j-=Ge(ae);ut(ae)||ae===65039||ae===8419;){if(j===0)return;ae=N(ie,j),j-=Ge(ae)}if(!!se(ae)){if(j>=0){const ce=N(ie,j);ce===8205&&(j-=Ge(ce))}return j}}function Ge(j){return j>=65536?2:1}function ut(j){return 127995<=j&&j<=127999}var st;(function(j){j[j.zwj=8205]="zwj",j[j.emojiVariantSelector=65039]="emojiVariantSelector",j[j.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={}))}),define(J[20],x([0,1,23,64]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",E=typeof TextDecoder!="undefined";let n,w;class y{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return A?new y(Buffer.allocUnsafe(h)):new y(new Uint8Array(h))}static wrap(h){return A&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new y(h)}static fromString(h,M){return!((M==null?void 0:M.dontUseNodeBuffer)||!1)&&A?new y(Buffer.from(h)):S?(n||(n=new TextEncoder),new y(n.encode(h))):new y(v.encodeUTF8(h))}static concat(h,M){if(typeof M=="undefined"){M=0;for(let H=0,X=h.length;H<X;H++)M+=h[H].byteLength}const T=y.alloc(M);let U=0;for(let H=0,X=h.length;H<X;H++){const ee=h[H];T.set(ee,U),U+=ee.byteLength}return T}toString(){return A?this.buffer.toString():E?(w||(w=new TextDecoder),w.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(h,M){return new y(this.buffer.subarray(h,M))}set(h,M){h instanceof y?this.buffer.set(h.buffer,M):this.buffer.set(h,M)}readUInt32BE(h){return k(this.buffer,h)}writeUInt32BE(h,M){p(this.buffer,h,M)}readUInt32LE(h){return g(this.buffer,h)}writeUInt32LE(h,M){m(this.buffer,h,M)}readUInt8(h){return D(this.buffer,h)}writeUInt8(h,M){b(this.buffer,h,M)}}e.VSBuffer=y;function i(f,h){return f[h+0]<<0>>>0|f[h+1]<<8>>>0}e.readUInt16LE=i;function I(f,h,M){f[M+0]=h&255,h=h>>>8,f[M+1]=h&255}e.writeUInt16LE=I;function k(f,h){return f[h]*2**24+f[h+1]*2**16+f[h+2]*2**8+f[h+3]}e.readUInt32BE=k;function p(f,h,M){f[M+3]=h,h=h>>>8,f[M+2]=h,h=h>>>8,f[M+1]=h,h=h>>>8,f[M]=h}e.writeUInt32BE=p;function g(f,h){return f[h+0]<<0>>>0|f[h+1]<<8>>>0|f[h+2]<<16>>>0|f[h+3]<<24>>>0}e.readUInt32LE=g;function m(f,h,M){f[M+0]=h&255,h=h>>>8,f[M+1]=h&255,h=h>>>8,f[M+2]=h&255,h=h>>>8,f[M+3]=h&255}e.writeUInt32LE=m;function D(f,h){return f[h]}e.readUInt8=D;function b(f,h,M){f[M]=h}e.writeUInt8=b;function l(f){return L.consumeReadable(f,h=>y.concat(h))}e.readableToBuffer=l;function u(f){return L.toReadable(f)}e.bufferToReadable=u;function o(f){return L.consumeStream(f,h=>y.concat(h))}e.streamToBuffer=o;async function a(f){return f.ended?y.concat(f.buffer):y.concat([...f.buffer,await o(f.stream)])}e.bufferedStreamToBuffer=a;function t(f){return L.toStream(f,h=>y.concat(h))}e.bufferToStream=t;function r(f){return L.transform(f,{data:h=>typeof h=="string"?y.fromString(h):y.wrap(h)},h=>y.concat(h))}e.streamToBufferReadableStream=r;function s(f){return L.newWriteableStream(h=>y.concat(h),f)}e.newWriteableBufferStream=s;function c(f,h){return L.prefixedReadable(f,h,M=>y.concat(M))}e.prefixedBufferReadable=c;function d(f,h){return L.prefixedStream(f,h,M=>y.concat(M))}e.prefixedBufferStream=d}),define(J[80],x([0,1,23]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function L(b){return A(b,0)}e.hash=L;function A(b,l){switch(typeof b){case"object":return b===null?S(349,l):Array.isArray(b)?w(b,l):y(b,l);case"string":return n(b,l);case"boolean":return E(b,l);case"number":return S(b,l);case"undefined":return S(937,l);default:return S(617,l)}}e.doHash=A;function S(b,l){return(l<<5)-l+b|0}function E(b,l){return S(b?433:863,l)}function n(b,l){l=S(149417,l);for(let u=0,o=b.length;u<o;u++)l=S(b.charCodeAt(u),l);return l}e.stringHash=n;function w(b,l){return l=S(104579,l),b.reduce((u,o)=>A(o,u),l)}function y(b,l){return l=S(181387,l),Object.keys(b).sort().reduce((u,o)=>(u=n(o,u),A(b[o],u)),l)}class i{constructor(){this._value=0}get value(){return this._value}hash(l){return this._value=A(l,this._value),this._value}}e.Hasher=i;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function k(b,l,u=32){const o=u-l,a=~((1<<o)-1);return(b<<l|(a&b)>>>o)>>>0}function p(b,l=0,u=b.byteLength,o=0){for(let a=0;a<u;a++)b[l+a]=o}function g(b,l,u="0"){for(;b.length<l;)b=u+b;return b}function m(b,l=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):g((b>>>0).toString(16),l/4)}e.toHexString=m;class D{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(l){const u=l.length;if(u===0)return;const o=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=l.charCodeAt(0),s=0);;){let c=r;if(v.isHighSurrogate(r))if(s+1<u){const d=l.charCodeAt(s+1);v.isLowSurrogate(d)?(s++,c=v.computeCodePoint(r,d)):c=65533}else{t=r;break}else v.isLowSurrogate(r)&&(c=65533);if(a=this._push(o,a,c),s++,s<u)r=l.charCodeAt(s);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(l,u,o){return o<128?l[u++]=o:o<2048?(l[u++]=192|(o&1984)>>>6,l[u++]=128|(o&63)>>>0):o<65536?(l[u++]=224|(o&61440)>>>12,l[u++]=128|(o&4032)>>>6,l[u++]=128|(o&63)>>>0):(l[u++]=240|(o&1835008)>>>18,l[u++]=128|(o&258048)>>>12,l[u++]=128|(o&4032)>>>6,l[u++]=128|(o&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const l=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(l/4294967296),!1),this._buffDV.setUint32(60,l%4294967296,!1),this._step()}_step(){const l=D._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)l.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)l.setUint32(h,k(l.getUint32(h-12,!1)^l.getUint32(h-32,!1)^l.getUint32(h-56,!1)^l.getUint32(h-64,!1),1),!1);let o=this._h0,a=this._h1,t=this._h2,r=this._h3,s=this._h4,c,d,f;for(let h=0;h<80;h++)h<20?(c=a&t|~a&r,d=1518500249):h<40?(c=a^t^r,d=1859775393):h<60?(c=a&t|a&r|t&r,d=2400959708):(c=a^t^r,d=3395469782),f=k(o,5)+c+s+d+l.getUint32(h*4,!1)&4294967295,s=r,r=t,t=k(a,30),a=o,o=f;this._h0=this._h0+o&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=D,D._bigBlock32=new DataView(new ArrayBuffer(320))}),define(J[13],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(h){return Array.isArray(h)}e.isArray=v;function L(h){return typeof h=="string"}e.isString=L;function A(h){return Array.isArray(h)&&h.every(M=>L(M))}e.isStringArray=A;function S(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=S;function E(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=E;function n(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=n;function w(h){return h===!0||h===!1}e.isBoolean=w;function y(h){return typeof h=="undefined"}e.isUndefined=y;function i(h){return!I(h)}e.isDefined=i;function I(h){return y(h)||h===null}e.isUndefinedOrNull=I;function k(h,M){if(!h)throw new Error(M?`Unexpected type, expected '${M}'`:"Unexpected type")}e.assertType=k;function p(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=p;function g(...h){const M=[];for(let T=0;T<h.length;T++){const U=h[T];if(I(U))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);M.push(U)}return M}e.assertAllDefined=g;const m=Object.prototype.hasOwnProperty;function D(h){if(!S(h))return!1;for(let M in h)if(m.call(h,M))return!1;return!0}e.isEmptyObject=D;function b(h){return typeof h=="function"}e.isFunction=b;function l(...h){return h.length>0&&h.every(b)}e.areFunctions=l;function u(h,M){const T=Math.min(h.length,M.length);for(let U=0;U<T;U++)o(h[U],M[U])}e.validateConstraints=u;function o(h,M){if(L(M)){if(typeof h!==M)throw new Error(`argument does not match constraint: typeof ${M}`)}else if(b(M)){try{if(h instanceof M)return}catch(T){}if(!I(h)&&h.constructor===M||M.length===1&&M.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function a(h){let M=[],T=Object.getPrototypeOf(h);for(;Object.prototype!==T;)M=M.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return M}e.getAllPropertyNames=a;function t(h){const M=[];for(const T of a(h))typeof h[T]=="function"&&M.push(T);return M}e.getAllMethodNames=t;function r(h,M){const T=H=>function(){const X=Array.prototype.slice.call(arguments,0);return M(H,X)};let U={};for(const H of h)U[H]=T(H);return U}e.createProxyObject=r;function s(h){return h===null?void 0:h}e.withNullAsUndefined=s;function c(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=c;function d(h){return class{constructor(){return new Proxy({},{get(M,T){if(M[T])return M[T];throw new Error(`Not Implemented: ${h}->${String(T)}`)}})}}}e.NotImplementedProxy=d;function f(h){throw new Error("Unreachable")}e.assertNever=f}),define(J[30],x([0,1,3,23,8,13]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function E(s){return s===47||s===92}e.isPathSeparator=E;function n(s){return s.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=n;function w(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=w;function y(s,c=A.posix.sep){if(!s)return"";const d=s.length,f=s.charCodeAt(0);if(E(f)){if(E(s.charCodeAt(1))&&!E(s.charCodeAt(2))){let M=3;const T=M;for(;M<d&&!E(s.charCodeAt(M));M++);if(T!==M&&!E(s.charCodeAt(M+1))){for(M+=1;M<d;M++)if(E(s.charCodeAt(M)))return s.slice(0,M+1).replace(/[\\/]/g,c)}}return c}else if(b(f)&&s.charCodeAt(1)===58)return E(s.charCodeAt(2))?s.slice(0,2)+c:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<d;h++)if(E(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=y;function i(s){if(!v.isWindows||!s||s.length<5)return!1;let c=s.charCodeAt(0);if(c!==92||(c=s.charCodeAt(1),c!==92))return!1;let d=2;const f=d;for(;d<s.length&&(c=s.charCodeAt(d),c!==92);d++);return!(f===d||(c=s.charCodeAt(d+1),isNaN(c)||c===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(s,c=v.isWindows){const d=c?I:k;return!(!s||s.length===0||/^\s+$/.test(s)||(d.lastIndex=0,d.test(s))||c&&p.test(s)||s==="."||s===".."||c&&s[s.length-1]==="."||c&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=g;function m(s,c,d){const f=s===c;return!d||f?f:!s||!c?!1:L.equalsIgnoreCase(s,c)}e.isEqual=m;function D(s,c,d,f=A.sep){if(s===c)return!0;if(!s||!c||c.length>s.length)return!1;if(d){if(!L.startsWithIgnoreCase(s,c))return!1;if(c.length===s.length)return!0;let M=c.length;return c.charAt(c.length-1)===f&&M--,s.charAt(M)===f}return c.charAt(c.length-1)!==f&&(c+=f),s.indexOf(c)===0}e.isEqualOrParent=D;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function l(s,c){return v.isWindows&&s.endsWith(":")&&(s+=A.sep),A.isAbsolute(s)||(s=A.join(c,s)),s=A.normalize(s),v.isWindows?(s=L.rtrim(s,A.sep),s.endsWith(":")&&(s+=A.sep)):(s=L.rtrim(s,A.sep),s||(s=A.sep)),s}e.sanitizeFilePath=l;function u(s){const c=A.normalize(s);return v.isWindows?s.length>3?!1:o(c)&&(s.length===2||c.charCodeAt(2)===92):c===A.posix.sep}e.isRootOrDriveLetter=u;function o(s){return v.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function a(s){return o(s)?s[0]:void 0}e.getDriveLetter=a;function t(s,c,d){return c.length>s.length?-1:s===c?0:(d&&(s=s.toLowerCase(),c=c.toLowerCase()),s.indexOf(c))}e.indexOfPath=t;function r(s){const c=s.split(":");let d,f,h;if(c.forEach(M=>{const T=Number(M);S.isNumber(T)?f===void 0?f=T:h===void 0&&(h=T):d=d?[d,M].join(":"):M}),!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:f!==void 0?f:void 0,column:h!==void 0?h:f!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(J[44],x([0,1,13]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const D=Array.isArray(m)?[]:{};return Object.keys(m).forEach(b=>{m[b]&&typeof m[b]=="object"?D[b]=L(m[b]):D[b]=m[b]}),D}e.deepClone=L;function A(m){if(!m||typeof m!="object")return m;const D=[m];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const l in b)if(S.call(b,l)){const u=b[l];typeof u=="object"&&!Object.isFrozen(u)&&D.push(u)}}return m}e.deepFreeze=A;const S=Object.prototype.hasOwnProperty;function E(m,D){return n(m,D,new Set)}e.cloneAndChange=E;function n(m,D,b){if(v.isUndefinedOrNull(m))return m;const l=D(m);if(typeof l!="undefined")return l;if(v.isArray(m)){const u=[];for(const o of m)u.push(n(o,D,b));return u}if(v.isObject(m)){if(b.has(m))throw new Error("Cannot clone recursive data-structure");b.add(m);const u={};for(let o in m)S.call(m,o)&&(u[o]=n(m[o],D,b));return b.delete(m),u}return m}function w(m,D,b=!0){return v.isObject(m)?(v.isObject(D)&&Object.keys(D).forEach(l=>{l in m?b&&(v.isObject(m[l])&&v.isObject(D[l])?w(m[l],D[l],b):m[l]=D[l]):m[l]=D[l]}),m):D}e.mixin=w;function y(m,D){if(m===D)return!0;if(m==null||D===null||D===void 0||typeof m!=typeof D||typeof m!="object"||Array.isArray(m)!==Array.isArray(D))return!1;let b,l;if(Array.isArray(m)){if(m.length!==D.length)return!1;for(b=0;b<m.length;b++)if(!y(m[b],D[b]))return!1}else{const u=[];for(l in m)u.push(l);u.sort();const o=[];for(l in D)o.push(l);if(o.sort(),!y(u,o))return!1;for(b=0;b<u.length;b++)if(!y(m[u[b]],D[u[b]]))return!1}return!0}e.equals=y;function i(m){const D=new Set;return JSON.stringify(m,(b,l)=>{if(v.isObject(l)||Array.isArray(l)){if(D.has(l))return"[Circular]";D.add(l)}return l})}e.safeStringify=i;function I(m,D,b){const l=D(m);return typeof l=="undefined"?b:l}e.getOrDefault=I;function k(m,D){const b=Object.create(null);return!m||!D||Object.keys(D).forEach(u=>{const o=m[u],a=D[u];y(o,a)||(b[u]=a)}),b}e.distinct=k;function p(m,D){const b=D.toLowerCase(),l=Object.keys(m).find(u=>u.toLowerCase()===b);return l?m[l]:m[D]}e.getCaseInsensitive=p;function g(m,D){const b=Object.create(null);for(const l of Object.keys(m))D(l,m[l])&&(b[l]=m[l]);return b}e.filter=g}),define(J[7],x([0,1,3,8]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,S=/^\//,E=/^\/\//;function n(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,c){return!s&&!c?"file":s}function y(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const i="",I="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(c,d,f,h,M,T=!1){typeof c=="object"?(this.scheme=c.scheme||i,this.authority=c.authority||i,this.path=c.path||i,this.query=c.query||i,this.fragment=c.fragment||i):(this.scheme=w(c,T),this.authority=d||i,this.path=y(this.scheme,f||i),this.query=h||i,this.fragment=M||i,n(this,T))}static isUri(c){return c instanceof p?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return u(this,!1)}with(c){if(!c)return this;let{scheme:d,authority:f,path:h,query:M,fragment:T}=c;return d===void 0?d=this.scheme:d===null&&(d=i),f===void 0?f=this.authority:f===null&&(f=i),h===void 0?h=this.path:h===null&&(h=i),M===void 0?M=this.query:M===null&&(M=i),T===void 0?T=this.fragment:T===null&&(T=i),d===this.scheme&&f===this.authority&&h===this.path&&M===this.query&&T===this.fragment?this:new m(d,f,h,M,T)}static parse(c,d=!1){const f=k.exec(c);return f?new m(f[2]||i,r(f[4]||i),r(f[5]||i),r(f[7]||i),r(f[9]||i),d):new m(i,i,i,i,i)}static file(c){let d=i;if(v.isWindows&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const f=c.indexOf(I,2);f===-1?(d=c.substring(2),c=I):(d=c.substring(2,f),c=c.substring(f)||I)}return new m("file",d,c,i,i)}static from(c){const d=new m(c.scheme,c.authority,c.path,c.query,c.fragment);return n(d,!0),d}static joinPath(c,...d){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&c.scheme==="file"?f=p.file(L.win32.join(u(c,!0),...d)).path:f=L.posix.join(c.path,...d),c.with({path:f})}toString(c=!1){return o(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof p)return c;{const d=new m(c);return d._formatted=c.external,d._fsPath=c._sep===g?c.fsPath:null,d}}else return c}}e.URI=p;const g=v.isWindows?1:void 0;class m extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(c=!1){return c?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=g),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,c){let d,f=-1;for(let h=0;h<s.length;h++){const M=s.charCodeAt(h);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||c&&M===47)f!==-1&&(d+=encodeURIComponent(s.substring(f,h)),f=-1),d!==void 0&&(d+=s.charAt(h));else{d===void 0&&(d=s.substr(0,h));const T=D[M];T!==void 0?(f!==-1&&(d+=encodeURIComponent(s.substring(f,h)),f=-1),d+=T):f===-1&&(f=h)}}return f!==-1&&(d+=encodeURIComponent(s.substring(f))),d!==void 0?d:s}function l(s){let c;for(let d=0;d<s.length;d++){const f=s.charCodeAt(d);f===35||f===63?(c===void 0&&(c=s.substr(0,d)),c+=D[f]):c!==void 0&&(c+=s[d])}return c!==void 0?c:s}function u(s,c){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,v.isWindows&&(d=d.replace(/\//g,"\\")),d}e.uriToFsPath=u;function o(s,c){const d=c?l:b;let f="",{scheme:h,authority:M,path:T,query:U,fragment:H}=s;if(h&&(f+=h,f+=":"),(M||h==="file")&&(f+=I,f+=I),M){let X=M.indexOf("@");if(X!==-1){const ee=M.substr(0,X);M=M.substr(X+1),X=ee.indexOf(":"),X===-1?f+=d(ee,!1):(f+=d(ee.substr(0,X),!1),f+=":",f+=d(ee.substr(X+1),!1)),f+="@"}M=M.toLowerCase(),X=M.indexOf(":"),X===-1?f+=d(M,!1):(f+=d(M.substr(0,X),!1),f+=M.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}f+=d(T,!0)}return U&&(f+="?",f+=d(U,!1)),H&&(f+="#",f+=c?H:b(H,!1)),f}function a(s){try{return decodeURIComponent(s)}catch(c){return s.length>3?s.substr(0,3)+a(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,c=>a(c)):s}}),define(J[109],x([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(y){const i=y;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function A(y){const i=[];let I;try{const k=JSON.parse(y.arguments),p=k[k.length-1];p&&p.__$stack&&(k.pop(),I=p.__$stack),i.push(...k)}catch(k){i.push("Unable to log remote console arguments",y.arguments)}return{args:i,stack:I}}e.parse=A;function S(y){if(typeof y!="string")return S(A(y).stack);const i=y;if(i){const I=E(i),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(k&&k.length===4)return{uri:v.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}e.getFirstFrame=S;function E(y){if(!y)return y;const i=y.indexOf(`
`);return i===-1?y:y.substring(0,i)}function n(y,i){const{args:I,stack:k}=A(y),p=typeof I[0]=="string"&&I.length===1;let g=E(k);g&&(g=`(${g.trim()})`);let m=[];if(typeof I[0]=="string"?g&&p?m=[`%c[${i}] %c${I[0]} %c${g}`,w("blue"),w(""),w("grey")]:m=[`%c[${i}] %c${I[0]}`,w("blue"),w(""),...I.slice(1)]:m=[`%c[${i}]%`,w("blue"),...I],g&&!p&&m.push(g),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,m)}e.log=n;function w(y){return`color: ${y}`}});var It=this&&this.__classPrivateFieldSet||function($,e,v,L,A){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?$!==e||!A:!e.has($))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?A.call($,v):A?A.value=v:e.set($,v),v},Ke=this&&this.__classPrivateFieldGet||function($,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?$!==e||!L:!e.has($))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call($):L?L.value:e.get($)};define(J[36],x([0,1,7,23]),function($,e,v,L){"use strict";var A,S,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function n(t,r,s){let c=t.get(r);return c===void 0&&(c=s,t.set(r,c)),c}e.getOrSet=n;function w(t){const r=[];return t.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=w;function y(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class k{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?L.compareSubstring(r,this._value,0,r.length,this._from,this._to):L.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var p;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return L.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return L.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return L.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return L.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new g(r))}static forPaths(){return new D(new k)}static forStrings(){return new D(new i)}static forConfigKeys(){return new D(new I)}clear(){this._root=void 0}set(r,s){const c=this._iter.reset(r);let d;for(this._root||(this._root=new m,this._root.segment=c.value()),d=this._root;;){const h=c.cmp(d.segment);if(h>0)d.left||(d.left=new m,d.left.segment=c.value()),d=d.left;else if(h<0)d.right||(d.right=new m,d.right.segment=c.value()),d=d.right;else if(c.hasNext())c.next(),d.mid||(d.mid=new m,d.mid.segment=c.value()),d=d.mid;else break}const f=d.value;return d.value=s,d.key=r,f}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const d=s.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const c=this._iter.reset(r),d=[];let f=this._root;for(;f;){const h=c.cmp(f.segment);if(h>0)d.push([1,f]),f=f.left;else if(h<0)d.push([-1,f]),f=f.right;else if(c.hasNext())c.next(),d.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;d.length>0&&f.isEmpty();){let[M,T]=d.pop();switch(M){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(r){const s=this._iter.reset(r);let c=this._root,d;for(;c;){const f=s.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(s.hasNext())s.next(),d=c.value||d,c=c.mid;else break}return c&&c.value||d}findSuperstr(r){const s=this._iter.reset(r);let c=this._root;for(;c;){const d=s.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[s,c]of this)r(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r,s=0){if(s>5e3){console.log("potential CYCLE detected",new Error().stack);return}r&&(yield*this._entries(r.left,s++),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid,s++),yield*this._entries(r.right,s++))}}e.TernarySearchTree=D;class b{constructor(r,s){this[A]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[c,d]of this.map)r(d,v.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const c=this._map.get(r);if(!!c)return s!==0&&this.touch(c,s),c.value}set(r,s,c=0){let d=this._map.get(r);if(d)d.value=s,c!==0&&this.touch(d,c);else{switch(d={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(r,d),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const c=this._state;let d=this._head;for(;d;){if(s?r.bind(s)(d.value,d.key,this):r(d.value,d.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,s=this._state;let c=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return d}values(){const r=this,s=this._state;let c=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return d}entries(){const r=this,s=this._state;let c=this._head;const d={[Symbol.iterator](){return d},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return d}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>r;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const c=r.next,d=r.previous;r===this._tail?(d.next=void 0,this._tail=d):(c.previous=d,d.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const c=r.next,d=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=d,d.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.LinkedMap=u;class o extends u{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class a{constructor(r){E.set(this,void 0),It(this,E,r,"f")}get size(){return Ke(this,E,"f").size}forEach(r,s){Ke(this,E,"f").forEach(r,s)}get(r){return Ke(this,E,"f").get(r)}has(r){return Ke(this,E,"f").has(r)}entries(){return Ke(this,E,"f").entries()}keys(){return Ke(this,E,"f").keys()}values(){return Ke(this,E,"f").values()}[(E=new WeakMap,Symbol.iterator)](){return Ke(this,E,"f").entries()}}e.ReadonlyMapView=a}),define(J[110],x([0,1,20,23,7]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(y){return JSON.stringify(y,n)}e.stringify=S;function E(y){let i=JSON.parse(y);return i=w(i),i}e.parse=E;function n(y,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:L.regExpFlags(i)}:i}function w(y,i=0){if(!y||i>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return A.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof v.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let I=0;I<y.length;++I)y[I]=w(y[I],i+1);else for(const I in y)Object.hasOwnProperty.call(y,I)&&(y[I]=w(y[I],i+1))}return y}e.revive=w}),define(J[10],x([0,1,7,3]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,y,i){this._hosts[w]=y,this._ports[w]=i}setConnectionToken(w,y){this._connectionTokens[w]=y}rewrite(w){if(this._delegate)return this._delegate(w);const y=w.authority;let i=this._hosts[y];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[y],k=this._connectionTokens[y];let p=`path=${encodeURIComponent(w.path)}`;return typeof k=="string"&&(p+=`&tkn=${encodeURIComponent(k)}`),v.URI.from({scheme:L.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class E{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,y,i){const I=this.toUri(w,y);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):L.isNative&&(i||L.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(w,y){const i=this.toUri(w,y);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(w,y){return v.URI.isUri(w)?w:v.URI.parse(y.toUrl(w))}}e.FileAccess=new E}),define(J[65],x([0,1,36]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new v.LRUCache(1e4);function A(y){return w(y,"NFC",L)}e.normalizeNFC=A;const S=new v.LRUCache(1e4);function E(y){return w(y,"NFD",S)}e.normalizeNFD=E;const n=/[^\u0000-\u0080]/;function w(y,i,I){if(!e.canNormalize||!y)return y;const k=I.get(y);if(k)return k;let p;return n.test(y)?p=y.normalize(i):p=y,I.set(y,p),p}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(i){return E(i).replace(y,"")}}else return function(y){return y}}()}),define(J[15],x([0,1,30,8,7,23,10,3]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(p){return A.uriToFsPath(p,!0)}e.originalFSPath=w;class y{constructor(g){this._ignorePathCasing=g}compare(g,m,D=!1){return g===m?0:S.compare(this.getComparisonKey(g,D),this.getComparisonKey(m,D))}isEqual(g,m,D=!1){return g===m?!0:!g||!m?!1:this.getComparisonKey(g,D)===this.getComparisonKey(m,D)}getComparisonKey(g,m=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,m,D=!1){if(g.scheme===m.scheme){if(g.scheme===E.Schemas.file)return v.isEqualOrParent(w(g),w(m),this._ignorePathCasing(g))&&g.query===m.query&&(D||g.fragment===m.fragment);if(e.isEqualAuthority(g.authority,m.authority))return v.isEqualOrParent(g.path,m.path,this._ignorePathCasing(g),"/")&&g.query===m.query&&(D||g.fragment===m.fragment)}return!1}joinPath(g,...m){return A.URI.joinPath(g,...m)}basenameOrAuthority(g){return e.basename(g)||g.authority}basename(g){return L.posix.basename(g.path)}extname(g){return L.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let m;return g.scheme===E.Schemas.file?m=A.URI.file(L.dirname(w(g))).path:(m=L.posix.dirname(g.path),g.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),m="/")),g.with({path:m})}normalizePath(g){if(!g.path.length)return g;let m;return g.scheme===E.Schemas.file?m=A.URI.file(L.normalize(w(g))).path:m=L.posix.normalize(g.path),g.with({path:m})}relativePath(g,m){if(g.scheme!==m.scheme||!e.isEqualAuthority(g.authority,m.authority))return;if(g.scheme===E.Schemas.file){const l=L.relative(w(g),w(m));return n.isWindows?v.toSlashes(l):l}let D=g.path||"/",b=m.path||"/";if(this._ignorePathCasing(g)){let l=0;for(const u=Math.min(D.length,b.length);l<u&&!(D.charCodeAt(l)!==b.charCodeAt(l)&&D.charAt(l).toLowerCase()!==b.charAt(l).toLowerCase());l++);D=b.substr(0,l)+D.substr(l)}return L.posix.relative(D,b)}resolvePath(g,m){if(g.scheme===E.Schemas.file){const D=A.URI.file(L.resolve(w(g),m));return g.with({authority:D.authority,path:D.path})}return m=v.toPosixPath(m),g.with({path:L.posix.resolve(g.path,m)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,m){return g===m||S.equalsIgnoreCase(g,m)}hasTrailingPathSeparator(g,m=L.sep){if(g.scheme===E.Schemas.file){const D=w(g);return D.length>v.getRoot(D).length&&D[D.length-1]===m}else{const D=g.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,m=L.sep){return e.hasTrailingPathSeparator(g,m)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,m=L.sep){let D=!1;if(g.scheme===E.Schemas.file){const b=w(g);D=b!==void 0&&b.length===v.getRoot(b).length&&b[b.length-1]===m}else{m="/";const b=g.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!e.hasTrailingPathSeparator(g,m)?g.with({path:g.path+"/"}):g}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(p=>p.scheme===E.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new y(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,g){const m=[];for(let D=0;D<p.length;D++){const b=g(p[D]);p.some((l,u)=>u===D?!1:e.isEqualOrParent(b,g(l)))||m.push(p[D])}return m}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function g(m){const D=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(u=>{const[o,a]=u.split(":");o&&a&&D.set(o,a)});const l=m.path.substring(0,m.path.indexOf(";"));return l&&D.set(p.META_DATA_MIME,l),D}p.parseMetaData=g})(I=e.DataUri||(e.DataUri={}));function k(p,g,m){if(g){let D=p.path;return D&&D[0]!==L.posix.sep&&(D=L.posix.sep+D),p.with({scheme:m,authority:g,path:D})}return p.with({scheme:m})}e.toLocalResource=k}),define(J[9],x([0,1,25,19,5,2,78,15]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(C){return!!C&&typeof C.then=="function"}e.isThenable=w;function y(C){const F=new v.CancellationTokenSource,R=C(F.token),O=new Promise((P,W)=>{F.token.onCancellationRequested(()=>{W(L.canceled())}),Promise.resolve(R).then(_=>{F.dispose(),P(_)},_=>{F.dispose(),W(_)})});return new class{cancel(){F.cancel()}then(P,W){return O.then(P,W)}catch(P){return this.then(void 0,P)}finally(P){return O.finally(P)}}}e.createCancelablePromise=y;function i(C,F,R){return Promise.race([C,new Promise(O=>F.onCancellationRequested(()=>O(R)))])}e.raceCancellation=i;async function I(C){let F=-1;const R=C.map((P,W)=>P.then(_=>(F=W,_))),O=await Promise.race(R);return C.forEach((P,W)=>{W!==F&&P.cancel()}),O}e.raceCancellablePromises=I;function k(C,F,R){let O;const P=setTimeout(()=>{O==null||O(void 0),R==null||R()},F);return Promise.race([C.finally(()=>clearTimeout(P)),new Promise(W=>O=W)])}e.raceTimeout=k;function p(C){return new Promise((F,R)=>{const O=C();w(O)?O.then(F,R):F(O)})}e.asPromise=p;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(R,R).then(O)})}return new Promise((R,O)=>{this.queuedPromise.then(R,O)})}return this.activePromise=F(),new Promise((R,O)=>{this.activePromise.then(P=>{this.activePromise=null,R(P)},P=>{this.activePromise=null,O(P)})})}}e.Throttler=g;class m{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=m;class D{constructor(){this.promiseMap=new Map}queue(F,R){var O;const W=((O=this.promiseMap.get(F))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(F)===W&&this.promiseMap.delete(F)});return this.promiseMap.set(F,W),W}}e.SequencerByKey=D;class b{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,R=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,P)=>{this.doResolve=O,this.doReject=P}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(L.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=b;class l{constructor(F){this.delayer=new b(F),this.throttler=new g}trigger(F,R){return this.delayer.trigger(()=>this.throttler.queue(F),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,R)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class o extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function a(C,F){return F?new Promise((R,O)=>{const P=setTimeout(R,C);F.onCancellationRequested(()=>{clearTimeout(P),O(L.canceled())})}):y(R=>a(C,R))}e.timeout=a;function t(C,F=0){const R=setTimeout(C,F);return S.toDisposable(()=>clearTimeout(R))}e.disposableTimeout=t;function r(C){return C.then(void 0,F=>{})}e.ignoreErrors=r;function s(C){const F=[];let R=0;const O=C.length;function P(){return R<O?C[R++]():null}function W(_){_!=null&&F.push(_);const q=P();return q?q.then(W):Promise.resolve(F)}return Promise.resolve(null).then(W)}e.sequence=s;function c(C,F=O=>!!O,R=null){let O=0;const P=C.length,W=()=>{if(O>=P)return Promise.resolve(R);const _=C[O++];return Promise.resolve(_()).then(V=>F(V)?Promise.resolve(V):W())};return W()}e.first=c;function d(C,F=O=>!!O,R=null){if(C.length===0)return Promise.resolve(R);let O=C.length;const P=()=>{var W,_;O=-1;for(const q of C)(_=(W=q).cancel)===null||_===void 0||_.call(W)};return new Promise((W,_)=>{for(const q of C)q.then(V=>{--O>=0&&F(V)?(P(),W(V)):O===0&&W(R)}).catch(V=>{--O>=0&&(P(),_(V))})})}e.firstParallel=d;class f{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((R,O)=>{this.outstandingPromises.push({factory:F,c:R,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const R=F.factory();R.then(F.c,F.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class h extends f{constructor(){super(1)}}e.Queue=h;class M{constructor(){this.queues=new Map}queueFor(F,R=n.extUri){const O=R.getComparisonKey(F);let P=this.queues.get(O);return P||(P=new h,A.Event.once(P.onFinished)(()=>{P==null||P.dispose(),this.queues.delete(O)}),this.queues.set(O,P)),P}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=M;class T{constructor(F,R){this._token=-1,typeof F=="function"&&typeof R=="number"&&this.setIfNotSet(F,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},R)}setIfNotSet(F,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},R))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,R){this.cancel(),this._token=setInterval(()=>{F()},R)}}e.IntervalTimer=U;class H{constructor(F,R){this.timeoutToken=-1,this.runner=F,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class X extends H{constructor(F,R){super(F,R);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const C=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const R=setTimeout(()=>F(C));let O=!1;return{dispose(){O||(O=!0,clearTimeout(R))}}}}else e.runWhenIdle=(C,F)=>{const R=requestIdleCallback(C,typeof F=="number"?{timeout:F}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(R))}}}}();class ee{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ee;async function B(C,F,R){let O;for(let P=0;P<R;P++)try{return await C()}catch(W){O=W,await a(F)}throw O}e.retry=B;class Y{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,R,O){return this._pending={taskId:F,cancel:()=>O==null?void 0:O(),promise:R},R.then(()=>this.donePending(F),()=>this.donePending(F)),R}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let R,O;const P=new Promise((W,_)=>{R=W,O=_});this._next={run:F,promise:P,promiseResolve:R,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=Y;class Q{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,R)=>{this.completeCallback=F,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(R=>{this.completeCallback(F),this.resolved=!0,R()})}error(F){return new Promise(R=>{this.errorCallback(F),this.rejected=!0,R()})}cancel(){new Promise(F=>{this.errorCallback(L.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=N;class G extends A.Emitter{async fireAsync(F,R,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new E.LinkedList);for(const P of this._listeners)this._asyncDeliveryQueue.push([P,F]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[P,W]=this._asyncDeliveryQueue.shift(),_=[],q=Object.assign(Object.assign({},W),{waitUntil:V=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");O&&(V=O(V,typeof P=="function"?P:P[0])),_.push(V)}});try{typeof P=="function"?P.call(void 0,q):P[0].call(P[1],q)}catch(V){L.onUnexpectedError(V);continue}Object.freeze(_),await z.settled(_).catch(V=>L.onUnexpectedError(V))}}}}e.AsyncEmitter=G;var z;(function(C){async function F(W){return typeof Promise.allSettled=="function"?R(W):O(W)}C.allSettled=F;async function R(W){return Promise.allSettled(W)}async function O(W){return Promise.all(W.map(_=>_.then(q=>({status:"fulfilled",value:q}),q=>({status:"rejected",reason:q}))))}async function P(W){let _;const q=await Promise.all(W.map(V=>V.then(K=>K,K=>{_||(_=K)})));if(typeof _!="undefined")throw _;return q}C.settled=P})(z=e.Promises||(e.Promises={}))}),define(J[111],x([0,1,23,30,8,36,9]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const w="**",y="/",i="[/\\\\]",I="[^/\\\\]",k=/\//g;function p(R){switch(R){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function g(R,O){if(!R)return[];const P=[];let W=!1,_=!1,q="";for(const V of R){switch(V){case O:if(!W&&!_){P.push(q),q="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":_=!0;break;case"]":_=!1;break}q+=V}return q&&P.push(q),P}e.splitGlobAware=g;function m(R){if(!R)return"";let O="";const P=g(R,y);if(P.every(W=>W===w))O=".*";else{let W=!1;P.forEach((_,q)=>{if(_===w){W||(O+=p(2),W=!0);return}let V=!1,K="",Z=!1,ne="";for(const re of _){if(re!=="}"&&V){K+=re;continue}if(Z&&(re!=="]"||!ne)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!ne?se="^":re===y?se="":se=v.escapeRegExpCharacters(re),ne+=se;continue}switch(re){case"{":V=!0;continue;case"[":Z=!0;continue;case"}":O+=`(?:${g(K,",").map(oe=>m(oe)).join("|")})`,V=!1,K="";break;case"]":O+="["+ne+"]",Z=!1,ne="";break;case"?":O+=I;continue;case"*":O+=p(1);continue;default:O+=v.escapeRegExpCharacters(re)}}q<P.length-1&&(P[q+1]!==w||q+2<P.length)&&(O+=i),W=!1})}return O}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},s=function(){return null};function c(R,O){if(!R)return s;let P;typeof R!="string"?P=R.pattern:P=R,P=P.trim();const W=`${P}_${!!O.trimForExclusions}`;let _=t.get(W);if(_)return d(_,R);let q;if(D.test(P)){const V=P.substr(4);_=function(K,Z){return typeof K=="string"&&K.endsWith(V)?P:null}}else(q=b.exec(f(P,O)))?_=h(q[1],P):(O.trimForExclusions?u:l).test(P)?_=M(P,O):(q=o.exec(f(P,O)))?_=T(q[1].substr(1),P,!0):(q=a.exec(f(P,O)))?_=T(q[1],P,!1):_=U(P);return t.set(W,_),d(_,R)}function d(R,O){return typeof O=="string"?R:function(P,W){return L.isEqualOrParent(P,O.base)?R(A.relative(O.base,P),W):null}}function f(R,O){return O.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function h(R,O){const P=`/${R}`,W=`\\${R}`,_=function(V,K){return typeof V!="string"?null:K?K===R?O:null:V===R||V.endsWith(P)||V.endsWith(W)?O:null},q=[R];return _.basenames=q,_.patterns=[O],_.allBasenames=q,_}function M(R,O){const P=F(R.slice(1,-1).split(",").map(K=>c(K,O)).filter(K=>K!==s),R),W=P.length;if(!W)return s;if(W===1)return P[0];const _=function(K,Z){for(let ne=0,re=P.length;ne<re;ne++)if(P[ne](K,Z))return R;return null},q=P.find(K=>!!K.allBasenames);q&&(_.allBasenames=q.allBasenames);const V=P.reduce((K,Z)=>Z.allPaths?K.concat(Z.allPaths):K,[]);return V.length&&(_.allPaths=V),_}function T(R,O,P){const W=A.sep===A.posix.sep,_=W?R:R.replace(k,A.sep),q=A.sep+_,V=A.posix.sep+R,K=P?function(Z,ne){return typeof Z=="string"&&(Z===_||Z.endsWith(q)||!W&&(Z===R||Z.endsWith(V)))?O:null}:function(Z,ne){return typeof Z=="string"&&(Z===_||!W&&Z===R)?O:null};return K.allPaths=[(P?"*/":"./")+R],K}function U(R){try{const O=new RegExp(`^${m(R)}$`);return function(P){return O.lastIndex=0,typeof P=="string"&&O.test(P)?R:null}}catch(O){return s}}function H(R,O,P){return!R||typeof O!="string"?!1:X(R)(O,void 0,P)}e.match=H;function X(R,O={}){if(!R)return r;if(typeof R=="string"||Q(R)){const P=c(R,O);if(P===s)return r;const W=function(_,q){return!!P(_,q)};return P.allBasenames&&(W.allBasenames=P.allBasenames),P.allPaths&&(W.allPaths=P.allPaths),W}return z(R,O)}e.parse=X;function ee(R){if(!R)return;let O;return P=>(O||(O=(R()||Promise.resolve([])).then(W=>W?Y(W):{})),O.then(W=>!!W[P]))}e.hasSiblingPromiseFn=ee;function B(R){if(!R)return;let O;return P=>{if(!O){const W=R();O=W?Y(W):{}}return!!O[P]}}e.hasSiblingFn=B;function Y(R){const O={};for(const P of R)O[P]=!0;return O}function Q(R){const O=R;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=Q;function N(R){return R.allBasenames||[]}e.getBasenameTerms=N;function G(R){return R.allPaths||[]}e.getPathTerms=G;function z(R,O){const P=F(Object.getOwnPropertyNames(R).map(K=>C(K,R[K],O)).filter(K=>K!==s)),W=P.length;if(!W)return s;if(!P.some(K=>!!K.requiresSiblings)){if(W===1)return P[0];const K=function(re,se){for(let le=0,oe=P.length;le<oe;le++){const ue=P[le](re,se);if(ue)return ue}return null},Z=P.find(re=>!!re.allBasenames);Z&&(K.allBasenames=Z.allBasenames);const ne=P.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return ne.length&&(K.allPaths=ne),K}const _=function(K,Z,ne){let re;for(let se=0,le=P.length;se<le;se++){const oe=P[se];oe.requiresSiblings&&ne&&(Z||(Z=A.basename(K)),re||(re=Z.substr(0,Z.length-A.extname(K).length)));const ue=oe(K,Z,re,ne);if(ue)return ue}return null},q=P.find(K=>!!K.allBasenames);q&&(_.allBasenames=q.allBasenames);const V=P.reduce((K,Z)=>Z.allPaths?K.concat(Z.allPaths):K,[]);return V.length&&(_.allPaths=V),_}function C(R,O,P){if(O===!1)return s;const W=c(R,P);if(W===s)return s;if(typeof O=="boolean")return W;if(O){const _=O.when;if(typeof _=="string"){const q=(V,K,Z,ne)=>{if(!ne||!W(V,K))return null;const re=_.replace("$(basename)",Z),se=ne(re);return E.isThenable(se)?se.then(le=>le?R:null):se?R:null};return q.requiresSiblings=!0,q}}return W}function F(R,O){const P=R.filter(K=>!!K.basenames);if(P.length<2)return R;const W=P.reduce((K,Z)=>{const ne=Z.basenames;return ne?K.concat(ne):K},[]);let _;if(O){_=[];for(let K=0,Z=W.length;K<Z;K++)_.push(O)}else _=P.reduce((K,Z)=>{const ne=Z.patterns;return ne?K.concat(ne):K},[]);const q=function(K,Z){if(typeof K!="string")return null;if(!Z){let re;for(re=K.length;re>0;re--){const se=K.charCodeAt(re-1);if(se===47||se===92)break}Z=K.substr(re)}const ne=W.indexOf(Z);return ne!==-1?_[ne]:null};q.basenames=W,q.patterns=_,q.allBasenames=W;const V=R.filter(K=>!K.basenames);return V.push(q),V}}),define(J[39],x([0,1,7,8,23,10,3,15,30]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(c,d,f){if(typeof c=="string"&&(c=v.URI.file(c)),f){const M=f.getWorkspaceFolder(c);if(M){const T=f.getWorkspace().folders.length>1;let U;if(n.isEqual(M.uri,c)?U="":U=n.relativePath(M.uri,c),T){const H=M.name?M.name:n.basename(M.uri);U=U?H+" \u2022 "+U:H}return U}}if(c.scheme!==S.Schemas.file&&c.scheme!==S.Schemas.untitled)return c.with({query:null,fragment:null}).toString(!0);if(w.hasDriveLetter(c.fsPath))return L.normalize(I(c.fsPath));let h=L.normalize(c.fsPath);return!E.isWindows&&(d==null?void 0:d.userHome)&&(h=p(h,d.userHome.fsPath)),h}e.getPathLabel=y;function i(c){if(!c)return;typeof c=="string"&&(c=v.URI.file(c));const d=n.basename(c)||(c.scheme===S.Schemas.file?c.fsPath:c.path);return E.isWindows&&w.isRootOrDriveLetter(d)?I(d):d}e.getBaseLabel=i;function I(c){return w.hasDriveLetter(c)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=I;let k=Object.create(null);function p(c,d){if(E.isWindows||!c||!d)return c;let f=k.original===d?k.normalized:void 0;return f||(f=`${A.rtrim(d,L.posix.sep)}${L.posix.sep}`,k={original:d,normalized:f}),(E.isLinux?c.startsWith(f):A.startsWithIgnoreCase(c,f))&&(c=`~/${c.substr(f.length)}`),c}e.tildify=p;function g(c,d){return c.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=g;const m="\u2026",D="\\\\",b="~";function l(c,d=L.sep){const f=new Array(c.length);let h=!1;for(let M=0;M<c.length;M++){let T=c[M];if(T===""){f[M]=`.${d}`;continue}if(!T){f[M]=T;continue}h=!0;let U="";T.indexOf(D)===0?(U=T.substr(0,T.indexOf(D)+D.length),T=T.substr(T.indexOf(D)+D.length)):T.indexOf(d)===0?(U=T.substr(0,T.indexOf(d)+d.length),T=T.substr(T.indexOf(d)+d.length)):T.indexOf(b)===0&&(U=T.substr(0,T.indexOf(b)+b.length),T=T.substr(T.indexOf(b)+b.length));const H=T.split(d);for(let X=1;h&&X<=H.length;X++)for(let ee=H.length-X;h&&ee>=0;ee--){h=!1;let B=H.slice(ee,ee+X).join(d);for(let Y=0;!h&&Y<c.length;Y++)if(Y!==M&&c[Y]&&c[Y].indexOf(B)>-1){const Q=ee+X===H.length,N=ee>0&&c[Y].indexOf(d)>-1?d+B:B,G=c[Y].endsWith(N);h=!Q||G}if(!h){let Y="";(H[0].endsWith(":")||U!=="")&&(ee===1&&(ee=0,X++,B=H[0]+d+B),ee>0&&(Y=H[0]+d),Y=U+Y),ee>0&&(Y=Y+m+d),Y=Y+B,ee+X<H.length&&(Y=Y+d+m),f[M]=Y}}h&&(f[M]=T)}return f}e.shorten=l;var u;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function o(c,d=Object.create(null)){const f=[];let h=!1,M="";for(const T of c)if(T==="$"||h&&T==="{")M&&f.push({value:M,type:u.TEXT}),M="",h=!0;else if(T==="}"&&h){const U=d[M];if(typeof U=="string")U.length&&f.push({value:U,type:u.VARIABLE});else if(U){const H=f[f.length-1];(!H||H.type!==u.SEPARATOR)&&f.push({value:U.label,type:u.SEPARATOR})}M="",h=!1}else M+=T;return M&&!h&&f.push({value:M,type:u.TEXT}),f.filter((T,U)=>{if(T.type===u.SEPARATOR){const H=f[U-1],X=f[U+1];return[H,X].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=o;function a(c,d){return E.isMacintosh||d?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,E.isMacintosh?"&":"&&"):c.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(c,d){return E.isMacintosh||d?c.replace(/\(&&\w\)|&&/g,""):E.isWindows?c.replace(/&&|&/g,f=>f==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(c){const d=c.indexOf("/")!==-1?L.posix:L.win32,f=d.basename(c),h=d.dirname(c);return f.length?{name:f,parentPath:h}:{name:h,parentPath:""}}e.splitName=s}),define(J[27],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(w){return v.test(w)}e.isUUID=L;const A=new Uint8Array(16),S=[];for(let w=0;w<256;w++)S.push(w.toString(16).padStart(2,"0"));let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(w){for(let y=0;y<w.length;y++)w[y]=Math.floor(Math.random()*256);return w};function n(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let w=0,y="";return y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+="-",y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y+=S[A[w++]],y}e.generateUuid=n}),define(J[112],x([0,1,29,58,42]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(E,n){if(await new Promise((i,I)=>{const k=v.createReadStream(E),p=L.createHash("sha1");k.pipe(p);const g=A.once((m,D)=>{k.removeAllListeners(),p.removeAllListeners(),m?I(m):i(D)});k.once("error",g),k.once("end",g),p.once("error",g),p.once("data",m=>g(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(J[81],x([0,1,237]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const E=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return E;let w=0,y,i=w;for(;i<n.length;)if(y=n.charCodeAt(i),y===13||y===10){if(E.push(n.substring(w,i)),i++,i<n.length){const I=y;y=n.charCodeAt(i),(I===13&&y===10||I===10&&y===13)&&i++}w=i}else i++;return this.remaining=w<n.length?n.substr(w):null,E}end(){return this.remaining}}e.LineDecoder=L}),define(J[113],x([0,1,26]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(n){const w=n.replace(/\-/g,":").toLowerCase();return!L.has(w)}function S(){return new Promise(async(n,w)=>{const y=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await E())}catch(i){w(i)}finally{clearTimeout(y)}})}e.getMac=S;function E(){return new Promise((n,w)=>{try{const y=v.networkInterfaces();for(let i in y){const I=y[i];if(I){for(const{mac:k}of I)if(A(k))return n(k)}}w("Unable to retrieve mac address (unexpected format)")}catch(y){w(y)}})}}),define(J[66],x([0,1,19,27,26,36,113]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const k=A.networkInterfaces();for(let p in k){const g=k[p];if(g)for(const{mac:m,internal:D}of g)D||(I+=1,this._isVirtualMachineMacAdress(m.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let n;async function w(){return n||(n=(async()=>await y()||L.generateUuid())()),n}e.getMachineId=w;async function y(){try{const i=await new Promise((k,p)=>{$(["crypto"],k,p)}),I=await E.getMac();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){v.onUnexpectedError(i);return}}}),define(J[16],x([0,1,29,26,114,8,9,3,30,27,65,15,7]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var p;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function g(z,C=p.UNLINK){if(w.isRootOrDriveLetter(z))throw new Error("rimraf - will refuse to recursively delete root");return C===p.UNLINK?D(z):m(z)}e.rimraf=g;async function m(z){try{const C=S.join(L.tmpdir(),y.generateUuid());try{await G.rename(z,C)}catch(F){return D(z)}D(C).catch(F=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function D(z){return G.rmdir(z,{recursive:!0,maxRetries:3})}function b(z){if(w.isRootOrDriveLetter(z))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(z,{recursive:!0})}e.rimrafSync=b;async function l(z,C){return a(await(C?u(z):G.readdir(z)))}e.readdir=l;async function u(z){try{return await G.readdir(z,{withFileTypes:!0})}catch(R){console.warn("[node.js fs] readdir with filetypes failed with error: ",R)}const C=[],F=await l(z);for(const R of F){let O=!1,P=!1,W=!1;try{const _=await G.lstat(S.join(z,R));O=_.isFile(),P=_.isDirectory(),W=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}C.push({name:R,isFile:()=>O,isDirectory:()=>P,isSymbolicLink:()=>W})}return C}function o(z){return a(v.readdirSync(z))}e.readdirSync=o;function a(z){return z.map(C=>typeof C=="string"?n.isMacintosh?i.normalizeNFC(C):C:(C.name=n.isMacintosh?i.normalizeNFC(C.name):C.name,C))}async function t(z){const C=await l(z),F=[];for(const R of C)await s.existsDirectory(S.join(z,R))&&F.push(R);return F}e.readDirsInDir=t;function r(z,C=1e3){return new Promise(F=>{let R=!1;const O=setInterval(()=>{R||(R=!0,v.access(z,P=>{R=!1,P&&(clearInterval(O),F(void 0))}))},C)})}e.whenDeleted=r;var s;(function(z){async function C(O){let P;try{if(P=await G.lstat(O),!P.isSymbolicLink())return{stat:P}}catch(W){}try{return{stat:await G.stat(O),symbolicLink:(P==null?void 0:P.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&P)return{stat:P,symbolicLink:{dangling:!0}};if(n.isWindows&&W.code==="EACCES")try{return{stat:await G.stat(await G.readlink(O)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&P)return{stat:P,symbolicLink:{dangling:!0}};throw _}throw W}}z.stat=C;async function F(O){try{const{stat:P,symbolicLink:W}=await z.stat(O);return P.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(P){}return!1}z.existsFile=F;async function R(O){try{const{stat:P,symbolicLink:W}=await z.stat(O);return P.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(P){}return!1}z.existsDirectory=R})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const c=new E.ResourceQueue;function d(z,C,F){return c.queueFor(k.URI.file(z),I.extUriBiasedIgnorePathCase).queue(()=>{const R=T(F);return new Promise((O,P)=>h(z,C,R,W=>W?P(W):O()))})}e.writeFile=d;let f=!0;function h(z,C,F,R){if(!f)return v.writeFile(z,C,{mode:F.mode,flag:F.flag},R);v.open(z,F.flag,F.mode,(O,P)=>{if(O)return R(O);v.writeFile(P,C,W=>{if(W)return v.close(P,()=>R(W));v.fdatasync(P,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),f=!1),v.close(P,q=>R(q))))})})}function M(z,C,F){const R=T(F);if(!f)return v.writeFileSync(z,C,{mode:R.mode,flag:R.flag});const O=v.openSync(z,R.flag,R.mode);try{v.writeFileSync(O,C);try{v.fdatasyncSync(O)}catch(P){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",P),f=!1}}finally{v.closeSync(O)}}e.writeFileSync=M;function T(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function U(z,C){if(z===C)return;async function F(R){try{const O=await G.lstat(R);if(O.isDirectory()||O.isSymbolicLink())return;await G.utimes(R,O.atime,new Date)}catch(O){}}try{await G.rename(z,C),await F(C)}catch(R){if(z.toLowerCase()!==C.toLowerCase()&&R.code==="EXDEV"||z.endsWith("."))await H(z,C,{preserveSymlinks:!1}),await g(z,p.MOVE),await F(C);else throw R}}e.move=U;async function H(z,C,F){return ee(z,C,{root:{source:z,target:C},options:F,handledSourcePaths:new Set})}e.copy=H;const X=511;async function ee(z,C,F){if(F.handledSourcePaths.has(z))return;F.handledSourcePaths.add(z);const{stat:R,symbolicLink:O}=await s.stat(z);if(O){if(F.options.preserveSymlinks)try{return await Q(z,C,F)}catch(P){console.warn("[node.js fs] copy of symlink failed: ",P)}if(O.dangling)return}return R.isDirectory()?B(z,C,R.mode&X,F):Y(z,C,R.mode&X)}async function B(z,C,F,R){await G.mkdir(C,{recursive:!0,mode:F});const O=await l(z);for(const P of O)await ee(S.join(z,P),S.join(C,P),R)}async function Y(z,C,F){await G.copyFile(z,C),await G.chmod(C,F)}async function Q(z,C,F){let R=await G.readlink(z);w.isEqualOrParent(R,F.root.source,!n.isLinux)&&(R=S.join(F.root.target,R.substr(F.root.source.length+1))),await G.symlink(R,C)}async function N(z){try{return await G.access(z),!0}catch(C){return!1}}e.exists=N;var G;(function(z){z.access=A.promisify(v.access),z.stat=A.promisify(v.stat),z.lstat=A.promisify(v.lstat),z.utimes=A.promisify(v.utimes),z.read=A.promisify(v.read),z.readFile=A.promisify(v.readFile),z.write=A.promisify(v.write),z.writeFile=A.promisify(v.writeFile),z.appendFile=A.promisify(v.appendFile),z.fdatasync=A.promisify(v.fdatasync),z.truncate=A.promisify(v.truncate),z.rename=A.promisify(v.rename),z.copyFile=A.promisify(v.copyFile),z.open=A.promisify(v.open),z.close=A.promisify(v.close),z.symlink=A.promisify(v.symlink),z.readlink=A.promisify(v.readlink),z.chmod=A.promisify(v.chmod),z.readdir=A.promisify(v.readdir),z.mkdir=A.promisify(v.mkdir),z.unlink=A.promisify(v.unlink),z.rmdir=A.promisify(v.rmdir),z.realpath=A.promisify(v.realpath)})(G=e.Promises||(e.Promises={}))}),define(J[82],x([0,1,29,23,8,16]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function E(i){const I=A.dirname(i);if(i===I)return i;const k=(A.basename(i)||i).toLowerCase();try{const g=S.readdirSync(I).filter(m=>m.toLowerCase()===k);if(g.length===1){const m=E(I);if(m)return A.join(m,g[0])}else if(g.length>1){const m=g.indexOf(k);if(m>=0){const D=E(I);if(D)return A.join(D,g[m])}}}catch(p){}return null}e.realcaseSync=E;async function n(i){try{return await S.Promises.realpath(i)}catch(I){const k=y(i);return await S.Promises.access(k,v.constants.R_OK),k}}e.realpath=n;function w(i){try{return v.realpathSync(i)}catch(I){const k=y(i);return v.accessSync(k,v.constants.R_OK),k}}e.realpathSync=w;function y(i){return L.rtrim(A.normalize(i),A.sep)}}),define(J[115],x([0,1,59]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,w,y){let i=!1;return new Promise(I=>{const k=setTimeout(()=>{if(!i)return i=!0,I(0)},y);A(n,w,p=>{if(!i)return i=!0,clearTimeout(k),I(p)})})}e.findFreePort=L;function A(n,w,y){if(w===0)return y(0);const i=new v.Socket;i.once("connect",()=>(E(i),A(n+1,w-1,y))),i.once("data",()=>{}),i.once("error",I=>(E(i),I.code!=="ECONNREFUSED"?A(n+1,w-1,y):y(n))),i.connect(n,"127.0.0.1")}function S(n,w,y){let i=!1,I,k=1;const p=v.createServer({pauseOnConnect:!0});function g(m,D){i||(i=!0,p.removeAllListeners(),p.close(),I&&clearTimeout(I),D(m))}return new Promise(m=>{I=setTimeout(()=>{g(0,m)},y),p.on("listening",()=>{g(n,m)}),p.on("error",D=>{D&&(D.code==="EADDRINUSE"||D.code==="EACCES")&&k<w?(n++,k++,p.listen(n,"127.0.0.1")):g(0,m)}),p.on("close",()=>{g(0,m)}),p.listen(n,"127.0.0.1")})}e.findFreePortFaster=S;function E(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(w){console.error(w)}}});var Oe=this&&this.__await||function($){return this instanceof Oe?(this.v=$,this):new Oe($)},wt=this&&this.__asyncGenerator||function($,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=v.apply($,e||[]),A,S=[];return A={},E("next"),E("throw"),E("return"),A[Symbol.asyncIterator]=function(){return this},A;function E(k){L[k]&&(A[k]=function(p){return new Promise(function(g,m){S.push([k,p,g,m])>1||n(k,p)})})}function n(k,p){try{w(L[k](p))}catch(g){I(S[0][3],g)}}function w(k){k.value instanceof Oe?Promise.resolve(k.value.v).then(y,i):I(S[0][2],k)}function y(k){n("next",k)}function i(k){n("throw",k)}function I(k,p){k(p),S.shift(),S.length&&n(S[0][0],S[0][1])}},pt=this&&this.__asyncValues||function($){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=$[Symbol.asyncIterator],v;return e?e.call($):($=typeof __values=="function"?__values($):$[Symbol.iterator](),v={},L("next"),L("throw"),L("return"),v[Symbol.asyncIterator]=function(){return this},v);function L(S){v[S]=$[S]&&function(E){return new Promise(function(n,w){E=$[S](E),A(n,w,E.done,E.value)})}}function A(S,E,n,w){Promise.resolve(w).then(function(y){S({value:y,done:n})},E)}};define(J[116],x([0,1,16,26,8]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,E=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var w;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(w||(w={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function k({useAlternateBitness:o=!1}={}){return o?y===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:o});if(!t)return null;const r=A.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let s=-1,c=null;for(const h of await v.readdir(r)){let M=-1;if(a){const U=h.indexOf("-");if(U<0)continue;const H=h.substring(0,U);if(!S.test(H)||h.substring(U+1)!=="preview")continue;M=parseInt(H,10)}else{if(!S.test(h))continue;M=parseInt(h,10)}if(M<=s)continue;const T=A.join(r,h,"pwsh.exe");!await v.SymlinkSupport.existsFile(T)||(c=T,s=M)}if(!c)return null;const d=t.includes("x86")?" (x86)":"",f=a?" Preview":"";return new I(c,`PowerShell${f}${d}`,!0)}async function g({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:E,pwshMsixName:"PowerShell (Store)"};for(const s of await v.readdir(a))if(t.test(s)){const c=A.join(a,s,"pwsh.exe");return new I(c,r)}return null}function m(){const o=A.join(L.homedir(),".dotnet","tools","pwsh.exe");return new I(o,".NET Core PowerShell Global Tool")}function D(){const o=A.join(process.env.windir,y===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(o,"Windows PowerShell",!0)}function b(){return wt(this,arguments,function*(){let a=yield Oe(p());a&&(yield yield Oe(a)),a=yield Oe(p({useAlternateBitness:!0})),a&&(yield yield Oe(a)),a=yield Oe(g()),a&&(yield yield Oe(a)),a=m(),a&&(yield yield Oe(a)),a=yield Oe(p({findPreview:!0})),a&&(yield yield Oe(a)),a=yield Oe(g({findPreview:!0})),a&&(yield yield Oe(a)),a=yield Oe(p({useAlternateBitness:!0,findPreview:!0})),a&&(yield yield Oe(a)),a=D(),a&&(yield yield Oe(a))})}function l(){return wt(this,arguments,function*(){var a,t;try{for(var r=pt(b()),s;s=yield Oe(r.next()),!s.done;){const c=s.value;(yield Oe(c.exists()))&&(yield yield Oe(c))}}catch(c){a={error:c}}finally{try{s&&!s.done&&(t=r.return)&&(yield Oe(t.call(r)))}finally{if(a)throw a.error}}})}e.enumeratePowerShellInstallations=l;async function u(){var o,a;try{for(var t=pt(l()),r;r=await t.next(),!r.done;)return r.value}catch(s){o={error:s}}finally{try{r&&!r.done&&(a=t.return)&&await a.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(J[83],x([0,1,40,10]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function A(E){return new Promise((n,w)=>{let y;const i=new Map;function I(p,g,m,D,b){const l=i.get(g);if(p===E||l){const u={name:k(m),cmd:m,pid:p,ppid:g,load:D,mem:b};i.set(p,u),p===E&&(y=u),l&&(l.children||(l.children=[]),l.children.push(u),l.children.length>1&&(l.children=l.children.sort((o,a)=>o.pid-a.pid)))}}function k(p){const g=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(m.exec(p))return"watcherService ";if(D.exec(p))return"electron-crash-reporter";if(b.exec(p))return"winpty-process";if(l.exec(p))return"console-window-host (Windows internal process)";let o=u.exec(p);if(o&&o.length===2)return o[1]==="renderer"?g.exec(p)?"shared-process":"window":o[1];const a=/[a-zA-Z-]+\.js/g;let t="";do o=a.exec(p),o&&(t+=o+" ");while(o);return t&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${t}`:p}if(process.platform==="win32"){const p=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,m)=>{$(["windows-process-tree"],g,m)}).then(g=>{g.getProcessList(E,m=>{g.getProcessCpuUsage(m,D=>{const b=new Map;D.forEach(l=>{const u=p(l.commandLine||"");b.set(l.pid,{name:k(u),cmd:u,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),y=b.get(E),y?(b.forEach(l=>{const u=b.get(l.ppid);u&&(u.children||(u.children=[]),u.children.push(l))}),b.forEach(l=>{l.children&&(l.children=l.children.sort((u,o)=>u.pid-o.pid))}),n(y)):w(new Error(`Root process ${E} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let p=function(){let g=[y];const m=[];for(;g.length;){const b=g.shift();b&&(m.push(b.pid),b.children&&(g=g.concat(b.children)))}let D=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",$).fsPath);D+=" "+m.join(" "),v.exec(D,{},(b,l,u)=>{if(b||u)w(b||new Error(u.toString()));else{const o=l.toString().split(`
`);for(let a=0;a<m.length;a++){const t=i.get(m[a]);t.load=parseFloat(o[a])}if(!y){w(new Error(`Root process ${E} not found`));return}n(y)}})};v.exec("which ps",{},(g,m,D)=>{if(g||D)if(process.platform!=="linux")w(g||new Error(D.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",$).fsPath);v.exec(b,{},(l,u,o)=>{l||o?w(l||new Error(o.toString())):(S(u,I),p())})}else{const b=m.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${b} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,o,a)=>{u||a&&!a.includes("screen size is bogus")?w(u||new Error(a.toString())):(S(o,I),process.platform==="linux"?p():y?n(y):w(new Error(`Root process ${E} not found`)))})}})}})}e.listProcesses=A;function S(E,n){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=E.toString().split(`
`);for(const i of y){const I=w.exec(i.trim());I&&I.length===6&&n(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(J[117],x([0,1,8,29,3,65,2,16]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(I,k,p){return i({path:I,isDirectory:!1},k,p)}e.watchFile=w;function y(I,k,p){return i({path:I,isDirectory:!0},k,p)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function i(I,k,p){const g=v.basename(I.path),m=new Map;let D=!1,b=[E.toDisposable(()=>{m.forEach(l=>E.dispose(l)),m.clear()})];try{const l=L.watch(I.path);b.push(E.toDisposable(()=>{l.removeAllListeners(),l.close()}));const u=new Set;I.isDirectory&&n.readdir(I.path).then(o=>o.forEach(a=>u.add(a))),l.on("error",(o,a)=>{D||p(`Failed to watch ${I.path} for changes using fs.watch() (${o}, ${a})`)}),l.on("change",(o,a)=>{if(D)return;let t="";if(a&&(t=a.toString(),A.isMacintosh&&(t=S.normalizeNFC(t))),!t||o!=="change"&&o!=="rename")return;const r=I.isDirectory?v.join(I.path,t):I.path;if(I.isDirectory)if(o==="rename"){const s=m.get(r);s&&E.dispose(s);const c=setTimeout(async()=>{m.delete(r);const d=await n.exists(r);if(D)return;let f;d?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),k(f,r)},e.CHANGE_BUFFER_DELAY);m.set(r,E.toDisposable(()=>clearTimeout(c)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),k(s,r)}else if(o==="rename"||t!==g){const s=setTimeout(async()=>{const c=await n.exists(r);D||(c?(k("changed",r),b=[i(I,k,p)]):k("deleted",r))},e.CHANGE_BUFFER_DELAY);E.dispose(b),b=[E.toDisposable(()=>clearTimeout(s))]}else k("changed",r)})}catch(l){n.exists(I.path).then(u=>{u&&!D&&p(`Failed to watch ${I.path} for changes using fs.watch() (${l.toString()})`)})}return E.toDisposable(()=>{D=!0,b=E.dispose(b)})}}),define(J[118],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(J[119],x([0,1,14,118,13]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){v.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(n,w,y,i,I)=>{const k=E(n,i,y);k.popup({window:A.withNullAsUndefined(v.BrowserWindow.fromWebContents(n.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{k&&n.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=S;function E(n,w,y){const i=new v.Menu;return y.forEach(I=>{let k;I.type==="separator"?k=new v.MenuItem({type:I.type}):Array.isArray(I.submenu)?k=new v.MenuItem({submenu:E(n,w,I.submenu),label:I.label}):k=new v.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(p,g,m)=>n.sender.send(w,I.id,m)}),i.append(k)}),i}});var he=this&&this.__decorate||function($,e,v,L){var A=arguments.length,S=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,E;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate($,e,v,L);else for(var n=$.length-1;n>=0;n--)(E=$[n])&&(S=(A<3?E(S):A>3?E(e,v,S):E(e,v))||S);return A>3&&S&&Object.defineProperty(e,v,S),S};define(J[33],x([0,1,5,2,9,25,19,20,35,13,110,23,46]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function g(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function D(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class l{constructor(R){this.buffer=R,this.pos=0}read(R){const O=this.buffer.slice(this.pos,this.pos+R);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(R){this.buffers.push(R)}}var o;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(o||(o={}));function a(F){const R=n.VSBuffer.alloc(4);return R.writeUInt32BE(F,0),R}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const R=n.VSBuffer.alloc(1);return R.writeUInt8(F,0),R}const s={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object)},c=typeof Buffer!="undefined";function d(F,R){if(typeof R=="undefined")F.write(s.Undefined);else if(typeof R=="string"){const O=n.VSBuffer.fromString(R);F.write(s.String),F.write(a(O.byteLength)),F.write(O)}else if(c&&Buffer.isBuffer(R)){const O=n.VSBuffer.wrap(R);F.write(s.Buffer),F.write(a(O.byteLength)),F.write(O)}else if(R instanceof n.VSBuffer)F.write(s.VSBuffer),F.write(a(R.byteLength)),F.write(R);else if(Array.isArray(R)){F.write(s.Array),F.write(a(R.length));for(const O of R)d(F,O)}else{const O=n.VSBuffer.fromString(JSON.stringify(R));F.write(s.Object),F.write(a(O.byteLength)),F.write(O)}}function f(F){switch(F.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return F.read(t(F)).toString();case o.Buffer:return F.read(t(F)).buffer;case o.VSBuffer:return F.read(t(F));case o.Array:{const O=t(F),P=[];for(let W=0;W<O;W++)P.push(f(F));return P}case o.Object:return JSON.parse(F.read(t(F)).toString())}}class h{constructor(R,O,P=null,W=1e3){this.protocol=R,this.ctx=O,this.logger=P,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(R,O){this.channels.set(R,O),setTimeout(()=>this.flushPendingRequests(R),0)}sendResponse(R){switch(R.type){case 200:{const O=this.send([R.type]);this.logger&&this.logger.logOutgoing(O,0,1,D(R.type));return}case 201:case 202:case 204:case 203:{const O=this.send([R.type,R.id],R.data);this.logger&&this.logger.logOutgoing(O,R.id,1,D(R.type),R.data);return}}}send(R,O=void 0){const P=new u;return d(P,R),d(P,O),this.sendBuffer(P.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onRawMessage(R){const O=new l(R),P=f(O),W=f(O),_=P[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(R.byteLength,P[1],1,`${g(_)}: ${P[2]}.${P[3]}`,W),this.onPromise({type:_,id:P[1],channelName:P[2],name:P[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(R.byteLength,P[1],1,`${g(_)}: ${P[2]}.${P[3]}`,W),this.onEventListen({type:_,id:P[1],channelName:P[2],name:P[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(R.byteLength,P[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:P[1]});case 103:return this.logger&&this.logger.logIncoming(R.byteLength,P[1],1,`${g(_)}`),this.disposeActiveRequest({type:_,id:P[1]})}}onPromise(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const P=new S.CancellationTokenSource;let W;try{W=O.call(this.ctx,R.name,R.arg,P.token)}catch(V){W=Promise.reject(V)}const _=R.id;W.then(V=>{this.sendResponse({id:_,data:V,type:201}),this.activeRequests.delete(R.id)},V=>{V instanceof Error?this.sendResponse({id:_,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:_,data:V,type:203}),this.activeRequests.delete(R.id)});const q=L.toDisposable(()=>P.cancel());this.activeRequests.set(R.id,q)}onEventListen(R){const O=this.channels.get(R.channelName);if(!O){this.collectPendingRequest(R);return}const P=R.id,_=O.listen(this.ctx,R.name,R.arg)(q=>this.sendResponse({id:P,data:q,type:204}));this.activeRequests.set(R.id,_)}disposeActiveRequest(R){const O=this.activeRequests.get(R.id);O&&(O.dispose(),this.activeRequests.delete(R.id))}collectPendingRequest(R){let O=this.pendingRequests.get(R.channelName);O||(O=[],this.pendingRequests.set(R.channelName,O));const P=setTimeout(()=>{console.error(`Unknown channel: ${R.channelName}`),R.type===100&&this.sendResponse({id:R.id,data:{name:"Unknown channel",message:`Channel name '${R.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:R,timeoutTimer:P})}flushPendingRequests(R){const O=this.pendingRequests.get(R);if(O){for(const P of O)switch(clearTimeout(P.timeoutTimer),P.request.type){case 100:this.onPromise(P.request);break;case 102:this.onEventListen(P.request);break}this.pendingRequests.delete(R)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var M;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(R,O=null){this.protocol=R,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(P=>this.onBuffer(P)),this.logger=O}getChannel(R){const O=this;return{call(P,W,_){return O.isDisposed?Promise.reject(E.canceled()):O.requestPromise(R,P,W,_)},listen(P,W){return O.isDisposed?Promise.reject(E.canceled()):O.requestEvent(R,P,W)}}}requestPromise(R,O,P,W=S.CancellationToken.None){const _=this.lastRequestId++,V={id:_,type:100,channelName:R,name:O,arg:P};if(W.isCancellationRequested)return Promise.reject(E.canceled());let K;return new Promise((ne,re)=>{if(W.isCancellationRequested)return re(E.canceled());const se=()=>{const me=Se=>{switch(Se.type){case 201:this.handlers.delete(_),ne(Se.data);break;case 202:this.handlers.delete(_);const Le=new Error(Se.data.message);Le.stack=Se.data.stack,Le.name=Se.data.name,re(Le);break;case 203:this.handlers.delete(_),re(Se.data);break}};this.handlers.set(_,me),this.sendRequest(V)};let le=null;this.state===b.Idle?se():(le=A.createCancelablePromise(me=>this.whenInitialized()),le.then(()=>{le=null,se()}));const oe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),re(E.canceled())},ue=W.onCancellationRequested(oe);K=L.combinedDisposable(L.toDisposable(oe),ue),this.activeRequests.add(K)}).finally(()=>{this.activeRequests.delete(K)})}requestEvent(R,O,P){const W=this.lastRequestId++,q={id:W,type:102,channelName:R,name:O,arg:P};let V=null;const K=new v.Emitter({onFirstListenerAdd:()=>{V=A.createCancelablePromise(ne=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(K),this.sendRequest(q)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(K),this.sendRequest({id:W,type:103}))}}),Z=ne=>K.fire(ne.data);return this.handlers.set(W,Z),K.event}sendRequest(R){switch(R.type){case 100:case 102:{const O=this.send([R.type,R.id,R.channelName,R.name],R.arg);this.logger&&this.logger.logOutgoing(O,R.id,0,`${g(R.type)}: ${R.channelName}.${R.name}`,R.arg);return}case 101:case 103:{const O=this.send([R.type,R.id]);this.logger&&this.logger.logOutgoing(O,R.id,0,g(R.type));return}}}send(R,O=void 0){const P=new u;return d(P,R),d(P,O),this.sendBuffer(P.buffer)}sendBuffer(R){try{return this.protocol.send(R),R.byteLength}catch(O){return 0}}onBuffer(R){const O=new l(R),P=f(O),W=f(O),_=P[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(R.byteLength,0,0,D(_)),this.onResponse({type:P[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(R.byteLength,P[1],0,D(_),W),this.onResponse({type:P[0],id:P[1],data:W})}}onResponse(R){if(R.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(R.id);O&&O(R)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(R=>R.dispose()),this.activeRequests.clear()}}he([k.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class U{constructor(R){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,R(({protocol:O,onDidClientDisconnect:P})=>{v.Event.once(O.onMessage)(_=>{const q=new l(_),V=f(q),K=new h(O,V),Z=new T(O);this.channels.forEach((re,se)=>K.registerChannel(se,re));const ne={channelServer:K,channelClient:Z,ctx:V};this._connections.add(ne),this._onDidAddConnection.fire(ne),P(()=>{K.dispose(),Z.dispose(),this._connections.delete(ne),this._onDidRemoveConnection.fire(ne)})})})}get connections(){const R=[];return this._connections.forEach(O=>R.push(O)),R}getChannel(R,O){const P=this;return{call(W,_,q){let V;if(y.isFunction(O)){let Z=w.getRandomElement(P.connections.filter(O));V=Z?Promise.resolve(Z):v.Event.toPromise(v.Event.filter(P.onDidAddConnection,O))}else V=O.routeCall(P,W,_);const K=V.then(Z=>Z.channelClient.getChannel(R));return X(K).call(W,_,q)},listen(W,_){if(y.isFunction(O))return P.getMulticastEvent(R,O,W,_);const q=O.routeEvent(P,W,_).then(V=>V.channelClient.getChannel(R));return X(q).listen(W,_)}}}getMulticastEvent(R,O,P,W){const _=this;let q=new L.DisposableStore;const V=new v.Emitter({onFirstListenerAdd:()=>{q=new L.DisposableStore;const K=new v.EventMultiplexer,Z=new Map,ne=se=>{const oe=se.channelClient.getChannel(R).listen(P,W),ue=K.add(oe);Z.set(se,ue)},re=se=>{const le=Z.get(se);!le||(le.dispose(),Z.delete(se))};_.connections.filter(O).forEach(ne),v.Event.filter(_.onDidAddConnection,O)(ne,void 0,q),_.onDidRemoveConnection(re,void 0,q),K.event(V.fire,V,q),q.add(K)},onLastListenerRemove:()=>{q.dispose()}});return V.event}registerChannel(R,O){this.channels.set(R,O),this._connections.forEach(P=>{P.channelServer.registerChannel(R,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=U;class H{constructor(R,O,P=null){const W=new u;d(W,O),R.send(W.buffer),this.channelClient=new T(R,P),this.channelServer=new h(R,O,P)}getChannel(R){return this.channelClient.getChannel(R)}registerChannel(R,O){this.channelServer.registerChannel(R,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=H;function X(F){return{call(R,O,P){return F.then(W=>W.call(R,O,P))},listen(R,O){const P=new v.Relay;return F.then(W=>P.input=W.listen(R,O)),P.event}}}e.getDelayedChannel=X;function ee(F){let R=!1;return{call(O,P,W){return R?F.call(O,P,W):A.timeout(0).then(()=>R=!0).then(()=>F.call(O,P,W))},listen(O,P){if(R)return F.listen(O,P);const W=new v.Relay;return A.timeout(0).then(()=>R=!0).then(()=>W.input=F.listen(O,P)),W.event}}}e.getNextTickChannel=ee;class B{constructor(R){this.fn=R}routeCall(R){return this.route(R)}routeEvent(R){return this.route(R)}async route(R){for(const O of R.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await v.Event.toPromise(R.onDidAddConnection),await this.route(R)}}e.StaticRouter=B;var Y;(function(F){function R(W,_){const q=W,V=_&&_.disableMarshalling,K=new Map;for(const Z in q)P(Z)&&K.set(Z,v.Event.buffer(q[Z],!0));return new class{listen(Z,ne){const re=K.get(ne);if(re)return re;throw new Error(`Event not found: ${ne}`)}call(Z,ne,re){const se=q[ne];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let le=0;le<re.length;le++)re[le]=i.revive(re[le]);return se.apply(q,re)}throw new Error(`Method not found: ${ne}`)}}}F.fromService=R;function O(W,_){const q=_&&_.disableMarshalling;return new Proxy({},{get(V,K){var Z;if(typeof K=="string")return((Z=_==null?void 0:_.properties)===null||Z===void 0?void 0:Z.has(K))?_.properties.get(K):P(K)?W.listen(K):async function(...ne){let re;_&&!y.isUndefinedOrNull(_.context)?re=[_.context,...ne]:re=ne;const se=await W.call(K,re);return q?se:i.revive(se)};throw new Error(`Property not found: ${String(K)}`)}})}F.toService=O;function P(W){return W[0]==="o"&&W[1]==="n"&&I.isUpperAsciiLetter(W.charCodeAt(2))}})(Y=e.ProxyChannel||(e.ProxyChannel={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let R=F.toString();if(R!=="[object Object]")return R}return F}function G(F){return Array.isArray(F)?F.map(N):N(F)}function z(F,R,O,P,W,_,q){q=G(q);const V=Q[W],K=V[P%V.length];let Z=[`%c[${F}]%c[${String(R).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(P).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(_)?(Z=Z.concat(q),Z.push(")")):Z.push(q),console.log.apply(console,Z)}e.logWithColors=z;class C{constructor(R,O){this._outgoingPrefix=R,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(R,O,P,W,_){this._totalOutgoing+=R,z(this._outgoingPrefix,this._totalOutgoing,R,O,P,W,_)}logIncoming(R,O,P,W,_){this._totalIncoming+=R,z(this._incomingPrefix,this._totalIncoming,R,O,P,W,_)}}e.IPCLogger=C}),define(J[120],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(A,S){this.sender=A,this.onMessage=S}send(A){try{this.sender.send("vscode:message",A.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(J[121],x([0,1,5,33,20]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(w){this.port=w,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",y=>A.VSBuffer.wrap(y.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class E extends L.IPCClient{constructor(w,y){const i=new S(w);super(i,y);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=E}),define(J[84],x([0,1,5,33,2,20,3,32]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function y(){return w||(w=S.VSBuffer.alloc(0)),w}class i{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return y();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const M=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),M}if(this._chunks[0].byteLength>s){const M=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),M}let d=S.VSBuffer.alloc(s),f=0,h=0;for(;s>0;){const M=this._chunks[h];if(M.byteLength>s){const T=M.slice(0,s);d.set(T,f),f+=s,c&&(this._chunks[h]=M.slice(s),this._totalLength-=s),s-=s}else d.set(M,f),f+=M.byteLength,c?(this._chunks.shift(),this._totalLength-=M.byteLength):h++,s-=M.byteLength}return d}}e.ChunkStream=i;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var k;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(k=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(s,c,d,f){this.type=s,this.id=c,this.ack=d,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new i,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const d=this._state.messageType,f=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new p(d,f,h,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._writeSoon(c,s.data)}_bufferAdd(s,c){const d=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,d}_bufferTake(){const s=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&E.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class D extends A.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new p(1,0,0,s))}}e.Protocol=D;class b extends L.IPCClient{constructor(s,c,d=null){super(s,c,d);this.protocol=s}static fromSocket(s,c){return new b(new D(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=b;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],c=0,d=this._first;for(;d;)s[c++]=d.data,d=d.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new u(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<a._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=a._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),c=(1+a._HISTORY_LENGTH)*1e3;let d=0;for(let f=0;f<a._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=c&&d++;return 1-d/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class t{constructor(s,c=null){this._loadEstimator=a.getInstance(),this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=A.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new p(5,0,0,y());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const c=new p(4,0,0,y());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=A.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let c=0,d=s.length;c<d;c++)this._socketWriter.write(s[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new p(6,0,0,y())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const c=this._outgoingUnackMsg.toArray();for(let d=0,f=c.length;d<f;d++)this._socketWriter.write(c[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new p(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(s){const c=new p(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new p(3,0,this._incomingAckId,y());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(J[122],x([0,1,14,5,33,120,2,20]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(i,I){const k=L.Event.fromNodeEventEmitter(v.ipcMain,I,(g,m)=>({event:g,message:m})),p=L.Event.filter(k,({event:g})=>g.sender.id===i);return L.Event.map(p,({message:g})=>g&&n.VSBuffer.wrap(g))}class y extends A.IPCServer{constructor(){super(y.getOnDidClientConnect())}static getOnDidClientConnect(){const I=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:k})=>k);return L.Event.map(I,k=>{const p=k.id,g=y.Clients.get(p);g&&g.dispose();const m=new L.Emitter;y.Clients.set(p,E.toDisposable(()=>m.fire()));const D=w(p,"vscode:message"),b=L.Event.any(L.Event.signal(w(p,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(k,D),onDidClientDisconnect:b}})}}e.Server=y,y.Clients=new Map}),define(J[85],x([0,1,14,5,27,121]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class E extends S.Client{constructor(y,i){super({addEventListener:(I,k)=>y.addListener(I,k),removeEventListener:(I,k)=>y.removeListener(I,k),postMessage:I=>y.postMessage(I),start:()=>y.start(),close:()=>y.close()},i)}}e.Client=E;async function n(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const y=A.generateUuid();w.webContents.send("vscode:createMessageChannel",y);const i=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(k,p)=>({nonce:p,port:k.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,k=>k.nonce===y)));return I}e.connect=n}),define(J[86],x([0,1,2,5,9,13]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var E;(function(i){i[i.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(E=e.StorageHint||(e.StorageHint={}));var n;(function(i){i[i.None=0]="None",i[i.Initialized=1]="Initialized",i[i.Closed=2]="Closed"})(n||(n={}));class w extends v.Disposable{constructor(I,k=Object.create(null)){super();this.database=I,this.options=k,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new A.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(I=>this.onDidChangeItemsExternal(I)))}onDidChangeItemsExternal(I){var k,p;(k=I.changed)===null||k===void 0||k.forEach((g,m)=>this.accept(m,g)),(p=I.deleted)===null||p===void 0||p.forEach(g=>this.accept(g,void 0))}accept(I,k){if(this.state===n.Closed)return;let p=!1;S.isUndefinedOrNull(k)?p=this.cache.delete(I):this.cache.get(I)!==k&&(this.cache.set(I,k),p=!0),p&&this._onDidChangeStorage.fire(I)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(I,k){const p=this.cache.get(I);return S.isUndefinedOrNull(p)?k:p}getBoolean(I,k){const p=this.get(I);return S.isUndefinedOrNull(p)?k:p==="true"}getNumber(I,k){const p=this.get(I);return S.isUndefinedOrNull(p)?k:parseInt(p,10)}async set(I,k){if(this.state===n.Closed)return;if(S.isUndefinedOrNull(k))return this.delete(I);const p=String(k);if(this.cache.get(I)!==p)return this.cache.set(I,p),this.pendingInserts.set(I,p),this.pendingDeletes.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async delete(I){if(!(this.state===n.Closed||!this.cache.delete(I)))return this.pendingDeletes.has(I)||this.pendingDeletes.add(I),this.pendingInserts.delete(I),this._onDidChangeStorage.fire(I),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(I){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const I={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(I).finally(()=>{var k;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(k=this.whenFlushedCallbacks.pop())===null||k===void 0||k()})}async whenFlushed(){if(!!this.hasPending)return new Promise(I=>this.whenFlushedCallbacks.push(I))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(I){I.insert&&I.insert.forEach((k,p)=>this.items.set(p,k)),I.delete&&I.delete.forEach(k=>this.items.delete(k))}async close(){}}e.InMemoryStorageDatabase=y}),define(J[123],x([0,1,5,9,36,8,16]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=S.basename(this.path),this.logger=new w(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return v.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(p=>I.set(p.key,p.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?A.mapToString(I.insert):"0"}), delete(${I.delete?A.setToString(I.delete):"0"})`),this.transaction(i,()=>{const k=I.insert,p=I.delete;if(k&&k.size>0){const g=[];g.push([]);let m=0;k.forEach((D,b)=>{let l=g[m];l.length>n.MAX_HOST_PARAMETERS&&(m++,l=[],g.push(l)),l.push(b,D)}),g.forEach(D=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(D.length/2).fill("(?,?)").join(",")}`,b=>b.run(D),()=>{const b=[];let l=0;return k.forEach((u,o)=>{b.push(o),l+=u.length}),`Keys: ${b.join(", ")} Length: ${l}`})})}if(p&&p.size){const g=[];g.push([]);let m=0;p.forEach(D=>{let b=g[m];b.length>n.MAX_HOST_PARAMETERS&&(m++,b=[],g.push(b)),b.push(D)}),g.forEach(D=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(D.length).fill("?").join(",")})`,b=>b.run(D),()=>{const b=[];return p.forEach(l=>{b.push(l)}),`Keys: ${b.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((k,p)=>{i.db.close(g=>(g&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${g}`),this.path===n.IN_MEMORY_PATH?k():!i.isErroneous&&!i.isInMemory?this.backup().then(k,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),k())):typeof I=="function"?E.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const D=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:I()}).then(()=>D(),b=>(D(),Promise.reject(b)))})).then(k,p):p(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return E.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,k=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),p=i?k.integrity_check:k.quick_check;return I.isErroneous?`${p} (last error: ${I.lastError})`:I.isInMemory?`${p} (in-memory!)`:p}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(k){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&I)return await L.timeout(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await E.Promises.unlink(i);try{await E.Promises.rename(this.toBackupPath(i),i)}catch(p){}return await this.doConnect(i)}catch(p){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${p}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,k)=>{new Promise((p,g)=>{$(["vscode-sqlite3"],p,g)}).then(p=>{const g={db:new(this.logger.isTracing?p.verbose().Database:p.Database)(i,m=>m?g.db?g.db.close(()=>k(m)):k(m):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(g),D=>g.db.close(()=>k(D)))),isInMemory:i===n.IN_MEMORY_PATH};g.db.on("error",m=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&g.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},k)})}exec(i,I){return new Promise((k,p)=>{i.db.exec(I,g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${g}`),p(g)):k())})}get(i,I){return new Promise((k,p)=>{i.db.get(I,(g,m)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${g}`),p(g)):k(m))})}all(i,I){return new Promise((k,p)=>{i.db.all(I,(g,m)=>g?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${g}`),p(g)):k(m))})}transaction(i,I){return new Promise((k,p)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${g}`),p(g)):k())})})}prepare(i,I,k,p){const g=i.db.prepare(I),m=D=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${D} (${I}). Details: ${p()}`)};g.on("error",m),k(g),g.finalize(D=>{D&&m(D),g.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class w{constructor(i){i&&typeof i.logTrace=="function"&&process.env[w.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}w.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(J[124],x([12,11]),function($,e){return $.create("vs/base/common/date",e)}),define(J[125],x([0,1,124]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,A=L*60,S=A*24,E=S*7,n=S*30,w=S*365;function y(I,k){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return v.localize(0,null,y(new Date().getTime()+p*1e3,!1));if(p<30)return v.localize(1,null);let g;return p<L?(g=p,k?g===1?v.localize(2,null,g):v.localize(3,null,g):g===1?v.localize(4,null,g):v.localize(5,null,g)):p<A?(g=Math.floor(p/L),k?g===1?v.localize(6,null,g):v.localize(7,null,g):g===1?v.localize(8,null,g):v.localize(9,null,g)):p<S?(g=Math.floor(p/A),k?g===1?v.localize(10,null,g):v.localize(11,null,g):g===1?v.localize(12,null,g):v.localize(13,null,g)):p<E?(g=Math.floor(p/S),k?g===1?v.localize(14,null,g):v.localize(15,null,g):g===1?v.localize(16,null,g):v.localize(17,null,g)):p<n?(g=Math.floor(p/E),k?g===1?v.localize(18,null,g):v.localize(19,null,g):g===1?v.localize(20,null,g):v.localize(21,null,g)):p<w?(g=Math.floor(p/n),k?g===1?v.localize(22,null,g):v.localize(23,null,g):g===1?v.localize(24,null,g):v.localize(25,null,g)):(g=Math.floor(p/w),k?g===1?v.localize(26,null,g):v.localize(27,null,g):g===1?v.localize(28,null,g):v.localize(29,null,g))}e.fromNow=y;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(J[126],x([12,11]),function($,e){return $.create("vs/base/common/errorMessage",e)}),define(J[67],x([0,1,126,13,35]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(y,i){return i&&(y.stack||y.stacktrace)?v.localize(0,null,n(y),E(y.stack)||E(y.stacktrace)):n(y)}function E(y){return Array.isArray(y)?y.join(`
`):y}function n(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?v.localize(1,null,y.message):y.message||v.localize(2,null)}function w(y=null,i=!1){if(!y)return v.localize(3,null);if(Array.isArray(y)){const I=A.coalesce(y),k=w(I[0],i);return I.length>1?v.localize(4,null,k,I.length):k}if(L.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return y.stack?S(y,i):y.message?y.message:v.localize(5,null)}e.toErrorMessage=w}),define(J[127],x([12,11]),function($,e){return $.create("vs/base/common/keybindingLabels",e)}),define(J[128],x([0,1,127]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(E,n,w=n){this.modifierLabels=[null],this.modifierLabels[2]=E,this.modifierLabels[1]=n,this.modifierLabels[3]=w}toLabel(E,n,w){if(n.length===0)return null;const y=[];for(let i=0,I=n.length;i<I;i++){const k=n[i],p=w(k);if(p===null)return null;y[i]=A(k,p,this.modifierLabels[E])}return y.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function A(S,E,n){if(E===null)return"";const w=[];return S.ctrlKey&&w.push(n.ctrlKey),S.shiftKey&&w.push(n.shiftKey),S.altKey&&w.push(n.altKey),S.metaKey&&w.push(n.metaKey),E!==""&&w.push(E),w.join(n.separator)}}),define(J[129],x([12,11]),function($,e){return $.create("vs/base/node/processes",e)}),define(J[68],x([0,1,8,16,40,129,32,13,44,30,3,81,10]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function p(o){switch(o){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(o,a){if(i.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=A.execFile("taskkill",["/T","/F","/PID",o.pid.toString()],t);return new Promise(s=>{r.once("error",c=>{s({success:!1,error:c})}),r.once("exit",(c,d)=>{s(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?p(t.status):1})}else if(i.isLinux||i.isMacintosh)try{const t=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(r=>{A.execFile(t,[o.pid.toString()],{encoding:"utf8",shell:!0},(s,c,d)=>{r(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else o.kill("SIGKILL");return Promise.resolve({success:!0})}function m(o=E.env){return o.comspec||"cmd.exe"}e.getWindowsShell=m;class D{constructor(a,t,r,s){if(t!==void 0&&r!==void 0&&s!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=s;else{const c=a;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(E.env).forEach(d=>{c[d]=E.env[d]}),Object.keys(this.options.env).forEach(d=>{c[d]=this.options.env[d]}),this.options.env=c}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(v.sep);return t!==-1&&(a=a.substring(t+1)),D.WellKnowCommands[a]?a:"other"}start(a){return i.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,s;const c=new Promise((d,f)=>{r=d,s=f});if(t){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=A.exec(d,this.options,(f,h,M)=>{this.childProcess=null;const T=f;T&&T.killed?s({killed:this.terminateRequested,stdout:h.toString(),stderr:M.toString()}):this.handleExec(r,a,f,h,M)})}else{let d=null;const f=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,a,s);const M={terminated:this.terminateRequested};n.isNumber(h)&&(M.cmdCode=h),r(M)};if(this.shell&&i.isWindows){const h=w.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let M=!1,T=!1;const U=[];let H=this.ensureQuotes(this.cmd);U.push(H.value),M=H.quoted,this.args&&this.args.forEach(ee=>{H=this.ensureQuotes(ee),U.push(H.value),T=T&&H.quoted});const X=["/s","/c"];M?T?X.push('"'+U.join(" ")+'"'):U.length>1?X.push('"'+U[0]+'" '+U.slice(1).join(" ")):X.push('"'+U[0]+'"'):X.push(U.join(" ")),d=A.spawn(m(),X,h)}else this.cmd&&(d=A.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(n.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",h=>{this.childProcess=null,s({terminated:this.terminateRequested,error:h})}),d.pid&&(this.childProcess.on("close",f),this.handleSpawn(d,r,a,s,!0)))}return c})}handleClose(a,t,r,s){}ensureQuotes(a){return D.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,g(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!i.isWindows)return a(!1);const t=A.spawn(m(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(a,t,r,s){super(a,t,r,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,s,c){[s,c].forEach((d,f)=>{const h=new I.LineDecoder;h.write(d).forEach(U=>{t({line:U,source:f===0?0:1})});const T=h.end();T&&t({line:T,source:f===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,s,c){const d=new I.LineDecoder,f=new I.LineDecoder;a.stdout.on("data",h=>{d.write(h).forEach(T=>r({line:T,source:0}))}),a.stderr.on("data",h=>{f.write(h).forEach(T=>r({line:T,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=f}handleClose(a,t,r,s){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&r({line:c,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&r({line:d,source:1})}}e.LineProcess=b;function l(o){let a=[],t=!1;const r=function(s){if(t){a.push(s);return}(!o.send(s,d=>{if(d&&console.error(d),t=!1,a.length>0){const f=a.slice(0);a=[],f.forEach(h=>r(h))}})||i.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=l;var u;(function(o){async function a(t,r,s){if(v.isAbsolute(t))return t;if(r===void 0&&(r=E.cwd()),v.dirname(t)!=="."||(s===void 0&&n.isString(E.env.PATH)&&(s=E.env.PATH.split(v.delimiter)),s===void 0||s.length===0))return v.join(r,t);async function d(f){return await L.exists(f)?!(await L.Promises.stat(f)).isDirectory():!1}for(let f of s){let h;if(v.isAbsolute(f)?h=v.join(f,t):h=v.join(r,f,t),await d(h))return h;let M=h+".com";if(await d(M)||(M=h+".exe",await d(M)))return M}return v.join(r,t)}o.findExecutable=a})(u=e.win32||(e.win32={}))}),define(J[130],x([0,1,26,3,116,68]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function E(p,g){return p===1?L.isWindows?I():S.getWindowsShell(g):y(p,g)}e.getSystemShell=E;function n(p,g){return p===1?L.isWindows?k(g):S.getWindowsShell(g):y(p,g)}e.getSystemShellSync=n;let w=null;function y(p,g){if(L.isLinux&&p===2||L.isMacintosh&&p===3)return"/bin/bash";if(!w){let m;if(L.isWindows)m="/bin/bash";else{if(m=g.SHELL,!m)try{m=v.userInfo().shell}catch(D){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}w=m}return w}let i=null;async function I(){return i||(i=(await A.getFirstAvailablePowerShellInstallation()).exePath),i}function k(p){if(i)return i;const g=L.isWindows&&parseFloat(v.release())>=10,m=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),D=`${p.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return g?D:S.getWindowsShell(p)}}),define(J[87],x([0,1,40,2,9,44,5,68,33,109,25,19,20,3]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class g extends w.ChannelServer{constructor(b){super({send:l=>{try{process.send&&process.send(l.buffer.toString("base64"))}catch(u){}},onMessage:E.Event.fromNodeEventEmitter(process,"message",l=>k.VSBuffer.wrap(Buffer.from(l,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=g;class m{constructor(b,l){this.modulePath=b,this.options=l,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=l&&l.timeout?l.timeout:6e4;this.disposeDelayer=new A.Delayer(u),this.child=null,this._client=null}getChannel(b){const l=this;return{call(u,o,a){return l.requestPromise(b,u,o,a)},listen(u,o){return l.requestEvent(b,u,o)}}}requestPromise(b,l,u,o=i.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=A.createCancelablePromise(c=>a.call(l,u,c)),r=o.onCancellationRequested(()=>t.cancel()),s=L.toDisposable(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{r.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,l,u){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let o;const a=new E.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(b).listen(l,u)(a.fire,a),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],l=Object.create(null);l.env=Object.assign(Object.assign({},S.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(l.env=Object.assign(Object.assign({},l.env),this.options.env)),this.options&&this.options.freshExecArgv&&(l.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(d=>!/^--inspect(-brk)?=/.test(d))),p.isMacintosh&&l.env&&delete l.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,b,l);const u=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",d=>d)(d=>{if(y.isRemoteConsoleLog(d)){y.log(d,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(d,"base64")))});const a=this.options.useQueue?n.createQueuedSender(this.child):this.child,t=d=>this.child&&this.child.connected&&a.send(d.buffer.toString("base64")),r=u.event,s={send:t,onMessage:r};this._client=new w.ChannelClient(s);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",d=>console.warn('IPC "'+this.options.serverName+'" errored with '+d)),this.child.on("exit",(d,f)=>{process.removeListener("exit",c),this.activeRequests.forEach(h=>L.dispose(h)),this.activeRequests.clear(),d!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+d+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:d,signal:f})})}return this._client}getCachedChannel(b){let l=this.channels.get(b);return l||(l=this.client.getChannel(b),this.channels.set(b,l)),l}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(J[131],x([12,11]),function($,e){return $.create("vs/code/electron-main/app",e)}),define(J[132],x([12,11]),function($,e){return $.create("vs/platform/configuration/common/configurationRegistry",e)}),define(J[133],x([12,11]),function($,e){return $.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(J[134],x([12,11]),function($,e){return $.create("vs/platform/environment/node/argv",e)}),define(J[135],x([12,11]),function($,e){return $.create("vs/platform/environment/node/argvHelper",e)}),define(J[136],x([12,11]),function($,e){return $.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(J[137],x([12,11]),function($,e){return $.create("vs/platform/extensions/common/extensionValidator",e)}),define(J[138],x([12,11]),function($,e){return $.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(J[139],x([12,11]),function($,e){return $.create("vs/platform/files/common/fileService",e)}),define(J[140],x([12,11]),function($,e){return $.create("vs/platform/files/common/files",e)}),define(J[141],x([12,11]),function($,e){return $.create("vs/platform/files/common/io",e)}),define(J[142],x([12,11]),function($,e){return $.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(J[143],x([12,11]),function($,e){return $.create("vs/platform/issue/electron-main/issueMainService",e)}),define(J[144],x([12,11]),function($,e){return $.create("vs/platform/menubar/electron-main/menubar",e)}),define(J[145],x([12,11]),function($,e){return $.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(J[146],x([12,11]),function($,e){return $.create("vs/platform/request/common/request",e)}),define(J[147],x([12,11]),function($,e){return $.create("vs/platform/telemetry/common/telemetryService",e)}),define(J[148],x([12,11]),function($,e){return $.create("vs/platform/update/common/update.config.contribution",e)}),define(J[149],x([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/window",e)}),define(J[150],x([12,11]),function($,e){return $.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(J[151],x([12,11]),function($,e){return $.create("vs/platform/workspaces/common/workspaces",e)}),define(J[152],x([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(J[153],x([12,11]),function($,e){return $.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(J[154],x([0,1,5,2]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class A{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,w,y){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(n,w,y){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=A,A.ChannelName="extensionhostdebugservice";class S extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,w,y){this.channel.call("attach",[n,w,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,w){this.channel.call("terminate",[n,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,w,y){return this.channel.call("openExtensionDevelopmentHostWindow",[n,w||{},y])}}e.ExtensionHostDebugChannelClient=S}),define(J[155],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(E){this.driver=E}listen(E,n){throw new Error(`No event found: ${n}`)}call(E,n,w){switch(n){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(E){this.channel=E}click(E,n,w){return this.channel.call("click",[E,n,w])}doubleClick(E){return this.channel.call("doubleClick",E)}setValue(E,n){return this.channel.call("setValue",[E,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(E){return this.channel.call("isActiveElement",E)}getElements(E,n){return this.channel.call("getElements",[E,n])}getElementXY(E,n,w){return this.channel.call("getElementXY",[E,n,w])}typeInEditor(E,n){return this.channel.call("typeInEditor",[E,n])}getTerminalBuffer(E){return this.channel.call("getTerminalBuffer",E)}writeInTerminal(E,n){return this.channel.call("writeInTerminal",[E,n])}}e.WindowDriverChannelClient=L;class A{constructor(E){this.channel=E}registerWindowDriver(E){return this.channel.call("registerWindowDriver",E)}reloadWindowDriver(E){return this.channel.call("reloadWindowDriver",E)}}e.WindowDriverRegistryChannelClient=A}),define(J[156],x([0,1,8,15,46,125,10,7,32]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(g,m,D){this._args=g,this.paths=m,this.productService=D}get appRoot(){return v.dirname(E.FileAccess.asFileUri("",$).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file(v.join(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return L.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return L.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=v.join(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file(v.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return L.joinPath(n.URI.file(v.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return L.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return L.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=w.env.VSCODE_PORTABLE;return g?n.URI.file(v.join(g,"argv.json")):L.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return L.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file(v.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return v.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?v.resolve(g):v.normalize(v.join(E.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?v.resolve(g):v.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return v.resolve(g);const m=w.env.VSCODE_EXTENSIONS;if(m)return m;const D=w.env.VSCODE_PORTABLE;return D?v.join(D,"extensions"):L.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file(v.normalize(m)))}get extensionDevelopmentKind(){var g;return(g=this.args.extensionDevelopmentKind)===null||g===void 0?void 0:g.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?n.URI.parse(g):n.URI.file(v.normalize(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return L.joinPath(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file(v.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([A.memoize],y.prototype,"appRoot",null),he([A.memoize],y.prototype,"userHome",null),he([A.memoize],y.prototype,"userDataPath",null),he([A.memoize],y.prototype,"appSettingsHome",null),he([A.memoize],y.prototype,"tmpDir",null),he([A.memoize],y.prototype,"userRoamingDataHome",null),he([A.memoize],y.prototype,"settingsResource",null),he([A.memoize],y.prototype,"userDataSyncHome",null),he([A.memoize],y.prototype,"userDataSyncLogResource",null),he([A.memoize],y.prototype,"sync",null),he([A.memoize],y.prototype,"machineSettingsResource",null),he([A.memoize],y.prototype,"globalStorageHome",null),he([A.memoize],y.prototype,"workspaceStorageHome",null),he([A.memoize],y.prototype,"keybindingsResource",null),he([A.memoize],y.prototype,"keyboardLayoutResource",null),he([A.memoize],y.prototype,"argvResource",null),he([A.memoize],y.prototype,"snippetsHome",null),he([A.memoize],y.prototype,"isExtensionDevelopment",null),he([A.memoize],y.prototype,"untitledWorkspacesHome",null),he([A.memoize],y.prototype,"installSourcePath",null),he([A.memoize],y.prototype,"builtinExtensionsPath",null),he([A.memoize],y.prototype,"extensionsPath",null),he([A.memoize],y.prototype,"extensionDevelopmentLocationURI",null),he([A.memoize],y.prototype,"extensionDevelopmentKind",null),he([A.memoize],y.prototype,"extensionTestsLocationURI",null),he([A.memoize],y.prototype,"debugExtensionHost",null),he([A.memoize],y.prototype,"serviceMachineIdResource",null),he([A.memoize],y.prototype,"telemetryLogResource",null),he([A.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function i(p,g){return k(p["inspect-extensions"],p["inspect-brk-extensions"],5870,g,p.debugId)}e.parseExtensionHostPort=i;function I(p,g){return k(p["inspect-search"],p["inspect-brk-search"],5876,g)}e.parseSearchPort=I;function k(p,g,m,D,b){const u=Number(g||p)||(D?null:m),o=u?Boolean(!!g):!1;return{port:u,break:o,debugId:b}}}),define(J[88],x([0,1,238,134,3]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:L.localize(0,null),e:L.localize(1,null),t:L.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:L.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:L.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:L.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:L.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:L.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:L.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:L.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:L.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:L.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:L.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:L.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:L.localize(14,null)},category:{type:"string",cat:"e",description:L.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:L.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:L.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:L.localize(19,null)},verbose:{type:"boolean",cat:"t",description:L.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:L.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:L.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:L.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:L.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:L.localize(25,null)},sync:{type:"string",cat:"t",description:L.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:L.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:L.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:L.localize(29,null)},"max-memory":{type:"string",cat:"t",description:L.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:L.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const E={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(g,m,D=E){const b={},l=[],u=[];for(let r in m){const s=m[r];s.alias&&(b[r]=s.alias),s.type==="string"||s.type==="string[]"?(l.push(r),s.deprecates&&l.push(s.deprecates)):s.type==="boolean"&&(u.push(r),s.deprecates&&u.push(s.deprecates))}const o=v(g,{string:l,boolean:u,alias:b}),a={},t=o;a._=o._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const s=m[r];s.alias&&delete t[s.alias];let c=t[r];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(c||(c=t[s.deprecates]),delete t[s.deprecates]),typeof c!="undefined"&&(s.type==="string[]"?c&&!Array.isArray(c)&&(c=[c]):s.type==="string"&&Array.isArray(c)&&(c=c.pop(),D.onMultipleValues(r,c)),a[r]=c),delete t[r]}for(let r in t)D.onUnknownOption(r);return a}e.parseArgs=n;function w(g,m){let D="";return m.args&&(Array.isArray(m.args)?D=` <${m.args.join("> <")}>`:D=` <${m.args}>`),m.alias?`-${m.alias} --${g}${D}`:`--${g}${D}`}function y(g,m){let D=0,b=[];for(const a in g){const t=g[a],r=w(a,t);D=Math.max(D,r.length),b.push([r,t.description])}let l=D+2+1;if(m-l<25)return b.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=m-l-1,o=[];for(const a of b){let t=a[0],r=I(a[1],u),s=i(l-t.length-2);o.push("  "+t+s+r[0]);for(let c=1;c<r.length;c++)o.push(i(l)+r[c])}return o}e.formatOptions=y;function i(g){return" ".repeat(g)}function I(g,m){let D=[];for(;g.length;){let b=g.length<m?g.length:g.lastIndexOf(" ",m),l=g.slice(0,b).trim();g=g.slice(b),D.push(l)}return D}function k(g,m,D,b,l=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${g} ${D}`];o.push(""),o.push(`${L.localize(32,null)}: ${m} [${L.localize(33,null)}][${L.localize(34,null)}...]`),o.push(""),l&&(A.isWindows?o.push(L.localize(35,null,m)):o.push(L.localize(36,null,m)),o.push(""));const a={};for(const t in b){const r=b[t];if(r.description&&r.cat){let s=a[r.cat];s||(a[r.cat]=s={}),s[t]=r}}for(let t in a){const r=t;let s=a[r];s&&(o.push(S[r]),o.push(...y(s,u)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=k;function p(g,m){return`${g||L.localize(37,null)}
${m||L.localize(38,null)}
${process.arch}`}e.buildVersionMessage=p}),define(J[157],x([0,1,88,59,154]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends A.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,w,y){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(y[0],y[1],y[2]):super.call(n,w,y)}async openExtensionDevelopmentHostWindow(n,w,y){const i=v.parseArgs(n,v.OPTIONS);i.debugRenderer=y;const I=i.extensionDevelopmentPath;if(!I)return{success:!1};let k;const p=Object.keys(w);for(let u of p){let o=w[u];o===null||(k||(k=Object.create(null)),k[u]=o)}const[g]=this.windowsMainService.openExtensionDevelopmentHostWindow(I,{context:5,cli:i,userEnv:k});if(!y)return{success:!0};const m=g.win;if(!m)return{success:!0};const D=m.webContents.debugger;let b=D.isAttached()?Infinity:0;const l=L.createServer(u=>{b++==0&&D.attach();let o=!1;const a=s=>{o||u.write(JSON.stringify(s)+"\0")},t=(s,c,d,f)=>a({method:c,params:d,sessionId:f});m.on("close",()=>{D.removeListener("message",t),u.end(),o=!0}),D.addListener("message",t);let r=Buffer.alloc(0);u.on("data",s=>{r=Buffer.concat([r,s]);for(let c=r.indexOf(0);c!==-1;c=r.indexOf(0)){let d;try{const f=r.slice(0,c).toString("utf8");r=r.slice(c+1),d=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}D.sendCommand(d.method,d.params,d.sessionId).then(f=>a({id:d.id,sessionId:d.sessionId,result:f})).catch(f=>a({id:d.id,sessionId:d.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{o=!0,--b==0&&D.detach()})});return await new Promise(u=>l.listen(0,u)),m.on("close",()=>l.close()),{rendererDebugPort:l.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function $(e,v,L,A){function S(n){const w=E(n),y=[w];return e.isAbsolute(w)||y.unshift(A),e.resolve(...y)}function E(n){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const y=n["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(I,"AppData","Roaming")}break;case"darwin":i=e.join(v.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,L)}return{getUserDataPath:S}}if(typeof define=="function")define(J[158],x([0,159,26,10,15,32]),function(e,v,L,A,S,E){const n=S.dirname(A.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);return $(v,L,w.name,E.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=$(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[160],x([0,1,26,158,156]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends A.AbstractNativeEnvironmentService{constructor(n,w){super(n,{homeDir:v.homedir(),tmpDir:v.tmpdir(),userDataDir:L.getUserDataPath(n)},w)}}e.NativeEnvironmentService=S}),define(J[161],x([0,1,29,26,8]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(E){const n=A.join(L.tmpdir(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),E&&console.log(`Marker file for --wait created: ${n}`),n}catch(w){E&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=S}),define(J[162],x([0,1,137]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function S(k){return k=k.trim(),k==="*"||L.test(k)}e.isValidVersionStr=S;function E(k){if(!S(k))return null;if(k=k.trim(),k==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=k.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=E;function n(k){if(!k)return null;let p=k.majorBase,g=k.majorMustEqual,m=k.minorBase,D=k.minorMustEqual,b=k.patchBase,l=k.patchMustEqual;k.hasCaret&&(p===0||(D=!1),l=!1);let u=0;if(k.preRelease){const o=A.exec(k.preRelease);if(o){const[,a,t,r]=o;u=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:p,majorMustEqual:g,minorBase:m,minorMustEqual:D,patchBase:b,patchMustEqual:l,isMinimum:k.hasGreaterEquals,notBefore:u}}e.normalizeVersion=n;function w(k,p,g){let m;typeof k=="string"?m=n(E(k)):m=k;let D;p instanceof Date?D=p.getTime():typeof p=="string"&&(D=new Date(p).getTime());let b;if(typeof g=="string"?b=n(E(g)):b=g,!m||!b)return!1;let l=m.majorBase,u=m.minorBase,o=m.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,c=b.majorMustEqual,d=b.minorMustEqual,f=b.patchMustEqual;return b.isMinimum?l>a?!0:l<a?!1:u>t?!0:u<t||D&&D<s?!1:o>=r:(l===1&&a===0&&(!c||!d||!f)&&(a=1,t=0,r=0,c=!0,d=!1,f=!1),l<a?!1:l>a?!c:u<t?!1:u>t?!d:o<r?!1:o>r?!f:!(D&&D<s))}e.isValidVersion=w;function y(k,p,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:I(k,p,g.engines.vscode,m)}e.isValidExtensionVersion=y;function i(k,p,g){return k==="*"||I(p,g,k)}e.isEngineValid=i;function I(k,p,g,m=[]){let D=n(E(g));if(!D)return m.push(v.localize(0,null,g)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return m.push(v.localize(1,null,g)),!1}else if(!D.majorMustEqual)return m.push(v.localize(2,null,g)),!1;return w(k,p,D)?!0:(m.push(v.localize(3,null,k,g)),!1)}}),define(J[163],x([0,1,33,87,2,10]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[164],x([0,1,33,87,2,10]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends A.Disposable{constructor(w,y,i,I,k={}){super();this.folders=w,this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new L.Client(S.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=E.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E,E.MAX_RESTARTS=5}),define(J[165],x([0,1,40,81,111,10]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class E{constructor(w,y,i,I,k){this.watchedFolder=w,this.eventCallback=i,this.logCallback=I,this.verboseLogging=k,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(p=>A.parse(p)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,w);const y=new L.LineDecoder;this.handle.stdout.on("data",i=>{const I=[];y.write(i).forEach(k=>{const p=k.split("|");if(p.length===2){const g=Number(p[0]),m=p[1];if(g>=0&&g<3){if(this.ignored&&this.ignored.some(D=>D(m))){this.verboseLogging&&this.log(m);return}I.push({type:E.changeTypeMap[g],path:m})}else this.log(p[1])}}),I.length>0&&this.eventCallback(I)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,I)=>this.onExit(i,I))}onError(w){this.error("process error: "+w.toString())}onExit(w,y){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${y})`),this.restartCounter<=E.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=E,E.MAX_RESTARTS=5,E.changeTypeMap=[0,1,2]}),define(J[166],x([0,1,165,8,23]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,w,y,i){this.onDidFilesChange=w,this.onLogMessage=y,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=A.rtrim(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(J[69],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,E=[],n=!1){this.ctor=S,this.staticArguments=E,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v;const L=(A,...S)=>new v(A,S);e.createSyncDescriptor=L}),define(J[167],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let E of this._nodes.values())E.outgoing.size===0&&S.push(E);return S}insertEdge(S,E){const n=this.lookupOrInsertNode(S),w=this.lookupOrInsertNode(E);n.outgoing.set(this._hashFn(E),w),w.incoming.set(this._hashFn(S),n)}removeNode(S){const E=this._hashFn(S);this._nodes.delete(E);for(let n of this._nodes.values())n.outgoing.delete(E),n.incoming.delete(E)}lookupOrInsertNode(S){const E=this._hashFn(S);let n=this._nodes.get(E);return n||(n=new v(S),this._nodes.set(E,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[E,n]of this._nodes)S.push(`${E}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,E]of this._nodes){const n=new Set([S]),w=this._findCycle(E,n);if(w)return w}}_findCycle(S,E){for(let[n,w]of S.outgoing){if(E.has(n))return[...E,n].join(" -> ");E.add(n);const y=this._findCycle(w,E);if(y)return y;E.delete(n)}}}e.Graph=L}),define(J[4],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function w(y){return y[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=w})(v=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function L(n,w,y,i){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:n,index:y,optional:i}):(w[v.DI_DEPENDENCIES]=[{id:n,index:y,optional:i}],w[v.DI_TARGET]=w)}function A(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const w=function(y,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(w,y,I,!1)};return w.toString=()=>n,v.serviceIds.set(n,w),w}e.createDecorator=A;function S(n){return n}e.refineServiceDecorator=S;function E(n){return function(w,y,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,w,i,!0)}}e.optional=E}),define(J[70],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.isRemoteDiagnosticError=L}),define(J[89],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=v.createDecorator("encryptionMainService");class L{constructor(S){this.machineId=S}encryption(){return new Promise((S,E)=>$(["vscode-encrypt"],S,E))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(E){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(E){return S}}}e.EncryptionMainService=L}),define(J[53],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(J[168],x([0,1,136,4,10]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var E;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var n;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var w;(function(I){I.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=L.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class i extends Error{constructor(k,p){super(k);this.code=p}}e.ExtensionManagementError=i,e.IExtensionManagementService=L.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=L.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=L.createDecorator("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=L.createDecorator("IExtensionManagementCLIService")}),define(J[169],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=v.createDecorator("extensionUrlTrustService")}),define(J[170],x([0,1,23,4]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=A;function S(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var E;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(E=e.ExtensionType||(e.ExtensionType={}));class n{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,k){if(typeof I=="undefined"||I===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof I=="string"||typeof k=="string"){let p=typeof I=="string"?I:I.value,g=typeof k=="string"?k:k.value;return v.equalsIgnoreCase(p,g)}return I._lower===k._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=n;function w(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function y(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=L.createDecorator("IBuiltinExtensionsScannerService")}),define(J[171],x([0,1,23,170]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(p,g){return p.uuid&&g.uuid?p.uuid===g.uuid:p.id===g.id?!0:v.compareIgnoreCase(p.id,g.id)===0}e.areSameExtensions=A;class S{constructor(g,m){this.version=m,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof S?A(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=S;function E(p,g){return`${p}.${g}`}e.getExtensionId=E;function n(p){return p.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function w(p,g){return n(E(p,g))}e.getGalleryExtensionId=w;function y(p,g){const m=[],D=b=>{for(const l of m)if(l.some(u=>A(g(u),g(b))))return l;return null};for(const b of p){const l=D(b);l?l.push(b):m.push([b])}return m}e.groupByExtension=y;function i(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(p){return Object.assign({id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0)},p.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function k(p){const g=new Set;for(const m of p)m.malicious&&g.add(m.id.id);return g}e.getMaliciousExtensionsSet=k}),define(J[90],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(J[172],x([0,1,40,8,68,138,16,3,90,10,105]),function($,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class k{async getDefaultTerminalForPlatforms(){const o=await m.getDefaultTerminalLinuxReady();return{windows:p.getDefaultTerminalWindows(),linux:o,osx:"xterm"}}}class p extends k{openTerminal(o,a){return this.spawnTerminal(v,o,A.getWindowsShell(),a)}spawnTerminal(o,a,t,r){const s=a.windowsExec||p.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const c=L.basename(s).toLowerCase();if(c==="cmder"||c==="cmder.exe")return o.spawn(s,r?[r]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),(c==="wt"||c==="wt.exe")&&d.push("-d ."),new Promise((f,h)=>{const M=D(process),T=o.spawn(t,d,{cwd:r,env:M});T.on("error",h),T.on("exit",()=>f())})}runInTerminal(o,a,t,r,s){const c="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((d,f)=>{const h=`"${a} - ${I}"`,M=`""${t.join('" "')}" & pause"`,T=["/c","start",h,"/wait",c,"/c",M],U=Object.assign({},D(process),r);Object.keys(U).filter(ee=>U[ee]===null).forEach(ee=>delete U[ee]);const H={cwd:a,env:U,windowsVerbatimArguments:!0};v.spawn(p.CMD,T,H).on("error",ee=>{f(b(ee))}),d(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class g extends k{openTerminal(o,a){return this.spawnTerminal(v,o,a)}runInTerminal(o,a,t,r,s){const c=s.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((d,f)=>{if(c===w.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const h=c===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",T=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,$).fsPath,"-t",o||I,"-w",a];for(let X of t)T.push("-a"),T.push(X);if(r)for(let X in r){const ee=r[X];ee===null?(T.push("-u"),T.push(X)):(T.push("-e"),T.push(`${X}=${ee}`))}let U="";const H=v.spawn(g.OSASCRIPT,T);H.on("error",X=>{f(b(X))}),H.stderr.on("data",X=>{U+=X.toString()}),H.on("exit",X=>{if(X===0)d(void 0);else if(U){const ee=U.split(`
`,1);f(new Error(ee[0]))}else f(new Error(S.localize(1,null,h,X)))})}else f(new Error(S.localize(2,null,c)))})}spawnTerminal(o,a,t){const r=a.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{const d=["-a",r];t&&d.push(t);const f=o.spawn("/usr/bin/open",d);f.on("error",c),f.on("exit",()=>s())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class m extends k{openTerminal(o,a){return this.spawnTerminal(v,o,a)}runInTerminal(o,a,t,r,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,f)=>{let h=[];c.then(M=>{M.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const T=`${l(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;h.push(`''${T}''`);const U=Object.assign({},process.env,r);Object.keys(U).filter(B=>U[B]===null).forEach(B=>delete U[B]);const H={cwd:a,env:U};let X="";const ee=v.spawn(M,h,H);ee.on("error",B=>{f(b(B))}),ee.stderr.on("data",B=>{X+=B.toString()}),ee.on("exit",B=>{if(B===0)d(void 0);else if(X){const Y=X.split(`
`,1);f(new Error(Y[0]))}else f(new Error(S.localize(4,null,M,B)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{n.isLinux?await E.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{r.then(d=>{const f=D(process),h=o.spawn(d,[],{cwd:t,env:f});h.on("error",c),h.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=S.localize(3,null);function D(u){const o=u.env;return i.sanitizeProcessEnvironment(o),o}function b(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function l(u){let o="";for(let a of u)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(J[21],x([0,1,140,8,7,4,23,13,36]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function y(N){return N.create===!0}e.isFileOpenForWriteOptions=y;var i;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(N){N[N.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var k;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=p;function g(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=g;function m(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function D(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(G,z){super(G);this.code=z}}e.FileSystemProviderError=l;function u(N,G){const z=new l(N.toString(),G);return a(z,G),z}e.createFileSystemProviderError=u;function o(N){return N||u(v.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=o;function a(N,G){return N.name=G?`${G} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=a;function t(N){if(!N)return b.Unknown;if(N instanceof l)return N.code;const G=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!G)return b.Unknown;switch(G[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(N){if(N instanceof M)return N.fileOperationResult;switch(t(N)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class c{constructor(G,z,C){this.resource=G,this.operation=z,this.target=C}isOperation(G){return this.operation===G}}e.FileOperationEvent=c;var d;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class f{constructor(G,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=G;for(const C of G)switch(C.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains(G,...z){return this.doContains(G,{includeChildren:!1},...z)}affects(G,...z){return this.doContains(G,{includeChildren:!0},...z)}doContains(G,z,...C){var F,R,O,P,W,_;if(!G)return!1;const q=C.length>0;return!!((!q||C.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(G))||z.includeChildren&&((R=this.added)===null||R===void 0?void 0:R.findSuperstr(G)))||(!q||C.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(G))||z.includeChildren&&((P=this.updated)===null||P===void 0?void 0:P.findSuperstr(G)))||(!q||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(G))||z.includeChildren&&((_=this.deleted)===null||_===void 0?void 0:_.findSuperstr(G))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(G){const z=[],C=G===1?this.added:G===0?this.updated:this.deleted;if(C)for(const[,F]of C)z.push(F);return z}filter(G){return new f(this.changes.filter(z=>G(z)),this.ignorePathCasing)}}e.FileChangesEvent=f;function h(N,G,z){return!N||!G||N===G||G.length>N.length?!1:(G.charAt(G.length-1)!==L.sep&&(G+=L.sep),z?E.startsWithIgnoreCase(N,G):N.indexOf(G)===0)}e.isParent=h;class M extends Error{constructor(G,z,C){super(G);this.fileOperationResult=z,this.options=C}}e.FileOperationError=M;class T extends M{constructor(G,z,C){super(G,2,C);this.stat=z}}e.NotModifiedSinceFileOperationError=T;var U;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(U=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function X(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=X;async function ee(N,G){if(!G.canHandleResource(A.URI.from({scheme:N.scheme})))return new Promise(z=>{const C=G.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===N.scheme&&F.added&&(C.dispose(),z())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(G){return n.isNumber(G)||(G=0),G<B.KB?v.localize(1,null,G.toFixed(0)):G<B.MB?v.localize(2,null,(G/B.KB).toFixed(2)):G<B.GB?v.localize(3,null,(G/B.MB).toFixed(2)):G<B.TB?v.localize(4,null,(G/B.GB).toFixed(2)):v.localize(5,null,(G/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var Y;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function Q(N){return{maxFileSize:N===0?300*B.MB:16*B.GB,maxHeapSize:N===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=Q}),define(J[54],x([0,1,239,135,21,88]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function E(k,p){const g={onUnknownOption:D=>{console.warn(L.localize(0,null,D))},onMultipleValues:(D,b)=>{console.warn(L.localize(1,null,D,b))}},m=S.parseArgs(k,S.OPTIONS,p?g:void 0);return m.goto&&m._.forEach(D=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),L.localize(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(k){const p=k.findIndex(g=>!/^-/.test(g));if(p>-1)return[...k.slice(0,p),...k.slice(p+1)]}function w(k){let[,...p]=k;process.env.VSCODE_DEV&&(p=n(p)||[]);const g=!I(process.env);return E(p,g)}e.parseMainProcessArgv=w;function y(k){const[,,...p]=k;return E(p,!0)}e.parseCLIProcessArgv=y;function i(k,...p){const g=k.indexOf("--");return g===-1?k.push(...p):k.splice(g,0,...p),k}e.addArg=i;function I(k){return k.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(J[91],x([0,1,159,40,27,3,54,67,130]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(k,p,g){return p["force-disable-user-env"]?(k.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(k.trace("resolveShellEnv(): skipped (Windows)"),{}):E.isLaunchedFromCli(g)&&!p["force-user-env"]?(k.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(E.isLaunchedFromCli(g)?k.trace("resolveShellEnv(): running (--force-user-env)"):k.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=I(k)),i)}e.resolveShellEnv=y;let i;async function I(k){const p=new Promise(async(g,m)=>{const D=process.env.ELECTRON_RUN_AS_NODE;k.trace("getUnixShellEnvironment#runAsNode",D);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;k.trace("getUnixShellEnvironment#noAttach",b);const l=A.generateUuid().replace(/-/g,"").substr(0,12),u=new RegExp(l+"(.*)"+l),o=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});k.trace("getUnixShellEnvironment#env",o);const a=await w.getSystemShell(S.OS,o);k.trace("getUnixShellEnvironment#shell",a);const t=v.basename(a);let r,s;/^pwsh(-preview)?$/.test(t)?(r=`& '${process.execPath}' -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,s=["-Login","-Command"]):(r=`'${process.execPath}' -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s=["-ilc"]),k.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),r);const c=L.spawn(a,[...s,r],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});c.on("error",h=>{k.error("getUnixShellEnvironment#errorChildProcess",n.toErrorMessage(h)),g({})});const d=[];c.stdout.on("data",h=>d.push(h));const f=[];c.stderr.on("data",h=>f.push(h)),c.on("close",(h,M)=>{const T=Buffer.concat(d).toString("utf8");k.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&k.trace("getUnixShellEnvironment#stderr",U),h||M)return m(new Error(`Failed to get environment (code ${h}, signal ${M})`));const H=u.exec(T),X=H?H[1]:"{}";try{const ee=JSON.parse(X);D?ee.ELECTRON_RUN_AS_NODE=D:delete ee.ELECTRON_RUN_AS_NODE,b?ee.ELECTRON_NO_ATTACH_CONSOLE=b:delete ee.ELECTRON_NO_ATTACH_CONSOLE,delete ee.XDG_RUNTIME_DIR,k.trace("getUnixShellEnvironment#result",ee),g(ee)}catch(ee){k.error("getUnixShellEnvironment#errorCaught",n.toErrorMessage(ee)),m(ee)}})});try{return await p}catch(g){return k.error("getUnixShellEnvironment#error",n.toErrorMessage(g)),{}}}}),define(J[92],x([0,1,7,21,3]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(w){return w.map(y=>({type:y.type,resource:v.URI.file(y.path)}))}e.toFileChanges=S;function E(w){const y=new n;for(const i of w)y.processEvent(i);return y.normalize()}e.normalizeFileChanges=E;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const i=this.mapPathToChange.get(y.path);if(i){const I=i.type,k=y.type;I===1&&k===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(i),1)):I===2&&k===1?i.type=0:I===1&&k===0||(i.type=k)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],i=[];return this.normalized.filter(I=>I.type!==2?(y.push(I),!1):!0).sort((I,k)=>I.path.length-k.path.length).filter(I=>i.some(k=>L.isParent(I.path,k,!A.isLinux))?!1:(i.push(I.path),!0)).concat(y)}}}),define(J[173],x([0,1,92,2,16,82,117,9,8]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends L.Disposable{constructor(I,k,p,g){super();this.path=I,this.onDidFilesChange=k,this.onLogMessage=p,this.verboseLogging=g,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(E.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:k}=await A.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(k)try{p=await S.realpath(p)}catch(g){if(this.onError(g),k.dangling)return}I.isDirectory()?this._register(E.watchFolder(p,(g,m)=>{this.onFileChange({type:g==="changed"?0:g==="added"?1:2,path:w.join(this.path,w.basename(m))})},g=>this.onError(g))):this._register(E.watchFile(p,g=>{this.onFileChange({type:g==="changed"?0:2,path:this.path})},g=>this.onError(g)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const k=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=v.normalizeFileChanges(k);this.verboseLogging&&p.forEach(g=>{this.onVerbose(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`)}),p.length>0&&this.onDidFilesChange(p)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(J[71],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...A){this._entries=new Map;for(let[S,E]of A)this.set(S,E)}set(A,S){const E=this._entries.get(A);return this._entries.set(A,S),E}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=v}),define(J[174],x([0,1,19,167,69,4,71,9]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class y extends Error{constructor(g){var m;super("cyclic dependency between services");this.message=(m=g.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class i{constructor(g=new E.ServiceCollection,m=!1,D){this._activeInstantiations=new Set,this._services=g,this._strict=m,this._parent=D,this._services.set(S.IInstantiationService,this)}createChild(g){return new i(g,this._strict,this)}invokeFunction(g,...m){let D=k.traceInvocation(g),b=!1;try{return g({get:(u,o)=>{if(b)throw v.illegalState("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(u,D);if(!a&&o!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return a}},...m)}finally{b=!0,D.stop()}}createInstance(g,...m){let D,b;return g instanceof A.SyncDescriptor?(D=k.traceCreation(g.ctor),b=this._createInstance(g.ctor,g.staticArguments.concat(m),D)):(D=k.traceCreation(g),b=this._createInstance(g,m,D)),D.stop(),b}_createInstance(g,m=[],D){let b=S._util.getServiceDependencies(g).sort((o,a)=>o.index-a.index),l=[];for(const o of b){let a=this._getOrCreateServiceInstance(o.id,D);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${g.name} depends on UNKNOWN service ${o.id}.`);l.push(a)}let u=b.length>0?b[0].index:m.length;if(m.length!==u){console.warn(`[createInstance] First service dependency of ${g.name} at position ${u+1} conflicts with ${m.length} static arguments`);let o=u-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,u)}return new g(...[...m,...l])}_setServiceInstance(g,m){if(this._services.get(g)instanceof A.SyncDescriptor)this._services.set(g,m);else if(this._parent)this._parent._setServiceInstance(g,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let m=this._services.get(g);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):m}_getOrCreateServiceInstance(g,m){let D=this._getServiceInstanceOrDescriptor(g);return D instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,D,m.branch(g,!0)):(m.branch(g,!1),D)}_safeCreateAndCacheServiceInstance(g,m,D){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,m,D)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,m,D){const b=new L.Graph(o=>o.id.toString());let l=0;const u=[{id:g,desc:m,_trace:D}];for(;u.length;){const o=u.pop();if(b.lookupOrInsertNode(o),l++>1e3)throw new y(b);for(let a of S._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${g} depends on ${a.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const r={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};b.insertEdge(o,r),u.push(r)}}}for(;;){const o=b.roots();if(o.length===0){if(!b.isEmpty())throw new y(b);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof A.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,m,D=[],b,l){if(this._services.get(g)instanceof A.SyncDescriptor)return this._createServiceInstance(m,D,b,l);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,m,D,b,l);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(g,m=[],D,b){if(D){const l=new n.IdleValue(()=>this._createInstance(g,m,b));return new Proxy(Object.create(null),{get(u,o){if(o in u)return u[o];let a=l.value,t=a[o];return typeof t!="function"||(t=t.bind(a),u[o]=t),t},set(u,o,a){return l.value[o]=a,!0}})}else return this._createInstance(g,m,b)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class k{constructor(g,m){this.type=g,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return w?new k(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):k._None}static traceCreation(g){return w?new k(0,g.name):k._None}branch(g,m){let D=new k(2,g.toString());return this._dep.push([g,m,D]),D}stop(){let g=Date.now()-this._start;k._totals+=g;let m=!1;function D(l,u){let o=[],a=new Array(l+1).join("	");for(const[t,r,s]of u._dep)if(r&&s){m=!0,o.push(`${a}CREATES -> ${t}`);let c=D(l+1,s);c&&o.push(c)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${k._totals.toFixed(2)}ms)`];(g>2||m)&&console.log(b.join(`
`))}}k._None=new class extends k{constructor(){super(-1,null)}stop(){}branch(){return this}},k._totals=0}),define(J[175],x([0,1,19,128,57]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends A.ResolvedKeybinding{constructor(n,w){super();if(w.length===0)throw v.illegalArgument("parts");this._os=n,this._parts=w}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new A.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(J[176],x([0,1,57,175]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class A extends L.BaseResolvedKeybinding{constructor(E,n){super(n,E.parts)}_keyCodeToUILabel(E){if(this._os===2)switch(E){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(E)}_getLabel(E){return E.isDuplicateModifierCase()?"":this._keyCodeToUILabel(E.keyCode)}_getAriaLabel(E){return E.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(E.keyCode)}_keyCodeToElectronAccelerator(E){if(E>=93&&E<=108)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(E)}_getElectronAccelerator(E){return E.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(E.keyCode)}_getUserSettingsLabel(E){if(E.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(E.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(E){return A.getDispatchStr(E)}static getDispatchStr(E){if(E.isModifierKey())return null;let n="";return E.ctrlKey&&(n+="ctrl+"),E.shiftKey&&(n+="shift+"),E.altKey&&(n+="alt+"),E.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(E.keyCode),n}_getSingleModifierDispatchPart(E){return E.keyCode===5&&!E.shiftKey&&!E.altKey&&!E.metaKey?"ctrl":E.keyCode===4&&!E.ctrlKey&&!E.altKey&&!E.metaKey?"shift":E.keyCode===6&&!E.ctrlKey&&!E.shiftKey&&!E.metaKey?"alt":E.keyCode===57&&!E.ctrlKey&&!E.shiftKey&&!E.altKey?"meta":null}}e.USLayoutResolvedKeybinding=A}),define(J[177],x([0,1,9]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(A,S){if(A.length===0)return Promise.resolve(!1);const E=[];let n=!1;for(let w of A){if(w===!0)return Promise.resolve(!0);v.isThenable(w)&&E.push(w.then(y=>{y&&(n=!0)},y=>{S(y),n=!0}))}return v.Promises.settled(E).then(()=>n)}e.handleVetos=L}),define(J[6],x([0,1,4,2,3,5,67]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function n(){return new Date().toISOString()}var w;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class y extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class i extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let c=t[s];if(typeof c=="object")try{c=JSON.stringify(c)}catch(d){}r+=(s>0?" ":"")+c}return r}}e.AbstractMessageLogger=i;class I extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...r){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}debug(t,...r){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}info(t,...r){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...r):console.log(`[main ${n()}]`,t,...r))}warn(t,...r){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...r):console.warn(`[main ${n()}]`,t,...r))}error(t,...r){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}critical(t,...r){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...r):console.error(`[main ${n()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class k extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=k;class p extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:E.toErrorMessage(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class g extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=g;class m extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class D extends L.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?w.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function l(a){if(a.verbose)return w.Trace;if(typeof a.logLevel=="string"){const t=u(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function o(a){switch(a){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=o}),define(J[93],x([0,1,6]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(S,E){switch(E){case v.LogLevel.Trace:return S.trace;case v.LogLevel.Debug:return S.debug;case v.LogLevel.Info:return S.info;case v.LogLevel.Warning:return S.warn;case v.LogLevel.Error:return S.error;case v.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class A extends v.AbstractLogger{constructor(E=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(E),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(E){this._logger=E;for(const{level:n,args:w}of this.buffer)L(E,n).apply(E,w);this.buffer=[]}_log(E,...n){this._logger?L(this._logger,E).apply(this._logger,n):this.getLevel()<=E&&this.buffer.push({level:E,args:n})}trace(E,...n){this._log(v.LogLevel.Trace,E,...n)}debug(E,...n){this._log(v.LogLevel.Debug,E,...n)}info(E,...n){this._log(v.LogLevel.Info,E,...n)}warn(E,...n){this._log(v.LogLevel.Warning,E,...n)}error(E,...n){this._log(v.LogLevel.Error,E,...n)}critical(E,...n){this._log(v.LogLevel.Critical,E,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=A});var te=this&&this.__param||function($,e){return function(v,L){e(v,L,$)}};define(J[178],x([0,1,6,21,9,20,15,4,93]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const y=5*L.ByteSize.MB;let i=class extends v.AbstractLogger{constructor(p,g,m,D){super();this.name=p,this.resource=g,this.fileService=D,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new A.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const g=Array.prototype.slice.call(arguments);g[0]=p.stack,this._log(v.LogLevel.Error,this.format(g))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(p,g){this._log(p,this.format(g))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,g){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>y&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(m)),m=""),m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${g}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(m))})}getCurrentTimestamp(){const p=D=>D<10?`0${D}`:D,g=D=>D<10?`00${D}`:D<100?`0${D}`:D,m=new Date;return`${m.getFullYear()}-${p(m.getMonth()+1)}-${p(m.getDate())} ${p(m.getHours())}:${p(m.getMinutes())}:${p(m.getSeconds())}.${g(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,E.joinPath(E.dirname(this.resource),`${E.basename(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(p){return""}}stringifyLogLevel(p){switch(p){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(p){let g="";for(let m=0;m<p.length;m++){let D=p[m];if(typeof D=="object")try{D=JSON.stringify(D)}catch(b){}g+=(m>0?" ":"")+D}return g}};i=he([te(3,L.IFileService)],i),e.FileLogger=i;let I=class extends v.AbstractLoggerService{constructor(p,g,m){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=g,this.fileService=m}doCreateLogger(p,g){const m=new w.BufferLogService(g);return L.whenProviderRegistered(p,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(i,E.basename(p),p,m.getLevel())),m}};I=he([te(0,v.ILogService),te(1,n.IInstantiationService),te(2,L.IFileService)],I),e.FileLoggerService=I}),define(J[179],x([0,1,6,5,7]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(k){this.service=k,this.onDidChangeLogLevel=L.Event.buffer(k.onDidChangeLogLevel,!0)}listen(k,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(k,p,g){switch(p){case"setLevel":return this.service.setLevel(g)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=S;class E{constructor(k){this.channel=k}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(k){E.setLevel(this.channel,k)}static setLevel(k,p){return k.call("setLevel",p)}}e.LogLevelChannelClient=E;class n{constructor(k){this.loggerService=k,this.loggers=new Map}listen(k,p){throw new Error(`Event not found: ${p}`)}async call(k,p,g){switch(p){case"createLogger":this.createLogger(A.URI.revive(g[0]),g[1]);return;case"log":return this.log(A.URI.revive(g[0]),g[1]);case"consoleLog":return this.consoleLog(g[0],g[1])}throw new Error(`Call not found: ${p}`)}createLogger(k,p){this.loggers.set(k.toString(),this.loggerService.createLogger(k,p))}consoleLog(k,p){let g=console.log;switch(k){case v.LogLevel.Error:g=console.error;break;case v.LogLevel.Warning:g=console.warn;break;case v.LogLevel.Info:g=console.info;break}g.call(console,...p)}log(k,p){const g=this.loggers.get(k.toString());if(!g)throw new Error("Create the logger before logging");for(const[m,D]of p)switch(m){case v.LogLevel.Trace:g.trace(D);break;case v.LogLevel.Debug:g.debug(D);break;case v.LogLevel.Info:g.info(D);break;case v.LogLevel.Warning:g.warn(D);break;case v.LogLevel.Error:g.error(D);break;case v.LogLevel.Critical:g.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class w extends v.AbstractLoggerService{constructor(k,p,g){super(k,p);this.channel=g}createConsoleMainLogger(){return new v.AdapterLogger({log:(k,p)=>{this.channel.call("consoleLog",[k,p])}})}doCreateLogger(k,p,g){return new y(this.channel,k,p,g)}}e.LoggerChannelClient=w;class y extends v.AbstractMessageLogger{constructor(k,p,g,m){super(m==null?void 0:m.always);this.channel=k,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(g),this.channel.call("createLogger",[p,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(k,p){const g=[[k,p]];this.isLoggerCreated?this.doLog(g):this.buffer.push(...g)}doLog(k){this.channel.call("log",[this.file,k])}}class i extends v.LogService{constructor(k,p){super(p);this.parent=k,this._register(k.onDidChangeLogLevel(g=>p.setLevel(g)))}setLevel(k){super.setLevel(k),this.parent.setLevel(k)}}e.FollowerLogService=i}),define(J[94],x([0,1,6,21]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(w,y,i,I){try{const k=await new Promise((p,g)=>{$(["spdlog"],p,g)});return k.setFlushOn(v.LogLevel.Trace),k.createAsyncRotatingLogger(w,y,i,I)}catch(k){console.error(k)}return null}function S(w,y,i,I){const k=$.__$__nodeRequire("spdlog");return k.setFlushOn(v.LogLevel.Trace),k.createRotatingLogger(w,y,i,I)}e.createRotatingLogger=S;function E(w,y,i){switch(y){case v.LogLevel.Trace:w.trace(i);break;case v.LogLevel.Debug:w.debug(i);break;case v.LogLevel.Info:w.info(i);break;case v.LogLevel.Warning:w.warn(i);break;case v.LogLevel.Error:w.error(i);break;case v.LogLevel.Critical:w.critical(i);break;default:throw new Error("Invalid log level")}}class n extends v.AbstractMessageLogger{constructor(y,i,I,k){super();this.name=y,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(k),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const y=this.rotating?6:1,i=30/y*L.ByteSize.MB;return A(this.name,this.filepath,i,y).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:k,message:p}of this.buffer)E(this._logger,k,p);this.buffer=[]}})}log(y,i){this._logger?E(this._logger,y,i):this.getLevel()<=y&&this.buffer.push({level:y,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(J[180],x([0,1,6,15,10,178,94,21,27]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let y=class extends v.AbstractLoggerService{constructor(I,k){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=k}doCreateLogger(I,k,p){var g;if(I.scheme===A.Schemas.file){const m=new E.SpdLogLogger((p==null?void 0:p.name)||w.generateUuid(),I.fsPath,!(p==null?void 0:p.donotRotate),k);return(p==null?void 0:p.donotUseFormatters)&&m.clearFormatters(),m}else return new S.FileLogger((g=p==null?void 0:p.name)!==null&&g!==void 0?g:L.basename(I),I,k,this.fileService)}};y=he([te(0,v.ILogService),te(1,n.IFileService)],y),e.LoggerService=y}),define(J[181],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(E){return E.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(E){return E.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function A(E){return E.uri!==void 0}e.isMenubarMenuItemRecentAction=A;function S(E){return!v(E)&&!L(E)&&!A(E)}e.isMenubarMenuItemAction=S}),define(J[47],x([0,1,10,3,32,15]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let E;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)E=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof($==null?void 0:$.__$__nodeRequire)=="function"){const n=S.dirname(v.FileAccess.asFileUri("",$));E=$.__$__nodeRequire(S.joinPath(n,"product.json").fsPath);const w=$.__$__nodeRequire(S.joinPath(n,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(E,{nameShort:`${E.nameShort} Dev`,nameLong:`${E.nameLong} Dev`,dataFolderName:`${E.dataFolderName}-dev`}),Object.assign(E,{version:w.version})}else E={},Object.keys(E).length===0&&Object.assign(E,{version:"1.57.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=E}),define(J[95],x([0,1,141,20,21,19,47]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(I,k,p,g,m,D){let b;try{await w(I,k,p,g,m,D)}catch(l){b=l}finally{b&&m.errorTransformer&&(b=m.errorTransformer(b)),typeof b!="undefined"&&p.error(b),p.end()}}e.readFileIntoStream=n;async function w(I,k,p,g,m,D){y(D);const b=await I.open(k,{create:!1});try{y(D);let l=0,u=0,o=m&&typeof m.length=="number"?m.length:void 0,a=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,r=0;do u=await I.read(b,t,a.buffer,r,a.byteLength-r),t+=u,r+=u,l+=u,typeof o=="number"&&(o-=u),r===a.byteLength&&(await p.write(g(a)),a=L.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),r=0);while(u>0&&(typeof o!="number"||o>0)&&y(D)&&i(l,m));if(r>0){let s=r;typeof o=="number"&&(s=Math.min(r,o)),p.write(g(a.slice(0,s)))}}catch(l){throw A.ensureFileSystemProviderError(l)}finally{await I.close(b)}}function y(I){if(I.isCancellationRequested)throw S.canceled();return!0}function i(I,k){if(k==null?void 0:k.limits){if(typeof k.limits.memory=="number"&&I>k.limits.memory)throw A.createFileSystemProviderError(v.localize(0,null,E.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof k.limits.size=="number"&&I>k.limits.size)throw A.createFileSystemProviderError(v.localize(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[182],x([0,1,139,72,2,21,5,15,36,35,6,20,64,9,25,10,95,63]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let l=class extends A.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new E.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new E.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new E.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new E.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new E.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new E.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new p.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);L.mark(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new A.DisposableStore;return t.add(a.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(a))))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),A.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),A.dispose(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await p.Promises.settled(a)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!n.isAbsolutePath(o))throw new S.FileOperationError(v.localize(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(a)||S.hasReadWriteCapability(a)||S.hasFileReadStreamCapability(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if(S.hasOpenReadWriteCloseCapability(a)||S.hasReadWriteCapability(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw S.toFileSystemProviderErrorCode(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError(v.localize(2,null,this.resourceForError(o)),1):S.ensureFileSystemProviderError(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),r=this.isPathCaseSensitive(t),s=a==null?void 0:a.resolveTo,c=a==null?void 0:a.resolveSingleChildDescendants,d=a==null?void 0:a.resolveMetadata,f=await t.stat(o);let h;return this.toFileStat(t,o,f,void 0,!!d,(M,T)=>(h||(h=w.TernarySearchTree.forUris(()=>!r),h.set(o,!0),y.isNonEmptyArray(s)&&s.forEach(U=>h.set(U,!0))),Boolean(h.findSuperstr(M.resource)||h.get(M.resource))?!0:M.isDirectory&&c?T===1:!1))}async toFileStat(o,a,t,r,s,c){var d;const{providerExtUri:f}=this.getExtUri(o),h={resource:a,name:f.basename(a),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((d=t.permissions)!==null&&d!==void 0?d:0)&S.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:S.etag({mtime:t.mtime,size:t.size})};if(h.isDirectory&&c(h,r)){try{const M=await o.readdir(a),T=await p.Promises.settled(M.map(async([U,H])=>{try{const X=f.joinPath(a,U),ee=s?await o.stat(X):{type:H};return await this.toFileStat(o,X,ee,M.length,s,c)}catch(X){return this.logService.trace(X),null}}));h.children=y.coalesce(T)}catch(M){this.logService.trace(M),h.children=[]}return h}return h}async resolveAll(o){return p.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!(a==null?void 0:a.overwrite)&&await this.exists(o))throw new S.FileOperationError(v.localize(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=I.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const r=await this.writeFile(o,a);return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,r)),r}async writeFile(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(r);try{await this.validateWriteFile(r,o,t)||await this.mkdirp(r,s.dirname(o));let d;if(S.hasReadWriteCapability(r)&&!(a instanceof I.VSBuffer))if(k.isReadableStream(a)){const f=await k.peekStream(a,3);f.ended?d=I.VSBuffer.concat(f.buffer):d=f}else d=k.peekReadable(a,f=>I.VSBuffer.concat(f),3);else d=a;!S.hasOpenReadWriteCloseCapability(r)||S.hasReadWriteCapability(r)&&d instanceof I.VSBuffer?await this.doWriteUnbuffered(r,o,t,d):await this.doWriteBuffered(r,o,t,d instanceof I.VSBuffer?I.bufferToReadable(d):d)}catch(c){throw new S.FileOperationError(v.localize(4,null,this.resourceForError(o),S.ensureFileSystemProviderError(c).toString()),S.toFileOperationResult(c),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!(t==null?void 0:t.unlock)&&!(o.capabilities&8192))throw new Error(v.localize(5,null,this.resourceForError(a)));let s;try{s=await o.stat(a)}catch(c){return}if((s.type&S.FileType.Directory)!=0)throw new S.FileOperationError(v.localize(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,s),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==S.etag({mtime:t.mtime,size:s.size}))throw new S.FileOperationError(v.localize(7,null),3,t);return s}async readFile(o,a){const t=await this.withReadProvider(o);return(a==null?void 0:a.atomic)?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((r,s)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(o,a,t);r(c)}catch(c){s(c)}})})}async doReadFile(o,a,t){const r=await this.doReadFileStream(o,a,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await I.streamToBuffer(r.value)})}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const r=new g.CancellationTokenSource,s=this.validateReadFile(a,t).then(d=>d,d=>{throw r.cancel(),d});let c;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await s,!(S.hasOpenReadWriteCloseCapability(o)||S.hasFileReadStreamCapability(o))||S.hasReadWriteCapability(o)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(o,a,t):S.hasFileReadStreamCapability(o)?c=this.readFileStreamed(o,a,r.token,t):c=this.readFileBuffered(o,a,r.token,t);const d=await s;return Object.assign(Object.assign({},d),{value:c})}catch(d){c&&await k.consumeStream(c);const f=v.localize(8,null,this.resourceForError(a),S.ensureFileSystemProviderError(d).toString());throw d instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(f,d.stat,t):new S.FileOperationError(f,S.toFileOperationResult(d),t)}}readFileStreamed(o,a,t,r=Object.create(null)){const s=o.readFileStream(a,r,t);return k.transform(s,{data:c=>c instanceof I.VSBuffer?c:I.VSBuffer.wrap(c),error:c=>new S.FileOperationError(v.localize(9,null,this.resourceForError(a),S.ensureFileSystemProviderError(c).toString()),S.toFileOperationResult(c),r)},c=>I.VSBuffer.concat(c))}readFileBuffered(o,a,t,r=Object.create(null)){const s=I.newWriteableBufferStream();return D.readFileIntoStream(o,a,s,c=>c,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new S.FileOperationError(v.localize(10,null,this.resourceForError(a),S.ensureFileSystemProviderError(c).toString()),S.toFileOperationResult(c),r)}),t),s}readFileUnbuffered(o,a,t){const r=k.newWriteableStream(s=>I.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(a);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(a,s.byteLength,t),r.end(I.VSBuffer.wrap(s))}catch(s){r.error(s),r.end()}})(),r}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError(v.localize(11,null,this.resourceForError(o)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==S.ETAG_DISABLED&&a.etag===t.etag)throw new S.NotModifiedSinceFileOperationError(v.localize(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError(v.localize(13,null,this.resourceForError(o)),r)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,r){if(o.toString()!==a.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(s,o,c,a,t,r)}catch(s){return s}return!0}async move(o,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),c=await this.doMoveCopy(r,o,s,a,"move",!!t),d=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,c==="move"?2:3,d)),d}async copy(o,a,t){const r=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),c=await this.doMoveCopy(r,o,s,a,"copy",!!t),d=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,c==="copy"?3:2,d)),d}async doMoveCopy(o,a,t,r,s,c){if(a.toString()===r.toString())return s;const{exists:d,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,a,t,r,s,c);if(d&&!f&&c&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),s==="copy"){if(o===t&&S.hasFileFolderCopyCapability(o))await o.copy(a,r,{overwrite:c});else{const h=await this.resolve(a);h.isDirectory?await this.doCopyFolder(o,h,t,r):await this.doCopyFile(o,a,t,r)}return s}else return o===t?(await o.rename(a,r,{overwrite:c}),s):(await this.doMoveCopy(o,a,t,r,"copy",c),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,r){if(S.hasOpenReadWriteCloseCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(o,a,t,r);if(S.hasOpenReadWriteCloseCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(o,a,t,r);if(S.hasReadWriteCapability(o)&&S.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(o,a,t,r);if(S.hasReadWriteCapability(o)&&S.hasReadWriteCapability(t))return this.doPipeUnbuffered(o,a,t,r)}async doCopyFolder(o,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await p.Promises.settled(a.children.map(async s=>{const c=this.getExtUri(t).providerExtUri.joinPath(r,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,c):this.doCopyFile(o,s.resource,t,c)}))}async doValidateMoveCopy(o,a,t,r,s,c){let d=!1;if(o===t){const{providerExtUri:h,isPathCaseSensitive:M}=this.getExtUri(o);if(M||(d=h.isEqual(a,r)),d&&s==="copy")throw new Error(v.localize(14,null,this.resourceForError(a),this.resourceForError(r)));if(!d&&h.isEqualOrParent(r,a))throw new Error(v.localize(15,null,this.resourceForError(a),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!d){if(!c)throw new S.FileOperationError(v.localize(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(o===t){const{providerExtUri:h}=this.getExtUri(o);if(h.isEqualOrParent(a,r))throw new Error(v.localize(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:d}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:r}=this.getExtUri(o);for(;!r.isEqual(a,r.dirname(a));)try{if(((await o.stat(a)).type&S.FileType.Directory)==0)throw new Error(v.localize(18,null,this.resourceForError(a)));break}catch(s){if(S.toFileSystemProviderErrorCode(s)!==S.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(r.basename(a)),a=r.dirname(a)}for(let s=t.length-1;s>=0;s--){a=r.joinPath(a,t[s]);try{await o.mkdir(a)}catch(c){if(S.toFileSystemProviderErrorCode(c)!==S.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(a==null?void 0:a.useTrash)&&!(t.capabilities&4096))throw new Error(v.localize(19,null,this.resourceForError(o)));let s;try{s=await t.stat(o)}catch(d){}if(s)this.throwIfFileIsReadonly(o,s);else throw new S.FileOperationError(v.localize(20,null,this.resourceForError(o)),1);if(!!!(a==null?void 0:a.recursive)){const d=await this.resolve(o);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error(v.localize(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),r=!!(a==null?void 0:a.useTrash),s=!!(a==null?void 0:a.recursive);await t.delete(o,{recursive:s,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(o,1))}watch(o,a={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(o,a).then(s=>{t?A.dispose(s):r=()=>A.dispose(s)},s=>this.logService.error(s)),A.toDisposable(()=>r())}async doWatch(o,a){const t=await this.withProvider(o),r=this.toWatchKey(t,o,a),s=this.activeWatchers.get(r)||{count:0,disposable:t.watch(o,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,s),s.count+=1,A.toDisposable(()=>{s.count--,s.count===0&&(A.dispose(s.disposable),this.activeWatchers.delete(r))})}toWatchKey(o,a,t){const{providerExtUri:r}=this.getExtUri(o);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>A.dispose(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const c=await o.open(a,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{k.isReadableStream(r)||k.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(o,c,r):await this.doWriteReadableBufferedQueued(o,c,r)}catch(d){throw S.ensureFileSystemProviderError(d)}finally{await o.close(c)}})}async doWriteStreamBufferedQueued(o,a,t){let r=0,s;if(k.isReadableBufferedStream(t)){if(t.buffer.length>0){const c=I.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,c,c.byteLength,r,0),r+=c.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(c,d)=>{k.listenStream(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(o,a,f,f.byteLength,r,0)}catch(h){return d(h)}r+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>d(f),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(o,a,t){let r=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,a,s,s.byteLength,r,0),r+=s.byteLength}async doWriteBuffer(o,a,t,r,s,c){let d=0;for(;d<r;)d+=await o.write(a,s+d,t.buffer,c+d,r-d)}async doWriteUnbuffered(o,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,r))}async doWriteUnbufferedQueued(o,a,t,r){var s;let c;r instanceof I.VSBuffer?c=r:k.isReadableStream(r)?c=await I.streamToBuffer(r):k.isReadableBufferedStream(r)?c=await I.bufferedStreamToBuffer(r):c=I.readableToBuffer(r),await o.writeFile(a,c.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,r))}async doPipeBufferedQueued(o,a,t,r){let s,c;try{s=await o.open(a,{create:!1}),c=await t.open(r,{create:!0,unlock:!1});const d=I.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,h=0,M=0;do M=await o.read(s,f,d.buffer,h,d.byteLength-h),await this.doWriteBuffer(t,c,d,M,f,h),f+=M,h+=M,h===d.byteLength&&(h=0);while(M>0)}catch(d){throw S.ensureFileSystemProviderError(d)}finally{await p.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,r))}async doPipeUnbufferedQueued(o,a,t,r){return t.writeFile(r,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,r))}async doPipeUnbufferedToBufferedQueued(o,a,t,r){const s=await t.open(r,{create:!0,unlock:!1});try{const c=await o.readFile(a);await this.doWriteBuffer(t,s,I.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw S.ensureFileSystemProviderError(c)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,a,t,r){const s=await I.streamToBuffer(this.readFileBuffered(o,a,g.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,s)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new S.FileOperationError(v.localize(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){var t;if(((t=a.permissions)!==null&&t!==void 0?t:0)&S.FilePermission.Readonly)throw new S.FileOperationError(v.localize(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===m.Schemas.file?o.fsPath:o.toString(!0)}};l=he([te(0,i.ILogService)],l),e.FileService=l}),define(J[183],x([0,1,2,21,5,3,16,8,15,30,9,6,142,92,164,166,163,173,64,95,35,20]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends v.Disposable{constructor(s,c){var d;super();this.logService=s,this.options=c,this.BUFFER_SIZE=((d=this.options)===null||d===void 0?void 0:d.bufferSize)||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,S.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:c,symbolicLink:d}=await E.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(c,d),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size}}catch(c){throw this.toFileSystemProviderError(c)}}async readdir(s){try{const c=await E.readdir(this.toFilePath(s),{withFileTypes:!0}),d=[];return await Promise.all(c.map(async f=>{try{let h;f.isSymbolicLink()?h=(await this.stat(w.joinPath(s,f.name))).type:h=this.toType(f),d.push([f.name,h])}catch(h){this.logService.trace(h)}})),d}catch(c){throw this.toFileSystemProviderError(c)}}toType(s,c){let d;return(c==null?void 0:c.dangling)?d=L.FileType.Unknown:s.isFile()?d=L.FileType.File:s.isDirectory()?d=L.FileType.Directory:d=L.FileType.Unknown,c&&(d|=L.FileType.SymbolicLink),d}async readFile(s){try{const c=this.toFilePath(s);return await E.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}}readFileStream(s,c,d){const f=l.newWriteableStream(h=>a.VSBuffer.concat(h.map(M=>a.VSBuffer.wrap(M))).buffer);return u.readFileIntoStream(this,s,f,h=>h.buffer,Object.assign(Object.assign({},c),{bufferSize:this.BUFFER_SIZE}),d),f}async writeFile(s,c,d){let f;try{const h=this.toFilePath(s);if(!d.create||!d.overwrite){if(await E.exists(h)){if(!d.overwrite)throw L.createFileSystemProviderError(k.localize(0,null),L.FileSystemProviderErrorCode.FileExists)}else if(!d.create)throw L.createFileSystemProviderError(k.localize(1,null),L.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(s,{create:!0,unlock:d.unlock}),await this.write(f,0,c,0,c.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof f=="number"&&await this.close(f)}}async open(s,c){try{const d=this.toFilePath(s);if(L.isFileOpenForWriteOptions(c)&&c.unlock)try{const{stat:M}=await E.SymlinkSupport.stat(d);M.mode&128||await E.Promises.chmod(d,M.mode|128)}catch(M){this.logService.trace(M)}let f;if(L.isFileOpenForWriteOptions(c)){if(S.isWindows)try{await E.Promises.truncate(d,0),f="r+"}catch(M){M.code!=="ENOENT"&&this.logService.trace(M)}f||(f="w")}else f="r";const h=await E.Promises.open(d,f);return this.mapHandleToPos.set(h,0),L.isFileOpenForWriteOptions(c)&&this.writeHandles.set(h,s),h}catch(d){throw L.isFileOpenForWriteOptions(c)?await this.toFileSystemProviderWriteError(s,d):this.toFileSystemProviderError(d)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await E.Promises.fdatasync(s)}catch(c){this.canFlush=!1,this.logService.error(c)}return await E.Promises.close(s)}catch(c){throw this.toFileSystemProviderError(c)}}async read(s,c,d,f,h){const M=this.normalizePos(s,c);let T=null;try{const U=await E.Promises.read(s,d,f,h,M);return typeof U=="number"?T=U:T=U.bytesRead,T}catch(U){throw this.toFileSystemProviderError(U)}finally{this.updatePos(s,M,T)}}normalizePos(s,c){return c===this.mapHandleToPos.get(s)?null:c}updatePos(s,c,d){const f=this.mapHandleToPos.get(s);typeof f=="number"&&(typeof c=="number"||(typeof d=="number"?this.mapHandleToPos.set(s,f+d):this.mapHandleToPos.delete(s)))}async write(s,c,d,f,h){return i.retry(()=>this.doWrite(s,c,d,f,h),100,3)}async doWrite(s,c,d,f,h){const M=this.normalizePos(s,c);let T=null;try{const U=await E.Promises.write(s,d,f,h,M);return typeof U=="number"?T=U:T=U.bytesWritten,T}catch(U){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),U)}finally{this.updatePos(s,M,T)}}async mkdir(s){try{await E.Promises.mkdir(this.toFilePath(s))}catch(c){throw this.toFileSystemProviderError(c)}}async delete(s,c){try{const d=this.toFilePath(s);await this.doDelete(d,c)}catch(d){throw this.toFileSystemProviderError(d)}}async doDelete(s,c){c.recursive?await E.rimraf(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}async rename(s,c,d){const f=this.toFilePath(s),h=this.toFilePath(c);if(f!==h)try{await this.validateTargetDeleted(s,c,"move",d.overwrite),await E.move(f,h)}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error(k.localize(2,null,n.basename(f),n.basename(n.dirname(h)),M.toString()))),this.toFileSystemProviderError(M)}}async copy(s,c,d){const f=this.toFilePath(s),h=this.toFilePath(c);if(f!==h)try{await this.validateTargetDeleted(s,c,"copy",d.overwrite),await E.copy(f,h,{preserveSymlinks:!0})}catch(M){throw(M.code==="EINVAL"||M.code==="EBUSY"||M.code==="ENAMETOOLONG")&&(M=new Error(k.localize(3,null,n.basename(f),n.basename(n.dirname(h)),M.toString()))),this.toFileSystemProviderError(M)}}async validateTargetDeleted(s,c,d,f){const h=this.toFilePath(s),M=this.toFilePath(c);let T=!1;if(!!(this.capabilities&1024)||(T=y.isEqual(h,M,!0)),T&&d==="copy")throw L.createFileSystemProviderError(k.localize(4,null),L.FileSystemProviderErrorCode.FileExists);if(!T&&await E.exists(M)){if(!f)throw L.createFileSystemProviderError(k.localize(5,null),L.FileSystemProviderErrorCode.FileExists);await this.delete(c,{recursive:!0,useTrash:!1})}}watch(s,c){return c.recursive?this.watchRecursive(s,c.excludes):this.watchNonRecursive(s)}watchRecursive(s,c){const d={path:this.toFilePath(s),excludes:c},f=o.insert(this.recursiveFoldersToWatch,d);return this.refreshRecursiveWatchers(),v.toDisposable(()=>{f(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var s,c,d;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let f,h;((c=(s=this.options)===null||s===void 0?void 0:s.watcher)===null||c===void 0?void 0:c.usePolling)?(f=g.FileWatcher,h=(d=this.options)===null||d===void 0?void 0:d.watcher):this.recursiveFoldersToWatch.length===1?S.isWindows?f=m.FileWatcher:f=g.FileWatcher:f=D.FileWatcher,this.recursiveWatcher=new f(this.recursiveFoldersToWatch,M=>this._onDidChangeFile.fire(p.toFileChanges(M)),M=>{M.type==="error"&&this._onDidWatchErrorOccur.fire(M.message),this.logService[M.type](M.message)},this.logService.getLevel()===I.LogLevel.Trace,h),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))}}watchNonRecursive(s){const c=new b.FileWatcher(this.toFilePath(s),f=>this._onDidChangeFile.fire(p.toFileChanges(f)),f=>{f.type==="error"&&this._onDidWatchErrorOccur.fire(f.message),this.logService[f.type](f.message)},this.logService.getLevel()===I.LogLevel.Trace),d=this.logService.onDidChangeLogLevel(()=>{c.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return v.combinedDisposable(c,d)}toFilePath(s){return n.normalize(s.fsPath)}toFileSystemProviderError(s){if(s instanceof L.FileSystemProviderError)return s;let c;switch(s.code){case"ENOENT":c=L.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=L.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=L.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=L.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=L.FileSystemProviderErrorCode.NoPermissions;break;default:c=L.FileSystemProviderErrorCode.Unknown}return L.createFileSystemProviderError(s,c)}async toFileSystemProviderWriteError(s,c){let d=this.toFileSystemProviderError(c);if(s&&d.code===L.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await E.SymlinkSupport.stat(this.toFilePath(s));f.mode&128||(d=L.createFileSystemProviderError(c,L.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.logService.trace(f)}return d}dispose(){super.dispose(),v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,v.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(J[22],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(J[184],x([0,1,58,6,22]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,w){this.productService=n,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const y=/^(.*)#([^#]+)$/.exec(w);if(!y)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,i,I]=y;let k=this.trustedExtensionUrlPublicKeys.get(n);if(!k){if(k=this.productService.trustedExtensionUrlPublicKeys[n],!k||k.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...k])}const p=Buffer.from(decodeURIComponent(I),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const g=p.slice(0,6),m=p.readUIntBE(0,6),D=Date.now()-m;if(D<0||D>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const b=p.slice(6),l=v.createVerify("SHA256");l.write(g),l.write(Buffer.from(i)),l.end();for(let u=0;u<k.length;u++){let o=k[u];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),k[u]=o}catch(a){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${n}:`,a),k[u]=null;continue}if(l.verify(o,b))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};S=he([te(0,A.IProductService),te(1,L.ILogService)],S),e.ExtensionUrlTrustService=S}),define(J[55],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=v.createDecorator("protocolMainService")}),define(J[185],x([0,1,2,10,7,53,14,6,36,3,15,27]),function($,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let k=class extends v.Disposable{constructor(g,m){super();this.logService=m,this.validRoots=w.TernarySearchTree.forUris(()=>!y.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(A.URI.file(g.appRoot)),this.addValidFileRoot(A.URI.file(g.extensionsPath)),this.addValidFileRoot(g.globalStorageHome),this.addValidFileRoot(g.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:g}=E.session;g.protocol.registerFileProtocol(L.Schemas.vscodeFileResource,(m,D)=>this.handleResourceRequest(m,D)),g.protocol.interceptFileProtocol(L.Schemas.file,(m,D)=>this.handleFileRequest(m,D)),this._register(v.toDisposable(()=>{g.protocol.unregisterProtocol(L.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(L.Schemas.file)}))}addValidFileRoot(g){return this.validRoots.get(g)?v.Disposable.None:(this.validRoots.set(g,!0),v.toDisposable(()=>this.validRoots.delete(g)))}handleFileRequest(g,m){const D=A.URI.parse(g.url);return y.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3})):this.validRoots.findSubstr(D)?m({path:D.fsPath}):this.validExtensions.has(i.extname(D))?m({path:D.fsPath}):(this.logService.error(`${L.Schemas.file}: Refused to load resource ${D.fsPath} from ${L.Schemas.file}: protocol (original URL: ${g.url})`),m({error:-3}))}handleResourceRequest(g,m){const D=A.URI.parse(g.url),b=L.FileAccess.asFileUri(D);return this.validRoots.findSubstr(b)?m({path:b.fsPath}):this.validExtensions.has(i.extname(b))?m({path:b.fsPath}):(this.logService.error(`${L.Schemas.vscodeFileResource}: Refused to load resource ${b.fsPath} from ${L.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),m({error:-3}))}createIPCObjectUrl(){let g;const m=A.URI.from({scheme:"vscode",path:I.generateUuid()}),D=m.toString(),b=async()=>g;return E.ipcMain.handle(D,b),this.logService.trace(`IPC Object URL: Registered new channel ${D}.`),{resource:m,update:l=>g=l,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${D}.`),E.ipcMain.removeHandler(D)}}}};k=he([te(0,S.INativeEnvironmentService),te(1,n.ILogService)],k),e.ProtocolMainService=k}),define(J[37],x([0,1,13,102]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(E,n){L.ok(v.isString(E)),L.ok(v.isObject(n)),L.ok(!this.data.has(E),"There is already an extension with this id"),this.data.set(E,n)}knows(E){return this.data.has(E)}as(E){return this.data.get(E)||null}}e.Registry=new A}),define(J[186],x([0,1,37,5]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,y){this.schemasById[A(w)]=y,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const E=new S;v.Registry.add(e.Extensions.JSONContribution,E)}),define(J[48],x([0,1,132,5,37,13,186]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=A.Registry.as(E.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const u=[];b.forEach(o=>{u.push(...this.validateAndRegisterProperties(o,l,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const l=[],u=o=>{if(o.properties)for(const a in o.properties)l.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,o.properties[a]);o.allOf&&o.allOf.forEach(a=>u(a))};for(const o of b){u(o);const a=this.configurationContributors.indexOf(o);a!==-1&&this.configurationContributors.splice(a,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}registerDefaultConfigurations(b){const l=[],u=[];for(const o of b)for(const a in o)if(l.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),o[a]);const t={type:"object",default:this.defaultValues[a],description:v.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=o[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(b){const l=[];for(const u of b)for(const o in u)if(l.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const a=this.configurationProperties[o];a&&(this.updatePropertyDefaultValue(o,a),this.updateSchema(o,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,l=!0,u,o=3){var a;o=S.isUndefinedOrNull(b.scope)?o:b.scope;let t=[],r=b.properties;if(r)for(let c in r){if(l&&g(c)){delete r[c];continue}const d=r[c];if(this.updatePropertyDefaultValue(c,d),e.OVERRIDE_PROPERTY_PATTERN.test(c)?d.scope=void 0:(d.scope=S.isUndefinedOrNull(d.scope)?o:d.scope,d.restricted=S.isUndefinedOrNull(d.restricted)?!!((a=u==null?void 0:u.restrictedConfigurations)===null||a===void 0?void 0:a.includes(c)):d.restricted),r[c].hasOwnProperty("included")&&!r[c].included){this.excludedConfigurationProperties[c]=r[c],delete r[c];continue}else this.configurationProperties[c]=r[c];!r[c].deprecationMessage&&r[c].markdownDeprecationMessage&&(r[c].deprecationMessage=r[c].markdownDeprecationMessage),t.push(c)}let s=b.allOf;if(s)for(let c of s)t.push(...this.validateAndRegisterProperties(c,l,u,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const l=u=>{let o=u.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let a=u.allOf;a&&a.forEach(l)};l(b)}updateSchema(b,l){switch(e.allSettings.properties[b]=l,l.scope){case 1:e.applicationSettings.properties[b]=l;break;case 2:e.machineSettings.properties[b]=l;break;case 6:e.machineOverridableSettings.properties[b]=l;break;case 3:e.windowSettings.properties[b]=l;break;case 4:e.resourceSettings.properties[b]=l;break;case 5:e.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete e.allSettings.properties[b],l.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,u),e.allSettings.properties[l]=u,e.applicationSettings.properties[l]=u,e.machineSettings.properties[l]=u,e.machineOverridableSettings.properties[l]=u,e.windowSettings.properties[l]=u,e.resourceSettings.properties[l]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){let u=this.defaultValues[b];S.isUndefined(u)&&(u=l.default),S.isUndefined(u)&&(u=k(l.type)),l.default=u}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=I;function k(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=k;const p=new y;A.Registry.add(e.Extensions.Configuration,p);function g(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?v.localize(5,null,D):p.getConfigurationProperties()[D]!==void 0?v.localize(6,null,D):null:v.localize(4,null)}e.validateProperty=g;function m(){const D=[],b=p.getConfigurationProperties();for(const l of Object.keys(b))D.push([l,b[l].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=m}),define(J[17],x([0,1,44,13,7,37,4,48]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=E.createDecorator("configurationService");function w(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof A.URI)}e.isConfigurationOverrides=w;var y;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(r,s){const c=s?r?s.keys.filter(H=>r.keys.indexOf(H)===-1):[...s.keys]:[],d=r?s?r.keys.filter(H=>s.keys.indexOf(H)===-1):[...r.keys]:[],f=[];if(s&&r){for(const H of r.keys)if(s.keys.indexOf(H)!==-1){const X=b(r.contents,H),ee=b(s.contents,H);v.equals(X,ee)||f.push(H)}}const h=[],M=H=>{const X={};for(const ee of H)for(const B of ee.identifiers)X[a(B)]=ee;return X},T=s?M(s.overrides):{},U=r?M(r.overrides):{};if(Object.keys(T).length)for(const H of c){const X=T[H];X&&h.push([n.overrideIdentifierFromKey(H),X.keys])}if(Object.keys(U).length)for(const H of d){const X=U[H];X&&h.push([n.overrideIdentifierFromKey(H),X.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const H of f){const X=U[H],ee=T[H];if(X&&ee){const B=I({contents:X.contents,keys:X.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});h.push([n.overrideIdentifierFromKey(H),[...B.added,...B.removed,...B.updated]])}}return{added:c,removed:d,updated:f,overrides:h}}e.compare=I;function k(r,s){const c=[];for(const d of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(d)){const f={};for(const h in r[d])f[h]=r[d][h];c.push({identifiers:[n.overrideIdentifierFromKey(d).trim()],keys:Object.keys(f),contents:p(f,s)})}return c}e.toOverrides=k;function p(r,s){const c=Object.create(null);for(let d in r)g(c,d,r[d],s);return c}e.toValuesTree=p;function g(r,s,c,d){const f=s.split("."),h=f.pop();let M=r;for(let T=0;T<f.length;T++){let U=f[T],H=M[U];switch(typeof H){case"undefined":H=M[U]=Object.create(null);break;case"object":break;default:d(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(H)}`);return}M=H}if(typeof M=="object"&&M!==null)try{M[h]=c}catch(T){d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(M)}`)}else d(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(M)}`)}e.addToValueTree=g;function m(r,s){const c=s.split(".");D(r,c)}e.removeFromValueTree=m;function D(r,s){const c=s.shift();if(s.length===0){delete r[c];return}if(Object.keys(r).indexOf(c)!==-1){const d=r[c];typeof d=="object"&&!Array.isArray(d)&&(D(d,s),Object.keys(d).length===0&&delete r[c])}}function b(r,s,c){function d(M,T){let U=M;for(const H of T){if(typeof U!="object"||U===null)return;U=U[H]}return U}const f=s.split("."),h=d(r,f);return typeof h=="undefined"?c:h}e.getConfigurationValue=b;function l(r,s,c){Object.keys(s).forEach(d=>{d!=="__proto__"&&(d in r?L.isObject(r[d])&&L.isObject(s[d])?l(r[d],s[d],c):c&&(r[d]=s[d]):r[d]=s[d])})}e.merge=l;function u(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function o(){const r=Object.create(null),s=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let c in s){let d=s[c].default;g(r,c,d,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=o;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,s,c){const d=r.inspect(s),f=r.inspect(c);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=t}),define(J[187],x([0,1,43,36,35,13,44,7,48,17,37,2,5]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?y.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?y.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const c of A.distinct([...Object.keys(this.contents),...Object.keys(r)])){let d=this.contents[c],f=r[c];f&&(typeof d=="object"&&typeof f=="object"?(d=E.deepClone(d),this.mergeContents(d,f)):d=f),s[c]=d}return new p(s,this.keys,this.overrides)}merge(...t){const r=E.deepClone(this.contents),s=E.deepClone(this.overrides),c=[...this.keys];for(const d of t){this.mergeContents(r,d.contents);for(const f of d.overrides){const[h]=s.filter(M=>A.equals(M.identifiers,f.identifiers));h?this.mergeContents(h.contents,f.contents):s.push(E.deepClone(f))}for(const f of d.keys)c.indexOf(f)===-1&&c.push(f)}return new p(r,c,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&S.isObject(t[s])&&S.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=E.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?E.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),y.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&y.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=p;class g extends p{constructor(){const t=y.getDefaultValues(),r=y.getConfigurationKeys(),s=[];for(const c of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(c)&&s.push({identifiers:[w.overrideIdentifierFromKey(c).trim()],keys:Object.keys(t[c]),contents:y.toValuesTree(t[c],d=>console.error(`Conflict in default settings file: ${d}`))});super(t,r,s)}}e.DefaultConfigurationModel=g;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:c,overrides:d,restricted:f}=this.doParseRaw(t,r);this._configurationModel=new p(s,c,d),this._restrictedConfigurations=f||[]}doParseContent(t){let r={},s=null,c=[],d=[],f=[];function h(T){Array.isArray(c)?c.push(T):s&&(c[s]=T)}let M={onObjectBegin:()=>{let T={};h(T),d.push(c),c=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{c=d.pop()},onArrayBegin:()=>{let T=[];h(T),d.push(c),c=T,s=null},onArrayEnd:()=>{c=d.pop()},onLiteralValue:h,onError:(T,U,H)=>{f.push({error:T,offset:U,length:H})}};if(t)try{v.visit(t,M),r=c[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return r}doParseRaw(t,r){const s=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),c=this.filter(t,s,!0,r);t=c.raw;const d=y.toValuesTree(t,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),f=Object.keys(t),h=y.toOverrides(t,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:d,keys:f,overrides:h,restricted:c.restricted}}filter(t,r,s,c){if(!(c==null?void 0:c.scopes)&&!(c==null?void 0:c.skipRestricted))return{raw:t,restricted:[]};const d={},f=[];for(let h in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(h)&&s){const M=this.filter(t[h],r,!1,c);d[h]=M.raw,f.push(...M.restricted)}else{const M=r[h],T=M?typeof M.scope!="undefined"?M.scope:3:void 0;(M==null?void 0:M.restricted)&&f.push(h),(T===void 0||c.scopes===void 0||c.scopes.includes(T))&&(c.skipRestricted&&(M==null?void 0:M.restricted)||(d[h]=t[h]))}return{raw:d,restricted:f}}}e.ConfigurationModelParser=m;class D extends I.Disposable{constructor(t,r,s,c){super();this.userSettingsResource=t,this.scopes=r,this.fileService=c,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.filter(this.fileService.onDidFilesChange,d=>d.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,s=new p,c=new p,d=new L.ResourceMap,f=new p,h=new L.ResourceMap,M=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=d,this._memoryConfiguration=f,this._memoryConfigurationByResource=h,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new p,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,r===void 0?c.removeValue(t):c.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const c=this.getConsolidateConfigurationModel(r,s),d=this.getFolderConfigurationModelForResource(r.resource,s),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),M=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=d?r.overrideIdentifier?d.freeze().override(r.overrideIdentifier).getValue(t):d.freeze().getValue(t):void 0,ee=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),B=c.getValue(t),Y=A.distinct(A.flatten(c.overrides.map(Q=>Q.identifiers))).filter(Q=>c.getOverrideValue(t,Q)!==void 0);return{defaultValue:h,userValue:M,userLocalValue:T,userRemoteValue:U,workspaceValue:H,workspaceFolderValue:X,memoryValue:ee,value:B,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:d==null?void 0:d.freeze().getValue(t),override:r.overrideIdentifier?d==null?void 0:d.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(c=>w.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const d=w.overrideIdentifierFromKey(c),f=this._defaultConfiguration.getKeysForOverrideIdentifier(d),h=t.getKeysForOverrideIdentifier(d),M=[...h.filter(T=>f.indexOf(T)===-1),...f.filter(T=>h.indexOf(T)===-1),...f.filter(T=>!E.equals(this._defaultConfiguration.override(d).getValue(T),t.override(d).getValue(T)))];return[d,M]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:c,overrides:d}=y.compare(this.localUserConfiguration,t),f=[...r,...s,...c];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:c,overrides:d}=y.compare(this.remoteUserConfiguration,t);let f=[...r,...s,...c];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:d}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:c,overrides:d}=y.compare(this.workspaceConfiguration,t);let f=[...r,...s,...c];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:d}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:c,updated:d,removed:f,overrides:h}=y.compare(s,r);let M=[...c,...d,...f];return(M.length||!s)&&this.updateFolderConfiguration(t,r),{keys:M,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:c,removed:d,overrides:f}=y.compare(r,void 0);return{keys:[...s,...c,...d],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const c=r.getFolder(t);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const d=this._memoryConfigurationByResource.get(t);d&&(s=s.merge(d))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(r=s.merge(c),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:c,keys:d}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:c,keys:d}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(c=>r.add(c))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),d=t.folders.reduce((f,h)=>(f.set(n.URI.revive(h[0]),this.parseConfigurationModel(h[1])),f),new L.ResourceMap);return new b(r,s,new p,c,d,new p,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new p(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function l(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const c of a)c.keys.forEach(d=>t.add(d)),c.overrides.forEach(([d,f])=>{const h=L.getOrSet(r,d,new Set);f.forEach(M=>h.add(M))});const s=[];return r.forEach((c,d)=>s.push([d,[...c.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=l;class u{constructor(t,r,s,c){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const d=new Set;t.keys.forEach(h=>d.add(h)),t.overrides.forEach(([,h])=>h.forEach(M=>d.add(M))),this.affectedKeys=[...d.values()];const f=new p;this.affectedKeys.forEach(h=>f.setValue(h,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,d=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!E.equals(c,d)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=y.toValuesTree({[r]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(t=t[c],!t)return!1;s=s[c]}return!0}}e.ConfigurationChangeEvent=u;class o extends u{constructor(t,r,s,c){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=o}),define(J[188],x([0,1,37,48,2,17,187,5,9,15]),function($,e,v,L,A,S,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends A.Disposable{constructor(k,p){super();this.settingsResource=k,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new E.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,p)),this.configuration=new E.Configuration(new E.DefaultConfigurationModel,new E.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(g=>this.onDidDefaultConfigurationChange(g))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const k=await this.userConfiguration.loadConfiguration();this.configuration=new E.Configuration(new E.DefaultConfigurationModel,k)}getConfigurationData(){return this.configuration.toData()}getValue(k,p){const g=typeof k=="string"?k:void 0,m=S.isConfigurationOverrides(k)?k:S.isConfigurationOverrides(p)?p:{};return this.configuration.getValue(g,m,void 0)}updateValue(k,p,g,m){return Promise.reject(new Error("not supported"))}inspect(k){return this.configuration.inspect(k,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const k=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(k)}onDidChangeUserConfiguration(k){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateLocalUserConfiguration(k);this.trigger(g,p,1)}onDidDefaultConfigurationChange(k){const p=this.configuration.toData(),g=this.configuration.compareAndUpdateDefaultConfiguration(new E.DefaultConfigurationModel,k);this.trigger(g,p,6)}trigger(k,p,g){const m=new E.ConfigurationChangeEvent(k,{data:p},this.configuration);m.source=g,m.sourceConfig=this.getTargetConfiguration(g),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(k){switch(k){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(J[189],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class A extends Error{constructor(E,n=L.Unknown,w){super(E);this._message=E,this._code=n,this._detail=w,this.isHandled=n===L.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype)}static isTemporarilyNotAvailable(E){return E instanceof A&&E._code===L.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof A&&E._code===L.NoResolverFound}static isHandled(E){return E instanceof A&&E.isHandled}}e.RemoteAuthorityResolverError=A}),define(J[190],x([0,1,84,27,2,20,5,189,19,9,25]),function($,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var k;(function(P){P[P.Management=1]="Management",P[P.ExtensionHost=2]="ExtensionHost",P[P.Tunnel=3]="Tunnel"})(k=e.ConnectionType||(e.ConnectionType={}));function p(P){switch(P){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(P){const W=new i.CancellationTokenSource;return setTimeout(()=>W.cancel(),P),W.token}function m(P,W){if(P.isCancellationRequested||W.isCancellationRequested)return i.CancellationToken.Cancelled;const _=new i.CancellationTokenSource;return P.onCancellationRequested(()=>_.cancel()),W.onCancellationRequested(()=>_.cancel()),_.token}class D{constructor(W){this._state="pending",this._disposables=new A.DisposableStore,this.promise=new Promise((_,q)=>{this._resolvePromise=_,this._rejectPromise=q}),W.isCancellationRequested?this._timeout():this._disposables.add(W.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(W){this._state==="pending"?this._disposables.add(W):W.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(W))}reject(W){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(W))}}function b(P,W){const _=new D(W);return _.registerDisposable(P.onControlMessage(q=>{const V=JSON.parse(q.toString()),K=z(V);K?_.reject(K):_.resolve(V)})),_.promise}function l(P,W,_,q,V,K){const Z=new D(K);return W.connect(_,q,V,(ne,re)=>{Z.didTimeout?(ne&&P.error(ne),re==null||re.dispose()):ne||!re?Z.reject(ne):Z.resolve(re)}),Z.promise}function u(P,W){const _=new D(W);return P.then(q=>{_.didTimeout||_.resolve(q)},q=>{_.didTimeout||_.reject(q)}),_.promise}async function o(P,W,_,q){const V=R(P,W);P.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let K;try{K=await l(P.logService,P.socketFactory,P.host,P.port,`reconnectionToken=${P.reconnectionToken}&reconnection=${P.reconnectionProtocol?"true":"false"}`,q)}catch(se){throw P.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),P.logService.error(se),se}P.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let Z,ne;P.reconnectionProtocol?(P.reconnectionProtocol.beginAcceptReconnection(K,null),Z=P.reconnectionProtocol,ne=!1):(Z=new v.PersistentProtocol(K,null),ne=!0),P.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:P.connectionToken||"00000000000000000000"};Z.sendControl(S.VSBuffer.fromString(JSON.stringify(re)));try{const se=await b(Z,m(q,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}P.logService.trace(`${V} 4/6. received SignRequest control message.`);const le=await u(P.signService.sign(se.data),q),oe={type:"connectionType",commit:P.commit,signedData:le,desiredConnectionType:W};return _&&(oe.args=_),P.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(S.VSBuffer.fromString(JSON.stringify(oe))),{protocol:Z,ownsProtocol:ne}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(P.logService.error(`${V} the handshake timed out. Error:`),P.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(P.logService.error(`${V} received error control message when negotiating connection. Error:`),P.logService.error(se)),ne&&G(Z),se}}async function a(P,W,_,q){const V=Date.now(),K=R(P,W),{protocol:Z,ownsProtocol:ne}=await o(P,W,_,q),re=new D(q);return re.registerDisposable(Z.onControlMessage(se=>{const le=JSON.parse(se.toString()),oe=z(le);oe?(P.logService.error(`${K} received error control message when negotiating connection. Error:`),P.logService.error(oe),ne&&G(Z),re.reject(oe)):(P.reconnectionProtocol&&P.reconnectionProtocol.endAcceptReconnection(),P.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${O(V)}!`),re.resolve({protocol:Z,firstMessage:le}))})),re.promise}async function t(P,W){const{protocol:_}=await a(P,1,void 0,W);return{protocol:_}}async function r(P,W,_){const{protocol:q,firstMessage:V}=await a(P,2,W,_),K=V&&V.debugPort;return{protocol:q,debugPort:K}}async function s(P,W,_){const q=Date.now(),V=R(P,3),{protocol:K}=await o(P,3,W,_);return P.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${O(q)}!`),K}async function c(P,W,_){const{host:q,port:V,connectionToken:K}=await P.addressProvider.getAddress();return{commit:P.commit,host:q,port:V,connectionToken:K,reconnectionToken:W,reconnectionProtocol:_,socketFactory:P.socketFactory,signService:P.signService,logService:P.logService}}async function d(P,W,_){try{const q=L.generateUuid(),V=await c(P,q,null),{protocol:K}=await t(V,i.CancellationToken.None);return new Q(P,W,_,q,K)}catch(q){throw P.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),P.logService.error(q),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=d;async function f(P,W){try{const _=L.generateUuid(),q=await c(P,_,null),{protocol:V,debugPort:K}=await r(q,W,i.CancellationToken.None);return new N(P,W,_,V,K)}catch(_){throw P.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),P.logService.error(_),Y.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=f;async function h(P,W){const _=await c(P,L.generateUuid(),null);return await s(_,{port:W},i.CancellationToken.None)}e.connectRemoteAgentTunnel=h;function M(P){return y.createCancelablePromise(W=>new Promise((_,q)=>{const V=setTimeout(_,P*1e3);W.onCancellationRequested(()=>{clearTimeout(V),_()})}))}var T;(function(P){P[P.ConnectionLost=0]="ConnectionLost",P[P.ReconnectionWait=1]="ReconnectionWait",P[P.ReconnectionRunning=2]="ReconnectionRunning",P[P.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",P[P.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(W,_){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=U;class H{constructor(W,_,q,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.durationSeconds=q,this.cancellableTimer=V,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class X{constructor(W,_,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=X;class ee{constructor(W,_,q){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=4}}e.ConnectionGainEvent=ee;class B{constructor(W,_,q,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=_,this.attempt=q,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends A.Disposable{constructor(W,_,q,V){super();this._connectionType=W,this._onDidStateChange=this._register(new E.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=q,this.protocol=V,this._isReconnecting=!1,this._onDidStateChange.fire(new ee(this.reconnectionToken,0,0)),this._register(V.onSocketClose(()=>this._beginReconnecting())),this._register(V.onSocketTimeout(()=>this._beginReconnecting())),Y._instances.push(this),Y._permanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}static triggerPermanentFailure(W,_,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=W,this._permanentFailureAttempt=_,this._permanentFailureHandled=q,this._instances.forEach(V=>V._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(Y._permanentFailure)return;const W=F(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30],q=Date.now();let V=-1;do{V++;const K=V<_.length?_[V]:_[_.length-1];try{if(K>0){const ne=M(K);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),K,ne)),this._options.logService.info(`${W} waiting for ${K} seconds before reconnecting...`);try{await ne}catch(re){}}if(Y._permanentFailure){this._options.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this._options.logService.info(`${W} resolving connection...`);const Z=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${W} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,g(I)),this._options.logService.info(`${W} reconnected!`),this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(Date.now()-q>108e5){this._options.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(w.isPromiseCanceledError(Z)){this._options.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,n.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),Y.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!Y._permanentFailure)}_gotoPermanentFailure(W,_,q){this._onDidStateChange.fire(new B(this.reconnectionToken,W,_,q)),G(this.protocol)}}Y._permanentFailure=!1,Y._permanentFailureMillisSinceLastIncomingData=0,Y._permanentFailureAttempt=0,Y._permanentFailureHandled=!1,Y._instances=[];class Q extends Y{constructor(W,_,q,V,K){super(1,W,V,K);this.client=this._register(new v.Client(K,{remoteAuthority:_,clientId:q},W.ipcLogger))}async _reconnect(W,_){await t(W,_)}}e.ManagementPersistentConnection=Q;class N extends Y{constructor(W,_,q,V,K){super(2,W,q,V);this._startArguments=_,this.debugPort=K}async _reconnect(W,_){await r(W,this._startArguments,_)}}e.ExtensionHostPersistentConnection=N;function G(P){try{P.acceptDisconnect();const W=P.getSocket();P.dispose(),W.dispose()}catch(W){w.onUnexpectedError(W)}}function z(P){if(P&&P.type==="error"){const W=new Error(`Connection error: ${P.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function C(P,W){for(;P.length<W;)P+=" ";return P}function F(P,W,_){return`[remote-connection][${C(p(P),13)}][${W.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function R(P,W){return`${F(W,P.reconnectionToken,!!P.reconnectionProtocol)}[${P.host}:${P.port}]`}function O(P){return`${Date.now()-P} ms`}}),define(J[73],x([0,1,10]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(y){return y.scheme===v.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=L;function A(y){if(!y)return;const i=y.indexOf("+");return i<0?y:y.substr(0,i)}e.getRemoteName=A;function S(y){return y.scheme!==v.Schemas.file&&y.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=S;function E(y){if(y.folders.length)return y.folders.every(i=>S(i.uri))?y.folders[0].uri:void 0;if(y.configuration&&S(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=E;function n(y){var i;return(i=E(y))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=n;function w(y){return E(y)!==void 0}e.isVirtualWorkspace=w}),define(J[74],x([0,1,5,3,4,6]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=A.createDecorator("tunnelService");var E;(function(k){k[k.Notify=1]="Notify",k[k.OpenBrowser=2]="OpenBrowser",k[k.OpenPreview=3]="OpenPreview",k[k.Silent=4]="Silent",k[k.Ignore=5]="Ignore"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(k){if(k.scheme!=="http"&&k.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(k.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(k){return e.LOCALHOST_ADDRESSES.indexOf(k)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(k){return e.ALL_INTERFACES_ADDRESSES.indexOf(k)>=0}e.isAllInterfaces=y;function i(k,p){return p?p!==1&&k<1024:!L.isWindows&&k<1024}e.isPortPrivileged=i;let I=class{constructor(p){this.logService=p,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,g){return this._tunnelProvider=p,p?(this._canElevate=g.elevation,this._canMakePublic=g.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async p=>{const g=[],m=Array.from(this._tunnels.values());for(let D of m){const b=Array.from(D.values());for(let l of b){const u=await l.value;u&&g.push(u)}}p(g)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:g}of p.values())await g.then(m=>m==null?void 0:m.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,g,m,D,b=!1,l=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${m} on local port ${D}.`),!p)return;g||(g="localhost");const u=this.retainOrCreateTunnel(p,g,m,D,b,l);return u?u.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.makeTunnel(o);return(o.tunnelRemoteHost!==g||o.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(a),a}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,public:p.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const g=this._tunnels.get(p.tunnelRemoteHost);if(g){const m=g.get(p.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,m))}}}}async tryDisposeTunnel(p,g,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${g}.`);const D=m.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(g),D}}async closeTunnel(p,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${g} `);const m=this._tunnels.get(p);if(m&&m.has(g)){const D=m.get(g);D.refcount=0,await this.tryDisposeTunnel(p,g,D)}}addTunnelToMap(p,g,m){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(g,{refcount:1,value:m})}async removeEmptyTunnelFromMap(p,g){const m=this._tunnels.get(p);m&&(await m.get(g)||m.delete(g),m.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,g){let m=[p];w(p)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):y(p)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const D=m.map(b=>this._tunnels.get(b));for(const b of D){const l=b==null?void 0:b.get(g);if(l)return l}}canTunnel(p){return!!n(p)}createWithProvider(p,g,m,D,b,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${m} on local port ${D}.`);const o={elevationRequired:b?i(D===void 0?m:D):!1},a={remoteAddress:{host:g,port:m},localAddressPort:D,public:l},t=p.forwardPort(a,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(g,m,t),t}};I=he([te(0,S.ILogService)],I),e.AbstractTunnelService=I}),define(J[49],x([0,1,146,4,48,37,20]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=L.createDecorator("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function w(g){return g.res.statusCode===204}async function y(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return w(g)?null:(await E.streamToBuffer(g.stream)).toString()}e.asText=y;async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(w(g))return null;const D=(await E.streamToBuffer(g.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=i;function I(g){p(g)}e.updateProxyConfigurationsScope=I;let k;function p(g){const m=S.Registry.as(A.Extensions.Configuration);k&&m.deregisterConfigurations([k]),k={id:"http",order:15,title:v.localize(0,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null),v.localize(7,null)],default:"override",description:v.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(9,null),restricted:!0}}},m.registerConfiguration(k)}p(2)}),define(J[191],x([0,1,192,13]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function A(E,n){return E.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:E.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(E,n,w={}){const y=v.parse(E),i=w.proxyUrl||A(y,n);if(!i)return null;const I=v.parse(i);if(!/^https?:$/.test(I.protocol||""))return null;const k={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:L.isBoolean(w.strictSSL)?w.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((p,g)=>{$(["http-proxy-agent"],p,g)}))(k):new(await new Promise((p,g)=>{$(["https-proxy-agent"],p,g)}))(k)}e.getProxyAgent=S}),define(J[193],x([0,1,27,20]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function A(S,E,n){let w=n&&n.get("storage.serviceMachineId",0)||null;if(w)return w;try{const i=(await E.readFile(S.serviceMachineIdResource)).value.toString();w=v.isUUID(i)?i:null}catch(y){w=null}if(!w){w=v.generateUuid();try{await E.writeFile(S.serviceMachineIdResource,L.VSBuffer.fromString(w))}catch(y){}}return n&&n.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=A}),define(J[75],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=v.createDecorator(e.SIGN_SERVICE_ID)}),define(J[194],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((A,S)=>$(["vsda"],A,S))}async sign(A){try{const S=await this.vsda(),E=new S.signer;if(E)return E.sign(A)}catch(S){}return A}}e.SignService=v}),define(J[38],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=v.createDecorator("stateMainService")}),define(J[18],x([0,1,14,6,38,5,4,177,3,2,9,13,32]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=E.createDecorator("lifecycleMainService");var p;(function(D){D[D.CLOSE=1]="CLOSE",D[D.QUIT=2]="QUIT",D[D.RELOAD=3]="RELOAD",D[D.LOAD=4]="LOAD"})(p=e.UnloadReason||(e.UnloadReason={}));var g;(function(D){D[D.Starting=1]="Starting",D[D.Ready=2]="Ready",D[D.AfterWindowOpen=3]="AfterWindowOpen"})(g=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class at extends y.Disposable{constructor(b,l){super();this.logService=b,this.stateMainService=l,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(at.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(at.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",b);const l=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",l),v.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",l),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(l){b.push(l)}}),this.pendingWillShutdownPromise=(async()=>{try{await i.Promises.settled(b)}catch(l){this.logService.error(l)}try{await this.stateMainService.close()}catch(l){this.logService.error(l)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const l=this.phaseWhen.get(this._phase);l&&(l.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let l=this.phaseWhen.get(b);l||(l=new i.Barrier,this.phaseWhen.set(b,l)),await l.wait()}registerWindow(b){const l=new y.DisposableStore;this.windowCounter++,l.add(b.onWillLoad(o=>this._onWillLoadWindow.fire({window:b,workspace:o.workspace})));const u=I.assertIsDefined(b.win);u.on("close",o=>{const a=b.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),o.preventDefault(),this.unload(b,1).then(t=>{if(t){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(b),b.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,l.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,l){await this.unload(b,3)||b.reload(l)}async unload(b,l){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const u=this._quitRequested?2:l;let o=await this.onBeforeUnloadWindowInRenderer(b,u);return o?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(o)):(o=await this.onBeforeUnloadWindowInMain(b,u),o?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(o)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,u),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,l){return new Promise(u=>{const o=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${o}`,t=`vscode:cancel${o}`;v.ipcMain.once(a,()=>{u(!1)}),v.ipcMain.once(t,()=>{u(!0)}),b.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:t,reason:l})})}onBeforeUnloadWindowInMain(b,l){const u=[];return this._onBeforeUnloadWindow.fire({reason:l,window:b,veto(o){u.push(o)}}),n.handleVetos(u,o=>this.logService.error(o))}onWillUnloadWindowInRenderer(b,l){return new Promise(u=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(a,()=>u()),b.send("vscode:onWillUnload",{replyChannel:a,reason:l})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(at.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(l=>{this.pendingQuitPromiseResolve=l,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const l=process.argv.slice(1);if((b==null?void 0:b.addArgs)&&l.push(...b.addArgs),b==null?void 0:b.removeArgs)for(const a of b.removeArgs){const t=l.indexOf(a);t>=0&&l.splice(t,1)}const u=()=>{try{if(w.isWindows){const a=k.cwd();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:l})};v.app.once("quit",u),await this.quit(!0)&&v.app.removeListener("quit",u)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([i.timeout(1e3),(async()=>{for(const l of v.BrowserWindow.getAllWindows())if(l&&!l.isDestroyed()){let u;l.webContents&&!l.webContents.isDestroyed()?u=new Promise(o=>l.once("closed",o)):u=Promise.resolve(),l.destroy(),await u}})()]),v.app.exit(b)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=he([te(0,L.ILogService),te(1,A.IStateMainService)],m),e.LifecycleMainService=m}),define(J[195],x([0,1,4,5,2,18]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=v.createDecorator("keyboardLayoutMainService");let E=class extends A.Disposable{constructor(y){super();this._onDidChangeKeyboardLayout=this._register(new L.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,y.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const y=await new Promise((i,I)=>{$(["native-keymap"],i,I)});this._keyboardLayoutData=n(y),y.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(y),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};E=he([te(0,S.ILifecycleMainService)],E),e.KeyboardLayoutMainService=E;function n(w){const y=w.getKeyMap(),i=w.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:i}}}),define(J[96],x([0,1,4,5,2,13,86,9]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var y;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class k extends A.Disposable{constructor(D={flushInterval:k.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=n.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){A.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===w?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.get(D,l)}getBoolean(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getBoolean(D,l)}getNumber(D,b,l){var u;return(u=this.getStorage(b))===null||u===void 0?void 0:u.getNumber(D,l)}store(D,b,l,u){if(S.isUndefinedOrNull(b)){this.remove(D,l);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(D,l,u),(o=this.getStorage(l))===null||o===void 0||o.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{var l;this.updateKeyTarget(D,b,void 0),(l=this.getStorage(b))===null||l===void 0||l.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const l=[],u=this.getKeyTargets(D);for(const o of Object.keys(u))u[o]===b&&l.push(o);return l}updateKeyTarget(D,b,l){var u,o;const a=this.getKeyTargets(b);typeof l=="number"?a[D]!==l&&(a[D]=l,(u=this.getStorage(b))===null||u===void 0||u.set(w,JSON.stringify(a))):typeof a[D]=="number"&&(delete a[D],(o=this.getStorage(b))===null||o===void 0||o.set(w,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(w,D);if(b)try{return JSON.parse(b)}catch(l){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){var D,b,l,u;this._onWillSaveState.fire({reason:y.NONE}),await n.Promises.settled([(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.whenFlushed())!==null&&b!==void 0?b:Promise.resolve(),(u=(l=this.getStorage(1))===null||l===void 0?void 0:l.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var D,b,l,u,o,a;const t=(b=(D=this.getStorage(0))===null||D===void 0?void 0:D.items)!==null&&b!==void 0?b:new Map,r=(u=(l=this.getStorage(1))===null||l===void 0?void 0:l.items)!==null&&u!==void 0?u:new Map;return g(t,r,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(a=this.getLogDetails(1))!==null&&a!==void 0?a:"")}}e.AbstractStorageService=k,k.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends k{constructor(){super();this.globalStorage=new E.Storage(new E.InMemoryStorageDatabase),this.workspaceStorage=new E.Storage(new E.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=p;async function g(m,D,b,l){const u=d=>{try{return JSON.parse(d)}catch(f){return d}},o=new Map,a=new Map;m.forEach((d,f)=>{o.set(f,d),a.set(f,u(d))});const t=new Map,r=new Map;D.forEach((d,f)=>{t.set(f,d),r.set(f,u(d))}),console.group(`Storage: Global (path: ${b})`);let s=[];o.forEach((d,f)=>{s.push({key:f,value:d})}),console.table(s),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${l})`);let c=[];t.forEach((d,f)=>{c.push({key:f,value:d})}),console.table(c),console.groupEnd(),console.log(r)}e.logStorage=g}),define(J[196],x([0,1,3,32,27,7]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function E(y){if(v.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function n(y,i,I,k,p,g,m,D,b,l){const u=Object.create(null);u["common.machineId"]=m,u.sessionID=A.generateUuid()+Date.now(),u.commitHash=p,u.version=g,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=v.PlatformToString(v.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=k,u["common.product"]=l||"desktop";const o=w(D||[]);o&&(u["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const r=E(I);r&&(u["common.platformDetail"]=r);try{const s=await y.readFile(S.URI.file(b));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=n;function w(y){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return y.some(k=>I===k)}e.verifyMicrosoftInternalDomain=w}),define(J[31],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=v.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(J[197],x([0,1,26,66,70,29,8,43,83,22,3,7,31,63,10,21,16]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(t,r){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,d=new Map,f=2e4;function h(U,H,X,ee){const B=H.substring(U.length+1);return new Promise(async Y=>{var Q,N,G;let z;try{z=await D.readdir(H,{withFileTypes:!0})}catch(R){Y();return}if(ee.count>=f){ee.count+=z.length,ee.maxReached=!0,Y();return}let C=z.length;if(C===0){Y();return}let F=z;ee.count+z.length>f&&(ee.maxReached=!0,C=f-ee.count,F=z.slice(0,C)),ee.count+=z.length;for(const R of F)if(R.isDirectory()){if(X.includes(R.name)||await h(U,E.join(H,R.name),X,ee),--C==0){Y();return}}else{const O=R.name.lastIndexOf(".");if(O>=0){const P=R.name.substring(O+1);P&&c.set(P,((Q=c.get(P))!==null&&Q!==void 0?Q:0)+1)}for(const P of s)((N=P.relativePathPattern)===null||N===void 0?void 0:N.test(B))!==!1&&P.filePattern.test(R.name)&&d.set(P.tag,((G=d.get(P.tag))!==null&&G!==void 0?G:0)+1);if(--C==0){Y();return}}})}const M={count:0,maxReached:!1};await h(t,t,r,M);const T=await o(t);return{configFiles:l(d),fileTypes:l(c),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=b;function l(t){return[...p.Iterable.map(t.entries(),([r,s])=>({name:r,count:s}))].sort((r,s)=>s.count-r.count)}function u(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=u;function o(t){let r=new Map,s=E.join(t,".vscode","launch.json");return new Promise((c,d)=>{S.exists(s,f=>{if(f)S.readFile(s,(h,M)=>{if(h)return c([]);const T=[],U=n.parse(M.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),c([]);if(n.getNodeType(U)==="object"&&U.configurations)for(const H of U.configurations){const X=H.type;X&&(r.has(X)?r.set(X,r.get(X)+1):r.set(X,1))}return c(l(r))});else return c([])})})}e.collectLaunchConfigs=o;let a=class{constructor(r,s){this.telemetryService=r,this.productService=s}formatMachineInfo(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}formatEnvironment(r){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const c=v.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),i.isWindows||s.push(`Load (avg):       ${v.loadavg().map(d=>Math.round(d)).join(", ")}`),s.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([w.listProcesses(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async c=>{let[d,f]=c,h=this.formatProcessList(r,d);return s.forEach(M=>{if(A.isRemoteDiagnosticError(M))h+=`
${M.errorMessage}`,f+=`
${M.errorMessage}`;else if(h+=`

Remote: ${M.hostName}`,M.processes&&(h+=`
${this.formatProcessList(r,M.processes)}`),M.workspaceMetadata){f+=`
|  Remote: ${M.hostName}`;for(const T of Object.keys(M.workspaceMetadata)){const U=M.workspaceMetadata[T];let H=`${U.fileCount} files`;U.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${T}): ${H}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:h,workspaceInfo:f}})}async getSystemInfo(r,s){const{memory:c,vmHint:d,os:f,cpus:h}=u(),M={os:f,memory:c,cpus:h,vmHint:d,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return i.isWindows||(M.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),i.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(r,s){const c=[];return w.listProcesses(r.mainPID).then(async d=>(c.push(""),c.push(this.formatEnvironment(r)),c.push(""),c.push(this.formatProcessList(r,d)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(r))),s.forEach(f=>{if(A.isRemoteDiagnosticError(f))c.push(`
${f.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${f.hostName}`),c.push(this.formatMachineInfo(f.machineInfo)),f.processes&&c.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const h of Object.keys(f.workspaceMetadata)){const M=f.workspaceMetadata[h];let T=`${M.fileCount} files`;M.maxFilesReached&&(T=`more than ${T}`),c.push(`Folder (${h}): ${T}`),c.push(this.formatWorkspaceStats(M))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(r){const s=[],c=60;let d=0;const f=(U,H)=>{const X=` ${U}(${H})`;d+X.length>c?(s.push(h),h="|                 ",d=h.length):d+=X.length,h+=X};let h="|      File types:";const M=10;let T=r.fileTypes.length>M?M:r.fileTypes.length;for(let U=0;U<T;U++){const H=r.fileTypes[U];f(H.name,H.count)}if(s.push(h),r.configFiles.length>=0&&(h="|      Conf files:",d=0,r.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(h)),r.launchConfigFiles.length>0){let U="|      Launch Configs:";r.launchConfigFiles.forEach(H=>{U+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(r){const s=Math.max(...Object.keys(r).map(c=>c.length));return Object.keys(r).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${r[c]}`).join(`
                  `)}formatWorkspaceMetadata(r){const s=[],c=[];return r.windows.forEach(d=>{d.folderURIs.length===0||!!d.remoteAuthority||(s.push(`|  Window (${d.title})`),d.folderURIs.forEach(f=>{const h=I.URI.revive(f);if(h.scheme===g.Schemas.file){const M=h.fsPath;c.push(b(M,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${E.basename(M)}): ${U}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${M} (${T.toString()})`)}))}else s.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(d=>s.join(`
`)).catch(d=>`Unable to collect workspace stats: ${d}`)}formatProcessList(r,s){const c=new Map;r.windows.forEach(f=>c.set(f.pid,f.title));const d=[];return d.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(r.mainPID,c,d,s,0),d.join(`
`)}formatProcessItem(r,s,c,d,f){const h=f===0;let M;h?M=d.pid===r?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(f)} ${d.name}`,d.name==="window"&&(M=`${M} (${s.get(d.pid)})`));const T=process.platform==="win32"?d.mem:v.totalmem()*(d.mem/100);c.push(`${d.load.toFixed(0).padStart(5," ")}	${(T/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${d.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(d.children)&&d.children.forEach(U=>this.formatProcessItem(r,s,c,U,f+1))}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const c=I.URI.revive(s);if(c.scheme!==g.Schemas.file)continue;const d=c.fsPath;try{const f=await b(d,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),f.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})}),f.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:h.name,count:h.count})})}catch(f){}}}};a=he([te(0,k.ITelemetryService),te(1,y.IProductService)],a),e.DiagnosticsService=a}),define(J[198],x([0,1,19,168,171,44,31,49,162,53,25,6,21,7,22,96,193,4,15]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished"})(u||(u={}));function o(...F){return String(F.reduce((R,O)=>R|O,0))}var a;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class d{constructor(R=c){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,O=this.state.pageSize){return new d(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:O}))}withFilter(R,...O){const P=[...this.state.criteria,...O.length?O.map(W=>({filterType:R,value:W})):[{filterType:R}]];return new d(Object.assign(Object.assign({},this.state),{criteria:P}))}withSortBy(R){return new d(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new d(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new d(Object.assign(Object.assign({},this.state),{flags:R.reduce((O,P)=>O|P,0)}))}withAssetTypes(...R){return new d(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:O,pageSize:P,sortBy:W,sortOrder:_,flags:q,assetTypes:V}=this.state;return{filters:[{criteria:R,pageNumber:O,pageSize:P,sortBy:W,sortOrder:_}],assetTypes:V,flags:q}}get searchText(){const R=this.state.criteria.filter(O=>O.filterType===a.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(F,R){const O=(F||[]).filter(P=>P.statisticName===R)[0];return O?O.value:0}function h(F){const R="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(P=>P.assetType.indexOf(R)===0).reduce((P,W)=>{const _=H(F,W.assetType);return _&&P.push([W.assetType.substring(R.length),_]),P},[])}function M(F){if(F.properties){const R=F.properties.filter(W=>W.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),P=R.filter(W=>O.test(W.value))[0];return P?{uri:P.value,fallbackUri:P.value}:null}return H(F,t.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${F.fallbackAssetUri}/${t.VSIX}`}}function U(F){const R=H(F,t.Icon);if(R)return R;const O=L.DefaultIconPath;return{uri:O,fallbackUri:O}}function H(F,R){return F.files.filter(P=>P.assetType===R)[0]?{uri:`${F.assetUri}/${R}`,fallbackUri:`${F.fallbackAssetUri}/${R}`}:null}function X(F,R){const O=F.properties?F.properties.filter(W=>W.key===R):[],P=O.length>0&&O[0].value;return P?P.split(",").map(W=>A.adoptToGalleryExtensionId(W)):[]}function ee(F){const R=F.properties?F.properties.filter(O=>O.key===r.Engine):[];return R.length>0&&R[0].value||""}function B(F){const R=F.properties?F.properties.filter(P=>P.key===r.LocalizedLanguages):[],O=R.length>0&&R[0].value||"";return O?O.split(","):[]}function Y(F){return F.indexOf("preview")!==-1}function Q(F){const R=F.properties?F.properties.find(O=>O.key===r.WebExtension):void 0;return!!R&&R.value==="true"}function N(F){return F.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?l.joinPath(p.URI.parse(F.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function G(F,R,O,P,W){const _={manifest:H(R,t.Manifest),readme:H(R,t.Details),changelog:H(R,t.Changelog),license:H(R,t.License),repository:M(R),download:T(R),icon:U(R),coreTranslations:h(R)};return{identifier:{id:A.getGalleryExtensionId(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:R.version,date:R.lastUpdated,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,description:F.shortDescription||"",installCount:f(F.statistics,"install"),rating:f(F.statistics,"averagerating"),ratingCount:f(F.statistics,"ratingcount"),assetUri:p.URI.parse(R.assetUri),webResource:N(R),assetTypes:R.files.map(({assetType:q})=>q),assets:_,properties:{dependencies:X(R,r.Dependency),extensionPack:X(R,r.ExtensionPack),engine:ee(R),localizedLanguages:B(R),webExtension:Q(R)},telemetryData:{index:(P.pageNumber-1)*P.pageSize+O,querySource:W},preview:Y(F.flags)}}let z=class{constructor(R,O,P,W,_,q,V){this.requestService=R,this.logService=O,this.environmentService=P,this.telemetryService=W,this.fileService=_,this.productService=q;const K=q.extensionsGallery;this.extensionsGalleryUrl=K&&K.serviceUrl,this.extensionsControlUrl=K&&K.controlUrl,this.commonHeadersPromise=C(q.version,this.environmentService,this.fileService,V)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,O){const P=[];let{total:W,firstPage:_,getPage:q}=await this.query({names:R,pageSize:R.length},O);P.push(..._);for(let V=1;P.length<W&&(_=await q(V,O),_.length);V++)P.push(..._);return P}async getCompatibleExtension(R,O){const P=await this.getCompatibleExtensionByEngine(R,O);return(P==null?void 0:P.properties.webExtension)?P.webResource?P:null:P}async getCompatibleExtensionByEngine(R,O){const P=L.isIExtensionIdentifier(R)?null:R;if(P&&P.properties.engine&&w.isEngineValid(P.properties.engine,this.productService.version,this.productService.date))return P;const{id:W,uuid:_}=P?P.identifier:R;let q=new d().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");_?q=q.withFilter(a.ExtensionId,_):q=q.withFilter(a.ExtensionName,W);const{galleryExtensions:V}=await this.queryGallery(q,i.CancellationToken.None),[K]=V;if(!K||!K.versions.length)return null;if(O){const ne=K.versions.filter(re=>re.version===O)[0];if(ne){const re=G(K,ne,0,q);if(re.properties.engine&&w.isEngineValid(re.properties.engine,this.productService.version,this.productService.date))return re}return null}const Z=await this.getLastValidExtensionVersion(K,K.versions);return Z?G(K,Z,0,q):null}async query(R,O){const P=i.CancellationToken.isCancellationToken(R)?{}:R,W=i.CancellationToken.isCancellationToken(R)?R:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let _=P.text||"";const q=S.getOrDefault(P,se=>se.pageSize,50);let V=new d().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,q).withFilter(a.Target,"Microsoft.VisualStudio.Code");_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(V=V.withFilter(a.Category,oe||le),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,le,oe)=>(V=V.withFilter(a.Tag,oe||le),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(a.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),V=V.withFilter(a.SearchText,_)),V=V.withSortBy(0)):P.ids?V=V.withFilter(a.ExtensionId,...P.ids):P.names?V=V.withFilter(a.ExtensionName,...P.names):V=V.withSortBy(4),typeof P.sortBy=="number"&&(V=V.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(V=V.withSortOrder(P.sortOrder));const{galleryExtensions:K,total:Z}=await this.queryGallery(V,W),ne=K.map((se,le)=>G(se,se.versions[0],le,V,P.source)),re=async(se,le)=>{if(le.isCancellationRequested)throw v.canceled();const oe=V.withPage(se+1),{galleryExtensions:ue}=await this.queryGallery(oe,le);return ue.map((me,Se)=>G(me,me.versions[0],Se,oe,P.source))};return{firstPage:ne,total:Z,pageSize:V.pageSize,getPage:re}}async queryGallery(R,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,u.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,o(u.Unpublished));const P=await this.commonHeadersPromise,W=JSON.stringify(R.raw),_=Object.assign(Object.assign({},P),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),q=new Date().getTime();let V,K,Z=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:_},O),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:Z};const ne=await n.asJson(V);if(ne){const re=ne.results[0],se=re.extensions,le=re.resultMetadata&&re.resultMetadata.filter(oe=>oe.metadataType==="ResultCount")[0];return Z=le&&le.metadataItems.filter(oe=>oe.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:Z}}return{galleryExtensions:[],total:Z}}catch(ne){throw K=ne,ne}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-q,success:!!V&&n.isSuccess(V),responseBodySize:V==null?void 0:V.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:K?v.isPromiseCanceledError(K)?"canceled":v.getErrorMessage(K).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,O,P,W){if(!this.isEnabled())return;const _=await this.commonHeadersPromise,q=Object.assign(Object.assign({},_),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${O}/${P}/stats?statType=${W}`),headers:q},i.CancellationToken.None)}catch(V){}}async download(R,O,P){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const W=A.getGalleryExtensionTelemetryData(R),_=new Date().getTime(),q=ne=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:ne})),V=P===1?"install":P===2?"update":"",K=V?{uri:`${R.assets.download.uri}&${V}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${V}=true`}:R.assets.download,Z=await this.getAsset(K);await this.fileService.writeFile(O,Z.stream),q(new Date().getTime()-_)}async getReadme(R,O){if(R.assets.readme){const P=await this.getAsset(R.assets.readme,{},O);return await n.asText(P)||""}return""}async getManifest(R,O){if(R.assets.manifest){const P=await this.getAsset(R.assets.manifest,{},O),W=await n.asText(P);return W?JSON.parse(W):null}return null}async getCoreTranslation(R,O){const P=R.assets.coreTranslations.filter(W=>W[0]===O.toUpperCase())[0];if(P){const W=await this.getAsset(P[1]),_=await n.asText(W);return _?JSON.parse(_):null}return null}async getChangelog(R,O){if(R.assets.changelog){const P=await this.getAsset(R.assets.changelog,{},O);return await n.asText(P)||""}return""}async getAllVersions(R,O){let P=new d().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?P=P.withFilter(a.ExtensionId,R.identifier.uuid):P=P.withFilter(a.ExtensionName,R.identifier.id);const W=[],{galleryExtensions:_}=await this.queryGallery(P,i.CancellationToken.None);return _.length&&(O?await Promise.all(_[0].versions.map(async q=>{let V;try{V=await this.getEngine(q)}catch(K){}V&&w.isEngineValid(V,this.productService.version,this.productService.date)&&W.push({version:q.version,date:q.lastUpdated})})):W.push(..._[0].versions.map(q=>({version:q.version,date:q.lastUpdated})))),W}async getAsset(R,O={},P=i.CancellationToken.None){const W=await this.commonHeadersPromise,_={type:"GET"},q=Object.assign(Object.assign({},W),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),_),{headers:q});const V=R.uri,K=R.fallbackUri,Z=Object.assign(Object.assign({},O),{url:V});try{const ne=await this.requestService.request(Z,P);if(ne.res.statusCode===200)return ne;const re=await n.asText(ne);throw new Error(`Expected 200, got back ${ne.res.statusCode} instead.

${re}`)}catch(ne){if(v.isPromiseCanceledError(ne))throw ne;const re=v.getErrorMessage(ne);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:re});const se=Object.assign(Object.assign({},O),{url:K});return this.requestService.request(se,P)}}async getLastValidExtensionVersion(R,O){const P=this.getLastValidExtensionVersionFromProperties(R,O);return P||this.getLastValidExtensionVersionRecursively(R,O)}getLastValidExtensionVersionFromProperties(R,O){for(const P of O){const W=ee(P);if(!W)return null;if(w.isEngineValid(W,this.productService.version,this.productService.date))return P}return null}async getEngine(R){const O=ee(R);if(O)return O;const P=H(R,t.Manifest);if(!P)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},_=await this.getAsset(P,{headers:W}),q=await n.asJson(_);if(q)return q.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,O){if(!O.length)return null;const P=O[0],W=await this.getEngine(P);return w.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},P),{properties:[...P.properties||[],{key:r.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(R,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await n.asJson(R),P=new Map;if(O)for(const W of O.malicious){const _=P.get(W)||{id:{id:W},malicious:!0,slow:!1};_.malicious=!0,P.set(W,_)}return[...P.values()]}};z=he([te(0,n.IRequestService),te(1,I.ILogService),te(2,y.IEnvironmentService),te(3,E.ITelemetryService),te(4,k.IFileService),te(5,g.IProductService),te(6,b.optional(m.IStorageService))],z),e.ExtensionGalleryService=z;async function C(F,R,O,P){const W={"X-Market-Client-Id":`VSCode ${F}`,"User-Agent":`VSCode ${F}`},_=await D.getServiceMachineId(R,O,P);return W["X-Market-User-Id"]=_,W}e.resolveMarketplaceHeaders=C}),define(J[199],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(S){this.appender=S}listen(S,E){throw new Error(`Event not found: ${E}`)}call(S,E,{eventName:n,data:w}){return this.appender.log(n,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(S){this.channel=S}log(S,E){return this.channel.call("log",{eventName:S,data:E}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(J[200],x([0,1,47,147,23,4,17,48,2,44,37]),function($,e,v,L,A,S,E,n,w,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let I=class{constructor(g,m){this._configurationService=m,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=g.appender,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(A.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(g,m){this._experimentProperties[g]=m}setEnabled(g){this._enabled=g}_updateUserOptIn(){var g;const m=(g=this._configurationService)===null||g===void 0?void 0:g.getValue(k);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const g=await this._commonProperties;let m=g.sessionID,D=g["common.instanceId"],b=g["common.machineId"],l=g["common.firstSessionDate"],u=g["common.msftInternal"];return{sessionId:m,instanceId:D,machineId:b,firstSessionDate:l,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(g,m,D){return this.isOptedIn?this._commonProperties.then(b=>{m=y.mixin(m,b),m=y.mixin(m,this._experimentProperties),m=y.cloneAndChange(m,l=>{if(typeof l=="string")return this._cleanupInfo(l,D)}),this._appender.log(g,m)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(g,m,D){return this.publicLog(g,m,D)}publicLogError(g,m){return this.sendErrorTelemetry?this.publicLog(g,m,!0):Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}_cleanupInfo(g,m){let D=g;if(m){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(g);if(!t)break;b.push([t.index,a.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(D="";;){const a=u.exec(g);if(!a)break;!l.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(D+=g.substring(o,a.index)+"<REDACTED: user-file-path>",o=u.lastIndex)}o<g.length&&(D+=g.substr(o))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};I.IDLE_START_EVENT_NAME="UserIdleStart",I.IDLE_STOP_EVENT_NAME="UserIdleStop",I=he([te(1,S.optional(E.IConfigurationService))],I),e.TelemetryService=I;const k="telemetry";i.Registry.as(n.Extensions.Configuration).registerConfiguration({id:k,order:110,type:"object",title:L.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?L.localize(2,null,v.default.privacyStatementUrl):L.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(J[97],x([0,1,17,44,13,9]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(g,m){return Promise.resolve(void 0)}publicLog2(g,m){return this.publicLog(g,m)}publicLogError(g,m){return Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class E{async publicLog(m,D,b){}async publicLogError(m,D,b){}}e.NullEndpointTelemetryService=E;function n(...g){return{log:(m,D)=>g.forEach(b=>b.log(m,D)),flush:()=>S.Promises.settled(g.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(g,m){return m.onDidChangeConfiguration(D=>{D.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(D.source),configurationKeys:k(D.sourceConfig)})})}e.configurationTelemetry=w;function y(g){const m=Object.create(null),D=Object.create(null),b=Object.create(null);I(g,b);for(let l in b){l=l.length>150?l.substr(l.length-149):l;const u=b[l];typeof u=="number"?D[l]=u:typeof u=="boolean"?D[l]=u?1:0:typeof u=="string"?m[l]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(m[l]=u)}return{properties:m,measurements:D}}e.validateTelemetryData=y;function i(g){if(!g)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{g.indexOf(`${b}+`)===0&&(m=b)}),m}e.cleanRemoteAuthority=i;function I(g,m,D=0,b){if(!!g)for(let l of Object.getOwnPropertyNames(g)){const u=g[l],o=b?b+l:l;Array.isArray(u)?m[o]=L.safeStringify(u):u instanceof Date?m[o]=u.toISOString():A.isObject(u)?D<2?I(u,m,D+1,o+"."):m[o]=L.safeStringify(u):m[o]=u}}function k(g){if(!g)return[];const m=[];return p(m,"",g),m}function p(g,m,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>p(g,m?`${m}.${b}`:b,D[b])):g.push(m)}}),define(J[201],x([0,1]),function($,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(J[202],x([0,1,4,2,37,5,201,108]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=v.createDecorator("themeService");var w;(function(D){function b(l){return l&&typeof l=="object"&&typeof l.id=="string"}D.isThemeColor=b})(w=e.ThemeColor||(e.ThemeColor={}));function y(D){return{id:D}}e.themeColorFromId=y;var i;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||w.isThemeColor(r.color))}D.isThemeIcon=b;const l=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function u(r){const s=l.exec(r);if(!s)return;let[,c]=s;return{id:c}}D.fromString=u;function o(r,s){let c=r.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),s&&(c=`${c}~${s}`),{id:c}}D.modify=o;function a(r,s){var c,d;return r.id===s.id&&((c=r.color)===null||c===void 0?void 0:c.id)===((d=s.color)===null||d===void 0?void 0:d.id)}D.isEqual=a;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=n.CSSIcon.asClassNameArray,D.asClassName=n.CSSIcon.asClassName,D.asCSSSelector=n.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function I(D){switch(D){case E.ColorScheme.DARK:return"vs-dark";case E.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class k{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),L.toDisposable(()=>{const l=this.themingParticipants.indexOf(b);this.themingParticipants.splice(l,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new k;A.Registry.add(e.Extensions.ThemingContribution,p);function g(D){return p.onColorThemeChange(D)}e.registerThemingParticipant=g;class m extends L.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(l=>this.onThemeChange(l)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,l){let u=this.theme.getColor(b);return u&&l&&(u=l(u,this.theme)),u?u.toString():null}}e.Themable=m}),define(J[60],x([0,1,14,3,38,4]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const E="#FFFFFF",n="#1E1E1E",w="#000000",y="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=S.createDecorator("themeMainService");let k=class{constructor(g){this.stateMainService=g}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return w;let g=this.stateMainService.getItem(i,null);if(!g){let m;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(y,"vs-dark").split(" ")[0],g=m==="hc-black"?w:m==="vs"?E:n}return L.isMacintosh&&g.toUpperCase()===n&&(g="#171717"),g}saveWindowSplash(g,m){this.stateMainService.setItems([{key:y,data:m.baseTheme},{key:i,data:m.colorInfo.background},{key:I,data:m}]),typeof g=="number"&&this.updateBackgroundColor(g,m)}updateBackgroundColor(g,m){for(const D of v.BrowserWindow.getAllWindows())if(D.id===g){D.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};k=he([te(0,A.IStateMainService)],k),e.ThemeMainService=k}),define(J[41],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(L=e.StateType||(e.StateType={}));var A;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(A=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=v.createDecorator("updateService")}),define(J[203],x([0,1,37,48,148,3]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:A.localize(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:A.localize(1,null),tags:["usesOnlineServices"],enumDescriptions:[A.localize(2,null),A.localize(3,null),A.localize(4,null),A.localize(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:A.localize(6,null),deprecationMessage:A.localize(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:A.localize(8,null),description:A.localize(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:A.localize(10,null),tags:["usesOnlineServices"]}}})}),define(J[204],x([0,1,5,41]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class A{constructor(n){this.service=n}listen(n,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"checkForUpdates":return this.service.checkForUpdates(y);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=A;class S{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(J[98],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=v.createDecorator("urlService")}),define(J[205],x([0,1,7]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,w){throw new Error(`Event not found: ${w}`)}call(n,w,y){switch(w){case"handleURL":return this.handler.handleURL(v.URI.revive(y[0]),y[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=L;class A{constructor(n){this.channel=n}handleURL(n,w){return this.channel.call("handleURL",[n.toJSON(),w])}}e.URLHandlerChannelClient=A;class S{constructor(n){this.next=n}async routeCall(n,w,y,i){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(y){const I=v.URI.revive(y);if(I&&I.query){const k=/\bwindowId=(\d+)/.exec(I.query);if(k){const p=k[1],g=new RegExp(`window:${p}`),m=n.connections.find(D=>g.test(D.ctx));if(m)return m}}}return this.next.routeCall(n,w,y,i)}routeEvent(n,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=S}),define(J[206],x([0,1,7,9,2,22]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class E extends A.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(y,i){const I=[...this.handlers.values()];return L.first(I.map(k=>()=>k.handleURL(y,i)),void 0,!1).then(k=>k||!1)}registerHandler(y){return this.handlers.add(y),A.toDisposable(()=>this.handlers.delete(y))}}e.AbstractURLService=E;let n=class extends E{constructor(y){super();this.productService=y}create(y){let{authority:i,path:I,query:k,fragment:p}=y||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),v.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:k,fragment:p})}};n=he([te(0,S.IProductService)],n),e.NativeURLService=n}),define(J[207],x([0,1,5,14,7,2,3,9]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(i){try{return A.URI.parse(i)}catch(I){return null}}class y{constructor(I,k,p,g,m){if(this.urlService=k,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=I,E.isWindows){const l=g.isBuilt?[]:[`"${g.appRoot}"`];l.push("--open-url","--"),L.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,l)}const D=v.Event.map(v.Event.fromNodeEventEmitter(L.app,"open-url",(l,u)=>({event:l,url:u})),({event:l,url:u})=>(l.preventDefault(),u));this.disposables.add(D(l=>{const u=w(l);!u||this.urlService.open(u,{originalUrl:l})})),p.getWindows().filter(l=>l.isReady).length>0?this.flush():v.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const k of this.uris)await this.urlService.open(k.uri,{originalUrl:k.url})||I.push(k);I.length!==0&&(this.uris=I,this.flushDisposable=n.disposableTimeout(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=y}),define(J[76],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=v.createDecorator("webviewManagerService"),e.webviewPartitionId="webview"}),define(J[208],x([0,1,14,2,10,7,76]),function($,e,v,L,A,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends L.Disposable{constructor(){super();const y=v.session.fromPartition(E.webviewPartitionId),i=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i),y.protocol.registerFileProtocol(A.Schemas.vscodeWebview,i)}async handleWebviewRequest(y,i){try{const I=S.URI.parse(y.url),k=n.validWebviewFilePaths.get(I.path);if(typeof k=="string"){const p=I.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${k}`:`vs/workbench/contrib/webview/browser/pre/${k}`,g=A.FileAccess.asFileUri(p,$);return i(decodeURIComponent(g.fsPath))}}catch(I){}i({error:-10})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(J[61],x([0,1,3]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(y){return!!y.workspaceUri}e.isWorkspaceToOpen=L;function A(y){return!!y.folderUri}e.isFolderToOpen=A;function S(y){return!!y.fileUri}e.isFileToOpen=S;function E(y){const i=n(y),I=y.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||v.isMacintosh&&v.isNative?"classic":I}e.getMenuBarVisibility=E;function n(y){if(v.isWeb)return"custom";const i=y.getValue("window");if(i){if(v.isMacintosh&&i.nativeTabs===!0||v.isMacintosh&&i.nativeFullScreen===!1)return"native";const p=i.titleBarStyle;if(p==="native"||p==="custom")return p}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function w(y=0){return Math.pow(1.2,y)}e.zoomLevelToZoomFactor=w}),define(J[34],x([0,1,4]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var L;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(L=e.OpenContext||(e.OpenContext={}));const A=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=A;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var E;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(E=e.WindowError||(e.WindowError={})),e.IWindowsMainService=v.createDecorator("windowsMainService")}),define(J[209],x([0,1,14,2,74,76,208,34]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends L.Disposable{constructor(i,I){super();this.windowsMainService=I,this._register(new E.WebviewProtocolProvider);const k=v.session.fromPartition(S.webviewPartitionId);k.setPermissionRequestHandler((p,g,m)=>m(g==="clipboard-read")),k.setPermissionCheckHandler((p,g)=>g==="clipboard-read")}async setIgnoreMenuShortcuts(i,I){let k;if(typeof i.windowId=="number"){const{windowId:p}=i,g=this.windowsMainService.getWindowById(p);if(!(g==null?void 0:g.win))throw new Error(`Invalid windowId: ${p}`);k=g.win.webContents}else{const{webContentsId:p}=i;if(k=v.webContents.fromId(p),!k)throw new Error(`Invalid webContentsId: ${p}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(I)}};w=he([te(0,A.ITunnelService),te(1,n.IWindowsMainService)],w),e.WebviewMainService=w}),define(J[210],x([0,1,5,2,9]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends L.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:w,getActiveWindowId:y}){super();this.disposables=this._register(new L.DisposableStore),v.Event.latch(v.Event.any(n,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=A.createCancelablePromise(()=>y()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(J[211],x([0,1,7,15,4,36]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=A.createDecorator("contextService");var E;(function(k){k[k.EMPTY=1]="EMPTY",k[k.FOLDER=2]="FOLDER",k[k.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function n(k){const p=k;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=n;function w(k){const p=k;return!!(p&&typeof p=="object"&&v.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=w;class y{constructor(p,g,m,D){this._id=p,this._configuration=m,this._ignorePathCasing=D,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=g}update(p){this._id=p.id,this._configuration=p.configuration,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class i{constructor(p,g){this.raw=g,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return L.joinPath(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(k){return new i({uri:k,index:0,name:L.basenameOrAuthority(k)},{uri:k.toString()})}e.toWorkspaceFolder=I}),define(J[28],x([0,1,4,151,211,7,3,8,15,104,43,10,39,30,73]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:L.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(N){return(typeof N=="string"?n.extname(N):w.extname(N))===m}e.hasWorkspaceFileExtension=D,e.IWorkspacesService=v.createDecorator("workspacesService");function b(N){return N.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function l(N){return N.hasOwnProperty("folderUri")}e.isRecentFolder=l;function u(N){return N.hasOwnProperty("fileUri")}e.isRecentFile=u;function o(N){const G=N;return typeof(G==null?void 0:G.id)=="string"&&S.URI.isUri(G.uri)}e.isSingleFolderWorkspaceIdentifier=o;function a(N){if(N.configuration)return{id:N.id,configPath:N.configuration};if(N.folders.length===1)return{id:N.id,uri:N.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(N){const G=N;return typeof(G==null?void 0:G.id)=="string"&&S.URI.isUri(G.configPath)}e.isWorkspaceIdentifier=t;function r(N){const G=N;if(G==null?void 0:G.uri)return{id:G.id,uri:S.URI.revive(G.uri)};const z=N;if(z==null?void 0:z.configPath)return{id:z.id,configPath:S.URI.revive(z.configPath)};if(N==null?void 0:N.id)return{id:N.id}}e.reviveIdentifier=r;function s(N,G){return w.extUriBiasedIgnorePathCase.isEqualOrParent(N,G.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function c(N){return d(N)||f(N)}e.isStoredWorkspaceFolder=c;function d(N){const G=N;return typeof(G==null?void 0:G.path)=="string"&&(!G.name||typeof G.name=="string")}e.isRawFileWorkspaceFolder=d;function f(N){const G=N;return typeof(G==null?void 0:G.uri)=="string"&&(!G.name||typeof G.name=="string")}e.isRawUriWorkspaceFolder=f;function h(N,G,z,C,F=!E.isWindows,R){if(N.scheme!==C.scheme)return{name:z,uri:N.toString(!0)};let O=G?void 0:R.relativePath(C,N);if(O!==void 0)O.length===0?O=".":E.isWindows&&N.scheme===I.Schemas.file&&!F&&(O=O.replace(/\//g,"\\"));else if(N.scheme===I.Schemas.file)O=N.fsPath,E.isWindows&&(O=k.normalizeDriveLetter(O),F&&(O=p.toSlashes(O)));else{if(!R.isEqualAuthority(N.authority,C.authority))return{name:z,uri:N.toString(!0)};O=N.path}return{name:z,path:O}}e.getStoredWorkspaceFolder=h;function M(N,G,z){let C=[],F=new Set;const R=z.dirname(G);for(let O of N){let P;if(d(O))O.path&&(P=z.resolvePath(R,O.path));else if(f(O))try{P=S.URI.parse(O.uri),P.path[0]!=="/"&&(P=P.with({path:"/"+P.path}))}catch(W){console.warn(W)}if(P){let W=z.getComparisonKey(P);if(!F.has(W)){F.add(W);const _=O.name||z.basenameOrAuthority(P);C.push(new A.WorkspaceFolder({uri:P,name:_,index:C.length},O))}}}return C}e.toWorkspaceFolders=M;function T(N,G,z,C,F){let R=U(G,N);const O=F.dirname(G),P=F.dirname(C),W=[],_=H(R.folders);for(const Z of R.folders){const ne=d(Z)?F.resolvePath(O,Z.path):S.URI.parse(Z.uri);let re;z?re=!1:re=!d(Z)||n.isAbsolute(Z.path),W.push(h(ne,re,Z.name,P,_,F))}const q={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},V=y.setProperty(N,["folders"],W,q);let K=y.applyEdits(N,V);return R.remoteAuthority===g.getRemoteAuthority(C)&&(K=y.applyEdits(K,y.removeProperty(K,["remoteAuthority"],q))),K}e.rewriteWorkspaceFileForNewLocation=T;function U(N,G){let z=i.parse(G);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(C=>c(C));else throw new Error(`${N} looks like an invalid workspace file.`);return z}function H(N){return E.isWindows?N.some(G=>d(G)&&G.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function X(N){return N.workspace&&typeof N.workspace=="object"&&typeof N.workspace.id=="string"&&typeof N.workspace.configPath=="string"}function ee(N){return typeof N.folderUri=="string"}function B(N){return typeof N.fileUri=="string"}function Y(N,G){const z={workspaces:[],files:[]};if(N){const C=function(R,O){for(let P=0;P<R.length;P++)try{O(R[P],P)}catch(W){G.warn(`Error restoring recent entry ${JSON.stringify(R[P])}: ${W.toString()}. Skip entry.`)}},F=N;if(Array.isArray(F.entries))C(F.entries,R=>{const O=R.label,P=R.remoteAuthority;X(R)?z.workspaces.push({label:O,remoteAuthority:P,workspace:{id:R.workspace.id,configPath:S.URI.parse(R.workspace.configPath)}}):ee(R)?z.workspaces.push({label:O,remoteAuthority:P,folderUri:S.URI.parse(R.folderUri)}):B(R)&&z.files.push({label:O,remoteAuthority:P,fileUri:S.URI.parse(R.fileUri)})});else{const R=N;Array.isArray(R.workspaces3)&&C(R.workspaces3,(O,P)=>{const W=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[P]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?z.workspaces.push({label:W,workspace:{id:O.id,configPath:S.URI.parse(O.configURIPath)}}):typeof O=="string"&&z.workspaces.push({label:W,folderUri:S.URI.parse(O)})}),Array.isArray(R.files2)&&C(R.files2,(O,P)=>{const W=Array.isArray(R.fileLabels)&&R.fileLabels[P]||void 0;typeof O=="string"&&z.files.push({label:W,fileUri:S.URI.parse(O)})})}}return z}e.restoreRecentlyOpened=Y;function Q(N){const G={entries:[]};for(const z of N.workspaces)l(z)?G.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):G.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of N.files)G.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return G}e.toStoreData=Q}),define(J[50],x([0,1,4,28]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=v.createDecorator("backupMainService");function A(S){const E=S;return E&&L.isWorkspaceIdentifier(E.workspace)}e.isWorkspaceBackupInfo=A}),define(J[51],x([0,1,4,14,9,38,3,8,65,16,13,133,28,39,2,80]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=v.createDecorator("dialogMainService");let D=class gt{constructor(l){this.stateMainService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new A.Queue}pickFileFolder(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,pickFiles:!0,title:I.localize(0,null)}),u)}pickFolder(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFolders:!0,title:I.localize(1,null)}),u)}pickFile(l,u){return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:I.localize(2,null)}),u)}pickWorkspace(l,u){const o=I.localize(3,null),a=p.mnemonicButtonLabel(I.localize(4,null)),t=k.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},l),{pickFiles:!0,title:o,filters:t,buttonLabel:a}),u)}async doPick(l,u){const o={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};o.defaultPath=l.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(o.properties=void 0,l.pickFiles&&l.pickFolders&&(o.properties=["multiSelections","openDirectory","openFile","createDirectory"])),o.properties||(o.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),E.isMacintosh&&o.properties.push("treatPackageAsDirectory");const a=u||L.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(o,i.withNullAsUndefined(a));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,n.dirname(t.filePaths[0])),t.filePaths}getWindowDialogQueue(l){if(l){let u=this.windowDialogQueues.get(l.id);return u||(u=new A.Queue,this.windowDialogQueues.set(l.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(l,u){return this.getWindowDialogQueue(u).queue(async()=>u?L.dialog.showMessageBox(u,l):L.dialog.showMessageBox(l))}async showSaveDialog(l,u){const o=this.acquireFileDialogLock(l,u);if(!o)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await L.dialog.showSaveDialog(u,l):a=await L.dialog.showSaveDialog(l),a.filePath=this.normalizePath(a.filePath),a})}finally{g.dispose(o)}}normalizePath(l){return l&&E.isMacintosh&&(l=w.normalizeNFC(l)),l}normalizePaths(l){return l.map(u=>this.normalizePath(u))}async showOpenDialog(l,u){l.defaultPath&&(await y.exists(l.defaultPath)||(l.defaultPath=void 0));const o=this.acquireFileDialogLock(l,u);if(!o)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await L.dialog.showOpenDialog(u,l):a=await L.dialog.showOpenDialog(l),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{g.dispose(o)}}acquireFileDialogLock(l,u){if(!u)return g.Disposable.None;let o=this.windowFileDialogLocks.get(u.id);o||(o=new Set,this.windowFileDialogLocks.set(u.id,o));const a=m.hash(l);if(!o.has(a))return o.add(a),g.toDisposable(()=>{o==null||o.delete(a),(o==null?void 0:o.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};D.workingDirPickerStorageKey="pickerWorkingDir",D=he([te(0,S.IStateMainService)],D),e.DialogMainService=D}),define(J[212],x([0,1,5,2,28]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends L.Disposable{constructor(n,w){super();this.logService=n,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,w)=>(n?n.push(w):n=[w],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const w=new Map,y=new Set;return n.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?w.set(i.key,I):y.add(i.key)}),{changed:Array.from(w.entries()),deleted:Array.from(y.values())}}listen(n,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(n,w,y){const i=A.reviveIdentifier(y.workspace),I=await this.withStorageInitialized(i);switch(w){case"getItems":return Array.from(I.items.entries());case"updateItems":{const k=y;if(k.insert)for(const[p,g]of k.insert)I.set(p,g);k.delete&&k.delete.forEach(p=>I.delete(p));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(n){const w=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await w.init()}catch(y){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${y}`)}return w}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(J[213],x([0,1,16,5,2,6,123,86,8,96,31,27,28]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class p extends A.Disposable{constructor(b){super();this.logService=b,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const b=await this.doCreate();this.storage.dispose(),this.storage=b,this._register(b.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(b);const l=b.getBoolean(y.IS_NEW_KEY);l===void 0?b.set(y.IS_NEW_KEY,!0):l&&b.set(y.IS_NEW_KEY,!1)}catch(b){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${b}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?b=>this.logService.trace(b):void 0,logError:b=>this.logService.error(b)}}doInit(b){return b.init()}get items(){return this.storage.items}get(b,l){return this.storage.get(b,l)}set(b,l){return this.storage.set(b,l)}delete(b){return this.storage.delete(b)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends p{constructor(b,l,u){super(l);this.options=b,this.environmentService=u}async doCreate(){let b;return this.options.useInMemoryStorage?b=E.SQLiteStorageDatabase.IN_MEMORY_PATH:b=w.join(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}))}async doInit(b){await super.doInit(b),this.updateTelemetryState(b)}updateTelemetryState(b){b.get(i.instanceStorageKey,void 0)===void 0&&b.set(i.instanceStorageKey,I.generateUuid()),b.get(i.firstSessionDateStorageKey,void 0)===void 0&&b.set(i.firstSessionDateStorageKey,new Date().toUTCString());const o=b.get(i.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();b.set(i.lastSessionDateStorageKey,typeof o=="undefined"?null:o),b.set(i.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class m extends p{constructor(b,l,u,o){super(u);this.workspace=b,this.options=l,this.environmentService=o}async doCreate(){const{storageFilePath:b,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new E.SQLiteStorageDatabase(b,{logging:this.createLogginOptions()}),{hint:l?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:E.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const b=w.join(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=w.join(b,m.WORKSPACE_STORAGE_NAME);return await v.exists(b)?{storageFilePath:l,wasCreated:!1}:(await v.Promises.mkdir(b,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(b),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(b){let l;if(k.isSingleFolderWorkspaceIdentifier(this.workspace)?l={folder:this.workspace.uri.toString()}:k.isWorkspaceIdentifier(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const u=w.join(b,m.WORKSPACE_META_NAME);await v.exists(u)||await v.writeFile(u,JSON.stringify(l,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(J[99],x([0,1,42,2,53,4,18,6,213]),function($,e,v,L,A,S,E,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=S.createDecorator("storageMainService");let y=class extends L.Disposable{constructor(I,k,p){super();this.logService=I,this.environmentService=k,this.lifecycleMainService=p,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,k]of this.mapWorkspaceToStorage)I.join(k.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return v.once(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new w.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let k=this.mapWorkspaceToStorage.get(I.id);return k||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),k=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,k),v.once(k.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),k}};y=he([te(0,n.ILogService),te(1,A.IEnvironmentService),te(2,E.ILifecycleMainService)],y),e.StorageMainService=y}),define(J[100],x([0,1,7,28,15]),function($,e,v,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(w,y,i){for(const k of w){const p=k.openedWorkspace;if(L.isWorkspaceIdentifier(p)){const g=i(p);if(g){if(g.folders.some(m=>A.extUriBiasedIgnorePathCase.isEqualOrParent(y,m.uri)))return k}else if(A.extUriBiasedIgnorePathCase.isEqualOrParent(y,p.configPath))return k}}const I=w.filter(k=>L.isSingleFolderWorkspaceIdentifier(k.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqualOrParent(y,k.openedWorkspace.uri));if(I.length)return I.sort((k,p)=>-(k.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function E(w,y){for(const i of w)if(L.isWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,y)||L.isSingleFolderWorkspaceIdentifier(i.openedWorkspace)&&A.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,y))return i}e.findWindowOnWorkspaceOrFolder=E;function n(w,y){var i,I;const k=p=>y.some(g=>A.extUriBiasedIgnorePathCase.isEqual(v.URI.file(g),v.URI.file(p)));for(const p of w)if((I=(i=p.config)===null||i===void 0?void 0:i.extensionDevelopmentPath)===null||I===void 0?void 0:I.some(g=>k(g)))return p}e.findWindowOnExtensionDevelopmentPath=n}),define(J[214],x([0,1,14,2,3,15,7,17,18,6,38,34,28]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let p=class mt extends L.Disposable{constructor(u,o,a,t,r){super();this.windowsMainService=u,this.stateMainService=o,this.lifecycleMainService=a,this.logService=t,this.configurationService=r,this._state=g(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const a=D(u);this.stateMainService.setItem(mt.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(a=>{var t;const r=k.isWorkspaceIdentifier(u.openedWorkspace)&&((t=a.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=k.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)&&a.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(a.folderUri,u.openedWorkspace.uri);(r||s)&&(a.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(u){return{workspace:k.isWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:k.isSingleFolderWorkspaceIdentifier(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const o=this.doGetNewWindowState(u),a=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!((a==null?void 0:a.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(a==null?void 0:a.restoreFullscreen)),t&&A.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(u){const o=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const d=u.workspace;if(k.isWorkspaceIdentifier(d)){const h=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===d.id).map(M=>M.uiState);if(h.length)return h[0]}if(k.isSingleFolderWorkspaceIdentifier(d)){const h=this.state.openedWindows.filter(M=>M.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(M.folderUri,d.uri)).map(M=>M.uiState);if(h.length)return h[0]}else if(u.backupPath){const h=this.state.openedWindows.filter(M=>M.backupPath===u.backupPath).map(M=>M.uiState);if(h.length)return h[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!o&&f)return f.uiState}let a;const t=v.screen.getAllDisplays();if(t.length===1)a=t[0];else{if(A.isMacintosh){const d=v.screen.getCursorScreenPoint();a=v.screen.getDisplayNearestPoint(d)}!a&&o&&(a=v.screen.getDisplayMatching(o.getBounds())),a||(a=v.screen.getPrimaryDisplay()||t[0])}let r=I.defaultWindowState();r.x=Math.round(a.bounds.x+a.bounds.width/2-r.width/2),r.y=Math.round(a.bounds.y+a.bounds.height/2-r.height/2);const s=this.configurationService.getValue("window");let c=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")r.mode=0,c=!1;else if(s.newWindowDimensions==="fullscreen")r.mode=3,c=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const d=o.serializeWindowState();d.mode===3?r.mode=3:r=d,c=r.mode!==3&&s.newWindowDimensions==="offset"}}return c&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const o=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;o.some(a=>a.x===u.x||a.y===u.y);)u.x+=30,u.y+=30;return u}};p.windowsStateStorageKey="windowsState",p=he([te(0,I.IWindowsMainService),te(1,i.IStateMainService),te(2,w.ILifecycleMainService),te(3,y.ILogService),te(4,n.IConfigurationService)],p),e.WindowsStateHandler=p;function g(l){const u={openedWindows:[]},o=l||{openedWindows:[]};return o.lastActiveWindow&&(u.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(u.openedWindows=o.openedWindows.map(a=>m(a))),u}e.restoreWindowsState=g;function m(l){const u={uiState:l.uiState};return l.backupPath&&(u.backupPath=l.backupPath),l.remoteAuthority&&(u.remoteAuthority=l.remoteAuthority),l.folder&&(u.folderUri=E.URI.parse(l.folder)),l.workspaceIdentifier&&(u.workspace={id:l.workspaceIdentifier.id,configPath:E.URI.parse(l.workspaceIdentifier.configURIPath)}),u}function D(l){return{lastActiveWindow:l.lastActiveWindow&&b(l.lastActiveWindow),lastPluginDevelopmentHostWindow:l.lastPluginDevelopmentHostWindow&&b(l.lastPluginDevelopmentHostWindow),openedWindows:l.openedWindows.map(u=>b(u))}}e.getWindowsStateStoreData=D;function b(l){return{workspaceIdentifier:l.workspace&&{id:l.workspace.id,configURIPath:l.workspace.configPath.toString()},folder:l.folderUri&&l.folderUri.toString(),backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.uiState}}}),define(J[56],x([0,1,58,59,215,5,33,8,26,27,2,20,84,19,3]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(h){this.socket=h,this._errorListener=M=>{if(M){if(M.code==="EPIPE")return;p.onUnexpectedError(M)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const M=T=>h(I.VSBuffer.wrap(T));return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,M=>{if(M){if(M.code==="EPIPE")return;p.onUnexpectedError(M)}})}catch(M){if(M.code==="EPIPE")return;p.onUnexpectedError(M)}}end(){this.socket.end()}drain(){return new Promise((h,M)=>{if(this.socket.bufferSize===0){h();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),h()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=m;var D;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(D||(D={}));var b;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(b||(b={}));class l extends i.Disposable{constructor(h,M,T,U){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=M,this._recordInflateBytes=U,M?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),p.onUnexpectedError(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),p.onUnexpectedError(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new k.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let M=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.length-4),this._isEnded||this._write(I.VSBuffer.wrap(M),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,M){let T=2;h.byteLength<126?T+=0:h.byteLength<2**16?T+=2:T+=8;const U=I.VSBuffer.alloc(T);if(M?U.writeUInt8(194,0):U.writeUInt8(130,0),h.byteLength<126)U.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(h.byteLength>>>8&255,++H),U.writeUInt8(h.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(h.byteLength>>>24&255,++H),U.writeUInt8(h.byteLength>>>16&255,++H),U.writeUInt8(h.byteLength>>>8&255,++H),U.writeUInt8(h.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=U.byteLength+h.byteLength,this.socket.write(I.VSBuffer.concat([U,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),U=(M.readUInt8(0)&128)>>>7,H=M.readUInt8(1),X=(H&128)>>>7,ee=H&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),T=M.readUInt8(1),U=(T&128)>>>7;let H=T&127,X=1;H===126?H=M.readUInt8(++X)*2**8+M.readUInt8(++X):H===127&&(H=M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*0+M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X));let ee=0;U&&(ee=M.readUInt8(++X)*2**24+M.readUInt8(++X)*2**16+M.readUInt8(++X)*2**8+M.readUInt8(++X)),this._state.state=3,this._state.readLen=H,this._state.mask=ee}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);u(M,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(M.buffer)),this._zlibInflate.write(M.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(I.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=M.byteLength,this._onData.fire(M))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=l;function u(f,h){if(h===0)return;let M=f.byteLength>>>2;for(let B=0;B<M;B++){const Y=f.readUInt32BE(B*4);f.writeUInt32BE(Y^h,B*4)}let T=M*4,U=f.byteLength-T;const H=h>>>24&255,X=h>>>16&255,ee=h>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(T)^H,T),U>=2&&f.writeUInt8(f.readUInt8(T+1)^X,T+1),U>=3&&f.writeUInt8(f.readUInt8(T+2)^ee,T+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function a(){const f=y.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let h;return e.XDG_RUNTIME_DIR?h=n.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):h=n.join(w.tmpdir(),`vscode-ipc-${f}.sock`),r(h),h}e.createRandomIPCHandle=a;function t(f,h,M){const T=v.createHash("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${M}-${h}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=n.join(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${M}-${h}.sock`):U=n.join(f,`${M}-${h}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(f){const h=o[g.platform];typeof h=="number"&&f.length>=h&&console.warn(`WARNING: IPC handle "${f}" is longer than ${h} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(h){super(s.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const M=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(M,T=>({protocol:new k.Protocol(new m(T)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(f){return new Promise((h,M)=>{const T=L.createServer();T.on("error",M),T.listen(f,()=>{T.removeListener("error",M),h(new s(T))})})}e.serve=c;function d(f,h){return new Promise((M,T)=>{const U=L.createConnection(f,()=>{U.removeListener("error",T),M(k.Client.fromSocket(new m(U),h))});U.once("error",T)})}e.connect=d}),define(J[216],x([0,1,56]),function($,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(w){this.driver=w}listen(w,y){throw new Error("No event found")}call(w,y,i){switch(y){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2])}throw new Error(`Call not found: ${y}`)}}e.DriverChannel=L;class A{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,y){return this.channel.call("dispatchKeybinding",[w,y])}click(w,y,i,I){return this.channel.call("click",[w,y,i,I])}doubleClick(w,y){return this.channel.call("doubleClick",[w,y])}setValue(w,y,i){return this.channel.call("setValue",[w,y,i])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,y){return this.channel.call("isActiveElement",[w,y])}getElements(w,y,i){return this.channel.call("getElements",[w,y,i])}getElementXY(w,y,i,I){return this.channel.call("getElementXY",[w,y,i,I])}typeInEditor(w,y,i){return this.channel.call("typeInEditor",[w,y,i])}getTerminalBuffer(w,y){return this.channel.call("getTerminalBuffer",[w,y])}writeInTerminal(w,y,i){return this.channel.call("writeInTerminal",[w,y,i])}}e.DriverChannelClient=A;class S{constructor(w){this.registry=w}listen(w,y){throw new Error(`Event not found: ${y}`)}call(w,y,i){switch(y){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${y}`)}}e.WindowDriverRegistryChannel=S;async function E(n){const w=await v.connect(n,"driverClient"),y=w.getChannel("driver"),i=new A(y);return{client:w,driver:i}}e.connect=E}),define(J[24],x([0,1,8,46,4,53,160,56]),function($,e,v,L,A,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=A.refineServiceDecorator(S.IEnvironmentService);class w extends E.NativeEnvironmentService{get cachedLanguagesPath(){return v.join(this.userDataPath,"clp")}get backupHome(){return v.join(this.userDataPath,"Backups")}get backupWorkspacesPath(){return v.join(this.backupHome,"workspaces.json")}get mainIPCHandle(){return n.createStaticIPCHandle(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return v.join(this.userDataPath,"Code Cache")}}he([L.memoize],w.prototype,"cachedLanguagesPath",null),he([L.memoize],w.prototype,"backupHome",null),he([L.memoize],w.prototype,"backupWorkspacesPath",null),he([L.memoize],w.prototype,"mainIPCHandle",null),he([L.memoize],w.prototype,"sandbox",null),he([L.memoize],w.prototype,"driverVerbose",null),he([L.memoize],w.prototype,"disableUpdates",null),he([L.memoize],w.prototype,"disableKeytar",null),he([L.memoize],w.prototype,"nodeCachedDataDir",null),he([L.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(J[217],x([0,1,29,58,8,3,16,50,24,17,21,6,28,7,30,10,15]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let b=class{constructor(u,o,a){this.configurationService=o,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=D.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>g.isEqual(t,r,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await E.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}u.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos));let o=[];try{Array.isArray(u.rootURIWorkspaces)&&(o=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:p.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let a=[];try{Array.isArray(u.folderURIWorkspaces)&&(a=u.folderURIWorkspaces.map(t=>p.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==i.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===i.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const o=this.configurationService.getValue();return((u=o==null?void 0:o.files)===null||u===void 0?void 0:u.hotExit)||i.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,o){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const a=this.getBackupPath(u.workspace.id);return o&&this.moveBackupFolderSync(a,o),a}moveBackupFolderSync(u,o){if(v.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),v.existsSync(o))try{v.renameSync(o,u)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(u){const o=u.id,a=this.workspaces.findIndex(t=>t.workspace.id===o);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(o=>this.backupUriComparer.isEqual(u,o))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const o=this.folders.findIndex(a=>this.backupUriComparer.isEqual(u,a));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(u,o){const a=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:o}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(u){const o=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,u));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(u){return A.join(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const o=new Set,a=[];for(let t of u){const r=t.workspace;if(!k.isWorkspaceIdentifier(r))return[];if(!o.has(r.id)){o.add(r.id);const s=this.getBackupPath(r.id);await this.doHasBackups(s)?r.configPath.scheme!==m.Schemas.file||await E.exists(r.configPath.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateFolders(u){if(!Array.isArray(u))return[];const o=[],a=new Set;for(let t of u){const r=this.backupUriComparer.getComparisonKey(t);if(!a.has(r)){a.add(r);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==m.Schemas.file||await E.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const o=[],a=new Set;for(let t of u){const r=t.backupFolder;if(typeof r!="string")return[];if(!a.has(r)){a.add(r);const s=this.getBackupPath(r);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(u){try{await E.exists(u)&&await E.rimraf(u,E.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const a=this.getBackupPath(o);try{await E.Promises.rename(u,a)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(u){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const a=this.getBackupPath(o);try{v.renameSync(u,a)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const u=[];for(const o of this.workspaces)await this.hasBackups(o)&&u.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&u.push(o);return u}hasBackups(u){let o;return p.URI.isUri(u)?o=this.getBackupPath(this.getFolderHash(u)):n.isWorkspaceBackupInfo(u)?o=this.getBackupPath(u.workspace.id):o=u.backupFolder,this.doHasBackups(o)}async doHasBackups(u){try{const o=await E.readdir(u);for(const a of o)try{if((await E.readdir(A.join(u,a))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{E.writeFileSync(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await E.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let o;return u.scheme===m.Schemas.file?o=S.isLinux?u.fsPath:u.fsPath.toLowerCase():o=u.toString().toLowerCase(),L.createHash("md5").update(o).digest("hex")}};b=he([te(0,w.IEnvironmentMainService),te(1,y.IConfigurationService),te(2,I.ILogService)],b),e.BackupMainService=b}),define(J[45],x([0,1,40,114,145,82,5,34,14,18,3,24,51,16,7,31,4,26,66,6,8,22,46,2,60]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=D.createDecorator("nativeHostMainService");let c=class lt extends r.Disposable{constructor(f,h,M,T,U,H,X,ee,B){super();this.sharedProcess=f,this.windowsMainService=h,this.dialogMainService=M,this.lifecycleMainService=T,this.environmentMainService=U,this.telemetryService=H,this.logService=X,this.productService=ee,this.themeMainService=B,this.onDidOpenWindow=E.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-maximize",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-unmaximize",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-blur",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),E.Event.filter(E.Event.fromNodeEventEmitter(w.app,"browser-window-focus",(Y,Q)=>Q.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(w.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new E.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new E.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(w.screen,"display-metrics-changed",(Y,Q,N)=>N),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),E.Event.fromNodeEventEmitter(w.screen,"display-added"),E.Event.fromNodeEventEmitter(w.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){w.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors,dark:w.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(h=>{var M,T;return{id:h.id,workspace:h.openedWorkspace,title:(T=(M=h.win)===null||M===void 0?void 0:M.getTitle())!==null&&T!==void 0?T:"",filename:h.getRepresentedFilename(),dirty:h.isDocumentEdited()}})}async getWindowCount(f){return this.windowsMainService.getWindowCount()}async getActiveWindowId(f){const h=w.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(h)return h.id}openWindow(f,h,M){return Array.isArray(h)?this.doOpenWindow(f,h,M):this.doOpenEmptyWindow(f,h)}async doOpenWindow(f,h,M=Object.create(null)){h.length>0&&this.windowsMainService.open({context:5,contextWindowId:f,urisToOpen:h,cli:this.environmentMainService.args,forceNewWindow:M.forceNewWindow,forceReuseWindow:M.forceReuseWindow,preferNewWindow:M.preferNewWindow,diffMode:M.diffMode,addMode:M.addMode,gotoLineMode:M.gotoLineMode,noRecentEntry:M.noRecentEntry,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:M.remoteAuthority||void 0})}async doOpenEmptyWindow(f,h){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:f},h)}async toggleFullScreen(f){const h=this.windowById(f);h&&h.toggleFullScreen()}async handleTitleDoubleClick(f){const h=this.windowById(f);h&&h.handleTitleDoubleClick()}async isMaximized(f){const h=this.windowById(f);return(h==null?void 0:h.win)?h.win.isMaximized():!1}async maximizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.maximize()}async unmaximizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.unmaximize()}async minimizeWindow(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.minimize()}async focusWindow(f,h){var M;h&&typeof h.windowId=="number"&&(f=h.windowId);const T=this.windowById(f);T&&T.focus({force:(M=h==null?void 0:h.force)!==null&&M!==void 0?M:!1})}async setMinimumSize(f,h,M){const T=this.windowById(f);if(T==null?void 0:T.win){const[U,H]=T.win.getSize(),[X,ee]=T.win.getMinimumSize(),[B,Y]=[h??X,M??ee],[Q,N]=[Math.max(U,B),Math.max(H,Y)];(X!==B||ee!==Y)&&T.win.setMinimumSize(B,Y),(U!==Q||H!==N)&&T.win.setSize(Q,N)}}async saveWindowSplash(f,h){this.themeMainService.saveWindowSplash(f,h)}async installShellCommand(f){const{source:h,target:M}=await this.getShellCommandLink();try{const{symbolicLink:T}=await p.SymlinkSupport.stat(h);if(T&&!T.dangling){const U=await S.realpath(h);if(M===U)return}await p.Promises.unlink(h)}catch(T){if(T.code!=="ENOENT")throw T}try{await p.Promises.symlink(M,h)}catch(T){if(T.code!=="EACCES"&&T.code!=="ENOENT")throw T;const{response:U}=await this.showMessageBox(f,{type:"info",message:A.localize(0,null,this.productService.nameShort),buttons:[A.localize(1,null),A.localize(2,null)],cancelId:1});if(U===0)try{const H=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${M}' '${h}'\\" with administrator privileges"`;await L.promisify(v.exec)(H)}catch(H){throw new Error(A.localize(3,null,h))}}}async uninstallShellCommand(f){const{source:h}=await this.getShellCommandLink();try{await p.Promises.unlink(h)}catch(M){switch(M.code){case"EACCES":const{response:T}=await this.showMessageBox(f,{type:"info",message:A.localize(4,null,this.productService.nameShort),buttons:[A.localize(5,null),A.localize(6,null)],cancelId:1});if(T===0)try{const U=`osascript -e "do shell script \\"rm '${h}'\\" with administrator privileges"`;await L.promisify(v.exec)(U)}catch(U){throw new Error(A.localize(7,null,h))}break;case"ENOENT":break;default:throw M}}}async getShellCommandLink(){const f=o.resolve(this.environmentMainService.appRoot,"bin","code"),h=`/usr/local/bin/${this.productService.applicationName}`;if(!await p.exists(f))throw new Error(A.localize(8,null,f));return{source:h,target:f}}async showMessageBox(f,h){return this.dialogMainService.showMessageBox(h,this.toBrowserWindow(f))}async showSaveDialog(f,h){return this.dialogMainService.showSaveDialog(h,this.toBrowserWindow(f))}async showOpenDialog(f,h){return this.dialogMainService.showOpenDialog(h,this.toBrowserWindow(f))}toBrowserWindow(f){const h=this.windowById(f);if(h==null?void 0:h.win)return h.win}async pickFileFolderAndOpen(f,h){const M=await this.dialogMainService.pickFileFolder(h);M&&(this.sendPickerTelemetry(M,h.telemetryEventName||"openFileFolder",h.telemetryExtraData),this.doOpenPicked(await Promise.all(M.map(async T=>await p.SymlinkSupport.existsDirectory(T)?{folderUri:g.URI.file(T)}:{fileUri:g.URI.file(T)})),h,f))}async pickFolderAndOpen(f,h){const M=await this.dialogMainService.pickFolder(h);M&&(this.sendPickerTelemetry(M,h.telemetryEventName||"openFolder",h.telemetryExtraData),this.doOpenPicked(M.map(T=>({folderUri:g.URI.file(T)})),h,f))}async pickFileAndOpen(f,h){const M=await this.dialogMainService.pickFile(h);M&&(this.sendPickerTelemetry(M,h.telemetryEventName||"openFile",h.telemetryExtraData),this.doOpenPicked(M.map(T=>({fileUri:g.URI.file(T)})),h,f))}async pickWorkspaceAndOpen(f,h){const M=await this.dialogMainService.pickWorkspace(h);M&&(this.sendPickerTelemetry(M,h.telemetryEventName||"openWorkspace",h.telemetryExtraData),this.doOpenPicked(M.map(T=>({workspaceUri:g.URI.file(T)})),h,f))}doOpenPicked(f,h,M){this.windowsMainService.open({context:3,contextWindowId:M,cli:this.environmentMainService.args,urisToOpen:f,forceNewWindow:h.forceNewWindow})}sendPickerTelemetry(f,h,M){const T=f?f.length:0;this.telemetryService.publicLog(h,Object.assign(Object.assign({},M),{outcome:T?"success":"canceled",numberOfPaths:T}))}async showItemInFolder(f,h){w.shell.showItemInFolder(h)}async setRepresentedFilename(f,h){const M=this.windowById(f);M&&M.setRepresentedFilename(h)}async setDocumentEdited(f,h){const M=this.windowById(f);M&&M.setDocumentEdited(h)}async openExternal(f,h){return i.isLinuxSnap?this.safeSnapOpenExternal(h):w.shell.openExternal(h),!0}safeSnapOpenExternal(f){const h=process.env.GDK_PIXBUF_MODULE_FILE,M=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,w.shell.openExternal(f),process.env.GDK_PIXBUF_MODULE_FILE=h,process.env.GDK_PIXBUF_MODULEDIR=M}moveItemToTrash(f,h){return w.shell.trashItem(h)}async isAdmin(){let f;return i.isWindows?f=(await new Promise((h,M)=>{$(["native-is-elevated"],h,M)}))():f=process.getuid()===0,f}async writeElevated(f,h,M,T){const U=await new Promise((H,X)=>{$(["sudo-prompt"],H,X)});return new Promise((H,X)=>{const ee=[`"${this.cliPath}"`];(T==null?void 0:T.unlock)&&ee.push("--file-chmod"),ee.push("--file-write",`"${h.fsPath}"`,`"${M.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:i.isMacintosh&&this.environmentMainService.isBuilt?o.join(o.dirname(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};U.exec(ee.join(" "),B,(Y,Q,N)=>{Q&&this.logService.trace(`[sudo-prompt] received stdout: ${Q}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),Y?X(Y):H(void 0)})})}get cliPath(){return i.isWindows?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}.cmd`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.bat"):i.isLinux?this.environmentMainService.isBuilt?o.join(o.dirname(process.execPath),"bin",`${this.productService.applicationName}`):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?o.join(this.environmentMainService.appRoot,"bin","code"):o.join(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:b.totalmem(),freemem:b.freemem(),loadavg:b.loadavg()}}async getOSProperties(){return{arch:b.arch(),platform:b.platform(),release:b.release(),type:b.type(),cpus:b.cpus()}}async getOSVirtualMachineHint(){return l.virtualMachineHint.value()}async killProcess(f,h,M){process.kill(h,M)}async readClipboardText(f,h){return w.clipboard.readText(h)}async writeClipboardText(f,h,M){return w.clipboard.writeText(h,M)}async readClipboardFindText(f){return w.clipboard.readFindText()}async writeClipboardFindText(f,h){return w.clipboard.writeFindText(h)}async writeClipboardBuffer(f,h,M,T){return w.clipboard.writeBuffer(h,Buffer.from(M),T)}async readClipboardBuffer(f,h){return w.clipboard.readBuffer(h)}async hasClipboard(f,h,M){return w.clipboard.has(h,M)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){w.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){w.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){w.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){w.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){w.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(f,h){const M=this.windowById(f);M&&M.updateTouchBar(h)}async notifyReady(f){const h=this.windowById(f);h&&h.setReady()}async relaunch(f,h){return this.lifecycleMainService.relaunch(h)}async reload(f,h){const M=this.windowById(f);if(M)return this.lifecycleMainService.reload(M,(h==null?void 0:h.disableExtensions)!==void 0?{_:[],"disable-extensions":h==null?void 0:h.disableExtensions}:void 0)}async closeWindow(f){this.closeWindowById(f,f)}async closeWindowById(f,h){const M=this.windowById(h);if(M==null?void 0:M.win)return M.win.close()}async quit(f){const h=this.windowsMainService.getLastActiveWindow();(h==null?void 0:h.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&h.win?h.win.close():this.lifecycleMainService.quit()}async exit(f,h){await this.lifecycleMainService.kill(h)}async resolveProxy(f,h){var M,T;const U=this.windowById(f),H=(T=(M=U==null?void 0:U.win)===null||M===void 0?void 0:M.webContents)===null||T===void 0?void 0:T.session;if(H)return H.resolveProxy(h)}async openDevTools(f,h){const M=this.windowById(f);(M==null?void 0:M.win)&&M.win.webContents.openDevTools(h)}async toggleDevTools(f){const h=this.windowById(f);(h==null?void 0:h.win)&&h.win.webContents.toggleDevTools()}async sendInputEvent(f,h){const M=this.windowById(f);(M==null?void 0:M.win)&&(h.type==="mouseDown"||h.type==="mouseUp")&&M.win.webContents.sendInputEvent(h)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(f,h,M,T){if(!i.isWindows)return;const U=await new Promise((H,X)=>{$(["vscode-windows-registry"],H,X)});try{return U.GetStringRegKey(h,M,T)}catch(H){return}}async getPassword(f,h,M){const T=await this.withKeytar(),U=await T.getPassword(h,M);if(U)try{let{content:H,hasNextChunk:X}=JSON.parse(U);if(!H||!X)return U;let ee=1;for(;X;){const B=await T.getPassword(h,`${M}-${ee}`),Y=JSON.parse(B);H+=Y.content,X=Y.hasNextChunk}return H}catch(H){return U}return U}async setPassword(f,h,M,T){const U=await this.withKeytar(),H=3,X=async(ee,B,Y)=>{let Q=0,N;for(;Q<H;)try{await U.setPassword(ee,B,Y);return}catch(G){N=G,this.logService.warn("Error attempting to set a password: ",G),Q++,await new Promise(z=>setTimeout(z,200))}throw N};if(i.isWindows&&T.length>lt.MAX_PASSWORD_LENGTH){let ee=0,B=0,Y=!0;for(;Y;){const Q=T.substring(ee,ee+lt.PASSWORD_CHUNK_SIZE);ee+=lt.PASSWORD_CHUNK_SIZE,Y=T.length-ee>0;const N={content:Q,hasNextChunk:Y};await X(h,B?`${M}-${B}`:M,JSON.stringify(N)),B++}}else await X(h,M,T);this._onDidChangePassword.fire({service:h,account:M})}async deletePassword(f,h,M){const U=await(await this.withKeytar()).deletePassword(h,M);return U&&this._onDidChangePassword.fire({service:h,account:M}),U}async findPassword(f,h){return(await this.withKeytar()).findPassword(h)}async findCredentials(f,h){return(await this.withKeytar()).findCredentials(h)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((f,h)=>{$(["keytar"],f,h)})}windowById(f){if(typeof f=="number")return this.windowsMainService.getWindowById(f)}};c.MAX_PASSWORD_LENGTH=2500,c.PASSWORD_CHUNK_SIZE=c.MAX_PASSWORD_LENGTH-100,he([t.memoize],c.prototype,"cliPath",null),c=he([te(1,n.IWindowsMainService),te(2,k.IDialogMainService),te(3,y.ILifecycleMainService),te(4,I.IEnvironmentMainService),te(5,m.ITelemetryService),te(6,u.ILogService),te(7,a.IProductService),te(8,s.IThemeMainService)],c),e.NativeHostMainService=c}),define(J[218],x([0,1,2,5,80,14,6,34,45,89,27,22,25]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let g=class extends v.Disposable{constructor(D,b,l,u,o){super();this.logService=D,this.windowsMainService=b,this.nativeHostMainService=l,this.encryptionMainService=u,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const D=L.Event.fromNodeEventEmitter(S.app,"login",(b,l,u,o,a)=>({event:b,webContents:l,req:u,authInfo:o,callback:a}));this._register(D(this.onLogin,this))}async onLogin({event:D,authInfo:b,req:l,callback:u}){if(!b.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&l.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}D.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(b);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(o==null?void 0:o.username,o==null?void 0:o.password)}async resolveProxyCredentials(D){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.doResolveProxyCredentials(D);if(b)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(D){var b,l,u,o;this.logService.trace("auth#doResolveProxyCredentials - enter",D);const a=String(A.hash({scheme:D.scheme,host:D.host,port:D.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a);if(f){const h=JSON.parse(await this.encryptionMainService.decrypt(f));t=h.username,r=h.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:t,password:r};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const c={authInfo:D,username:(l=(b=this.sessionCredentials)===null||b===void 0?void 0:b.username)!==null&&l!==void 0?l:t,password:(o=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&o!==void 0?o:r,replyChannel:`vscode:proxyAuthResponse:${i.generateUuid()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",k.CancellationToken.None,c),this.state=p.LoginDialogShown;const d=await new Promise(f=>{var h;const M=async(T,U,H)=>{var X;if(U===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",M),H){const ee={username:H.username,password:H.password};try{if(H.remember){const B=await this.encryptionMainService.encrypt(JSON.stringify(ee));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a,B)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,a)}catch(B){this.logService.error(B)}f({username:ee.username,password:ee.password})}else f(void 0)};(h=s.win)===null||h===void 0||h.webContents.on("ipc-message",M)});return this.sessionCredentials=d,d}};g=he([te(0,E.ILogService),te(1,n.IWindowsMainService),te(2,w.INativeHostMainService),te(3,y.IEncryptionMainService),te(4,I.IProductService)],g),e.ProxyAuthHandler=g}),define(J[219],x([0,1,216,155,34,56,2,33,57,176,3,5,79,106,9,18,45]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(o){return o<21}let l=class{constructor(a,t,r,s,c){this.windowServer=a,this.options=t,this.windowsMainService=r,this.lifecycleMainService=s,this.nativeHostMainService=c,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new I.Emitter}async registerWindowDriver(a){return this.registeredWindowIds.add(a),this.reloadingWindowIds.delete(a),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(a){this.reloadingWindowIds.add(a)}async getWindowIds(){return this.windowsMainService.getWindows().map(a=>a.id).filter(a=>this.registeredWindowIds.has(a)&&!this.reloadingWindowIds.has(a))}async capturePage(a){await this.whenUnfrozen(a);const t=this.windowsMainService.getWindowById(a);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(a){await this.whenUnfrozen(a);const t=this.windowsMainService.getWindowById(a);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(a),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(a,t){await this.whenUnfrozen(a);const r=p.KeybindingParser.parseUserBinding(t);for(let s of r)await this._dispatchKeybinding(a,s)}async _dispatchKeybinding(a,t){if(t instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const r=this.windowsMainService.getWindowById(a);if(!(r==null?void 0:r.win))throw new Error("Invalid window");const s=r.win.webContents,c=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new y.USLayoutResolvedKeybinding(c.toChord(),i.OS).getElectronAccelerator(),h=[];t.ctrlKey&&h.push("ctrl"),t.metaKey&&h.push("meta"),t.shiftKey&&h.push("shift"),t.altKey&&h.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:h}),b(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:h}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:h}),await g.timeout(100)}async click(a,t,r,s){await(await this.getWindowDriver(a)).click(t,r,s)}async doubleClick(a,t){await(await this.getWindowDriver(a)).doubleClick(t)}async setValue(a,t,r){await(await this.getWindowDriver(a)).setValue(t,r)}async getTitle(a){return await(await this.getWindowDriver(a)).getTitle()}async isActiveElement(a,t){return await(await this.getWindowDriver(a)).isActiveElement(t)}async getElements(a,t,r){return await(await this.getWindowDriver(a)).getElements(t,r)}async getElementXY(a,t,r,s){return await(await this.getWindowDriver(a)).getElementXY(t,r,s)}async typeInEditor(a,t,r){await(await this.getWindowDriver(a)).typeInEditor(t,r)}async getTerminalBuffer(a,t){return await(await this.getWindowDriver(a)).getTerminalBuffer(t)}async writeInTerminal(a,t,r){await(await this.getWindowDriver(a)).writeInTerminal(t,r)}async getWindowDriver(a){await this.whenUnfrozen(a);const t=`window:${a}`,r=new n.StaticRouter(c=>c===t),s=this.windowServer.getChannel("windowDriver",r);return new L.WindowDriverChannelClient(s)}async whenUnfrozen(a){for(;this.reloadingWindowIds.has(a);)await I.Event.toPromise(this.onDidReloadingChange.event)}};l=he([te(2,A.IWindowsMainService),te(3,m.ILifecycleMainService),te(4,D.INativeHostMainService)],l),e.Driver=l;async function u(o,a,t,r){const s=t.driverVerbose,c=r.createInstance(l,o,{verbose:s}),d=new v.WindowDriverRegistryChannel(c);o.registerChannel("windowDriverRegistry",d);const f=await S.serve(a),h=new v.DriverChannel(c);return f.registerChannel("driver",h),E.combinedDisposable(f,o)}e.serve=u}),define(J[220],x([0,1,59,56]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(A,S,E,n){const w=i=>n(i,void 0),y=v.createConnection({host:A,port:S},()=>{y.removeListener("error",w);const i=Buffer.alloc(16);for(let g=0;g<16;g++)i[g]=Math.round(Math.random()*256);const I=i.toString("base64");let k=[`GET ws://${/:/.test(A)?`[${A}]`:A}:${S}/?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];y.write(k.join(`\r
`)+`\r
\r
`);const p=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",p),n(void 0,new L.NodeSocket(y)))};y.on("data",p)});y.once("error",w)}}}),define(J[221],x([0,1,59,9,2,115,17,6,22,190,74,220,75]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function p(b,l,u,o,a){return new g(b,l,u,o,a).waitForReady()}class g extends A.Disposable{constructor(l,u,o,a,t){super();this.defaultTunnelHost=u,this.suggestedLocalPort=t,this.public=!1,this._socketsDispose=new Map,this._options=l,this._server=v.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){var l;let u=await S.findFreePortFaster((l=this.suggestedLocalPort)!==null&&l!==void 0?l:this.tunnelRemotePort,2,1e3),o=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address(),o||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),o=this._server.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async _onConnection(l){l.pause();const u=await y.connectRemoteAgentTunnel(this._options,this.tunnelRemotePort),o=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{this._socketsDispose.delete(l.localAddress),o.end()}),l.on("close",()=>o.end()),l.on("error",()=>{this._socketsDispose.delete(l.localAddress),o.destroy()}),o.on("end",()=>l.end()),o.on("close",()=>l.end()),o.on("error",()=>{l.destroy()}),l.pipe(o),o.pipe(l),this._socketsDispose.set(l.localAddress,()=>{l.end(),o.end()})}}let m=class extends i.AbstractTunnelService{constructor(l,u,o,a,t){super(u);this.socketFactory=l,this.signService=o,this.productService=a,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,u,o,a,t,r){const s=this.getTunnelFromMap(u,o);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,o,a,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${o} on local port ${a}.`);const c={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},d=p(c,this.defaultTunnelHost,u,o,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,o,d),d}}};m=he([te(1,n.ILogService),te(2,k.ISignService),te(3,w.IProductService),te(4,E.IConfigurationService)],m),e.BaseTunnelService=m;let D=class extends m{constructor(l,u,o,a){super(I.nodeSocketFactory,l,u,o,a)}};D=he([te(0,n.ILogService),te(1,k.ISignService),te(2,w.IProductService),te(3,E.IConfigurationService)],D),e.TunnelService=D}),define(J[222],x([0,1,215,192,2,13,19,191,17,6,20,53,91]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends A.Disposable{constructor(m,D,b){super();this.environmentService=D,this.logService=b,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,D){this.logService.trace("RequestService#request",m.url);const{proxyUrl:b,strictSSL:l}=this,u=Object.assign(Object.assign({},process.env),await k.resolveShellEnv(this.logService,this.environmentService.args,process.env)),o=m.agent?m.agent:await n.getProxyAgent(m.url||"",u,{proxyUrl:b,strictSSL:l});return m.agent=o,m.strictSSL=l,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,D)}async getNodeRequest(m){return(L.parse(m.url).protocol==="https:"?await new Promise((l,u)=>{$(["https"],l,u)}):await new Promise((l,u)=>{$(["http"],l,u)})).request}_request(m,D){return new Promise(async(b,l)=>{let u;const o=L.parse(m.url),a=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:S.isBoolean(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),u=a(t,r=>{const s=S.isNumber(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&s>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:s-1}),D).then(b,l);else{let c=r;r.headers["content-encoding"]==="gzip"&&(c=r.pipe(v.createGunzip())),b({res:r,stream:i.streamToBufferReadableStream(c)})}}),u.on("error",l),m.timeout&&u.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&u.write(m.data),u.end(),D.onCancellationRequested(()=>{u.abort(),l(E.canceled())})})}async resolveProxy(m){}};p=he([te(0,w.IConfigurationService),te(1,I.INativeEnvironmentService),te(2,y.ILogService)],p),e.RequestService=p}),define(J[223],x([0,1,222,14]),function($,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function A(E){return L.net.request}class S extends v.RequestService{request(n,w){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:A}),w)}}e.RequestMainService=S}),define(J[224],x([0,1,47,14,24,9,6,18,60,10,3,2,85,13,5,55]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let D=class extends I.Disposable{constructor(l,u,o,a,t,r,s){super();this.machineId=l,this.userEnv=u,this.environmentMainService=o,this.lifecycleMainService=a,this.logService=t,this.themeMainService=r,this.protocolMainService=s,this.firstWindowConnectionBarrier=new S.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new g.Emitter),this.onDidError=g.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),L.ipcMain.on("vscode:createSharedProcessMessageChannel",async(l,u)=>this.onWindowConnection(l,u))}async onWindowConnection(l,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const o=await this.connect();if(l.sender.isDestroyed())return o.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[o])}onWillShutdown(){const l=this.window;!l||(!l.isDestroyed()&&!l.webContents.isDestroyed()&&l.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>L.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>L.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new L.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",$).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{var u;this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(l,u,o)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${o}`})))}async connect(){await this.whenIpcReady;const l=p.assertIsDefined(this.window);return k.connect(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var l,u;return(u=(l=this.window)===null||l===void 0?void 0:l.isVisible())!==null&&u!==void 0?u:!1}};D=he([te(2,A.IEnvironmentMainService),te(3,n.ILifecycleMainService),te(4,E.ILogService),te(5,w.IThemeMainService),te(6,m.IProtocolMainService)],D),e.SharedProcess=D}),define(J[225],x([0,1,7,8,13,6,24,9,21,20]),function($,e,v,L,A,S,E,n,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(p,g,m){this.storagePath=p,this.logService=g,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new n.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,g){const m=this.storage[p];return A.isUndefinedOrNull(m)?g:m}setItem(p,g){this.setItems([{key:p,data:g}])}setItems(p){let g=!1;for(const{key:m,data:D}of p)this.storage[m]!==D&&(A.isUndefinedOrNull(D)?A.isUndefined(this.storage[m])||(this.storage[m]=void 0,g=!0):(this.storage[m]=D,g=!0));g&&this.save()}removeItem(p){A.isUndefined(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,y.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(g){this.logService.error(g)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class bt{constructor(p,g,m){this.fileStorage=new i(v.URI.file(L.join(p.userDataPath,bt.STATE_FILE)),g,m)}async init(){return this.fileStorage.init()}getItem(p,g){return this.fileStorage.getItem(p,g)}setItem(p,g){this.fileStorage.setItem(p,g)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,E.IEnvironmentMainService),te(1,S.ILogService),te(2,w.IFileService)],I),e.StateMainService=I}),define(J[77],x([0,1,5,9,17,18,22,41,24,6,49,25]),function($,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function k(g,m,D){return`${D.updateUrl}/api/update/${g}/${m}/${D.commit}`}e.createUpdateURL=k;let p=class{constructor(m,D,b,l,u,o){this.lifecycleMainService=m,this.configurationService=D,this.environmentMainService=b,this.requestService=l,this.logService=u,this.productService=o,this._state=n.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=A.getMigratedSettingValue(this.configurationService,"update.mode","update.channel"),D=this.getProductQuality(m);if(!D){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(D),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,b=>this.logService.error(b))}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return L.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},I.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};p=he([te(0,S.ILifecycleMainService),te(1,A.IConfigurationService),te(2,w.IEnvironmentMainService),te(3,i.IRequestService),te(4,y.ILogService),te(5,E.IProductService)],p),e.AbstractUpdateService=p}),define(J[226],x([0,1,14,2,5,46,17,18,41,31,24,6,77,49,22]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends k.AbstractUpdateService{constructor(b,l,u,o,a,t,r){super(b,l,o,a,t,r);this.telemetryService=u,this.disposables=new L.DisposableStore}get onRawError(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"error",(b,l)=>l)}get onRawUpdateNotAvailable(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(b,l,u)=>({url:l,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return A.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(b,l,u,o)=>({releaseNotes:l,version:u,productVersion:u,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(b){this.logService.error("UpdateService error:",b);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?b:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(b){let l;this.productService.darwinUniversalAssetId?l=this.productService.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const u=k.createUpdateURL(l,b,this.productService);try{v.autoUpdater.setFeedURL({url:u})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return u}doCheckForUpdates(b){this.setState(w.State.CheckingForUpdates(b)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(b){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(b))}onUpdateDownloaded(b){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:b.version}),this.setState(w.State.Ready(b)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([S.memoize],m.prototype,"onRawError",null),he([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([S.memoize],m.prototype,"onRawUpdateAvailable",null),he([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,y.ITelemetryService),te(3,i.IEnvironmentMainService),te(4,p.IRequestService),te(5,I.ILogService),te(6,g.IProductService)],m),e.DarwinUpdateService=m}),define(J[227],x([0,1,22,17,18,41,31,24,6,77,49,25,45]),function($,e,v,L,A,S,E,n,w,y,i,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends y.AbstractUpdateService{constructor(m,D,b,l,u,o,a,t){super(m,D,l,u,o,t);this.telemetryService=b,this.nativeHostMainService=a}buildUpdateFeedUrl(m){return y.createUpdateURL(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},I.CancellationToken.None).then(i.asJson).then(D=>{!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(D))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const b=m?D.message||D:void 0;this.setState(S.State.Idle(1,b))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};p=he([te(0,A.ILifecycleMainService),te(1,L.IConfigurationService),te(2,E.ITelemetryService),te(3,n.IEnvironmentMainService),te(4,i.IRequestService),te(5,w.ILogService),te(6,k.INativeHostMainService),te(7,v.IProductService)],p),e.LinuxUpdateService=p}),define(J[228],x([0,1,5,9,18,41,24,6,8,29,40,31]),function($,e,v,L,A,S,E,n,w,y,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let k=class{constructor(m,D,b){if(this.lifecycleMainService=m,this.logService=b,this._state=S.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,D.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,l=>this.logService.error(l))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return L.timeout(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};k=he([te(0,A.ILifecycleMainService),te(1,E.IEnvironmentMainService),te(2,n.ILogService)],k);let p=class extends k{constructor(m,D,b,l,u,o){super(b,l,u);this.snap=m,this.snapRevision=D,this.telemetryService=o;const a=y.watch(w.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(a,"change",(d,f)=>f),r=v.Event.filter(t,d=>d==="current"),c=v.Event.debounce(r,(d,f)=>f,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{c.dispose(),a.close()})}doCheckForUpdates(){this.setState(S.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(S.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),i.spawn("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((b,l)=>y.realpath(`${w.dirname(this.snap)}/current`,(u,o)=>u?l(u):b(o))),D=w.basename(m);return this.snapRevision!==D}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=he([te(2,A.ILifecycleMainService),te(3,E.IEnvironmentMainService),te(4,n.ILogService),te(5,I.ITelemetryService)],p),e.SnapUpdateService=p}),define(J[229],x([0,1,29,8,16,46,17,18,22,41,31,24,6,77,49,112,26,40,25,9,21,7,45]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,h=1e3){for(;!f();)await u.timeout(h)}let s;function c(){return typeof s=="undefined"&&(s=v.existsSync(L.join(L.dirname(process.execPath),"unins000.exe"))?0:1),s}let d=class extends p.AbstractUpdateService{constructor(h,M,T,U,H,X,ee,B,Y){super(h,M,U,H,X,Y);this.telemetryService=T,this.fileService=ee,this.nativeHostMainService=B}get cachePath(){const h=L.join(D.tmpdir(),`vscode-update-${this.productService.target}-${process.arch}`);return A.Promises.mkdir(h,{recursive:!0}).then(()=>h)}initialize(){super.initialize(),c()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(h){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),c()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),p.createUpdateURL(M,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(y.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},l.CancellationToken.None).then(g.asJson).then(M=>{const T=c();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(y.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(y.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(y.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(U=>A.exists(U).then(H=>{if(H)return Promise.resolve(U);const X=M.url,ee=M.hash,B=`${U}.tmp`;return this.requestService.request({url:X},l.CancellationToken.None).then(Y=>this.fileService.writeFile(a.URI.file(B),Y.stream)).then(ee?()=>m.checksum(B,M.hash):()=>{}).then(()=>A.Promises.rename(B,U)).then(()=>U)})).then(U=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},H&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(y.State.Downloaded(M)):this.setState(y.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const T=h?M.message||M:void 0;this.setState(y.State.Idle(c(),T))}))}async doDownloadUpdate(h){h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(y.State.Idle(c()))}async getUpdatePackagePath(h){const M=await this.cachePath;return L.join(M,`CodeSetup-${this.productService.quality}-${h}.exe`)}async cleanup(h=null){const M=h?X=>!new RegExp(`${this.productService.quality}-${h}\\.exe$`).test(X):()=>!0,T=await this.cachePath,H=(await A.readdir(T)).filter(M).map(async X=>{try{await A.Promises.unlink(L.join(T,X))}catch(ee){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const h=this.state.update;this.setState(y.State.Updating(h));const M=await this.cachePath;this.availableUpdate.updateFilePath=L.join(M,`CodeSetup-${this.productService.quality}-${h.version}.flag`),await A.writeFile(this.availableUpdate.updateFilePath,"flag"),b.spawn(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(y.State.Idle(c()))});const U=`${this.productService.win32MutexName}-ready`,H=await new Promise((X,ee)=>{$(["windows-mutex"],X,ee)});r(()=>H.isActive(U)).then(()=>this.setState(y.State.Ready(h)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):b.spawn(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return c()}};he([S.memoize],d.prototype,"cachePath",null),d=he([te(0,n.ILifecycleMainService),te(1,E.IConfigurationService),te(2,i.ITelemetryService),te(3,I.IEnvironmentMainService),te(4,g.IRequestService),te(5,k.ILogService),te(6,o.IFileService),te(7,t.INativeHostMainService),te(8,w.IProductService)],d),e.Win32UpdateService=d}),define(J[52],x([0,1,28,24,8,16,29,3,5,6,58,43,10,2,15,4,153,22,14,13,50,51,100]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=m.createDecorator("workspacesManagementMainService");let r=class extends p.Disposable{constructor(f,h,M,T,U){super();this.environmentMainService=f,this.logService=h,this.backupMainService=M,this.dialogMainService=T,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==k.Schemas.file)return;let h;try{h=E.readFileSync(f.fsPath,"utf8")}catch(M){return}return this.doResolveWorkspace(f,h)}isWorkspacePath(f){return v.isUntitledWorkspace(f,this.environmentMainService)||v.hasWorkspaceFileExtension(f)}doResolveWorkspace(f,h){try{const M=this.doParseStoredWorkspace(f,h),T=s(f);return{id:T.id,configPath:T.configPath,folders:v.toWorkspaceFolders(M.folders,T.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:M.remoteAuthority}}catch(M){this.logService.warn(M.toString())}}doParseStoredWorkspace(f,h){const M=I.parse(h);if(M&&Array.isArray(M.folders))M.folders=M.folders.filter(T=>v.isStoredWorkspaceFolder(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return M}async createUntitledWorkspace(f,h){const{workspace:M,storedWorkspace:T}=this.newUntitledWorkspace(f,h),U=M.configPath.fsPath;return await S.Promises.mkdir(A.dirname(U),{recursive:!0}),await S.writeFile(U,JSON.stringify(T,null,"	")),M}createUntitledWorkspaceSync(f,h){const{workspace:M,storedWorkspace:T}=this.newUntitledWorkspace(f,h),U=M.configPath.fsPath;return E.mkdirSync(A.dirname(U),{recursive:!0}),S.writeFileSync(U,JSON.stringify(T,null,"	")),M}newUntitledWorkspace(f=[],h){const M=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=g.joinPath(this.untitledWorkspacesHome,M),U=g.joinPath(T,v.UNTITLED_WORKSPACE_NAME),H=[];for(const X of f)H.push(v.getStoredWorkspaceFolder(X.uri,!0,X.name,T,!n.isWindows,g.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:H,remoteAuthority:h}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return v.isUntitledWorkspace(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const h=g.originalFSPath(f.configPath);try{S.rimrafSync(A.dirname(h));const M=A.join(this.environmentMainService.workspaceStorageHome.fsPath,f.id);E.existsSync(M)&&S.writeFileSync(A.join(M,"obsolete"),"")}catch(M){this.logService.warn(`Unable to delete untitled workspace ${h} (${M}).`)}}getUntitledWorkspacesSync(){const f=[];try{const h=S.readdirSync(this.untitledWorkspacesHome.fsPath).map(M=>g.joinPath(this.untitledWorkspacesHome,M,v.UNTITLED_WORKSPACE_NAME));for(const M of h){const T=s(M),U=this.resolveLocalWorkspaceSync(M);U?f.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return f}async enterWorkspace(f,h,M){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,h,M))return;const U=this.doEnterWorkspace(f,s(M));if(!!U)return this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U}async isValidTargetWorkspacePath(f,h,M){if(!M)return!0;if(v.isWorkspaceIdentifier(f.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,M))return!1;if(t.findWindowOnWorkspaceOrFolder(h,M)){const T={title:this.productService.nameLong,type:"info",buttons:[D.localize(0,null)],message:D.localize(1,null,g.basename(M)),detail:D.localize(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,u.withNullAsUndefined(l.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,h){if(!f.config)return;f.focus();let M;return f.config.extensionDevelopmentPath||(M=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:f.remoteAuthority},f.config.backupPath)),v.isWorkspaceIdentifier(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=h,f.config.backupPath=M,{workspace:h,backupPath:M}}};r=he([te(0,L.IEnvironmentMainService),te(1,y.ILogService),te(2,o.IBackupMainService),te(3,a.IDialogMainService),te(4,b.IProductService)],r),e.WorkspacesManagementMainService=r;function s(d){function f(){let h=d.scheme===k.Schemas.file?g.originalFSPath(d):d.toString();return n.isLinux||(h=h.toLowerCase()),i.createHash("md5").update(h).digest("hex")}return{id:f(),configPath:d}}e.getWorkspaceIdentifier=s;function c(d,f){function h(){if(d.scheme!==k.Schemas.file)return i.createHash("md5").update(d.toString()).digest("hex");if(!f)try{f=E.statSync(d.fsPath)}catch(U){return}let T;return n.isLinux?T=f.ino:n.isMacintosh?T=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),i.createHash("md5").update(d.fsPath).update(T?String(T):"").digest("hex")}const M=h();if(typeof M=="string")return{id:M,uri:d}}e.getSingleFolderWorkspaceIdentifier=c}),define(J[101],x([0,1,6,98,3,4,34,16,52,17,7,14,35,54,25,28,13]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=S.createDecorator(e.ID);let b=class{constructor(u,o,a,t,r){this.logService=u,this.windowsMainService=o,this.urlService=a,this.workspacesManagementMainService=t,this.configurationService=r}async start(u,o){this.logService.trace("Received data from other instance: ",u,o),A.isMacintosh&&I.app.focus({steal:!0});const a=this.parseOpenUrl(u);if(a.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:s}of a)this.urlService.open(r,{originalUrl:s})})}else return this.startOpenWindow(u,o)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?k.coalesce(u._urls.map(o=>{try{return{uri:i.URI.parse(o),url:o}}catch(a){return null}})):[]}async startOpenWindow(u,o){const a=p.isLaunchedFromCli(o)?0:4;let t=[];const r=u.wait&&u.waitMarkerFilePath?i.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:a,cli:u,userEnv:o,waitMarkerFileURI:r,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let c=!1;if(u["new-window"]||u["unity-launch"])c=!0;else if(u["reuse-window"])c=!1;else{const d=this.configurationService.getValue("window");switch((d==null?void 0:d.openWithoutArgumentsInNewWindow)||"default"){case"on":c=!0;break;case"off":c=!1;break;default:c=!A.isMacintosh}}if(c)t=this.windowsMainService.open({context:a,cli:u,userEnv:o,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:s});else{const d=this.windowsMainService.getLastActiveWindow();d?(d.focus(),t=[d]):t=this.windowsMainService.open({context:a,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:a,cli:u,userEnv:o,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:u.goto,remoteAuthority:s});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,n.whenDeleted(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return I.BrowserWindow.getAllWindows().forEach(o=>{const a=this.windowsMainService.getWindowById(o.id);a?u.push(this.codeWindowToInfo(a)):u.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!I.app.accessibilitySupportEnabled,gpuFeatureStatus:I.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(r=>{const s=t.remoteAuthority;if(s){const c=`vscode:getDiagnosticInfoResponse${t.id}`,d={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",g.CancellationToken.None,{replyChannel:c,args:d}),I.ipcMain.once(c,(f,h)=>{h||r({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),r(h)}),setTimeout(()=>{r({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const o=[],a=u.openedWorkspace;if(m.isSingleFolderWorkspaceIdentifier(a))o.push(a.uri);else if(m.isWorkspaceIdentifier(a)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(a.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(u){const o=this.getFolderURIs(u),a=D.assertIsDefined(u.win);return this.browserWindowToInfo(a,o,u.remoteAuthority)}browserWindowToInfo(u,o=[],a){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:o,remoteAuthority:a}}};b=he([te(0,v.ILogService),te(1,E.IWindowsMainService),te(2,L.IURLService),te(3,w.IWorkspacesManagementMainService),te(4,y.IConfigurationService)],b),e.LaunchMainService=b}),define(J[230],x([0,1,143,26,47,14,101,70,24,3,6,83,51,4,61,10,45,55,2]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=p.createDecorator("issueMainService");let u=class Et{constructor(a,t,r,s,c,d,f,h){this.userEnv=a,this.environmentMainService=t,this.launchMainService=r,this.logService=s,this.diagnosticsService=c,this.dialogMainService=d,this.nativeHostMainService=f,this.protocolMainService=h,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(a,"vscode:issueSystemInfoResponse",s)}),S.ipcMain.on("vscode:listProcesses",async a=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:v.localize(0,null),rootProcess:await I.listProcesses(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(c=>{n.isRemoteDiagnosticError(c)?t.push({name:c.hostName,rootProcess:c}):c.processes&&t.push({name:c.hostName,rootProcess:c.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(a,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async a=>{const t={message:v.localize(1,null),type:"warning",buttons:[v.localize(2,null),v.localize(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const t=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={message:v.localize(4,null),type:"warning",buttons:[v.localize(5,null),v.localize(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(a,t)=>{const{id:r,from:s,args:c}=t;let d;switch(s){case"issueReporter":d=this.issueReporterParentWindow;break;case"processExplorer":d=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}d&&d.webContents.send("vscode:runAction",{id:r,from:s,args:c})}),S.ipcMain.on("vscode:openExternal",(a,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async a=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",t.windows)})}safeSend(a,t,...r){a.sender.isDestroyed()||a.sender.send(t,...r)}async openReporter(a){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new l.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,s,{backgroundColor:a.styles.backgroundColor,title:v.localize(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:L.type(),arch:L.arch(),release:L.release()},product:A.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",$,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(a){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new l.DisposableStore,s=r.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,s,{backgroundColor:a.styles.backgroundColor,title:v.localize(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:A.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",$,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(a,t,r){const s=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:r.title,backgroundColor:r.backgroundColor||Et.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:y.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:g.zoomLevelToZoomFactor(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[a,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,t)}getWindowPosition(a,t,r){let s;const c=S.screen.getAllDisplays();if(c.length===1)s=c[0];else{if(y.isMacintosh){const h=S.screen.getCursorScreenPoint();s=S.screen.getDisplayNearestPoint(h)}!s&&a&&(s=S.screen.getDisplayMatching(a.getBounds())),s||(s=S.screen.getPrimaryDisplay()||c[0])}const d={width:t,height:r},f=s.bounds;return d.x=f.x+f.width/2-d.width/2,d.y=f.y+f.height/2-d.height/2,f.width>0&&f.height>0&&(d.x<f.x&&(d.x=f.x),d.y<f.y&&(d.y=f.y),d.x>f.x+f.width&&(d.x=f.x),d.y>f.y+f.height&&(d.y=f.y),d.width>f.width&&(d.width=f.width),d.height>f.height&&(d.height=f.height)),d}async getPerformanceInfo(){try{const[a,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,t)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([te(1,w.IEnvironmentMainService),te(2,E.ILaunchMainService),te(3,i.ILogService),te(4,n.IDiagnosticsService),te(5,k.IDialogMainService),te(6,D.INativeHostMainService),te(7,b.IProtocolMainService)],u),e.IssueMainService=u}),define(J[231],x([0,1,8,149,72,5,7,14,24,6,17,22,61,2,3,34,28,52,50,198,60,31,51,39,202,18,99,21,10,54,25,55]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t,r,s,c,d,f,h,M,T,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(ee){ee[ee.NONE=0]="NONE",ee[ee.LOADING=1]="LOADING",ee[ee.NAVIGATING=2]="NAVIGATING",ee[ee.READY=3]="READY"})(H||(H={}));let X=class extends p.Disposable{constructor(B,Y,Q,N,G,z,C,F,R,O,P,W,_,q){super();this.logService=Y,this.environmentMainService=Q,this.fileService=N,this.configurationService=z,this.themeMainService=C,this.workspacesManagementMainService=F,this.backupMainService=R,this.telemetryService=O,this.dialogMainService=P,this.lifecycleMainService=W,this.productService=_,this.protocolMainService=q,this._onWillLoad=this._register(new S.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new S.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new S.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new S.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[V,K]=this.restoreWindowState(B.state);this.windowState=V,this.logService.trace("window#ctor: using window state",V);const Z=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!Z,title:this.productService.nameLong,webPreferences:Object.assign({preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",$).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:g.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:k.zoomLevelToZoomFactor(ne==null?void 0:ne.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};g.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${g.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),g.isLinux?re.icon=v.join(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=v.join(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),g.isMacintosh&&(re.acceptFirstMouse=!0,(ne==null?void 0:ne.clickThroughInactive)===!1&&(re.acceptFirstMouse=!1));const se=g.isMacintosh&&(ne==null?void 0:ne.nativeTabs)===!0;se&&(re.tabbingIdentifier=this.productService.nameShort);const le=k.getTitleBarStyle(this.configurationService)==="custom";if(le&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(re.frame=!1)),A.mark("code/willCreateCodeBrowserWindow"),this._win=new n.BrowserWindow(re),A.mark("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&le&&this._win.setSheetOffset(22),g.isMacintosh&&K&&(!se||n.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(oe=>typeof oe=="number")){const oe=this.windowState;this._win.setBounds({width:oe.width,height:oe.height,x:oe.x,y:oe.y})}Z&&(A.mark("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),A.mark("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=u.resolveMarketplaceHeaders(this.productService.version,this.environmentMainService,this.fileService,{get:V=>G.globalStorage.get(V),store:(V,K)=>G.globalStorage.set(V,K)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.backupPath}get openedWorkspace(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.workspace}get remoteAuthority(){var B;return(B=this.currentConfig)===null||B===void 0?void 0:B.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionDevelopmentPath)}get isExtensionTestHost(){var B;return!!((B=this.currentConfig)===null||B===void 0?void 0:B.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var B;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((B=this.currentConfig)===null||B===void 0?void 0:B.debugId)}setRepresentedFilename(B){g.isMacintosh?this._win.setRepresentedFilename(B):this.representedFilename=B}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(B){g.isMacintosh&&this._win.setDocumentEdited(B),this.documentEdited=B}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(B){g.isMacintosh&&(B==null?void 0:B.force)&&n.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(B=>{if(this.isReady)return B(this);this.whenReadyCallbacks.push(B)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(B=>{function Y(){Q.dispose(),N.dispose(),B()}const Q=this.onDidClose(()=>Y()),N=this.onWillLoad(()=>Y())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(G,z)=>this.onWindowError(2,z)),this._win.webContents.on("did-fail-load",(G,z,C)=>this.onWindowError(3,C)),this._win.webContents.on("will-prevent-unload",G=>{G.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const B=new Set([h.Schemas.file,h.Schemas.vscodeFileResource,h.Schemas.vscodeRemoteResource,"devtools"]),Y=G=>{for(let z=G;z;z=z.parent)if(z.url.startsWith(`${h.Schemas.vscodeWebview}://`))return!0;return!1},Q=G=>G.resourceType==="xhr"||Y(G.frame);this._win.webContents.session.webRequest.onBeforeRequest((G,z)=>{const C=E.URI.parse(G.url);return C.path.endsWith(".svg")&&!(B.has(C.scheme)||C.path.includes(h.Schemas.vscodeRemoteResource))?z({cancel:!Q(G)}):z({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((G,z)=>{const C=G.responseHeaders,F=C["content-type"]||C["Content-Type"];if(F&&Array.isArray(F)){const R=E.URI.parse(G.url);if(R.path.endsWith(".svg")&&B.has(R.scheme))return C["Content-Type"]=["image/svg+xml"],z({cancel:!1,responseHeaders:C});if(!R.path.includes(h.Schemas.vscodeRemoteResource)&&F.some(O=>O.toLowerCase().includes("image/svg")))return z({cancel:!Q(G)})}return z({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!0),n.app.emit("browser-window-maximize",G,this._win)}),this._win.on("unmaximize",G=>{this.currentConfig&&(this.currentConfig.maximized=!1),n.app.emit("browser-window-unmaximize",G,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(G=>this.onDidDeleteUntitledWorkspace(G)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(G,z)=>{const C=await this.marketplaceHeadersPromise;z({cancel:!1,requestHeaders:Object.assign(G.requestHeaders,C)})})}async onWindowError(B,Y){var Q;switch(B){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof Y=="string"?Y:Y==null?void 0:Y.reason}, code: ${typeof Y=="string"?"<unknown>":(Q=Y==null?void 0:Y.exitCode)!==null&&Q!==void 0?Q:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof Y=="string"?Y:Y==null?void 0:Y.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:B,reason:typeof Y!="string"?Y==null?void 0:Y.reason:void 0}),B===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(0,null)),r.mnemonicButtonLabel(L.localize(1,null)),r.mnemonicButtonLabel(L.localize(2,null))],message:L.localize(3,null),detail:L.localize(4,null),noLink:!0},this._win);if(!this._win)return;N.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):N.response===2&&this.destroyWindow()}else if(B===2){let N;typeof Y=="string"||!Y?N=L.localize(5,null):N=L.localize(6,null,Y.reason);const G=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[r.mnemonicButtonLabel(L.localize(7,null)),r.mnemonicButtonLabel(L.localize(8,null))],message:N,detail:L.localize(9,null),noLink:!0},this._win);if(!this._win)return;G.response===0?this.reload():G.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(B){var Y;((Y=this.openedWorkspace)===null||Y===void 0?void 0:Y.id)===B.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const B=this.getMenuBarVisibility();B!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=B,this.setMenuBarVisibility(B));let Y=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(Y==null?void 0:Y.endsWith("/"))&&(Y=Y.substr(0,Y.length-1));const Q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((Y||"").indexOf("@")===-1&&(Y!==this.currentHttpProxy||Q!==this.currentNoProxy)){this.currentHttpProxy=Y,this.currentNoProxy=Q;const N=Y||"",G=Q?`${Q},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${G}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:G,pacScript:""})}}addTabbedWindow(B){g.isMacintosh&&B.win&&this._win.addTabbedWindow(B.win)}load(B,Y=Object.create(null)){this.isDocumentEdited()&&(!Y.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),Y.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(B,Y),this.readyState===0?this.currentConfig=B:(this.pendingLoadConfig=B,this.readyState=2),this._win.loadURL(h.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",$).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:B.workspace})}updateConfiguration(B,Y){var Q,N;const G=(N=(Q=this.currentConfig)!==null&&Q!==void 0?Q:this.pendingLoadConfig)===null||N===void 0?void 0:N.userEnv;G&&M.isLaunchedFromCli(G)&&!M.isLaunchedFromCli(B.userEnv)&&(B.userEnv=Object.assign(Object.assign({},G),B.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(B.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),Y.disableExtensions!==void 0&&(B["disable-extensions"]=Y.disableExtensions),B.fullscreen=this.isFullScreen,B.maximized=this._win.isMaximized(),B.partsSplash=this.themeMainService.getWindowSplash(),A.mark("code/willOpenNewWindow"),B.perfMarks=A.getMarks(),this.configObjectUrl.update(B)}async reload(B){const Y=Object.assign({},this.currentConfig);Y.workspace=await this.validateWorkspace(Y),delete Y.filesToOpenOrCreate,delete Y.filesToDiff,delete Y.filesToWait,this.isExtensionDevelopmentHost&&B&&(Y.verbose=B.verbose,Y.debugId=B.debugId,Y["inspect-extensions"]=B["inspect-extensions"],Y["inspect-brk-extensions"]=B["inspect-brk-extensions"],Y["extensions-dir"]=B["extensions-dir"]),Y.isInitialStartup=!1,this.load(Y,{isReload:!0,disableExtensions:B==null?void 0:B["disable-extensions"]})}async validateWorkspace(B){if(D.isWorkspaceIdentifier(B.workspace)){const Y=B.workspace.configPath;if(Y.scheme===h.Schemas.file&&!await this.fileService.exists(Y))return}else if(D.isSingleFolderWorkspaceIdentifier(B.workspace)){const Y=B.workspace.uri;if(Y.scheme===h.Schemas.file&&!await this.fileService.exists(Y))return}return B.workspace}serializeWindowState(){if(!this._win)return m.defaultWindowState();if(this.isFullScreen){let Q;try{Q=n.screen.getDisplayMatching(this.getBounds())}catch(z){}const N=m.defaultWindowState();return{mode:3,display:Q?Q.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const B=Object.create(null);let Y;if(!g.isMacintosh&&this._win.isMaximized()?Y=0:Y=1,Y===0?B.mode=0:B.mode=1,Y===1||Y===0){let Q;Y===1?Q=this.getBounds():Q=this._win.getNormalBounds(),B.x=Q.x,B.y=Q.y,B.width=Q.width,B.height=Q.height}return B}restoreWindowState(B){A.mark("code/willRestoreCodeWindowState");let Y=!1;if(B)try{const Q=n.screen.getAllDisplays();Y=Q.length>1,B=this.validateWindowState(B,Q)}catch(Q){this.logService.warn(`Unexpected error validating window state: ${Q}
${Q.stack}`)}return A.mark("code/didRestoreCodeWindowState"),[B||m.defaultWindowState(),Y]}validateWindowState(B,Y){var Q,N;if(this.logService.trace(`window#validateWindowState: validating window state on ${Y.length} display(s)`,B),typeof B.x!="number"||typeof B.y!="number"||typeof B.width!="number"||typeof B.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(B.width<=0||B.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(Y.length===1){const C=this.getWorkingArea(Y[0]);if(C){let F=function(){!B||typeof B.x!="number"||typeof B.y!="number"||!C||(B.x<C.x&&(B.x=C.x),B.y<C.y&&(B.y=C.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",C),F(),B.width>C.width&&(B.width=C.width),B.height>C.height&&(B.height=C.height),B.x>C.x+C.width-128&&(B.x=C.x+C.width-B.width),B.y>C.y+C.height-128&&(B.y=C.y+C.height-B.height),F()}return B}if(B.display&&B.mode===3){const C=Y.find(F=>F.id===B.display);if(C&&typeof((Q=C.bounds)===null||Q===void 0?void 0:Q.x)=="number"&&typeof((N=C.bounds)===null||N===void 0?void 0:N.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const F=m.defaultWindowState(3);return F.x=C.bounds.x,F.y=C.bounds.y,F}}let G,z;try{G=n.screen.getDisplayMatching({x:B.x,y:B.y,width:B.width,height:B.height}),z=this.getWorkingArea(G)}catch(C){}if(G&&z&&B.x+B.width>z.x&&B.y+B.height>z.y&&B.x<z.x+z.width&&B.y<z.y+z.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",z),B}getWorkingArea(B){if(B.workArea.width>0&&B.workArea.height>0)return B.workArea;if(B.bounds.width>0&&B.bounds.height>0)return B.bounds}getBounds(){const[B,Y]=this._win.getPosition(),[Q,N]=this._win.getSize();return{x:B,y:Y,width:Q,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(B){this.useNativeFullScreen()?this.setNativeFullScreen(B):this.setSimpleFullScreen(B),this.sendWhenReady(B?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(B){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(B)}setSimpleFullScreen(B){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(B),this._win.webContents.focus()}useNativeFullScreen(){const B=this.configurationService.getValue("window");return!B||typeof B.nativeFullScreen!="boolean"||B.nativeTabs?!0:B.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let B=k.getMenuBarVisibility(this.configurationService);return["visible","toggle","hidden"].indexOf(B)<0&&(B="classic"),B}setMenuBarVisibility(B,Y=!0){g.isMacintosh||(B==="toggle"&&Y&&this.send("vscode:showInfoMessage",L.localize(10,null)),B==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(B)}):this.doSetMenuBarVisibility(B))}doSetMenuBarVisibility(B){const Y=this.isFullScreen;switch(B){case"classic":this._win.setMenuBarVisibility(!Y),this._win.autoHideMenuBar=Y;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(B,Y,...Q){this.isReady?this.send(B,...Q):this.ready().then(()=>{Y.isCancellationRequested||this.send(B,...Q)})}send(B,...Y){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${B} for window that is destroyed`);return}this._win.webContents.send(B,...Y)}}updateTouchBar(B){!g.isMacintosh||this.touchBarGroups.forEach((Y,Q)=>{const N=B[Q];Y.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!g.isMacintosh){for(let B=0;B<10;B++){const Y=this.createTouchBarGroup();this.touchBarGroups.push(Y)}this._win.setTouchBar(new n.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(B=[]){const Y=this.createTouchBarGroupSegments(B),Q=new n.TouchBar.TouchBarSegmentedControl({segments:Y,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:Q.segments[N].id,from:"touchbar"})}});return Q}createTouchBarGroupSegments(B=[]){return B.map(Q=>{var N,G;let z;Q.icon&&!s.ThemeIcon.isThemeIcon(Q.icon)&&((G=(N=Q.icon)===null||N===void 0?void 0:N.dark)===null||G===void 0?void 0:G.scheme)===h.Schemas.file&&(z=n.nativeImage.createFromPath(E.URI.revive(Q.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let C;return typeof Q.title=="string"?C=Q.title:C=Q.title.value,{id:Q.id,label:z?void 0:C,icon:z}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};X=he([te(1,y.ILogService),te(2,w.IEnvironmentMainService),te(3,f.IFileService),te(4,d.IStorageMainService),te(5,i.IConfigurationService),te(6,o.IThemeMainService),te(7,b.IWorkspacesManagementMainService),te(8,l.IBackupMainService),te(9,a.ITelemetryService),te(10,t.IDialogMainService),te(11,c.ILifecycleMainService),te(12,I.IProductService),te(13,U.IProtocolMainService)],X),e.CodeWindow=X}),define(J[62],x([0,1,152,35,38,14,6,39,5,3,28,52,9,15,7,10,16,18,4,2]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=l.createDecorator("workspacesHistoryMainService");let o=class Ve extends u.Disposable{constructor(f,h,M,T){super();this.stateMainService=f,this.logService=h,this.workspacesManagementMainService=M,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new k.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!y.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const h=[],M=[];for(let T of f)if(i.isRecentWorkspace(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&r(h,T.workspace)===-1&&h.push(T);else if(i.isRecentFolder(T))s(h,T.folderUri)===-1&&h.push(T);else{const U=c(M,T.fileUri)>=0,H=T.fileUri.scheme===m.Schemas.file&&Ve.COMMON_FILES_FILTER.indexOf(p.basename(T.fileUri))>=0;!U&&!H&&(M.push(T),y.isWindows&&T.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(h,M),h.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(h.length=Ve.MAX_TOTAL_RECENT_ENTRIES),M.length>Ve.MAX_TOTAL_RECENT_ENTRIES&&(M.length=Ve.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:h,files:M}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const h=H=>{const X=t(H);for(const ee of f)if(p.extUriBiasedIgnorePathCase.isEqual(ee,X))return!1;return!0},M=this.getRecentlyOpened(),T=M.workspaces.filter(h),U=M.files.filter(h);(T.length!==M.workspaces.length||U.length!==M.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),y.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!y.isMacintosh)return;S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),h=[];let M=0;for(let U=0;U<f.workspaces.length&&M<Ve.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const H=t(f.workspaces[U]);if(H.scheme===m.Schemas.file){const X=p.originalFSPath(H);await D.exists(X)&&(h.push(X),M++)}}const T=[];for(let U=0;U<f.files.length&&M<Ve.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const H=t(f.files[U]);if(H.scheme===m.Schemas.file){const X=p.originalFSPath(H);if(Ve.COMMON_FILES_FILTER.includes(p.basename(H))||h.includes(X))continue;await D.exists(X)&&(T.push(X),M++)}}T.reverse().forEach(U=>S.app.addRecentDocument(U)),h.reverse().forEach(U=>S.app.addRecentDocument(U))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var h,M;const T=[],U=[],H=(h=f==null?void 0:f.config)===null||h===void 0?void 0:h.workspace;i.isWorkspaceIdentifier(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?T.push({workspace:H}):i.isSingleFolderWorkspaceIdentifier(H)&&T.push({folderUri:H.uri});const X=(M=f==null?void 0:f.config)===null||M===void 0?void 0:M.filesToOpenOrCreate;if(X)for(let ee of X){const B=ee.fileUri;B&&c(U,B)===-1&&U.push({fileUri:B})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(f,h){let M=this.getRecentlyOpenedFromStorage();for(let T of M.workspaces){let U=i.isRecentFolder(T)?s(f,T.folderUri):r(f,T.workspace);U>=0?f[U].label=f[U].label||T.label:f.push(T)}for(let T of M.files){let U=c(h,T.fileUri);U>=0?h[U].label=h[U].label||T.label:h.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(Ve.recentlyOpenedStorageKey);return i.restoreRecentlyOpened(f,this.logService)}saveRecentlyOpened(f){const h=i.toStoreData(f);this.stateMainService.setItem(Ve.recentlyOpenedStorageKey,h)}updateWindowsJumpList(){if(!y.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:v.localize(0,null),description:v.localize(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let h=[];for(let U of S.app.getJumpListSettings().removedItems){const H=U.args;if(H){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);X&&h.push(g.URI.parse(X[2]))}}this.removeRecentlyOpened(h);let M=!1;const T=L.coalesce(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const H=i.isRecentWorkspace(U)?U.workspace:U.folderUri,{title:X,description:ee}=this.getWindowsJumpListLabel(H,U.label);let B;return g.URI.isUri(H)?B=`--folder-uri "${H.toString()}"`:(M=!0,B=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:ee.substr(0,255),program:process.execPath,args:B,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:M?v.localize(2,null):v.localize(3,null),items:T})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(h){this.logService.warn("updateWindowsJumpList#setJumpList",h)}}getWindowsJumpListLabel(f,h){if(h)return{title:n.splitName(h).name,description:h};if(g.URI.isUri(f))return{title:p.basename(f),description:a(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:v.localize(4,null),description:""};let M=p.basename(f.configPath);return M.endsWith(i.WORKSPACE_EXTENSION)&&(M=M.substr(0,M.length-i.WORKSPACE_EXTENSION.length-1)),{title:v.localize(5,null,M),description:a(f.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([te(0,A.IStateMainService),te(1,E.ILogService),te(2,I.IWorkspacesManagementMainService),te(3,b.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function a(d){return d.scheme==="file"?n.normalizeDriveLetter(d.fsPath):d.toString()}function t(d){return i.isRecentFolder(d)?d.folderUri:i.isRecentFile(d)?d.fileUri:d.workspace.configPath}function r(d,f){return d.findIndex(h=>i.isRecentWorkspace(h)&&h.workspace.id===f.id)}function s(d,f){return d.findIndex(h=>i.isRecentFolder(h)&&p.extUriBiasedIgnorePathCase.isEqual(h.folderUri,f))}function c(d,f){return d.findIndex(h=>p.extUriBiasedIgnorePathCase.isEqual(h.fileUri,f))}}),define(J[232],x([0,1,144,3,24,14,61,17,31,41,22,9,6,39,34,62,181,7,38,18,45,25]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class vt{constructor(d,f,h,M,T,U,H,X,ee,B,Y){this.updateService=d,this.configurationService=f,this.windowsMainService=h,this.environmentMainService=M,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateMainService=H,this.lifecycleMainService=X,this.logService=ee,this.nativeHostMainService=B,this.productService=Y,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new I.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new I.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(L.isMacintosh||E.getTitleBarStyle(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const d=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);d&&(d.menus&&(this.menubarMenus=d.menus),d.keybindings&&(this.keybindings=d.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,H,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,H,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const d=this.productService.twitterUrl;d&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(d,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const h=this.productService.reportIssueUrl;h&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(h,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(L.language){const U=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${U}lang=${L.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(L.language){const U=M.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${L.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(d=>this.onDidChangeWindowsCount(d)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let d=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof d!="boolean"&&(d=!0),d}get currentEnableNativeTabs(){if(!L.isMacintosh)return!1;let d=this.configurationService.getValue("window.nativeTabs");return typeof d!="boolean"&&(d=!1),d}updateMenu(d,f){this.menubarMenus=d.menus,this.keybindings=d.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,d),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(d){!L.isMacintosh||(d.oldCount===0&&d.newCount>0||d.oldCount>0&&d.newCount===0)&&(this.closedLastWindow=d.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!L.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const d=S.Menu.getApplicationMenu();if(d&&this.oldMenus.push(d),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(L.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let h;if(L.isMacintosh){const T=new S.Menu;h=new S.MenuItem({label:this.productService.nameShort,submenu:T}),this.setMacApplicationMenu(T),f.append(h)}if(L.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const T=new S.Menu;T.append(new S.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(T)}if(this.shouldDrawMenu("File")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:T});this.setMenuById(T,"File"),f.append(U)}if(this.shouldDrawMenu("Edit")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:T});this.setMenuById(T,"Edit"),f.append(U)}if(this.shouldDrawMenu("Selection")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:T});this.setMenuById(T,"Selection"),f.append(U)}if(this.shouldDrawMenu("View")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:T});this.setMenuById(T,"View"),f.append(U)}if(this.shouldDrawMenu("Go")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:T});this.setMenuById(T,"Go"),f.append(U)}if(this.shouldDrawMenu("Run")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:T});this.setMenuById(T,"Run"),f.append(U)}if(this.shouldDrawMenu("Terminal")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:T});this.setMenuById(T,"Terminal"),f.append(U)}let M;if(this.shouldDrawMenu("Window")){const T=new S.Menu;M=new S.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:T,role:"window"}),this.setMacWindowMenu(T)}if(M&&f.append(M),this.shouldDrawMenu("Help")){const T=new S.Menu,U=new S.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:T,role:"help"});this.setMenuById(T,"Help"),f.append(U)}f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(d){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),h=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const Q=new S.Menu;this.setMenuById(Q,"Preferences"),M=new S.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:Q})}const T=new S.Menu,U=new S.MenuItem({label:v.localize(12,null),role:"services",submenu:T}),H=new S.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new S.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ee=new S.MenuItem({label:v.localize(15,null),role:"unhide"}),B=new S.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const Q=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(Q==null?void 0:Q.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),Y=[f];Y.push(...h),M&&Y.push(s(),M),Y.push(s(),U,s(),H,X,ee,s(),B),Y.forEach(Q=>d.append(Q))}shouldDrawMenu(d){if(!L.isMacintosh&&E.getTitleBarStyle(this.configurationService)==="custom")return!1;switch(d){case"File":case"Help":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[d];case"Window":if(L.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[d]}}setMenu(d,f){f.forEach(h=>{if(D.isMenubarMenuItemSeparator(h))d.append(s());else if(D.isMenubarMenuItemSubmenu(h)){const M=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(h.label),submenu:M});this.setMenu(M,h.submenu.items),d.append(T)}else D.isMenubarMenuItemRecentAction(h)?d.append(this.createOpenRecentMenuItem(h)):D.isMenubarMenuItemAction(h)&&(h.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(d),L.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[h.id]?d.append(new S.MenuItem(this.likeAction(h.id,{label:this.mnemonicLabel(h.label),click:this.fallbackMenuHandlers[h.id]}))):d.append(this.createMenuItem(h.label,h.id,!1,h.checked)):d.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)):d.append(this.createMenuItem(h.label,h.id,h.enabled!==!1,!!h.checked)))})}setMenuById(d,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(d,this.menubarMenus[f].items)}insertCheckForUpdatesItems(d){const f=this.getUpdateMenuItems();f.length&&(f.forEach(h=>d.append(h)),d.append(s()))}createOpenRecentMenuItem(d){const f=b.URI.revive(d.uri),h=d.id,M=h==="openRecentFile"?{fileUri:f}:h==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(h,{label:d.label,click:(T,U,H)=>{const X=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:d.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(d){return!!(d&&(!L.isMacintosh&&(d.ctrlKey||d.shiftKey)||L.isMacintosh&&(d.metaKey||d.altKey)))}createRoleMenuItem(d,f,h){const M={label:this.mnemonicLabel(d),role:h,enabled:!0};return new S.MenuItem(this.withKeybinding(f,M))}setMacWindowMenu(d){const f=new S.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),h=new S.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new S.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,h,s(),T,...U,s(),M].forEach(H=>d.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(d,f,h,M){const T=this.mnemonicLabel(d),U=typeof f=="function"?f:(Y,Q,N)=>{const G=Y?Y.userSettingsLabel:null;let z=f;Array.isArray(f)&&(z=this.isOptionClick(N)?f[1]:f[0]),G&&N.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:G}):this.runActionInRenderer({type:"commandId",commandId:z})},H=typeof h=="boolean"?h:this.windowsMainService.getWindowCount()>0,X=typeof M=="boolean"?M:!1,ee={label:T,click:U,enabled:H};X&&(ee.type="checkbox",ee.checked=X);let B;return typeof f=="string"?B=f:Array.isArray(f)&&(B=f[0]),L.isMacintosh&&(B==="editor.action.clipboardCutAction"?ee.role="cut":B==="editor.action.clipboardCopyAction"?ee.role="copy":B==="editor.action.clipboardPasteAction"&&(ee.role="paste"),B==="undo"?ee.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):B==="redo"?ee.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):B==="editor.action.selectAll"&&(ee.click=this.makeContextAwareClickHandler(U,{inDevTools:Y=>Y.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(B,ee))}makeContextAwareClickHandler(d,f){return(h,M,T)=>{const U=S.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);d(h,M||U,T)}}runActionInRenderer(d){let f=S.BrowserWindow.getFocusedWindow();if(!f){const M=this.windowsMainService.getLastActiveWindow();(M==null?void 0:M.isMinimized())&&(f=M.win)}const h=f?this.windowsMainService.getWindowById(f.id):void 0;if(h){if(this.logService.trace("menubar#runActionInRenderer",d),L.isMacintosh&&!this.environmentMainService.isBuilt&&!h.isReady&&(d.type==="commandId"&&d.commandId==="workbench.action.toggleDevTools"||d.type!=="commandId"&&d.userSettingsLabel==="alt+cmd+i"))return;if(d.type==="commandId"){const M={id:d.commandId,from:"menu"};h.sendWhenReady("vscode:runAction",a.CancellationToken.None,M)}else{const M={userSettingsLabel:d.userSettingsLabel};h.sendWhenReady("vscode:runKeybinding",a.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",d)}withKeybinding(d,f){const h=typeof d=="string"?this.keybindings[d]:void 0;if(h==null?void 0:h.label){if(h.isNative!==!1)f.accelerator=h.label,f.userSettingsLabel=h.userSettingsLabel;else if(typeof f.label=="string"){const M=f.label.indexOf("[");M>=0?f.label=`${f.label.substr(0,M)} [${h.label}]`:f.label=`${f.label} [${h.label}]`}}else f.accelerator=void 0;return f}likeAction(d,f,h=!f.accelerator){h&&(f=this.withKeybinding(d,f));const M=f.click;return f.click=(T,U,H)=>{this.reportMenuActionTelemetry(d),M&&M(T,U,H)},f}openUrl(d,f){this.nativeHostMainService.openExternal(void 0,d),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(d){this.telemetryService.publicLog2("workbenchActionExecuted",{id:d,from:t})}mnemonicLabel(d){return p.mnemonicMenuLabel(d,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=he([te(0,y.IUpdateService),te(1,n.IConfigurationService),te(2,g.IWindowsMainService),te(3,A.IEnvironmentMainService),te(4,w.ITelemetryService),te(5,m.IWorkspacesHistoryMainService),te(6,l.IStateMainService),te(7,u.ILifecycleMainService),te(8,k.ILogService),te(9,o.INativeHostMainService),te(10,i.IProductService)],r),e.Menubar=r;function s(){return new S.MenuItem({type:"separator"})}}),define(J[233],x([0,1,232,6,4,18]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=A.createDecorator("menubarMainService");let E=class{constructor(w,y,i){this.instantiationService=w,this.lifecycleMainService=y,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(w,y){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(y,w)}};E=he([te(0,A.IInstantiationService),te(1,S.ILifecycleMainService),te(2,L.ILogService)],E),e.MenubarMainService=E}),define(J[234],x([0,1,29,26,47,72,8,150,35,50,24,38,231,14,18,17,6,61,100,5,22,62,3,28,4,10,7,15,73,214,52,42,2,51,13,30,39,25,21,32,55]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t,r,s,c,d,f,h,M,T,U,H,X,ee,B,Y,Q,N,G,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function C(O){return r.isWorkspaceIdentifier(O==null?void 0:O.workspace)}function F(O){return r.isSingleFolderWorkspaceIdentifier(O==null?void 0:O.workspace)}let R=class Ze extends H.Disposable{constructor(P,W,_,q,V,K,Z,ne,re,se,le,oe,ue,me,Se){super();this.machineId=P,this.initialUserEnv=W,this.logService=_,this.stateMainService=q,this.environmentMainService=V,this.lifecycleMainService=K,this.backupMainService=Z,this.configurationService=ne,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=le,this.dialogMainService=oe,this.fileService=ue,this.productService=me,this.protocolMainService=Se,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new M.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(P=>this._onDidSignalReadyWindow.fire(P.window))),this._register(this.onDidSignalReadyWindow(P=>{var W,_;if(((W=P.config)===null||W===void 0?void 0:W.extensionDevelopmentPath)||((_=P.config)===null||_===void 0?void 0:_.extensionTestsPath)){const q=new H.DisposableStore;if(q.add(u.Event.any(P.onDidClose,P.onDidDestroy)(()=>q.dispose())),P.config.extensionDevelopmentPath)for(const V of P.config.extensionDevelopmentPath)q.add(this.protocolMainService.addValidFileRoot(d.URI.file(V)));P.config.extensionTestsPath&&q.add(this.protocolMainService.addValidFileRoot(d.URI.file(P.config.extensionTestsPath)))}}))}openEmptyWindow(P,W){let _=this.environmentMainService.args;const q=(W==null?void 0:W.remoteAuthority)||void 0,V=!0,K=W==null?void 0:W.forceReuseWindow,Z=!K;return this.open(Object.assign(Object.assign({},P),{cli:_,forceEmpty:V,forceNewWindow:Z,forceReuseWindow:K,remoteAuthority:q}))}open(P){this.logService.trace("windowsManager#open"),P.addMode&&(P.initialStartup||!this.getLastActiveWindow())&&(P.addMode=!1);const W=[],_=[],q=[],V=[],K=[];let Z,ne=0;const re=this.getPathsToOpen(P);this.logService.trace("windowsManager#open pathsToOpen",re);for(const me of re)F(me)?P.addMode?W.push(me):_.push(me):C(me)?q.push(me):me.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),Z.filesToOpenOrCreate.push(me)):me.backupPath?K.push({backupFolder:E.basename(me.backupPath),remoteAuthority:me.remoteAuthority}):ne++;P.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&P.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:P.waitMarkerFileURI}),P.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),q.push(...V),K.push(...this.backupMainService.getEmptyWindowBackupPaths())):K.length=0;const{windows:se,filesOpenedInWindow:le}=this.doOpen(P,q,_,K,ne,Z,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${q.length}, foldersToOpen: ${_.length}, emptyToRestore: ${K.length}, emptyToOpen: ${ne})`),se.length>1)if(le)le.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!P.forceEmpty&&!P.cli._.length&&!P.cli["file-uri"]&&!P.cli["folder-uri"]&&!(P.urisToOpen&&P.urisToOpen.length);let Se=!0,Le=!0;if(me){const Ie=se.filter(we=>this.windowsStateHandler.state.lastActiveWindow&&we.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),Se=!1,Le=!1)}if(Se)for(let Ie=se.length-1;Ie>=0;Ie--){const we=se[Ie];if(!(we.openedWorkspace&&V.some(ye=>we.openedWorkspace&&ye.workspace.id===we.openedWorkspace.id)||we.backupPath&&K.some(ye=>we.backupPath&&ye.backupFolder===E.basename(we.backupPath)))){we.focus(),Le=!1;break}}Le&&se[se.length-1].focus()}const oe=Z&&Z.filesToDiff.length>0;if(!se.some(me=>me.isExtensionDevelopmentHost)&&!oe&&!P.noRecentEntry){const me=[];for(const Se of re)C(Se)?me.push({label:Se.label,workspace:Se.workspace,remoteAuthority:Se.remoteAuthority}):F(Se)?me.push({label:Se.label,folderUri:Se.workspace.uri,remoteAuthority:Se.remoteAuthority}):Se.fileUri&&me.push({label:Se.label,fileUri:Se.fileUri,remoteAuthority:Se.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const ue=P.waitMarkerFileURI;return P.context===0&&ue&&se.length===1&&se[0]&&(async()=>{await se[0].whenClosedOrLoaded;try{await this.fileService.del(ue)}catch(me){}})(),se}doOpen(P,W,_,q,V,K,Z){const ne=[];let re;function se(Ie,we){ne.push(Ie),we&&(re=Ie,K=void 0)}let{openFolderInNewWindow:le,openFilesInNewWindow:oe}=this.shouldOpenNewWindow(P);if(!P.initialStartup&&Z.length>0){const Ie=Z[0].remoteAuthority,we=this.getLastActiveWindowForAuthority(Ie);we&&se(this.doAddFoldersToExistingWindow(we,Z.map(ye=>ye.workspace.uri)))}const ue=_.length+W.length+q.length;if(K&&ue===0){const Ie=K.filesToOpenOrCreate[0]||K.filesToDiff[0],we=this.getWindows().filter(Re=>K&&Re.remoteAuthority===K.remoteAuthority);let ye;(Ie==null?void 0:Ie.fileUri)&&!oe&&((P.context===4||P.context===0||P.context===1)&&(ye=l.findWindowOnFile(we,Ie.fileUri,Re=>Re.configPath.scheme===c.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),ye||(ye=this.doGetLastActiveWindow(we))),ye?r.isWorkspaceIdentifier(ye.openedWorkspace)?W.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):r.isSingleFolderWorkspaceIdentifier(ye.openedWorkspace)?_.push({workspace:ye.openedWorkspace,remoteAuthority:ye.remoteAuthority}):se(this.doOpenFilesInExistingWindow(P,ye,K),!0):se(this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,filesToOpen:K,forceNewWindow:!0,remoteAuthority:K.remoteAuthority,forceNewTabbedWindow:P.forceNewTabbedWindow}),!0)}const me=w.distinct(W,Ie=>Ie.workspace.id);if(me.length>0){const Ie=w.coalesce(me.map(we=>l.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.configPath)));if(Ie.length>0){const we=Ie[0],ye=(K==null?void 0:K.remoteAuthority)===we.remoteAuthority?K:void 0;se(this.doOpenFilesInExistingWindow(P,we,ye),!!ye),le=!0}me.forEach(we=>{if(Ie.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===we.workspace.id))return;const ye=we.remoteAuthority,Re=(K==null?void 0:K.remoteAuthority)===ye?K:void 0;se(this.doOpenFolderOrWorkspace(P,we,le,Re),!!Re),le=!0})}const Se=w.distinct(_,Ie=>f.extUriBiasedIgnorePathCase.getComparisonKey(Ie.workspace.uri));if(Se.length>0){const Ie=w.coalesce(Se.map(we=>l.findWindowOnWorkspaceOrFolder(this.getWindows(),we.workspace.uri)));if(Ie.length>0){const we=Ie[0],ye=(K==null?void 0:K.remoteAuthority)===we.remoteAuthority?K:void 0;se(this.doOpenFilesInExistingWindow(P,we,ye),!!ye),le=!0}Se.forEach(we=>{if(Ie.some(Te=>r.isSingleFolderWorkspaceIdentifier(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,we.workspace.uri)))return;const ye=we.remoteAuthority,Re=(K==null?void 0:K.remoteAuthority)===ye?K:void 0;se(this.doOpenFolderOrWorkspace(P,we,le,Re),!!Re),le=!0})}const Le=w.distinct(q,Ie=>Ie.backupFolder);if(Le.length>0&&Le.forEach(Ie=>{const we=Ie.remoteAuthority,ye=(K==null?void 0:K.remoteAuthority)===we?K:void 0;se(this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,filesToOpen:ye,remoteAuthority:we,forceNewWindow:!0,forceNewTabbedWindow:P.forceNewTabbedWindow,emptyWindowBackupInfo:Ie}),!!ye),le=!0}),ne.length===0||K){K&&!V&&V++;const Ie=K?K.remoteAuthority:P.remoteAuthority;for(let we=0;we<V;we++)se(this.doOpenEmpty(P,le,Ie,K),!!K),le=!0}return{windows:w.distinct(ne),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(P,W,_){var q;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const V={filesToOpenOrCreate:_==null?void 0:_.filesToOpenOrCreate,filesToDiff:_==null?void 0:_.filesToDiff,filesToWait:_==null?void 0:_.filesToWait,termProgram:(q=P==null?void 0:P.userEnv)===null||q===void 0?void 0:q.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",Q.CancellationToken.None,V),W}doAddFoldersToExistingWindow(P,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),P.focus();const _={foldersToAdd:W};return P.sendWhenReady("vscode:addFolders",Q.CancellationToken.None,_),P}doOpenEmpty(P,W,_,q,V){return!W&&!V&&typeof P.contextWindowId=="number"&&(V=this.getWindowById(P.contextWindowId)),this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,remoteAuthority:_,forceNewWindow:W,forceNewTabbedWindow:P.forceNewTabbedWindow,filesToOpen:q,windowToUse:V})}doOpenFolderOrWorkspace(P,W,_,q,V){return!_&&!V&&typeof P.contextWindowId=="number"&&(V=this.getWindowById(P.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:P.forceNewTabbedWindow,filesToOpen:q,windowToUse:V})}getPathsToOpen(P){var W;let _,q=!1,V=!1;if(P.urisToOpen&&P.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(P),q=!0):P.forceEmpty?_=[Object.create(null)]:P.cli._.length||P.cli["folder-uri"]||P.cli["file-uri"]?(_=this.doExtractPathsFromCLI(P.cli),_.length===0&&_.push(Object.create(null)),q=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),V=!0),!P.addMode&&q){const K=_.filter(Z=>F(Z));if(K.length>1){const Z=K[0].remoteAuthority;if(K.every(ne=>ne.remoteAuthority===Z)){const ne=this.workspacesManagementMainService.createUntitledWorkspaceSync(K.map(re=>({uri:re.workspace.uri})));_.push({workspace:ne,remoteAuthority:Z}),_=_.filter(re=>!F(re))}}}return P.initialStartup&&!V&&((W=this.configurationService.getValue("window"))===null||W===void 0?void 0:W.restoreWindows)==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(K=>C(K)||F(K)||K.backupPath)),_}doExtractPathsFromAPI(P){const W=[],_={gotoLineMode:P.gotoLineMode,remoteAuthority:P.remoteAuthority};for(const q of w.coalesce(P.urisToOpen||[])){const V=this.resolveOpenable(q,_);if(V)V.label=q.label,W.push(V);else{const K=this.resourceFromOpenable(q),Z={title:this.productService.nameLong,type:"info",buttons:[n.localize(0,null)],message:K.scheme===c.Schemas.file?n.localize(1,null):n.localize(2,null),detail:K.scheme===c.Schemas.file?n.localize(3,null,Y.getPathLabel(K.fsPath,this.environmentMainService)):n.localize(4,null,K.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,ee.withNullAsUndefined(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(P){const W=[],_={ignoreFileNotFound:!0,gotoLineMode:P.goto,remoteAuthority:P.remote||void 0,forceOpenWorkspaceAsFile:!1},q=P["folder-uri"];if(q)for(const Z of q){const ne=this.cliArgToUri(Z);if(ne){const re=this.resolveOpenable({folderUri:ne},_);re&&W.push(re)}}const V=P["file-uri"];if(V)for(const Z of V){const ne=this.cliArgToUri(Z);if(ne){const re=this.resolveOpenable(r.hasWorkspaceFileExtension(Z)?{workspaceUri:ne}:{fileUri:ne},_);re&&W.push(re)}}const K=P._;for(const Z of K){const ne=_.remoteAuthority?this.doResolvePathRemote(Z,_):this.doResolveFilePath(Z,_);ne&&W.push(ne)}return W}cliArgToUri(P){try{const W=d.URI.parse(P);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${P}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${P}, ${W.message}`)}}doGetPathsFromLastSession(){const P=this.getRestoreWindowsSetting();switch(P){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];P!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const q of W)if(q.workspace){const V=this.resolveOpenable({workspaceUri:q.workspace.configPath},{remoteAuthority:q.remoteAuthority});C(V)&&_.push(V)}else if(q.folderUri){const V=this.resolveOpenable({folderUri:q.folderUri},{remoteAuthority:q.remoteAuthority});F(V)&&_.push(V)}else P!=="folders"&&q.backupPath&&_.push({backupPath:q.backupPath,remoteAuthority:q.remoteAuthority});return _}}getRestoreWindowsSetting(){let P;if(this.lifecycleMainService.wasRestarted)P="all";else{const W=this.configurationService.getValue("window");P=(W==null?void 0:W.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(P)||(P="all")}return P}resolveOpenable(P,W={}){let _=this.resourceFromOpenable(P);return _.scheme===c.Schemas.file?(b.isFileToOpen(P)&&(W=Object.assign(Object.assign({},W),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(_.fsPath,W)):this.doResolveRemoteOpenable(P,W)}doResolveRemoteOpenable(P,W){let _=this.resourceFromOpenable(P);const q=h.getRemoteAuthority(_)||W.remoteAuthority;if(_=f.removeTrailingPathSeparator(f.normalizePath(_)),b.isFileToOpen(P)){if(W.gotoLineMode){const{path:V,line:K,column:Z}=B.parseLineAndColumnAware(_.path);return{fileUri:_.with({path:V}),lineNumber:K,columnNumber:Z,remoteAuthority:q}}return{fileUri:_,remoteAuthority:q}}else if(b.isWorkspaceToOpen(P))return{workspace:T.getWorkspaceIdentifier(_),remoteAuthority:q};return{workspace:T.getSingleFolderWorkspaceIdentifier(_),remoteAuthority:q}}resourceFromOpenable(P){return b.isWorkspaceToOpen(P)?P.workspaceUri:b.isFolderToOpen(P)?P.folderUri:P.fileUri}doResolveFilePath(P,W){let _,q;W.gotoLineMode&&({path:P,line:_,column:q}=B.parseLineAndColumnAware(P)),P=B.sanitizeFilePath(E.normalize(P),G.cwd());try{const V=v.statSync(P);if(V.isFile()){if(!W.forceOpenWorkspaceAsFile){const K=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(P));if(K)return{workspace:{id:K.id,configPath:K.configPath},remoteAuthority:K.remoteAuthority,exists:!0}}return{fileUri:d.URI.file(P),lineNumber:_,columnNumber:q,exists:!0}}else if(V.isDirectory())return{workspace:T.getSingleFolderWorkspaceIdentifier(d.URI.file(P),V),exists:!0}}catch(V){const K=d.URI.file(P);if(this.workspacesHistoryMainService.removeRecentlyOpened([K]),W.ignoreFileNotFound)return{fileUri:K,exists:!1}}}doResolvePathRemote(P,W){const _=P.charCodeAt(0),q=W.remoteAuthority;let V,K;W.gotoLineMode&&({path:P,line:V,column:K}=B.parseLineAndColumnAware(P)),_!==47&&(B.isWindowsDriveLetter(_)&&P.charCodeAt(P.charCodeAt(1))===58&&(P=B.toSlashes(P)),P=`/${P}`);const Z=d.URI.from({scheme:c.Schemas.vscodeRemote,authority:q,path:P});if(P.charCodeAt(P.length-1)!==47){if(r.hasWorkspaceFileExtension(P))return W.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:V,columnNumber:K,remoteAuthority:W.remoteAuthority}:{workspace:T.getWorkspaceIdentifier(Z),remoteAuthority:q};if(W.gotoLineMode||E.posix.basename(P).indexOf(".")!==-1)return{fileUri:Z,lineNumber:V,columnNumber:K,remoteAuthority:q}}return{workspace:T.getSingleFolderWorkspaceIdentifier(Z),remoteAuthority:q}}shouldOpenNewWindow(P){const W=this.configurationService.getValue("window"),_=(W==null?void 0:W.openFoldersInNewWindow)||"default",q=(W==null?void 0:W.openFilesInNewWindow)||"off";let V=(P.preferNewWindow||P.forceNewWindow)&&!P.forceReuseWindow;!P.forceNewWindow&&!P.forceReuseWindow&&(_==="on"||_==="off")&&(V=_==="on");let K=!1;return P.forceNewWindow||P.forceReuseWindow?K=!!P.forceNewWindow&&!P.forceReuseWindow:(t.isMacintosh?P.context===1&&(K=!0):P.context!==3&&P.context!==2&&!(P.userEnv&&P.userEnv.TERM_PROGRAM==="vscode")&&(K=!0),!P.cli.extensionDevelopmentPath&&(q==="on"||q==="off")&&(K=q==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:K}}openExtensionDevelopmentHostWindow(P,W){const _=l.findWindowOnExtensionDevelopmentPath(this.getWindows(),P);if(_)return this.lifecycleMainService.reload(_,W.cli),_.focus(),[_];let q=W.cli["folder-uri"]||[],V=W.cli["file-uri"]||[],K=W.cli._;if(!K.length&&!q.length&&!V.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,le=se&&(se.workspace||se.folderUri);le&&(d.URI.isUri(le)?le.scheme===c.Schemas.file?K=[le.fsPath]:q=[le.toString()]:le.configPath.scheme===c.Schemas.file?K=[f.originalFSPath(le.configPath)]:V=[le.configPath.toString()])}let Z=W.remoteAuthority;for(const se of P)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=d.URI.parse(se),oe=h.getRemoteAuthority(le);oe&&(Z?oe!==Z&&this.logService.error("more than one extension development path authority"):Z=oe)}K=K.filter(se=>{const le=d.URI.file(se);return l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:h.getRemoteAuthority(le)===Z}),q=q.filter(se=>{const le=this.cliArgToUri(se);return le&&!!l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?h.getRemoteAuthority(le)===Z:!1}),V=V.filter(se=>{const le=this.cliArgToUri(se);return le&&!!l.findWindowOnWorkspaceOrFolder(this.getWindows(),le)?!1:le?h.getRemoteAuthority(le)===Z:!1}),W.cli._=K,W.cli["folder-uri"]=q,W.cli["file-uri"]=V;const ne=!K.length&&!q.length&&!V.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ne,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:Z};return this.open(re)}openInBrowserWindow(P){var W,_,q,V,K;const Z=this.configurationService.getValue("window"),ne=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),P.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupPath:P.emptyWindowBackupInfo?E.join(this.environmentMainService.backupHome,P.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:P.remoteAuthority,workspace:P.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),P.userEnv),filesToOpenOrCreate:(W=P.filesToOpen)===null||W===void 0?void 0:W.filesToOpenOrCreate,filesToDiff:(_=P.filesToOpen)===null||_===void 0?void 0:_.filesToDiff,filesToWait:(q=P.filesToOpen)===null||q===void 0?void 0:q.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:A.default,isInitialStartup:P.initialStartup,perfMarks:S.getMarks(),os:{release:L.release(),hostname:L.hostname()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(V=Z==null?void 0:Z.autoDetectHighContrast)!==null&&V!==void 0?V:!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}});let re;if(!P.forceNewWindow&&!P.forceNewTabbedWindow&&(re=P.windowToUse||this.getLastActiveWindow(),re&&re.focus()),re){const se=re.config;!ne.extensionDevelopmentPath&&se&&!!se.extensionDevelopmentPath&&(ne.extensionDevelopmentPath=se.extensionDevelopmentPath,ne.verbose=se.verbose,ne["inspect-brk-extensions"]=se["inspect-brk-extensions"],ne.debugId=se.debugId,ne["inspect-extensions"]=se["inspect-extensions"],ne["extensions-dir"]=se["extensions-dir"])}else{const se=this.windowsStateHandler.getNewWindowState(ne);S.mark("code/willCreateCodeWindow");const le=re=this.instantiationService.createInstance(k.CodeWindow,{state:se,extensionDevelopmentPath:ne.extensionDevelopmentPath,isExtensionTestHost:!!ne.extensionTestsPath});if(S.mark("code/didCreateCodeWindow"),P.forceNewTabbedWindow){const ue=this.getLastActiveWindow();ue&&ue.addTabbedWindow(le)}Ze.WINDOWS.push(le),this._onDidOpenWindow.fire(le),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),U.once(le.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(le)),U.once(le.onDidClose)(()=>this.onWindowClosed(le)),U.once(le.onDidDestroy)(()=>this._onDidDestroyWindow.fire(le));const oe=ee.assertIsDefined((K=le.win)===null||K===void 0?void 0:K.webContents);oe.removeAllListeners("devtools-reload-page"),oe.on("devtools-reload-page",()=>this.lifecycleMainService.reload(le)),this.lifecycleMainService.registerWindow(le)}return ne.windowId=re.id,re.isReady?this.lifecycleMainService.unload(re,4).then(se=>{se||this.doOpenInBrowserWindow(re,ne,P)}):this.doOpenInBrowserWindow(re,ne,P),re}doOpenInBrowserWindow(P,W,_){if(!W.extensionDevelopmentPath)if(r.isWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if(r.isSingleFolderWorkspaceIdentifier(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const q=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(q,W.remoteAuthority)}P.load(W)}onWindowClosed(P){const W=Ze.WINDOWS.indexOf(P);Ze.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const P=p.BrowserWindow.getFocusedWindow();if(P)return this.getWindowById(P.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(P){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===P))}doGetLastActiveWindow(P){const W=Math.max.apply(Math,P.map(_=>_.lastFocusTime));return P.find(_=>_.lastFocusTime===W)}sendToFocused(P,...W){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(P,Q.CancellationToken.None,...W)}sendToAll(P,W,_){for(const q of this.getWindows())_&&_.indexOf(q.id)>=0||q.sendWhenReady(P,Q.CancellationToken.None,W)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(P){const W=this.getWindows().filter(_=>_.id===P);return w.firstOrDefault(W)}getWindowByWebContents(P){const W=p.BrowserWindow.fromWebContents(P);if(!!W)return this.getWindowById(W.id)}};R.WINDOWS=[],R=he([te(2,D.ILogService),te(3,I.IStateMainService),te(4,i.IEnvironmentMainService),te(5,g.ILifecycleMainService),te(6,y.IBackupMainService),te(7,m.IConfigurationService),te(8,a.IWorkspacesHistoryMainService),te(9,T.IWorkspacesManagementMainService),te(10,s.IInstantiationService),te(11,X.IDialogMainService),te(12,N.IFileService),te(13,o.IProductService),te(14,z.IProtocolMainService)],R),e.WindowsMainService=R}),define(J[235],x([0,1,52,34,62,50]),function($,e,v,L,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let E=class{constructor(w,y,i,I){this.workspacesManagementMainService=w,this.windowsMainService=y,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,y){const i=this.windowsMainService.getWindowById(w);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),y)}createUntitledWorkspace(w,y,i){return this.workspacesManagementMainService.createUntitledWorkspace(y,i)}deleteUntitledWorkspace(w,y){return this.workspacesManagementMainService.deleteUntitledWorkspace(y)}getWorkspaceIdentifier(w,y){return this.workspacesManagementMainService.getWorkspaceIdentifier(y)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,y){return this.workspacesHistoryMainService.addRecentlyOpened(y)}async removeRecentlyOpened(w,y){return this.workspacesHistoryMainService.removeRecentlyOpened(y)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};E=he([te(0,v.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,A.IWorkspacesHistoryMainService),te(3,S.IBackupMainService)],E),e.WorkspacesMainService=E}),define(J[236],x([0,1,26,29,14,3,234,18,91,41,204,33,122,85,224,101,4,71,69,6,38,24,17,98,205,31,97,199,200,196,22,218,2,34,7,28,235,66,229,227,226,230,179,19,207,219,233,119,8,15,131,10,228,99,212,217,50,62,206,52,70,157,45,51,13,39,209,76,21,43,27,20,89,210,195,54,30,9,169,184,42,73,75,90,172]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t,r,s,c,d,f,h,M,T,U,H,X,ee,B,Y,Q,N,G,z,C,F,R,O,P,W,_,q,V,K,Z,ne,re,se,le,oe,ue,me,Se,Le,Ie,we,ye,Re,Te,$e,Ne,je,xe,Be,rt,et,ct,Ge,ut,st,j,ie,ae,ce,fe,be,Me,Fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Ue=class extends H.Disposable{constructor(de,pe,ge,ve,Ee,Ae,ke,De,Pe,Ce){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=ge,this.logService=ve,this.environmentMainService=Ee,this.lifecycleMainService=Ae,this.configurationService=ke,this.stateMainService=De,this.fileService=Pe,this.productService=Ce,this.registerListeners()}registerListeners(){R.setUnexpectedErrorHandler(ge=>this.onUnexpectedError(ge)),process.on("uncaughtException",ge=>this.onUnexpectedError(ge)),process.on("unhandledRejection",ge=>R.onUnexpectedError(ge)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),_.registerContextMenuListener(),A.app.on("accessibility-support-changed",(ge,ve)=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.sendToAll("vscode:accessibilitySupportChanged",ve)}),A.app.on("activate",(ge,ve)=>{var Ee;this.logService.trace("app#activate"),ve||(Ee=this.windowsMainService)===null||Ee===void 0||Ee.openEmptyWindow({context:1})}),A.app.on("remote-require",(ge,ve,Ee)=>{this.logService.trace("app#on(remote-require): prevented"),ge.preventDefault()}),A.app.on("remote-get-global",(ge,ve,Ee)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Ee}`),ge.preventDefault()}),A.app.on("remote-get-builtin",(ge,ve,Ee)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Ee}`),Ee!=="clipboard"&&ge.preventDefault()}),A.app.on("remote-get-current-window",ge=>{this.logService.trace("app#on(remote-get-current-window): prevented"),ge.preventDefault()}),A.app.on("remote-get-current-web-contents",ge=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),ge.preventDefault())}),A.app.on("web-contents-created",(ge,ve)=>{ve.on("will-attach-webview",(Ae,ke,De)=>{const Pe=Ce=>{if(!Ce)return!1;const He=ee.URI.parse(Ce);if(He.scheme===Z.Schemas.vscodeWebview)return He.path==="/index.html"||He.path==="/electron-browser-index.html";const Ye=He.fsPath.toLowerCase(),Xe=ee.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ye.startsWith(Xe+q.sep)};delete ke.preload,ke.nodeIntegration=!1,!(Pe(De.src)&&Pe(ke.preloadURL))&&(delete ke.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ae.preventDefault())}),ve.on("will-navigate",Ae=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),ve.on("new-window",(Ae,ke)=>{var De;Ae.preventDefault(),(De=this.nativeHostMainService)===null||De===void 0||De.openExternal(void 0,ke)});const Ee=Ae=>Ae.startsWith(`${Z.Schemas.vscodeWebview}://`);A.session.defaultSession.setPermissionRequestHandler((Ae,ke,De,Pe)=>Ee(Pe.requestingUrl)?De(ke==="clipboard-read"):De(!1)),A.session.defaultSession.setPermissionCheckHandler((Ae,ke,De,Pe)=>Ee(Pe.requestingUrl)?ke==="clipboard-read":!1)});let de=[],pe;A.app.on("open-file",(ge,ve)=>{this.logService.trace("app#open-file: ",ve),ge.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ve)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Ee;(Ee=this.windowsMainService)===null||Ee===void 0||Ee.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),A.app.on("new-window-for-tab",()=>{var ge;(ge=this.windowsMainService)===null||ge===void 0||ge.openEmptyWindow({context:4})}),A.ipcMain.handle("vscode:fetchShellEnv",ge=>{var ve;const Ee=(ve=this.windowsMainService)===null||ve===void 0?void 0:ve.getWindowByWebContents(ge.sender);let Ae,ke;return(Ee==null?void 0:Ee.config)?(Ae=Ee.config,ke=Object.assign(Object.assign({},process.env),Ee.config.userEnv)):(Ae=this.environmentMainService.args,ke=process.env),w.resolveShellEnv(this.logService,Ae,ke)}),A.ipcMain.handle("vscode:writeNlsFile",(ge,ve,Ee)=>{const Ae=this.validateNlsPath([ve]);if(!Ae||typeof Ee!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ae,rt.VSBuffer.fromString(Ee))}),A.ipcMain.handle("vscode:readNlsFile",async(ge,...ve)=>{const Ee=this.validateNlsPath(ve);if(!Ee)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ee)).value.toString()}),A.ipcMain.on("vscode:toggleDevTools",ge=>ge.sender.toggleDevTools()),A.ipcMain.on("vscode:openDevTools",ge=>ge.sender.openDevTools()),A.ipcMain.on("vscode:reloadWindow",ge=>ge.sender.reload())}validateNlsPath(de){let pe;for(const ge of de)typeof ge=="string"&&(typeof pe!="string"?pe=ge:pe=q.join(pe,ge));if(!(typeof pe!="string"||!q.isAbsolute(pe)||!st.isEqualOrParent(pe,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return ee.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const ge={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(ge))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Pe=ee.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Pe.fsPath}`),await this.fileService.del(Pe,{recursive:!0})}catch(Pe){Pe.fileOperationResult!==1&&this.logService.error(Pe)}const de=this.productService.win32AppUserModelId;S.isWindows&&de&&A.app.setAppUserModelId(de);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!A.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&A.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new k.Server;this.logService.trace("Resolving machine identifier...");const ge=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ge}`);const{sharedProcess:ve,sharedProcessReady:Ee,sharedProcessClient:Ae}=this.setupSharedProcess(ge),ke=await this.initServices(ge,ve,Ee);if(this.environmentMainService.driverHandle){const Pe=await P.serve(pe,this.environmentMainService.driverHandle,this.environmentMainService,ke);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(ke.createInstance(U.ProxyAuthHandler)),ke.invokeFunction(Pe=>this.initChannels(Pe,pe,Ae));const De=ke.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));ke.invokeFunction(Pe=>this.afterWindowOpen(Pe,ve)),this.environmentMainService.args.trace&&ke.invokeFunction(Pe=>this.stopTracingEventually(Pe,De))}async resolveMachineId(){let de=this.stateMainService.getItem(c.machineIdKey);return(!de||S.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await Q.getMachineId(),this.stateMainService.setItem(c.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(g.SharedProcess,de,this.userEnv)),ge=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new p.Client(Ee,"main")})(),ve=(async()=>(await pe.whenReady(),ge))();return{sharedProcess:pe,sharedProcessReady:ve,sharedProcessClient:ge}}async initServices(de,pe,ge){const ve=new b.ServiceCollection;switch(process.platform){case"win32":ve.set(y.IUpdateService,new l.SyncDescriptor(N.Win32UpdateService));break;case"linux":S.isLinuxSnap?ve.set(y.IUpdateService,new l.SyncDescriptor(ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(y.IUpdateService,new l.SyncDescriptor(G.LinuxUpdateService));break;case"darwin":ve.set(y.IUpdateService,new l.SyncDescriptor(z.DarwinUpdateService));break}ve.set(X.IWindowsMainService,new l.SyncDescriptor(E.WindowsMainService,[de,this.userEnv])),ve.set(ye.IDialogMainService,new l.SyncDescriptor(ye.DialogMainService)),ve.set(m.ILaunchMainService,new l.SyncDescriptor(m.LaunchMainService)),ve.set(Le.IDiagnosticsService,I.ProxyChannel.toService(I.getDelayedChannel(ge.then(Ae=>Ae.getChannel("diagnostics"))))),ve.set(C.IIssueMainService,new l.SyncDescriptor(C.IssueMainService,[this.userEnv])),ve.set(et.IEncryptionMainService,new l.SyncDescriptor(et.EncryptionMainService,[de])),ve.set(Ge.IKeyboardLayoutMainService,new l.SyncDescriptor(Ge.KeyboardLayoutMainService)),ve.set(we.INativeHostMainService,new l.SyncDescriptor(we.NativeHostMainService,[pe])),ve.set(Ne.IWebviewManagerService,new l.SyncDescriptor($e.WebviewMainService)),ve.set(B.IWorkspacesService,new l.SyncDescriptor(Y.WorkspacesMainService)),ve.set(Se.IWorkspacesManagementMainService,new l.SyncDescriptor(Se.WorkspacesManagementMainService)),ve.set(ue.IWorkspacesHistoryMainService,new l.SyncDescriptor(ue.WorkspacesHistoryMainService)),ve.set(W.IMenubarMainService,new l.SyncDescriptor(W.MenubarMainService)),ve.set(ie.IExtensionUrlTrustService,new l.SyncDescriptor(ae.ExtensionUrlTrustService)),ve.set(re.IStorageMainService,new l.SyncDescriptor(re.StorageMainService)),S.isWindows?ve.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.WindowsExternalTerminalService)):S.isMacintosh?ve.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.MacExternalTerminalService)):S.isLinux&&ve.set(Me.IExternalTerminalMainService,new l.SyncDescriptor(Fe.LinuxExternalTerminalService));const Ee=new le.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(oe.IBackupMainService,Ee),ve.set(r.IURLService,new l.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Ae=I.getDelayedChannel(ge.then(He=>He.getChannel("telemetryAppender"))),ke=new f.TelemetryAppenderClient(Ae),De=M.resolveCommonProperties(this.fileService,v.release(),v.hostname(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ce={appender:ke,commonProperties:De,piiPaths:Pe,sendErrorTelemetry:!0};ve.set(c.ITelemetryService,new l.SyncDescriptor(h.TelemetryService,[Ce]))}else ve.set(c.ITelemetryService,d.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(de,pe,ge){const ve=I.ProxyChannel.fromService(de.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const Ee=new i.UpdateChannel(de.get(y.IUpdateService));pe.registerChannel("update",Ee);const Ae=I.ProxyChannel.fromService(de.get(C.IIssueMainService));pe.registerChannel("issue",Ae);const ke=I.ProxyChannel.fromService(de.get(et.IEncryptionMainService));pe.registerChannel("encryption",ke);const De=I.ProxyChannel.fromService(de.get(be.ISignService));pe.registerChannel("sign",De);const Pe=I.ProxyChannel.fromService(de.get(Ge.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=de.get(we.INativeHostMainService);const Ce=I.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ce),ge.then(qe=>qe.registerChannel("nativeHost",Ce));const He=I.ProxyChannel.fromService(de.get(B.IWorkspacesService));pe.registerChannel("workspaces",He);const Ye=I.ProxyChannel.fromService(de.get(W.IMenubarMainService));pe.registerChannel("menubar",Ye);const Xe=I.ProxyChannel.fromService(de.get(r.IURLService));pe.registerChannel("url",Xe);const ht=I.ProxyChannel.fromService(de.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",ht);const _e=I.ProxyChannel.fromService(de.get(Ne.IWebviewManagerService));pe.registerChannel("webview",_e);const tt=this._register(new se.StorageDatabaseChannel(this.logService,de.get(re.IStorageMainService)));pe.registerChannel("storage",tt),ge.then(qe=>qe.registerChannel("storage",tt));const it=I.ProxyChannel.fromService(de.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",it);const Je=new F.LogLevelChannel(de.get(u.ILogService));pe.registerChannel("logLevel",Je),ge.then(qe=>qe.registerChannel("logLevel",Je));const nt=new F.LoggerChannel(de.get(u.ILoggerService));pe.registerChannel("logger",nt),ge.then(qe=>qe.registerChannel("logger",nt));const ot=new Ie.ElectronExtensionHostDebugBroadcastChannel(de.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",ot)}openFirstWindow(de,pe){const ge=this.windowsMainService=de.get(X.IWindowsMainService),ve=de.get(r.IURLService),Ee=de.get(we.INativeHostMainService);this.lifecycleMainService.phase=2;const Ae=[],ke=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(We=>{try{return{uri:ee.URI.parse(We),url:We}}catch(Qe){return null}}).filter(We=>{if(!We||this.shouldBlockURI(We.uri))return!1;const Qe=this.getWindowOpenableFromProtocolLink(We.uri);return Qe?(Ae.push(Qe),!1):!0}),De=this,Pe=this.environmentMainService,Ce=this.productService;ve.registerHandler({async handleURL(We,Qe){if(We.scheme===Ce.urlProtocol&&We.path==="workspace"&&(We=We.with({authority:"file",path:ee.URI.parse(We.query).path,query:""})),De.shouldBlockURI(We))return!0;const St=De.getWindowOpenableFromProtocolLink(We);if(St){const[ft]=ge.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[St],gotoLineMode:!0});return ft.focus(),!0}if(S.isMacintosh&&ge.getWindowCount()===0){const[ft]=ge.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:fe.getRemoteAuthority(We)});return await ft.ready(),ve.open(We,Qe)}return!1}});const He=this._register(new ct.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Ye=new I.StaticRouter(We=>He.getActiveClientId().then(Qe=>We===Qe)),Xe=new s.URLHandlerRouter(Ye),ht=pe.getChannel("urlHandler",Xe);ve.registerHandler(new s.URLHandlerChannelClient(ht)),this._register(new O.ElectronURLListener(ke,ve,ge,this.environmentMainService,this.productService));const _e=this.environmentMainService.args,tt=global.macOpenFiles,it=ut.isLaunchedFromCli(process.env)?0:4,Je=_e._.length,nt=!!_e["folder-uri"],ot=!!_e["file-uri"],qe=_e["skip-add-to-recently-opened"]===!0,dt=_e.wait&&_e.waitMarkerFilePath?ee.URI.file(_e.waitMarkerFilePath):void 0,yt=_e.remote||void 0;return Ae.length>0?ge.open({context:it,cli:_e,urisToOpen:Ae,gotoLineMode:!0,initialStartup:!0}):_e["new-window"]&&!Je&&!nt&&!ot?ge.open({context:it,cli:_e,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:yt}):tt.length&&!Je&&!nt&&!ot?ge.open({context:1,cli:_e,urisToOpen:tt.map(We=>this.getWindowOpenableFromPathSync(We)),noRecentEntry:qe,waitMarkerFileURI:dt,initialStartup:!0}):ge.open({context:it,cli:_e,forceNewWindow:_e["new-window"]||!Je&&_e["unity-launch"],diffMode:_e.diff,noRecentEntry:qe,waitMarkerFileURI:dt,gotoLineMode:_e.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(de){return!!(de.authority===Z.Schemas.file&&S.isWindows&&A.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[Te.mnemonicButtonLabel(K.localize(0,null)),Te.mnemonicButtonLabel(K.localize(1,null))],cancelId:1,message:K.localize(2,null,Te.getPathLabel(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:K.localize(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===Z.Schemas.file)return{fileUri:ee.URI.file(de.fsPath)};if(de.authority===Z.Schemas.vscodeRemote){const pe=de.path.indexOf(q.posix.sep,1);if(pe!==-1){const ge=de.path.substring(1,pe),ve=de.path.substring(pe),Ee=ee.URI.from({scheme:Z.Schemas.vscodeRemote,authority:ge,path:ve,query:de.query,fragment:de.fragment});return B.hasWorkspaceFileExtension(ve)?{workspaceUri:Ee}:/:[\d]+$/.test(ve)?{fileUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(de){try{if(L.statSync(de).isDirectory())return{folderUri:ee.URI.file(de)};if(B.hasWorkspaceFileExtension(de))return{workspaceUri:ee.URI.file(de)}}catch(pe){}return{fileUri:ee.URI.file(de)}}async afterWindowOpen(de,pe){var ge;this.lifecycleMainService.phase=3;let ve=!1;ce.once(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const Ee=de.get(c.ITelemetryService);this._register(pe.onDidError(({type:De,details:Pe})=>{let Ce;typeof Pe=="string"?Ce=Pe:Ce=`SharedProcess: crashed (detail: ${Pe.reason}, code: ${Pe.exitCode})`,R.onUnexpectedError(new Error(Ce)),Ee.publicLog2("sharedprocesserror",{type:De,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:pe.isVisible(),shuttingdown:ve})}));const Ae=this.productService.win32MutexName;if(S.isWindows&&Ae)try{const De=$.__$__nodeRequire("windows-mutex").Mutex,Pe=new De(Ae);ce.once(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(De){this.logService.error(De)}A.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(De,Pe)=>{Pe({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})});const ke=de.get(y.IUpdateService);(ke instanceof N.Win32UpdateService||ke instanceof G.LinuxUpdateService||ke instanceof z.DarwinUpdateService)&&ke.initialize(),(async()=>{const De=this._register(new j.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));De.schedule(),await w.resolveShellEnv(this.logService,this.environmentMainService.args,process.env),De.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse(xe.stripComments(Pe))["enable-crash-reporter"]===void 0){const He=(ge=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&ge!==void 0?ge:!0,Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${He},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${Be.generateUuid()}"`,"}"],Xe=Pe.substring(0,Pe.length-2).concat(`,
`,Ye.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,rt.VSBuffer.fromString(Xe))}}catch(De){this.logService.error(De)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const ge=de.get(ye.IDialogMainService);let ve=!1;const Ee=async ke=>{if(ve)return;ve=!0;const De=await A.contentTracing.stopRecording(V.joinPath(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);ke?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${De}`):ge.showMessageBox({type:"info",message:K.localize(4,null),detail:K.localize(5,null,De),buttons:[K.localize(6,null)]},Re.withNullAsUndefined(A.BrowserWindow.getFocusedWindow()))},Ae=setTimeout(()=>Ee(!0),3e4);Promise.all(pe.map(ke=>ke.ready())).then(()=>{clearTimeout(Ae),Ee(!1)})}};Ue=he([te(2,D.IInstantiationService),te(3,u.ILogService),te(4,a.IEnvironmentMainService),te(5,n.ILifecycleMainService),te(6,t.IConfigurationService),te(7,o.IStateMainService),te(8,je.IFileService),te(9,T.IProductService)],Ue),e.CodeApplication=Ue}),define(J[240],x([0,1,14,29,16,11,3,72,47,54,161,18,33,56,174,71,69,6,225,38,17,188,49,223,236,39,94,93,19,60,42,75,194,197,182,183,10,21,74,221,22,30,23,8,35,24,67,97,180,32,55,185,9,203]),function($,e,v,L,A,S,E,n,w,y,i,I,k,p,g,m,D,b,l,u,o,a,t,r,s,c,d,f,h,M,T,U,H,X,ee,B,Y,Q,N,G,z,C,F,R,O,P,W,_,q,V,K,Z,ne){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class re{main(){try{this.startup()}catch(oe){console.error(oe.message),v.app.exit(1)}}async startup(){h.setUnexpectedErrorHandler(ye=>console.error(ye));const[oe,ue,me,Se,Le,Ie,we]=this.createServices();try{try{await this.initServices(me,Se,Le)}catch(ye){throw this.handleStartupDataDirError(me,we.nameLong,ye),ye}await oe.invokeFunction(async ye=>{const Re=ye.get(b.ILogService),Te=ye.get(I.ILifecycleMainService),$e=ye.get(Q.IFileService),Ne=await this.claimInstance(Re,me,Te,oe,we,!0);return Ie.logger=new d.SpdLogLogger("main",R.join(me.logsPath,"main.log"),!0,Ie.getLevel()),T.once(Te.onWillShutdown)(()=>{$e.dispose(),Se.dispose()}),oe.createInstance(s.CodeApplication,Ne,ue).startup()})}catch(ye){oe.invokeFunction(this.quit,ye)}}createServices(){const oe=new m.ServiceCollection,ue=Object.assign({_serviceBrand:void 0},w.default);oe.set(z.IProductService,ue);const me=new P.EnvironmentMainService(this.resolveArgs(),ue),Se=this.patchEnvironment(me);oe.set(P.IEnvironmentMainService,me);const Le=new f.BufferLogService,Ie=new b.MultiplexLogService([new b.ConsoleMainLogger(b.getLogLevel(me)),Le]);process.once("exit",()=>Ie.dispose()),oe.set(b.ILogService,Ie);const we=new ee.FileService(Ie);oe.set(Q.IFileService,we);const ye=new B.DiskFileSystemProvider(Ie);we.registerProvider(Y.Schemas.file,ye),oe.set(b.ILoggerService,new q.LoggerService(Ie,we));const Re=new a.ConfigurationService(me.settingsResource,we);oe.set(o.IConfigurationService,Re),oe.set(I.ILifecycleMainService,new D.SyncDescriptor(I.LifecycleMainService));const Te=new l.StateMainService(me,Ie,we);return oe.set(u.IStateMainService,Te),oe.set(t.IRequestService,new D.SyncDescriptor(r.RequestMainService)),oe.set(M.IThemeMainService,new D.SyncDescriptor(M.ThemeMainService)),oe.set(U.ISignService,new D.SyncDescriptor(H.SignService)),oe.set(N.ITunnelService,new D.SyncDescriptor(G.TunnelService)),oe.set(K.IProtocolMainService,new D.SyncDescriptor(Z.ProtocolMainService)),[new g.InstantiationService(oe,!0),Se,me,Re,Te,Le,ue]}patchEnvironment(oe){const ue={VSCODE_IPC_HOOK:oe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(me=>{const Se=process.env[me];typeof Se=="string"&&(ue[me]=Se)}),Object.assign(process.env,ue),ue}initServices(oe,ue,me){return ne.Promises.settled([Promise.all([oe.extensionsPath,oe.nodeCachedDataDir,oe.logsPath,oe.globalStorageHome.fsPath,oe.workspaceStorageHome.fsPath,oe.backupHome].map(Se=>Se?A.Promises.mkdir(Se,{recursive:!0}):void 0)),ue.initialize(),me.init()])}async claimInstance(oe,ue,me,Se,Le,Ie){let we;try{n.mark("code/willStartMainServer"),we=await p.serve(ue.mainIPCHandle),n.mark("code/didStartMainServer"),T.once(me.onWillShutdown)(()=>we.dispose())}catch(ye){if(ye.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ue,Le.nameLong,ye),ye;let Re;try{Re=await p.connect(ue.mainIPCHandle,"main")}catch(Ne){if(!Ie||E.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog(S.localize(0,null,Le.nameShort),S.localize(1,null),Le.nameLong),Ne;try{L.unlinkSync(ue.mainIPCHandle)}catch(je){throw oe.warn("Could not delete obsolete instance handle",je),je}return this.claimInstance(oe,ue,me,Se,Le,!1)}if(ue.extensionTestsLocationURI&&!ue.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw oe.error(Ne),Re.dispose(),new Error(Ne)}let Te;!ue.args.wait&&!ue.args.status&&(Te=setTimeout(()=>{this.showStartupWarningDialog(S.localize(2,null,Le.nameShort),S.localize(3,null),Le.nameLong)},1e4));const $e=k.ProxyChannel.toService(Re.getChannel("launch"),{disableMarshalling:!0});if(ue.args.status)return Se.invokeFunction(async()=>{const Ne=new X.DiagnosticsService(_.NullTelemetryService,Le),je=await $e.getMainProcessInfo(),xe=await $e.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Be=await Ne.getDiagnostics(je,xe);throw console.log(Be),new h.ExpectedError});throw E.isWindows&&await this.windowsAllowSetForegroundWindow($e,oe),oe.trace("Sending env to running instance..."),await $e.start(ue.args,process.env),Re.dispose(),Te&&clearTimeout(Te),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ue.args.status)throw oe.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),we}handleStartupDataDirError(oe,ue,me){if(me.code==="EACCES"||me.code==="EPERM"){const Se=O.coalesce([oe.userDataPath,oe.extensionsPath,p.XDG_RUNTIME_DIR]).map(Le=>c.getPathLabel(Le,oe));this.showStartupWarningDialog(S.localize(4,null),S.localize(5,null,W.toErrorMessage(me),Se.join(`
`)),ue)}}showStartupWarningDialog(oe,ue,me){v.dialog.showMessageBoxSync({title:me,type:"warning",buttons:[c.mnemonicButtonLabel(S.localize(6,null))],message:oe,detail:ue,noLink:!0})}async windowsAllowSetForegroundWindow(oe,ue){if(E.isWindows){const me=await oe.getMainProcessId();ue.trace("Sending some foreground love to the running instance:",me);try{(await new Promise((Se,Le)=>{$(["windows-foreground-love"],Se,Le)})).allowSetForegroundWindow(me)}catch(Se){ue.error(Se)}}}quit(oe,ue){const me=oe.get(b.ILogService),Se=oe.get(I.ILifecycleMainService);let Le=0;ue&&(ue.isExpected?ue.message&&me.trace(ue.message):(Le=1,ue.stack?me.error(ue.stack):me.error(`Startup error: ${ue.toString()}`))),Se.kill(Le)}resolveArgs(){const oe=this.validatePaths(y.parseMainProcessArgv(process.argv));if(oe.wait&&!oe.waitMarkerFilePath){const ue=i.createWaitMarkerFile(oe.verbose);ue&&(y.addArg(process.argv,"--waitMarkerFilePath",ue),oe.waitMarkerFilePath=ue)}return oe}validatePaths(oe){if(oe["open-url"]&&(oe._urls=oe._,oe._=[]),!oe.remote){const ue=this.doValidatePaths(oe._,oe.goto);oe._=ue}return oe}doValidatePaths(oe,ue){const me=V.cwd(),Se=oe.map(we=>{let ye=String(we),Re;ue&&(Re=C.parseLineAndColumnAware(ye),ye=Re.path),ye&&(ye=this.preparePath(me,ye));const Te=C.sanitizeFilePath(ye,me),$e=R.basename(Te);return $e&&!C.isValidBasename($e)?null:ue&&Re?(Re.path=Te,this.toPath(Re)):Te}),Le=E.isWindows||E.isMacintosh,Ie=O.distinct(Se,we=>we&&Le?we.toLowerCase():we||"");return O.coalesce(Ie)}preparePath(oe,ue){return E.isWindows&&(ue=F.rtrim(ue,'"')),ue=F.trim(F.trim(ue," "),"	"),E.isWindows&&(ue=R.resolve(oe,ue),ue=F.rtrim(ue,".")),ue}toPath(oe){const ue=[oe.path];return typeof oe.line=="number"&&ue.push(String(oe.line)),typeof oe.column=="number"&&ue.push(String(oe.column)),ue.join(":")}}new re().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/507ce72a4466fbb27b715c3722558bb15afa9f48/core/vs/code/electron-main/main.js.map
