/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ge=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/common/mime","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],pe=function(X){for(var e=[],v=0,R=X.length;v<R;v++)e[v]=ge[X[v]];return e};define(ge[49],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,k){if(!R)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=v}),define(ge[68],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function R(s){const I=[];for(let l in s)v.call(s,l)&&I.push(s[l]);return I}e.values=R;function k(s,I){for(let l in s)if(v.call(s,l)&&I({key:l,value:s[l]},function(){delete s[l]})===!1)return}e.forEach=k;function S(s,I){const l=Object.create(null);for(const g of s){const c=I(g);let m=l[c];m||(m=l[c]=[]),m.push(g)}return l}e.groupBy=S;function A(s){const I=Object.create(null);return s&&s.forEach((l,g)=>{I[g]=l}),I}e.fromMap=A;function C(s,I){const l=[],g=[];for(let c of s)I.has(c)||l.push(c);for(let c of I)s.has(c)||g.push(c);return{removed:l,added:g}}e.diffSets=C;function D(s,I){const l=[],g=[];for(let[c,m]of s)I.has(c)||l.push(m);for(let[c,m]of I)s.has(c)||g.push(m);return{removed:l,added:g}}e.diffMaps=D;class P{constructor(){this.map=new Map}add(I,l){let g=this.map.get(I);g||(g=new Set,this.map.set(I,g)),g.add(l)}delete(I,l){const g=this.map.get(I);!g||(g.delete(l),g.size===0&&this.map.delete(I))}forEach(I,l){const g=this.map.get(I);!g||g.forEach(l)}}e.SetMap=P}),define(ge[50],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(A){return(C,D,P)=>{let s=null,I=null;if(typeof P.value=="function"?(s="value",I=P.value):typeof P.get=="function"&&(s="get",I=P.get),!I)throw new Error("not supported");P[s]=A(I,D)}}e.createDecorator=v;function R(A,C,D){let P=null,s=null;if(typeof D.value=="function"?(P="value",s=D.value,s.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",s=D.get),!s)throw new Error("not supported");const I=`$memoize$${C}`;D[P]=function(...l){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:s.apply(this,l)}),this[I]}}e.memoize=R;function k(A,C,D){return v((P,s)=>{const I=`$debounce$${s}`,l=`$debounce$result$${s}`;return function(...g){this[l]||(this[l]=D?D():void 0),clearTimeout(this[I]),C&&(this[l]=C(this[l],...g),g=[this[l]]),this[I]=setTimeout(()=>{P.apply(this,g),this[l]=D?D():void 0},A)}})}e.debounce=k;function S(A,C,D){return v((P,s)=>{const I=`$throttle$timer$${s}`,l=`$throttle$result$${s}`,g=`$throttle$lastRun$${s}`,c=`$throttle$pending$${s}`;return function(...m){if(this[l]||(this[l]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),C&&(this[l]=C(this[l],...m)),this[c])return;const _=this[g]+A;_<=Date.now()?(this[g]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[g]=Date.now(),P.apply(this,[this[l]]),this[l]=D?D():void 0},_-Date.now()))}})}e.throttle=S}),define(ge[16],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=R;function k(f){D(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=k;function S(f){D(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=S;function A(f){if(f instanceof Error){let{name:t,message:r}=f;const n=f.stacktrace||f.stack;return{$isError:!0,name:t,message:r,stack:n}}return f}e.transformErrorForSerialization=A;const C="Canceled";function D(f){return f instanceof Error&&f.name===C&&f.message===C}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=P;function s(){const f=new Error(C);return f.name=f.message,f}e.canceled=s;function I(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=I;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=l;function g(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function c(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function m(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=m;class _ extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=_;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function u(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function d(f,t=Object.create(null)){const r=new Error(f);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=d}),define(ge[17],pe([0,1,16]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,F=0){return N[N.length-(1+F)]}e.tail=R;function k(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=k;function S(N,F,M=(U,B)=>U===B){if(N===F)return!0;if(!N||!F||N.length!==F.length)return!1;for(let U=0,B=N.length;U<B;U++)if(!M(N[U],F[U]))return!1;return!0}e.equals=S;function A(N,F,M){let U=0,B=N.length-1;for(;U<=B;){const K=(U+B)/2|0,ie=M(N[K],F);if(ie<0)U=K+1;else if(ie>0)B=K-1;else return K}return-(U+1)}e.binarySearch=A;function C(N,F){let M=0,U=N.length;if(U===0)return 0;for(;M<U;){const B=Math.floor((M+U)/2);F(N[B])?U=B:M=B+1}return M}e.findFirstInSorted=C;function D(N,F,M){if(N=N|0,N>=F.length)throw new TypeError("invalid index");let U=F[Math.floor(F.length*Math.random())],B=[],K=[],ie=[];for(let we of F){const Te=M(we,U);Te<0?B.push(we):Te>0?K.push(we):ie.push(we)}return N<B.length?D(N,B,M):N<B.length+ie.length?ie[0]:D(N-(B.length+ie.length),K,M)}e.quickSelect=D;function P(N,F){const M=[];let U;for(const B of N.slice(0).sort(F))!U||F(U[0],B)!==0?(U=[B],M.push(U)):U.push(B);return M}e.groupBy=P;function s(N,F,M){const U=[];function B(we,Te,ye){if(Te===0&&ye.length===0)return;const Oe=U[U.length-1];Oe&&Oe.start+Oe.deleteCount===we?(Oe.deleteCount+=Te,Oe.toInsert.push(...ye)):U.push({start:we,deleteCount:Te,toInsert:ye})}let K=0,ie=0;for(;;){if(K===N.length){B(K,0,F.slice(ie));break}if(ie===F.length){B(K,N.length-K,[]);break}const we=N[K],Te=F[ie],ye=M(we,Te);ye===0?(K+=1,ie+=1):ye<0?(B(K,1,[]),K+=1):ye>0&&(B(K,0,[Te]),ie+=1)}return U}e.sortedDiff=s;function I(N,F,M){const U=s(N,F,M),B=[],K=[];for(const ie of U)B.push(...N.slice(ie.start,ie.start+ie.deleteCount)),K.push(...ie.toInsert);return{removed:B,added:K}}e.delta=I;function l(N,F,M){if(M===0)return[];const U=N.slice(0,M).sort(F);return c(N,F,U,M,N.length),U}e.top=l;function g(N,F,M,U,B){return M===0?Promise.resolve([]):new Promise((K,ie)=>{(async()=>{const we=N.length,Te=N.slice(0,M).sort(F);for(let ye=M,Oe=Math.min(M+U,we);ye<we;ye=Oe,Oe=Math.min(Oe+U,we)){if(ye>M&&await new Promise(je=>setTimeout(je)),B&&B.isCancellationRequested)throw v.canceled();c(N,F,Te,ye,Oe)}return Te})().then(K,ie)})}e.topAsync=g;function c(N,F,M,U,B){for(const K=M.length;U<B;U++){const ie=N[U];if(F(ie,M[K-1])<0){M.pop();const we=C(M,Te=>F(ie,Te)<0);M.splice(we,0,ie)}}}function m(N){return N.filter(F=>!!F)}e.coalesce=m;function _(N){let F=0;for(let M=0;M<N.length;M++)N[M]&&(N[F]=N[M],F+=1);N.length=F}e.coalesceInPlace=_;function w(N,F,M){N.splice(M,0,N.splice(F,1)[0])}e.move=w;function E(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=E;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function d(N,F){if(!F)return N.filter((U,B)=>N.indexOf(U)===B);const M=Object.create(null);return N.filter(U=>{const B=F(U);return M[B]?!1:(M[B]=!0,!0)})}e.distinct=d;function f(N){const F=new Set;return N.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=f;function t(N){const F=Object.create(null);return M=>{const U=N(M);return F[U]?!1:(F[U]=!0,!0)}}e.uniqueFilter=t;function r(N,F){for(let M=N.length-1;M>=0;M--){const U=N[M];if(F(U))return M}return-1}e.lastIndex=r;function n(N,F){return N.length>0?N[0]:F}e.firstOrDefault=n;function i(N,F,M=(U,B)=>U===B){let U=0;for(let B=0,K=Math.min(N.length,F.length);B<K&&M(N[B],F[B]);B++)U++;return U}e.commonPrefixLength=i;function a(N){return[].concat(...N)}e.flatten=a;function p(N,F){let M=typeof F=="number"?N:0;typeof F=="number"?M=N:(M=0,F=N);const U=[];if(M<=F)for(let B=M;B<F;B++)U.push(B);else for(let B=M;B>F;B--)U.push(B);return U}e.range=p;function h(N,F,M){return N.reduce((U,B)=>(U[F(B)]=M?M(B):B,U),Object.create(null))}e.index=h;function b(N,F){return N.push(F),()=>y(N,F)}e.insert=b;function y(N,F){const M=N.indexOf(F);if(M>-1)return N.splice(M,1),F}e.remove=y;function o(N,F,M){const U=N.slice(0,F),B=N.slice(F);return U.concat(M,B)}e.arrayInsert=o;function L(N,F){let M;if(typeof F=="number"){let U=F;M=()=>{const B=Math.sin(U++)*179426549;return B-Math.floor(B)}}else M=Math.random;for(let U=N.length-1;U>0;U-=1){const B=Math.floor(M()*(U+1)),K=N[U];N[U]=N[B],N[B]=K}}e.shuffle=L;function O(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.unshift(F))}e.pushToStart=O;function W(N,F){const M=N.indexOf(F);M>-1&&(N.splice(M,1),N.push(F))}e.pushToEnd=W;function ee(N,F){return Array.isArray(N)?N.map(F):F(N)}e.mapArrayOrNot=ee;function ce(N){return Array.isArray(N)?N:[N]}e.asArray=ce;function G(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=G;function x(N,F){for(const M of N){const U=F(M);if(U!==void 0)return U}}e.mapFind=x;function V(N,F){let M=Number.MAX_SAFE_INTEGER,U=0;return N.forEach((B,K)=>{const ie=F(B);ie<M&&(M=ie,U=K)}),U}e.minIndex=V;function T(N,F){let M=Number.MIN_SAFE_INTEGER,U=0;return N.forEach((B,K)=>{const ie=F(B);ie>M&&(M=ie,U=K)}),U}e.maxIndex=T}),define(ge[69],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const k=this;let S=!1,A;return function(){return S||(S=!0,A=R.apply(k,arguments)),A}}e.once=v}),define(ge[70],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class v{constructor(k){this._prefix=k,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=v,e.defaultGenerator=new v("id#")}),define(ge[71],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function k(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}R.is=k;const S=Object.freeze([]);function A(){return S}R.empty=A;function*C(f){yield f}R.single=C;function D(f){return f||S}R.from=D;function P(f){return!f||f[Symbol.iterator]().next().done===!0}R.isEmpty=P;function s(f){return f[Symbol.iterator]().next().value}R.first=s;function I(f,t){for(const r of f)if(t(r))return!0;return!1}R.some=I;function l(f,t){for(const r of f)if(t(r))return r}R.find=l;function*g(f,t){for(const r of f)t(r)&&(yield r)}R.filter=g;function*c(f,t){let r=0;for(const n of f)yield t(n,r++)}R.map=c;function*m(...f){for(const t of f)for(const r of t)yield r}R.concat=m;function*_(f){for(const t of f)for(const r of t)yield r}R.concatNested=_;function w(f,t,r){let n=r;for(const i of f)n=t(n,i);return n}R.reduce=w;function*E(f,t,r=f.length){for(t<0&&(t+=f.length),r<0?r+=f.length:r>f.length&&(r=f.length);t<r;t++)yield f[t]}R.slice=E;function u(f,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,f];const n=f[Symbol.iterator]();for(let i=0;i<t;i++){const a=n.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return n}}]}R.consume=u;function d(f,t,r=(n,i)=>n===i){const n=f[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=n.next(),p=i.next();if(a.done!==p.done)return!1;if(a.done)return!0;if(!r(a.value,p.value))return!1}}R.equals=d})(v=e.Iterable||(e.Iterable={}))}),define(ge[51],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function A(t,r=!1){let n=0,i=t.length,a="",p=0,h=16,b=0;function y(G){let x=0,V=0;for(;x<G;){const T=t.charCodeAt(n);if(T>=48&&T<=57)V=V*16+T-48;else if(T>=65&&T<=70)V=V*16+T-65+10;else if(T>=97&&T<=102)V=V*16+T-97+10;else break;n++,x++}return x<G&&(V=-1),V}function o(G){n=G,a="",p=0,h=16,b=0}function L(){const G=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&P(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&P(t.charCodeAt(n)))for(n++;n<t.length&&P(t.charCodeAt(n));)n++;else return b=3,t.substring(G,n);let x=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&P(t.charCodeAt(n))){for(n++;n<t.length&&P(t.charCodeAt(n));)n++;x=n}else b=3;return t.substring(G,x)}function O(){let G="",x=n;for(;;){if(n>=i){G+=t.substring(x,n),b=2;break}const V=t.charCodeAt(n);if(V===34){G+=t.substring(x,n),n++;break}if(V===92){if(G+=t.substring(x,n),n++,n>=i){b=2;break}switch(t.charCodeAt(n++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const N=y(4);N>=0?G+=String.fromCharCode(N):b=4;break;default:b=5}x=n;continue}if(V>=0&&V<=31)if(D(V)){G+=t.substring(x,n),b=2;break}else b=6;n++}return G}function W(){if(a="",b=0,p=n,n>=i)return p=i,h=17;let G=t.charCodeAt(n);if(C(G)){do n++,a+=String.fromCharCode(G),G=t.charCodeAt(n);while(C(G));return h=15}if(D(G))return n++,a+=String.fromCharCode(G),G===13&&t.charCodeAt(n)===10&&(n++,a+=`
`),h=14;switch(G){case 123:return n++,h=1;case 125:return n++,h=2;case 91:return n++,h=3;case 93:return n++,h=4;case 58:return n++,h=6;case 44:return n++,h=5;case 34:return n++,a=O(),h=10;case 47:const x=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!D(t.charCodeAt(n));)n++;return a=t.substring(x,n),h=12}if(t.charCodeAt(n+1)===42){n+=2;const V=i-1;let T=!1;for(;n<V;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,T=!0;break}n++}return T||(n++,b=1),a=t.substring(x,n),h=13}return a+=String.fromCharCode(G),n++,h=16;case 45:if(a+=String.fromCharCode(G),n++,n===i||!P(t.charCodeAt(n)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=L(),h=11;default:for(;n<i&&ee(G);)n++,G=t.charCodeAt(n);if(p!==n){switch(a=t.substring(p,n),a){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return a+=String.fromCharCode(G),n++,h=16}}function ee(G){if(C(G)||D(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let G;do G=W();while(G>=12&&G<=15);return G}return{setPosition:o,getPosition:()=>n,scan:r?ce:W,getToken:()=>h,getTokenValue:()=>a,getTokenOffset:()=>p,getTokenLength:()=>n-p,getTokenError:()=>b}}e.createScanner=A;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var s;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(s||(s={}));function I(t,r){const n=[],i=new Object;let a;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function b(y,o,L,O){p.value=y,p.offset=o,p.length=L,p.type=O,p.colonOffset=void 0,a=p}try{u(t,{onObjectBegin:(y,o)=>{if(r<=y)throw i;a=void 0,h=r>y,n.push("")},onObjectProperty:(y,o,L)=>{if(r<o||(b(y,o,L,"property"),n[n.length-1]=y,r<=o+L))throw i},onObjectEnd:(y,o)=>{if(r<=y)throw i;a=void 0,n.pop()},onArrayBegin:(y,o)=>{if(r<=y)throw i;a=void 0,n.push(0)},onArrayEnd:(y,o)=>{if(r<=y)throw i;a=void 0,n.pop()},onLiteralValue:(y,o,L)=>{if(r<o||(b(y,o,L,f(y)),r<=o+L))throw i},onSeparator:(y,o,L)=>{if(r<=o)throw i;if(y===":"&&a&&a.type==="property")a.colonOffset=o,h=!1,a=void 0;else if(y===","){const O=n[n.length-1];typeof O=="number"?n[n.length-1]=O+1:(h=!0,n[n.length-1]=""),a=void 0}}})}catch(y){if(y!==i)throw y}return{path:n,previousNode:a,isAtPropertyKey:h,matches:y=>{let o=0;for(let L=0;o<y.length&&L<n.length;L++)if(y[o]===n[L]||y[o]==="*")o++;else if(y[o]!=="**")return!1;return o===y.length}}}e.getLocation=I;function l(t,r=[],n=S.DEFAULT){let i=null,a=[];const p=[];function h(y){Array.isArray(a)?a.push(y):i!==null&&(a[i]=y)}return u(t,{onObjectBegin:()=>{const y={};h(y),p.push(a),a=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{a=p.pop()},onArrayBegin:()=>{const y=[];h(y),p.push(a),a=y,i=null},onArrayEnd:()=>{a=p.pop()},onLiteralValue:h,onError:(y,o,L)=>{r.push({error:y,offset:o,length:L})}},n),a[0]}e.parse=l;function g(t,r=[],n=S.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function p(y){return i.children.push(y),y}u(t,{onObjectBegin:y=>{i=p({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,o,L)=>{i=p({type:"property",offset:o,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:o,length:L,parent:i})},onObjectEnd:(y,o)=>{i.length=y+o-i.offset,i=i.parent,a(y+o)},onArrayBegin:(y,o)=>{i=p({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,o)=>{i.length=y+o-i.offset,i=i.parent,a(y+o)},onLiteralValue:(y,o,L)=>{p({type:f(y),offset:o,length:L,parent:i,value:y}),a(o+L)},onSeparator:(y,o,L)=>{i.type==="property"&&(y===":"?i.colonOffset=o:y===","&&a(o))},onError:(y,o,L)=>{r.push({error:y,offset:o,length:L})}},n);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=g;function c(t,r){if(!t)return;let n=t;for(let i of r)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const p of n.children)if(Array.isArray(p.children)&&p.children[0].value===i){n=p.children[1],a=!0;break}if(!a)return}else{const a=i;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}e.findNodeAtLocation=c;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=m;function _(t){switch(t.type){case"array":return t.children.map(_);case"object":const r=Object.create(null);for(let n of t.children){const i=n.children[1];i&&(r[n.children[0].value]=_(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=_;function w(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=w;function E(t,r,n=!1){if(w(t,r,n)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=r;a++){const p=E(i[a],r,n);if(p)return p}return t}}e.findNodeAtOffset=E;function u(t,r,n=S.DEFAULT){const i=A(t,!1);function a(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function p(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=a(r.onObjectBegin),b=p(r.onObjectProperty),y=a(r.onObjectEnd),o=a(r.onArrayBegin),L=a(r.onArrayEnd),O=p(r.onLiteralValue),W=p(r.onSeparator),ee=a(r.onComment),ce=p(r.onError),G=n&&n.disallowComments,x=n&&n.allowTrailingComma;function V(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:T(14);break;case 5:T(15);break;case 3:T(13);break;case 1:G||T(11);break;case 2:T(12);break;case 6:T(16);break}switch(ie){case 12:case 13:G?T(10):ee();break;case 16:T(1);break;case 15:case 14:break;default:return ie}}}function T(ie,we=[],Te=[]){if(ce(ie),we.length+Te.length>0){let ye=i.getToken();for(;ye!==17;){if(we.indexOf(ye)!==-1){V();break}else if(Te.indexOf(ye)!==-1)break;ye=V()}}}function N(ie){const we=i.getTokenValue();return ie?O(we):b(we),V(),!0}function F(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(T(2),ie=0)}catch(we){T(2)}O(ie);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return V(),!0}function M(){return i.getToken()!==10?(T(3,[],[2,5]),!1):(N(!1),i.getToken()===6?(W(":"),V(),K()||T(4,[],[2,5])):T(5,[],[2,5]),!0)}function U(){h(),V();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||T(4,[],[]),W(","),V(),i.getToken()===2&&x)break}else ie&&T(6,[],[]);M()||T(4,[],[2,5]),ie=!0}return y(),i.getToken()!==2?T(7,[2],[]):V(),!0}function B(){o(),V();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||T(4,[],[]),W(","),V(),i.getToken()===4&&x)break}else ie&&T(6,[],[]);K()||T(4,[],[4,5]),ie=!0}return L(),i.getToken()!==4?T(8,[4],[]):V(),!0}function K(){switch(i.getToken()){case 3:return B();case 1:return U();case 10:return N(!0);default:return F()}}return V(),i.getToken()===17?n.allowEmptyContent?!0:(T(4,[],[]),!1):K()?(i.getToken()!==17&&T(9,[],[]),!0):(T(4,[],[]),!1)}e.visit=u;function d(t,r){let n=A(t),i=[],a,p=0,h;do switch(h=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:p!==h&&i.push(t.substring(p,h)),r!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,r)),p=n.getPosition();break}while(a!==17);return i.join("")}e.stripComments=d;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ge[131],pe([0,1,51]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(D,P,s){let I,l,g,c,m;if(P){for(c=P.offset,m=c+P.length,g=c;g>0&&!C(D,g-1);)g--;let p=m;for(;p<D.length&&!C(D,p);)p++;l=D.substring(g,p),I=S(l,s)}else l=D,I=0,g=0,c=0,m=D.length;const _=A(s,D);let w=!1,E=0,u;s.insertSpaces?u=k(" ",s.tabSize||4):u="	";const d=v.createScanner(l,!1);let f=!1;function t(){return _+k(u,I+E)}function r(){let p=d.scan();for(w=!1;p===15||p===14;)w=w||p===14,p=d.scan();return f=p===16||d.getTokenError()!==0,p}const n=[];function i(p,h,b){!f&&h<m&&b>c&&D.substring(h,b)!==p&&n.push({offset:h,length:b-h,content:p})}let a=r();if(a!==17){const p=d.getTokenOffset()+g,h=k(u,I);i(h,g,p)}for(;a!==17;){let p=d.getTokenOffset()+d.getTokenLength()+g,h=r(),b="";for(;!w&&(h===12||h===13);){const o=d.getTokenOffset()+g;i(" ",p,o),p=d.getTokenOffset()+d.getTokenLength()+g,b=h===12?t():"",h=r()}if(h===2)a!==1&&(E--,b=t());else if(h===4)a!==3&&(E--,b=t());else{switch(a){case 3:case 1:E++,b=t();break;case 5:case 12:b=t();break;case 13:w?b=t():b=" ";break;case 6:b=" ";break;case 10:if(h===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?b=" ":h!==5&&h!==17&&(f=!0);break;case 16:f=!0;break}w&&(h===12||h===13)&&(b=t())}const y=d.getTokenOffset()+g;i(b,p,y),a=h}return n}e.format=R;function k(D,P){let s="";for(let I=0;I<P;I++)s+=D;return s}function S(D,P){let s=0,I=0;const l=P.tabSize||4;for(;s<D.length;){const g=D.charAt(s);if(g===" ")I++;else if(g==="	")I+=l;else break;s++}return Math.floor(I/l)}function A(D,P){for(let s=0;s<P.length;s++){const I=P.charAt(s);if(I==="\r")return s+1<P.length&&P.charAt(s+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=A;function C(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=C}),define(ge[132],pe([0,1,51,131]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(P,s,I){return S(P,s,void 0,I)}e.removeProperty=k;function S(P,s,I,l,g){const c=s.slice(),m=[],_=v.parseTree(P,m);let w,E;for(;c.length>0&&(E=c.pop(),w=v.findNodeAtLocation(_,c),w===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(w)if(w.type==="object"&&typeof E=="string"&&Array.isArray(w.children)){const u=v.findNodeAtLocation(w,[E]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const d=w.children.indexOf(u.parent);let f,t=u.parent.offset+u.parent.length;if(d>0){const r=w.children[d-1];f=r.offset+r.length}else f=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return A(P,{offset:f,length:t-f,content:""},l)}else return A(P,{offset:u.offset,length:u.length,content:JSON.stringify(I)},l);else{if(I===void 0)return[];const d=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,f=g?g(w.children.map(r=>r.children[0].value)):w.children.length;let t;if(f>0){const r=w.children[f-1];t={offset:r.offset+r.length,length:0,content:","+d}}else w.children.length===0?t={offset:w.offset+1,length:0,content:d}:t={offset:w.offset+1,length:0,content:d+","};return A(P,t,l)}}else if(w.type==="array"&&typeof E=="number"&&Array.isArray(w.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let d;if(w.children.length===0||E===0)d={offset:w.offset+1,length:0,content:w.children.length===0?u:u+","};else{const f=E===-1||E>w.children.length?w.children.length:E,t=w.children[f-1];d={offset:t.offset+t.length,length:0,content:","+u}}return A(P,d,l)}else{const u=E,d=w.children[u];let f;if(w.children.length===1)f={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===u){const t=w.children[u-1],r=t.offset+t.length,n=w.offset+w.length;f={offset:r,length:n-2-r,content:""}}else f={offset:d.offset,length:w.children[u+1].offset-d.offset,content:""};return A(P,f,l)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${w.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(P,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},l)}}e.setProperty=S;function A(P,s,I){let l=C(P,s),g=s.offset,c=s.offset+s.content.length;if(s.length===0||s.content.length===0){for(;g>0&&!R.isEOL(l,g-1);)g--;for(;c<l.length&&!R.isEOL(l,c);)c++}const m=R.format(l,{offset:g,length:c-g},I);for(let w=m.length-1;w>=0;w--){const E=m[w];l=C(l,E),g=Math.min(g,E.offset),c=Math.max(c,E.offset+E.length),c+=E.content.length-E.length}const _=P.length-(l.length-c)-g;return[{offset:g,length:_,content:l.substring(g,c)}]}e.withFormatting=A;function C(P,s){return P.substring(0,s.offset)+s.content+P.substring(s.offset+s.length)}e.applyEdit=C;function D(P,s){let I=s.slice(0).sort((g,c)=>{const m=g.offset-c.offset;return m===0?g.length-c.length:m}),l=P.length;for(let g=I.length-1;g>=0;g--){let c=I[g];if(c.offset+c.length<=l)P=C(P,c);else throw new Error("Overlapping edit");l=c.offset}return P}e.applyEdits=D}),define(ge[133],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new v(()=>k(this.getValue()))}}e.Lazy=v}),define(ge[6],pe([0,1,69,71]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const k=!1;let S=null;function A(u){S=u}if(e.setDisposableTracker=A,k){const u="__is_disposable_tracked__";S=new class{trackDisposable(d){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[u]||console.log(f)},3e3)}markTracked(d){if(d&&d!==m.None)try{d[u]=!0}catch(f){}}}}function C(u){!S||S.markTracked(u)}function D(u){return S&&S.trackDisposable(u),u}e.trackDisposable=D;class P extends Error{constructor(d){super(`Encountered errors while disposing of store. Errors: [${d.join(", ")}]`);this.errors=d}}e.MultiDisposeError=P;function s(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=s;function I(u){if(R.Iterable.is(u)){let d=[];for(const f of u)if(f){C(f);try{f.dispose()}catch(t){d.push(t)}}if(d.length===1)throw d[0];if(d.length>1)throw new P(d);return Array.isArray(u)?[]:u}else if(u)return C(u),u.dispose(),u}e.dispose=I;function l(...u){return u.forEach(C),g(()=>I(u))}e.combinedDisposable=l;function g(u){const d=D({dispose:()=>{C(d),u()}});return d}e.toDisposable=g;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return C(d),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(d),d}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new c,D(this)}dispose(){C(this),this._store.dispose()}_register(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(d)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class _{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(d){var f;this._isDisposed||d===this._value||((f=this._value)===null||f===void 0||f.dispose(),d&&C(d),this._value=d)}clear(){this.value=void 0}dispose(){var d;this._isDisposed=!0,C(this),(d=this._value)===null||d===void 0||d.dispose(),this._value=void 0}}e.MutableDisposable=_;class w{constructor(){this.references=new Map}acquire(d,...f){let t=this.references.get(d);t||(t={counter:0,object:this.createReferencedObject(d,...f)},this.references.set(d,t));const{object:r}=t,n=v.once(()=>{--t.counter==0&&(this.destroyReferencedObject(d,t.object),this.references.delete(d))});return t.counter++,{object:r,dispose:n}}}e.ReferenceCollection=w;class E{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=E}),define(ge[72],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let S=this._first;for(;S!==v.Undefined;){const A=S.next;S.prev=v.Undefined,S.next=v.Undefined,S=A}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,A){const C=new v(S);if(this._first===v.Undefined)this._first=C,this._last=C;else if(A){const P=this._last;this._last=C,C.prev=P,P.next=C}else{const P=this._first;this._first=C,C.next=P,P.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const A=S.prev;A.next=S.next,S.next.prev=A}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Se,_e){for(var ke=0;ke<_e.length;ke++){var ae=_e[ke];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Se,ae.key,ae)}}function e(Se,_e,ke){return _e&&X(Se.prototype,_e),ke&&X(Se,ke),Se}function v(Se,_e){if(!!Se){if(typeof Se=="string")return R(Se,_e);var ke=Object.prototype.toString.call(Se).slice(8,-1);if(ke==="Object"&&Se.constructor&&(ke=Se.constructor.name),ke==="Map"||ke==="Set")return Array.from(Se);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return R(Se,_e)}}function R(Se,_e){(_e==null||_e>Se.length)&&(_e=Se.length);for(var ke=0,ae=new Array(_e);ke<_e;ke++)ae[ke]=Se[ke];return ae}function k(Se,_e){var ke;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(ke=v(Se))||_e&&Se&&typeof Se.length=="number"){ke&&(Se=ke);var ae=0;return function(){return ae>=Se.length?{done:!0}:{done:!1,value:Se[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ke=Se[Symbol.iterator](),ke.next.bind(ke)}function S(Se){var _e={exports:{}};return Se(_e,_e.exports),_e.exports}var A=S(function(Se){function _e(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ke(ae){Se.exports.defaults=ae}Se.exports={defaults:_e(),getDefaults:_e,changeDefaults:ke}}),C=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,s=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(_e){return I[_e]};function g(Se,_e){if(_e){if(C.test(Se))return Se.replace(D,l)}else if(P.test(Se))return Se.replace(s,l);return Se}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Se){return Se.replace(c,function(_e,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var _=/(^|[^\[])\^/g;function w(Se,_e){Se=Se.source||Se,_e=_e||"";var ke={replace:function(fe,H){return H=H.source||H,H=H.replace(_,"$1"),Se=Se.replace(fe,H),ke},getRegex:function(){return new RegExp(Se,_e)}};return ke}var E=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Se,_e,ke){if(Se){var ae;try{ae=decodeURIComponent(m(ke)).replace(E,"").toLowerCase()}catch(fe){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!u.test(ke)&&(ke=i(_e,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(fe){return null}return ke}var f={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Se,_e){f[" "+Se]||(t.test(Se)?f[" "+Se]=Se+"/":f[" "+Se]=b(Se,"/",!0)),Se=f[" "+Se];var ke=Se.indexOf(":")===-1;return _e.substring(0,2)==="//"?ke?_e:Se.replace(r,"$1")+_e:_e.charAt(0)==="/"?ke?_e:Se.replace(n,"$1")+_e:Se+_e}var a={exec:function(){}};function p(Se){for(var _e=1,ke,ae;_e<arguments.length;_e++){ke=arguments[_e];for(ae in ke)Object.prototype.hasOwnProperty.call(ke,ae)&&(Se[ae]=ke[ae])}return Se}function h(Se,_e){var ke=Se.replace(/\|/g,function(H,Z,ue){for(var Pe=!1,Ae=Z;--Ae>=0&&ue[Ae]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ae=ke.split(/ \|/),fe=0;if(ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function b(Se,_e,ke){var ae=Se.length;if(ae===0)return"";for(var fe=0;fe<ae;){var H=Se.charAt(ae-fe-1);if(H===_e&&!ke)fe++;else if(H!==_e&&ke)fe++;else break}return Se.substr(0,ae-fe)}function y(Se,_e){if(Se.indexOf(_e[1])===-1)return-1;for(var ke=Se.length,ae=0,fe=0;fe<ke;fe++)if(Se[fe]==="\\")fe++;else if(Se[fe]===_e[0])ae++;else if(Se[fe]===_e[1]&&(ae--,ae<0))return fe;return-1}function o(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Se,_e){if(_e<1)return"";for(var ke="";_e>1;)_e&1&&(ke+=Se),_e>>=1,Se+=Se;return ke+Se}var O={escape:g,unescape:m,edit:w,cleanUrl:d,resolveUrl:i,noopTest:a,merge:p,splitCells:h,rtrim:b,findClosingBracket:y,checkSanitizeDeprecation:o,repeatString:L},W=A.defaults,ee=O.rtrim,ce=O.splitCells,G=O.escape,x=O.findClosingBracket;function V(Se,_e,ke){var ae=_e.href,fe=_e.title?G(_e.title):null,H=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:ke,href:ae,title:fe,text:H}:{type:"image",raw:ke,href:ae,title:fe,text:G(H)}}function T(Se,_e){var ke=Se.match(/^(\s+)(?:```)/);if(ke===null)return _e;var ae=ke[1];return _e.split(`
`).map(function(fe){var H=fe.match(/^\s+/);if(H===null)return fe;var Z=H[0];return Z.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var N=function(){function Se(ke){this.options=ke||W}var _e=Se.prototype;return _e.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},_e.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var H=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?H:ee(H,`
`)}}},_e.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var H=fe[0],Z=T(H,fe[3]||"");return{type:"code",raw:H,lang:fe[2]?fe[2].trim():fe[2],text:Z}}},_e.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var H=fe[2].trim();if(/#$/.test(H)){var Z=ee(H,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(H=Z.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:H}}},_e.nptable=function(ae){var fe=this.rules.block.nptable.exec(ae);if(fe){var H={type:"table",header:ce(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[],raw:fe[0]};if(H.header.length===H.align.length){var Z=H.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(Z=H.cells.length,ue=0;ue<Z;ue++)H.cells[ue]=ce(H.cells[ue],H.header.length);return H}}},_e.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},_e.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var H=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],text:H}}},_e.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var H=fe[0],Z=fe[2],ue=Z.length>1,Pe={type:"list",raw:H,ordered:ue,start:ue?+Z.slice(0,-1):"",loose:!1,items:[]},Ae=fe[0].match(this.rules.block.item),xe=!1,Be,Qe,rt,nt,Ze,ot,Ee,De,de=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var q=0;q<de;q++){if(Be=Ae[q],H=Be,q!==de-1){if(nt=this.rules.block.listItemStart.exec(Ae[q+1]),this.options.pedantic?nt[1].length>rt[1].length:nt[1].length>rt[0].length||nt[1].length>3){Ae.splice(q,2,Ae[q]+`
`+Ae[q+1]),q--,de--;continue}else(!this.options.pedantic||this.options.smartLists?nt[2][nt[2].length-1]!==Z[Z.length-1]:ue===(nt[2].length===1))&&(Ze=Ae.slice(q+1).join(`
`),Pe.raw=Pe.raw.substring(0,Pe.raw.length-Ze.length),q=de-1);rt=nt}Qe=Be.length,Be=Be.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Be.indexOf(`
 `)&&(Qe-=Be.length,Be=this.options.pedantic?Be.replace(/^ {1,4}/gm,""):Be.replace(new RegExp("^ {1,"+Qe+"}","gm"),"")),ot=xe||/\n\n(?!\s*$)/.test(Be),q!==de-1&&(xe=Be.charAt(Be.length-1)===`
`,ot||(ot=xe)),ot&&(Pe.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(Be),De=void 0,Ee&&(De=Be[1]!==" ",Be=Be.replace(/^\[[ xX]\] +/,""))),Pe.items.push({type:"list_item",raw:H,task:Ee,checked:De,loose:ot,text:Be})}return Pe}},_e.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe)return{type:this.options.sanitize?"paragraph":"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):G(fe[0]):fe[0]}},_e.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var H=fe[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:fe[0],href:fe[2],title:fe[3]}}},_e.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var H={type:"table",header:ce(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=fe[0];var Z=H.align.length,ue;for(ue=0;ue<Z;ue++)/^ *-+: *$/.test(H.align[ue])?H.align[ue]="right":/^ *:-+: *$/.test(H.align[ue])?H.align[ue]="center":/^ *:-+ *$/.test(H.align[ue])?H.align[ue]="left":H.align[ue]=null;for(Z=H.cells.length,ue=0;ue<Z;ue++)H.cells[ue]=ce(H.cells[ue].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},_e.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1]}},_e.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe)return{type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1]}},_e.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0]}},_e.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:G(fe[1])}},_e.tag=function(ae,fe,H){var Z=this.rules.inline.tag.exec(ae);if(Z)return!fe&&/^<a /i.test(Z[0])?fe=!0:fe&&/^<\/a>/i.test(Z[0])&&(fe=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:fe,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):G(Z[0]):Z[0]}},_e.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var H=fe[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var Z=ee(H.slice(0,-1),"\\");if((H.length-Z.length)%2==0)return}else{var ue=x(fe[2],"()");if(ue>-1){var Pe=fe[0].indexOf("!")===0?5:4,Ae=Pe+fe[1].length+ue;fe[2]=fe[2].substring(0,ue),fe[0]=fe[0].substring(0,Ae).trim(),fe[3]=""}}var xe=fe[2],Be="";if(this.options.pedantic){var Qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(xe);Qe&&(xe=Qe[1],Be=Qe[3])}else Be=fe[3]?fe[3].slice(1,-1):"";return xe=xe.trim(),/^</.test(xe)&&(this.options.pedantic&&!/>$/.test(H)?xe=xe.slice(1):xe=xe.slice(1,-1)),V(fe,{href:xe&&xe.replace(this.rules.inline._escapes,"$1"),title:Be&&Be.replace(this.rules.inline._escapes,"$1")},fe[0])}},_e.reflink=function(ae,fe){var H;if((H=this.rules.inline.reflink.exec(ae))||(H=this.rules.inline.nolink.exec(ae))){var Z=(H[2]||H[1]).replace(/\s+/g," ");if(Z=fe[Z.toLowerCase()],!Z||!Z.href){var ue=H[0].charAt(0);return{type:"text",raw:ue,text:ue}}return V(H,Z,H[0])}},_e.emStrong=function(ae,fe,H){H===void 0&&(H="");var Z=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Z&&!(Z[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ue=Z[1]||Z[2]||"";if(!ue||ue&&(H===""||this.rules.inline.punctuation.exec(H))){var Pe=Z[0].length-1,Ae,xe,Be=Pe,Qe=0,rt=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,fe=fe.slice(-1*ae.length+Pe);(Z=rt.exec(fe))!=null;)if(Ae=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Ae){if(xe=Ae.length,Z[3]||Z[4]){Be+=xe;continue}else if((Z[5]||Z[6])&&Pe%3&&!((Pe+xe)%3)){Qe+=xe;continue}if(Be-=xe,!(Be>0)){if(Be+Qe-xe<=0&&!fe.slice(rt.lastIndex).match(rt)&&(xe=Math.min(xe,xe+Be+Qe)),Math.min(Pe,xe)%2)return{type:"em",raw:ae.slice(0,Pe+Z.index+xe+1),text:ae.slice(1,Pe+Z.index+xe)};if(Math.min(Pe,xe)%2==0)return{type:"strong",raw:ae.slice(0,Pe+Z.index+xe+1),text:ae.slice(2,Pe+Z.index+xe-1)}}}}}},_e.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var H=fe[2].replace(/\n/g," "),Z=/[^ ]/.test(H),ue=/^ /.test(H)&&/ $/.test(H);return Z&&ue&&(H=H.substring(1,H.length-1)),H=G(H,!0),{type:"codespan",raw:fe[0],text:H}}},_e.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},_e.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2]}},_e.autolink=function(ae,fe){var H=this.rules.inline.autolink.exec(ae);if(H){var Z,ue;return H[2]==="@"?(Z=G(this.options.mangle?fe(H[1]):H[1]),ue="mailto:"+Z):(Z=G(H[1]),ue=Z),{type:"link",raw:H[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},_e.url=function(ae,fe){var H;if(H=this.rules.inline.url.exec(ae)){var Z,ue;if(H[2]==="@")Z=G(this.options.mangle?fe(H[0]):H[0]),ue="mailto:"+Z;else{var Pe;do Pe=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Pe!==H[0]);Z=G(H[0]),H[1]==="www."?ue="http://"+Z:ue=Z}return{type:"link",raw:H[0],text:Z,href:ue,tokens:[{type:"text",raw:Z,text:Z}]}}},_e.inlineText=function(ae,fe,H){var Z=this.rules.inline.text.exec(ae);if(Z){var ue;return fe?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):G(Z[0]):Z[0]:ue=G(this.options.smartypants?H(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ue}}},Se}(),F=O.noopTest,M=O.edit,U=O.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=M(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=M(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=M(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=M(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=M(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=M(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=M(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=U({},B),B.gfm=U({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=M(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=M(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=U({},B.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=M(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=M(B._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=M(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=M(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=M(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=M(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=M(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=M(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=M(K.reflink).replace("label",K._label).getRegex(),K.reflinkSearch=M(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=U({},K),K.pedantic=U({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=U({},K.normal,{escape:M(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),K.gfm.url=M(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=U({},K.gfm,{br:M(K.br).replace("{2,}","*").getRegex(),text:M(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ie={block:B,inline:K},we=A.defaults,Te=ie.block,ye=ie.inline,Oe=O.repeatString;function je(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(Se){var _e="",ke,ae,fe=Se.length;for(ke=0;ke<fe;ke++)ae=Se.charCodeAt(ke),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var qe=function(){function Se(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||we,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Te.normal,inline:ye.normal};this.options.pedantic?(ae.block=Te.pedantic,ae.inline=ye.pedantic):this.options.gfm&&(ae.block=Te.gfm,this.options.breaks?ae.inline=ye.breaks:ae.inline=ye.gfm),this.tokenizer.rules=ae}Se.lex=function(ae,fe){var H=new Se(fe);return H.lex(ae)},Se.lexInline=function(ae,fe){var H=new Se(fe);return H.inlineTokens(ae)};var _e=Se.prototype;return _e.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},_e.blockTokens=function(ae,fe,H){fe===void 0&&(fe=[]),H===void 0&&(H=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var Z,ue,Pe,Ae;ae;){if(Z=this.tokenizer.space(ae)){ae=ae.substring(Z.raw.length),Z.type&&fe.push(Z);continue}if(Z=this.tokenizer.code(ae)){ae=ae.substring(Z.raw.length),Ae=fe[fe.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):fe.push(Z);continue}if(Z=this.tokenizer.fences(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.heading(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.nptable(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.hr(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.blockquote(ae)){ae=ae.substring(Z.raw.length),Z.tokens=this.blockTokens(Z.text,[],H),fe.push(Z);continue}if(Z=this.tokenizer.list(ae)){for(ae=ae.substring(Z.raw.length),Pe=Z.items.length,ue=0;ue<Pe;ue++)Z.items[ue].tokens=this.blockTokens(Z.items[ue].text,[],!1);fe.push(Z);continue}if(Z=this.tokenizer.html(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(H&&(Z=this.tokenizer.def(ae))){ae=ae.substring(Z.raw.length),this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.lheading(ae)){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(H&&(Z=this.tokenizer.paragraph(ae))){ae=ae.substring(Z.raw.length),fe.push(Z);continue}if(Z=this.tokenizer.text(ae)){ae=ae.substring(Z.raw.length),Ae=fe[fe.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):fe.push(Z);continue}if(ae){var xe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return fe},_e.inline=function(ae){var fe,H,Z,ue,Pe,Ae,xe=ae.length;for(fe=0;fe<xe;fe++)switch(Ae=ae[fe],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ue=Ae.header.length,H=0;H<ue;H++)Ae.tokens.header[H]=[],this.inlineTokens(Ae.header[H],Ae.tokens.header[H]);for(ue=Ae.cells.length,H=0;H<ue;H++)for(Pe=Ae.cells[H],Ae.tokens.cells[H]=[],Z=0;Z<Pe.length;Z++)Ae.tokens.cells[H][Z]=[],this.inlineTokens(Pe[Z],Ae.tokens.cells[H][Z]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ue=Ae.items.length,H=0;H<ue;H++)this.inline(Ae.items[H].tokens);break}}return ae},_e.inlineTokens=function(ae,fe,H,Z){fe===void 0&&(fe=[]),H===void 0&&(H=!1),Z===void 0&&(Z=!1);var ue,Pe,Ae=ae,xe,Be,Qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(xe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(xe[0].slice(xe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,xe.index)+"["+Oe("a",xe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(xe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,xe.index)+"["+Oe("a",xe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(xe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,xe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(Be||(Qe=""),Be=!1,ue=this.tokenizer.escape(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.tag(ae,H,Z)){ae=ae.substring(ue.raw.length),H=ue.inLink,Z=ue.inRawBlock;var nt=fe[fe.length-1];nt&&ue.type==="text"&&nt.type==="text"?(nt.raw+=ue.raw,nt.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.link(ae)){ae=ae.substring(ue.raw.length),ue.type==="link"&&(ue.tokens=this.inlineTokens(ue.text,[],!0,Z)),fe.push(ue);continue}if(ue=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ue.raw.length);var Ze=fe[fe.length-1];ue.type==="link"?(ue.tokens=this.inlineTokens(ue.text,[],!0,Z),fe.push(ue)):Ze&&ue.type==="text"&&Ze.type==="text"?(Ze.raw+=ue.raw,Ze.text+=ue.text):fe.push(ue);continue}if(ue=this.tokenizer.emStrong(ae,Ae,Qe)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,Z),fe.push(ue);continue}if(ue=this.tokenizer.codespan(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.br(ae)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.del(ae)){ae=ae.substring(ue.raw.length),ue.tokens=this.inlineTokens(ue.text,[],H,Z),fe.push(ue);continue}if(ue=this.tokenizer.autolink(ae,ze)){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(!H&&(ue=this.tokenizer.url(ae,ze))){ae=ae.substring(ue.raw.length),fe.push(ue);continue}if(ue=this.tokenizer.inlineText(ae,Z,je)){ae=ae.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(Qe=ue.raw.slice(-1)),Be=!0,Pe=fe[fe.length-1],Pe&&Pe.type==="text"?(Pe.raw+=ue.raw,Pe.text+=ue.text):fe.push(ue);continue}if(ae){var ot="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return fe},e(Se,null,[{key:"rules",get:function(){return{block:Te,inline:ye}}}]),Se}(),j=A.defaults,J=O.cleanUrl,ne=O.escape,oe=function(){function Se(ke){this.options=ke||j}var _e=Se.prototype;return _e.code=function(ae,fe,H){var Z=(fe||"").match(/\S*/)[0];if(this.options.highlight){var ue=this.options.highlight(ae,Z);ue!=null&&ue!==ae&&(H=!0,ae=ue)}return ae=ae.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+ne(Z,!0)+'">'+(H?ae:ne(ae,!0))+`</code></pre>
`:"<pre><code>"+(H?ae:ne(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,fe,H,Z){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+Z.slug(H)+'">'+ae+"</h"+fe+`>
`:"<h"+fe+">"+ae+"</h"+fe+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,fe,H){var Z=fe?"ol":"ul",ue=fe&&H!==1?' start="'+H+'"':"";return"<"+Z+ue+`>
`+ae+"</"+Z+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,fe){var H=fe.header?"th":"td",Z=fe.align?"<"+H+' align="'+fe.align+'">':"<"+H+">";return Z+ae+"</"+H+`>
`},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,fe,H){if(ae=J(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var Z='<a href="'+ne(ae)+'"';return fe&&(Z+=' title="'+fe+'"'),Z+=">"+H+"</a>",Z},_e.image=function(ae,fe,H){if(ae=J(this.options.sanitize,this.options.baseUrl,ae),ae===null)return H;var Z='<img src="'+ae+'" alt="'+H+'"';return fe&&(Z+=' title="'+fe+'"'),Z+=this.options.xhtml?"/>":">",Z},_e.text=function(ae){return ae},Se}(),Y=function(){function Se(){}var _e=Se.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,fe,H){return""+H},_e.image=function(ae,fe,H){return""+H},_e.br=function(){return""},Se}(),le=function(){function Se(){this.seen={}}var _e=Se.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,fe){var H=ae,Z=0;if(this.seen.hasOwnProperty(H)){Z=this.seen[ae];do Z++,H=ae+"-"+Z;while(this.seen.hasOwnProperty(H))}return fe||(this.seen[ae]=Z,this.seen[H]=0),H},_e.slug=function(ae,fe){fe===void 0&&(fe={});var H=this.serialize(ae);return this.getNextSafeSlug(H,fe.dryrun)},Se}(),me=A.defaults,Re=O.unescape,We=function(){function Se(ke){this.options=ke||me,this.options.renderer=this.options.renderer||new oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new le}Se.parse=function(ae,fe){var H=new Se(fe);return H.parse(ae)},Se.parseInline=function(ae,fe){var H=new Se(fe);return H.parseInline(ae)};var _e=Se.prototype;return _e.parse=function(ae,fe){fe===void 0&&(fe=!0);var H="",Z,ue,Pe,Ae,xe,Be,Qe,rt,nt,Ze,ot,Ee,De,de,q,Ue,Le,Ge,Je=ae.length;for(Z=0;Z<Je;Z++)switch(Ze=ae[Z],Ze.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Ze.tokens),Ze.depth,Re(this.parseInline(Ze.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Ze.text,Ze.lang,Ze.escaped);continue}case"table":{for(rt="",Qe="",Ae=Ze.header.length,ue=0;ue<Ae;ue++)Qe+=this.renderer.tablecell(this.parseInline(Ze.tokens.header[ue]),{header:!0,align:Ze.align[ue]});for(rt+=this.renderer.tablerow(Qe),nt="",Ae=Ze.cells.length,ue=0;ue<Ae;ue++){for(Be=Ze.tokens.cells[ue],Qe="",xe=Be.length,Pe=0;Pe<xe;Pe++)Qe+=this.renderer.tablecell(this.parseInline(Be[Pe]),{header:!1,align:Ze.align[Pe]});nt+=this.renderer.tablerow(Qe)}H+=this.renderer.table(rt,nt);continue}case"blockquote":{nt=this.parse(Ze.tokens),H+=this.renderer.blockquote(nt);continue}case"list":{for(ot=Ze.ordered,Ee=Ze.start,De=Ze.loose,Ae=Ze.items.length,nt="",ue=0;ue<Ae;ue++)q=Ze.items[ue],Ue=q.checked,Le=q.task,de="",q.task&&(Ge=this.renderer.checkbox(Ue),De?q.tokens.length>0&&q.tokens[0].type==="text"?(q.tokens[0].text=Ge+" "+q.tokens[0].text,q.tokens[0].tokens&&q.tokens[0].tokens.length>0&&q.tokens[0].tokens[0].type==="text"&&(q.tokens[0].tokens[0].text=Ge+" "+q.tokens[0].tokens[0].text)):q.tokens.unshift({type:"text",text:Ge}):de+=Ge),de+=this.parse(q.tokens,De),nt+=this.renderer.listitem(de,Le,Ue);H+=this.renderer.list(nt,ot,Ee);continue}case"html":{H+=this.renderer.html(Ze.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Ze.tokens));continue}case"text":{for(nt=Ze.tokens?this.parseInline(Ze.tokens):Ze.text;Z+1<Je&&ae[Z+1].type==="text";)Ze=ae[++Z],nt+=`
`+(Ze.tokens?this.parseInline(Ze.tokens):Ze.text);H+=fe?this.renderer.paragraph(nt):nt;continue}default:{var lt='Token with "'+Ze.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}return H},_e.parseInline=function(ae,fe){fe=fe||this.renderer;var H="",Z,ue,Pe=ae.length;for(Z=0;Z<Pe;Z++)switch(ue=ae[Z],ue.type){case"escape":{H+=fe.text(ue.text);break}case"html":{H+=fe.html(ue.text);break}case"link":{H+=fe.link(ue.href,ue.title,this.parseInline(ue.tokens,fe));break}case"image":{H+=fe.image(ue.href,ue.title,ue.text);break}case"strong":{H+=fe.strong(this.parseInline(ue.tokens,fe));break}case"em":{H+=fe.em(this.parseInline(ue.tokens,fe));break}case"codespan":{H+=fe.codespan(ue.text);break}case"br":{H+=fe.br();break}case"del":{H+=fe.del(this.parseInline(ue.tokens,fe));break}case"text":{H+=fe.text(ue.text);break}default:{var Ae='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return H},Se}(),be=O.merge,Xe=O.checkSanitizeDeprecation,Q=O.escape,re=A.getDefaults,ve=A.changeDefaults,Me=A.defaults;function Ne(Se,_e,ke){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof _e=="function"&&(ke=_e,_e=null),_e=be({},Ne.defaults,_e||{}),Xe(_e),ke){var ae=_e.highlight,fe;try{fe=qe.lex(Se,_e)}catch(Pe){return ke(Pe)}var H=function(Ae){var xe;if(!Ae)try{xe=We.parse(fe,_e)}catch(Be){Ae=Be}return _e.highlight=ae,Ae?ke(Ae):ke(null,xe)};if(!ae||ae.length<3||(delete _e.highlight,!fe.length))return H();var Z=0;Ne.walkTokens(fe,function(Pe){Pe.type==="code"&&(Z++,setTimeout(function(){ae(Pe.text,Pe.lang,function(Ae,xe){if(Ae)return H(Ae);xe!=null&&xe!==Pe.text&&(Pe.text=xe,Pe.escaped=!0),Z--,Z===0&&H()})},0))}),Z===0&&H();return}try{var ue=qe.lex(Se,_e);return _e.walkTokens&&Ne.walkTokens(ue,_e.walkTokens),We.parse(ue,_e)}catch(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(Pe.message+"",!0)+"</pre>";throw Pe}}Ne.options=Ne.setOptions=function(Se){return be(Ne.defaults,Se),ve(Ne.defaults),Ne},Ne.getDefaults=re,Ne.defaults=Me,Ne.use=function(Se){var _e=be({},Se);if(Se.renderer&&function(){var ae=Ne.defaults.renderer||new oe,fe=function(ue){var Pe=ae[ue];ae[ue]=function(){for(var Ae=arguments.length,xe=new Array(Ae),Be=0;Be<Ae;Be++)xe[Be]=arguments[Be];var Qe=Se.renderer[ue].apply(ae,xe);return Qe===!1&&(Qe=Pe.apply(ae,xe)),Qe}};for(var H in Se.renderer)fe(H);_e.renderer=ae}(),Se.tokenizer&&function(){var ae=Ne.defaults.tokenizer||new N,fe=function(ue){var Pe=ae[ue];ae[ue]=function(){for(var Ae=arguments.length,xe=new Array(Ae),Be=0;Be<Ae;Be++)xe[Be]=arguments[Be];var Qe=Se.tokenizer[ue].apply(ae,xe);return Qe===!1&&(Qe=Pe.apply(ae,xe)),Qe}};for(var H in Se.tokenizer)fe(H);_e.tokenizer=ae}(),Se.walkTokens){var ke=Ne.defaults.walkTokens;_e.walkTokens=function(ae){Se.walkTokens(ae),ke&&ke(ae)}}Ne.setOptions(_e)},Ne.walkTokens=function(Se,_e){for(var ke=k(Se),ae;!(ae=ke()).done;){var fe=ae.value;switch(_e(fe),fe.type){case"table":{for(var H=k(fe.tokens.header),Z;!(Z=H()).done;){var ue=Z.value;Ne.walkTokens(ue,_e)}for(var Pe=k(fe.tokens.cells),Ae;!(Ae=Pe()).done;)for(var xe=Ae.value,Be=k(xe),Qe;!(Qe=Be()).done;){var rt=Qe.value;Ne.walkTokens(rt,_e)}break}case"list":{Ne.walkTokens(fe.items,_e);break}default:fe.tokens&&Ne.walkTokens(fe.tokens,_e)}}},Ne.parseInline=function(Se,_e){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");_e=be({},Ne.defaults,_e||{}),Xe(_e);try{var ke=qe.lexInline(Se,_e);return _e.walkTokens&&Ne.walkTokens(ke,_e.walkTokens),We.parseInline(ke,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(ae.message+"",!0)+"</pre>";throw ae}},Ne.Parser=We,Ne.parser=We.parse,Ne.Renderer=oe,Ne.TextRenderer=Y,Ne.Lexer=qe,Ne.lexer=qe.lex,Ne.Tokenizer=N,Ne.Slugger=le,Ne.parse=Ne;var Ye=Ne;return Ye}),define(ge[73],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function v(A,C,D){return Math.min(Math.max(A,C),D)}e.clamp=v;function R(A,C){return(C+A%C)%C}e.rot=R;class k{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=k;class S{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function X(k){const S=[];typeof k=="number"&&S.push("code/timeOrigin",k);function A(D){S.push(D,Date.now())}function C(){const D=[];for(let P=0;P<S.length;P+=2)D.push({name:S[P],startTime:S[P+1]});return D}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))S.push({name:A.name,startTime:Math.round(k+A.startTime)});return S}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function v(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(ge[11],pe([0,1]),function(X,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let k=!1,S=!1,A=!1,C=!1,D=!1,P=!1,s=!1,I,l=R,g,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const _=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=_&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!_)c=navigator.userAgent,k=c.indexOf("Windows")>=0,S=c.indexOf("Macintosh")>=0,s=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,P=!0,I=navigator.language,l=I;else if(typeof m=="object"){k=m.platform==="win32",S=m.platform==="darwin",A=m.platform==="linux",C=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,I=R,l=R;const i=m.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),p=a.availableLanguages["*"];I=a.locale,l=p||R,g=a._translationsConfigFile}catch(a){}D=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function E(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let u=0;S?u=1:k?u=3:A&&(u=2),e.isWindows=k,e.isMacintosh=S,e.isLinux=A,e.isLinuxSnap=C,e.isNative=D,e.isWeb=P,e.isIOS=s,e.platform=u,e.userAgent=c,e.language=l;var d;(function(i){function a(){return e.language}i.value=a;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=p;function h(){return e.language==="en"}i.isDefault=h})(d=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let p=[];e.globals.addEventListener("message",b=>{if(b.data&&b.data.vscodeSetImmediateId)for(let y=0,o=p.length;y<o;y++){const L=p[y];if(L.id===b.data.vscodeSetImmediateId){p.splice(y,1),L.callback();return}}});let h=0;return b=>{const y=++h;p.push({id:y,callback:b}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const a=Promise.resolve();return p=>a.then(p)}();var f;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||s?2:k?1:3;let t=!0,r=!1;function n(){if(!r){r=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(ge[37],pe([0,1,11]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const k=v.globals.vscode.process;R={get platform(){return k.platform},get env(){return k.env},cwd(){return k.cwd()},nextTick(S){return v.setImmediate(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(k){return process.nextTick(k)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(k){return v.setImmediate(k)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(ge[9],pe([0,1,37]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,k=97,S=90,A=122,C=46,D=47,P=92,s=58,I=63;class l extends Error{constructor(d,f,t){let r;typeof f=="string"&&f.indexOf("not ")===0?(r="must not be",f=f.replace(/^not /,"")):r="must be";const n=d.indexOf(".")!==-1?"property":"argument";let i=`The "${d}" ${n} ${r} of type ${f}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function g(u,d){if(typeof u!="string")throw new l(d,"string",u)}function c(u){return u===D||u===P}function m(u){return u===D}function _(u){return u>=R&&u<=S||u>=k&&u<=A}function w(u,d,f,t){let r="",n=0,i=-1,a=0,p=0;for(let h=0;h<=u.length;++h){if(h<u.length)p=u.charCodeAt(h);else{if(t(p))break;p=D}if(t(p)){if(!(i===h-1||a===1))if(a===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const b=r.lastIndexOf(f);b===-1?(r="",n=0):(r=r.slice(0,b),n=r.length-1-r.lastIndexOf(f)),i=h,a=0;continue}else if(r.length!==0){r="",n=0,i=h,a=0;continue}}d&&(r+=r.length>0?`${f}..`:"..",n=2)}else r.length>0?r+=`${f}${u.slice(i+1,h)}`:r=u.slice(i+1,h),n=h-i-1;i=h,a=0}else p===C&&a!==-1?++a:a=-1}return r}function E(u,d){if(d===null||typeof d!="object")throw new l("pathObject","Object",d);const f=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return f?f===d.root?`${f}${t}`:`${f}${u}${t}`:t}e.win32={resolve(...u){let d="",f="",t=!1;for(let r=u.length-1;r>=-1;r--){let n;if(r>=0){if(n=u[r],g(n,"path"),n.length===0)continue}else d.length===0?n=v.cwd():(n=v.env[`=${d}`]||v.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==d.toLowerCase()&&n.charCodeAt(2)===P)&&(n=`${d}\\`));const i=n.length;let a=0,p="",h=!1;const b=n.charCodeAt(0);if(i===1)c(b)&&(a=1,h=!0);else if(c(b))if(h=!0,c(n.charCodeAt(1))){let y=2,o=y;for(;y<i&&!c(n.charCodeAt(y));)y++;if(y<i&&y!==o){const L=n.slice(o,y);for(o=y;y<i&&c(n.charCodeAt(y));)y++;if(y<i&&y!==o){for(o=y;y<i&&!c(n.charCodeAt(y));)y++;(y===i||y!==o)&&(p=`\\\\${L}\\${n.slice(o,y)}`,a=y)}}}else a=1;else _(b)&&n.charCodeAt(1)===s&&(p=n.slice(0,2),a=2,i>2&&c(n.charCodeAt(2))&&(h=!0,a=3));if(p.length>0)if(d.length>0){if(p.toLowerCase()!==d.toLowerCase())continue}else d=p;if(t){if(d.length>0)break}else if(f=`${n.slice(a)}\\${f}`,t=h,h&&d.length>0)break}return f=w(f,!t,"\\",c),t?`${d}\\${f}`:`${d}${f}`||"."},normalize(u){g(u,"path");const d=u.length;if(d===0)return".";let f=0,t,r=!1;const n=u.charCodeAt(0);if(d===1)return m(n)?"\\":u;if(c(n))if(r=!0,c(u.charCodeAt(1))){let a=2,p=a;for(;a<d&&!c(u.charCodeAt(a));)a++;if(a<d&&a!==p){const h=u.slice(p,a);for(p=a;a<d&&c(u.charCodeAt(a));)a++;if(a<d&&a!==p){for(p=a;a<d&&!c(u.charCodeAt(a));)a++;if(a===d)return`\\\\${h}\\${u.slice(p)}\\`;a!==p&&(t=`\\\\${h}\\${u.slice(p,a)}`,f=a)}}}else f=1;else _(n)&&u.charCodeAt(1)===s&&(t=u.slice(0,2),f=2,d>2&&c(u.charCodeAt(2))&&(r=!0,f=3));let i=f<d?w(u.slice(f),!r,"\\",c):"";return i.length===0&&!r&&(i="."),i.length>0&&c(u.charCodeAt(d-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(u){g(u,"path");const d=u.length;if(d===0)return!1;const f=u.charCodeAt(0);return c(f)||d>2&&_(f)&&u.charCodeAt(1)===s&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,f;for(let n=0;n<u.length;++n){const i=u[n];g(i,"path"),i.length>0&&(d===void 0?d=f=i:d+=`\\${i}`)}if(d===void 0)return".";let t=!0,r=0;if(typeof f=="string"&&c(f.charCodeAt(0))){++r;const n=f.length;n>1&&c(f.charCodeAt(1))&&(++r,n>2&&(c(f.charCodeAt(2))?++r:t=!1))}if(t){for(;r<d.length&&c(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(u,d){if(g(u,"from"),g(d,"to"),u===d)return"";const f=e.win32.resolve(u),t=e.win32.resolve(d);if(f===t||(u=f.toLowerCase(),d=t.toLowerCase(),u===d))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===P;)r++;let n=u.length;for(;n-1>r&&u.charCodeAt(n-1)===P;)n--;const i=n-r;let a=0;for(;a<d.length&&d.charCodeAt(a)===P;)a++;let p=d.length;for(;p-1>a&&d.charCodeAt(p-1)===P;)p--;const h=p-a,b=i<h?i:h;let y=-1,o=0;for(;o<b;o++){const O=u.charCodeAt(r+o);if(O!==d.charCodeAt(a+o))break;O===P&&(y=o)}if(o!==b){if(y===-1)return t}else{if(h>b){if(d.charCodeAt(a+o)===P)return t.slice(a+o+1);if(o===2)return t.slice(a+o)}i>b&&(u.charCodeAt(r+o)===P?y=o:o===2&&(y=3)),y===-1&&(y=0)}let L="";for(o=r+y+1;o<=n;++o)(o===n||u.charCodeAt(o)===P)&&(L+=L.length===0?"..":"\\..");return a+=y,L.length>0?`${L}${t.slice(a,p)}`:(t.charCodeAt(a)===P&&++a,t.slice(a,p))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===P){if(d.charCodeAt(1)===P){const f=d.charCodeAt(2);if(f!==I&&f!==C)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(_(d.charCodeAt(0))&&d.charCodeAt(1)===s&&d.charCodeAt(2)===P)return`\\\\?\\${d}`;return u},dirname(u){g(u,"path");const d=u.length;if(d===0)return".";let f=-1,t=0;const r=u.charCodeAt(0);if(d===1)return c(r)?u:".";if(c(r)){if(f=t=1,c(u.charCodeAt(1))){let a=2,p=a;for(;a<d&&!c(u.charCodeAt(a));)a++;if(a<d&&a!==p){for(p=a;a<d&&c(u.charCodeAt(a));)a++;if(a<d&&a!==p){for(p=a;a<d&&!c(u.charCodeAt(a));)a++;if(a===d)return u;a!==p&&(f=t=a+1)}}}}else _(r)&&u.charCodeAt(1)===s&&(f=d>2&&c(u.charCodeAt(2))?3:2,t=f);let n=-1,i=!0;for(let a=d-1;a>=t;--a)if(c(u.charCodeAt(a))){if(!i){n=a;break}}else i=!1;if(n===-1){if(f===-1)return".";n=f}return u.slice(0,n)},basename(u,d){d!==void 0&&g(d,"ext"),g(u,"path");let f=0,t=-1,r=!0,n;if(u.length>=2&&_(u.charCodeAt(0))&&u.charCodeAt(1)===s&&(f=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let i=d.length-1,a=-1;for(n=u.length-1;n>=f;--n){const p=u.charCodeAt(n);if(c(p)){if(!r){f=n+1;break}}else a===-1&&(r=!1,a=n+1),i>=0&&(p===d.charCodeAt(i)?--i==-1&&(t=n):(i=-1,t=a))}return f===t?t=a:t===-1&&(t=u.length),u.slice(f,t)}for(n=u.length-1;n>=f;--n)if(c(u.charCodeAt(n))){if(!r){f=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":u.slice(f,t)},extname(u){g(u,"path");let d=0,f=-1,t=0,r=-1,n=!0,i=0;u.length>=2&&u.charCodeAt(1)===s&&_(u.charCodeAt(0))&&(d=t=2);for(let a=u.length-1;a>=d;--a){const p=u.charCodeAt(a);if(c(p)){if(!n){t=a+1;break}continue}r===-1&&(n=!1,r=a+1),p===C?f===-1?f=a:i!==1&&(i=1):f!==-1&&(i=-1)}return f===-1||r===-1||i===0||i===1&&f===r-1&&f===t+1?"":u.slice(f,r)},format:E.bind(null,"\\"),parse(u){g(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const f=u.length;let t=0,r=u.charCodeAt(0);if(f===1)return c(r)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(c(r)){if(t=1,c(u.charCodeAt(1))){let y=2,o=y;for(;y<f&&!c(u.charCodeAt(y));)y++;if(y<f&&y!==o){for(o=y;y<f&&c(u.charCodeAt(y));)y++;if(y<f&&y!==o){for(o=y;y<f&&!c(u.charCodeAt(y));)y++;y===f?t=y:y!==o&&(t=y+1)}}}}else if(_(r)&&u.charCodeAt(1)===s){if(f<=2)return d.root=d.dir=u,d;if(t=2,c(u.charCodeAt(2))){if(f===3)return d.root=d.dir=u,d;t=3}}t>0&&(d.root=u.slice(0,t));let n=-1,i=t,a=-1,p=!0,h=u.length-1,b=0;for(;h>=t;--h){if(r=u.charCodeAt(h),c(r)){if(!p){i=h+1;break}continue}a===-1&&(p=!1,a=h+1),r===C?n===-1?n=h:b!==1&&(b=1):n!==-1&&(b=-1)}return a!==-1&&(n===-1||b===0||b===1&&n===a-1&&n===i+1?d.base=d.name=u.slice(i,a):(d.name=u.slice(i,n),d.base=u.slice(i,a),d.ext=u.slice(n,a))),i>0&&i!==t?d.dir=u.slice(0,i-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",f=!1;for(let t=u.length-1;t>=-1&&!f;t--){const r=t>=0?u[t]:v.cwd();g(r,"path"),r.length!==0&&(d=`${r}/${d}`,f=r.charCodeAt(0)===D)}return d=w(d,!f,"/",m),f?`/${d}`:d.length>0?d:"."},normalize(u){if(g(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===D,f=u.charCodeAt(u.length-1)===D;return u=w(u,!d,"/",m),u.length===0?d?"/":f?"./":".":(f&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return g(u,"path"),u.length>0&&u.charCodeAt(0)===D},join(...u){if(u.length===0)return".";let d;for(let f=0;f<u.length;++f){const t=u[f];g(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(g(u,"from"),g(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const f=1,t=u.length,r=t-f,n=1,i=d.length-n,a=r<i?r:i;let p=-1,h=0;for(;h<a;h++){const y=u.charCodeAt(f+h);if(y!==d.charCodeAt(n+h))break;y===D&&(p=h)}if(h===a)if(i>a){if(d.charCodeAt(n+h)===D)return d.slice(n+h+1);if(h===0)return d.slice(n+h)}else r>a&&(u.charCodeAt(f+h)===D?p=h:h===0&&(p=0));let b="";for(h=f+p+1;h<=t;++h)(h===t||u.charCodeAt(h)===D)&&(b+=b.length===0?"..":"/..");return`${b}${d.slice(n+p)}`},toNamespacedPath(u){return u},dirname(u){if(g(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===D;let f=-1,t=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===D){if(!t){f=r;break}}else t=!1;return f===-1?d?"/":".":d&&f===1?"//":u.slice(0,f)},basename(u,d){d!==void 0&&g(d,"ext"),g(u,"path");let f=0,t=-1,r=!0,n;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let i=d.length-1,a=-1;for(n=u.length-1;n>=0;--n){const p=u.charCodeAt(n);if(p===D){if(!r){f=n+1;break}}else a===-1&&(r=!1,a=n+1),i>=0&&(p===d.charCodeAt(i)?--i==-1&&(t=n):(i=-1,t=a))}return f===t?t=a:t===-1&&(t=u.length),u.slice(f,t)}for(n=u.length-1;n>=0;--n)if(u.charCodeAt(n)===D){if(!r){f=n+1;break}}else t===-1&&(r=!1,t=n+1);return t===-1?"":u.slice(f,t)},extname(u){g(u,"path");let d=-1,f=0,t=-1,r=!0,n=0;for(let i=u.length-1;i>=0;--i){const a=u.charCodeAt(i);if(a===D){if(!r){f=i+1;break}continue}t===-1&&(r=!1,t=i+1),a===C?d===-1?d=i:n!==1&&(n=1):d!==-1&&(n=-1)}return d===-1||t===-1||n===0||n===1&&d===t-1&&d===f+1?"":u.slice(d,t)},format:E.bind(null,"/"),parse(u){g(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const f=u.charCodeAt(0)===D;let t;f?(d.root="/",t=1):t=0;let r=-1,n=0,i=-1,a=!0,p=u.length-1,h=0;for(;p>=t;--p){const b=u.charCodeAt(p);if(b===D){if(!a){n=p+1;break}continue}i===-1&&(a=!1,i=p+1),b===C?r===-1?r=p:h!==1&&(h=1):r!==-1&&(h=-1)}if(i!==-1){const b=n===0&&f?1:n;r===-1||h===0||h===1&&r===i-1&&r===n+1?d.base=d.name=u.slice(b,i):(d.name=u.slice(b,r),d.base=u.slice(b,i),d.ext=u.slice(r,i))}return n>0?d.dir=u.slice(0,n-1):f&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ge[134],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(S,...A){const C=A.reduce((s,I)=>(s[I]=!0,s),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(s=>!C[s]).forEach(s=>{for(let I=0;I<D.length;I++)if(s.search(D[I])!==-1){delete S[s];break}})}e.sanitizeProcessEnvironment=k}),define(ge[43],pe([0,1,11]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class k{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ge[3],pe([0,1,16,69,6,72,43]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(w){w.None=()=>k.Disposable.None;function E(G){return(x,V=null,T)=>{let N=!1,F;return F=G(M=>{if(!N)return F?F.dispose():N=!0,x.call(V,M)},null,T),N&&F.dispose(),F}}w.once=E;function u(G,x){return i((V,T=null,N)=>G(F=>V.call(T,x(F)),null,N))}w.map=u;function d(G,x){return i((V,T=null,N)=>G(F=>{x(F),V.call(T,F)},null,N))}w.forEach=d;function f(G,x){return i((V,T=null,N)=>G(F=>x(F)&&V.call(T,F),null,N))}w.filter=f;function t(G){return G}w.signal=t;function r(...G){return(x,V=null,T)=>k.combinedDisposable(...G.map(N=>N(F=>x.call(V,F),null,T)))}w.any=r;function n(G,x,V){let T=V;return u(G,N=>(T=x(T,N),T))}w.reduce=n;function i(G){let x;const V=new l({onFirstListenerAdd(){x=G(V.fire,V)},onLastListenerRemove(){x.dispose()}});return V.event}w.snapshot=i;function a(G,x,V=100,T=!1,N){let F,M,U,B=0;const K=new l({leakWarningThreshold:N,onFirstListenerAdd(){F=G(ie=>{B++,M=x(M,ie),T&&!U&&(K.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const we=M;M=void 0,U=void 0,(!T||B>1)&&K.fire(we),B=0},V)})},onLastListenerRemove(){F.dispose()}});return K.event}w.debounce=a;function p(G){const x=new Date().getTime();return u(E(G),V=>new Date().getTime()-x)}w.stopwatch=p;function h(G,x=(V,T)=>V===T){let V=!0,T;return f(G,N=>{const F=V||!x(N,T);return V=!1,T=N,F})}w.latch=h;function b(G,x){return[w.filter(G,x),w.filter(G,V=>!x(V))]}w.split=b;function y(G,x=!1,V=[]){let T=V.slice(),N=G(U=>{T?T.push(U):M.fire(U)});const F=()=>{T&&T.forEach(U=>M.fire(U)),T=null},M=new l({onFirstListenerAdd(){N||(N=G(U=>M.fire(U)))},onFirstListenerDidAdd(){T&&(x?setTimeout(F):F())},onLastListenerRemove(){N&&N.dispose(),N=null}});return M.event}w.buffer=y;class o{constructor(x){this.event=x}map(x){return new o(u(this.event,x))}forEach(x){return new o(d(this.event,x))}filter(x){return new o(f(this.event,x))}reduce(x,V){return new o(n(this.event,x,V))}latch(){return new o(h(this.event))}debounce(x,V=100,T=!1,N){return new o(a(this.event,x,V,T,N))}on(x,V,T){return this.event(x,V,T)}once(x,V,T){return E(this.event)(x,V,T)}}function L(G){return new o(G)}w.chain=L;function O(G,x,V=T=>T){const T=(...U)=>M.fire(V(...U)),N=()=>G.on(x,T),F=()=>G.removeListener(x,T),M=new l({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromNodeEventEmitter=O;function W(G,x,V=T=>T){const T=(...U)=>M.fire(V(...U)),N=()=>G.addEventListener(x,T),F=()=>G.removeEventListener(x,T),M=new l({onFirstListenerAdd:N,onLastListenerRemove:F});return M.event}w.fromDOMEventEmitter=W;function ee(G){const x=new l;let V=!1;return G.then(void 0,()=>null).then(()=>{V?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),V=!0,x.event}w.fromPromise=ee;function ce(G){return new Promise(x=>E(G)(x))}w.toPromise=ce})(C=e.Event||(e.Event={}));class D{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${D._idPool++}`}start(E){this._stopWatch=new A.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function s(w){const E=P;return P=w,{dispose(){P=E}}}e.setGlobalLeakWarningThreshold=s;class I{constructor(E,u=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let u=P;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||E<u)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(d)||0;if(this._stacks.set(d,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,r=0;for(const[n,i]of this._stacks)(!t||r<i)&&(t=n,r=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}class l{constructor(E){var u;this._disposed=!1,this._options=E,this._leakageMon=P>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(E,u,d)=>{var f;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(u?[E,u]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,u);const n=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let i;return i={dispose:()=>{n&&n(),i.dispose=l._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof k.DisposableStore?d.add(i):Array.isArray(d)&&d.push(i),i}),this._event}fire(E){var u,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,E]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(r){v.onUnexpectedError(r)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var E,u,d,f,t;this._disposed||(this._disposed=!0,(E=this._listeners)===null||E===void 0||E.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(f=(d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)===null||f===void 0||f.call(d),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=l,l._noop=function(){};class g extends l{constructor(E){super(E);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=g;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const u={event:E,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const d=()=>{this.hasListeners&&this.unhook(u);const f=this.events.indexOf(u);this.events.splice(f,1)};return k.toDisposable(R.once(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(u=>this.emitter.fire(u))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class m{constructor(){this.buffers=[]}wrapEvent(E){return(u,d,f)=>E(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>u.call(d,t)):u.call(d,t)},void 0,f)}bufferEvents(E){const u=[];this.buffers.push(u);const d=E();return this.buffers.pop(),u.forEach(f=>f()),d}}e.EventBufferer=m;class _{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=k.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=_}),define(ge[21],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(C,D){const P=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(P)}}});var k;(function(C){function D(P){return P===C.None||P===C.Cancelled||P instanceof S?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(k=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=k.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ge[90],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(I){const l=this._icons.get(I.id);l?I.description?l.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new R;e.iconRegistry=k;function S(s,I){return new C(s,I)}e.registerCodicon=S;function A(s){return s?s.replace(/\$\((.*?)\)/g,(I,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class C{constructor(I,l,g){this.id=I,this.definition=l,this.description=g,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(s,I){const l=["codicon","codicon-"+s];return I&&l.push("codicon-modifier-"+I),l}e.getClassNamesArray=D;var P;(function(s){s.iconNameSegment="[A-Za-z0-9]+",s.iconNameExpression="[A-Za-z0-9\\-]+",s.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${s.iconNameExpression})(${s.iconModifierExpression})?$`);function l(m){if(m instanceof C)return["codicon","codicon-"+m.id];const _=I.exec(m.id);if(!_)return l(C.error);let[,w,E]=_;const u=["codicon","codicon-"+w];return E&&u.push("codicon-modifier-"+E.substr(1)),u}s.asClassNameArray=l;function g(m){return l(m).join(" ")}s.asClassName=g;function c(m){return"."+l(m).join(".")}s.asCSSSelector=c})(P=e.CSSIcon||(e.CSSIcon={})),function(s){s.add=new s("add",{fontCharacter:"\\ea60"}),s.plus=new s("plus",{fontCharacter:"\\ea60"}),s.gistNew=new s("gist-new",{fontCharacter:"\\ea60"}),s.repoCreate=new s("repo-create",{fontCharacter:"\\ea60"}),s.lightbulb=new s("lightbulb",{fontCharacter:"\\ea61"}),s.lightBulb=new s("light-bulb",{fontCharacter:"\\ea61"}),s.repo=new s("repo",{fontCharacter:"\\ea62"}),s.repoDelete=new s("repo-delete",{fontCharacter:"\\ea62"}),s.gistFork=new s("gist-fork",{fontCharacter:"\\ea63"}),s.repoForked=new s("repo-forked",{fontCharacter:"\\ea63"}),s.gitPullRequest=new s("git-pull-request",{fontCharacter:"\\ea64"}),s.gitPullRequestAbandoned=new s("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),s.recordKeys=new s("record-keys",{fontCharacter:"\\ea65"}),s.keyboard=new s("keyboard",{fontCharacter:"\\ea65"}),s.tag=new s("tag",{fontCharacter:"\\ea66"}),s.tagAdd=new s("tag-add",{fontCharacter:"\\ea66"}),s.tagRemove=new s("tag-remove",{fontCharacter:"\\ea66"}),s.person=new s("person",{fontCharacter:"\\ea67"}),s.personFollow=new s("person-follow",{fontCharacter:"\\ea67"}),s.personOutline=new s("person-outline",{fontCharacter:"\\ea67"}),s.personFilled=new s("person-filled",{fontCharacter:"\\ea67"}),s.gitBranch=new s("git-branch",{fontCharacter:"\\ea68"}),s.gitBranchCreate=new s("git-branch-create",{fontCharacter:"\\ea68"}),s.gitBranchDelete=new s("git-branch-delete",{fontCharacter:"\\ea68"}),s.sourceControl=new s("source-control",{fontCharacter:"\\ea68"}),s.mirror=new s("mirror",{fontCharacter:"\\ea69"}),s.mirrorPublic=new s("mirror-public",{fontCharacter:"\\ea69"}),s.star=new s("star",{fontCharacter:"\\ea6a"}),s.starAdd=new s("star-add",{fontCharacter:"\\ea6a"}),s.starDelete=new s("star-delete",{fontCharacter:"\\ea6a"}),s.starEmpty=new s("star-empty",{fontCharacter:"\\ea6a"}),s.comment=new s("comment",{fontCharacter:"\\ea6b"}),s.commentAdd=new s("comment-add",{fontCharacter:"\\ea6b"}),s.alert=new s("alert",{fontCharacter:"\\ea6c"}),s.warning=new s("warning",{fontCharacter:"\\ea6c"}),s.search=new s("search",{fontCharacter:"\\ea6d"}),s.searchSave=new s("search-save",{fontCharacter:"\\ea6d"}),s.logOut=new s("log-out",{fontCharacter:"\\ea6e"}),s.signOut=new s("sign-out",{fontCharacter:"\\ea6e"}),s.logIn=new s("log-in",{fontCharacter:"\\ea6f"}),s.signIn=new s("sign-in",{fontCharacter:"\\ea6f"}),s.eye=new s("eye",{fontCharacter:"\\ea70"}),s.eyeUnwatch=new s("eye-unwatch",{fontCharacter:"\\ea70"}),s.eyeWatch=new s("eye-watch",{fontCharacter:"\\ea70"}),s.circleFilled=new s("circle-filled",{fontCharacter:"\\ea71"}),s.primitiveDot=new s("primitive-dot",{fontCharacter:"\\ea71"}),s.closeDirty=new s("close-dirty",{fontCharacter:"\\ea71"}),s.debugBreakpoint=new s("debug-breakpoint",{fontCharacter:"\\ea71"}),s.debugBreakpointDisabled=new s("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),s.debugHint=new s("debug-hint",{fontCharacter:"\\ea71"}),s.primitiveSquare=new s("primitive-square",{fontCharacter:"\\ea72"}),s.edit=new s("edit",{fontCharacter:"\\ea73"}),s.pencil=new s("pencil",{fontCharacter:"\\ea73"}),s.info=new s("info",{fontCharacter:"\\ea74"}),s.issueOpened=new s("issue-opened",{fontCharacter:"\\ea74"}),s.gistPrivate=new s("gist-private",{fontCharacter:"\\ea75"}),s.gitForkPrivate=new s("git-fork-private",{fontCharacter:"\\ea75"}),s.lock=new s("lock",{fontCharacter:"\\ea75"}),s.mirrorPrivate=new s("mirror-private",{fontCharacter:"\\ea75"}),s.close=new s("close",{fontCharacter:"\\ea76"}),s.removeClose=new s("remove-close",{fontCharacter:"\\ea76"}),s.x=new s("x",{fontCharacter:"\\ea76"}),s.repoSync=new s("repo-sync",{fontCharacter:"\\ea77"}),s.sync=new s("sync",{fontCharacter:"\\ea77"}),s.clone=new s("clone",{fontCharacter:"\\ea78"}),s.desktopDownload=new s("desktop-download",{fontCharacter:"\\ea78"}),s.beaker=new s("beaker",{fontCharacter:"\\ea79"}),s.microscope=new s("microscope",{fontCharacter:"\\ea79"}),s.vm=new s("vm",{fontCharacter:"\\ea7a"}),s.deviceDesktop=new s("device-desktop",{fontCharacter:"\\ea7a"}),s.file=new s("file",{fontCharacter:"\\ea7b"}),s.fileText=new s("file-text",{fontCharacter:"\\ea7b"}),s.more=new s("more",{fontCharacter:"\\ea7c"}),s.ellipsis=new s("ellipsis",{fontCharacter:"\\ea7c"}),s.kebabHorizontal=new s("kebab-horizontal",{fontCharacter:"\\ea7c"}),s.mailReply=new s("mail-reply",{fontCharacter:"\\ea7d"}),s.reply=new s("reply",{fontCharacter:"\\ea7d"}),s.organization=new s("organization",{fontCharacter:"\\ea7e"}),s.organizationFilled=new s("organization-filled",{fontCharacter:"\\ea7e"}),s.organizationOutline=new s("organization-outline",{fontCharacter:"\\ea7e"}),s.newFile=new s("new-file",{fontCharacter:"\\ea7f"}),s.fileAdd=new s("file-add",{fontCharacter:"\\ea7f"}),s.newFolder=new s("new-folder",{fontCharacter:"\\ea80"}),s.fileDirectoryCreate=new s("file-directory-create",{fontCharacter:"\\ea80"}),s.trash=new s("trash",{fontCharacter:"\\ea81"}),s.trashcan=new s("trashcan",{fontCharacter:"\\ea81"}),s.history=new s("history",{fontCharacter:"\\ea82"}),s.clock=new s("clock",{fontCharacter:"\\ea82"}),s.folder=new s("folder",{fontCharacter:"\\ea83"}),s.fileDirectory=new s("file-directory",{fontCharacter:"\\ea83"}),s.symbolFolder=new s("symbol-folder",{fontCharacter:"\\ea83"}),s.logoGithub=new s("logo-github",{fontCharacter:"\\ea84"}),s.markGithub=new s("mark-github",{fontCharacter:"\\ea84"}),s.github=new s("github",{fontCharacter:"\\ea84"}),s.terminal=new s("terminal",{fontCharacter:"\\ea85"}),s.console=new s("console",{fontCharacter:"\\ea85"}),s.repl=new s("repl",{fontCharacter:"\\ea85"}),s.zap=new s("zap",{fontCharacter:"\\ea86"}),s.symbolEvent=new s("symbol-event",{fontCharacter:"\\ea86"}),s.error=new s("error",{fontCharacter:"\\ea87"}),s.stop=new s("stop",{fontCharacter:"\\ea87"}),s.variable=new s("variable",{fontCharacter:"\\ea88"}),s.symbolVariable=new s("symbol-variable",{fontCharacter:"\\ea88"}),s.array=new s("array",{fontCharacter:"\\ea8a"}),s.symbolArray=new s("symbol-array",{fontCharacter:"\\ea8a"}),s.symbolModule=new s("symbol-module",{fontCharacter:"\\ea8b"}),s.symbolPackage=new s("symbol-package",{fontCharacter:"\\ea8b"}),s.symbolNamespace=new s("symbol-namespace",{fontCharacter:"\\ea8b"}),s.symbolObject=new s("symbol-object",{fontCharacter:"\\ea8b"}),s.symbolMethod=new s("symbol-method",{fontCharacter:"\\ea8c"}),s.symbolFunction=new s("symbol-function",{fontCharacter:"\\ea8c"}),s.symbolConstructor=new s("symbol-constructor",{fontCharacter:"\\ea8c"}),s.symbolBoolean=new s("symbol-boolean",{fontCharacter:"\\ea8f"}),s.symbolNull=new s("symbol-null",{fontCharacter:"\\ea8f"}),s.symbolNumeric=new s("symbol-numeric",{fontCharacter:"\\ea90"}),s.symbolNumber=new s("symbol-number",{fontCharacter:"\\ea90"}),s.symbolStructure=new s("symbol-structure",{fontCharacter:"\\ea91"}),s.symbolStruct=new s("symbol-struct",{fontCharacter:"\\ea91"}),s.symbolParameter=new s("symbol-parameter",{fontCharacter:"\\ea92"}),s.symbolTypeParameter=new s("symbol-type-parameter",{fontCharacter:"\\ea92"}),s.symbolKey=new s("symbol-key",{fontCharacter:"\\ea93"}),s.symbolText=new s("symbol-text",{fontCharacter:"\\ea93"}),s.symbolReference=new s("symbol-reference",{fontCharacter:"\\ea94"}),s.goToFile=new s("go-to-file",{fontCharacter:"\\ea94"}),s.symbolEnum=new s("symbol-enum",{fontCharacter:"\\ea95"}),s.symbolValue=new s("symbol-value",{fontCharacter:"\\ea95"}),s.symbolRuler=new s("symbol-ruler",{fontCharacter:"\\ea96"}),s.symbolUnit=new s("symbol-unit",{fontCharacter:"\\ea96"}),s.activateBreakpoints=new s("activate-breakpoints",{fontCharacter:"\\ea97"}),s.archive=new s("archive",{fontCharacter:"\\ea98"}),s.arrowBoth=new s("arrow-both",{fontCharacter:"\\ea99"}),s.arrowDown=new s("arrow-down",{fontCharacter:"\\ea9a"}),s.arrowLeft=new s("arrow-left",{fontCharacter:"\\ea9b"}),s.arrowRight=new s("arrow-right",{fontCharacter:"\\ea9c"}),s.arrowSmallDown=new s("arrow-small-down",{fontCharacter:"\\ea9d"}),s.arrowSmallLeft=new s("arrow-small-left",{fontCharacter:"\\ea9e"}),s.arrowSmallRight=new s("arrow-small-right",{fontCharacter:"\\ea9f"}),s.arrowSmallUp=new s("arrow-small-up",{fontCharacter:"\\eaa0"}),s.arrowUp=new s("arrow-up",{fontCharacter:"\\eaa1"}),s.bell=new s("bell",{fontCharacter:"\\eaa2"}),s.bold=new s("bold",{fontCharacter:"\\eaa3"}),s.book=new s("book",{fontCharacter:"\\eaa4"}),s.bookmark=new s("bookmark",{fontCharacter:"\\eaa5"}),s.debugBreakpointConditionalUnverified=new s("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),s.debugBreakpointConditional=new s("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),s.debugBreakpointConditionalDisabled=new s("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),s.debugBreakpointDataUnverified=new s("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),s.debugBreakpointData=new s("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),s.debugBreakpointDataDisabled=new s("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),s.debugBreakpointLogUnverified=new s("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),s.debugBreakpointLog=new s("debug-breakpoint-log",{fontCharacter:"\\eaab"}),s.debugBreakpointLogDisabled=new s("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),s.briefcase=new s("briefcase",{fontCharacter:"\\eaac"}),s.broadcast=new s("broadcast",{fontCharacter:"\\eaad"}),s.browser=new s("browser",{fontCharacter:"\\eaae"}),s.bug=new s("bug",{fontCharacter:"\\eaaf"}),s.calendar=new s("calendar",{fontCharacter:"\\eab0"}),s.caseSensitive=new s("case-sensitive",{fontCharacter:"\\eab1"}),s.check=new s("check",{fontCharacter:"\\eab2"}),s.checklist=new s("checklist",{fontCharacter:"\\eab3"}),s.chevronDown=new s("chevron-down",{fontCharacter:"\\eab4"}),s.chevronLeft=new s("chevron-left",{fontCharacter:"\\eab5"}),s.chevronRight=new s("chevron-right",{fontCharacter:"\\eab6"}),s.chevronUp=new s("chevron-up",{fontCharacter:"\\eab7"}),s.chromeClose=new s("chrome-close",{fontCharacter:"\\eab8"}),s.chromeMaximize=new s("chrome-maximize",{fontCharacter:"\\eab9"}),s.chromeMinimize=new s("chrome-minimize",{fontCharacter:"\\eaba"}),s.chromeRestore=new s("chrome-restore",{fontCharacter:"\\eabb"}),s.circleOutline=new s("circle-outline",{fontCharacter:"\\eabc"}),s.debugBreakpointUnverified=new s("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),s.circleSlash=new s("circle-slash",{fontCharacter:"\\eabd"}),s.circuitBoard=new s("circuit-board",{fontCharacter:"\\eabe"}),s.clearAll=new s("clear-all",{fontCharacter:"\\eabf"}),s.clippy=new s("clippy",{fontCharacter:"\\eac0"}),s.closeAll=new s("close-all",{fontCharacter:"\\eac1"}),s.cloudDownload=new s("cloud-download",{fontCharacter:"\\eac2"}),s.cloudUpload=new s("cloud-upload",{fontCharacter:"\\eac3"}),s.code=new s("code",{fontCharacter:"\\eac4"}),s.collapseAll=new s("collapse-all",{fontCharacter:"\\eac5"}),s.colorMode=new s("color-mode",{fontCharacter:"\\eac6"}),s.commentDiscussion=new s("comment-discussion",{fontCharacter:"\\eac7"}),s.compareChanges=new s("compare-changes",{fontCharacter:"\\eafd"}),s.creditCard=new s("credit-card",{fontCharacter:"\\eac9"}),s.dash=new s("dash",{fontCharacter:"\\eacc"}),s.dashboard=new s("dashboard",{fontCharacter:"\\eacd"}),s.database=new s("database",{fontCharacter:"\\eace"}),s.debugContinue=new s("debug-continue",{fontCharacter:"\\eacf"}),s.debugDisconnect=new s("debug-disconnect",{fontCharacter:"\\ead0"}),s.debugPause=new s("debug-pause",{fontCharacter:"\\ead1"}),s.debugRestart=new s("debug-restart",{fontCharacter:"\\ead2"}),s.debugStart=new s("debug-start",{fontCharacter:"\\ead3"}),s.debugStepInto=new s("debug-step-into",{fontCharacter:"\\ead4"}),s.debugStepOut=new s("debug-step-out",{fontCharacter:"\\ead5"}),s.debugStepOver=new s("debug-step-over",{fontCharacter:"\\ead6"}),s.debugStop=new s("debug-stop",{fontCharacter:"\\ead7"}),s.debug=new s("debug",{fontCharacter:"\\ead8"}),s.deviceCameraVideo=new s("device-camera-video",{fontCharacter:"\\ead9"}),s.deviceCamera=new s("device-camera",{fontCharacter:"\\eada"}),s.deviceMobile=new s("device-mobile",{fontCharacter:"\\eadb"}),s.diffAdded=new s("diff-added",{fontCharacter:"\\eadc"}),s.diffIgnored=new s("diff-ignored",{fontCharacter:"\\eadd"}),s.diffModified=new s("diff-modified",{fontCharacter:"\\eade"}),s.diffRemoved=new s("diff-removed",{fontCharacter:"\\eadf"}),s.diffRenamed=new s("diff-renamed",{fontCharacter:"\\eae0"}),s.diff=new s("diff",{fontCharacter:"\\eae1"}),s.discard=new s("discard",{fontCharacter:"\\eae2"}),s.editorLayout=new s("editor-layout",{fontCharacter:"\\eae3"}),s.emptyWindow=new s("empty-window",{fontCharacter:"\\eae4"}),s.exclude=new s("exclude",{fontCharacter:"\\eae5"}),s.extensions=new s("extensions",{fontCharacter:"\\eae6"}),s.eyeClosed=new s("eye-closed",{fontCharacter:"\\eae7"}),s.fileBinary=new s("file-binary",{fontCharacter:"\\eae8"}),s.fileCode=new s("file-code",{fontCharacter:"\\eae9"}),s.fileMedia=new s("file-media",{fontCharacter:"\\eaea"}),s.filePdf=new s("file-pdf",{fontCharacter:"\\eaeb"}),s.fileSubmodule=new s("file-submodule",{fontCharacter:"\\eaec"}),s.fileSymlinkDirectory=new s("file-symlink-directory",{fontCharacter:"\\eaed"}),s.fileSymlinkFile=new s("file-symlink-file",{fontCharacter:"\\eaee"}),s.fileZip=new s("file-zip",{fontCharacter:"\\eaef"}),s.files=new s("files",{fontCharacter:"\\eaf0"}),s.filter=new s("filter",{fontCharacter:"\\eaf1"}),s.flame=new s("flame",{fontCharacter:"\\eaf2"}),s.foldDown=new s("fold-down",{fontCharacter:"\\eaf3"}),s.foldUp=new s("fold-up",{fontCharacter:"\\eaf4"}),s.fold=new s("fold",{fontCharacter:"\\eaf5"}),s.folderActive=new s("folder-active",{fontCharacter:"\\eaf6"}),s.folderOpened=new s("folder-opened",{fontCharacter:"\\eaf7"}),s.gear=new s("gear",{fontCharacter:"\\eaf8"}),s.gift=new s("gift",{fontCharacter:"\\eaf9"}),s.gistSecret=new s("gist-secret",{fontCharacter:"\\eafa"}),s.gist=new s("gist",{fontCharacter:"\\eafb"}),s.gitCommit=new s("git-commit",{fontCharacter:"\\eafc"}),s.gitCompare=new s("git-compare",{fontCharacter:"\\eafd"}),s.gitMerge=new s("git-merge",{fontCharacter:"\\eafe"}),s.githubAction=new s("github-action",{fontCharacter:"\\eaff"}),s.githubAlt=new s("github-alt",{fontCharacter:"\\eb00"}),s.globe=new s("globe",{fontCharacter:"\\eb01"}),s.grabber=new s("grabber",{fontCharacter:"\\eb02"}),s.graph=new s("graph",{fontCharacter:"\\eb03"}),s.gripper=new s("gripper",{fontCharacter:"\\eb04"}),s.heart=new s("heart",{fontCharacter:"\\eb05"}),s.home=new s("home",{fontCharacter:"\\eb06"}),s.horizontalRule=new s("horizontal-rule",{fontCharacter:"\\eb07"}),s.hubot=new s("hubot",{fontCharacter:"\\eb08"}),s.inbox=new s("inbox",{fontCharacter:"\\eb09"}),s.issueClosed=new s("issue-closed",{fontCharacter:"\\eb0a"}),s.issueReopened=new s("issue-reopened",{fontCharacter:"\\eb0b"}),s.issues=new s("issues",{fontCharacter:"\\eb0c"}),s.italic=new s("italic",{fontCharacter:"\\eb0d"}),s.jersey=new s("jersey",{fontCharacter:"\\eb0e"}),s.json=new s("json",{fontCharacter:"\\eb0f"}),s.kebabVertical=new s("kebab-vertical",{fontCharacter:"\\eb10"}),s.key=new s("key",{fontCharacter:"\\eb11"}),s.law=new s("law",{fontCharacter:"\\eb12"}),s.lightbulbAutofix=new s("lightbulb-autofix",{fontCharacter:"\\eb13"}),s.linkExternal=new s("link-external",{fontCharacter:"\\eb14"}),s.link=new s("link",{fontCharacter:"\\eb15"}),s.listOrdered=new s("list-ordered",{fontCharacter:"\\eb16"}),s.listUnordered=new s("list-unordered",{fontCharacter:"\\eb17"}),s.liveShare=new s("live-share",{fontCharacter:"\\eb18"}),s.loading=new s("loading",{fontCharacter:"\\eb19"}),s.location=new s("location",{fontCharacter:"\\eb1a"}),s.mailRead=new s("mail-read",{fontCharacter:"\\eb1b"}),s.mail=new s("mail",{fontCharacter:"\\eb1c"}),s.markdown=new s("markdown",{fontCharacter:"\\eb1d"}),s.megaphone=new s("megaphone",{fontCharacter:"\\eb1e"}),s.mention=new s("mention",{fontCharacter:"\\eb1f"}),s.milestone=new s("milestone",{fontCharacter:"\\eb20"}),s.mortarBoard=new s("mortar-board",{fontCharacter:"\\eb21"}),s.move=new s("move",{fontCharacter:"\\eb22"}),s.multipleWindows=new s("multiple-windows",{fontCharacter:"\\eb23"}),s.mute=new s("mute",{fontCharacter:"\\eb24"}),s.noNewline=new s("no-newline",{fontCharacter:"\\eb25"}),s.note=new s("note",{fontCharacter:"\\eb26"}),s.octoface=new s("octoface",{fontCharacter:"\\eb27"}),s.openPreview=new s("open-preview",{fontCharacter:"\\eb28"}),s.package_=new s("package",{fontCharacter:"\\eb29"}),s.paintcan=new s("paintcan",{fontCharacter:"\\eb2a"}),s.pin=new s("pin",{fontCharacter:"\\eb2b"}),s.play=new s("play",{fontCharacter:"\\eb2c"}),s.run=new s("run",{fontCharacter:"\\eb2c"}),s.plug=new s("plug",{fontCharacter:"\\eb2d"}),s.preserveCase=new s("preserve-case",{fontCharacter:"\\eb2e"}),s.preview=new s("preview",{fontCharacter:"\\eb2f"}),s.project=new s("project",{fontCharacter:"\\eb30"}),s.pulse=new s("pulse",{fontCharacter:"\\eb31"}),s.question=new s("question",{fontCharacter:"\\eb32"}),s.quote=new s("quote",{fontCharacter:"\\eb33"}),s.radioTower=new s("radio-tower",{fontCharacter:"\\eb34"}),s.reactions=new s("reactions",{fontCharacter:"\\eb35"}),s.references=new s("references",{fontCharacter:"\\eb36"}),s.refresh=new s("refresh",{fontCharacter:"\\eb37"}),s.regex=new s("regex",{fontCharacter:"\\eb38"}),s.remoteExplorer=new s("remote-explorer",{fontCharacter:"\\eb39"}),s.remote=new s("remote",{fontCharacter:"\\eb3a"}),s.remove=new s("remove",{fontCharacter:"\\eb3b"}),s.replaceAll=new s("replace-all",{fontCharacter:"\\eb3c"}),s.replace=new s("replace",{fontCharacter:"\\eb3d"}),s.repoClone=new s("repo-clone",{fontCharacter:"\\eb3e"}),s.repoForcePush=new s("repo-force-push",{fontCharacter:"\\eb3f"}),s.repoPull=new s("repo-pull",{fontCharacter:"\\eb40"}),s.repoPush=new s("repo-push",{fontCharacter:"\\eb41"}),s.report=new s("report",{fontCharacter:"\\eb42"}),s.requestChanges=new s("request-changes",{fontCharacter:"\\eb43"}),s.rocket=new s("rocket",{fontCharacter:"\\eb44"}),s.rootFolderOpened=new s("root-folder-opened",{fontCharacter:"\\eb45"}),s.rootFolder=new s("root-folder",{fontCharacter:"\\eb46"}),s.rss=new s("rss",{fontCharacter:"\\eb47"}),s.ruby=new s("ruby",{fontCharacter:"\\eb48"}),s.saveAll=new s("save-all",{fontCharacter:"\\eb49"}),s.saveAs=new s("save-as",{fontCharacter:"\\eb4a"}),s.save=new s("save",{fontCharacter:"\\eb4b"}),s.screenFull=new s("screen-full",{fontCharacter:"\\eb4c"}),s.screenNormal=new s("screen-normal",{fontCharacter:"\\eb4d"}),s.searchStop=new s("search-stop",{fontCharacter:"\\eb4e"}),s.server=new s("server",{fontCharacter:"\\eb50"}),s.settingsGear=new s("settings-gear",{fontCharacter:"\\eb51"}),s.settings=new s("settings",{fontCharacter:"\\eb52"}),s.shield=new s("shield",{fontCharacter:"\\eb53"}),s.smiley=new s("smiley",{fontCharacter:"\\eb54"}),s.sortPrecedence=new s("sort-precedence",{fontCharacter:"\\eb55"}),s.splitHorizontal=new s("split-horizontal",{fontCharacter:"\\eb56"}),s.splitVertical=new s("split-vertical",{fontCharacter:"\\eb57"}),s.squirrel=new s("squirrel",{fontCharacter:"\\eb58"}),s.starFull=new s("star-full",{fontCharacter:"\\eb59"}),s.starHalf=new s("star-half",{fontCharacter:"\\eb5a"}),s.symbolClass=new s("symbol-class",{fontCharacter:"\\eb5b"}),s.symbolColor=new s("symbol-color",{fontCharacter:"\\eb5c"}),s.symbolConstant=new s("symbol-constant",{fontCharacter:"\\eb5d"}),s.symbolEnumMember=new s("symbol-enum-member",{fontCharacter:"\\eb5e"}),s.symbolField=new s("symbol-field",{fontCharacter:"\\eb5f"}),s.symbolFile=new s("symbol-file",{fontCharacter:"\\eb60"}),s.symbolInterface=new s("symbol-interface",{fontCharacter:"\\eb61"}),s.symbolKeyword=new s("symbol-keyword",{fontCharacter:"\\eb62"}),s.symbolMisc=new s("symbol-misc",{fontCharacter:"\\eb63"}),s.symbolOperator=new s("symbol-operator",{fontCharacter:"\\eb64"}),s.symbolProperty=new s("symbol-property",{fontCharacter:"\\eb65"}),s.wrench=new s("wrench",{fontCharacter:"\\eb65"}),s.wrenchSubaction=new s("wrench-subaction",{fontCharacter:"\\eb65"}),s.symbolSnippet=new s("symbol-snippet",{fontCharacter:"\\eb66"}),s.tasklist=new s("tasklist",{fontCharacter:"\\eb67"}),s.telescope=new s("telescope",{fontCharacter:"\\eb68"}),s.textSize=new s("text-size",{fontCharacter:"\\eb69"}),s.threeBars=new s("three-bars",{fontCharacter:"\\eb6a"}),s.thumbsdown=new s("thumbsdown",{fontCharacter:"\\eb6b"}),s.thumbsup=new s("thumbsup",{fontCharacter:"\\eb6c"}),s.tools=new s("tools",{fontCharacter:"\\eb6d"}),s.triangleDown=new s("triangle-down",{fontCharacter:"\\eb6e"}),s.triangleLeft=new s("triangle-left",{fontCharacter:"\\eb6f"}),s.triangleRight=new s("triangle-right",{fontCharacter:"\\eb70"}),s.triangleUp=new s("triangle-up",{fontCharacter:"\\eb71"}),s.twitter=new s("twitter",{fontCharacter:"\\eb72"}),s.unfold=new s("unfold",{fontCharacter:"\\eb73"}),s.unlock=new s("unlock",{fontCharacter:"\\eb74"}),s.unmute=new s("unmute",{fontCharacter:"\\eb75"}),s.unverified=new s("unverified",{fontCharacter:"\\eb76"}),s.verified=new s("verified",{fontCharacter:"\\eb77"}),s.versions=new s("versions",{fontCharacter:"\\eb78"}),s.vmActive=new s("vm-active",{fontCharacter:"\\eb79"}),s.vmOutline=new s("vm-outline",{fontCharacter:"\\eb7a"}),s.vmRunning=new s("vm-running",{fontCharacter:"\\eb7b"}),s.watch=new s("watch",{fontCharacter:"\\eb7c"}),s.whitespace=new s("whitespace",{fontCharacter:"\\eb7d"}),s.wholeWord=new s("whole-word",{fontCharacter:"\\eb7e"}),s.window=new s("window",{fontCharacter:"\\eb7f"}),s.wordWrap=new s("word-wrap",{fontCharacter:"\\eb80"}),s.zoomIn=new s("zoom-in",{fontCharacter:"\\eb81"}),s.zoomOut=new s("zoom-out",{fontCharacter:"\\eb82"}),s.listFilter=new s("list-filter",{fontCharacter:"\\eb83"}),s.listFlat=new s("list-flat",{fontCharacter:"\\eb84"}),s.listSelection=new s("list-selection",{fontCharacter:"\\eb85"}),s.selection=new s("selection",{fontCharacter:"\\eb85"}),s.listTree=new s("list-tree",{fontCharacter:"\\eb86"}),s.debugBreakpointFunctionUnverified=new s("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),s.debugBreakpointFunction=new s("debug-breakpoint-function",{fontCharacter:"\\eb88"}),s.debugBreakpointFunctionDisabled=new s("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),s.debugStackframeActive=new s("debug-stackframe-active",{fontCharacter:"\\eb89"}),s.debugStackframeDot=new s("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),s.debugStackframe=new s("debug-stackframe",{fontCharacter:"\\eb8b"}),s.debugStackframeFocused=new s("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),s.debugBreakpointUnsupported=new s("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),s.symbolString=new s("symbol-string",{fontCharacter:"\\eb8d"}),s.debugReverseContinue=new s("debug-reverse-continue",{fontCharacter:"\\eb8e"}),s.debugStepBack=new s("debug-step-back",{fontCharacter:"\\eb8f"}),s.debugRestartFrame=new s("debug-restart-frame",{fontCharacter:"\\eb90"}),s.callIncoming=new s("call-incoming",{fontCharacter:"\\eb92"}),s.callOutgoing=new s("call-outgoing",{fontCharacter:"\\eb93"}),s.menu=new s("menu",{fontCharacter:"\\eb94"}),s.expandAll=new s("expand-all",{fontCharacter:"\\eb95"}),s.feedback=new s("feedback",{fontCharacter:"\\eb96"}),s.groupByRefType=new s("group-by-ref-type",{fontCharacter:"\\eb97"}),s.ungroupByRefType=new s("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),s.account=new s("account",{fontCharacter:"\\eb99"}),s.bellDot=new s("bell-dot",{fontCharacter:"\\eb9a"}),s.debugConsole=new s("debug-console",{fontCharacter:"\\eb9b"}),s.library=new s("library",{fontCharacter:"\\eb9c"}),s.output=new s("output",{fontCharacter:"\\eb9d"}),s.runAll=new s("run-all",{fontCharacter:"\\eb9e"}),s.syncIgnored=new s("sync-ignored",{fontCharacter:"\\eb9f"}),s.pinned=new s("pinned",{fontCharacter:"\\eba0"}),s.githubInverted=new s("github-inverted",{fontCharacter:"\\eba1"}),s.debugAlt=new s("debug-alt",{fontCharacter:"\\eb91"}),s.serverProcess=new s("server-process",{fontCharacter:"\\eba2"}),s.serverEnvironment=new s("server-environment",{fontCharacter:"\\eba3"}),s.pass=new s("pass",{fontCharacter:"\\eba4"}),s.stopCircle=new s("stop-circle",{fontCharacter:"\\eba5"}),s.playCircle=new s("play-circle",{fontCharacter:"\\eba6"}),s.record=new s("record",{fontCharacter:"\\eba7"}),s.debugAltSmall=new s("debug-alt-small",{fontCharacter:"\\eba8"}),s.vmConnect=new s("vm-connect",{fontCharacter:"\\eba9"}),s.cloud=new s("cloud",{fontCharacter:"\\ebaa"}),s.merge=new s("merge",{fontCharacter:"\\ebab"}),s.exportIcon=new s("export",{fontCharacter:"\\ebac"}),s.graphLeft=new s("graph-left",{fontCharacter:"\\ebad"}),s.magnet=new s("magnet",{fontCharacter:"\\ebae"}),s.notebook=new s("notebook",{fontCharacter:"\\ebaf"}),s.redo=new s("redo",{fontCharacter:"\\ebb0"}),s.checkAll=new s("check-all",{fontCharacter:"\\ebb1"}),s.pinnedDirty=new s("pinned-dirty",{fontCharacter:"\\ebb2"}),s.passFilled=new s("pass-filled",{fontCharacter:"\\ebb3"}),s.circleLargeFilled=new s("circle-large-filled",{fontCharacter:"\\ebb4"}),s.circleLargeOutline=new s("circle-large-outline",{fontCharacter:"\\ebb5"}),s.combine=new s("combine",{fontCharacter:"\\ebb6"}),s.gather=new s("gather",{fontCharacter:"\\ebb6"}),s.table=new s("table",{fontCharacter:"\\ebb7"}),s.variableGroup=new s("variable-group",{fontCharacter:"\\ebb8"}),s.typeHierarchy=new s("type-hierarchy",{fontCharacter:"\\ebb9"}),s.typeHierarchySub=new s("type-hierarchy-sub",{fontCharacter:"\\ebba"}),s.typeHierarchySuper=new s("type-hierarchy-super",{fontCharacter:"\\ebbb"}),s.gitPullRequestCreate=new s("git-pull-request-create",{fontCharacter:"\\ebbc"}),s.runAbove=new s("run-above",{fontCharacter:"\\ebbd"}),s.runBelow=new s("run-below",{fontCharacter:"\\ebbe"}),s.notebookTemplate=new s("notebook-template",{fontCharacter:"\\ebbf"}),s.debugRerun=new s("debug-rerun",{fontCharacter:"\\ebc0"}),s.workspaceTrusted=new s("workspace-trusted",{fontCharacter:"\\ebc1"}),s.workspaceUntrusted=new s("workspace-untrusted",{fontCharacter:"\\ebc2"}),s.workspaceUnspecified=new s("workspace-unspecified",{fontCharacter:"\\ebc3"}),s.terminalCmd=new s("terminal-cmd",{fontCharacter:"\\ebc4"}),s.terminalDebian=new s("terminal-debian",{fontCharacter:"\\ebc5"}),s.terminalLinux=new s("terminal-linux",{fontCharacter:"\\ebc6"}),s.terminalPowershell=new s("terminal-powershell",{fontCharacter:"\\ebc7"}),s.terminalTmux=new s("terminal-tmux",{fontCharacter:"\\ebc8"}),s.terminalUbuntu=new s("terminal-ubuntu",{fontCharacter:"\\ebc9"}),s.terminalBash=new s("terminal-bash",{fontCharacter:"\\ebca"}),s.arrowSwap=new s("arrow-swap",{fontCharacter:"\\ebcb"}),s.copy=new s("copy",{fontCharacter:"\\ebcc"}),s.personAdd=new s("person-add",{fontCharacter:"\\ebcd"}),s.filterFilled=new s("filter-filled",{fontCharacter:"\\ebce"}),s.wand=new s("wand",{fontCharacter:"\\ebcf"}),s.debugLineByLine=new s("debug-line-by-line",{fontCharacter:"\\ebd0"}),s.inspect=new s("inspect",{fontCharacter:"\\ebd1"}),s.dropDownButton=new s("drop-down-button",s.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(ge[91],pe([0,1,16,6]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=k;function S(u){const d=u;return d?k(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(u,d){return new C(u,d)}e.newWriteableStream=A;class C{constructor(d,f){this.reducer=d,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(f=>f(d))}emitError(d){this.listeners.error.length===0?v.onUnexpectedError(d):this.listeners.error.slice(0).forEach(f=>f(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,f){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(d,f){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(f);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(u,d){const f=[];let t;for(;(t=u.read())!==null;)f.push(t);return d(f)}e.consumeReadable=D;function P(u,d,f){const t=[];let r;for(;(r=u.read())!==null&&t.length<f;)t.push(r);return r===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const n=r;return r=void 0,n}return u.read()}}}e.peekReadable=P;function s(u,d){return new Promise((f,t)=>{const r=[];I(u,{onData:n=>{d&&r.push(n)},onError:n=>{d?t(n):f(void 0)},onEnd:()=>{f(d?d(r):void 0)}})})}e.consumeStream=s;function I(u,d){u.on("error",f=>d.onError(f)),u.on("end",()=>d.onEnd()),u.on("data",f=>d.onData(f))}e.listenStream=I;function l(u,d){return new Promise((f,t)=>{const r=new R.DisposableStore,n=[],i=h=>{if(n.push(h),n.length>d)return r.dispose(),u.pause(),f({stream:u,buffer:n,ended:!1})},a=h=>t(h),p=()=>f({stream:u,buffer:n,ended:!0});r.add(R.toDisposable(()=>u.removeListener("error",a))),u.on("error",a),r.add(R.toDisposable(()=>u.removeListener("end",p))),u.on("end",p),r.add(R.toDisposable(()=>u.removeListener("data",i))),u.on("data",i)})}e.peekStream=l;function g(u,d){const f=A(d);return f.end(u),f}e.toStream=g;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function m(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=m;function _(u,d,f){const t=A(f);return I(u,{onData:r=>t.write(d.data(r)),onError:r=>t.error(d.error?d.error(r):r),onEnd:()=>t.end()}),t}e.transform=_;function w(u,d,f){let t=!1;return{read:()=>{const r=d.read();return t?r:(t=!0,r!==null?f([u,r]):u)}}}e.prefixedReadable=w;function E(u,d,f){let t=!1;const r=A(f);return I(d,{onData:n=>t?r.write(n):(t=!0,r.write(f([u,n]))),onError:n=>r.error(n),onEnd:()=>{t||(t=!0,r.write(u)),r.end()}}),r}e.prefixedStream=E}),define(ge[8],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function k(H,...Z){return Z.length===0?H:H.replace(R,function(ue,Pe){const Ae=parseInt(Pe,10);return isNaN(Ae)||Ae<0||Ae>=Z.length?ue:Z[Ae]})}e.format=k;function S(H){return H.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=S;function A(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function C(H,Z){let ue=0;const Pe=Z.charCodeAt(0);for(let Ae=H.length-1;Ae>=0;Ae--)H.charCodeAt(Ae)===Pe&&ue++;return ue}e.count=C;function D(H,Z,ue="\u2026"){return H.length<=Z?H:`${H.substr(0,Z)}${ue}`}e.truncate=D;function P(H,Z=" "){const ue=s(H,Z);return I(ue,Z)}e.trim=P;function s(H,Z){if(!H||!Z)return H;const ue=Z.length;if(ue===0||H.length===0)return H;let Pe=0;for(;H.indexOf(Z,Pe)===Pe;)Pe=Pe+ue;return H.substring(Pe)}e.ltrim=s;function I(H,Z){if(!H||!Z)return H;const ue=Z.length,Pe=H.length;if(ue===0||Pe===0)return H;let Ae=Pe,xe=-1;for(;xe=H.lastIndexOf(Z,Ae-1),!(xe===-1||xe+ue!==Ae);){if(xe===0)return"";Ae=xe}return H.substring(0,Ae)}e.rtrim=I;function l(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function g(H){return H.replace(/\*/g,"")}e.stripWildcards=g;function c(H,Z,ue={}){if(!H)throw new Error("Cannot create regex from empty string");Z||(H=A(H)),ue.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Pe="";return ue.global&&(Pe+="g"),ue.matchCase||(Pe+="i"),ue.multiline&&(Pe+="m"),ue.unicode&&(Pe+="u"),new RegExp(H,Pe)}e.createRegExp=c;function m(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function _(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=_;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function E(H){return H.split(/\r\n|\r|\n/)}e.splitLines=E;function u(H){for(let Z=0,ue=H.length;Z<ue;Z++){const Pe=H.charCodeAt(Z);if(Pe!==32&&Pe!==9)return Z}return-1}e.firstNonWhitespaceIndex=u;function d(H,Z=0,ue=H.length){for(let Pe=Z;Pe<ue;Pe++){const Ae=H.charCodeAt(Pe);if(Ae!==32&&Ae!==9)return H.substring(Z,Pe)}return H.substring(Z,ue)}e.getLeadingWhitespace=d;function f(H,Z=H.length-1){for(let ue=Z;ue>=0;ue--){const Pe=H.charCodeAt(ue);if(Pe!==32&&Pe!==9)return ue}return-1}e.lastNonWhitespaceIndex=f;function t(H,Z){return H<Z?-1:H>Z?1:0}e.compare=t;function r(H,Z,ue=0,Pe=H.length,Ae=0,xe=Z.length){for(;ue<Pe&&Ae<xe;ue++,Ae++){let rt=H.charCodeAt(ue),nt=Z.charCodeAt(Ae);if(rt<nt)return-1;if(rt>nt)return 1}const Be=Pe-ue,Qe=xe-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstring=r;function n(H,Z){return i(H,Z,0,H.length,0,Z.length)}e.compareIgnoreCase=n;function i(H,Z,ue=0,Pe=H.length,Ae=0,xe=Z.length){for(;ue<Pe&&Ae<xe;ue++,Ae++){let rt=H.charCodeAt(ue),nt=Z.charCodeAt(Ae);if(rt===nt)continue;const Ze=rt-nt;if(!(Ze===32&&p(nt))&&!(Ze===-32&&p(rt)))return a(rt)&&a(nt)?Ze:r(H.toLowerCase(),Z.toLowerCase(),ue,Pe,Ae,xe)}const Be=Pe-ue,Qe=xe-Ae;return Be<Qe?-1:Be>Qe?1:0}e.compareSubstringIgnoreCase=i;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function p(H){return H>=65&&H<=90}e.isUpperAsciiLetter=p;function h(H){return a(H)||p(H)}function b(H,Z){return H.length===Z.length&&y(H,Z)}e.equalsIgnoreCase=b;function y(H,Z,ue=H.length){for(let Pe=0;Pe<ue;Pe++){const Ae=H.charCodeAt(Pe),xe=Z.charCodeAt(Pe);if(Ae!==xe){if(h(Ae)&&h(xe)){const Be=Math.abs(Ae-xe);if(Be!==0&&Be!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(xe).toLowerCase())return!1}}return!0}function o(H,Z){const ue=Z.length;return Z.length>H.length?!1:y(H,Z,ue)}e.startsWithIgnoreCase=o;function L(H,Z){let ue,Pe=Math.min(H.length,Z.length);for(ue=0;ue<Pe;ue++)if(H.charCodeAt(ue)!==Z.charCodeAt(ue))return ue;return Pe}e.commonPrefixLength=L;function O(H,Z){let ue,Pe=Math.min(H.length,Z.length);const Ae=H.length-1,xe=Z.length-1;for(ue=0;ue<Pe;ue++)if(H.charCodeAt(Ae-ue)!==Z.charCodeAt(xe-ue))return ue;return Pe}e.commonSuffixLength=O;function W(H){return 55296<=H&&H<=56319}e.isHighSurrogate=W;function ee(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ee;function ce(H,Z){return(H-55296<<10)+(Z-56320)+65536}e.computeCodePoint=ce;function G(H,Z,ue){const Pe=H.charCodeAt(ue);if(W(Pe)&&ue+1<Z){const Ae=H.charCodeAt(ue+1);if(ee(Ae))return ce(Pe,Ae)}return Pe}e.getNextCodePoint=G;function x(H,Z){const ue=H.charCodeAt(Z-1);if(ee(ue)&&Z>1){const Pe=H.charCodeAt(Z-2);if(W(Pe))return ce(Pe,ue)}return ue}function V(H,Z){const ue=Ne.getInstance(),Pe=Z,Ae=H.length,xe=G(H,Ae,Z);Z+=xe>=65536?2:1;let Be=ue.getGraphemeBreakType(xe);for(;Z<Ae;){const Qe=G(H,Ae,Z),rt=ue.getGraphemeBreakType(Qe);if(ve(Be,rt))break;Z+=Qe>=65536?2:1,Be=rt}return Z-Pe}e.nextCharLength=V;function T(H,Z){const ue=Ne.getInstance(),Pe=Z,Ae=x(H,Z);Z-=Ae>=65536?2:1;let xe=ue.getGraphemeBreakType(Ae);for(;Z>0;){const Be=x(H,Z),Qe=ue.getGraphemeBreakType(Be);if(ve(Qe,xe))break;Z-=Be>=65536?2:1,xe=Qe}return Pe-Z}e.prevCharLength=T;function N(H,Z){const ue=Ne.getInstance(),Pe=H.length,Ae=Z,xe=G(H,Pe,Z),Be=ue.getGraphemeBreakType(xe);Z+=xe>=65536?2:1;let Qe=Be;for(;Z<Pe;){const nt=G(H,Pe,Z),Ze=ue.getGraphemeBreakType(nt);if(ve(Qe,Ze))break;Z+=nt>=65536?2:1,Qe=Ze}const rt=Z;for(Z=Ae,Qe=Be;Z>0;){const nt=x(H,Z),Ze=ue.getGraphemeBreakType(nt);if(ve(Ze,Qe))break;Z-=nt>=65536?2:1,Qe=Ze}return[Z,rt]}function F(H,Z){return Z>0&&ee(H.charCodeAt(Z))?N(H,Z-1):N(H,Z)}e.getCharContainingOffset=F;function M(H){const Z=H.length;let ue=0,Pe=0;for(;Pe<Z;){const Be=G(H,Z,Pe);Pe+=Be>=65536?2:1,Be<128?ue+=1:Be<2048?ue+=2:Be<65536?ue+=3:ue+=4}const Ae=new Uint8Array(ue);Pe=0;let xe=0;for(;Pe<Z;){const Be=G(H,Z,Pe);Pe+=Be>=65536?2:1,Be<128?Ae[xe++]=Be:Be<2048?(Ae[xe++]=192|(Be&1984)>>>6,Ae[xe++]=128|(Be&63)>>>0):Be<65536?(Ae[xe++]=224|(Be&61440)>>>12,Ae[xe++]=128|(Be&4032)>>>6,Ae[xe++]=128|(Be&63)>>>0):(Ae[xe++]=240|(Be&1835008)>>>18,Ae[xe++]=128|(Be&258048)>>>12,Ae[xe++]=128|(Be&4032)>>>6,Ae[xe++]=128|(Be&63)>>>0)}return Ae}e.encodeUTF8=M;function U(H){const Z=H.byteLength,ue=[];let Pe=0;for(;Pe<Z;){const Ae=H[Pe];let xe;if(Ae>=240&&Pe+3<Z?xe=(H[Pe++]&7)<<18>>>0|(H[Pe++]&63)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=224&&Pe+2<Z?xe=(H[Pe++]&15)<<12>>>0|(H[Pe++]&63)<<6>>>0|(H[Pe++]&63)<<0>>>0:Ae>=192&&Pe+1<Z?xe=(H[Pe++]&31)<<6>>>0|(H[Pe++]&63)<<0>>>0:xe=H[Pe++],xe>=0&&xe<=55295||xe>=57344&&xe<=65535)ue.push(String.fromCharCode(xe));else if(xe>=65536&&xe<=1114111){const Be=xe-65536,Qe=55296+((Be&1047552)>>>10),rt=56320+((Be&1023)>>>0);ue.push(String.fromCharCode(Qe)),ue.push(String.fromCharCode(rt))}else ue.push(String.fromCharCode(65533))}return ue.join("")}e.decodeUTF8=U;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(H){return B.test(H)}e.containsRTL=K;const ie=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function we(H){return ie.test(H)}e.containsEmoji=we;const Te=/^[\t\n\r\x20-\x7E]*$/;function ye(H){return Te.test(H)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Oe;function je(H){for(let Z=0,ue=H.length;Z<ue;Z++)if(ze(H.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=je;function ze(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=ze;function qe(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=qe;function j(H,Z){if(H.length<Z)return H;const ue=/\b/g;let Pe=0;for(;ue.test(H)&&!(H.length-ue.lastIndex<Z);)Pe=ue.lastIndex,ue.lastIndex+=1;return H.substring(Pe).replace(/^\s/,"")}e.lcut=j;const J=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,oe=/\x1b\[0?m/g;function Y(H){return H&&(H=H.replace(J,""),H=H.replace(ne,""),H=H.replace(oe,"")),H}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function me(H){return le(H)?H.substr(1):H}e.stripUTF8BOM=me;function Re(H,Z){if(!H||!Z||H.length<Z.length)return!1;const ue=Z.length,Pe=H.toLowerCase();let Ae=0,xe=-1;for(;Ae<ue;){const Be=Pe.indexOf(Z[Ae],xe+1);if(Be<0)return!1;xe=Be,Ae++}return!0}e.fuzzyContains=Re;function We(H,Z=!1){return H?(Z&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=We;function be(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=be;function Xe(H,Z=1){if(Z===0)return"";let ue=-1;do ue=H.indexOf(`
`,ue+1),Z--;while(Z>0&&ue>=0);return ue===-1?H:(H[ue-1]==="\r"&&ue--,H.substr(0,ue))}e.getNLines=Xe;function Q(H){const Z=90-65+1;return H=H%(2*Z),H<Z?String.fromCharCode(97+H):String.fromCharCode(65+H-Z)}e.singleLetterHash=Q;function re(H){return Ne.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=re;function ve(H,Z){return H===0?Z!==5&&Z!==7:H===2&&Z===3?!1:H===4||H===2||H===3||Z===4||Z===2||Z===3?!0:!(H===8&&(Z===8||Z===9||Z===11||Z===12)||(H===11||H===9)&&(Z===9||Z===10)||(H===12||H===10)&&Z===10||Z===5||Z===13||Z===7||H===1||H===13&&Z===14||H===6&&Z===6)}e.breakBetweenGraphemeBreakType=ve;var Me;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(Me=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Ye()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ue=this._data,Pe=ue.length/3;let Ae=1;for(;Ae<=Pe;)if(Z<ue[3*Ae])Ae=2*Ae;else if(Z>ue[3*Ae+1])Ae=2*Ae+1;else return ue[3*Ae+2];return 0}}Ne._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(H,Z){if(H===0)return 0;const ue=_e(H,Z);if(ue!==void 0)return ue;const Pe=x(Z,H);return H-=ke(Pe),H}e.getLeftDeleteOffset=Se;function _e(H,Z){let ue=x(Z,H);for(H-=ke(ue);ae(ue)||ue===65039||ue===8419;){if(H===0)return;ue=x(Z,H),H-=ke(ue)}if(!!qe(ue)){if(H>=0){const Pe=x(Z,H);Pe===8205&&(H-=ke(Pe))}return H}}function ke(H){return H>=65536?2:1}function ae(H){return 127995<=H&&H<=127999}var fe;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(fe||(fe={}))}),define(ge[22],pe([0,1,8,91]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let C,D;class P{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return k?new P(Buffer.allocUnsafe(h)):new P(new Uint8Array(h))}static wrap(h){return k&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new P(h)}static fromString(h,b){return!((b==null?void 0:b.dontUseNodeBuffer)||!1)&&k?new P(Buffer.from(h)):S?(C||(C=new TextEncoder),new P(C.encode(h))):new P(v.encodeUTF8(h))}static concat(h,b){if(typeof b=="undefined"){b=0;for(let L=0,O=h.length;L<O;L++)b+=h[L].byteLength}const y=P.alloc(b);let o=0;for(let L=0,O=h.length;L<O;L++){const W=h[L];y.set(W,o),o+=W.byteLength}return y}toString(){return k?this.buffer.toString():A?(D||(D=new TextDecoder),D.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(h,b){return new P(this.buffer.subarray(h,b))}set(h,b){h instanceof P?this.buffer.set(h.buffer,b):this.buffer.set(h,b)}readUInt32BE(h){return l(this.buffer,h)}writeUInt32BE(h,b){g(this.buffer,h,b)}readUInt32LE(h){return c(this.buffer,h)}writeUInt32LE(h,b){m(this.buffer,h,b)}readUInt8(h){return _(this.buffer,h)}writeUInt8(h,b){w(this.buffer,h,b)}}e.VSBuffer=P;function s(p,h){return p[h+0]<<0>>>0|p[h+1]<<8>>>0}e.readUInt16LE=s;function I(p,h,b){p[b+0]=h&255,h=h>>>8,p[b+1]=h&255}e.writeUInt16LE=I;function l(p,h){return p[h]*2**24+p[h+1]*2**16+p[h+2]*2**8+p[h+3]}e.readUInt32BE=l;function g(p,h,b){p[b+3]=h,h=h>>>8,p[b+2]=h,h=h>>>8,p[b+1]=h,h=h>>>8,p[b]=h}e.writeUInt32BE=g;function c(p,h){return p[h+0]<<0>>>0|p[h+1]<<8>>>0|p[h+2]<<16>>>0|p[h+3]<<24>>>0}e.readUInt32LE=c;function m(p,h,b){p[b+0]=h&255,h=h>>>8,p[b+1]=h&255,h=h>>>8,p[b+2]=h&255,h=h>>>8,p[b+3]=h&255}e.writeUInt32LE=m;function _(p,h){return p[h]}e.readUInt8=_;function w(p,h,b){p[b]=h}e.writeUInt8=w;function E(p){return R.consumeReadable(p,h=>P.concat(h))}e.readableToBuffer=E;function u(p){return R.toReadable(p)}e.bufferToReadable=u;function d(p){return R.consumeStream(p,h=>P.concat(h))}e.streamToBuffer=d;async function f(p){return p.ended?P.concat(p.buffer):P.concat([...p.buffer,await d(p.stream)])}e.bufferedStreamToBuffer=f;function t(p){return R.toStream(p,h=>P.concat(h))}e.bufferToStream=t;function r(p){return R.transform(p,{data:h=>typeof h=="string"?P.fromString(h):P.wrap(h)},h=>P.concat(h))}e.streamToBufferReadableStream=r;function n(p){return R.newWriteableStream(h=>P.concat(h),p)}e.newWriteableBufferStream=n;function i(p,h){return R.prefixedReadable(p,h,b=>P.concat(b))}e.prefixedBufferReadable=i;function a(p,h){return R.prefixedStream(p,h,b=>P.concat(b))}e.prefixedBufferStream=a}),define(ge[74],pe([0,1,8]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(w){return k(w,0)}e.hash=R;function k(w,E){switch(typeof w){case"object":return w===null?S(349,E):Array.isArray(w)?D(w,E):P(w,E);case"string":return C(w,E);case"boolean":return A(w,E);case"number":return S(w,E);case"undefined":return S(937,E);default:return S(617,E)}}e.doHash=k;function S(w,E){return(E<<5)-E+w|0}function A(w,E){return S(w?433:863,E)}function C(w,E){E=S(149417,E);for(let u=0,d=w.length;u<d;u++)E=S(w.charCodeAt(u),E);return E}e.stringHash=C;function D(w,E){return E=S(104579,E),w.reduce((u,d)=>k(d,u),E)}function P(w,E){return E=S(181387,E),Object.keys(w).sort().reduce((u,d)=>(u=C(d,u),k(w[d],u)),E)}class s{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=k(E,this._value),this._value}}e.Hasher=s;var I;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function l(w,E,u=32){const d=u-E,f=~((1<<d)-1);return(w<<E|(f&w)>>>d)>>>0}function g(w,E=0,u=w.byteLength,d=0){for(let f=0;f<u;f++)w[E+f]=d}function c(w,E,u="0"){for(;w.length<E;)w=u+w;return w}function m(w,E=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((w>>>0).toString(16),E/4)}e.toHexString=m;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const u=E.length;if(u===0)return;const d=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,r,n;for(t!==0?(r=t,n=-1,t=0):(r=E.charCodeAt(0),n=0);;){let i=r;if(v.isHighSurrogate(r))if(n+1<u){const a=E.charCodeAt(n+1);v.isLowSurrogate(a)?(n++,i=v.computeCodePoint(r,a)):i=65533}else{t=r;break}else v.isLowSurrogate(r)&&(i=65533);if(f=this._push(d,f,i),n++,n<u)r=E.charCodeAt(n);else break}this._buffLen=f,this._leftoverHighSurrogate=t}_push(E,u,d){return d<128?E[u++]=d:d<2048?(E[u++]=192|(d&1984)>>>6,E[u++]=128|(d&63)>>>0):d<65536?(E[u++]=224|(d&61440)>>>12,E[u++]=128|(d&4032)>>>6,E[u++]=128|(d&63)>>>0):(E[u++]=240|(d&1835008)>>>18,E[u++]=128|(d&258048)>>>12,E[u++]=128|(d&4032)>>>6,E[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=_._bigBlock32,u=this._buffDV;for(let h=0;h<64;h+=4)E.setUint32(h,u.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)E.setUint32(h,l(E.getUint32(h-12,!1)^E.getUint32(h-32,!1)^E.getUint32(h-56,!1)^E.getUint32(h-64,!1),1),!1);let d=this._h0,f=this._h1,t=this._h2,r=this._h3,n=this._h4,i,a,p;for(let h=0;h<80;h++)h<20?(i=f&t|~f&r,a=1518500249):h<40?(i=f^t^r,a=1859775393):h<60?(i=f&t|f&r|t&r,a=2400959708):(i=f^t^r,a=3395469782),p=l(d,5)+i+n+a+E.getUint32(h*4,!1)&4294967295,n=r,r=t,t=l(f,30),f=d,d=p;this._h0=this._h0+d&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ge[52],pe([0,1,8]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(R||(R={})),function(k){const S="error",A="warning",C="warn",D="info",P="ignore";function s(l){return l?v.equalsIgnoreCase(S,l)?k.Error:v.equalsIgnoreCase(A,l)||v.equalsIgnoreCase(C,l)?k.Warning:v.equalsIgnoreCase(D,l)?k.Info:k.Ignore:k.Ignore}k.fromValue=s;function I(l){switch(l){case k.Error:return S;case k.Warning:return A;case k.Info:return D;default:return P}}k.toString=I}(R||(R={})),e.default=R}),define(ge[13],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(h){return Array.isArray(h)}e.isArray=v;function R(h){return typeof h=="string"}e.isString=R;function k(h){return Array.isArray(h)&&h.every(b=>R(b))}e.isStringArray=k;function S(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=S;function A(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=A;function C(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=C;function D(h){return h===!0||h===!1}e.isBoolean=D;function P(h){return typeof h=="undefined"}e.isUndefined=P;function s(h){return!I(h)}e.isDefined=s;function I(h){return P(h)||h===null}e.isUndefinedOrNull=I;function l(h,b){if(!h)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=l;function g(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=g;function c(...h){const b=[];for(let y=0;y<h.length;y++){const o=h[y];if(I(o))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);b.push(o)}return b}e.assertAllDefined=c;const m=Object.prototype.hasOwnProperty;function _(h){if(!S(h))return!1;for(let b in h)if(m.call(h,b))return!1;return!0}e.isEmptyObject=_;function w(h){return typeof h=="function"}e.isFunction=w;function E(...h){return h.length>0&&h.every(w)}e.areFunctions=E;function u(h,b){const y=Math.min(h.length,b.length);for(let o=0;o<y;o++)d(h[o],b[o])}e.validateConstraints=u;function d(h,b){if(R(b)){if(typeof h!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(w(b)){try{if(h instanceof b)return}catch(y){}if(!I(h)&&h.constructor===b||b.length===1&&b.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function f(h){let b=[],y=Object.getPrototypeOf(h);for(;Object.prototype!==y;)b=b.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return b}e.getAllPropertyNames=f;function t(h){const b=[];for(const y of f(h))typeof h[y]=="function"&&b.push(y);return b}e.getAllMethodNames=t;function r(h,b){const y=L=>function(){const O=Array.prototype.slice.call(arguments,0);return b(L,O)};let o={};for(const L of h)o[L]=y(L);return o}e.createProxyObject=r;function n(h){return h===null?void 0:h}e.withNullAsUndefined=n;function i(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=i;function a(h){return class{constructor(){return new Proxy({},{get(b,y){if(b[y])return b[y];throw new Error(`Not Implemented: ${h}->${String(y)}`)}})}}}e.NotImplementedProxy=a;function p(h){throw new Error("Unreachable")}e.assertNever=p}),define(ge[29],pe([0,1,11,8,9,13]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(n){return n===47||n===92}e.isPathSeparator=A;function C(n){return n.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=C;function D(n){return n.indexOf("/")===-1&&(n=C(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=D;function P(n,i=k.posix.sep){if(!n)return"";const a=n.length,p=n.charCodeAt(0);if(A(p)){if(A(n.charCodeAt(1))&&!A(n.charCodeAt(2))){let b=3;const y=b;for(;b<a&&!A(n.charCodeAt(b));b++);if(y!==b&&!A(n.charCodeAt(b+1))){for(b+=1;b<a;b++)if(A(n.charCodeAt(b)))return n.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(w(p)&&n.charCodeAt(1)===58)return A(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<a;h++)if(A(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=P;function s(n){if(!v.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let a=2;const p=a;for(;a<n.length&&(i=n.charCodeAt(a),i!==92);a++);return!(p===a||(i=n.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=s;const I=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(n,i=v.isWindows){const a=i?I:l;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||i&&g.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=c;function m(n,i,a){const p=n===i;return!a||p?p:!n||!i?!1:R.equalsIgnoreCase(n,i)}e.isEqual=m;function _(n,i,a,p=k.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(a){if(!R.startsWithIgnoreCase(n,i))return!1;if(i.length===n.length)return!0;let b=i.length;return i.charAt(i.length-1)===p&&b--,n.charAt(b)===p}return i.charAt(i.length-1)!==p&&(i+=p),n.indexOf(i)===0}e.isEqualOrParent=_;function w(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=w;function E(n,i){return v.isWindows&&n.endsWith(":")&&(n+=k.sep),k.isAbsolute(n)||(n=k.join(i,n)),n=k.normalize(n),v.isWindows?(n=R.rtrim(n,k.sep),n.endsWith(":")&&(n+=k.sep)):(n=R.rtrim(n,k.sep),n||(n=k.sep)),n}e.sanitizeFilePath=E;function u(n){const i=k.normalize(n);return v.isWindows?n.length>3?!1:d(i)&&(n.length===2||i.charCodeAt(2)===92):i===k.posix.sep}e.isRootOrDriveLetter=u;function d(n){return v.isWindows?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function f(n){return d(n)?n[0]:void 0}e.getDriveLetter=f;function t(n,i,a){return i.length>n.length?-1:n===i?0:(a&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=t;function r(n){const i=n.split(":");let a,p,h;if(i.forEach(b=>{const y=Number(b);S.isNumber(y)?p===void 0?p=y:h===void 0&&(h=y):a=a?[a,b].join(":"):b}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:p!==void 0?p:void 0,column:h!==void 0?h:p!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(ge[25],pe([0,1,13]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const _=Array.isArray(m)?[]:{};return Object.keys(m).forEach(w=>{m[w]&&typeof m[w]=="object"?_[w]=R(m[w]):_[w]=m[w]}),_}e.deepClone=R;function k(m){if(!m||typeof m!="object")return m;const _=[m];for(;_.length>0;){const w=_.shift();Object.freeze(w);for(const E in w)if(S.call(w,E)){const u=w[E];typeof u=="object"&&!Object.isFrozen(u)&&_.push(u)}}return m}e.deepFreeze=k;const S=Object.prototype.hasOwnProperty;function A(m,_){return C(m,_,new Set)}e.cloneAndChange=A;function C(m,_,w){if(v.isUndefinedOrNull(m))return m;const E=_(m);if(typeof E!="undefined")return E;if(v.isArray(m)){const u=[];for(const d of m)u.push(C(d,_,w));return u}if(v.isObject(m)){if(w.has(m))throw new Error("Cannot clone recursive data-structure");w.add(m);const u={};for(let d in m)S.call(m,d)&&(u[d]=C(m[d],_,w));return w.delete(m),u}return m}function D(m,_,w=!0){return v.isObject(m)?(v.isObject(_)&&Object.keys(_).forEach(E=>{E in m?w&&(v.isObject(m[E])&&v.isObject(_[E])?D(m[E],_[E],w):m[E]=_[E]):m[E]=_[E]}),m):_}e.mixin=D;function P(m,_){if(m===_)return!0;if(m==null||_===null||_===void 0||typeof m!=typeof _||typeof m!="object"||Array.isArray(m)!==Array.isArray(_))return!1;let w,E;if(Array.isArray(m)){if(m.length!==_.length)return!1;for(w=0;w<m.length;w++)if(!P(m[w],_[w]))return!1}else{const u=[];for(E in m)u.push(E);u.sort();const d=[];for(E in _)d.push(E);if(d.sort(),!P(u,d))return!1;for(w=0;w<u.length;w++)if(!P(m[u[w]],_[u[w]]))return!1}return!0}e.equals=P;function s(m){const _=new Set;return JSON.stringify(m,(w,E)=>{if(v.isObject(E)||Array.isArray(E)){if(_.has(E))return"[Circular]";_.add(E)}return E})}e.safeStringify=s;function I(m,_,w){const E=_(m);return typeof E=="undefined"?w:E}e.getOrDefault=I;function l(m,_){const w=Object.create(null);return!m||!_||Object.keys(_).forEach(u=>{const d=m[u],f=_[u];P(d,f)||(w[u]=f)}),w}e.distinct=l;function g(m,_){const w=_.toLowerCase(),E=Object.keys(m).find(u=>u.toLowerCase()===w);return E?m[E]:m[_]}e.getCaseInsensitive=g;function c(m,_){const w=Object.create(null);for(const E of Object.keys(m))_(E,m[E])&&(w[E]=m[E]);return w}e.filter=c}),define(ge[92],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var v;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(v=e.Constants||(e.Constants={}));function R(S){return S<0?0:S>255?255:S|0}e.toUint8=R;function k(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=k}),define(ge[2],pe([0,1,11,9]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,S=/^\//,A=/^\/\//;function C(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!S.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(n,i){return!n&&!i?"file":n}function P(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const s="",I="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(i,a,p,h,b,y=!1){typeof i=="object"?(this.scheme=i.scheme||s,this.authority=i.authority||s,this.path=i.path||s,this.query=i.query||s,this.fragment=i.fragment||s):(this.scheme=D(i,y),this.authority=a||s,this.path=P(this.scheme,p||s),this.query=h||s,this.fragment=b||s,C(this,y))}static isUri(i){return i instanceof g?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:p,path:h,query:b,fragment:y}=i;return a===void 0?a=this.scheme:a===null&&(a=s),p===void 0?p=this.authority:p===null&&(p=s),h===void 0?h=this.path:h===null&&(h=s),b===void 0?b=this.query:b===null&&(b=s),y===void 0?y=this.fragment:y===null&&(y=s),a===this.scheme&&p===this.authority&&h===this.path&&b===this.query&&y===this.fragment?this:new m(a,p,h,b,y)}static parse(i,a=!1){const p=l.exec(i);return p?new m(p[2]||s,r(p[4]||s),r(p[5]||s),r(p[7]||s),r(p[9]||s),a):new m(s,s,s,s,s)}static file(i){let a=s;if(v.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const p=i.indexOf(I,2);p===-1?(a=i.substring(2),i=I):(a=i.substring(2,p),i=i.substring(p)||I)}return new m("file",a,i,s,s)}static from(i){const a=new m(i.scheme,i.authority,i.path,i.query,i.fragment);return C(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return v.isWindows&&i.scheme==="file"?p=g.file(R.win32.join(u(i,!0),...a)).path:p=R.posix.join(i.path,...a),i.with({path:p})}toString(i=!1){return d(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof g)return i;{const a=new m(i);return a._formatted=i.external,a._fsPath=i._sep===c?i.fsPath:null,a}}else return i}}e.URI=g;const c=v.isWindows?1:void 0;class m extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(n,i){let a,p=-1;for(let h=0;h<n.length;h++){const b=n.charCodeAt(h);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||i&&b===47)p!==-1&&(a+=encodeURIComponent(n.substring(p,h)),p=-1),a!==void 0&&(a+=n.charAt(h));else{a===void 0&&(a=n.substr(0,h));const y=_[b];y!==void 0?(p!==-1&&(a+=encodeURIComponent(n.substring(p,h)),p=-1),a+=y):p===-1&&(p=h)}}return p!==-1&&(a+=encodeURIComponent(n.substring(p))),a!==void 0?a:n}function E(n){let i;for(let a=0;a<n.length;a++){const p=n.charCodeAt(a);p===35||p===63?(i===void 0&&(i=n.substr(0,a)),i+=_[p]):i!==void 0&&(i+=n[a])}return i!==void 0?i:n}function u(n,i){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,v.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function d(n,i){const a=i?E:w;let p="",{scheme:h,authority:b,path:y,query:o,fragment:L}=n;if(h&&(p+=h,p+=":"),(b||h==="file")&&(p+=I,p+=I),b){let O=b.indexOf("@");if(O!==-1){const W=b.substr(0,O);b=b.substr(O+1),O=W.indexOf(":"),O===-1?p+=a(W,!1):(p+=a(W.substr(0,O),!1),p+=":",p+=a(W.substr(O+1),!1)),p+="@"}b=b.toLowerCase(),O=b.indexOf(":"),O===-1?p+=a(b,!1):(p+=a(b.substr(0,O),!1),p+=b.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}p+=a(y,!0)}return o&&(p+="?",p+=a(o,!1)),L&&(p+="#",p+=i?L:w(L,!1)),p}function f(n){try{return decodeURIComponent(n)}catch(i){return n.length>3?n.substr(0,3)+f(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,i=>f(i)):n}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[23],pe([0,1,2,8]),function(X,e,v,R){"use strict";var k,S,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,r,n){let i=t.get(r);return i===void 0&&(i=n,t.set(r,i)),i}e.getOrSet=C;function D(t){const r=[];return t.forEach((n,i)=>{r.push(`${i} => ${n}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=D;function P(t){const r=[];return t.forEach(n=>{r.push(n)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=P;class s{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return n-i}value(){return this._value[this._pos]}}e.StringIterator=s;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class l{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?R.compareSubstring(r,this._value,0,r.length,this._from,this._to):R.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return R.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class _{constructor(r){this._iter=r}static forUris(r=()=>!1){return new _(new c(r))}static forPaths(){return new _(new l)}static forStrings(){return new _(new s)}static forConfigKeys(){return new _(new I)}clear(){this._root=void 0}set(r,n){const i=this._iter.reset(r);let a;for(this._root||(this._root=new m,this._root.segment=i.value()),a=this._root;;){const h=i.cmp(a.segment);if(h>0)a.left||(a.left=new m,a.left.segment=i.value()),a=a.left;else if(h<0)a.right||(a.right=new m,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new m,a.mid.segment=i.value()),a=a.mid;else break}const p=a.value;return a.value=n,a.key=r,p}get(r){var n;return(n=this._getNode(r))===null||n===void 0?void 0:n.value}_getNode(r){const n=this._iter.reset(r);let i=this._root;for(;i;){const a=n.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(n.hasNext())n.next(),i=i.mid;else break}return i}has(r){const n=this._getNode(r);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const i=this._iter.reset(r),a=[];let p=this._root;for(;p;){const h=i.cmp(p.segment);if(h>0)a.push([1,p]),p=p.left;else if(h<0)a.push([-1,p]),p=p.right;else if(i.hasNext())i.next(),a.push([0,p]),p=p.mid;else{for(n?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;a.length>0&&p.isEmpty();){let[b,y]=a.pop();switch(b){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}p=y}break}}}findSubstr(r){const n=this._iter.reset(r);let i=this._root,a;for(;i;){const p=n.cmp(i.segment);if(p>0)i=i.left;else if(p<0)i=i.right;else if(n.hasNext())n.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(r){const n=this._iter.reset(r);let i=this._root;for(;i;){const a=n.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(n.hasNext())n.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[n,i]of this)r(i,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r,n=0){if(n>5e3){console.log("potential CYCLE detected",new Error().stack);return}r&&(yield*this._entries(r.left,n++),r.value&&(yield[r.key,r.value]),yield*this._entries(r.mid,n++),yield*this._entries(r.right,n++))}}e.TernarySearchTree=_;class w{constructor(r,n){this[k]="ResourceMap",r instanceof w?(this.map=new Map(r.map),this.toKey=n??w.defaultToKey):(this.map=new Map,this.toKey=r??w.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),n),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n!="undefined"&&(r=r.bind(n));for(let[i,a]of this.map)r(a,v.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,n=0){const i=this._map.get(r);if(!!i)return n!==0&&this.touch(i,n),i.value}set(r,n,i=0){let a=this._map.get(r);if(a)a.value=n,i!==0&&this.touch(a,i);else{switch(a={key:r,value:n,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(r,a),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const i=this._state;let a=this._head;for(;a;){if(n?r.bind(n)(a.value,a.key,this):r(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const r=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.key,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}values(){const r=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:i.value,done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}entries(){const r=this,n=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(i){const p={value:[i.key,i.value],done:!1};return i=i.next,p}else return{value:void 0,done:!0}}};return a}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,i=this.size;for(;n&&i>r;)this._map.delete(n.key),n=n.next,i--;this._head=n,this._size=i,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,i=r.previous;if(!n||!i)throw new Error("Invalid list");n.previous=i,i.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const i=r.next,a=r.previous;r===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const i=r.next,a=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,i)=>{r.push([i,n])}),r}fromJSON(r){this.clear();for(const[n,i]of r)this.set(n,i)}}e.LinkedMap=u;class d extends u{constructor(r,n=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class f{constructor(r){A.set(this,void 0),tt(this,A,r,"f")}get size(){return $e(this,A,"f").size}forEach(r,n){$e(this,A,"f").forEach(r,n)}get(r){return $e(this,A,"f").get(r)}has(r){return $e(this,A,"f").has(r)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=f}),define(ge[93],pe([0,1,23,8]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function k(...Y){return function(le,me){for(let Re=0,We=Y.length;Re<We;Re++){const be=Y[Re](le,me);if(be)return be}return null}}e.or=k,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Y,le,me){if(!me||me.length<le.length)return null;let Re;return Y?Re=R.startsWithIgnoreCase(me,le):Re=me.indexOf(le)===0,Re?le.length>0?[{start:0,end:le.length}]:[]:null}function A(Y,le){const me=le.toLowerCase().indexOf(Y.toLowerCase());return me===-1?null:[{start:me,end:me+Y.length}]}e.matchesContiguousSubString=A;function C(Y,le){return D(Y.toLowerCase(),le.toLowerCase(),0,0)}e.matchesSubString=C;function D(Y,le,me,Re){if(me===Y.length)return[];if(Re===le.length)return null;if(Y[me]===le[Re]){let We=null;return(We=D(Y,le,me+1,Re+1))?w({start:Re,end:Re+1},We):null}return D(Y,le,me,Re+1)}function P(Y){return 97<=Y&&Y<=122}function s(Y){return 65<=Y&&Y<=90}e.isUpper=s;function I(Y){return 48<=Y&&Y<=57}function l(Y){return Y===32||Y===9||Y===10||Y===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(Y=>g.add(Y.charCodeAt(0)));function c(Y){return l(Y)||g.has(Y)}function m(Y,le){return Y===le||c(Y)&&c(le)}function _(Y){return P(Y)||s(Y)||I(Y)}function w(Y,le){return le.length===0?le=[Y]:Y.end===le[0].start?le[0].start=Y.start:le.unshift(Y),le}function E(Y,le){for(let me=le;me<Y.length;me++){const Re=Y.charCodeAt(me);if(s(Re)||I(Re)||me>0&&!_(Y.charCodeAt(me-1)))return me}return Y.length}function u(Y,le,me,Re){if(me===Y.length)return[];if(Re===le.length)return null;if(Y[me]!==le[Re].toLowerCase())return null;{let We=null,be=Re+1;for(We=u(Y,le,me+1,Re+1);!We&&(be=E(le,be))<le.length;)We=u(Y,le,me+1,be),be++;return We===null?null:w({start:Re,end:Re+1},We)}}function d(Y){let le=0,me=0,Re=0,We=0,be=0;for(let Me=0;Me<Y.length;Me++)be=Y.charCodeAt(Me),s(be)&&le++,P(be)&&me++,_(be)&&Re++,I(be)&&We++;const Xe=le/Y.length,Q=me/Y.length,re=Re/Y.length,ve=We/Y.length;return{upperPercent:Xe,lowerPercent:Q,alphaPercent:re,numericPercent:ve}}function f(Y){const{upperPercent:le,lowerPercent:me}=Y;return me===0&&le>.6}function t(Y){const{upperPercent:le,lowerPercent:me,alphaPercent:Re,numericPercent:We}=Y;return me>.2&&le<.8&&Re>.6&&We<.2}function r(Y){let le=0,me=0,Re=0,We=0;for(let be=0;be<Y.length;be++)Re=Y.charCodeAt(be),s(Re)&&le++,P(Re)&&me++,l(Re)&&We++;return(le===0||me===0)&&We===0?Y.length<=30:le<=5}function n(Y,le){if(!le||(le=le.trim(),le.length===0)||!r(Y)||le.length>60)return null;const me=d(le);if(!t(me)){if(!f(me))return null;le=le.toLowerCase()}let Re=null,We=0;for(Y=Y.toLowerCase();We<le.length&&(Re=u(Y,le,0,We))===null;)We=E(le,We+1);return Re}e.matchesCamelCase=n;function i(Y,le,me=!1){if(!le||le.length===0)return null;let Re=null,We=0;for(Y=Y.toLowerCase(),le=le.toLowerCase();We<le.length&&(Re=a(Y,le,0,We,me))===null;)We=p(le,We+1);return Re}e.matchesWords=i;function a(Y,le,me,Re,We){if(me===Y.length)return[];if(Re===le.length)return null;if(m(Y.charCodeAt(me),le.charCodeAt(Re))){let be=null,Xe=Re+1;if(be=a(Y,le,me+1,Re+1,We),!We)for(;!be&&(Xe=p(le,Xe))<le.length;)be=a(Y,le,me+1,Xe,We),Xe++;return be===null?null:w({start:Re,end:Re+1},be)}else return null}function p(Y,le){for(let me=le;me<Y.length;me++)if(c(Y.charCodeAt(me))||me>0&&c(Y.charCodeAt(me-1)))return me;return Y.length}const h=k(e.matchesPrefix,n,A),b=k(e.matchesPrefix,n,C),y=new v.LRUCache(1e4);function o(Y,le,me=!1){if(typeof Y!="string"||typeof le!="string")return null;let Re=y.get(Y);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(Y),"i"),y.set(Y,Re));const We=Re.exec(le);return We?[{start:We.index,end:We.index+We[0].length}]:me?b(Y,le):h(Y,le)}e.matchesFuzzy=o;function L(Y,le){const me=je(Y,Y.toLowerCase(),0,le,le.toLowerCase(),0,!0);return me?W(me):null}e.matchesFuzzy2=L;function O(Y,le,me,Re,We,be){const Xe=Math.min(13,Y.length);for(;me<Xe;me++){const Q=je(Y,le,me,Re,We,be,!1);if(Q)return Q}return[0,be]}e.anyScore=O;function W(Y){if(typeof Y=="undefined")return[];const le=[],me=Y[1];for(let Re=Y.length-1;Re>1;Re--){const We=Y[Re]+me,be=le[le.length-1];be&&be.end===We?be.end=We+1:le.push({start:We,end:We+1})}return le}e.createMatches=W;const ee=128;function ce(){const Y=[],le=[];for(let me=0;me<=ee;me++)le[me]=0;for(let me=0;me<=ee;me++)Y.push(le.slice(0));return Y}function G(Y){const le=[];for(let me=0;me<=Y;me++)le[me]=0;return le}const x=G(2*ee),V=G(2*ee),T=ce(),N=ce(),F=ce(),M=!1;function U(Y,le,me,Re,We){function be(Q,re,ve=" "){for(;Q.length<re;)Q=ve+Q;return Q}let Xe=` |   |${Re.split("").map(Q=>be(Q,3)).join("|")}
`;for(let Q=0;Q<=me;Q++)Q===0?Xe+=" |":Xe+=`${le[Q-1]}|`,Xe+=Y[Q].slice(0,We+1).map(re=>be(re.toString(),3)).join("|")+`
`;return Xe}function B(Y,le,me,Re){Y=Y.substr(le),me=me.substr(Re),console.log(U(N,Y,Y.length,me,me.length)),console.log(U(F,Y,Y.length,me,me.length)),console.log(U(T,Y,Y.length,me,me.length))}function K(Y,le){if(le<0||le>=Y.length)return!1;const me=Y.codePointAt(le);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(me)}}function ie(Y,le){if(le<0||le>=Y.length)return!1;switch(Y.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function we(Y,le,me){return le[Y]!==me[Y]}function Te(Y,le,me,Re,We,be,Xe=!1){for(;le<me&&We<be;)Y[le]===Re[We]&&(Xe&&(x[le]=We),le+=1),We+=1;return le===me}e.isPatternInWord=Te;var ye;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Oe;(function(Y){Y.Default=[-100,0];function le(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}Y.isDefault=le})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function je(Y,le,me,Re,We,be,Xe){const Q=Y.length>ee?ee:Y.length,re=Re.length>ee?ee:Re.length;if(me>=Q||be>=re||Q-me>re-be||!Te(le,me,Q,We,be,re,!0))return;ze(Q,re,me,be,le,We);let ve=1,Me=1,Ne=me,Ye=be;const Se=[!1];for(ve=1,Ne=me;Ne<Q;ve++,Ne++){const H=x[Ne],Z=V[Ne],ue=Ne+1<Q?V[Ne+1]:re;for(Me=H-be+1,Ye=H;Ye<ue;Me++,Ye++){let Pe=Number.MIN_SAFE_INTEGER,Ae=!1;Ye<=Z&&(Pe=qe(Y,le,Ne,me,Re,We,Ye,re,be,T[ve-1][Me-1]===0,Se));let xe=0;Pe!==Number.MAX_SAFE_INTEGER&&(Ae=!0,xe=Pe+N[ve-1][Me-1]);const Be=Ye>H,Qe=Be?N[ve][Me-1]+(T[ve][Me-1]>0?-5:0):0,rt=Ye>H+1&&T[ve][Me-1]>0,nt=rt?N[ve][Me-2]+(T[ve][Me-2]>0?-5:0):0;if(rt&&(!Be||nt>=Qe)&&(!Ae||nt>=xe))N[ve][Me]=nt,F[ve][Me]=3,T[ve][Me]=0;else if(Be&&(!Ae||Qe>=xe))N[ve][Me]=Qe,F[ve][Me]=2,T[ve][Me]=0;else if(Ae)N[ve][Me]=xe,F[ve][Me]=1,T[ve][Me]=T[ve-1][Me-1]+1;else throw new Error("not possible")}}if(M&&B(Y,me,Re,be),!Se[0]&&!Xe)return;ve--,Me--;const _e=[N[ve][Me],be];let ke=0,ae=0;for(;ve>=1;){let H=Me;do{const Z=F[ve][H];if(Z===3)H=H-2;else if(Z===2)H=H-1;else break}while(H>=1);ke>1&&le[me+ve-1]===We[be+Me-1]&&!we(H+be-1,Re,We)&&ke+1>T[ve][H]&&(H=Me),H===Me?ke++:ke=1,ae||(ae=H),ve--,Me=H-1,_e.push(Me)}re===Q&&(_e[0]+=2);const fe=ae-Q;return _e[0]-=fe,_e}e.fuzzyScore=je;function ze(Y,le,me,Re,We,be){let Xe=Y-1,Q=le-1;for(;Xe>=me&&Q>=Re;)We[Xe]===be[Q]&&(V[Xe]=Q,Xe--),Q--}function qe(Y,le,me,Re,We,be,Xe,Q,re,ve,Me){if(le[me]!==be[Xe])return Number.MIN_SAFE_INTEGER;let Ne=1,Ye=!1;return Xe===me-Re?Ne=Y[me]===We[Xe]?7:5:we(Xe,We,be)&&(Xe===0||!we(Xe-1,We,be))?(Ne=Y[me]===We[Xe]?7:5,Ye=!0):K(be,Xe)&&(Xe===0||!K(be,Xe-1))?Ne=5:(K(be,Xe-1)||ie(be,Xe-1))&&(Ne=5,Ye=!0),Ne>1&&me===Re&&(Me[0]=!0),Ye||(Ye=we(Xe,We,be)||K(be,Xe-1)||ie(be,Xe-1)),me===Re?Xe>re&&(Ne-=Ye?3:5):ve?Ne+=Ye?2:0:Ne+=Ye?0:1,Xe+1===Q&&(Ne-=Ye?3:5),Ne}function j(Y,le,me,Re,We,be,Xe){return ne(Y,le,me,Re,We,be,!0,Xe)}e.fuzzyScoreGracefulAggressive=j;function J(Y,le,me,Re,We,be,Xe){return ne(Y,le,me,Re,We,be,!1,Xe)}e.fuzzyScoreGraceful=J;function ne(Y,le,me,Re,We,be,Xe,Q){let re=je(Y,le,me,Re,We,be,Q);if(re&&!Xe)return re;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let Me=me+1;Me<ve;Me++){const Ne=oe(Y,Me);if(Ne){const Ye=je(Ne,Ne.toLowerCase(),me,Re,We,be,Q);Ye&&(Ye[0]-=3,(!re||Ye[0]>re[0])&&(re=Ye))}}}return re}function oe(Y,le){if(le+1>=Y.length)return;const me=Y[le],Re=Y[le+1];if(me!==Re)return Y.slice(0,le)+Re+me+Y.slice(le+2)}}),define(ge[135],pe([0,1,90,93,8]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function C(m){return m.replace(A,(_,w)=>w?_:`\\${_}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${S.source}`,"g");function P(m){return m.replace(D,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=P;const s=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function I(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(s,(_,w,E,u)=>E?_:w||u||"")}e.stripIcons=I;function l(m){const _=m.indexOf(e.iconStartMarker);return _===-1?{text:m}:g(m,_)}e.parseLabelWithIcons=l;function g(m,_){const w=[];let E="";function u(p){if(p){E+=p;for(const h of p)w.push(t)}}let d=-1,f="",t=0,r,n,i=_;const a=m.length;for(u(m.substr(0,_));i<a;)r=m[i],n=m[i+1],r===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(d=i,u(f),f=e.iconStartMarker,i++):r===")"&&d!==-1?(t+=i-d+1,d=-1,f=""):d!==-1?/^[a-z0-9\-]$/i.test(r)?f+=r:(u(f),d=-1,f=""):u(r),i++;return u(f),{text:E,iconOffsets:w}}function c(m,_,w=!1){const{text:E,iconOffsets:u}=_;if(!u||u.length===0)return R.matchesFuzzy(m,E,w);const d=k.ltrim(E," "),f=E.length-d.length,t=R.matchesFuzzy(m,d,w);if(t)for(const r of t){const n=u[r.start+f]+f;r.start+=n,r.end+=n}return t}e.matchesFuzzyIconAware=c}),define(ge[94],pe([0,1,135,16]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var k;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(k=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(g="",c=!1){var m,_;if(this.value=g,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(m=c.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(_=c.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(g,c=0){return this.value+=P(this.supportThemeIcons?v.escapeIcons(g):g).replace(/([ \t]+)/g,(m,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(g){return this.value+=g,this}appendCodeblock(g,c){return this.value+="\n```",this.value+=g,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=S;function A(l){return C(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function C(l){return l instanceof S?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=C;function D(l,g){return l===g?!0:!l||!g?!1:l.value===g.value&&l.isTrusted===g.isTrusted&&l.supportThemeIcons===g.supportThemeIcons}e.markdownStringEqual=D;function P(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function s(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=s;function I(l){const g=[],c=l.split("|").map(_=>_.trim());l=c[0];const m=c[1];if(m){const _=/height=(\d+)/.exec(m),w=/width=(\d+)/.exec(m),E=_?_[1]:"",u=w?w[1]:"",d=isFinite(parseInt(u)),f=isFinite(parseInt(E));d&&g.push(`width="${u}"`),f&&g.push(`height="${E}"`)}return{href:l,dimensions:g}}e.parseHrefAndDimensions=I}),define(ge[53],pe([0,1,22,8,2]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(P){return JSON.stringify(P,C)}e.stringify=S;function A(P){let s=JSON.parse(P);return s=D(s),s}e.parse=A;function C(P,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:R.regExpFlags(s)}:s}function D(P,s=0){if(!P||s>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return k.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof v.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let I=0;I<P.length;++I)P[I]=D(P[I],s+1);else for(const I in P)Object.hasOwnProperty.call(P,I)&&(P[I]=D(P[I],s+1))}return P}e.revive=D}),define(ge[10],pe([0,1,2,11]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(k=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,s){this._hosts[D]=P,this._ports[D]=s}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let s=this._hosts[P];s&&s.indexOf(":")!==-1&&(s=`[${s}]`);const I=this._ports[P],l=this._connectionTokens[P];let g=`path=${encodeURIComponent(D.path)}`;return typeof l=="string"&&(g+=`&tkn=${encodeURIComponent(l)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${s}:${I}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new S;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,s){const I=this.toUri(D,P);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):R.isNative&&(s||R.isPreferringBrowserCodeLoad)&&I.scheme===k.file?I.with({scheme:k.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,P){const s=this.toUri(D,P);return s.scheme===k.vscodeFileResource?s.with({scheme:k.file,authority:s.authority!==this.FALLBACK_AUTHORITY?s.authority:null,query:null,fragment:null}):s}toUri(D,P){return v.URI.isUri(D)?D:v.URI.parse(P.toUrl(D))}}e.FileAccess=new A}),define(ge[75],pe([0,1,23]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function k(P){return D(P,"NFC",R)}e.normalizeNFC=k;const S=new v.LRUCache(1e4);function A(P){return D(P,"NFD",S)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function D(P,s,I){if(!e.canNormalize||!P)return P;const l=I.get(P);if(l)return l;let g;return C.test(P)?g=P.normalize(s):g=P,I.set(P,g),g}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(s){return A(s).replace(P,"")}}else return function(P){return P}}()}),define(ge[24],pe([0,1,29,9,2,8,10,11]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return k.uriToFsPath(g,!0)}e.originalFSPath=D;class P{constructor(c){this._ignorePathCasing=c}compare(c,m,_=!1){return c===m?0:S.compare(this.getComparisonKey(c,_),this.getComparisonKey(m,_))}isEqual(c,m,_=!1){return c===m?!0:!c||!m?!1:this.getComparisonKey(c,_)===this.getComparisonKey(m,_)}getComparisonKey(c,m=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,m,_=!1){if(c.scheme===m.scheme){if(c.scheme===A.Schemas.file)return v.isEqualOrParent(D(c),D(m),this._ignorePathCasing(c))&&c.query===m.query&&(_||c.fragment===m.fragment);if(e.isEqualAuthority(c.authority,m.authority))return v.isEqualOrParent(c.path,m.path,this._ignorePathCasing(c),"/")&&c.query===m.query&&(_||c.fragment===m.fragment)}return!1}joinPath(c,...m){return k.URI.joinPath(c,...m)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let m;return c.scheme===A.Schemas.file?m=k.URI.file(R.dirname(D(c))).path:(m=R.posix.dirname(c.path),c.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),m="/")),c.with({path:m})}normalizePath(c){if(!c.path.length)return c;let m;return c.scheme===A.Schemas.file?m=k.URI.file(R.normalize(D(c))).path:m=R.posix.normalize(c.path),c.with({path:m})}relativePath(c,m){if(c.scheme!==m.scheme||!e.isEqualAuthority(c.authority,m.authority))return;if(c.scheme===A.Schemas.file){const E=R.relative(D(c),D(m));return C.isWindows?v.toSlashes(E):E}let _=c.path||"/",w=m.path||"/";if(this._ignorePathCasing(c)){let E=0;for(const u=Math.min(_.length,w.length);E<u&&!(_.charCodeAt(E)!==w.charCodeAt(E)&&_.charAt(E).toLowerCase()!==w.charAt(E).toLowerCase());E++);_=w.substr(0,E)+_.substr(E)}return R.posix.relative(_,w)}resolvePath(c,m){if(c.scheme===A.Schemas.file){const _=k.URI.file(R.resolve(D(c),m));return c.with({authority:_.authority,path:_.path})}return m=v.toPosixPath(m),c.with({path:R.posix.resolve(c.path,m)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,m){return c===m||S.equalsIgnoreCase(c,m)}hasTrailingPathSeparator(c,m=R.sep){if(c.scheme===A.Schemas.file){const _=D(c);return _.length>v.getRoot(_).length&&_[_.length-1]===m}else{const _=c.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,m=R.sep){return e.hasTrailingPathSeparator(c,m)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,m=R.sep){let _=!1;if(c.scheme===A.Schemas.file){const w=D(c);_=w!==void 0&&w.length===v.getRoot(w).length&&w[w.length-1]===m}else{m="/";const w=c.path;_=w.length===1&&w.charCodeAt(w.length-1)===47}return!_&&!e.hasTrailingPathSeparator(c,m)?c.with({path:c.path+"/"}):c}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(g=>g.scheme===A.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new P(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function s(g,c){const m=[];for(let _=0;_<g.length;_++){const w=c(g[_]);g.some((E,u)=>u===_?!1:e.isEqualOrParent(w,c(E)))||m.push(g[_])}return m}e.distinctParents=s;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function c(m){const _=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,f]=u.split(":");d&&f&&_.set(d,f)});const E=m.path.substring(0,m.path.indexOf(";"));return E&&_.set(g.META_DATA_MIME,E),_}g.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function l(g,c,m){if(c){let _=g.path;return _&&_[0]!==R.posix.sep&&(_=R.posix.sep+_),g.with({scheme:m,authority:c,path:_})}return g.with({scheme:m})}e.toLocalResource=l}),define(ge[14],pe([0,1,21,16,3,6,72,24]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(N){return!!N&&typeof N.then=="function"}e.isThenable=D;function P(N){const F=new v.CancellationTokenSource,M=N(F.token),U=new Promise((B,K)=>{F.token.onCancellationRequested(()=>{K(R.canceled())}),Promise.resolve(M).then(ie=>{F.dispose(),B(ie)},ie=>{F.dispose(),K(ie)})});return new class{cancel(){F.cancel()}then(B,K){return U.then(B,K)}catch(B){return this.then(void 0,B)}finally(B){return U.finally(B)}}}e.createCancelablePromise=P;function s(N,F,M){return Promise.race([N,new Promise(U=>F.onCancellationRequested(()=>U(M)))])}e.raceCancellation=s;async function I(N){let F=-1;const M=N.map((B,K)=>B.then(ie=>(F=K,ie))),U=await Promise.race(M);return N.forEach((B,K)=>{K!==F&&B.cancel()}),U}e.raceCancellablePromises=I;function l(N,F,M){let U;const B=setTimeout(()=>{U==null||U(void 0),M==null||M()},F);return Promise.race([N.finally(()=>clearTimeout(B)),new Promise(K=>U=K)])}e.raceTimeout=l;function g(N){return new Promise((F,M)=>{const U=N();D(U)?U.then(F,M):F(U)})}e.asPromise=g;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(M,M).then(U)})}return new Promise((M,U)=>{this.queuedPromise.then(M,U)})}return this.activePromise=F(),new Promise((M,U)=>{this.activePromise.then(B=>{this.activePromise=null,M(B)},B=>{this.activePromise=null,U(B)})})}}e.Throttler=c;class m{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=m;class _{constructor(){this.promiseMap=new Map}queue(F,M){var U;const K=((U=this.promiseMap.get(F))!==null&&U!==void 0?U:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===K&&this.promiseMap.delete(F)});return this.promiseMap.set(F,K),K}}e.SequencerByKey=_;class w{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,B)=>{this.doResolve=U,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class E{constructor(F){this.delayer=new w(F),this.throttler=new c}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function f(N,F){return F?new Promise((M,U)=>{const B=setTimeout(M,N);F.onCancellationRequested(()=>{clearTimeout(B),U(R.canceled())})}):P(M=>f(N,M))}e.timeout=f;function t(N,F=0){const M=setTimeout(N,F);return S.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function r(N){return N.then(void 0,F=>{})}e.ignoreErrors=r;function n(N){const F=[];let M=0;const U=N.length;function B(){return M<U?N[M++]():null}function K(ie){ie!=null&&F.push(ie);const we=B();return we?we.then(K):Promise.resolve(F)}return Promise.resolve(null).then(K)}e.sequence=n;function i(N,F=U=>!!U,M=null){let U=0;const B=N.length,K=()=>{if(U>=B)return Promise.resolve(M);const ie=N[U++];return Promise.resolve(ie()).then(Te=>F(Te)?Promise.resolve(Te):K())};return K()}e.first=i;function a(N,F=U=>!!U,M=null){if(N.length===0)return Promise.resolve(M);let U=N.length;const B=()=>{var K,ie;U=-1;for(const we of N)(ie=(K=we).cancel)===null||ie===void 0||ie.call(K)};return new Promise((K,ie)=>{for(const we of N)we.then(Te=>{--U>=0&&F(Te)?(B(),K(Te)):U===0&&K(M)}).catch(Te=>{--U>=0&&(B(),ie(Te))})})}e.firstParallel=a;class p{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,U)=>{this.outstandingPromises.push({factory:F,c:M,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class h extends p{constructor(){super(1)}}e.Queue=h;class b{constructor(){this.queues=new Map}queueFor(F,M=C.extUri){const U=M.getComparisonKey(F);let B=this.queues.get(U);return B||(B=new h,k.Event.once(B.onFinished)(()=>{B==null||B.dispose(),this.queues.delete(U)}),this.queues.set(U,B)),B}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=b;class y{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=y;class o{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=o;class L{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class O extends L{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(N));let U=!1;return{dispose(){U||(U=!0,clearTimeout(M))}}}}else e.runWhenIdle=(N,F)=>{const M=requestIdleCallback(N,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(M))}}}}();class W{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=W;async function ee(N,F,M){let U;for(let B=0;B<M;B++)try{return await N()}catch(K){U=K,await f(F)}throw U}e.retry=ee;class ce{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,U){return this._pending={taskId:F,cancel:()=>U==null?void 0:U(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,U;const B=new Promise((K,ie)=>{M=K,U=ie});this._next={run:F,promise:B,promiseResolve:M,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=ce;class G{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=x;class V extends k.Emitter{async fireAsync(F,M,U){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const B of this._listeners)this._asyncDeliveryQueue.push([B,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[B,K]=this._asyncDeliveryQueue.shift(),ie=[],we=Object.assign(Object.assign({},K),{waitUntil:Te=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");U&&(Te=U(Te,typeof B=="function"?B:B[0])),ie.push(Te)}});try{typeof B=="function"?B.call(void 0,we):B[0].call(B[1],we)}catch(Te){R.onUnexpectedError(Te);continue}Object.freeze(ie),await T.settled(ie).catch(Te=>R.onUnexpectedError(Te))}}}}e.AsyncEmitter=V;var T;(function(N){async function F(K){return typeof Promise.allSettled=="function"?M(K):U(K)}N.allSettled=F;async function M(K){return Promise.allSettled(K)}async function U(K){return Promise.all(K.map(ie=>ie.then(we=>({status:"fulfilled",value:we}),we=>({status:"rejected",reason:we}))))}async function B(K){let ie;const we=await Promise.all(K.map(Te=>Te.then(ye=>ye,ye=>{ie||(ie=ye)})));if(typeof ie!="undefined")throw ie;return we}N.settled=B})(T=e.Promises||(e.Promises={}))}),define(ge[95],pe([0,1,9,14]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const k=new R.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),S=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(y,o,L=!1){const O=y||"",W=o||"",ee=k.value.collator.compare(O,W);return k.value.collatorIsNumeric&&ee===0&&O!==W?O<W?-1:1:ee}e.compareFileNames=C;function D(y,o){const L=S.value.collator;return y=y||"",o=o||"",f(L,y,o)}e.compareFileNamesDefault=D;function P(y,o){const L=S.value.collator;return y=y||"",o=o||"",i(y,o)||f(L,y,o)}e.compareFileNamesUpper=P;function s(y,o){const L=S.value.collator;return y=y||"",o=o||"",n(y,o)||f(L,y,o)}e.compareFileNamesLower=s;function I(y,o){return y=y||"",o=o||"",y===o?0:y<o?-1:1}e.compareFileNamesUnicode=I;function l(y,o,L=!1){L||(y=y&&y.toLowerCase(),o=o&&o.toLowerCase());const[O,W]=u(y),[ee,ce]=u(o);return O!==ee?O<ee?-1:1:W===ce?0:W<ce?-1:1}e.noIntlCompareFileNames=l;function g(y,o){const[L,O]=u(y),[W,ee]=u(o);let ce=k.value.collator.compare(O,ee);if(ce===0){if(k.value.collatorIsNumeric&&O!==ee)return O<ee?-1:1;if(ce=k.value.collator.compare(L,W),k.value.collatorIsNumeric&&ce===0&&L!==W)return L<W?-1:1}return ce}e.compareFileExtensions=g;function c(y,o){y=y||"",o=o||"";const L=d(y),O=d(o),W=S.value.collator,ee=A.value.collator;return f(ee,L,O)||f(W,y,o)}e.compareFileExtensionsDefault=c;function m(y,o){y=y||"",o=o||"";const L=d(y),O=d(o),W=S.value.collator,ee=A.value.collator;return f(ee,L,O)||i(y,o)||f(W,y,o)}e.compareFileExtensionsUpper=m;function _(y,o){y=y||"",o=o||"";const L=d(y),O=d(o),W=S.value.collator,ee=A.value.collator;return f(ee,L,O)||n(y,o)||f(W,y,o)}e.compareFileExtensionsLower=_;function w(y,o){y=y||"",o=o||"";const L=d(y).toLowerCase(),O=d(o).toLowerCase();return L!==O?L<O?-1:1:y!==o?y<o?-1:1:0}e.compareFileExtensionsUnicode=w;const E=/^(.*?)(\.([^.]*))?$/;function u(y,o=!1){const L=y?E.exec(y):[];let O=[L&&L[1]||"",L&&L[3]||""];return o&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function d(y){const o=y?E.exec(y):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function f(y,o,L){let O=y.compare(o,L);return O!==0?O:o.length!==L.length?o.length<L.length?-1:1:0}function t(y){const o=y.charAt(0);return o.toLocaleUpperCase()!==o}function r(y){const o=y.charAt(0);return o.toLocaleLowerCase()!==o}function n(y,o){return t(y)&&r(o)?-1:r(y)&&t(o)?1:0}function i(y,o){return r(y)&&t(o)?-1:t(y)&&r(o)?1:0}function a(y,o,L=!1){return L||(y=y&&y.toLowerCase(),o=o&&o.toLowerCase()),y===o?0:y<o?-1:1}function p(y,o,L=!1){const O=y.split(v.sep),W=o.split(v.sep),ee=O.length-1,ce=W.length-1;let G,x;for(let V=0;;V++){if(G=ee===V,x=ce===V,G&&x)return C(O[V],W[V],L);if(G)return-1;if(x)return 1;const T=a(O[V],W[V],L);if(T!==0)return T}}e.comparePaths=p;function h(y,o,L){const O=y.toLowerCase(),W=o.toLowerCase(),ee=b(y,o,L);if(ee)return ee;const ce=O.endsWith(L),G=W.endsWith(L);if(ce!==G)return ce?-1:1;const x=C(O,W);return x!==0?x:O.localeCompare(W)}e.compareAnything=h;function b(y,o,L){const O=y.toLowerCase(),W=o.toLowerCase(),ee=O.startsWith(L),ce=W.startsWith(L);if(ee!==ce)return ee?-1:1;if(ee&&ce){if(O.length<W.length)return-1;if(O.length>W.length)return 1}return 0}e.compareByPrefix=b}),define(ge[96],pe([0,1,95,93,9,11,8]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const C=0,D=[C,[]];function P(G,x,V,T){if(!G||!x)return D;const N=G.length,F=x.length;if(N<F)return D;const M=G.toLowerCase();return!T&&!M.includes(V)?D:s(x,V,F,G,M,N)}e.scoreFuzzy=P;function s(G,x,V,T,N,F){const M=[],U=[];for(let we=0;we<V;we++){const Te=we*F,ye=Te-F,Oe=we>0,je=G[we],ze=x[we];for(let qe=0;qe<F;qe++){const j=qe>0,J=Te+qe,ne=J-1,oe=ye+qe-1,Y=j?M[ne]:0,le=Oe&&j?M[oe]:0,me=Oe&&j?U[oe]:0;let Re;!le&&Oe?Re=0:Re=I(je,ze,T,N,qe,me),Re&&le+Re>=Y?(U[J]=me+1,M[J]=le+Re):(U[J]=C,M[J]=Y)}}const B=[];let K=V-1,ie=F-1;for(;K>=0&&ie>=0;){const we=K*F+ie;U[we]===C||(B.push(ie),K--),ie--}return[M[V*F-1],B.reverse()]}function I(G,x,V,T,N,F){let M=0;if(!l(x,T[N]))return M;if(M+=1,F>0&&(M+=F*5),G===V[N]&&(M+=1),N===0)M+=8;else{const U=g(V.charCodeAt(N-1));U?M+=U:R.isUpper(V.charCodeAt(N))&&(M+=2)}return M}function l(G,x){return G===x?!0:G==="/"||G==="\\"?x==="/"||x==="\\":!1}function g(G){switch(G){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function m(G,x,V=0,T=0){const N=x;return N.values&&N.values.length>1?_(G,N.values,V,T):w(G,x,V,T)}e.scoreFuzzy2=m;function _(G,x,V,T){let N=0;const F=[];for(const M of x){const[U,B]=w(G,M,V,T);if(typeof U!="number")return c;N+=U,F.push(...B)}return[N,p(F)]}function w(G,x,V,T){const N=R.fuzzyScore(x.original,x.originalLowercase,V,G,G.toLowerCase(),T,!0);return N?[N[0],R.createMatches(N)]:c}const E=Object.freeze({score:0}),u=1<<18,d=1<<17,f=1<<16;function t(G,x,V,T,N){if(!G||!x.normalized)return E;const F=T.getItemLabel(G);if(!F)return E;const M=T.getItemDescription(G);let U;M?U=`${F}${M}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${V}`:U=`${F}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${V}`;const B=N[U];if(B)return B;const K=r(F,M,T.getItemPath(G),x,V);return N[U]=K,K}e.scoreItemFuzzy=t;function r(G,x,V,T,N){const F=!V||!T.containsPathSeparator;return V&&(S.isLinux?T.pathNormalized===V:A.equalsIgnoreCase(T.pathNormalized,V))?{score:u,labelMatch:[{start:0,end:G.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:T.values&&T.values.length>1?n(G,x,V,T.values,F,N):i(G,x,V,T,F,N)}function n(G,x,V,T,N,F){let M=0;const U=[],B=[];for(const K of T){const{score:ie,labelMatch:we,descriptionMatch:Te}=i(G,x,V,K,N,F);if(ie===C)return E;M+=ie,we&&U.push(...we),Te&&B.push(...Te)}return{score:M,labelMatch:p(U),descriptionMatch:p(B)}}function i(G,x,V,T,N,F){if(N||!x){const[M,U]=P(G,T.normalized,T.normalizedLowercase,F);if(M){const B=R.matchesPrefix(T.normalized,G);let K;return B?(K=d,K+=Math.round(T.normalized.length/G.length*100)):K=f,{score:K+M,labelMatch:B||a(U)}}}if(x){let M=x;V&&(M=`${x}${k.sep}`);const U=M.length,B=`${M}${G}`,[K,ie]=P(B,T.normalized,T.normalizedLowercase,F);if(K){const we=a(ie),Te=[],ye=[];return we.forEach(Oe=>{Oe.start<U&&Oe.end>U?(Te.push({start:0,end:Oe.end-U}),ye.push({start:Oe.start,end:U})):Oe.start>=U?Te.push({start:Oe.start-U,end:Oe.end-U}):ye.push(Oe)}),{score:K,labelMatch:Te,descriptionMatch:ye}}}return E}function a(G){const x=[];if(!G)return x;let V;for(const T of G)V&&V.end===T?V.end+=1:(V={start:T,end:T+1},x.push(V));return x}function p(G){const x=G.sort((N,F)=>N.start-F.start),V=[];let T;for(const N of x)!T||!h(T,N)?(T=N,V.push(N)):(T.start=Math.min(T.start,N.start),T.end=Math.max(T.end,N.end));return V}function h(G,x){return!(G.end<x.start||x.end<G.start)}function b(G,x,V,T,N,F){const M=t(G,V,T,N,F),U=t(x,V,T,N,F),B=M.score,K=U.score;if((B===u||K===u)&&B!==K)return B===u?-1:1;if(B>f||K>f){if(B!==K)return B>K?-1:1;if(B<d&&K<d){const ze=o(M.labelMatch,U.labelMatch);if(ze!==0)return ze}const Oe=N.getItemLabel(G)||"",je=N.getItemLabel(x)||"";if(Oe.length!==je.length)return Oe.length-je.length}if(B!==K)return B>K?-1:1;const ie=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,we=Array.isArray(U.labelMatch)&&U.labelMatch.length>0;if(ie&&!we)return-1;if(we&&!ie)return 1;const Te=y(G,M,N),ye=y(x,U,N);return Te&&ye&&Te!==ye?ye>Te?-1:1:L(G,x,V,N)}e.compareItemsByFuzzyScore=b;function y(G,x,V){let T=-1,N=-1;if(x.descriptionMatch&&x.descriptionMatch.length?T=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(T=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(N=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const F=V.getItemDescription(G);F&&(N+=F.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(N=x.descriptionMatch[x.descriptionMatch.length-1].end);return N-T}function o(G,x){if(!G&&!x||(!G||!G.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!G||!G.length)return 1;const V=G[0].start,N=G[G.length-1].end-V,F=x[0].start,U=x[x.length-1].end-F;return N===U?0:U<N?1:-1}function L(G,x,V,T){const N=T.getItemLabel(G)||"",F=T.getItemLabel(x)||"",M=T.getItemDescription(G),U=T.getItemDescription(x),B=N.length+(M?M.length:0),K=F.length+(U?U.length:0);if(B!==K)return B-K;const ie=T.getItemPath(G),we=T.getItemPath(x);return ie&&we&&ie.length!==we.length?ie.length-we.length:N!==F?v.compareAnything(N,F,V.normalized):M&&U&&M!==U?v.compareAnything(M,U,V.normalized):ie&&we&&ie!==we?v.compareAnything(ie,we,V.normalized):0}const O=" ";function W(G){typeof G!="string"&&(G="");const x=G.toLowerCase(),{pathNormalized:V,normalized:T,normalizedLowercase:N}=ee(G),F=V.indexOf(k.sep)>=0;let M;const U=G.split(O);if(U.length>1)for(const B of U){const{pathNormalized:K,normalized:ie,normalizedLowercase:we}=ee(B);ie&&(M||(M=[]),M.push({original:B,originalLowercase:B.toLowerCase(),pathNormalized:K,normalized:ie,normalizedLowercase:we}))}return{original:G,originalLowercase:x,pathNormalized:V,normalized:T,normalizedLowercase:N,values:M,containsPathSeparator:F}}e.prepareQuery=W;function ee(G){let x;S.isWindows?x=G.replace(/\//g,k.sep):x=G.replace(/\\/g,k.sep);const V=A.stripWildcards(x).replace(/\s/g,"");return{pathNormalized:x,normalized:V,normalizedLowercase:V.toLowerCase()}}function ce(G){return Array.isArray(G)?W(G.map(x=>x.original).join(O)):W(G.original)}e.pieceToQuery=ce}),define(ge[30],pe([0,1,8,29,9,23,14]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",P="/",s="[/\\\\]",I="[^/\\\\]",l=/\//g;function g(M){switch(M){case 0:return"";case 1:return`${I}*?`;default:return`(?:${s}|${I}+${s}|${s}${I}+)*?`}}function c(M,U){if(!M)return[];const B=[];let K=!1,ie=!1,we="";for(const Te of M){switch(Te){case U:if(!K&&!ie){B.push(we),we="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Te}return we&&B.push(we),B}e.splitGlobAware=c;function m(M){if(!M)return"";let U="";const B=c(M,P);if(B.every(K=>K===D))U=".*";else{let K=!1;B.forEach((ie,we)=>{if(ie===D){K||(U+=g(2),K=!0);return}let Te=!1,ye="",Oe=!1,je="";for(const ze of ie){if(ze!=="}"&&Te){ye+=ze;continue}if(Oe&&(ze!=="]"||!je)){let qe;ze==="-"?qe=ze:(ze==="^"||ze==="!")&&!je?qe="^":ze===P?qe="":qe=v.escapeRegExpCharacters(ze),je+=qe;continue}switch(ze){case"{":Te=!0;continue;case"[":Oe=!0;continue;case"}":U+=`(?:${c(ye,",").map(J=>m(J)).join("|")})`,Te=!1,ye="";break;case"]":U+="["+je+"]",Oe=!1,je="";break;case"?":U+=I;continue;case"*":U+=g(1);continue;default:U+=v.escapeRegExpCharacters(ze)}}we<B.length-1&&(B[we+1]!==D||we+2<B.length)&&(U+=s),K=!1})}return U}const _=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},n=function(){return null};function i(M,U){if(!M)return n;let B;typeof M!="string"?B=M.pattern:B=M,B=B.trim();const K=`${B}_${!!U.trimForExclusions}`;let ie=t.get(K);if(ie)return a(ie,M);let we;if(_.test(B)){const Te=B.substr(4);ie=function(ye,Oe){return typeof ye=="string"&&ye.endsWith(Te)?B:null}}else(we=w.exec(p(B,U)))?ie=h(we[1],B):(U.trimForExclusions?u:E).test(B)?ie=b(B,U):(we=d.exec(p(B,U)))?ie=y(we[1].substr(1),B,!0):(we=f.exec(p(B,U)))?ie=y(we[1],B,!1):ie=o(B);return t.set(K,ie),a(ie,M)}function a(M,U){return typeof U=="string"?M:function(B,K){return R.isEqualOrParent(B,U.base)?M(k.relative(U.base,B),K):null}}function p(M,U){return U.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function h(M,U){const B=`/${M}`,K=`\\${M}`,ie=function(Te,ye){return typeof Te!="string"?null:ye?ye===M?U:null:Te===M||Te.endsWith(B)||Te.endsWith(K)?U:null},we=[M];return ie.basenames=we,ie.patterns=[U],ie.allBasenames=we,ie}function b(M,U){const B=F(M.slice(1,-1).split(",").map(ye=>i(ye,U)).filter(ye=>ye!==n),M),K=B.length;if(!K)return n;if(K===1)return B[0];const ie=function(ye,Oe){for(let je=0,ze=B.length;je<ze;je++)if(B[je](ye,Oe))return M;return null},we=B.find(ye=>!!ye.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Te=B.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(ie.allPaths=Te),ie}function y(M,U,B){const K=k.sep===k.posix.sep,ie=K?M:M.replace(l,k.sep),we=k.sep+ie,Te=k.posix.sep+M,ye=B?function(Oe,je){return typeof Oe=="string"&&(Oe===ie||Oe.endsWith(we)||!K&&(Oe===M||Oe.endsWith(Te)))?U:null}:function(Oe,je){return typeof Oe=="string"&&(Oe===ie||!K&&Oe===M)?U:null};return ye.allPaths=[(B?"*/":"./")+M],ye}function o(M){try{const U=new RegExp(`^${m(M)}$`);return function(B){return U.lastIndex=0,typeof B=="string"&&U.test(B)?M:null}}catch(U){return n}}function L(M,U,B){return!M||typeof U!="string"?!1:O(M)(U,void 0,B)}e.match=L;function O(M,U={}){if(!M)return r;if(typeof M=="string"||G(M)){const B=i(M,U);if(B===n)return r;const K=function(ie,we){return!!B(ie,we)};return B.allBasenames&&(K.allBasenames=B.allBasenames),B.allPaths&&(K.allPaths=B.allPaths),K}return T(M,U)}e.parse=O;function W(M){if(!M)return;let U;return B=>(U||(U=(M()||Promise.resolve([])).then(K=>K?ce(K):{})),U.then(K=>!!K[B]))}e.hasSiblingPromiseFn=W;function ee(M){if(!M)return;let U;return B=>{if(!U){const K=M();U=K?ce(K):{}}return!!U[B]}}e.hasSiblingFn=ee;function ce(M){const U={};for(const B of M)U[B]=!0;return U}function G(M){const U=M;return U&&typeof U.base=="string"&&typeof U.pattern=="string"}e.isRelativePattern=G;function x(M){return M.allBasenames||[]}e.getBasenameTerms=x;function V(M){return M.allPaths||[]}e.getPathTerms=V;function T(M,U){const B=F(Object.getOwnPropertyNames(M).map(ye=>N(ye,M[ye],U)).filter(ye=>ye!==n)),K=B.length;if(!K)return n;if(!B.some(ye=>!!ye.requiresSiblings)){if(K===1)return B[0];const ye=function(ze,qe){for(let j=0,J=B.length;j<J;j++){const ne=B[j](ze,qe);if(ne)return ne}return null},Oe=B.find(ze=>!!ze.allBasenames);Oe&&(ye.allBasenames=Oe.allBasenames);const je=B.reduce((ze,qe)=>qe.allPaths?ze.concat(qe.allPaths):ze,[]);return je.length&&(ye.allPaths=je),ye}const ie=function(ye,Oe,je){let ze;for(let qe=0,j=B.length;qe<j;qe++){const J=B[qe];J.requiresSiblings&&je&&(Oe||(Oe=k.basename(ye)),ze||(ze=Oe.substr(0,Oe.length-k.extname(ye).length)));const ne=J(ye,Oe,ze,je);if(ne)return ne}return null},we=B.find(ye=>!!ye.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Te=B.reduce((ye,Oe)=>Oe.allPaths?ye.concat(Oe.allPaths):ye,[]);return Te.length&&(ie.allPaths=Te),ie}function N(M,U,B){if(U===!1)return n;const K=i(M,B);if(K===n)return n;if(typeof U=="boolean")return K;if(U){const ie=U.when;if(typeof ie=="string"){const we=(Te,ye,Oe,je)=>{if(!je||!K(Te,ye))return null;const ze=ie.replace("$(basename)",Oe),qe=je(ze);return A.isThenable(qe)?qe.then(j=>j?M:null):qe?M:null};return we.requiresSiblings=!0,we}}return K}function F(M,U){const B=M.filter(ye=>!!ye.basenames);if(B.length<2)return M;const K=B.reduce((ye,Oe)=>{const je=Oe.basenames;return je?ye.concat(je):ye},[]);let ie;if(U){ie=[];for(let ye=0,Oe=K.length;ye<Oe;ye++)ie.push(U)}else ie=B.reduce((ye,Oe)=>{const je=Oe.patterns;return je?ye.concat(je):ye},[]);const we=function(ye,Oe){if(typeof ye!="string")return null;if(!Oe){let ze;for(ze=ye.length;ze>0;ze--){const qe=ye.charCodeAt(ze-1);if(qe===47||qe===92)break}Oe=ye.substr(ze)}const je=K.indexOf(Oe);return je!==-1?ie[je]:null};we.basenames=K,we.patterns=ie,we.allBasenames=K;const Te=M.filter(ye=>!ye.basenames);return Te.push(we),Te}}),define(ge[76],pe([0,1,2,9,8,10,11,24,29]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,a,p){if(typeof i=="string"&&(i=v.URI.file(i)),p){const b=p.getWorkspaceFolder(i);if(b){const y=p.getWorkspace().folders.length>1;let o;if(C.isEqual(b.uri,i)?o="":o=C.relativePath(b.uri,i),y){const L=b.name?b.name:C.basename(b.uri);o=o?L+" \u2022 "+o:L}return o}}if(i.scheme!==S.Schemas.file&&i.scheme!==S.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if(D.hasDriveLetter(i.fsPath))return R.normalize(I(i.fsPath));let h=R.normalize(i.fsPath);return!A.isWindows&&(a==null?void 0:a.userHome)&&(h=g(h,a.userHome.fsPath)),h}e.getPathLabel=P;function s(i){if(!i)return;typeof i=="string"&&(i=v.URI.file(i));const a=C.basename(i)||(i.scheme===S.Schemas.file?i.fsPath:i.path);return A.isWindows&&D.isRootOrDriveLetter(a)?I(a):a}e.getBaseLabel=s;function I(i){return D.hasDriveLetter(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let l=Object.create(null);function g(i,a){if(A.isWindows||!i||!a)return i;let p=l.original===a?l.normalized:void 0;return p||(p=`${k.rtrim(a,R.posix.sep)}${R.posix.sep}`,l={original:a,normalized:p}),(A.isLinux?i.startsWith(p):k.startsWithIgnoreCase(i,p))&&(i=`~/${i.substr(p.length)}`),i}e.tildify=g;function c(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=c;const m="\u2026",_="\\\\",w="~";function E(i,a=R.sep){const p=new Array(i.length);let h=!1;for(let b=0;b<i.length;b++){let y=i[b];if(y===""){p[b]=`.${a}`;continue}if(!y){p[b]=y;continue}h=!0;let o="";y.indexOf(_)===0?(o=y.substr(0,y.indexOf(_)+_.length),y=y.substr(y.indexOf(_)+_.length)):y.indexOf(a)===0?(o=y.substr(0,y.indexOf(a)+a.length),y=y.substr(y.indexOf(a)+a.length)):y.indexOf(w)===0&&(o=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length));const L=y.split(a);for(let O=1;h&&O<=L.length;O++)for(let W=L.length-O;h&&W>=0;W--){h=!1;let ee=L.slice(W,W+O).join(a);for(let ce=0;!h&&ce<i.length;ce++)if(ce!==b&&i[ce]&&i[ce].indexOf(ee)>-1){const G=W+O===L.length,x=W>0&&i[ce].indexOf(a)>-1?a+ee:ee,V=i[ce].endsWith(x);h=!G||V}if(!h){let ce="";(L[0].endsWith(":")||o!=="")&&(W===1&&(W=0,O++,ee=L[0]+a+ee),W>0&&(ce=L[0]+a),ce=o+ce),W>0&&(ce=ce+m+a),ce=ce+ee,W+O<L.length&&(ce=ce+a+m),p[b]=ce}}h&&(p[b]=y)}return p}e.shorten=E;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function d(i,a=Object.create(null)){const p=[];let h=!1,b="";for(const y of i)if(y==="$"||h&&y==="{")b&&p.push({value:b,type:u.TEXT}),b="",h=!0;else if(y==="}"&&h){const o=a[b];if(typeof o=="string")o.length&&p.push({value:o,type:u.VARIABLE});else if(o){const L=p[p.length-1];(!L||L.type!==u.SEPARATOR)&&p.push({value:o.label,type:u.SEPARATOR})}b="",h=!1}else b+=y;return b&&!h&&p.push({value:b,type:u.TEXT}),p.filter((y,o)=>{if(y.type===u.SEPARATOR){const L=p[o-1],O=p[o+1];return[L,O].every(W=>W&&(W.type===u.VARIABLE||W.type===u.TEXT)&&W.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=d;function f(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):i.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(i,a){return A.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):A.isWindows?i.replace(/&&|&/g,p=>p==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function n(i){const a=i.indexOf("/")!==-1?R.posix:R.win32,p=a.basename(i),h=a.dirname(i);return p.length?{name:p,parentPath:h}:{name:h,parentPath:""}}e.splitName=n}),define(ge[136],pe([0,1,9,8,30,10,24]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let C=[],D=[],P=[];function s(t,r=!1){const n=I(t);C.push(n),n.userConfigured?P.push(n):D.push(n),r&&!n.userConfigured&&C.forEach(i=>{i.mime===n.mime||i.userConfigured||(n.extension&&i.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&i.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&i.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&i.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=s;function I(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(v.posix.sep)>=0:!1}}function l(t){t?(C=C.filter(r=>!r.userConfigured),P=[]):(C=[],D=[],P=[])}e.clearTextMimes=l;function g(t,r){let n;if(t)switch(t.scheme){case S.Schemas.file:n=t.fsPath;break;case S.Schemas.data:n=A.DataUri.parseMetaData(t).get(A.DataUri.META_DATA_LABEL);break;default:n=t.path}if(!n)return[e.MIME_UNKNOWN];n=n.toLowerCase();const i=v.basename(n),a=c(n,i,P);if(a)return[a,e.MIME_TEXT];const p=c(n,i,D);if(p)return[p,e.MIME_TEXT];if(r){const h=m(r);if(h)return[h,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=g;function c(t,r,n){let i=null,a=null,p=null;for(let h=n.length-1;h>=0;h--){const b=n[h];if(r===b.filenameLowercase){i=b;break}if(b.filepattern&&(!a||b.filepattern.length>a.filepattern.length)){const y=b.filepatternOnPath?t:r;k.match(b.filepatternLowercase,y)&&(a=b)}b.extension&&(!p||b.extension.length>p.extension.length)&&r.endsWith(b.extensionLowercase)&&(p=b)}return i?i.mime:a?a.mime:p?p.mime:null}function m(t){if(R.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let r=C.length-1;r>=0;r--){const n=C[r];if(!n.firstline)continue;const i=t.match(n.firstline);if(i&&i.length>0)return n.mime}return null}function _(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&_(t[0]):!0}e.isUnspecific=_;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function E(t){const r=v.extname(t);return w[r.toLowerCase()]}e.getMediaMime=E;function u(t){for(const r in w)if(w[r]===t)return r}e.getExtensionForMimeType=u;const d=/^(.+)\/(.+?)(;.+)?$/;function f(t,r){var n;const i=d.exec(t);return i?`${i[1].toLowerCase()}/${i[2].toLowerCase()}${(n=i[3])!==null&&n!==void 0?n:""}`:r?void 0:t}e.normalizeMimeType=f}),define(ge[97],pe([0,1,2]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(s){return s.toJSON()}class k{constructor(I){this._uriTransformer=I}transformIncoming(I){const l=this._uriTransformer.transformIncoming(I);return l===I?I:R(v.URI.from(l))}transformOutgoing(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:R(v.URI.from(l))}transformOutgoingURI(I){const l=this._uriTransformer.transformOutgoing(I);return l===I?I:v.URI.from(l)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(s){return s}transformOutgoing(s){return s}transformOutgoingURI(s){return s}transformOutgoingScheme(s){return s}};function S(s,I,l){if(!s||l>200)return null;if(typeof s=="object"){if(s instanceof v.URI)return I.transformOutgoing(s);for(let g in s)if(Object.hasOwnProperty.call(s,g)){const c=S(s[g],I,l+1);c!==null&&(s[g]=c)}}return null}function A(s,I){const l=S(s,I,0);return l===null?s:l}e.transformOutgoingURIs=A;function C(s,I,l,g){if(!s||g>200)return null;if(typeof s=="object"){if(s.$mid===1)return l?v.URI.revive(I.transformIncoming(s)):I.transformIncoming(s);for(let c in s)if(Object.hasOwnProperty.call(s,c)){const m=C(s[c],I,l,g+1);m!==null&&(s[c]=m)}}return null}function D(s,I){const l=C(s,I,!1,0);return l===null?s:l}e.transformIncomingURIs=D;function P(s,I){const l=C(s,I,!0,0);return l===null?s:l}e.transformAndReviveIncomingURIs=P}),define(ge[32],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(D){return v.test(D)}e.isUUID=R;const k=new Uint8Array(16),S=[];for(let D=0;D<256;D++)S.push(D.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function C(){A(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let D=0,P="";return P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P+="-",P+=S[k[D++]],P+=S[k[D++]],P+="-",P+=S[k[D++]],P+=S[k[D++]],P+="-",P+=S[k[D++]],P+=S[k[D++]],P+="-",P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P+=S[k[D++]],P}e.generateUuid=C}),define(ge[137],pe([0,1,98]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(C.length<1)return A;let D=0,P,s=D;for(;s<C.length;)if(P=C.charCodeAt(s),P===13||P===10){if(A.push(C.substring(D,s)),s++,s<C.length){const I=P;P=C.charCodeAt(s),(I===13&&P===10||I===10&&P===13)&&s++}D=s}else s++;return this.remaining=D<C.length?C.substr(D):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(ge[28],pe([0,1,54,99,272,9,14,11,29,32,75,24,2]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function c(T,N=g.UNLINK){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");return N===g.UNLINK?_(T):m(T)}e.rimraf=c;async function m(T){try{const N=S.join(R.tmpdir(),P.generateUuid());try{await V.rename(T,N)}catch(F){return _(T)}_(N).catch(F=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function _(T){return V.rmdir(T,{recursive:!0,maxRetries:3})}function w(T){if(D.isRootOrDriveLetter(T))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(T,{recursive:!0})}e.rimrafSync=w;async function E(T,N){return f(await(N?u(T):V.readdir(T)))}e.readdir=E;async function u(T){try{return await V.readdir(T,{withFileTypes:!0})}catch(M){console.warn("[node.js fs] readdir with filetypes failed with error: ",M)}const N=[],F=await E(T);for(const M of F){let U=!1,B=!1,K=!1;try{const ie=await V.lstat(S.join(T,M));U=ie.isFile(),B=ie.isDirectory(),K=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}N.push({name:M,isFile:()=>U,isDirectory:()=>B,isSymbolicLink:()=>K})}return N}function d(T){return f(v.readdirSync(T))}e.readdirSync=d;function f(T){return T.map(N=>typeof N=="string"?C.isMacintosh?s.normalizeNFC(N):N:(N.name=C.isMacintosh?s.normalizeNFC(N.name):N.name,N))}async function t(T){const N=await E(T),F=[];for(const M of N)await n.existsDirectory(S.join(T,M))&&F.push(M);return F}e.readDirsInDir=t;function r(T,N=1e3){return new Promise(F=>{let M=!1;const U=setInterval(()=>{M||(M=!0,v.access(T,B=>{M=!1,B&&(clearInterval(U),F(void 0))}))},N)})}e.whenDeleted=r;var n;(function(T){async function N(U){let B;try{if(B=await V.lstat(U),!B.isSymbolicLink())return{stat:B}}catch(K){}try{return{stat:await V.stat(U),symbolicLink:(B==null?void 0:B.isSymbolicLink())?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await V.stat(await V.readlink(U)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ie}throw K}}T.stat=N;async function F(U){try{const{stat:B,symbolicLink:K}=await T.stat(U);return B.isFile()&&(K==null?void 0:K.dangling)!==!0}catch(B){}return!1}T.existsFile=F;async function M(U){try{const{stat:B,symbolicLink:K}=await T.stat(U);return B.isDirectory()&&(K==null?void 0:K.dangling)!==!0}catch(B){}return!1}T.existsDirectory=M})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function a(T,N,F){return i.queueFor(l.URI.file(T),I.extUriBiasedIgnorePathCase).queue(()=>{const M=y(F);return new Promise((U,B)=>h(T,N,M,K=>K?B(K):U()))})}e.writeFile=a;let p=!0;function h(T,N,F,M){if(!p)return v.writeFile(T,N,{mode:F.mode,flag:F.flag},M);v.open(T,F.flag,F.mode,(U,B)=>{if(U)return M(U);v.writeFile(B,N,K=>{if(K)return v.close(B,()=>M(K));v.fdatasync(B,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),p=!1),v.close(B,we=>M(we))))})})}function b(T,N,F){const M=y(F);if(!p)return v.writeFileSync(T,N,{mode:M.mode,flag:M.flag});const U=v.openSync(T,M.flag,M.mode);try{v.writeFileSync(U,N);try{v.fdatasyncSync(U)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),p=!1}}finally{v.closeSync(U)}}e.writeFileSync=b;function y(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function o(T,N){if(T===N)return;async function F(M){try{const U=await V.lstat(M);if(U.isDirectory()||U.isSymbolicLink())return;await V.utimes(M,U.atime,new Date)}catch(U){}}try{await V.rename(T,N),await F(N)}catch(M){if(T.toLowerCase()!==N.toLowerCase()&&M.code==="EXDEV"||T.endsWith("."))await L(T,N,{preserveSymlinks:!1}),await c(T,g.MOVE),await F(N);else throw M}}e.move=o;async function L(T,N,F){return W(T,N,{root:{source:T,target:N},options:F,handledSourcePaths:new Set})}e.copy=L;const O=511;async function W(T,N,F){if(F.handledSourcePaths.has(T))return;F.handledSourcePaths.add(T);const{stat:M,symbolicLink:U}=await n.stat(T);if(U){if(F.options.preserveSymlinks)try{return await G(T,N,F)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(U.dangling)return}return M.isDirectory()?ee(T,N,M.mode&O,F):ce(T,N,M.mode&O)}async function ee(T,N,F,M){await V.mkdir(N,{recursive:!0,mode:F});const U=await E(T);for(const B of U)await W(S.join(T,B),S.join(N,B),M)}async function ce(T,N,F){await V.copyFile(T,N),await V.chmod(N,F)}async function G(T,N,F){let M=await V.readlink(T);D.isEqualOrParent(M,F.root.source,!C.isLinux)&&(M=S.join(F.root.target,M.substr(F.root.source.length+1))),await V.symlink(M,N)}async function x(T){try{return await V.access(T),!0}catch(N){return!1}}e.exists=x;var V;(function(T){T.access=k.promisify(v.access),T.stat=k.promisify(v.stat),T.lstat=k.promisify(v.lstat),T.utimes=k.promisify(v.utimes),T.read=k.promisify(v.read),T.readFile=k.promisify(v.readFile),T.write=k.promisify(v.write),T.writeFile=k.promisify(v.writeFile),T.appendFile=k.promisify(v.appendFile),T.fdatasync=k.promisify(v.fdatasync),T.truncate=k.promisify(v.truncate),T.rename=k.promisify(v.rename),T.copyFile=k.promisify(v.copyFile),T.open=k.promisify(v.open),T.close=k.promisify(v.close),T.symlink=k.promisify(v.symlink),T.readlink=k.promisify(v.readlink),T.chmod=k.promisify(v.chmod),T.readdir=k.promisify(v.readdir),T.mkdir=k.promisify(v.mkdir),T.unlink=k.promisify(v.unlink),T.rmdir=k.promisify(v.rmdir),T.realpath=k.promisify(v.realpath)})(V=e.Promises||(e.Promises={}))}),define(ge[100],pe([0,1,54,8,9,28]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(s){const I=k.dirname(s);if(s===I)return s;const l=(k.basename(s)||s).toLowerCase();try{const c=S.readdirSync(I).filter(m=>m.toLowerCase()===l);if(c.length===1){const m=A(I);if(m)return k.join(m,c[0])}else if(c.length>1){const m=c.indexOf(l);if(m>=0){const _=A(I);if(_)return k.join(_,c[m])}}}catch(g){}return null}e.realcaseSync=A;async function C(s){try{return await S.Promises.realpath(s)}catch(I){const l=P(s);return await S.Promises.access(l,v.constants.R_OK),l}}e.realpath=C;function D(s){try{return v.realpathSync(s)}catch(I){const l=P(s);return v.accessSync(l,v.constants.R_OK),l}}e.realpathSync=D;function P(s){return R.rtrim(k.normalize(s),k.sep)}});var Ve=this&&this.__decorate||function(X,e,v,R){var k=arguments.length,S=k<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(X,e,v,R);else for(var C=X.length-1;C>=0;C--)(A=X[C])&&(S=(k<3?A(S):k>3?A(e,v,S):A(e,v))||S);return k>3&&S&&Object.defineProperty(e,v,S),S};define(ge[101],pe([0,1,3,6,14,21,16,22,17,13,53,8,50]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function c(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function _(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(w||(w={}));class E{constructor(M){this.buffer=M,this.pos=0}read(M){const U=this.buffer.slice(this.pos,this.pos+M);return this.pos+=U.byteLength,U}}class u{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function f(F){const M=C.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function r(F){const M=C.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const n={Undefined:r(d.Undefined),String:r(d.String),Buffer:r(d.Buffer),VSBuffer:r(d.VSBuffer),Array:r(d.Array),Object:r(d.Object)},i=typeof Buffer!="undefined";function a(F,M){if(typeof M=="undefined")F.write(n.Undefined);else if(typeof M=="string"){const U=C.VSBuffer.fromString(M);F.write(n.String),F.write(f(U.byteLength)),F.write(U)}else if(i&&Buffer.isBuffer(M)){const U=C.VSBuffer.wrap(M);F.write(n.Buffer),F.write(f(U.byteLength)),F.write(U)}else if(M instanceof C.VSBuffer)F.write(n.VSBuffer),F.write(f(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(n.Array),F.write(f(M.length));for(const U of M)a(F,U)}else{const U=C.VSBuffer.fromString(JSON.stringify(M));F.write(n.Object),F.write(f(U.byteLength)),F.write(U)}}function p(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(t(F)).toString();case d.Buffer:return F.read(t(F)).buffer;case d.VSBuffer:return F.read(t(F));case d.Array:{const U=t(F),B=[];for(let K=0;K<U;K++)B.push(p(F));return B}case d.Object:return JSON.parse(F.read(t(F)).toString())}}class h{constructor(M,U,B=null,K=1e3){this.protocol=M,this.ctx=U,this.logger=B,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ie=>this.onRawMessage(ie)),this.sendResponse({type:200})}registerChannel(M,U){this.channels.set(M,U),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const U=this.send([M.type]);this.logger&&this.logger.logOutgoing(U,0,1,_(M.type));return}case 201:case 202:case 204:case 203:{const U=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(U,M.id,1,_(M.type),M.data);return}}}send(M,U=void 0){const B=new u;return a(B,M),a(B,U),this.sendBuffer(B.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onRawMessage(M){const U=new E(M),B=p(U),K=p(U),ie=B[0];switch(ie){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}: ${B[2]}.${B[3]}`,K),this.onPromise({type:ie,id:B[1],channelName:B[2],name:B[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}: ${B[2]}.${B[3]}`,K),this.onEventListen({type:ie,id:B[1],channelName:B[2],name:B[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],1,`${c(ie)}`),this.disposeActiveRequest({type:ie,id:B[1]})}}onPromise(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const B=new S.CancellationTokenSource;let K;try{K=U.call(this.ctx,M.name,M.arg,B.token)}catch(Te){K=Promise.reject(Te)}const ie=M.id;K.then(Te=>{this.sendResponse({id:ie,data:Te,type:201}),this.activeRequests.delete(M.id)},Te=>{Te instanceof Error?this.sendResponse({id:ie,data:{message:Te.message,name:Te.name,stack:Te.stack?Te.stack.split?Te.stack.split(`
`):Te.stack:void 0},type:202}):this.sendResponse({id:ie,data:Te,type:203}),this.activeRequests.delete(M.id)});const we=R.toDisposable(()=>B.cancel());this.activeRequests.set(M.id,we)}onEventListen(M){const U=this.channels.get(M.channelName);if(!U){this.collectPendingRequest(M);return}const B=M.id,ie=U.listen(this.ctx,M.name,M.arg)(we=>this.sendResponse({id:B,data:we,type:204}));this.activeRequests.set(M.id,ie)}disposeActiveRequest(M){const U=this.activeRequests.get(M.id);U&&(U.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let U=this.pendingRequests.get(M.channelName);U||(U=[],this.pendingRequests.set(M.channelName,U));const B=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);U.push({request:M,timeoutTimer:B})}flushPendingRequests(M){const U=this.pendingRequests.get(M);if(U){for(const B of U)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=h;var b;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(b=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,U=null){this.protocol=M,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=U}getChannel(M){const U=this;return{call(B,K,ie){return U.isDisposed?Promise.reject(A.canceled()):U.requestPromise(M,B,K,ie)},listen(B,K){return U.isDisposed?Promise.reject(A.canceled()):U.requestEvent(M,B,K)}}}requestPromise(M,U,B,K=S.CancellationToken.None){const ie=this.lastRequestId++,Te={id:ie,type:100,channelName:M,name:U,arg:B};if(K.isCancellationRequested)return Promise.reject(A.canceled());let ye;return new Promise((je,ze)=>{if(K.isCancellationRequested)return ze(A.canceled());const qe=()=>{const oe=Y=>{switch(Y.type){case 201:this.handlers.delete(ie),je(Y.data);break;case 202:this.handlers.delete(ie);const le=new Error(Y.data.message);le.stack=Y.data.stack,le.name=Y.data.name,ze(le);break;case 203:this.handlers.delete(ie),ze(Y.data);break}};this.handlers.set(ie,oe),this.sendRequest(Te)};let j=null;this.state===w.Idle?qe():(j=k.createCancelablePromise(oe=>this.whenInitialized()),j.then(()=>{j=null,qe()}));const J=()=>{j?(j.cancel(),j=null):this.sendRequest({id:ie,type:101}),ze(A.canceled())},ne=K.onCancellationRequested(J);ye=R.combinedDisposable(R.toDisposable(J),ne),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,U,B){const K=this.lastRequestId++,we={id:K,type:102,channelName:M,name:U,arg:B};let Te=null;const ye=new v.Emitter({onFirstListenerAdd:()=>{Te=k.createCancelablePromise(je=>this.whenInitialized()),Te.then(()=>{Te=null,this.activeRequests.add(ye),this.sendRequest(we)})},onLastListenerRemove:()=>{Te?(Te.cancel(),Te=null):(this.activeRequests.delete(ye),this.sendRequest({id:K,type:103}))}}),Oe=je=>ye.fire(je.data);return this.handlers.set(K,Oe),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const U=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(U,M.id,0,`${c(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const U=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(U,M.id,0,c(M.type));return}}}send(M,U=void 0){const B=new u;return a(B,M),a(B,U),this.sendBuffer(B.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(U){return 0}}onBuffer(M){const U=new E(M),B=p(U),K=p(U),ie=B[0];switch(ie){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,_(ie)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,B[1],0,_(ie),K),this.onResponse({type:B[0],id:B[1],data:K})}}onResponse(M){if(M.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const U=this.handlers.get(M.id);U&&U(M)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}Ve([l.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class o{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:U,onDidClientDisconnect:B})=>{v.Event.once(U.onMessage)(ie=>{const we=new E(ie),Te=p(we),ye=new h(U,Te),Oe=new y(U);this.channels.forEach((ze,qe)=>ye.registerChannel(qe,ze));const je={channelServer:ye,channelClient:Oe,ctx:Te};this._connections.add(je),this._onDidAddConnection.fire(je),B(()=>{ye.dispose(),Oe.dispose(),this._connections.delete(je),this._onDidRemoveConnection.fire(je)})})})}get connections(){const M=[];return this._connections.forEach(U=>M.push(U)),M}getChannel(M,U){const B=this;return{call(K,ie,we){let Te;if(P.isFunction(U)){let Oe=D.getRandomElement(B.connections.filter(U));Te=Oe?Promise.resolve(Oe):v.Event.toPromise(v.Event.filter(B.onDidAddConnection,U))}else Te=U.routeCall(B,K,ie);const ye=Te.then(Oe=>Oe.channelClient.getChannel(M));return O(ye).call(K,ie,we)},listen(K,ie){if(P.isFunction(U))return B.getMulticastEvent(M,U,K,ie);const we=U.routeEvent(B,K,ie).then(Te=>Te.channelClient.getChannel(M));return O(we).listen(K,ie)}}}getMulticastEvent(M,U,B,K){const ie=this;let we=new R.DisposableStore;const Te=new v.Emitter({onFirstListenerAdd:()=>{we=new R.DisposableStore;const ye=new v.EventMultiplexer,Oe=new Map,je=qe=>{const J=qe.channelClient.getChannel(M).listen(B,K),ne=ye.add(J);Oe.set(qe,ne)},ze=qe=>{const j=Oe.get(qe);!j||(j.dispose(),Oe.delete(qe))};ie.connections.filter(U).forEach(je),v.Event.filter(ie.onDidAddConnection,U)(je,void 0,we),ie.onDidRemoveConnection(ze,void 0,we),ye.event(Te.fire,Te,we),we.add(ye)},onLastListenerRemove:()=>{we.dispose()}});return Te.event}registerChannel(M,U){this.channels.set(M,U),this._connections.forEach(B=>{B.channelServer.registerChannel(M,U)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class L{constructor(M,U,B=null){const K=new u;a(K,U),M.send(K.buffer),this.channelClient=new y(M,B),this.channelServer=new h(M,U,B)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,U){this.channelServer.registerChannel(M,U)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=L;function O(F){return{call(M,U,B){return F.then(K=>K.call(M,U,B))},listen(M,U){const B=new v.Relay;return F.then(K=>B.input=K.listen(M,U)),B.event}}}e.getDelayedChannel=O;function W(F){let M=!1;return{call(U,B,K){return M?F.call(U,B,K):k.timeout(0).then(()=>M=!0).then(()=>F.call(U,B,K))},listen(U,B){if(M)return F.listen(U,B);const K=new v.Relay;return k.timeout(0).then(()=>M=!0).then(()=>K.input=F.listen(U,B)),K.event}}}e.getNextTickChannel=W;class ee{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const U of M.connections)if(await Promise.resolve(this.fn(U.ctx)))return Promise.resolve(U);return await v.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=ee;var ce;(function(F){function M(K,ie){const we=K,Te=ie&&ie.disableMarshalling,ye=new Map;for(const Oe in we)B(Oe)&&ye.set(Oe,v.Event.buffer(we[Oe],!0));return new class{listen(Oe,je){const ze=ye.get(je);if(ze)return ze;throw new Error(`Event not found: ${je}`)}call(Oe,je,ze){const qe=we[je];if(typeof qe=="function"){if(!Te&&Array.isArray(ze))for(let j=0;j<ze.length;j++)ze[j]=s.revive(ze[j]);return qe.apply(we,ze)}throw new Error(`Method not found: ${je}`)}}}F.fromService=M;function U(K,ie){const we=ie&&ie.disableMarshalling;return new Proxy({},{get(Te,ye){var Oe;if(typeof ye=="string")return((Oe=ie==null?void 0:ie.properties)===null||Oe===void 0?void 0:Oe.has(ye))?ie.properties.get(ye):B(ye)?K.listen(ye):async function(...je){let ze;ie&&!P.isUndefinedOrNull(ie.context)?ze=[ie.context,...je]:ze=je;const qe=await K.call(ye,ze);return we?qe:s.revive(qe)};throw new Error(`Property not found: ${String(ye)}`)}})}F.toService=U;function B(K){return K[0]==="o"&&K[1]==="n"&&I.isUpperAsciiLetter(K.charCodeAt(2))}})(ce=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function V(F){return Array.isArray(F)?F.map(x):x(F)}function T(F,M,U,B,K,ie,we){we=V(we);const Te=G[K],ye=Te[B%Te.length];let Oe=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${ie}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(ie)?(Oe=Oe.concat(we),Oe.push(")")):Oe.push(we),console.log.apply(console,Oe)}e.logWithColors=T;class N{constructor(M,U){this._outgoingPrefix=M,this._incomingPrefix=U,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,U,B,K,ie){this._totalOutgoing+=M,T(this._outgoingPrefix,this._totalOutgoing,M,U,B,K,ie)}logIncoming(M,U,B,K,ie){this._totalIncoming+=M,T(this._incomingPrefix,this._totalIncoming,M,U,B,K,ie)}}e.IPCLogger=N}),define(ge[102],pe([0,1,3,101,6,22,11,37]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=S.VSBuffer.alloc(0)),D}class s{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,i){if(n===0)return P();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const b=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=n),b}if(this._chunks[0].byteLength>n){const b=this._chunks[0].slice(0,n);return i&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),b}let a=S.VSBuffer.alloc(n),p=0,h=0;for(;n>0;){const b=this._chunks[h];if(b.byteLength>n){const y=b.slice(0,n);a.set(y,p),p+=n,i&&(this._chunks[h]=b.slice(n),this._totalLength-=n),n-=n}else a.set(b,p),p+=b.byteLength,i?(this._chunks.shift(),this._totalLength-=b.byteLength):h++,n-=b.byteLength}return a}}e.ChunkStream=s;var I;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(I||(I={}));var l;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(l=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(n,i,a,p){this.type=n,this.id=i,this.ack=a,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends k.Disposable{constructor(n){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new s,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const a=this._state.messageType,p=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new g(a,p,h,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=S.VSBuffer.alloc(13);i.writeUInt8(n.type,0),i.writeUInt32BE(n.id,1),i.writeUInt32BE(n.ack,5),i.writeUInt32BE(n.data.byteLength,9),this._writeSoon(i,n.data)}_bufferAdd(n,i){const a=this._totalLength===0;return this._data.push(n,i),this._totalLength+=n.byteLength+i.byteLength,a}_bufferTake(){const n=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,i){this._bufferAdd(n,i)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class _ extends k.Disposable{constructor(n){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new c(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new g(1,0,0,n))}}e.Protocol=_;class w extends R.IPCClient{constructor(n,i,a=null){super(n,i,a);this.protocol=n}static fromSocket(n,i){return new w(new _(n),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=w;class E{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,C.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=E;class u{constructor(n){this.data=n,this.next=null}}class d{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],i=0,a=this._first;for(;a;)n[i++]=a.data,a=a.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const i=new u(n);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class f{constructor(){this.lastRuns=[];const n=Date.now();for(let i=0;i<f._HISTORY_LENGTH;i++)this.lastRuns[i]=n-1e3*i;setInterval(()=>{for(let i=f._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const n=Date.now(),i=(1+f._HISTORY_LENGTH)*1e3;let a=0;for(let p=0;p<f._HISTORY_LENGTH;p++)n-this.lastRuns[p]<=i&&a++;return 1-a/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class t{constructor(n,i=null){this._loadEstimator=f.getInstance(),this._onControlMessage=new E,this.onControlMessage=this._onControlMessage.event,this._onMessage=new E,this.onMessage=this._onMessage.event,this._onDidDispose=new E,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new E,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new E,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new d,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=k.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new g(5,0,0,P());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const i=new g(4,0,0,P());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,i){this._isReconnecting=!0,this._socketDisposables=k.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new c(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let i=0,a=n.length;i<a;i++)this._socketWriter.write(n[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new g(6,0,0,P())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const i=this._outgoingUnackMsg.toArray();for(let a=0,p=i.length;a<p;a++)this._socketWriter.write(i[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new g(1,i,this._incomingAckId,n);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(n){const i=new g(2,0,0,n);this._socketWriter.write(i)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),i=Date.now()-n.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new g(3,0,this._incomingAckId,P());this._socketWriter.write(n)}}e.PersistentProtocol=t}),define(ge[103],pe([0,1,92]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(C){let D=v.toUint8(C);this._defaultValue=D,this._asciiMap=R._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=C;return D}set(C,D){let P=v.toUint8(D);C>=0&&C<256?this._asciiMap[C]=P:this._map.set(C,P)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=R;var k;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(k||(k={}));class S{constructor(){this._actual=new R(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=S}),define(ge[138],pe([0,1,103]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class k extends v.CharacterClassifier{constructor(C){super(0);for(let D=0,P=C.length;D<P;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=k;function S(A){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=A(D)),C[D])}e.getMapForWordSeparators=S(A=>new k(A))}),define(ge[44],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class v{constructor(k,S){this.lineNumber=k,this.column=S}with(k=this.lineNumber,S=this.column){return k===this.lineNumber&&S===this.column?this:new v(k,S)}delta(k=0,S=0){return this.with(this.lineNumber+k,this.column+S)}equals(k){return v.equals(this,k)}static equals(k,S){return!k&&!S?!0:!!k&&!!S&&k.lineNumber===S.lineNumber&&k.column===S.column}isBefore(k){return v.isBefore(this,k)}static isBefore(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<S.column}isBeforeOrEqual(k){return v.isBeforeOrEqual(this,k)}static isBeforeOrEqual(k,S){return k.lineNumber<S.lineNumber?!0:S.lineNumber<k.lineNumber?!1:k.column<=S.column}static compare(k,S){let A=k.lineNumber|0,C=S.lineNumber|0;if(A===C){let D=k.column|0,P=S.column|0;return D-P}return A-C}clone(){return new v(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(k){return new v(k.lineNumber,k.column)}static isIPosition(k){return k&&typeof k.lineNumber=="number"&&typeof k.column=="number"}}e.Position=v}),define(ge[41],pe([0,1,44]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(S,A,C,D){S>C||S===C&&A>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=S,this.endColumn=A):(this.startLineNumber=S,this.startColumn=A,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,A){return!(A.lineNumber<S.startLineNumber||A.lineNumber>S.endLineNumber||A.lineNumber===S.startLineNumber&&A.column<S.startColumn||A.lineNumber===S.endLineNumber&&A.column>S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<=S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,A){let C,D,P,s;return A.startLineNumber<S.startLineNumber?(C=A.startLineNumber,D=A.startColumn):A.startLineNumber===S.startLineNumber?(C=A.startLineNumber,D=Math.min(A.startColumn,S.startColumn)):(C=S.startLineNumber,D=S.startColumn),A.endLineNumber>S.endLineNumber?(P=A.endLineNumber,s=A.endColumn):A.endLineNumber===S.endLineNumber?(P=A.endLineNumber,s=Math.max(A.endColumn,S.endColumn)):(P=S.endLineNumber,s=S.endColumn),new R(C,D,P,s)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,A){let C=S.startLineNumber,D=S.startColumn,P=S.endLineNumber,s=S.endColumn,I=A.startLineNumber,l=A.startColumn,g=A.endLineNumber,c=A.endColumn;return C<I?(C=I,D=l):C===I&&(D=Math.max(D,l)),P>g?(P=g,s=c):P===g&&(s=Math.min(s,c)),C>P||C===P&&D>s?null:new R(C,D,P,s)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,A){return!!S&&!!A&&S.startLineNumber===A.startLineNumber&&S.startColumn===A.startColumn&&S.endLineNumber===A.endLineNumber&&S.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new v.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new v.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,A){return new R(this.startLineNumber,this.startColumn,S,A)}setStartPosition(S,A){return new R(S,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,A=S){return new R(S.lineNumber,S.column,A.lineNumber,A.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn)}static areIntersecting(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,A){if(S&&A){const P=S.startLineNumber|0,s=A.startLineNumber|0;if(P===s){const I=S.startColumn|0,l=A.startColumn|0;if(I===l){const g=S.endLineNumber|0,c=A.endLineNumber|0;if(g===c){const m=S.endColumn|0,_=A.endColumn|0;return m-_}return g-c}return I-l}return P-s}return(S?1:0)-(A?1:0)}static compareRangesUsingEnds(S,A){return S.endLineNumber===A.endLineNumber?S.endColumn===A.endColumn?S.startLineNumber===A.startLineNumber?S.startColumn-A.startColumn:S.startLineNumber-A.startLineNumber:S.endColumn-A.endColumn:S.endLineNumber-A.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=R}),define(ge[139],pe([0,1,44,41]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var k;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(k=e.SelectionDirection||(e.SelectionDirection={}));class S extends R.Range{constructor(C,D,P,s){super(C,D,P,s);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return S.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,C,D):new S(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new v.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new S(C,D,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new S(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new S(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let P=0,s=C.length;P<s;P++)if(!this.selectionsEqual(C[P],D[P]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,P,s,I){return I===0?new S(C,D,P,s):new S(P,s,C,D)}}e.Selection=S}),define(ge[104],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var v;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(v=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var k;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(k=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(m){this.tabSize=Math.max(1,m.tabSize|0),this.indentSize=m.tabSize|0,this.insertSpaces=Boolean(m.insertSpaces),this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=Boolean(m.trimAutoWhitespace)}equals(m){return this.tabSize===m.tabSize&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(m,_){this.range=m,this.matches=_}}e.FindMatch=D;var P;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var s;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(s=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class l{constructor(m,_,w,E,u,d){this.identifier=m,this.range=_,this.text=w,this.forceMoveMarkers=E,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=l;class g{constructor(m,_,w){this.reverseEdits=m,this.changes=_,this.trimAutoWhitespaceLineNumbers=w}}e.ApplyEditsResult=g}),define(ge[140],pe([0,1,8,138,44,41,104]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(u,d,f,t){this.searchString=u,this.isRegex=d,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=P(this.searchString):u=this.searchString.indexOf(`
`)>=0;let d=null;try{d=v.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let f=!this.isRegex&&!u;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new s(d,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=D;function P(E){if(!E||E.length===0)return!1;for(let u=0,d=E.length;u<d;u++)if(E.charCodeAt(u)===92){if(u++,u>=d)break;const t=E.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class s{constructor(u,d,f){this.regex=u,this.wordSeparators=d,this.simpleSearch=f}}e.SearchData=s;function I(E,u,d){if(!d)return new A.FindMatch(E,null);let f=[];for(let t=0,r=u.length;t<r;t++)f[t]=u[t];return new A.FindMatch(E,f)}e.createFindMatch=I;class l{constructor(u){let d=[],f=0;for(let t=0,r=u.length;t<r;t++)u.charCodeAt(t)===10&&(d[f++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(u){const d=this._lineFeedsOffsets;let f=0,t=d.length-1;if(t===-1||u<=d[0])return 0;for(;f<t;){const r=f+((t-f)/2>>0);d[r]>=u?t=r-1:d[r+1]>=u?(f=r,t=r):f=r+1}return f+1}}class g{static findMatches(u,d,f,t,r){const n=d.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(u,f,new w(n.wordSeparators,n.regex),t,r):this._doFindMatchesLineByLine(u,f,n,t,r):[]}static _getMultilineMatchRange(u,d,f,t,r,n){let i,a=0;t?(a=t.findLineFeedCountBeforeOffset(r),i=d+r+a):i=d+r;let p;if(t){let o=t.findLineFeedCountBeforeOffset(r+n.length)-a;p=i+n.length+o}else p=i+n.length;const h=u.getPositionAt(i),b=u.getPositionAt(p);return new S.Range(h.lineNumber,h.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(u,d,f,t,r){const n=u.getOffsetAt(d.getStartPosition()),i=u.getValueInRange(d,1),a=u.getEOL()===`\r
`?new l(i):null,p=[];let h=0,b;for(f.reset(0);b=f.next(i);)if(p[h++]=I(this._getMultilineMatchRange(u,n,i,a,b.index,b[0]),b,t),h>=r)return p;return p}static _doFindMatchesLineByLine(u,d,f,t,r){const n=[];let i=0;if(d.startLineNumber===d.endLineNumber){const p=u.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return i=this._findMatchesInLine(f,p,d.startLineNumber,d.startColumn-1,i,n,t,r),n}const a=u.getLineContent(d.startLineNumber).substring(d.startColumn-1);i=this._findMatchesInLine(f,a,d.startLineNumber,d.startColumn-1,i,n,t,r);for(let p=d.startLineNumber+1;p<d.endLineNumber&&i<r;p++)i=this._findMatchesInLine(f,u.getLineContent(p),p,0,i,n,t,r);if(i<r){const p=u.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);i=this._findMatchesInLine(f,p,d.endLineNumber,0,i,n,t,r)}return n}static _findMatchesInLine(u,d,f,t,r,n,i,a){const p=u.wordSeparators;if(!i&&u.simpleSearch){const y=u.simpleSearch,o=y.length,L=d.length;let O=-o;for(;(O=d.indexOf(y,O+o))!==-1;)if((!p||_(p,d,L,O,o))&&(n[r++]=new A.FindMatch(new S.Range(f,O+1+t,f,O+1+o+t),null),r>=a))return r;return r}const h=new w(u.wordSeparators,u.regex);let b;h.reset(0);do if(b=h.next(d),b&&(n[r++]=I(new S.Range(f,b.index+1+t,f,b.index+1+b[0].length+t),b,i),r>=a))return r;while(b);return r}static findNextMatch(u,d,f,t){const r=d.parseSearchRequest();if(!r)return null;const n=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(u,f,n,t):this._doFindNextMatchLineByLine(u,f,n,t)}static _doFindNextMatchMultiline(u,d,f,t){const r=new k.Position(d.lineNumber,1),n=u.getOffsetAt(r),i=u.getLineCount(),a=u.getValueInRange(new S.Range(r.lineNumber,r.column,i,u.getLineMaxColumn(i)),1),p=u.getEOL()===`\r
`?new l(a):null;f.reset(d.column-1);let h=f.next(a);return h?I(this._getMultilineMatchRange(u,n,a,p,h.index,h[0]),h,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(u,new k.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(u,d,f,t){const r=u.getLineCount(),n=d.lineNumber,i=u.getLineContent(n),a=this._findFirstMatchInLine(f,i,n,d.column,t);if(a)return a;for(let p=1;p<=r;p++){const h=(n+p-1)%r,b=u.getLineContent(h+1),y=this._findFirstMatchInLine(f,b,h+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(u,d,f,t,r){u.reset(t-1);const n=u.next(d);return n?I(new S.Range(f,n.index+1,f,n.index+1+n[0].length),n,r):null}static findPreviousMatch(u,d,f,t){const r=d.parseSearchRequest();if(!r)return null;const n=new w(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(u,f,n,t):this._doFindPreviousMatchLineByLine(u,f,n,t)}static _doFindPreviousMatchMultiline(u,d,f,t){const r=this._doFindMatchesMultiline(u,new S.Range(1,1,d.lineNumber,d.column),f,t,10*C);if(r.length>0)return r[r.length-1];const n=u.getLineCount();return d.lineNumber!==n||d.column!==u.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(u,new k.Position(n,u.getLineMaxColumn(n)),f,t):null}static _doFindPreviousMatchLineByLine(u,d,f,t){const r=u.getLineCount(),n=d.lineNumber,i=u.getLineContent(n).substring(0,d.column-1),a=this._findLastMatchInLine(f,i,n,t);if(a)return a;for(let p=1;p<=r;p++){const h=(r+n-p-1)%r,b=u.getLineContent(h+1),y=this._findLastMatchInLine(f,b,h+1,t);if(y)return y}return null}static _findLastMatchInLine(u,d,f,t){let r=null,n;for(u.reset(0);n=u.next(d);)r=I(new S.Range(f,n.index+1,f,n.index+1+n[0].length),n,t);return r}}e.TextModelSearch=g;function c(E,u,d,f,t){if(f===0)return!0;const r=u.charCodeAt(f-1);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const n=u.charCodeAt(f);if(E.get(n)!==0)return!0}return!1}function m(E,u,d,f,t){if(f+t===d)return!0;const r=u.charCodeAt(f+t);if(E.get(r)!==0||r===13||r===10)return!0;if(t>0){const n=u.charCodeAt(f+t-1);if(E.get(n)!==0)return!0}return!1}function _(E,u,d,f,t){return c(E,u,d,f,t)&&m(E,u,d,f,t)}e.isValidMatch=_;class w{constructor(u,d){this._wordSeparators=u,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const d=u.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(f=this._searchRegex.exec(u),!f))return null;const t=f.index,r=f[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){v.getNextCodePoint(u,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||_(this._wordSeparators,u,d,t,r))return f}while(f);return null}}e.Searcher=w}),define(ge[105],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function v(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)C.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=v();function R(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let P="g";C.ignoreCase&&(P+="i"),C.multiline&&(P+="m"),C.unicode&&(P+="u"),D=new RegExp(C.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=R;const k={maxLen:1e3,windowSize:15,timeBudget:150};function S(C,D,P,s,I=k){if(P.length>I.maxLen){let _=C-I.maxLen/2;return _<0?_=0:s+=_,P=P.substring(_,C+I.maxLen/2),S(C,D,P,s,I)}const l=Date.now(),g=C-1-s;let c=-1,m=null;for(let _=1;!(Date.now()-l>=I.timeBudget);_++){const w=g-I.windowSize*_;D.lastIndex=Math.max(0,w);const E=A(D,P,g,c);if(!E&&m||(m=E,w<=0))break;c=w}if(m){let _={word:m[0],startColumn:s+1+m.index,endColumn:s+1+m.index+m[0].length};return D.lastIndex=0,_}return null}e.getWordAtText=S;function A(C,D,P,s){let I;for(;I=C.exec(D);){const l=I.index||0;if(l<=P&&C.lastIndex>=P)return I;if(s>0&&l>s)return null}return null}}),define(ge[141],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var v;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(v=e.IndentAction||(e.IndentAction={}));class R{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,P=C.notIn.length;D<P;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=R;class k{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)S(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),S(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),S(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),S(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&S(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=k;function S(A,C,D){A.has(C)?A.get(C).push(D):A.set(C,[D])}}),define(ge[77],pe([0,1,30,9]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function k(S,A,C,D){if(Array.isArray(S)){let P=0;for(const s of S){const I=k(s,A,C,D);if(I===10)return I;I>P&&(P=I)}return P}else{if(typeof S=="string")return D?S==="*"?5:S===C?10:0:0;if(S){const{language:P,pattern:s,scheme:I,hasAccessToAllModels:l}=S;if(!D&&!l)return 0;let g=0;if(I)if(I===A.scheme)g=10;else if(I==="*")g=5;else return 0;if(P)if(P===C)g=10;else if(P==="*")g=Math.max(g,5);else return 0;if(s){let c;if(typeof s=="string"?c=s:c=Object.assign(Object.assign({},s),{base:R.normalize(s.base)}),c===A.fsPath||v.match(c,A.fsPath))g=10;else return 0}return g}else return 0}}e.score=k}),define(ge[142],pe([0,1,103]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class k{constructor(c,m,_){const w=new Uint8Array(c*m);for(let E=0,u=c*m;E<u;E++)w[E]=_;this._data=w,this.rows=c,this.cols=m}get(c,m){return this._data[c*this.cols+m]}set(c,m,_){this._data[c*this.cols+m]=_}}e.Uint8Matrix=k;class S{constructor(c){let m=0,_=0;for(let E=0,u=c.length;E<u;E++){let[d,f,t]=c[E];f>m&&(m=f),d>_&&(_=d),t>_&&(_=t)}m++,_++;let w=new k(_,m,0);for(let E=0,u=c.length;E<u;E++){let[d,f,t]=c[E];w.set(d,f,t)}this._states=w,this._maxCharCode=m}nextState(c,m){return m<0||m>=this._maxCharCode?0:this._states.get(c,m)}}e.StateMachine=S;let A=null;function C(){return A===null&&(A=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var D;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function s(){if(P===null){P=new v.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<g.length;m++)P.set(g.charCodeAt(m),1);const c=".,;";for(let m=0;m<c.length;m++)P.set(c.charCodeAt(m),2)}return P}class I{static _createLink(c,m,_,w,E){let u=E-1;do{const d=m.charCodeAt(u);if(c.get(d)!==2)break;u--}while(u>w);if(w>0){const d=m.charCodeAt(w-1),f=m.charCodeAt(u);(d===40&&f===41||d===91&&f===93||d===123&&f===125)&&u--}return{range:{startLineNumber:_,startColumn:w+1,endLineNumber:_,endColumn:u+2},url:m.substring(w,u+1)}}static computeLinks(c,m=C()){const _=s();let w=[];for(let E=1,u=c.getLineCount();E<=u;E++){const d=c.getLineContent(E),f=d.length;let t=0,r=0,n=0,i=1,a=!1,p=!1,h=!1,b=!1;for(;t<f;){let y=!1;const o=d.charCodeAt(t);if(i===13){let L;switch(o){case 40:a=!0,L=0;break;case 41:L=a?0:1;break;case 91:h=!0,p=!0,L=0;break;case 93:h=!1,L=p?0:1;break;case 123:b=!0,L=0;break;case 125:L=b?0:1;break;case 39:L=n===34||n===96?0:1;break;case 34:L=n===39||n===96?0:1;break;case 96:L=n===39||n===34?0:1;break;case 42:L=n===42?1:0;break;case 124:L=n===124?1:0;break;case 32:L=h?0:1;break;default:L=_.get(o)}L===1&&(w.push(I._createLink(_,d,E,r,t)),y=!0)}else if(i===12){let L;o===91?(p=!0,L=0):L=_.get(o),L===1?y=!0:i=13}else i=m.nextState(i,o),i===0&&(y=!0);y&&(i=1,a=!1,p=!1,b=!1,r=t+1,n=o),t++}i===13&&w.push(I._createLink(_,d,E,r,f))}return w}}e.LinkComputer=I;function l(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:I.computeLinks(g)}e.computeLinks=l}),define(ge[143],pe([0,1,3,6]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class k{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new v.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,C){return this._map.set(A,C),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===C&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,C){let D=null,P=!1;return this._promises.set(A,C.then(s=>{this._promises.delete(A),!(P||!s)&&(D=this.register(A,s))})),R.toDisposable(()=>{P=!0,D&&D.dispose()})}getPromise(A){const C=this.get(A);if(C)return Promise.resolve(C);const D=this._promises.get(A);return D?D.then(P=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=k}),define(ge[106],pe([0,1,22,11]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var k;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(k||(k={}));function S(I){for(let l=0,g=I.length;l<g;l+=4){const c=I[l+0],m=I[l+1],_=I[l+2],w=I[l+3];I[l+0]=w,I[l+1]=_,I[l+2]=m,I[l+3]=c}}function A(I){const l=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||S(l),v.VSBuffer.wrap(l)}function C(I){const l=I.buffer;if(R.isLittleEndian()||S(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const g=new Uint8Array(l.byteLength);return g.set(l),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(I){const l=new Uint32Array(P(I));let g=0;if(l[g++]=I.id,I.type==="full")l[g++]=1,l[g++]=I.data.length,l.set(I.data,g),g+=I.data.length;else{l[g++]=2,l[g++]=I.deltas.length;for(const c of I.deltas)l[g++]=c.start,l[g++]=c.deleteCount,c.data?(l[g++]=c.data.length,l.set(c.data,g),g+=c.data.length):l[g++]=0}return A(l)}e.encodeSemanticTokensDto=D;function P(I){let l=0;if(l+=1+1,I.type==="full")l+=1+I.data.length;else{l+=1,l+=(1+1+1)*I.deltas.length;for(const g of I.deltas)g.data&&(l+=g.data.length)}return l}function s(I){const l=C(I);let g=0;const c=l[g++];if(l[g++]===1){const E=l[g++],u=l.subarray(g,g+E);return g+=E,{id:c,type:"full",data:u}}const _=l[g++];let w=[];for(let E=0;E<_;E++){const u=l[g++],d=l[g++],f=l[g++];let t;f>0&&(t=l.subarray(g,g+f),g+=f),w[E]={start:u,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:w}}e.decodeSemanticTokensDto=s}),define(ge[107],pe([0,1,92]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,C){this.index=A,this.remainder=C}}e.PrefixSumIndexOfResult=R;class k{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,C){A=v.toUint32(A);const D=this.values,P=this.prefixSum,s=C.length;return s===0?!1:(this.values=new Uint32Array(D.length+s),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A),A+s),this.values.set(C,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,C){return A=v.toUint32(A),C=v.toUint32(C),this.values[A]===C?!1:(this.values[A]=C,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,C){A=v.toUint32(A),C=v.toUint32(C);const D=this.values,P=this.prefixSum;if(A>=D.length)return!1;let s=D.length-A;return C>=s&&(C=s),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,A),0),this.values.set(D.subarray(A+C),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(A){return A<0?0:(A=v.toUint32(A),this._getAccumulatedValue(A))}_getAccumulatedValue(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),A>=this.values.length&&(A=this.values.length-1);for(let D=C;D<=A;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalValue();let C=0,D=this.values.length-1,P=0,s=0,I=0;for(;C<=D;)if(P=C+(D-C)/2|0,s=this.prefixSum[P],I=s-this.values[P],A<I)D=P-1;else if(A>=s)C=P+1;else break;return new R(P,A-I)}}e.PrefixSumComputer=k}),define(ge[144],pe([0,1,8,44,107]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(C,D,P,s){this._uri=C,this._lines=D,this._eol=P,this._versionId=s,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new R.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let s=0;s<D;s++)P[s]=this._lines[s].length+C;this._lineStarts=new k.PrefixSumComputer(P)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length===0)return;let P=v.splitLines(D);if(P.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}P[P.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+P[0]);let s=new Uint32Array(P.length-1);for(let I=1;I<P.length;I++)this._lines.splice(C.lineNumber+I-1,0,P[I]),s[I-1]=P[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,s)}}e.MirrorTextModel=S}),define(ge[145],pe([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(ge[146],pe([0,1,145]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,k=R*60,S=k*24,A=S*7,C=S*30,D=S*365;function P(I,l){typeof I!="number"&&(I=I.getTime());const g=Math.round((new Date().getTime()-I)/1e3);if(g<-30)return v.localize(0,null,P(new Date().getTime()+g*1e3,!1));if(g<30)return v.localize(1,null);let c;return g<R?(c=g,l?c===1?v.localize(2,null,c):v.localize(3,null,c):c===1?v.localize(4,null,c):v.localize(5,null,c)):g<k?(c=Math.floor(g/R),l?c===1?v.localize(6,null,c):v.localize(7,null,c):c===1?v.localize(8,null,c):v.localize(9,null,c)):g<S?(c=Math.floor(g/k),l?c===1?v.localize(10,null,c):v.localize(11,null,c):c===1?v.localize(12,null,c):v.localize(13,null,c)):g<A?(c=Math.floor(g/S),l?c===1?v.localize(14,null,c):v.localize(15,null,c):c===1?v.localize(16,null,c):v.localize(17,null,c)):g<C?(c=Math.floor(g/A),l?c===1?v.localize(18,null,c):v.localize(19,null,c):c===1?v.localize(20,null,c):v.localize(21,null,c)):g<D?(c=Math.floor(g/C),l?c===1?v.localize(22,null,c):v.localize(23,null,c):c===1?v.localize(24,null,c):v.localize(25,null,c)):(c=Math.floor(g/D),l?c===1?v.localize(26,null,c):v.localize(27,null,c):c===1?v.localize(28,null,c):v.localize(29,null,c))}e.fromNow=P;function s(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=s}),define(ge[147],pe([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ge[55],pe([0,1,147,13,17]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(P,s){return s&&(P.stack||P.stacktrace)?v.localize(0,null,C(P),A(P.stack)||A(P.stacktrace)):C(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function C(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?v.localize(1,null,P.message):P.message||v.localize(2,null)}function D(P=null,s=!1){if(!P)return v.localize(3,null);if(Array.isArray(P)){const I=k.coalesce(P),l=D(I[0],s);return I.length>1?v.localize(4,null,l,I.length):l}if(R.isString(P))return P;if(P.detail){const I=P.detail;if(I.error)return S(I.error,s);if(I.exception)return S(I.exception,s)}return P.stack?S(P,s):P.message?P.message:v.localize(5,null)}e.toErrorMessage=D}),define(ge[148],pe([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ge[108],pe([0,1,9,28,38,148,37,13,25,29,11,137,10]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,f){if(s.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};f&&(t.cwd=f);const r=k.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(n=>{r.once("error",i=>{n({success:!1,error:i})}),r.once("exit",(i,a)=>{n(i===0?{success:!0}:{success:!1,code:i!==null?i:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(s.isLinux||s.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(r=>{k.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(n,i,a)=>{r(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function m(d=A.env){return d.comspec||"cmd.exe"}e.getWindowsShell=m;class _{constructor(f,t,r,n){if(t!==void 0&&r!==void 0&&n!==void 0)this.cmd=f,this.args=t,this.shell=r,this.options=n;else{const i=f;this.cmd=i.command,this.shell=i.isShellCommand,this.args=i.args.slice(0),this.options=i.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const i=Object.create(null);Object.keys(A.env).forEach(a=>{i[a]=A.env[a]}),Object.keys(this.options.env).forEach(a=>{i[a]=this.options.env[a]}),this.options.env=i}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const t=f.lastIndexOf(v.sep);return t!==-1&&(f=f.substring(t+1)),_.WellKnowCommands[f]?f:"other"}start(f){return s.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(A.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let r,n;const i=new Promise((a,p)=>{r=a,n=p});if(t){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=k.exec(a,this.options,(p,h,b)=>{this.childProcess=null;const y=p;y&&y.killed?n({killed:this.terminateRequested,stdout:h.toString(),stderr:b.toString()}):this.handleExec(r,f,p,h,b)})}else{let a=null;const p=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,f,n);const b={terminated:this.terminateRequested};C.isNumber(h)&&(b.cmdCode=h),r(b)};if(this.shell&&s.isWindows){const h=D.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let b=!1,y=!1;const o=[];let L=this.ensureQuotes(this.cmd);o.push(L.value),b=L.quoted,this.args&&this.args.forEach(W=>{L=this.ensureQuotes(W),o.push(L.value),y=y&&L.quoted});const O=["/s","/c"];b?y?O.push('"'+o.join(" ")+'"'):o.length>1?O.push('"'+o[0]+'" '+o.slice(1).join(" ")):O.push('"'+o[0]+'"'):O.push(o.join(" ")),a=k.spawn(m(),O,h)}else this.cmd&&(a=k.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",h=>{this.childProcess=null,n({terminated:this.terminateRequested,error:h})}),a.pid&&(this.childProcess.on("close",p),this.handleSpawn(a,r,f,n,!0)))}return i})}handleClose(f,t,r,n){}ensureQuotes(f){return _.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,c(f,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!s.isWindows)return f(!1);const t=k.spawn(m(),["/s","/c"]);t.on("error",r=>f(!0)),t.on("exit",r=>f(!1))})}}e.AbstractProcess=_,_.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},_.regexp=/^[^"].* .*[^"]/;class w extends _{constructor(f,t,r,n){super(f,t,r,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,t,r,n,i){[n,i].forEach((a,p)=>{const h=new I.LineDecoder;h.write(a).forEach(o=>{t({line:o,source:p===0?0:1})});const y=h.end();y&&t({line:y,source:p===0?0:1})}),f({terminated:this.terminateRequested,error:r})}handleSpawn(f,t,r,n,i){const a=new I.LineDecoder,p=new I.LineDecoder;f.stdout.on("data",h=>{a.write(h).forEach(y=>r({line:y,source:0}))}),f.stderr.on("data",h=>{p.write(h).forEach(y=>r({line:y,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=p}handleClose(f,t,r,n){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&r({line:i,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&r({line:a,source:1})}}e.LineProcess=w;function E(d){let f=[],t=!1;const r=function(n){if(t){f.push(n);return}(!d.send(n,a=>{if(a&&console.error(a),t=!1,f.length>0){const p=f.slice(0);f=[],p.forEach(h=>r(h))}})||s.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=E;var u;(function(d){async function f(t,r,n){if(v.isAbsolute(t))return t;if(r===void 0&&(r=A.cwd()),v.dirname(t)!=="."||(n===void 0&&C.isString(A.env.PATH)&&(n=A.env.PATH.split(v.delimiter)),n===void 0||n.length===0))return v.join(r,t);async function a(p){return await R.exists(p)?!(await R.Promises.stat(p)).isDirectory():!1}for(let p of n){let h;if(v.isAbsolute(p)?h=v.join(p,t):h=v.join(r,p,t),await a(h))return h;let b=h+".com";if(await a(b)||(b=h+".exe",await a(b)))return b}return v.join(r,t)}d.findExecutable=f})(u=e.win32||(e.win32={}))}),define(ge[149],pe([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(ge[150],pe([0,1,149,11,105]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(re){this._values=re}hasChanged(re){return this._values[re]}}e.ConfigurationChangedEvent=A;class C{constructor(){this._values=[]}_read(re){return this._values[re]}get(re){return this._values[re]}_write(re,ve){this._values[re]=ve}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(re,ve,Me,Ne){this.id=re,this.name=ve,this.defaultValue=Me,this.schema=Ne}compute(re,ve,Me){return Me}}class s{constructor(re,ve=null){this.schema=void 0,this.id=re,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(re){return this.defaultValue}}class I{constructor(re,ve,Me,Ne){this.id=re,this.name=ve,this.defaultValue=Me,this.schema=Ne}validate(re){return typeof re=="undefined"?this.defaultValue:re}compute(re,ve,Me){return Me}}function l(Q,re){return typeof Q=="undefined"?re:Q==="false"?!1:Boolean(Q)}e.boolean=l;class g extends I{constructor(re,ve,Me,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Me),super(re,ve,Me,Ne)}validate(re){return l(re,this.defaultValue)}}class c extends I{constructor(re,ve,Me,Ne,Ye,Se=void 0){typeof Se!="undefined"&&(Se.type="integer",Se.default=Me,Se.minimum=Ne,Se.maximum=Ye),super(re,ve,Me,Se),this.minimum=Ne,this.maximum=Ye}static clampedInt(re,ve,Me,Ne){if(typeof re=="undefined")return ve;let Ye=parseInt(re,10);return isNaN(Ye)?ve:(Ye=Math.max(Me,Ye),Ye=Math.min(Ne,Ye),Ye|0)}validate(re){return c.clampedInt(re,this.defaultValue,this.minimum,this.maximum)}}class m extends I{constructor(re,ve,Me,Ne,Ye){typeof Ye!="undefined"&&(Ye.type="number",Ye.default=Me),super(re,ve,Me,Ye),this.validationFn=Ne}static clamp(re,ve,Me){return re<ve?ve:re>Me?Me:re}static float(re,ve){if(typeof re=="number")return re;if(typeof re=="undefined")return ve;const Me=parseFloat(re);return isNaN(Me)?ve:Me}validate(re){return this.validationFn(m.float(re,this.defaultValue))}}class _ extends I{static string(re,ve){return typeof re!="string"?ve:re}constructor(re,ve,Me,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Me),super(re,ve,Me,Ne)}validate(re){return _.string(re,this.defaultValue)}}function w(Q,re,ve){return typeof Q!="string"||ve.indexOf(Q)===-1?re:Q}e.stringSet=w;class E extends I{constructor(re,ve,Me,Ne,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Ne,Ye.default=Me),super(re,ve,Me,Ye),this._allowedValues=Ne}validate(re){return w(re,this.defaultValue,this._allowedValues)}}class u extends P{constructor(re,ve,Me,Ne,Ye,Se,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.enum=Ye,_e.default=Ne),super(re,ve,Me,_e),this._allowedValues=Ye,this._convert=Se}validate(re){return typeof re!="string"?this.defaultValue:this._allowedValues.indexOf(re)===-1?this.defaultValue:this._convert(re)}}function d(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",description:v.localize(3,null)})}validate(re){switch(re){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(re,ve,Me){return Me===0?re.accessibilitySupport:Me}}class t extends P{constructor(){const re={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",re,{"editor.comments.insertSpace":{type:"boolean",default:re.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:re.ignoreEmptyLines,description:v.localize(5,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertSpace:l(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function n(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(Q){switch(Q){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function p(Q){switch(Q){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class h extends s{constructor(){super(125,[63,31])}compute(re,ve,Me){const Ne=["monaco-editor"];return ve.get(31)&&Ne.push(ve.get(31)),re.extraEditorClassName&&Ne.push(re.extraEditorClassName),ve.get(63)==="default"?Ne.push("mouse-default"):ve.get(63)==="copy"&&Ne.push("mouse-copy"),ve.get(98)&&Ne.push("showUnused"),ve.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class b extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(re,ve,Me){return Me&&re.emptySelectionClipboard}}class y extends P{constructor(){const re={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",re,{"editor.find.cursorMoveOnType":{type:"boolean",default:re.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:re.seedSearchStringFromSelection,description:v.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:re.autoFindInSelection,enumDescriptions:[v.localize(9,null),v.localize(10,null),v.localize(11,null)],description:v.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:re.globalFindClipboard,description:v.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:re.addExtraSpaceOnTop,description:v.localize(14,null)},"editor.find.loop":{type:"boolean",default:re.loop,description:v.localize(15,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{cursorMoveOnType:l(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof re.autoFindInSelection=="boolean"?re.autoFindInSelection?"always":"never":w(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(ve.loop,this.defaultValue.loop)}}}class o extends P{constructor(){super(41,"fontLigatures",o.OFF,{anyOf:[{type:"boolean",description:v.localize(16,null)},{type:"string",description:v.localize(17,null)}],description:v.localize(18,null),default:!1})}validate(re){return typeof re=="undefined"?this.defaultValue:typeof re=="string"?re==="false"?o.OFF:re==="true"?o.ON:re:Boolean(re)?o.ON:o.OFF}}e.EditorFontLigatures=o,o.OFF='"liga" off, "calt" off',o.ON='"liga" on, "calt" on';class L extends s{constructor(){super(40)}compute(re,ve,Me){return re.fontInfo}}class O extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(19,null)})}validate(re){let ve=m.float(re,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(ve,6,100)}compute(re,ve,Me){return re.fontInfo.fontSize}}class W extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:v.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(21,null)})}validate(re){return re==="normal"||re==="bold"?re:String(c.clampedInt(re,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class ee extends P{constructor(){const re={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:re.multiple,enumDescriptions:[v.localize(22,null),v.localize(23,null),v.localize(24,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",re,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:v.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:v.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:v.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:v.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:v.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:re.alternativeDefinitionCommand,enum:Me,description:v.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:re.alternativeTypeDefinitionCommand,enum:Me,description:v.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:re.alternativeDeclarationCommand,enum:Me,description:v.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:re.alternativeImplementationCommand,enum:Me,description:v.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:re.alternativeReferenceCommand,enum:Me,description:v.localize(35,null)}})}validate(re){var ve,Me,Ne,Ye,Se;if(!re||typeof re!="object")return this.defaultValue;const _e=re;return{multiple:w(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=_e.multipleDefinitions)!==null&&ve!==void 0?ve:w(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=_e.multipleTypeDefinitions)!==null&&Me!==void 0?Me:w(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=_e.multipleDeclarations)!==null&&Ne!==void 0?Ne:w(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ye=_e.multipleImplementations)!==null&&Ye!==void 0?Ye:w(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Se=_e.multipleReferences)!==null&&Se!==void 0?Se:w(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends P{constructor(){const re={enabled:!0,delay:300,sticky:!0};super(50,"hover",re,{"editor.hover.enabled":{type:"boolean",default:re.enabled,description:v.localize(36,null)},"editor.hover.delay":{type:"number",default:re.delay,description:v.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:re.sticky,description:v.localize(38,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),delay:c.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:l(ve.sticky,this.defaultValue.sticky)}}}var G;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(G=e.RenderMinimap||(e.RenderMinimap={}));class x extends s{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(re,ve,Me){return x.computeLayout(ve,{memory:re.memory,outerWidth:re.outerWidth,outerHeight:re.outerHeight,isDominatedByLongLines:re.isDominatedByLongLines,lineHeight:re.fontInfo.lineHeight,viewLineCount:re.viewLineCount,lineNumbersDigitCount:re.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:re.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:re.fontInfo.maxDigitWidth,pixelRatio:re.pixelRatio})}static computeContainedMinimapLineCount(re){const ve=re.height/re.lineHeight,Me=re.scrollBeyondLastLine?ve-1:0,Ne=(re.viewLineCount+Me)/(re.pixelRatio*re.height),Ye=Math.floor(re.viewLineCount/Ne);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Me,desiredRatio:Ne,minimapLineCount:Ye}}static _computeMinimapLayout(re,ve){const Me=re.outerWidth,Ne=re.outerHeight,Ye=re.pixelRatio;if(!re.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Se=ve.stableMinimapLayoutInput,_e=Se&&re.outerHeight===Se.outerHeight&&re.lineHeight===Se.lineHeight&&re.typicalHalfwidthCharacterWidth===Se.typicalHalfwidthCharacterWidth&&re.pixelRatio===Se.pixelRatio&&re.scrollBeyondLastLine===Se.scrollBeyondLastLine&&re.minimap.enabled===Se.minimap.enabled&&re.minimap.side===Se.minimap.side&&re.minimap.size===Se.minimap.size&&re.minimap.showSlider===Se.minimap.showSlider&&re.minimap.renderCharacters===Se.minimap.renderCharacters&&re.minimap.maxColumn===Se.minimap.maxColumn&&re.minimap.scale===Se.minimap.scale&&re.verticalScrollbarWidth===Se.verticalScrollbarWidth&&re.isViewportWrapping===Se.isViewportWrapping,ke=re.lineHeight,ae=re.typicalHalfwidthCharacterWidth,fe=re.scrollBeyondLastLine,H=re.minimap.renderCharacters;let Z=Ye>=2?Math.round(re.minimap.scale*2):re.minimap.scale;const ue=re.minimap.maxColumn,Pe=re.minimap.size,Ae=re.minimap.side,xe=re.verticalScrollbarWidth,Be=re.viewLineCount,Qe=re.remainingWidth,rt=re.isViewportWrapping,nt=H?2:3;let Ze=Math.floor(Ye*Ne);const ot=Ze/Ye;let Ee=!1,De=!1,de=nt*Z,q=Z/Ye,Ue=1;if(Pe==="fill"||Pe==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:St,desiredRatio:vt,minimapLineCount:bt}=x.computeContainedMinimapLineCount({viewLineCount:Be,scrollBeyondLastLine:fe,height:Ne,lineHeight:ke,pixelRatio:Ye});if(Be/bt>1)Ee=!0,De=!0,Z=1,de=1,q=Z/Ye;else{let ht=!1,kt=Z+1;if(Pe==="fit"){const _t=Math.ceil((Be+St)*de);rt&&_e&&Qe<=ve.stableFitRemainingWidth?(ht=!0,kt=ve.stableFitMaxMinimapScale):(ht=_t>Ze,rt&&ht?(ve.stableMinimapLayoutInput=re,ve.stableFitRemainingWidth=Qe):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(Pe==="fill"||ht){Ee=!0;const _t=Z;de=Math.min(ke*Ye,Math.max(1,Math.floor(1/vt))),Z=Math.min(kt,Math.max(1,Math.floor(de/nt))),Z>_t&&(Ue=Math.min(2,Z/_t)),q=Z/Ye/Ue,Ze=Math.ceil(Math.max(mt,Be+St)*de),rt&&ht&&(ve.stableFitMaxMinimapScale=Z)}}}const Le=Math.floor(ue*q),Ge=Math.min(Le,Math.max(0,Math.floor((Qe-xe-2)*q/(ae+q)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(Ye*Ge);const lt=Je/Ye;Je=Math.floor(Je*Ue);const ct=H?1:2,it=Ae==="left"?0:Me-Ge-xe;return{renderMinimap:ct,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:Ee,minimapIsSampling:De,minimapScale:Z,minimapLineHeight:de,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:Ze,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:ot}}static computeLayout(re,ve){const Me=ve.outerWidth|0,Ne=ve.outerHeight|0,Ye=ve.lineHeight|0,Se=ve.lineNumbersDigitCount|0,_e=ve.typicalHalfwidthCharacterWidth,ke=ve.maxDigitWidth,ae=ve.pixelRatio,fe=ve.viewLineCount,H=re.get(120),Z=H==="inherit"?re.get(119):H,ue=Z==="inherit"?re.get(115):Z,Pe=re.get(118),Ae=re.get(2),xe=ve.isDominatedByLongLines,Be=re.get(46),Qe=re.get(57).renderType!==0,rt=re.get(58),nt=re.get(92),Ze=re.get(62),ot=re.get(90),Ee=ot.verticalScrollbarSize,De=ot.verticalHasArrows,de=ot.arrowSize,q=ot.horizontalScrollbarSize,Ue=re.get(55),Le=re.get(35);let Ge;if(typeof Ue=="string"&&/^\d+(\.\d+)?ch$/.test(Ue)){const Et=parseFloat(Ue.substr(0,Ue.length-2));Ge=c.clampedInt(Et*_e,0,0,1e3)}else Ge=c.clampedInt(Ue,0,0,1e3);Le&&(Ge+=16);let Je=0;if(Qe){const Et=Math.max(Se,rt);Je=Math.round(Et*ke)}let lt=0;Be&&(lt=Ye);let ct=0,it=ct+lt,mt=it+Je,St=mt+Ge;const vt=Me-lt-Je-Ge;let bt=!1,gt=!1,ht=-1;Ae!==2&&(Z==="inherit"&&xe?(bt=!0,gt=!0):ue==="on"||ue==="bounded"?gt=!0:ue==="wordWrapColumn"&&(ht=Pe));const kt=x._computeMinimapLayout({outerWidth:Me,outerHeight:Ne,lineHeight:Ye,typicalHalfwidthCharacterWidth:_e,pixelRatio:ae,scrollBeyondLastLine:nt,minimap:Ze,verticalScrollbarWidth:Ee,viewLineCount:fe,remainingWidth:vt,isViewportWrapping:gt},ve.memory||new D);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ct+=kt.minimapWidth,it+=kt.minimapWidth,mt+=kt.minimapWidth,St+=kt.minimapWidth);const _t=vt-kt.minimapWidth,It=Math.max(1,Math.floor((_t-Ee-2)/_e)),Lt=De?de:0;return gt&&(ht=Math.max(1,It),ue==="bounded"&&(ht=Math.min(ht,Pe))),{width:Me,height:Ne,glyphMarginLeft:ct,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:Je,decorationsLeft:mt,decorationsWidth:Ge,contentLeft:St,contentWidth:_t,minimap:kt,viewportColumn:It,isWordWrapMinified:bt,isViewportWrapping:gt,wrappingColumn:ht,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:q,overviewRuler:{top:Lt,width:Ee,height:Ne-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=x;class V extends P{constructor(){const re={enabled:!0};super(54,"lightbulb",re,{"editor.lightbulb.enabled":{type:"boolean",default:re.enabled,description:v.localize(39,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:l(re.enabled,this.defaultValue.enabled)}}}class T extends P{constructor(){const re={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",re,{"editor.inlayHints.enabled":{type:"boolean",default:re.enabled,description:v.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:re.fontSize,description:v.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:re.fontFamily,description:v.localize(42,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class N extends c{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:v.localize(43,null)})}compute(re,ve,Me){return re.fontInfo.lineHeight}}class F extends P{constructor(){const re={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",re,{"editor.minimap.enabled":{type:"boolean",default:re.enabled,description:v.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(45,null),v.localize(46,null),v.localize(47,null)],default:re.size,description:v.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:re.side,description:v.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:re.showSlider,description:v.localize(50,null)},"editor.minimap.scale":{type:"number",default:re.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:re.renderCharacters,description:v.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:re.maxColumn,description:v.localize(53,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),size:w(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ve.side,this.defaultValue.side,["right","left"]),showSlider:w(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(ve.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ve.scale,1,1,3),maxColumn:c.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Q){return Q==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class U extends P{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(55,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{top:c.clampedInt(ve.top,0,0,1e3),bottom:c.clampedInt(ve.bottom,0,0,1e3)}}}class B extends P{constructor(){const re={enabled:!0,cycle:!1};super(73,"parameterHints",re,{"editor.parameterHints.enabled":{type:"boolean",default:re.enabled,description:v.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:re.cycle,description:v.localize(57,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{enabled:l(ve.enabled,this.defaultValue.enabled),cycle:l(ve.cycle,this.defaultValue.cycle)}}}class K extends s{constructor(){super(126)}compute(re,ve,Me){return re.pixelRatio}}class ie extends P{constructor(){const re={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",re,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:re.strings,description:v.localize(58,null)},comments:{type:"boolean",default:re.comments,description:v.localize(59,null)},other:{type:"boolean",default:re.other,description:v.localize(60,null)}}}],default:re,description:v.localize(61,null)});this.defaultValue=re}validate(re){if(typeof re=="boolean")return re;if(re&&typeof re=="object"){const ve=re,Me={other:l(ve.other,this.defaultValue.other),comments:l(ve.comments,this.defaultValue.comments),strings:l(ve.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var we;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(we=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends P{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(62,null),v.localize(63,null),v.localize(64,null),v.localize(65,null)],default:"on",description:v.localize(66,null)})}validate(re){let ve=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof re!="undefined"&&(typeof re=="function"?(ve=4,Me=re):re==="interval"?ve=3:re==="relative"?ve=2:re==="on"?ve=1:ve=0),{renderType:ve,renderFn:Me}}}function ye(Q){const re=Q.get(85);return re==="editable"?Q.get(78):re!=="on"}e.filterValidationDecorations=ye;class Oe extends P{constructor(){const re=[],ve={type:"number",description:v.localize(67,null)};super(89,"rulers",re,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:v.localize(68,null),format:"color-hex"}}}]},default:re,description:v.localize(69,null)})}validate(re){if(Array.isArray(re)){let ve=[];for(let Me of re)if(typeof Me=="number")ve.push({column:c.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const Ne=Me;ve.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ve.sort((Me,Ne)=>Me.column-Ne.column),ve}return this.defaultValue}}function je(Q,re){if(typeof Q!="string")return re;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends P{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re,Me=c.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(ve.vertical,this.defaultValue.vertical),horizontal:je(ve.horizontal,this.defaultValue.horizontal),useShadows:l(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:c.clampedInt(ve.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ve.verticalSliderSize,Ne,0,1e3),scrollByPage:l(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class qe extends P{constructor(){const re={enabled:!1};super(52,"inlineSuggest",re,{"editor.inlineSuggest.enabled":{type:"boolean",default:re.enabled,description:v.localize(70,null)}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{enabled:l(re.enabled,this.defaultValue.enabled)}}}class j extends P{constructor(){const re={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",re,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(71,null),v.localize(72,null)],default:re.insertMode,description:v.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:re.filterGraceful,description:v.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:re.localityBonus,description:v.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:re.shareSuggestSelections,markdownDescription:v.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:re.snippetsPreventQuickSuggestions,description:v.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:re.showIcons,description:v.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:re.showStatusBar,description:v.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:re.preview,description:v.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:re.showInlineDetails,description:v.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(112,null)}})}validate(re){if(!re||typeof re!="object")return this.defaultValue;const ve=re;return{insertMode:w(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(ve.showIcons,this.defaultValue.showIcons),showStatusBar:l(ve.showStatusBar,this.defaultValue.showStatusBar),preview:l(ve.preview,this.defaultValue.preview),showInlineDetails:l(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(ve.showMethods,this.defaultValue.showMethods),showFunctions:l(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:l(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(ve.showDeprecated,this.defaultValue.showDeprecated),showFields:l(ve.showFields,this.defaultValue.showFields),showVariables:l(ve.showVariables,this.defaultValue.showVariables),showClasses:l(ve.showClasses,this.defaultValue.showClasses),showStructs:l(ve.showStructs,this.defaultValue.showStructs),showInterfaces:l(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:l(ve.showModules,this.defaultValue.showModules),showProperties:l(ve.showProperties,this.defaultValue.showProperties),showEvents:l(ve.showEvents,this.defaultValue.showEvents),showOperators:l(ve.showOperators,this.defaultValue.showOperators),showUnits:l(ve.showUnits,this.defaultValue.showUnits),showValues:l(ve.showValues,this.defaultValue.showValues),showConstants:l(ve.showConstants,this.defaultValue.showConstants),showEnums:l(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:l(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(ve.showKeywords,this.defaultValue.showKeywords),showWords:l(ve.showWords,this.defaultValue.showWords),showColors:l(ve.showColors,this.defaultValue.showColors),showFiles:l(ve.showFiles,this.defaultValue.showFiles),showReferences:l(ve.showReferences,this.defaultValue.showReferences),showFolders:l(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:l(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(ve.showSnippets,this.defaultValue.showSnippets),showUsers:l(ve.showUsers,this.defaultValue.showUsers),showIssues:l(ve.showIssues,this.defaultValue.showIssues)}}}class J extends P{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(113,null),default:!0,type:"boolean"}})}validate(re){return!re||typeof re!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(re.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ne extends s{constructor(){super(127,[78])}compute(re,ve,Me){return ve.get(78)?!0:re.tabFocusMode}}var oe;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(oe=e.WrappingIndent||(e.WrappingIndent={}));function Y(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class le extends s{constructor(){super(129,[128])}compute(re,ve,Me){const Ne=ve.get(128);return{isDominatedByLongLines:re.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const me="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",We="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?We:me,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Xe;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.inlineSuggest=52]="inlineSuggest",Q[Q.letterSpacing=53]="letterSpacing",Q[Q.lightbulb=54]="lightbulb",Q[Q.lineDecorationsWidth=55]="lineDecorationsWidth",Q[Q.lineHeight=56]="lineHeight",Q[Q.lineNumbers=57]="lineNumbers",Q[Q.lineNumbersMinChars=58]="lineNumbersMinChars",Q[Q.linkedEditing=59]="linkedEditing",Q[Q.links=60]="links",Q[Q.matchBrackets=61]="matchBrackets",Q[Q.minimap=62]="minimap",Q[Q.mouseStyle=63]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=65]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=67]="multiCursorModifier",Q[Q.multiCursorPaste=68]="multiCursorPaste",Q[Q.occurrencesHighlight=69]="occurrencesHighlight",Q[Q.overviewRulerBorder=70]="overviewRulerBorder",Q[Q.overviewRulerLanes=71]="overviewRulerLanes",Q[Q.padding=72]="padding",Q[Q.parameterHints=73]="parameterHints",Q[Q.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=76]="quickSuggestions",Q[Q.quickSuggestionsDelay=77]="quickSuggestionsDelay",Q[Q.readOnly=78]="readOnly",Q[Q.renameOnType=79]="renameOnType",Q[Q.renderControlCharacters=80]="renderControlCharacters",Q[Q.renderIndentGuides=81]="renderIndentGuides",Q[Q.renderFinalNewline=82]="renderFinalNewline",Q[Q.renderLineHighlight=83]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=85]="renderValidationDecorations",Q[Q.renderWhitespace=86]="renderWhitespace",Q[Q.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",Q[Q.roundedSelection=88]="roundedSelection",Q[Q.rulers=89]="rulers",Q[Q.scrollbar=90]="scrollbar",Q[Q.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=92]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=93]="scrollPredominantAxis",Q[Q.selectionClipboard=94]="selectionClipboard",Q[Q.selectionHighlight=95]="selectionHighlight",Q[Q.selectOnLineNumbers=96]="selectOnLineNumbers",Q[Q.showFoldingControls=97]="showFoldingControls",Q[Q.showUnused=98]="showUnused",Q[Q.snippetSuggestions=99]="snippetSuggestions",Q[Q.smartSelect=100]="smartSelect",Q[Q.smoothScrolling=101]="smoothScrolling",Q[Q.stickyTabStops=102]="stickyTabStops",Q[Q.stopRenderingLineAfter=103]="stopRenderingLineAfter",Q[Q.suggest=104]="suggest",Q[Q.suggestFontSize=105]="suggestFontSize",Q[Q.suggestLineHeight=106]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",Q[Q.suggestSelection=108]="suggestSelection",Q[Q.tabCompletion=109]="tabCompletion",Q[Q.tabIndex=110]="tabIndex",Q[Q.unusualLineTerminators=111]="unusualLineTerminators",Q[Q.useShadowDOM=112]="useShadowDOM",Q[Q.useTabStops=113]="useTabStops",Q[Q.wordSeparators=114]="wordSeparators",Q[Q.wordWrap=115]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=118]="wordWrapColumn",Q[Q.wordWrapOverride1=119]="wordWrapOverride1",Q[Q.wordWrapOverride2=120]="wordWrapOverride2",Q[Q.wrappingIndent=121]="wrappingIndent",Q[Q.wrappingStrategy=122]="wrappingStrategy",Q[Q.showDeprecated=123]="showDeprecated",Q[Q.inlayHints=124]="inlayHints",Q[Q.editorClassName=125]="editorClassName",Q[Q.pixelRatio=126]="pixelRatio",Q[Q.tabFocusMode=127]="tabFocusMode",Q[Q.layoutInfo=128]="layoutInfo",Q[Q.wrappingInfo=129]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(114,null)})),acceptSuggestionOnEnter:be(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(115,null),""],markdownDescription:v.localize(116,null)})),accessibilitySupport:be(new f),accessibilityPageSize:be(new c(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(117,null)})),ariaLabel:be(new _(4,"ariaLabel",v.localize(118,null))),autoClosingBrackets:be(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(119,null),v.localize(120,null),""],description:v.localize(121,null)})),autoClosingDelete:be(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(122,null),""],description:v.localize(123,null)})),autoClosingOvertype:be(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(124,null),""],description:v.localize(125,null)})),autoClosingQuotes:be(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(126,null),v.localize(127,null),""],description:v.localize(128,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null),v.localize(132,null),v.localize(133,null)],description:v.localize(134,null)})),automaticLayout:be(new g(10,"automaticLayout",!1)),autoSurround:be(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null),""],description:v.localize(138,null)})),stickyTabStops:be(new g(102,"stickyTabStops",!1,{description:v.localize(139,null)})),codeLens:be(new g(12,"codeLens",!0,{description:v.localize(140,null)})),codeLensFontFamily:be(new _(13,"codeLensFontFamily","",{description:v.localize(141,null)})),codeLensFontSize:be(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:v.localize(142,null)})),colorDecorators:be(new g(15,"colorDecorators",!0,{description:v.localize(143,null)})),columnSelection:be(new g(16,"columnSelection",!1,{description:v.localize(144,null)})),comments:be(new t),contextmenu:be(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new g(19,"copyWithSyntaxHighlighting",!0,{description:v.localize(145,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],n,{description:v.localize(146,null)})),cursorSmoothCaretAnimation:be(new g(21,"cursorSmoothCaretAnimation",!1,{description:v.localize(147,null)})),cursorStyle:be(new u(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:v.localize(148,null)})),cursorSurroundingLines:be(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(149,null)})),cursorSurroundingLinesStyle:be(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(150,null),v.localize(151,null)],description:v.localize(152,null)})),cursorWidth:be(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(153,null)})),disableLayerHinting:be(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new g(28,"domReadOnly",!1)),dragAndDrop:be(new g(29,"dragAndDrop",!0,{description:v.localize(154,null)})),emptySelectionClipboard:be(new b),extraEditorClassName:be(new _(31,"extraEditorClassName","")),fastScrollSensitivity:be(new m(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:v.localize(155,null)})),find:be(new y),fixedOverflowWidgets:be(new g(34,"fixedOverflowWidgets",!1)),folding:be(new g(35,"folding",!0,{description:v.localize(156,null)})),foldingStrategy:be(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(157,null),v.localize(158,null)],description:v.localize(159,null)})),foldingHighlight:be(new g(37,"foldingHighlight",!0,{description:v.localize(160,null)})),unfoldOnClickAfterEndOfLine:be(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(161,null)})),fontFamily:be(new _(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(162,null)})),fontInfo:be(new L),fontLigatures2:be(new o),fontSize:be(new O),fontWeight:be(new W),formatOnPaste:be(new g(44,"formatOnPaste",!1,{description:v.localize(163,null)})),formatOnType:be(new g(45,"formatOnType",!1,{description:v.localize(164,null)})),glyphMargin:be(new g(46,"glyphMargin",!0,{description:v.localize(165,null)})),gotoLocation:be(new ee),hideCursorInOverviewRuler:be(new g(48,"hideCursorInOverviewRuler",!1,{description:v.localize(166,null)})),highlightActiveIndentGuide:be(new g(49,"highlightActiveIndentGuide",!0,{description:v.localize(167,null)})),hover:be(new ce),inDiffEditor:be(new g(51,"inDiffEditor",!1)),letterSpacing:be(new m(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>m.clamp(Q,-5,20),{description:v.localize(168,null)})),lightbulb:be(new V),lineDecorationsWidth:be(new I(55,"lineDecorationsWidth",10)),lineHeight:be(new N),lineNumbers:be(new Te),lineNumbersMinChars:be(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new g(59,"linkedEditing",!1,{description:v.localize(169,null)})),links:be(new g(60,"links",!0,{description:v.localize(170,null)})),matchBrackets:be(new E(61,"matchBrackets","always",["always","near","never"],{description:v.localize(171,null)})),minimap:be(new F),mouseStyle:be(new E(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new m(64,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:v.localize(172,null)})),mouseWheelZoom:be(new g(65,"mouseWheelZoom",!1,{markdownDescription:v.localize(173,null)})),multiCursorMergeOverlapping:be(new g(66,"multiCursorMergeOverlapping",!0,{description:v.localize(174,null)})),multiCursorModifier:be(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[v.localize(175,null),v.localize(176,null)],markdownDescription:v.localize(177,null)})),multiCursorPaste:be(new E(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(178,null),v.localize(179,null)],markdownDescription:v.localize(180,null)})),occurrencesHighlight:be(new g(69,"occurrencesHighlight",!0,{description:v.localize(181,null)})),overviewRulerBorder:be(new g(70,"overviewRulerBorder",!0,{description:v.localize(182,null)})),overviewRulerLanes:be(new c(71,"overviewRulerLanes",3,0,3)),padding:be(new U),parameterHints:be(new B),peekWidgetDefaultFocus:be(new E(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(183,null),v.localize(184,null)],description:v.localize(185,null)})),definitionLinkOpensInPeek:be(new g(75,"definitionLinkOpensInPeek",!1,{description:v.localize(186,null)})),quickSuggestions:be(new ie),quickSuggestionsDelay:be(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(187,null)})),readOnly:be(new g(78,"readOnly",!1)),renameOnType:be(new g(79,"renameOnType",!1,{description:v.localize(188,null),markdownDeprecationMessage:v.localize(189,null)})),renderControlCharacters:be(new g(80,"renderControlCharacters",!1,{description:v.localize(190,null)})),renderIndentGuides:be(new g(81,"renderIndentGuides",!0,{description:v.localize(191,null)})),renderFinalNewline:be(new g(82,"renderFinalNewline",!0,{description:v.localize(192,null)})),renderLineHighlight:be(new E(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(193,null)],description:v.localize(194,null)})),renderLineHighlightOnlyWhenFocus:be(new g(84,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(195,null)})),renderValidationDecorations:be(new E(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new E(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(196,null),v.localize(197,null),v.localize(198,null),""],description:v.localize(199,null)})),revealHorizontalRightPadding:be(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new g(88,"roundedSelection",!0,{description:v.localize(200,null)})),rulers:be(new Oe),scrollbar:be(new ze),scrollBeyondLastColumn:be(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:v.localize(201,null)})),scrollBeyondLastLine:be(new g(92,"scrollBeyondLastLine",!0,{description:v.localize(202,null)})),scrollPredominantAxis:be(new g(93,"scrollPredominantAxis",!0,{description:v.localize(203,null)})),selectionClipboard:be(new g(94,"selectionClipboard",!0,{description:v.localize(204,null),included:R.isLinux})),selectionHighlight:be(new g(95,"selectionHighlight",!0,{description:v.localize(205,null)})),selectOnLineNumbers:be(new g(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new E(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[v.localize(206,null),v.localize(207,null)],description:v.localize(208,null)})),showUnused:be(new g(98,"showUnused",!0,{description:v.localize(209,null)})),showDeprecated:be(new g(123,"showDeprecated",!0,{description:v.localize(210,null)})),inlayHints:be(new T),snippetSuggestions:be(new E(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(211,null),v.localize(212,null),v.localize(213,null),v.localize(214,null)],description:v.localize(215,null)})),smartSelect:be(new J),smoothScrolling:be(new g(101,"smoothScrolling",!1,{description:v.localize(216,null)})),stopRenderingLineAfter:be(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new j),inlineSuggest:be(new qe),suggestFontSize:be(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(217,null)})),suggestLineHeight:be(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(218,null)})),suggestOnTriggerCharacters:be(new g(107,"suggestOnTriggerCharacters",!0,{description:v.localize(219,null)})),suggestSelection:be(new E(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(220,null),v.localize(221,null),v.localize(222,null)],description:v.localize(223,null)})),tabCompletion:be(new E(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(224,null),v.localize(225,null),v.localize(226,null)],description:v.localize(227,null)})),tabIndex:be(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new E(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(228,null),v.localize(229,null),v.localize(230,null)],description:v.localize(231,null)})),useShadowDOM:be(new g(112,"useShadowDOM",!0)),useTabStops:be(new g(113,"useTabStops",!0,{description:v.localize(232,null)})),wordSeparators:be(new _(114,"wordSeparators",k.USUAL_WORD_SEPARATORS,{description:v.localize(233,null)})),wordWrap:be(new E(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(234,null),v.localize(235,null),v.localize(236,null),v.localize(237,null)],description:v.localize(238,null)})),wordWrapBreakAfterCharacters:be(new _(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new _(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(239,null)})),wordWrapOverride1:be(new E(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new E(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Y,{enumDescriptions:[v.localize(240,null),v.localize(241,null),v.localize(242,null),v.localize(243,null)],description:v.localize(244,null)})),wrappingStrategy:be(new E(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),editorClassName:be(new h),pixelRatio:be(new K),tabFocusMode:be(new ne),layoutInfo:be(new x),wrappingInfo:be(new le)}}),define(ge[151],pe([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ge[152],pe([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ge[153],pe([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ge[154],pe([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ge[155],pe([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ge[156],pe([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(ge[157],pe([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(ge[158],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ge[159],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ge[160],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(ge[161],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ge[162],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ge[163],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ge[164],pe([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ge[165],pe([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(ge[166],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ge[167],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ge[168],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ge[169],pe([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ge[170],pe([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ge[171],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var v;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(v=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var k;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(k=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ge[172],pe([0,1,153]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=S;function A(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=l.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=A;function C(l){if(!l)return null;let g=l.majorBase,c=l.majorMustEqual,m=l.minorBase,_=l.minorMustEqual,w=l.patchBase,E=l.patchMustEqual;l.hasCaret&&(g===0||(_=!1),E=!1);let u=0;if(l.preRelease){const d=k.exec(l.preRelease);if(d){const[,f,t,r]=d;u=Date.UTC(Number(f),Number(t)-1,Number(r))}}return{majorBase:g,majorMustEqual:c,minorBase:m,minorMustEqual:_,patchBase:w,patchMustEqual:E,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=C;function D(l,g,c){let m;typeof l=="string"?m=C(A(l)):m=l;let _;g instanceof Date?_=g.getTime():typeof g=="string"&&(_=new Date(g).getTime());let w;if(typeof c=="string"?w=C(A(c)):w=c,!m||!w)return!1;let E=m.majorBase,u=m.minorBase,d=m.patchBase,f=w.majorBase,t=w.minorBase,r=w.patchBase,n=w.notBefore,i=w.majorMustEqual,a=w.minorMustEqual,p=w.patchMustEqual;return w.isMinimum?E>f?!0:E<f?!1:u>t?!0:u<t||_&&_<n?!1:d>=r:(E===1&&f===0&&(!i||!a||!p)&&(f=1,t=0,r=0,i=!0,a=!1,p=!1),E<f?!1:E>f?!i:u<t?!1:u>t?!a:d<r?!1:d>r?!p:!(_&&_<n))}e.isValidVersion=D;function P(l,g,c,m){return c.isBuiltin||typeof c.main=="undefined"?!0:I(l,g,c.engines.vscode,m)}e.isValidExtensionVersion=P;function s(l,g,c){return l==="*"||I(g,c,l)}e.isEngineValid=s;function I(l,g,c,m=[]){let _=C(A(c));if(!_)return m.push(v.localize(0,null,c)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return m.push(v.localize(1,null,c)),!1}else if(!_.majorMustEqual)return m.push(v.localize(2,null,c)),!1;return D(l,g,_)?!0:(m.push(v.localize(3,null,l,c)),!1)}}),define(ge[109],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,A=[],C=!1){this.ctor=S,this.staticArguments=A,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=v;const R=(k,...S)=>new v(k,S);e.createSyncDescriptor=R}),define(ge[78],pe([0,1,109]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function k(A,C,D){C instanceof v.SyncDescriptor||(C=new v.SyncDescriptor(C,[],D)),R.push([A,C])}e.registerSingleton=k;function S(){return R}e.getSingletonServiceDescriptors=S}),define(ge[173],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let A of this._nodes.values())A.outgoing.size===0&&S.push(A);return S}insertEdge(S,A){const C=this.lookupOrInsertNode(S),D=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),D),D.incoming.set(this._hashFn(S),C)}removeNode(S){const A=this._hashFn(S);this._nodes.delete(A);for(let C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(S){const A=this._hashFn(S);let C=this._nodes.get(A);return C||(C=new v(S),this._nodes.set(A,C)),C}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[A,C]of this._nodes)S.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,A]of this._nodes){const C=new Set([S]),D=this._findCycle(A,C);if(D)return D}}_findCycle(S,A){for(let[C,D]of S.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const P=this._findCycle(D,A);if(P)return P;A.delete(C)}}}e.Graph=R}),define(ge[4],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(v=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function R(C,D,P,s){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:C,index:P,optional:s}):(D[v.DI_DEPENDENCIES]=[{id:C,index:P,optional:s}],D[v.DI_TARGET]=D)}function k(C){if(v.serviceIds.has(C))return v.serviceIds.get(C);const D=function(P,s,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(D,P,I,!1)};return D.toString=()=>C,v.serviceIds.set(C,D),D}e.createDecorator=k;function S(C){return C}e.refineServiceDecorator=S;function A(C){return function(D,P,s){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(C,D,s,!0)}}e.optional=A}),define(ge[174],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=v.createDecorator("modelService");function R(k){return!k.isTooLargeForSyncing()&&!k.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(ge[175],pe([0,1,3,74,6,23,73,77,174]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(P):!!l.exclusive}class s{constructor(){this._clock=0,this._entries=[],this._onDidChange=new v.Emitter}get onDidChange(){return this._onDidChange.event}register(g,c){let m={selector:g,provider:c,_score:-1,_time:this._clock++};return this._entries.push(m),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),k.toDisposable(()=>{if(m){let _=this._entries.indexOf(m);_>=0&&(this._entries.splice(_,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),m=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const c=[];for(let m of this._entries)m._score>0&&c.push(m.provider);return c}ordered(g){const c=[];return this._orderedForEach(g,m=>c.push(m.provider)),c}orderedGroups(g){const c=[];let m,_;return this._orderedForEach(g,w=>{m&&_===w._score?m.push(w.provider):(_=w._score,m=[w.provider],c.push(m))}),c}_orderedForEach(g,c){if(!!g){this._updateScores(g);for(const m of this._entries)m._score>0&&c(m)}}_updateScores(g){let c={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let m of this._entries)if(m._score=C.score(m.selector,g.uri,g.getLanguageIdentifier().language,D.shouldSynchronizeModel(g)),P(m.selector)&&m._score>0){for(let _ of this._entries)_._score=0;m._score=1e3;break}this._entries.sort(s._compareByScoreAndTime)}}static _compareByScoreAndTime(g,c){return g._score<c._score?1:g._score>c._score?-1:g._time<c._time?1:g._time>c._time?-1:0}}e.LanguageFeatureRegistry=s;class I{constructor(g,c,m=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=c,this.max=m,this._cache=new S.LRUCache(50,.7)}_key(g){return g.id+R.hash(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const c=this._key(g),m=this._cache.get(c);return this._clamp(m==null?void 0:m.value)}update(g,c){const m=this._key(g);let _=this._cache.get(m);return _||(_=new A.MovingAverage,this._cache.set(m,_)),_.update(c),this.get(g)}}e.LanguageFeatureRequestDelays=I}),define(ge[79],pe([0,1,2,41,175,143,90]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(L,O){this.language=L,this.id=O}}e.LanguageIdentifier=D;var P;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var s;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(s=e.ColorId||(e.ColorId={}));var I;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(L){return(L&255)>>>0}static getTokenType(L){return(L&1792)>>>8}static getFontStyle(L){return(L&14336)>>>11}static getForeground(L){return(L&8372224)>>>14}static getBackground(L){return(L&4286578688)>>>23}static getClassNameFromMetadata(L){let O=this.getForeground(L),W="mtk"+O,ee=this.getFontStyle(L);return ee&1&&(W+=" mtki"),ee&2&&(W+=" mtkb"),ee&4&&(W+=" mtku"),W}static getInlineStyleFromMetadata(L,O){const W=this.getForeground(L),ee=this.getFontStyle(L);let ce=`color: ${O[W]};`;return ee&1&&(ce+="font-style: italic;"),ee&2&&(ce+="font-weight: bold;"),ee&4&&(ce+="text-decoration: underline;"),ce}}e.TokenMetadata=g;var c;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(L){const O=o[L];let W=O&&A.iconRegistry.get(O);return W||(console.info("No codicon found for CompletionItemKind "+L),W=A.Codicon.symbolProperty),W.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(L,O){let W=o[L];return typeof W=="undefined"&&!O&&(W=9),W}}();var m;(function(o){o[o.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var _;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(_=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&v.URI.isUri(o.uri)&&R.Range.isIRange(o.range)&&(R.Range.isIRange(o.originSelectionRange)||R.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var r;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var n;(function(o){o[o.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var i;(function(o){const L=new Map;L.set("file",0),L.set("module",1),L.set("namespace",2),L.set("package",3),L.set("class",4),L.set("method",5),L.set("property",6),L.set("field",7),L.set("constructor",8),L.set("enum",9),L.set("interface",10),L.set("function",11),L.set("variable",12),L.set("constant",13),L.set("string",14),L.set("number",15),L.set("boolean",16),L.set("array",17),L.set("object",18),L.set("key",19),L.set("null",20),L.set("enum-member",21),L.set("struct",22),L.set("event",23),L.set("operator",24),L.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function W(G){return L.get(G)}o.fromString=W;function ee(G){return O.get(G)}o.toString=ee;function ce(G,x){const V=O.get(G);let T=V&&A.iconRegistry.get("symbol-"+V);return T||(console.info("No codicon found for SymbolKind "+G),T=A.Codicon.symbolProperty),`${x?"inline":"block"} ${T.classNames}`}o.toCssClassName=ce})(i=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(L){this.value=L}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var p;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var b;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(b=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new k.LanguageFeatureRegistry,e.RenameProviderRegistry=new k.LanguageFeatureRegistry,e.CompletionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new k.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new k.LanguageFeatureRegistry,e.HoverProviderRegistry=new k.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new k.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new k.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new k.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new k.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new k.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new k.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new k.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new k.LanguageFeatureRegistry,e.LinkProviderRegistry=new k.LanguageFeatureRegistry,e.ColorProviderRegistry=new k.LanguageFeatureRegistry,e.SelectionRangeRegistry=new k.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new k.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var y;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ge[110],pe([0,1,8,4,11]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=k.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",k.isMacintosh),A.set("isLinux",k.isLinux),A.set("isWindows",k.isWindows),A.set("isWeb",k.isWeb),A.set("isMacNative",k.isMacintosh&&!k.isWeb),A.set("isEdge",S.indexOf("Edg/")>=0),A.set("isFirefox",S.indexOf("Firefox")>=0),A.set("isChrome",S.indexOf("Chrome")>=0),A.set("isSafari",S.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(y){y[y.False=0]="False",y[y.True=1]="True",y[y.Defined=2]="Defined",y[y.Not=3]="Not",y[y.Equals=4]="Equals",y[y.NotEquals=5]="NotEquals",y[y.And=6]="And",y[y.Regex=7]="Regex",y[y.NotRegex=8]="NotRegex",y[y.Or=9]="Or",y[y.In=10]="In",y[y.NotIn=11]="NotIn",y[y.Greater=12]="Greater",y[y.GreaterEquals=13]="GreaterEquals",y[y.Smaller=14]="Smaller",y[y.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return I.INSTANCE}static true(){return l.INSTANCE}static has(o){return g.create(o)}static equals(o,L){return c.create(o,L)}static notEquals(o,L){return w.create(o,L)}static regex(o,L){return r.create(o,L)}static in(o,L){return m.create(o,L)}static not(o){return E.create(o)}static and(...o){return i.create(o)}static or(...o){return a.create(o)}static greater(o,L){return u.create(o,L)}static less(o,L){return f.create(o,L)}static deserialize(o,L=!1){if(!!o)return this._deserializeOrExpression(o,L)}static _deserializeOrExpression(o,L){let O=o.split("||");return a.create(O.map(W=>this._deserializeAndExpression(W,L)))}static _deserializeAndExpression(o,L){let O=o.split("&&");return i.create(O.map(W=>this._deserializeOne(W,L)))}static _deserializeOne(o,L){if(o=o.trim(),o.indexOf("!=")>=0){let O=o.split("!=");return w.create(O[0].trim(),this._deserializeValue(O[1],L))}if(o.indexOf("==")>=0){let O=o.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],L))}if(o.indexOf("=~")>=0){let O=o.split("=~");return r.create(O[0].trim(),this._deserializeRegexValue(O[1],L))}if(o.indexOf(" in ")>=0){let O=o.split(" in ");return m.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const O=o.split(">=");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const O=o.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const O=o.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const O=o.split("<");return f.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(o)?E.create(o.substr(1).trim()):g.create(o)}static _deserializeValue(o,L){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let O=/^'([^']*)'$/.exec(o);return O?O[1].trim():o}static _deserializeRegexValue(o,L){if(v.isFalsyOrWhitespace(o)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=o.indexOf("/"),W=o.lastIndexOf("/");if(O===W||O<0){if(L)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let ee=o.slice(O+1,W),ce=o[W+1]==="i"?"i":"";try{return new RegExp(ee,ce)}catch(G){if(L)throw new Error(`bad regexp-value '${o}', parse error: ${G}`);return console.warn(`bad regexp-value '${o}', parse error: ${G}`),null}}}e.ContextKeyExpr=P;function s(y,o){return y.cmp(o)}class I{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class l{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class g{constructor(o){this.key=o,this.type=2}static create(o){const L=A.get(o);return typeof L=="boolean"?L?l.INSTANCE:I.INSTANCE:new g(o)}cmp(o){return o.type!==this.type?this.type-o.type:h(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=g;class c{constructor(o,L){this.key=o,this.value=L,this.type=4}static create(o,L){if(typeof L=="boolean")return L?g.create(o):E.create(o);const O=A.get(o);return typeof O=="boolean"?L===(O?"true":"false")?l.INSTANCE:I.INSTANCE:new c(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class m{constructor(o,L){this.key=o,this.valueKey=L,this.type=10}static create(o,L){return new m(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const L=o.getValue(this.valueKey),O=o.getValue(this.key);return Array.isArray(L)?L.indexOf(O)>=0:typeof O=="string"&&typeof L=="object"&&L!==null?C.call(L,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return _.create(this)}}e.ContextKeyInExpr=m;class _{constructor(o){this._actual=o,this.type=11}static create(o){return new _(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new _(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=_;class w{constructor(o,L){this.key=o,this.value=L,this.type=5}static create(o,L){if(typeof L=="boolean")return L?E.create(o):g.create(o);const O=A.get(o);return typeof O=="boolean"?L===(O?"true":"false")?I.INSTANCE:l.INSTANCE:new w(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class E{constructor(o){this.key=o,this.type=3}static create(o){const L=A.get(o);return typeof L=="boolean"?L?I.INSTANCE:l.INSTANCE:new E(o)}cmp(o){return o.type!==this.type?this.type-o.type:h(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=E;class u{constructor(o,L){this.key=o,this.value=L,this.type=12}static create(o,L){return new u(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class d{constructor(o,L){this.key=o,this.value=L,this.type=13}static create(o,L){return new d(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class f{constructor(o,L){this.key=o,this.value=L,this.type=14}static create(o,L){return new f(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(o,L){this.key=o,this.value=L,this.type=15}static create(o,L){return new t(o,L)}cmp(o){return o.type!==this.type?this.type-o.type:b(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(o,L){this.key=o,this.regexp=L,this.type=7}static create(o,L){return new r(o,L)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const L=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return L<O?-1:L>O?1:0}equals(o){if(o.type===this.type){const L=this.regexp?this.regexp.source:"",O=o.regexp?o.regexp.source:"";return this.key===o.key&&L===O}return!1}evaluate(o){let L=o.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=r;class n{constructor(o){this._actual=o,this.type=8}static create(o){return new n(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new n(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class i{constructor(o){this.expr=o,this.type=6}static create(o){return i._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],o.expr[L]);if(W!==0)return W}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(o.expr[L]))return!1;return!0}return!1}evaluate(o){for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].evaluate(o))return!1;return!0}static _normalizeArr(o){const L=[];let O=!1;for(const W of o)if(!!W){if(W.type===1){O=!0;continue}if(W.type===0)return I.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&O)return l.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];for(L.sort(s);L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const ee=L.pop(),ce=a.create(W.expr.map(G=>i.create([G,ee])));ce&&(L.push(ce),L.sort(s))}return L.length===1?L[0]:new i(L)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let L of this.expr)o.push(...L.keys());return o}map(o){return new i(this.expr.map(L=>L.map(o)))}negate(){let o=[];for(let L of this.expr)o.push(L.negate());return a.create(o)}}e.ContextKeyAndExpr=i;class a{constructor(o){this.expr=o,this.type=9}static create(o){const L=a._normalizeArr(o);if(L.length!==0)return L.length===1?L[0]:new a(L)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let L=0,O=this.expr.length;L<O;L++){const W=s(this.expr[L],o.expr[L]);if(W!==0)return W}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let L=0,O=this.expr.length;L<O;L++)if(!this.expr[L].equals(o.expr[L]))return!1;return!0}return!1}evaluate(o){for(let L=0,O=this.expr.length;L<O;L++)if(this.expr[L].evaluate(o))return!0;return!1}static _normalizeArr(o){let L=[],O=!1;if(o){for(let W=0,ee=o.length;W<ee;W++){const ce=o[W];if(!!ce){if(ce.type===0){O=!0;continue}if(ce.type===1)return[l.INSTANCE];if(ce.type===9){L=L.concat(ce.expr);continue}L.push(ce)}}if(L.length===0&&O)return[I.INSTANCE];L.sort(s)}return L}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let L of this.expr)o.push(...L.keys());return o}map(o){return new a(this.expr.map(L=>L.map(o)))}negate(){let o=[];for(let O of this.expr)o.push(O.negate());const L=O=>O.type===9?O.expr:[O];for(;o.length>1;){const O=o.shift(),W=o.shift(),ee=[];for(const ce of L(O))for(const G of L(W))ee.push(P.and(ce,G));o.unshift(P.or(...ee))}return o[0]}}e.ContextKeyOrExpr=a;class p extends g{constructor(o,L,O){super(o);this._defaultValue=L,typeof O=="object"?p._info.push(Object.assign(Object.assign({},O),{key:o})):O!==!0&&p._info.push({key:o,description:O,type:L!=null?typeof L:void 0})}static all(){return p._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(o){return P.equals(this.key,o)}notEqualsTo(o){return P.notEquals(this.key,o)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(y,o){return y<o?-1:y>o?1:0}function b(y,o,L,O){return y<L?-1:y>L?1:o<O?-1:o>O?1:0}}),define(ge[176],pe([0,1,152,4,10]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(I){return I&&typeof I=="object"&&typeof I.id=="string"&&(!I.uuid||typeof I.uuid=="string")}e.isIExtensionIdentifier=S;var A;(function(I){I[I.NoneOrRelevance=0]="NoneOrRelevance",I[I.LastUpdatedDate=1]="LastUpdatedDate",I[I.Title=2]="Title",I[I.PublisherName=3]="PublisherName",I[I.InstallCount=4]="InstallCount",I[I.PublishedDate=5]="PublishedDate",I[I.AverageRating=6]="AverageRating",I[I.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var C;(function(I){I[I.Default=0]="Default",I[I.Ascending=1]="Ascending",I[I.Descending=2]="Descending"})(C=e.SortOrder||(e.SortOrder={}));var D;(function(I){I.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(I){I[I.None=0]="None",I[I.Install=1]="Install",I[I.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(l,g){super(l);this.code=g}}e.ExtensionManagementError=s,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(ge[26],pe([0,1,8,4]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function k(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.getWorkpaceSupportTypeMessage=k;function S(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,l){if(typeof I=="undefined"||I===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof I=="string"||typeof l=="string"){let g=typeof I=="string"?I:I.value,c=typeof l=="string"?l:l.value;return v.equalsIgnoreCase(g,c)}return I._lower===l._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=C;function D(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=P,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(ge[177],pe([0,1,8,26]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(g,c){return g.uuid&&c.uuid?g.uuid===c.uuid:g.id===c.id?!0:v.compareIgnoreCase(g.id,c.id)===0}e.areSameExtensions=k;class S{constructor(c,m){this.version=m,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof S?k(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=S;function A(g,c){return`${g}.${c}`}e.getExtensionId=A;function C(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(g,c){return C(A(g,c))}e.getGalleryExtensionId=D;function P(g,c){const m=[],_=w=>{for(const E of m)if(E.some(u=>k(c(u),c(w))))return E;return null};for(const w of g){const E=_(w);E?E.push(w):m.push([w])}return m}e.groupByExtension=P;function s(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=s;function I(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(g){const c=new Set;for(const m of g)m.malicious&&c.add(m.id.id);return c}e.getMaliciousExtensionsSet=l}),define(ge[178],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=v.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=v.createDecorator("externalTerminal")}),define(ge[179],pe([0,1,38,9,108,154,28,11,178,10,134]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=S.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const d=await m.getDefaultTerminalLinuxReady();return{windows:g.getDefaultTerminalWindows(),linux:d,osx:"xterm"}}}class g extends l{openTerminal(d,f){return this.spawnTerminal(v,d,k.getWindowsShell(),f)}spawnTerminal(d,f,t,r){const n=f.windowsExec||g.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=R.basename(n).toLowerCase();if(i==="cmder"||i==="cmder.exe")return d.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return n.indexOf(" ")>=0&&a.push('""'),a.push(n),(i==="wt"||i==="wt.exe")&&a.push("-d ."),new Promise((p,h)=>{const b=_(process),y=d.spawn(t,a,{cwd:r,env:b});y.on("error",h),y.on("exit",()=>p())})}runInTerminal(d,f,t,r,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:g.getDefaultTerminalWindows();return new Promise((a,p)=>{const h=`"${f} - ${I}"`,b=`""${t.join('" "')}" & pause"`,y=["/c","start",h,"/wait",i,"/c",b],o=Object.assign({},_(process),r);Object.keys(o).filter(W=>o[W]===null).forEach(W=>delete o[W]);const L={cwd:f,env:o,windowsVerbatimArguments:!0};v.spawn(g.CMD,y,L).on("error",W=>{p(w(W))}),a(void 0)})}static getDefaultTerminalWindows(){if(!g._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");g._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return g._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=g,g.CMD="cmd.exe";class c extends l{openTerminal(d,f){return this.spawnTerminal(v,d,f)}runInTerminal(d,f,t,r,n){const i=n.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((a,p)=>{if(i===D.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const h=i===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[P.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${h}.scpt`,X).fsPath,"-t",d||I,"-w",f];for(let O of t)y.push("-a"),y.push(O);if(r)for(let O in r){const W=r[O];W===null?(y.push("-u"),y.push(O)):(y.push("-e"),y.push(`${O}=${W}`))}let o="";const L=v.spawn(c.OSASCRIPT,y);L.on("error",O=>{p(w(O))}),L.stderr.on("data",O=>{o+=O.toString()}),L.on("exit",O=>{if(O===0)a(void 0);else if(o){const W=o.split(`
`,1);p(new Error(W[0]))}else p(new Error(S.localize(1,null,h,O)))})}else p(new Error(S.localize(2,null,i)))})}spawnTerminal(d,f,t){const r=f.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const a=["-a",r];t&&a.push(t);const p=d.spawn("/usr/bin/open",a);p.on("error",i),p.on("exit",()=>n())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class m extends l{openTerminal(d,f){return this.spawnTerminal(v,d,f)}runInTerminal(d,f,t,r,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((a,p)=>{let h=[];i.then(b=>{b.indexOf("gnome-terminal")>=0?h.push("-x"):h.push("-e"),h.push("bash"),h.push("-c");const y=`${E(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;h.push(`''${y}''`);const o=Object.assign({},process.env,r);Object.keys(o).filter(ee=>o[ee]===null).forEach(ee=>delete o[ee]);const L={cwd:f,env:o};let O="";const W=v.spawn(b,h,L);W.on("error",ee=>{p(w(ee))}),W.stderr.on("data",ee=>{O+=ee.toString()}),W.on("exit",ee=>{if(ee===0)a(void 0);else if(O){const ce=O.split(`
`,1);p(new Error(ce[0]))}else p(new Error(S.localize(4,null,b,ee)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{C.isLinux?await A.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,f,t){const r=f.linuxExec?Promise.resolve(f.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{r.then(a=>{const p=_(process),h=d.spawn(a,[],{cwd:t,env:p});h.on("error",i),h.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=S.localize(3,null);function _(u){const d=u.env;return s.sanitizeProcessEnvironment(d),d}function w(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function E(u){let d="";for(let f of u)f.indexOf(" ")>=0?d+='"'+f+'"':d+=f,d+=" ";return d}}),define(ge[42],pe([0,1,155,9,2,4,8,13,23]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function P(x){return x.create===!0}e.isFileOpenForWriteOptions=P;var s;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(s=e.FileType||(e.FileType={}));var I;(function(x){x[x.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=g;function c(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=c;function m(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function _(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=_;var w;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class E extends Error{constructor(V,T){super(V);this.code=T}}e.FileSystemProviderError=E;function u(x,V){const T=new E(x.toString(),V);return f(T,V),T}e.createFileSystemProviderError=u;function d(x){return x||u(v.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=d;function f(x,V){return x.name=V?`${V} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=f;function t(x){if(!x)return w.Unknown;if(x instanceof E)return x.code;const V=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!V)return w.Unknown;switch(V[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function r(x){if(x instanceof b)return x.fileOperationResult;switch(t(x)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var n;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class i{constructor(V,T,N){this.resource=V,this.operation=T,this.target=N}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var a;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class p{constructor(V,T){this.ignorePathCasing=T,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=V;for(const N of V)switch(N.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains(V,...T){return this.doContains(V,{includeChildren:!1},...T)}affects(V,...T){return this.doContains(V,{includeChildren:!0},...T)}doContains(V,T,...N){var F,M,U,B,K,ie;if(!V)return!1;const we=N.length>0;return!!((!we||N.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(V))||T.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(V)))||(!we||N.includes(0))&&(((U=this.updated)===null||U===void 0?void 0:U.get(V))||T.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(V)))||(!we||N.includes(2))&&(((K=this.deleted)===null||K===void 0?void 0:K.findSubstr(V))||T.includeChildren&&((ie=this.deleted)===null||ie===void 0?void 0:ie.findSuperstr(V))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(V){const T=[],N=V===1?this.added:V===0?this.updated:this.deleted;if(N)for(const[,F]of N)T.push(F);return T}filter(V){return new p(this.changes.filter(T=>V(T)),this.ignorePathCasing)}}e.FileChangesEvent=p;function h(x,V,T){return!x||!V||x===V||V.length>x.length?!1:(V.charAt(V.length-1)!==R.sep&&(V+=R.sep),T?A.startsWithIgnoreCase(x,V):x.indexOf(V)===0)}e.isParent=h;class b extends Error{constructor(V,T,N){super(V);this.fileOperationResult=T,this.options=N}}e.FileOperationError=b;class y extends b{constructor(V,T,N){super(V,2,N);this.stat=T}}e.NotModifiedSinceFileOperationError=y;var o;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=O;async function W(x,V){if(!V.canHandleResource(k.URI.from({scheme:x.scheme})))return new Promise(T=>{const N=V.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===x.scheme&&F.added&&(N.dispose(),T())})})}e.whenProviderRegistered=W,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ee{static formatSize(V){return C.isNumber(V)||(V=0),V<ee.KB?v.localize(1,null,V.toFixed(0)):V<ee.MB?v.localize(2,null,(V/ee.KB).toFixed(2)):V<ee.GB?v.localize(3,null,(V/ee.MB).toFixed(2)):V<ee.TB?v.localize(4,null,(V/ee.GB).toFixed(2)):v.localize(5,null,(V/ee.TB).toFixed(2))}}e.ByteSize=ee,ee.KB=1024,ee.MB=ee.KB*ee.KB,ee.GB=ee.MB*ee.KB,ee.TB=ee.GB*ee.KB;var ce;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(ce=e.Arch||(e.Arch={}));function G(x){return{maxFileSize:x===0?300*ee.MB:16*ee.GB,maxHeapSize:x===0?700*ee.MB:2*700*ee.MB}}e.getPlatformLimits=G}),define(ge[80],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...k){this._entries=new Map;for(let[S,A]of k)this.set(S,A)}set(k,S){const A=this._entries.get(k);return this._entries.set(k,S),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=v}),define(ge[180],pe([0,1,16,173,109,4,80,14]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(c){var m;super("cyclic dependency between services");this.message=(m=c.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class s{constructor(c=new A.ServiceCollection,m=!1,_){this._activeInstantiations=new Set,this._services=c,this._strict=m,this._parent=_,this._services.set(S.IInstantiationService,this)}createChild(c){return new s(c,this._strict,this)}invokeFunction(c,...m){let _=l.traceInvocation(c),w=!1;try{return c({get:(u,d)=>{if(w)throw v.illegalState("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,_);if(!f&&d!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...m)}finally{w=!0,_.stop()}}createInstance(c,...m){let _,w;return c instanceof k.SyncDescriptor?(_=l.traceCreation(c.ctor),w=this._createInstance(c.ctor,c.staticArguments.concat(m),_)):(_=l.traceCreation(c),w=this._createInstance(c,m,_)),_.stop(),w}_createInstance(c,m=[],_){let w=S._util.getServiceDependencies(c).sort((d,f)=>d.index-f.index),E=[];for(const d of w){let f=this._getOrCreateServiceInstance(d.id,_);if(!f&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);E.push(f)}let u=w.length>0?w[0].index:m.length;if(m.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${m.length} static arguments`);let d=u-m.length;d>0?m=m.concat(new Array(d)):m=m.slice(0,u)}return new c(...[...m,...E])}_setServiceInstance(c,m){if(this._services.get(c)instanceof k.SyncDescriptor)this._services.set(c,m);else if(this._parent)this._parent._setServiceInstance(c,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let m=this._services.get(c);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):m}_getOrCreateServiceInstance(c,m){let _=this._getServiceInstanceOrDescriptor(c);return _ instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,_,m.branch(c,!0)):(m.branch(c,!1),_)}_safeCreateAndCacheServiceInstance(c,m,_){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,m,_)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,m,_){const w=new R.Graph(d=>d.id.toString());let E=0;const u=[{id:c,desc:m,_trace:_}];for(;u.length;){const d=u.pop();if(w.lookupOrInsertNode(d),E++>1e3)throw new P(w);for(let f of S._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${c} depends on ${f.id} which is NOT registered.`),t instanceof k.SyncDescriptor){const r={id:f.id,desc:t,_trace:d._trace.branch(f.id,!0)};w.insertEdge(d,r),u.push(r)}}}for(;;){const d=w.roots();if(d.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:f}of d){if(this._getServiceInstanceOrDescriptor(f.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,r)}w.removeNode(f)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,m,_=[],w,E){if(this._services.get(c)instanceof k.SyncDescriptor)return this._createServiceInstance(m,_,w,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,m,_,w,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(c,m=[],_,w){if(_){const E=new C.IdleValue(()=>this._createInstance(c,m,w));return new Proxy(Object.create(null),{get(u,d){if(d in u)return u[d];let f=E.value,t=f[d];return typeof t!="function"||(t=t.bind(f),u[d]=t),t},set(u,d,f){return E.value[d]=f,!0}})}else return this._createInstance(c,m,w)}}e.InstantiationService=s;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class l{constructor(c,m){this.type=c,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return D?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return D?new l(0,c.name):l._None}branch(c,m){let _=new l(2,c.toString());return this._dep.push([c,m,_]),_}stop(){let c=Date.now()-this._start;l._totals+=c;let m=!1;function _(E,u){let d=[],f=new Array(E+1).join("	");for(const[t,r,n]of u._dep)if(r&&n){m=!0,d.push(`${f}CREATES -> ${t}`);let i=_(E+1,n);i&&d.push(i)}else d.push(`${f}uses -> ${t}`);return d.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||m)&&console.log(w.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(ge[15],pe([0,1,4,6,11,3,55]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function C(){return new Date().toISOString()}var D;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class s extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(D.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(D.Error,this.format(n))}else this.log(D.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let n=0;n<t.length;n++){let i=t[n];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}r+=(n>0?" ":"")+i}return r}}e.AbstractMessageLogger=s;class I extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!k.isWindows}trace(t,...r){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}debug(t,...r){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}info(t,...r){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...r):console.log(`[main ${C()}]`,t,...r))}warn(t,...r){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...r):console.warn(`[main ${C()}]`,t,...r))}error(t,...r){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}critical(t,...r){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...r):console.error(`[main ${C()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class l extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=l;class g extends P{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class c extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const n of this.logServices)n.trace(t,...r)}debug(t,...r){for(const n of this.logServices)n.debug(t,...r)}info(t,...r){for(const n of this.logServices)n.info(t,...r)}warn(t,...r){for(const n of this.logServices)n.warn(t,...r)}error(t,...r){for(const n of this.logServices)n.error(t,...r)}critical(t,...r){for(const n of this.logServices)n.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class m extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=m;class _ extends R.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(n))}))}createLogger(t,r){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(r==null?void 0:r.always)?D.Trace:this.logLevel,r),this.loggers.set(t.toString(),n),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=_;class w{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=w;function E(f){if(f.verbose)return D.Trace;if(typeof f.logLevel=="string"){const t=u(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function u(f){switch(f){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=u;function d(f){switch(f){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=d}),define(ge[111],pe([0,1,15,42]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function k(D,P,s,I){try{const l=await new Promise((g,c)=>{X(["spdlog"],g,c)});return l.setFlushOn(v.LogLevel.Trace),l.createAsyncRotatingLogger(D,P,s,I)}catch(l){console.error(l)}return null}function S(D,P,s,I){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(v.LogLevel.Trace),l.createRotatingLogger(D,P,s,I)}e.createRotatingLogger=S;function A(D,P,s){switch(P){case v.LogLevel.Trace:D.trace(s);break;case v.LogLevel.Debug:D.debug(s);break;case v.LogLevel.Info:D.info(s);break;case v.LogLevel.Warning:D.warn(s);break;case v.LogLevel.Error:D.error(s);break;case v.LogLevel.Critical:D.critical(s);break;default:throw new Error("Invalid log level")}}class C extends v.AbstractMessageLogger{constructor(P,s,I,l){super();this.name=P,this.filepath=s,this.rotating=I,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(g=>{this._logger&&this._logger.setLevel(g)}))}_createSpdLogLogger(){const P=this.rotating?6:1,s=30/P*R.ByteSize.MB;return k(this.name,this.filepath,s,P).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:l,message:g}of this.buffer)A(this._logger,l,g);this.buffer=[]}})}log(P,s){this._logger?A(this._logger,P,s):this.getLevel()<=P&&this.buffer.push({level:P,message:s})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ge[112],pe([0,1,4,156,52]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(c,m){return m-c}D.compare=P;const s=Object.create(null);s[D.Error]=R.localize(0,null),s[D.Warning]=R.localize(1,null),s[D.Info]=R.localize(2,null);function I(c){return s[c]||""}D.toString=I;function l(c){switch(c){case k.default.Error:return D.Error;case k.default.Warning:return D.Warning;case k.default.Info:return D.Info;case k.default.Ignore:return D.Hint}}D.fromSeverity=l;function g(c){switch(c){case D.Error:return k.default.Error;case D.Warning:return k.default.Warning;case D.Info:return k.default.Info;case D.Hint:return k.default.Ignore}}D.toSeverity=g}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const P="";function s(l){return I(l,!0)}D.makeKey=s;function I(l,g){let c=[P];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(P),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(P),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(P),l.message&&g?c.push(l.message.replace("\xA6","\\\xA6")):c.push(P),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(P),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(P),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(P),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(P),c.push(P),c.join("\xA6")}D.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=v.createDecorator("markerService")}),define(ge[181],pe([0,1,52,4,3]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=v.default,e.INotificationService=R.createDecorator("notificationService");var S;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(s){}updateMessage(s){}updateActions(s){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(s){}worked(s){}}e.NoOpProgress=D}),define(ge[182],pe([0,1,6,8,2,4]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=S.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return v.Disposable.None},registerValidator(){return v.Disposable.None},registerExternalUriResolver(){return v.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return v.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function A(C,D){return k.URI.isUri(C)?R.equalsIgnoreCase(C.scheme,D):R.startsWithIgnoreCase(C,D+":")}e.matchesScheme=A}),define(ge[183],pe([0,1,10,11,37,24]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const C=R.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const C=S.dirname(v.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(S.joinPath(C,"product.json").fsPath);const D=X.__$__nodeRequire(S.joinPath(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:D.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var He=this&&this.__param||function(X,e){return function(v,R){e(v,R,X)}};define(ge[113],pe([0,1,4,21,6,14]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=v.createDecorator("progressService");var A;(function(s){s[s.Explorer=1]="Explorer",s[s.Scm=3]="Scm",s[s.Extensions=5]="Extensions",s[s.Window=10]="Window",s[s.Notification=15]="Notification",s[s.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends k.Disposable{constructor(I,l){super();this.deferred=new S.DeferredPromise,l.withProgress(I,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register(k.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};D=Ve([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends k.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new k.DisposableStore)}start(I){this.stop();const l=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(k.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(k.toDisposable(()=>g.cancel())),this.currentOperationDisposables.add(k.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:g.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=v.createDecorator("editorProgressService")}),define(ge[56],pe([0,1,13,49]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,C){R.ok(v.isString(A)),R.ok(v.isObject(C)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ge[184],pe([0,1,56,3]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[k(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new S;v.Registry.add(e.Extensions.JSONContribution,A)}),define(ge[81],pe([0,1,151,3,56,13,184]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=k.Registry.as(A.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,E=!0){this.registerConfigurations([w],E)}registerConfigurations(w,E=!0){const u=[];w.forEach(d=>{u.push(...this.validateAndRegisterProperties(d,E,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(w){const E=[],u=d=>{if(d.properties)for(const f in d.properties)E.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,d.properties[f]);d.allOf&&d.allOf.forEach(f=>u(f))};for(const d of w){u(d);const f=this.configurationContributors.indexOf(d);f!==-1&&this.configurationContributors.splice(f,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(w){const E=[],u=[];for(const d of w)for(const f in d)if(E.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),d[f]);const t={type:"object",default:this.defaultValues[f],description:v.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};u.push(I(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=d[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(w){const E=[];for(const u of w)for(const d in u)if(E.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const f=this.configurationProperties[d];f&&(this.updatePropertyDefaultValue(d,f),this.updateSchema(d,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const E of w)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,E=!0,u,d=3){var f;d=S.isUndefinedOrNull(w.scope)?d:w.scope;let t=[],r=w.properties;if(r)for(let i in r){if(E&&c(i)){delete r[i];continue}const a=r[i];if(this.updatePropertyDefaultValue(i,a),e.OVERRIDE_PROPERTY_PATTERN.test(i)?a.scope=void 0:(a.scope=S.isUndefinedOrNull(a.scope)?d:a.scope,a.restricted=S.isUndefinedOrNull(a.restricted)?!!((f=u==null?void 0:u.restrictedConfigurations)===null||f===void 0?void 0:f.includes(i)):a.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let n=w.allOf;if(n)for(let i of n)t.push(...this.validateAndRegisterProperties(i,E,u,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const E=u=>{let d=u.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let f=u.allOf;f&&f.forEach(E)};E(w)}updateSchema(w,E){switch(e.allSettings.properties[w]=E,E.scope){case 1:e.applicationSettings.properties[w]=E;break;case 2:e.machineSettings.properties[w]=E;break;case 6:e.machineOverridableSettings.properties[w]=E;break;case 3:e.windowSettings.properties[w]=E;break;case 4:e.resourceSettings.properties[w]=E;break;case 5:e.resourceSettings.properties[w]=E,this.resourceLanguageSettingsSchema.properties[w]=E;break}}removeFromSchema(w,E){switch(delete e.allSettings.properties[w],E.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const E=`[${w}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,u),e.allSettings.properties[E]=u,e.applicationSettings.properties[E]=u,e.machineSettings.properties[E]=u,e.machineOverridableSettings.properties[E]=u,e.windowSettings.properties[E]=u,e.resourceSettings.properties[E]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,E){let u=this.defaultValues[w];S.isUndefined(u)&&(u=E.default),S.isUndefined(u)&&(u=l(E.type)),E.default=u}}const s="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(s);function I(_){return _.substring(1,_.length-1)}e.overrideIdentifierFromKey=I;function l(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new P;k.Registry.add(e.Extensions.Configuration,g);function c(_){return _.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(_)?v.localize(5,null,_):g.getConfigurationProperties()[_]!==void 0?v.localize(6,null,_):null:v.localize(4,null)}e.validateProperty=c;function m(){const _=[],w=g.getConfigurationProperties();for(const E of Object.keys(w))_.push([E,w[E].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=m}),define(ge[114],pe([0,1,25,13,2,56,4,81]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function D(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof k.URI)}e.isConfigurationOverrides=D;var P;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function s(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=s;function I(r,n){const i=n?r?n.keys.filter(L=>r.keys.indexOf(L)===-1):[...n.keys]:[],a=r?n?r.keys.filter(L=>n.keys.indexOf(L)===-1):[...r.keys]:[],p=[];if(n&&r){for(const L of r.keys)if(n.keys.indexOf(L)!==-1){const O=w(r.contents,L),W=w(n.contents,L);v.equals(O,W)||p.push(L)}}const h=[],b=L=>{const O={};for(const W of L)for(const ee of W.identifiers)O[f(ee)]=W;return O},y=n?b(n.overrides):{},o=r?b(r.overrides):{};if(Object.keys(y).length)for(const L of i){const O=y[L];O&&h.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(o).length)for(const L of a){const O=o[L];O&&h.push([C.overrideIdentifierFromKey(L),O.keys])}if(Object.keys(y).length&&Object.keys(o).length)for(const L of p){const O=o[L],W=y[L];if(O&&W){const ee=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:W.contents,keys:W.keys,overrides:[]});h.push([C.overrideIdentifierFromKey(L),[...ee.added,...ee.removed,...ee.updated]])}}return{added:i,removed:a,updated:p,overrides:h}}e.compare=I;function l(r,n){const i=[];for(const a of Object.keys(r))if(C.OVERRIDE_PROPERTY_PATTERN.test(a)){const p={};for(const h in r[a])p[h]=r[a][h];i.push({identifiers:[C.overrideIdentifierFromKey(a).trim()],keys:Object.keys(p),contents:g(p,n)})}return i}e.toOverrides=l;function g(r,n){const i=Object.create(null);for(let a in r)c(i,a,r[a],n);return i}e.toValuesTree=g;function c(r,n,i,a){const p=n.split("."),h=p.pop();let b=r;for(let y=0;y<p.length;y++){let o=p[y],L=b[o];switch(typeof L){case"undefined":L=b[o]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${p.slice(0,y+1).join(".")} is ${JSON.stringify(L)}`);return}b=L}if(typeof b=="object"&&b!==null)try{b[h]=i}catch(y){a(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(b)}`)}else a(`Ignoring ${n} as ${p.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=c;function m(r,n){const i=n.split(".");_(r,i)}e.removeFromValueTree=m;function _(r,n){const i=n.shift();if(n.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const a=r[i];typeof a=="object"&&!Array.isArray(a)&&(_(a,n),Object.keys(a).length===0&&delete r[i])}}function w(r,n,i){function a(b,y){let o=b;for(const L of y){if(typeof o!="object"||o===null)return;o=o[L]}return o}const p=n.split("."),h=a(r,p);return typeof h=="undefined"?i:h}e.getConfigurationValue=w;function E(r,n,i){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in r?R.isObject(r[a])&&R.isObject(n[a])?E(r[a],n[a],i):i&&(r[a]=n[a]):r[a]=n[a])})}e.merge=E;function u(){const r=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=u;function d(){const r=Object.create(null),n=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let i in n){let a=n[i].default;c(r,i,a,p=>console.error(`Conflict in default settings: ${p}`))}return r}e.getDefaultValues=d;function f(r){return`[${r}]`}e.keyFromOverrideIdentifier=f;function t(r,n,i){const a=r.inspect(n),p=r.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:a.defaultValue}e.getMigratedSettingValue=t}),define(ge[185],pe([0,1,51,23,17,13,25,2,81,114,56,6,3]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],n=[]){this._contents=t,this._keys=r,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?P.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const n=this.getContentsForOverrideIdentifer(r);return n?t?P.getConfigurationValue(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let n={};for(const i of k.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[i],p=r[i];p&&(typeof a=="object"&&typeof p=="object"?(a=A.deepClone(a),this.mergeContents(a,p)):a=p),n[i]=a}return new g(n,this.keys,this.overrides)}merge(...t){const r=A.deepClone(this.contents),n=A.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(r,a.contents);for(const p of a.overrides){const[h]=n.filter(b=>k.equals(b.identifiers,p.identifiers));h?this.mergeContents(h.contents,p.contents):n.push(A.deepClone(p))}for(const p of a.keys)i.indexOf(p)===-1&&i.push(p)}return new g(r,i,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const n of Object.keys(r)){if(n in t&&S.isObject(t[n])&&S.isObject(r[n])){this.mergeContents(t[n],r[n]);continue}t[n]=A.deepClone(r[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),P.addToValueTree(this.contents,t,r,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&P.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let n=0;n<r;n++)t.indexOf(this.keys[n])===0&&(r=n);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class c extends g{constructor(){const t=P.getDefaultValues(),r=P.getConfigurationKeys(),n=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&n.push({identifiers:[D.overrideIdentifierFromKey(i).trim()],keys:Object.keys(t[i]),contents:P.toValuesTree(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,r,n)}}e.DefaultConfigurationModel=c;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!S.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:n,keys:i,overrides:a,restricted:p}=this.doParseRaw(t,r);this._configurationModel=new g(n,i,a),this._restrictedConfigurations=p||[]}doParseContent(t){let r={},n=null,i=[],a=[],p=[];function h(y){Array.isArray(i)?i.push(y):n&&(i[n]=y)}let b={onObjectBegin:()=>{let y={};h(y),a.push(i),i=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let y=[];h(y),a.push(i),i=y,n=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:h,onError:(y,o,L)=>{p.push({error:y,offset:o,length:L})}};if(t)try{v.visit(t,b),r=i[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return r}doParseRaw(t,r){const n=s.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,n,!0,r);t=i.raw;const a=P.toValuesTree(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),p=Object.keys(t),h=P.toOverrides(t,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:a,keys:p,overrides:h,restricted:i.restricted}}filter(t,r,n,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const a={},p=[];for(let h in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(h)&&n){const b=this.filter(t[h],r,!1,i);a[h]=b.raw,p.push(...b.restricted)}else{const b=r[h],y=b?typeof b.scope!="undefined"?b.scope:3:void 0;(b==null?void 0:b.restricted)&&p.push(h),(y===void 0||i.scopes===void 0||i.scopes.includes(y))&&(i.skipRestricted&&(b==null?void 0:b.restricted)||(a[h]=t[h]))}return{raw:a,restricted:p}}}e.ConfigurationModelParser=m;class _ extends I.Disposable{constructor(t,r,n,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class w{constructor(t,r,n=new g,i=new g,a=new R.ResourceMap,p=new g,h=new R.ResourceMap,b=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=n,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=p,this._memoryConfigurationByResource=h,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,n){return this.getConsolidateConfigurationModel(r,n).getValue(t)}updateValue(t,r,n={}){let i;n.resource?(i=this._memoryConfigurationByResource.get(n.resource),i||(i=new g,this._memoryConfigurationByResource.set(n.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,n){const i=this.getConsolidateConfigurationModel(r,n),a=this.getFolderConfigurationModelForResource(r.resource,n),p=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,h=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),b=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),L=n?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,W=r.overrideIdentifier?p.override(r.overrideIdentifier).getValue(t):p.getValue(t),ee=i.getValue(t),ce=k.distinct(k.flatten(i.overrides.map(G=>G.identifiers))).filter(G=>i.getOverrideValue(t,G)!==void 0);return{defaultValue:h,userValue:b,userLocalValue:y,userRemoteValue:o,workspaceValue:L,workspaceFolderValue:O,memoryValue:W,value:ee,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:r.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:p.getValue(t),override:r.overrideIdentifier?p.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const n=r.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=D.overrideIdentifierFromKey(i),p=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=t.getKeysForOverrideIdentifier(a),b=[...h.filter(y=>p.indexOf(y)===-1),...p.filter(y=>h.indexOf(y)===-1),...p.filter(y=>!A.equals(this._defaultConfiguration.override(a).getValue(y),t.override(a).getValue(y)))];return[a,b]});return this.updateDefaultConfiguration(t),{keys:r,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:n,removed:i,overrides:a}=P.compare(this.localUserConfiguration,t),p=[...r,...n,...i];return p.length&&this.updateLocalUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:n,removed:i,overrides:a}=P.compare(this.remoteUserConfiguration,t);let p=[...r,...n,...i];return p.length&&this.updateRemoteUserConfiguration(t),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:n,removed:i,overrides:a}=P.compare(this.workspaceConfiguration,t);let p=[...r,...n,...i];return p.length&&this.updateWorkspaceConfiguration(t),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(t,r){const n=this.folderConfigurations.get(t),{added:i,updated:a,removed:p,overrides:h}=P.compare(n,r);let b=[...i,...a,...p];return(b.length||!n)&&this.updateFolderConfiguration(t,r),{keys:b,overrides:h}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:i,removed:a,overrides:p}=P.compare(r,void 0);return{keys:[...n,...i,...a],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let n=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},r){let n=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(n=this.getFolderConsolidatedConfiguration(i.uri)||n);const a=this._memoryConfigurationByResource.get(t);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const n=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=n.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=n}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const n=r.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:n,overrides:i,keys:a}=this._folderConfigurations.get(r);return t.push([r,{contents:n,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((p,h)=>(p.set(C.URI.revive(h[0]),this.parseConfigurationModel(h[1])),p),new R.ResourceMap);return new w(r,n,new g,i,a,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function E(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,r=new Map;for(const i of f)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,p])=>{const h=R.getOrSet(r,a,new Set);p.forEach(b=>h.add(b))});const n=[];return r.forEach((i,a)=>n.push([a,[...i.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=E;class u{constructor(t,r,n,i){this.change=t,this.previous=r,this.currentConfiguraiton=n,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(h=>a.add(h)),t.overrides.forEach(([,h])=>h.forEach(b=>a.add(b))),this.affectedKeys=[...a.values()];const p=new g;this.affectedKeys.forEach(h=>p.setValue(h,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,a=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!A.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let n=P.toValuesTree({[r]:!0},()=>{}),i;for(;typeof n=="object"&&(i=Object.keys(n)[0]);){if(t=t[i],!t)return!1;n=n[i]}return!0}}e.ConfigurationChangeEvent=u;class d extends u{constructor(t,r,n,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=n,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=d}),define(ge[115],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=v.createDecorator("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(A,C=R.Unknown,D){super(A);this._message=A,this._code=C,this._detail=D,this.isHandled=C===R.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(A){return A instanceof k&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof k&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof k&&A.isHandled}}e.RemoteAuthorityResolverError=k}),define(ge[116],pe([0,1,10]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(P){return P.scheme===v.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=R;function k(P){if(!P)return;const s=P.indexOf("+");return s<0?P:P.substr(0,s)}e.getRemoteName=k;function S(P){return P.scheme!==v.Schemas.file&&P.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=S;function A(P){if(P.folders.length)return P.folders.every(s=>S(s.uri))?P.folders[0].uri:void 0;if(P.configuration&&S(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=A;function C(P){var s;return(s=A(P))===null||s===void 0?void 0:s.scheme}e.getVirtualWorkspaceScheme=C;function D(P){return A(P)!==void 0}e.isVirtualWorkspace=D}),define(ge[186],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((k,S)=>X(["vsda"],k,S))}async sign(k){try{const S=await this.vsda(),A=new S.signer;if(A)return A.sign(k)}catch(S){}return k}}e.SignService=v}),define(ge[187],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(k){this._callback=k,this._terminalBufferMap=new Map}dispose(){for(const k of this._terminalBufferMap.values())k.dispose()}startBuffering(k,S,A=5){let C;return C=S(D=>{const P=typeof D=="string"?D:D.data;let s=this._terminalBufferMap.get(k);if(s){s.data.push(P);return}const I=setTimeout(()=>this.flushBuffer(k),A);s={data:[P],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(k),C.dispose()}},this._terminalBufferMap.set(k,s)}),C}stopBuffering(k){const S=this._terminalBufferMap.get(k);S&&S.dispose()}flushBuffer(k){const S=this._terminalBufferMap.get(k);S&&(this._terminalBufferMap.delete(k),this._callback(k,S.data.join("")))}}e.TerminalDataBufferer=v}),define(ge[57],pe([0,1,2,24,4,23]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=k.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function C(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=C;function D(l){const g=l;return!!(g&&typeof g=="object"&&v.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(g,c,m,_){this._id=g,this._configuration=m,this._ignorePathCasing=_,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class s{constructor(g,c){this.raw=c,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return R.joinPath(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=s;function I(l){return new s({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=I}),define(ge[188],pe([0,1,4,157,57,2,11,9,24,132,51,10,76,29,116]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(x){return(typeof x=="string"?C.extname(x):D.extname(x))===m}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=v.createDecorator("workspacesService");function w(x){return x.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function E(x){return x.hasOwnProperty("folderUri")}e.isRecentFolder=E;function u(x){return x.hasOwnProperty("fileUri")}e.isRecentFile=u;function d(x){const V=x;return typeof(V==null?void 0:V.id)=="string"&&S.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=d;function f(x){if(x.configuration)return{id:x.id,configPath:x.configuration};if(x.folders.length===1)return{id:x.id,uri:x.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(x){const V=x;return typeof(V==null?void 0:V.id)=="string"&&S.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=t;function r(x){const V=x;if(V==null?void 0:V.uri)return{id:V.id,uri:S.URI.revive(V.uri)};const T=x;if(T==null?void 0:T.configPath)return{id:T.id,configPath:S.URI.revive(T.configPath)};if(x==null?void 0:x.id)return{id:x.id}}e.reviveIdentifier=r;function n(x,V){return D.extUriBiasedIgnorePathCase.isEqualOrParent(x,V.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function i(x){return a(x)||p(x)}e.isStoredWorkspaceFolder=i;function a(x){const V=x;return typeof(V==null?void 0:V.path)=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=a;function p(x){const V=x;return typeof(V==null?void 0:V.uri)=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=p;function h(x,V,T,N,F=!A.isWindows,M){if(x.scheme!==N.scheme)return{name:T,uri:x.toString(!0)};let U=V?void 0:M.relativePath(N,x);if(U!==void 0)U.length===0?U=".":A.isWindows&&x.scheme===I.Schemas.file&&!F&&(U=U.replace(/\//g,"\\"));else if(x.scheme===I.Schemas.file)U=x.fsPath,A.isWindows&&(U=l.normalizeDriveLetter(U),F&&(U=g.toSlashes(U)));else{if(!M.isEqualAuthority(x.authority,N.authority))return{name:T,uri:x.toString(!0)};U=x.path}return{name:T,path:U}}e.getStoredWorkspaceFolder=h;function b(x,V,T){let N=[],F=new Set;const M=T.dirname(V);for(let U of x){let B;if(a(U))U.path&&(B=T.resolvePath(M,U.path));else if(p(U))try{B=S.URI.parse(U.uri),B.path[0]!=="/"&&(B=B.with({path:"/"+B.path}))}catch(K){console.warn(K)}if(B){let K=T.getComparisonKey(B);if(!F.has(K)){F.add(K);const ie=U.name||T.basenameOrAuthority(B);N.push(new k.WorkspaceFolder({uri:B,name:ie,index:N.length},U))}}}return N}e.toWorkspaceFolders=b;function y(x,V,T,N,F){let M=o(V,x);const U=F.dirname(V),B=F.dirname(N),K=[],ie=L(M.folders);for(const Oe of M.folders){const je=a(Oe)?F.resolvePath(U,Oe.path):S.URI.parse(Oe.uri);let ze;T?ze=!1:ze=!a(Oe)||C.isAbsolute(Oe.path),K.push(h(je,ze,Oe.name,B,ie,F))}const we={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Te=P.setProperty(x,["folders"],K,we);let ye=P.applyEdits(x,Te);return M.remoteAuthority===c.getRemoteAuthority(N)&&(ye=P.applyEdits(ye,P.removeProperty(ye,["remoteAuthority"],we))),ye}e.rewriteWorkspaceFileForNewLocation=y;function o(x,V){let T=s.parse(V);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(N=>i(N));else throw new Error(`${x} looks like an invalid workspace file.`);return T}function L(x){return A.isWindows?x.some(V=>a(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=L;function O(x){return x.workspace&&typeof x.workspace=="object"&&typeof x.workspace.id=="string"&&typeof x.workspace.configPath=="string"}function W(x){return typeof x.folderUri=="string"}function ee(x){return typeof x.fileUri=="string"}function ce(x,V){const T={workspaces:[],files:[]};if(x){const N=function(M,U){for(let B=0;B<M.length;B++)try{U(M[B],B)}catch(K){V.warn(`Error restoring recent entry ${JSON.stringify(M[B])}: ${K.toString()}. Skip entry.`)}},F=x;if(Array.isArray(F.entries))N(F.entries,M=>{const U=M.label,B=M.remoteAuthority;O(M)?T.workspaces.push({label:U,remoteAuthority:B,workspace:{id:M.workspace.id,configPath:S.URI.parse(M.workspace.configPath)}}):W(M)?T.workspaces.push({label:U,remoteAuthority:B,folderUri:S.URI.parse(M.folderUri)}):ee(M)&&T.files.push({label:U,remoteAuthority:B,fileUri:S.URI.parse(M.fileUri)})});else{const M=x;Array.isArray(M.workspaces3)&&N(M.workspaces3,(U,B)=>{const K=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[B]||void 0;typeof U=="object"&&typeof U.id=="string"&&typeof U.configURIPath=="string"?T.workspaces.push({label:K,workspace:{id:U.id,configPath:S.URI.parse(U.configURIPath)}}):typeof U=="string"&&T.workspaces.push({label:K,folderUri:S.URI.parse(U)})}),Array.isArray(M.files2)&&N(M.files2,(U,B)=>{const K=Array.isArray(M.fileLabels)&&M.fileLabels[B]||void 0;typeof U=="string"&&T.files.push({label:K,fileUri:S.URI.parse(U)})})}}return T}e.restoreRecentlyOpened=ce;function G(x){const V={entries:[]};for(const T of x.workspaces)E(T)?V.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):V.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of x.files)V.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return V}e.toStoreData=G}),define(ge[82],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class v{constructor(k){this.id=k,this._data=new Map,this._idPool=1}add(k){const S=this._idPool++;return this._data.set(S,k),this.logDebugInfo(),S}get(k,S){return this._data.has(k)?this._data.get(k)[S]:void 0}delete(k){this._data.delete(k),this.logDebugInfo()}logDebugInfo(){!v.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=v,v.enableDebugLogging=!1}),define(ge[45],pe([0,1,2,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=k.createDecorator("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(C){this._tabs=C.map(D=>({name:D.name,group:D.group,resource:v.URI.revive(D.resource),isActive:D.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(ge[58],pe([0,1,10,4]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class k{constructor(){this._systemSchemes=new Set(Object.keys(v.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A):this._providerInfo.set(A,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=k,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(ge[27],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=v.createDecorator("IExtHostInitDataService")}),define(ge[189],pe([0,1,14]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,C,D){this._deferredPromises=new Map,this._id=A,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new v.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const s of P.values())s.complete()}catch(s){for(const I of P.values())I.error(s)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(A,C){let D=this._value[A];return typeof D=="undefined"&&(D=C),D}update(A,C){this._value[A]=C;let D=this._deferredPromises.get(A);if(D!==void 0)return D.p;const P=new v.DeferredPromise;return this._deferredPromises.set(A,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class k extends R{constructor(A,C){super(A.identifier.value,!0,C);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=k}),define(ge[12],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=v.createDecorator("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=R});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[190],pe([0,1,26,3]),function(X,e,v,R){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(C,D){k.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=v.ExtensionIdentifier.toKey(C.identifier),tt(this,k,D,"f"),$e(this,k,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(C){return $e(this,k,"f").get(this._id,C)}store(C,D){return $e(this,k,"f").store(this._id,C,D)}delete(C){return $e(this,k,"f").delete(this._id,C)}}e.ExtensionSecrets=S,k=new WeakMap}),define(ge[117],pe([0,1,4,3]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class k{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=k,e.IExtHostTelemetry=v.createDecorator("IExtHostTelemetry")}),define(ge[83],pe([0,1,3]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const k=new WeakMap,S=A=>{let C=k.get(A);return C||(C={children:new Map,bus:new v.Emitter},k.set(A,C)),C};e.getPrivateApiFor=S}),define(ge[46],pe([0,1,4,3,12]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(C){function D(s){return{remoteAddress:s.remoteAddress,localAddress:s.localAddress,public:!!s.public}}C.fromApiTunnel=D;function P(s){return{remoteAddress:{host:s.tunnelRemoteHost,port:s.tunnelRemotePort},localAddress:s.localAddress,public:s.public}}C.fromServiceTunnel=P})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=v.createDecorator("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,s,I,l){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ve([He(0,k.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[7],pe([0,1,17,16,94,23,136,13,2,32,42,115,83]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";var g,c,m,_,w,E,u,d,f,t,r,n,i,a,p,h,b,y;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function o(z){function $(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf($,z),Object.setPrototypeOf($.prototype,z.prototype),$}let L=w=class{constructor($){g.set(this,void 0),tt(this,g,$,"f")}static from(...$){let se=$;return new w(function(){if(se){for(const Ce of se)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();se=void 0}})}dispose(){typeof $e(this,g,"f")=="function"&&($e(this,g,"f").call(this),tt(this,g,void 0,"f"))}};g=new WeakMap,L=w=Ve([o],L),e.Disposable=L;let O=E=class{constructor($,se){if($<0)throw R.illegalArgument("line must be non-negative");if(se<0)throw R.illegalArgument("character must be non-negative");this._line=$,this._character=se}static Min(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const Ke=$[Ce];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...$){if($.length===0)throw new TypeError;let se=$[0];for(let Ce=1;Ce<$.length;Ce++){const Ke=$[Ce];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition($){if(!$)return!1;if($ instanceof E)return!0;let{line:se,character:Ce}=$;return typeof se=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,se=0){if($===null||se===null)throw R.illegalArgument();let Ce;return typeof $=="undefined"?Ce=0:typeof $=="number"?Ce=$:(Ce=typeof $.lineDelta=="number"?$.lineDelta:0,se=typeof $.characterDelta=="number"?$.characterDelta:0),Ce===0&&se===0?this:new E(this.line+Ce,this.character+se)}with($,se=this.character){if($===null||se===null)throw R.illegalArgument();let Ce;return typeof $=="undefined"?Ce=this.line:typeof $=="number"?Ce=$:(Ce=typeof $.line=="number"?$.line:this.line,se=typeof $.character=="number"?$.character:this.character),Ce===this.line&&se===this.character?this:new E(Ce,se)}toJSON(){return{line:this.line,character:this.character}}};O=E=Ve([o],O),e.Position=O;let W=u=class{constructor($,se,Ce,Ke){let et,at;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new O($,se),at=new O(Ce,Ke)):$ instanceof O&&se instanceof O&&(et=$,at=se),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange($){return $ instanceof u?!0:$?O.isPosition($.start)&&O.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof u?this.contains($._start)&&this.contains($._end):$ instanceof O?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const se=O.Max($.start,this._start),Ce=O.Min($.end,this._end);if(!se.isAfter(Ce))return new u(se,Ce)}union($){if(this.contains($))return this;if($.contains(this))return $;const se=O.Min($.start,this._start),Ce=O.Max($.end,this.end);return new u(se,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,se=this.end){if($===null||se===null)throw R.illegalArgument();let Ce;return $?O.isPosition($)?Ce=$:(Ce=$.start||this.start,se=$.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&se.isEqual(this.end)?this:new u(Ce,se)}toJSON(){return[this.start,this.end]}};W=u=Ve([o],W),e.Range=W;let ee=d=class extends W{constructor($,se,Ce,Ke){let et,at;if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(et=new O($,se),at=new O(Ce,Ke)):$ instanceof O&&se instanceof O&&(et=$,at=se),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection($){return $ instanceof d?!0:$?W.isRange($)&&O.isPosition($.anchor)&&O.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ee=d=Ve([o],ee),e.Selection=ee;class ce{constructor($,se,Ce){if(typeof $!="string"||$.length===0)throw R.illegalArgument("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw R.illegalArgument("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw R.illegalArgument("connectionToken");this.host=$,this.port=Math.round(se),this.connectionToken=Ce}}e.ResolvedAuthority=ce;class G extends Error{constructor($,se=I.RemoteAuthorityResolverErrorCode.Unknown,Ce){super($);this._message=$,this._code=se,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,G.prototype)}static NotAvailable($,se){return new G($,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable($){return new G($,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=G;var x;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var V;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(V=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let T=f=class{constructor($,se){this._range=$,this._newText=se}static isTextEdit($){return $ instanceof f?!0:$?W.isRange($)&&typeof $.newText=="string":!1}static replace($,se){return new f($,se)}static insert($,se){return f.replace(new W($,$),se)}static delete($){return f.replace($,"")}static setEndOfLine($){const se=new f(new W(new O(0,0),new O(0,0)),"");return se.newEol=$,se}get range(){return this._range}set range($){if($&&!W.isRange($))throw R.illegalArgument("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw R.illegalArgument("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw R.illegalArgument("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};T=f=Ve([o],T),e.TextEdit=T;var N;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellOutput=4]="CellOutput",z[z.CellReplace=5]="CellReplace",z[z.CellOutputItem=6]="CellOutputItem"})(N=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,se,Ce,Ke){this._edits.push({_type:1,from:$,to:se,options:Ce,metadata:Ke})}createFile($,se,Ce){this._edits.push({_type:1,from:void 0,to:$,options:se,metadata:Ce})}deleteFile($,se,Ce){this._edits.push({_type:1,from:$,to:void 0,options:se,metadata:Ce})}replaceNotebookMetadata($,se,Ce){this._edits.push({_type:3,metadata:Ce,uri:$,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells($,se,Ce,Ke,et){let at,dt,yt=[],Pt;if($t.isNotebookRange(se)&&Tt.isNotebookCellDataArray(Ce)&&!Tt.isNotebookCellDataArray(Ke)?(at=se.start,dt=se.end,yt=Ce,Pt=Ke):typeof se=="number"&&typeof Ce=="number"&&Tt.isNotebookCellDataArray(Ke)&&(at=se,dt=Ce,yt=Ke,Pt=et),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||yt.length>0)&&this._edits.push({_type:5,uri:$,index:at,count:dt-at,cells:yt,metadata:Pt})}replaceNotebookCellMetadata($,se,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:$,edit:{editType:8,index:se,metadata:Ce}})}replace($,se,Ce,Ke){this._edits.push({_type:2,uri:$,edit:new T(se,Ce),metadata:Ke})}insert($,se,Ce,Ke){this.replace($,new W(se,se),Ce,Ke)}delete($,se,Ce){this.replace($,se,"",Ce)}has($){return this._edits.some(se=>se._type===2&&se.uri.toString()===$.toString())}set($,se){if(se)for(const Ce of se)Ce&&this._edits.push({_type:2,uri:$,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===$.toString()&&(this._edits[Ce]=void 0)}v.coalesceInPlace(this._edits)}}get($){const se=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===$.toString()&&se.push(Ce.edit);return se}entries(){const $=new S.ResourceMap;for(let se of this._edits)if(se._type===2){let Ce=$.get(se.uri);Ce||(Ce=[se.uri,[]],$.set(se.uri,Ce)),Ce[1].push(se.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=Ve([o],F),e.WorkspaceEdit=F;let M=t=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof t?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=t._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,se=this._tabstop++){if(typeof $=="function"){const Ce=new t;Ce._tabstop=this._tabstop,$(Ce),this._tabstop=Ce._tabstop,$=Ce.value}else $=t._escape($);return this.value+="${",this.value+=se,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,se=this._tabstop++){const Ce=$.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable($,se){if(typeof se=="function"){const Ce=new t;Ce._tabstop=this._tabstop,se(Ce),this._tabstop=Ce._tabstop,se=Ce.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,se&&(this.value+=":",this.value+=se),this.value+="}",this}};M=t=Ve([o],M),e.SnippetString=M;var U;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(U=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let K=r=class{constructor($,se){if(this.uri=$,se)if(se instanceof W)this.range=se;else if(se instanceof O)this.range=new W(se,se);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof r?!0:$?W.isRange($.range)&&D.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};K=r=Ve([o],K),e.Location=K;let ie=class{constructor($,se){this.location=$,this.message=se}static is($){return $?typeof $.message=="string"&&$.location&&W.isRange($.location.range)&&D.URI.isUri($.location.uri):!1}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.location.range.isEqual(se.location.range)&&$.location.uri.toString()===se.location.uri.toString()}};ie=Ve([o],ie),e.DiagnosticRelatedInformation=ie;let we=class{constructor($,se,Ce=B.Error){if(!W.isRange($))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=$,this.message=se,this.severity=Ce}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,se){return $===se?!0:!$||!se?!1:$.message===se.message&&$.severity===se.severity&&$.code===se.code&&$.severity===se.severity&&$.source===se.source&&$.range.isEqual(se.range)&&v.equals($.tags,se.tags)&&v.equals($.relatedInformation,se.relatedInformation,ie.isEqual)}};we=Ve([o],we),e.Diagnostic=we;let Te=class{constructor($,se){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:k.isMarkdownString($)?this.contents=[$]:this.contents=[$],this.range=se}};Te=Ve([o],Te),e.Hover=Te;var ye;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ye=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor($,se=ye.Text){this.range=$,this.kind=se}toJSON(){return{range:this.range,kind:ye[this.kind]}}};Oe=Ve([o],Oe),e.DocumentHighlight=Oe;var je;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var ze;(function(z){z[z.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let qe=n=class{constructor($,se,Ce,Ke,et){this.name=$,this.kind=se,this.containerName=et,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof K?this.location=Ke:Ce instanceof W&&(this.location=new K(Ke,Ce)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};qe=n=Ve([o],qe),e.SymbolInformation=qe;let j=i=class{constructor($,se,Ce,Ke,et){this.name=$,this.detail=se,this.kind=Ce,this.range=Ke,this.selectionRange=et,this.children=[],i.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(i.validate)}};j=i=Ve([o],j),e.DocumentSymbol=j;var J;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(J=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor($,se){this.title=$,this.kind=se}};ne=Ve([o],ne),e.CodeAction=ne;let oe=a=class{constructor($){this.value=$}append($){return new a(this.value?this.value+a.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+a.sep)}};oe.sep=".",oe=a=Ve([o],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let Y=class{constructor($,se){if(this.range=$,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Ve([o],Y),e.SelectionRange=Y;class le{constructor($,se,Ce,Ke,et,at){this.kind=$,this.name=se,this.detail=Ce,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=le;class me{constructor($,se){this.fromRanges=se,this.from=$}}e.CallHierarchyIncomingCall=me;class Re{constructor($,se){this.fromRanges=se,this.to=$}}e.CallHierarchyOutgoingCall=Re;let We=class{constructor($,se){this.range=$,this.command=se}get isResolved(){return!!this.command}};We=Ve([o],We),e.CodeLens=We;let be=p=class{constructor($,se=!1){c.set(this,void 0),tt(this,c,new k.MarkdownString($,{supportThemeIcons:se}),"f")}static isMarkdownString($){return $ instanceof p?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return $e(this,c,"f").value}set value($){$e(this,c,"f").value=$}get isTrusted(){return $e(this,c,"f").isTrusted}set isTrusted($){$e(this,c,"f").isTrusted=$}get supportThemeIcons(){return $e(this,c,"f").supportThemeIcons}appendText($){return $e(this,c,"f").appendText($),this}appendMarkdown($){return $e(this,c,"f").appendMarkdown($),this}appendCodeblock($,se){return $e(this,c,"f").appendCodeblock(se??"",$),this}};c=new WeakMap,be=p=Ve([o],be),e.MarkdownString=be;let Xe=class{constructor($,se){this.label=$,this.documentation=se}};Xe=Ve([o],Xe),e.ParameterInformation=Xe;let Q=class{constructor($,se){this.label=$,this.documentation=se,this.parameters=[]}};Q=Ve([o],Q),e.SignatureInformation=Q;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};re=Ve([o],re),e.SignatureHelp=re;var ve;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(ve=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Me;(function(z){z[z.Other=0]="Other",z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Me=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor($,se,Ce){this.text=$,this.position=se,this.kind=Ce}};Ne=Ve([o],Ne),e.InlayHint=Ne;var Ye;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(z){z[z.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let ke=class{constructor($,se){this.label=$,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ke=Ve([o],ke),e.CompletionItem=ke;let ae=class{constructor($=[],se=!1){this.items=$,this.isIncomplete=se}};ae=Ve([o],ae),e.CompletionList=ae;let fe=class{constructor($,se,Ce){this.text=$,this.range=se,this.command=Ce}};fe=Ve([o],fe),e.InlineSuggestion=fe;let H=class{constructor($){this.items=$}};H=Ve([o],H),e.InlineSuggestions=H;var Z;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Z=e.ViewColumn||(e.ViewColumn={}));var ue;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ue=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Pe;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(Pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ae;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Be;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Qe;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function $(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=$}(Be=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor($,se){if(se&&!D.URI.isUri(se))throw R.illegalArgument("target");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.target=se}};rt=Ve([o],rt),e.DocumentLink=rt;let nt=class{constructor($,se,Ce,Ke){this.red=$,this.green=se,this.blue=Ce,this.alpha=Ke}};nt=Ve([o],nt),e.Color=nt;let Ze=class{constructor($,se){if(se&&!(se instanceof nt))throw R.illegalArgument("color");if(!W.isRange($)||$.isEmpty)throw R.illegalArgument("range");this.range=$,this.color=se}};Ze=Ve([o],Ze),e.ColorInformation=Ze;let ot=class{constructor($){if(!$||typeof $!="string")throw R.illegalArgument("label");this.label=$}};ot=Ve([o],ot),e.ColorPresentation=ot;var Ee;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ee=e.ColorFormat||(e.ColorFormat={}));var De;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var de;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(de=e.TaskRevealKind||(e.TaskRevealKind={}));var q;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(q=e.TaskPanelKind||(e.TaskPanelKind={}));let Ue=h=class{constructor($,se){if(typeof $!="string"||typeof se!="string")throw R.illegalArgument("name");this._id=$}static from($){switch($){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}get id(){return this._id}};Ue.Clean=new h("clean","Clean"),Ue.Build=new h("build","Build"),Ue.Rebuild=new h("rebuild","Rebuild"),Ue.Test=new h("test","Test"),Ue=h=Ve([o],Ue),e.TaskGroup=Ue;function Le(z){let $="";for(let se=0;se<z.length;se++)$+=z[se].replace(/,/g,",,")+",";return $}let Ge=class{constructor($,se,Ce){if(typeof $!="string")throw R.illegalArgument("process");this._args=[],this._process=$,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=Ce):this._options=se)}get process(){return this._process}set process($){if(typeof $!="string")throw R.illegalArgument("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let se of this._args)$.push(se);return Le($)}};Ge=Ve([o],Ge),e.ProcessExecution=Ge;let Je=class{constructor($,se,Ce){if(this._args=[],Array.isArray(se)){if(!$)throw R.illegalArgument("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$,this._args=se,this._options=Ce}else{if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$,this._options=se}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw R.illegalArgument("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw R.illegalArgument("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)$.push(typeof se=="string"?se:se.value);return Le($)}};Je=Ve([o],Je),e.ShellExecution=Je;var lt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class it{constructor($){this._callback=$}computeId(){return"customExecution"+P.generateUuid()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=it;let mt=b=class{constructor($,se,Ce,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=$;let dt;typeof se=="string"?(this._name=this.name=se,this._source=this.source=Ce,this.execution=Ke,dt=et,this.__deprecated=!0):se===ct.Global||se===ct.Workspace?(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,dt=at):(this.target=se,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=et,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Je?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof it?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:P.generateUuid()}}get definition(){return this._definition}set definition($){if($==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw R.illegalArgument("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const se=this._definition.type;(b.EmptyType===se||b.ProcessType===se||b.ShellType===se||b.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};mt.ExtensionCallbackType="customExecution",mt.ProcessType="process",mt.ShellType="shell",mt.EmptyType="$empty",mt=b=Ve([o],mt),e.Task=mt;var St;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,se=bt.None){this.collapsibleState=se,D.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=Ve([o],vt),e.TreeItem=vt;var bt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(bt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor($,se){this.id=$,this.color=se}};gt=Ve([o],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let ht=class{constructor($){this.id=$}};ht=Ve([o],ht),e.ThemeColor=ht;var kt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(kt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{constructor($,se){if(typeof $!="string"&&(!$||!D.URI.isUri($)&&!D.URI.isUri($.uri)))throw R.illegalArgument("base");if(typeof se!="string")throw R.illegalArgument("pattern");typeof $=="string"?(this.baseFolder=D.URI.file($),this.base=$):D.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=se}};_t=Ve([o],_t),e.RelativePattern=_t;let It=class{constructor($,se,Ce,Ke){this.enabled=typeof $=="boolean"?$:!0,typeof se=="string"&&(this.condition=se),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=P.generateUuid()),this._id}};It=Ve([o],It),e.Breakpoint=It;let Lt=class extends It{constructor($,se,Ce,Ke,et){super(se,Ce,Ke,et);if($===null)throw R.illegalArgument("location");this.location=$}};Lt=Ve([o],Lt),e.SourceBreakpoint=Lt;let Et=class extends It{constructor($,se,Ce,Ke,et){super(se,Ce,Ke,et);this.functionName=$}};Et=Ve([o],Et),e.FunctionBreakpoint=Et;let qt=class extends It{constructor($,se,Ce,Ke,et,at,dt){super(Ke,et,at,dt);if(!se)throw R.illegalArgument("dataId");this.label=$,this.dataId=se,this.canPersist=Ce}};qt=Ve([o],qt),e.DataBreakpoint=qt;let Gt=class{constructor($,se,Ce){this.command=$,this.args=se||[],this.options=Ce}};Gt=Ve([o],Gt),e.DebugAdapterExecutable=Gt;let ft=class{constructor($,se){this.port=$,this.host=se}};ft=Ve([o],ft),e.DebugAdapterServer=ft;let Kt=class{constructor($){this.path=$}};Kt=Ve([o],Kt),e.DebugAdapterNamedPipeServer=Kt;let Qt=class{constructor($){this.implementation=$}};Qt=Ve([o],Qt),e.DebugAdapterInlineImplementation=Qt;let Dt=class{constructor($,se){this.range=$,this.expression=se}};Dt=Ve([o],Dt),e.EvaluatableExpression=Dt;var ln;(function(z){z[z.Automatic=0]="Automatic",z[z.Explicit=1]="Explicit"})(ln=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Xt=class{constructor($,se){this.range=$,this.text=se}};Xt=Ve([o],Xt),e.InlineValueText=Xt;let xt=class{constructor($,se,Ce=!0){this.range=$,this.variableName=se,this.caseSensitiveLookup=Ce}};xt=Ve([o],xt),e.InlineValueVariableLookup=xt;let ut=class{constructor($,se){this.range=$,this.expression=se}};ut=Ve([o],ut),e.InlineValueEvaluatableExpression=ut;let Yt=class{constructor($,se){this.frameId=$,this.stoppedLocation=se}};Yt=Ve([o],Yt),e.InlineValueContext=Yt;var Ft;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Ft=e.FileChangeType||(e.FileChangeType={}));let Mt=y=class extends Error{constructor($,se=s.FileSystemProviderErrorCode.Unknown,Ce){var Ke;super(D.URI.isUri($)?$.toString(!0):$);this.code=(Ke=Ce==null?void 0:Ce.name)!==null&&Ke!==void 0?Ke:"Unknown",s.markAsFileSystemProviderError(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists($){return new y($,s.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound($){return new y($,s.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory($){return new y($,s.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory($){return new y($,s.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions($){return new y($,s.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable($){return new y($,s.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Mt=y=Ve([o],Mt),e.FileSystemError=Mt;let Vt=class{constructor($,se,Ce){this.start=$,this.end=se,this.kind=Ce}};Vt=Ve([o],Vt),e.FoldingRange=Vt;var bn;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(bn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var cn;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(cn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var En;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(En=e.CommentMode||(e.CommentMode={}));class un{constructor($,se=[]){this.tokenTypes=$,this.tokenModifiers=se}}e.SemanticTokensLegend=un;function Bt(z){return typeof z=="undefined"||C.isStringArray(z)}class Jt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let se=0,Ce=$.tokenTypes.length;se<Ce;se++)this._tokenTypeStrToInt.set($.tokenTypes[se],se);for(let se=0,Ce=$.tokenModifiers.length;se<Ce;se++)this._tokenModifierStrToInt.set($.tokenModifiers[se],se)}}push($,se,Ce,Ke,et){if(typeof $=="number"&&typeof se=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded($,se,Ce,Ke,et);if(W.isRange($)&&typeof se=="string"&&Bt(Ce))return this._push($,se,Ce);throw R.illegalArgument()}_push($,se,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=$.start.line,et=$.start.character,at=$.end.character-$.start.character,dt=this._tokenTypeStrToInt.get(se);let yt=0;if(Ce)for(const Pt of Ce){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(Pt);yt|=1<<At>>>0}this._pushEncoded(Ke,et,at,dt,yt)}_pushEncoded($,se,Ce,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Pt=0,At=0;for(let Rt=0;Rt<yt;Rt++){let Nt=this._data[5*Rt],on=this._data[5*Rt+1];Nt===0?(Nt=Pt,on+=At):Nt+=Pt,this._data[5*Rt]=Nt,this._data[5*Rt+1]=on,Pt=Nt,At=on}}let at=$,dt=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=$,this._prevChar=se}static _sortAndDeltaEncode($){let se=[];const Ce=$.length/5|0;for(let dt=0;dt<Ce;dt++)se[dt]=dt;se.sort((dt,yt)=>{const Pt=$[5*dt],At=$[5*yt];if(Pt===At){const Rt=$[5*dt+1],Nt=$[5*yt+1];return Rt-Nt}return Pt-At});const Ke=new Uint32Array($.length);let et=0,at=0;for(let dt=0;dt<Ce;dt++){const yt=5*se[dt],Pt=$[yt+0],At=$[yt+1],Rt=$[yt+2],Nt=$[yt+3],on=$[yt+4],Ln=Pt-et,xn=Ln===0?At-at:At,an=5*dt;Ke[an+0]=Ln,Ke[an+1]=xn,Ke[an+2]=Rt,Ke[an+3]=Nt,Ke[an+4]=on,et=Pt,at=At}return Ke}build($){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),$):new Ht(Jt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Jt;class Ht{constructor($,se){this.resultId=se,this.data=$}}e.SemanticTokens=Ht;class Zt{constructor($,se,Ce){this.start=$,this.deleteCount=se,this.data=Ce}}e.SemanticTokensEdit=Zt;class _n{constructor($,se){this.resultId=se,this.edits=$}}e.SemanticTokensEdits=_n;var Sn;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Sn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Ot;(function(z){z[z.Initial=1]="Initial",z[z.Dynamic=2]="Dynamic"})(Ot=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new gt("arrow-left")},jt=Ve([o],jt),e.QuickInputButtons=jt;var yn;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Dn{constructor($,se,Ce){this.badge=$,this.tooltip=se,this.color=Ce}static validate($){if($.badge&&$.badge.length!==1&&$.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Dn;let en=class{constructor($){this.kind=$}};en=Ve([o],en),e.ColorTheme=en;var tn;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast"})(tn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor($,se){if($<0)throw R.illegalArgument("start must be positive");if(se<0)throw R.illegalArgument("end must be positive");$<=se?(this._start=$,this._end=se):(this._start=se,this._end=$)}static isNotebookRange($){return $ instanceof $t?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let se=this._start,Ce=this._end;return $.start!==void 0&&(se=$.start),$.end!==void 0&&(Ce=$.end),se===this._start&&Ce===this._end?this:new $t(se,Ce)}}e.NotebookRange=$t;class Tt{constructor($,se,Ce,Ke,et,at){this.kind=$,this.value=se,this.languageId=Ce,this.outputs=Ke??[],this.metadata=et,this.executionSummary=at,Tt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(se=>Tt.isNotebookCellData(se))}static isNotebookCellData($){return!0}}e.NotebookCellData=Tt;class nn{constructor($){this.cells=$}}e.NotebookData=nn;class Fe{constructor($,se){this.data=$,this.mime=se;const Ce=A.normalizeMimeType(se,!0);if(!Ce)throw new Error("INVALID mime type, must not be empty or falsy: "+se);this.mime=Ce}static isNotebookCellOutputItem($){return $ instanceof Fe?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const se={name:$.name,message:$.message,stack:$.stack};return Fe.json(se,"application/vnd.code.notebook.error")}static stdout($){return Fe.text($,"application/vnd.code.notebook.stdout")}static stderr($){return Fe.text($,"application/vnd.code.notebook.stderr")}static bytes($,se="application/octet-stream"){return new Fe($,se)}static text($,se="text/plain"){const Ce=$e(Fe,m,"f",_).encode(String($));return new Fe(Ce,se)}static json($,se="application/json"){const Ce=JSON.stringify($,void 0,"	");return Fe.text(Ce,se)}}e.NotebookCellOutputItem=Fe,m=Fe,_={value:new TextEncoder};class Wt{constructor($,se,Ce){this.items=Wt.ensureUniqueMimeTypes($,!0),typeof se=="string"?(this.id=se,this.metadata=Ce):(this.id=P.generateUuid(),this.metadata=se??Ce)}static isNotebookCellOutput($){return $ instanceof Wt?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&C.isArray($.items)}static ensureUniqueMimeTypes($,se=!1){const Ce=new Set,Ke=new Set;for(let et=0;et<$.length;et++){const at=$[et],dt=A.normalizeMimeType(at.mime);if(!Ce.has(dt)){Ce.add(dt);continue}Ke.add(et),se&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?$:$.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=Wt;var dn;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(dn=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Cn;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Cn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var kn;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(kn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class hn{constructor($,se){this.text=$,this.alignment=se}}e.NotebookCellStatusBarItem=hn;var fn;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(fn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class rn{constructor($,se=[]){this.uri=$,this.provides=v.asArray(se)}}e.NotebookRendererScript=rn;let sn=class{constructor($,se){this.label=$,this.timestamp=se}};sn=Ve([o],sn),e.TimelineItem=sn;var Pn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Pn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var mn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=4]="RegEx"})(mn=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor($,se){this.ranges=$,this.wordPattern=se}}e.LinkedEditingRanges=An;class Tn{constructor($,se){this._port=$,this._autoForwardAction=se}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var gn;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information",z[z.Hint=3]="Hint"})(gn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var pn;(function(z){z[z.Pending=0]="Pending",z[z.Resolved=1]="Resolved"})(pn=e.TestItemStatus||(e.TestItemStatus={}));const te=(z,$,se,Ce)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){Ce(Ke,et)||(Ke=et,z.bus.fire([3,$,et]))}}},he=(z,$)=>z===$,Ie=(z,$)=>z===$?!0:!z||!$?!1:z.isEqual($);class st{constructor($,se,Ce,Ke){this.label=se,this.data=Ke;const et=l.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:Ce,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new S.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:te(et,"range",void 0,Ie),description:te(et,"description",void 0,he),runnable:te(et,"runnable",!0,he),debuggable:te(et,"debuggable",!1,he),status:te(et,"status",pn.Resolved,he),error:te(et,"error",void 0,he)})}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){const $=l.getPrivateApiFor(this);$.parent&&l.getPrivateApiFor($.parent).children.delete(this.id),$.bus.fire([1])}addChild($){if(!($ instanceof st))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=l.getPrivateApiFor(this);if(se.children.has($.id))throw new Error(`Attempted to insert a duplicate test item ID ${$.id}`);se.children.set($.id,$),se.bus.fire([0,$])}}e.TestItemImpl=st;class wt{constructor($){this.message=$,this.severity=gn.Error}static diff($,se,Ce){const Ke=new wt($);return Ke.expectedOutput=se,Ke.actualOutput=Ce,Ke}}e.TestMessage=wt;var Ct;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(Ct=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Nn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(Nn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Un;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore"})(Un=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ge[118],pe([0,1,49,10,8,144,105,7,17]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function s(c,m){m?P.set(c,m):P.delete(c)}e.setWordDefinitionFor=s;function I(c){return P.get(c)}e.getWordDefinitionFor=I;class l extends S.MirrorTextModel{constructor(m,_,w,E,u,d,f,t){super(_,w,E,u);this._proxy=m,this._languageId=d,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){v.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return D.equals(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===R.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(_){return _?m._getTextInRange(_):m.getText()},get eol(){return m._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(_){return m._lineAt(_)},offsetAt(_){return m._offsetAt(_)},positionAt(_){return m._positionAt(_)},validateRange(_){return m._validateRange(_)},validatePosition(_){return m._validatePosition(_)},getWordRangeAtPosition(_,w){return m._getWordRangeAtPosition(_,w)}}}return Object.freeze(this._document)}_acceptLanguageId(m){v.ok(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){v.ok(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const _=this._validateRange(m);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const w=this._eol,E=_.start.line,u=_.end.line,d=[];d.push(this._lines[E].substring(_.start.character));for(let f=E+1;f<u;f++)d.push(this._lines[f]);return d.push(this._lines[u].substring(0,_.end.character)),d.join(w)}_lineAt(m){let _;if(m instanceof C.Position?_=m.line:typeof m=="number"&&(_=m),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new g(_,this._lines[_],_===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(m),w=this._lines[_.index].length;return new C.Position(_.index,Math.min(_.remainder,w))}_validateRange(m){if(!(m instanceof C.Range))throw new Error("Invalid argument");const _=this._validatePosition(m.start),w=this._validatePosition(m.end);return _===m.start&&w===m.end?m:new C.Range(_.line,_.character,w.line,w.character)}_validatePosition(m){if(!(m instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:_,character:w}=m,E=!1;if(_<0)_=0,w=0,E=!0;else if(_>=this._lines.length)_=this._lines.length-1,w=this._lines[_].length,E=!0;else{const u=this._lines[_].length;w<0?(w=0,E=!0):w>u&&(w=u,E=!0)}return E?new C.Position(_,w):m}_getWordRangeAtPosition(m,_){const w=this._validatePosition(m);if(!_)_=I(this._languageId);else if(k.regExpLeadsToEndlessLoop(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const E=A.getWordAtText(w.character+1,A.ensureValidWordDefinition(_),this._lines[w.line],0);if(E)return new C.Range(w.line,E.startColumn-1,w.line,E.endColumn-1)}}e.ExtHostDocumentData=l;class g{constructor(m,_,w){this._line=m,this._text=_,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(ge[191],pe([0,1,7,3,107,6,77,23,2,32]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class s{constructor(l,g,c,m){this._notebook=c,this._selector=m,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:P.generateUuid()}),this._init(),this._disposables.add(g.onDidChangeDocument(w=>{const E=this._cellUris.get(w.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(w=>_(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const l=[],g=[];for(const c of this._notebook.getCells())c.kind===v.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),g.push(c.document.lineCount));this._cellLengths=new k.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new k.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(l){var g,c;if(!l){let u="";for(const d of this._cells)u+=d.document.getText()+`
`;return u=u.slice(0,-1),u}if(l.isEmpty)return"";const m=this.locationAt(l.start),_=this.locationAt(l.end),w=this._cells[(g=this._cellUris.get(m.uri))!==null&&g!==void 0?g:-1],E=this._cells[(c=this._cellUris.get(_.uri))!==null&&c!==void 0?c:-1];if(!w||!E)return"";if(w===E)return w.document.getText(new v.Range(m.range.start,_.range.end));{const u=w.document.getText(new v.Range(m.range.start,new v.Position(w.document.lineCount,0))),d=E.document.getText(new v.Range(new v.Position(0,0),_.range.end));return u+`
`+d}}offsetAt(l){const g=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getAccumulatedValue(g.index-1),m=this._cells[g.index].document.offsetAt(l.with(g.remainder));return c+m}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),m=this._cellLines.getAccumulatedValue(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(m)}const g=this._cellUris.get(l.uri);if(g!==void 0){const c=this._cellLines.getAccumulatedValue(g-1);return new v.Position(c+l.range.start.line,l.range.start.character)}return new v.Position(0,0)}locationAt(l){v.Range.isRange(l)||(l=new v.Range(l,l));const g=this._cellLines.getIndexOf(l.start.line);let c=g;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const m=new v.Position(g.remainder,l.start.character),_=new v.Position(c.remainder,l.end.character),w=new v.Range(m,_),E=this._cells[g.index];return new v.Location(E.document.uri,E.document.validateRange(w))}contains(l){return this._cellUris.has(l)}validateRange(l){const g=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(g,c)}validatePosition(l){const g=this._cellLines.getIndexOf(l.line),c=new v.Position(g.remainder,l.character),m=this._cells[g.index].document.validatePosition(c),_=this._cellLines.getAccumulatedValue(g.index-1);return new v.Position(_+m.line,m.character)}}e.ExtHostNotebookConcatDocument=s}),define(ge[192],pe([0,1,7,12,3]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(C){this._actual=new v.ColorTheme(v.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new k.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?v.ColorThemeKind.Light:C==="dark"?v.ColorThemeKind.Dark:v.ColorThemeKind.HighContrast;this._actual=new v.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([He(0,R.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(ge[59],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=v.createDecorator("IURITransformerService");class R{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(ge[193],pe([0,1,22]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function k(C,D){if(D.serializeBuffersForPostMessage){const P=new R,s=(g,c)=>{if(c instanceof ArrayBuffer){const m=P.add(c);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(c)){const m=S(c);if(m){const _=P.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:m,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(C,s),l=P.buffers.map(g=>{const c=new Uint8Array(g);return v.VSBuffer.wrap(c)});return{message:I,buffers:l}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=k;function S(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(C,D){const P=D.map(l=>{const g=new ArrayBuffer(l.byteLength);return new Uint8Array(g).set(l.buffer),g}),s=D.length?(l,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const c=g,{index:m}=c,_=P[m];if(c.view)switch(c.view.type){case 1:return new Int8Array(_,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return g}:void 0;return{message:JSON.parse(C,s),arrayBuffers:P}}e.deserializeWebviewMessage=A}),define(ge[84],pe([0,1,10,2]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function k(S,A){return S.scheme===v.Schemas.http||S.scheme===v.Schemas.https?S:(A&&A.authority&&A.isRemote&&S.scheme===v.Schemas.file&&(S=R.URI.from({scheme:v.Schemas.vscodeRemote,authority:A.authority,path:S.path})),R.URI.from({scheme:v.Schemas.https,authority:`${S.scheme}+${S.authority}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=k}),define(ge[194],pe([0,1,3,6,84]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(C,D,P){this._proxy=C,this._editors=D,this._initData=P,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const s=D.getVisibleTextEditors();for(const I of this._insets.values())s.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(C=>C.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(C,D,P,s,I){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===C){l=u;break}if(!l)throw new Error("not a visible editor");const g=this,c=this._handlePool++,m=new v.Emitter,_=new v.Emitter,w=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return k.asWebviewUri(u,g._initData.remote)}get cspSource(){return k.webviewGenericCspSource}set options(u){this._options=u,g._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,g._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(u){return g._proxy.$postMessage(c,u)}},E=new class{constructor(){this.editor=C,this.line=D,this.height=P,this.webview=w,this.onDidDispose=_.event}dispose(){g._insets.has(c)&&(g._insets.delete(c),g._proxy.$disposeEditorInset(c),_.fire(),_.dispose(),m.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,D+1,P,s||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:C,inset:E,onDidReceiveMessage:m}),E}$onDidDispose(C){const D=this._insets.get(C);D&&D.inset.dispose()}$onDidReceiveMessage(C,D){const P=this._insets.get(C);P&&P.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=S}),define(ge[119],pe([0,1,3,14,166]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new v.Emitter,this._onExit=new v.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,P,s){const I={command:C};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof s=="number"){const l=setTimeout(()=>{clearTimeout(l);const g=this.pendingRequests.get(I.seq);if(g){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:k.localize(0,null,s,C)};g(c)}},s)}return P&&this.pendingRequests.set(I.seq,P),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await R.timeout(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,P)=>C.set(P,D)),await R.timeout(500),C.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(ge[195],pe([0,1,8,2,9,25,10]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(r,n,i){return r.replace(C,function(a,p){return n&&p.length>0&&p[0]!=="_"?a:i&&i.hasOwnProperty(p)?i[p]:a})}e.formatPII=D;function P(r){const n={};for(const i of Object.keys(r))i.startsWith("!")||(n[i]=r[i]);return n}e.filterExceptionsFromTelemetry=P;function s(r){return r.configuration.request==="attach"&&!I(r)}e.isSessionAttach=s;function I(r){let n=r.configuration.type;if(!!n)return n==="vslsShare"&&(n=r.configuration.adapterProxy.configuration.type),v.equalsIgnoreCase(n,"extensionhost")||v.equalsIgnoreCase(n,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function l(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=l;function g(r,n,i){let a,p=0,h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,b=null;for(;b=h.exec(r);){let y=b.index+1,o=y+b[0].length;if(y<=n&&o>=i){a=b[0],p=y;break}}if(a){let y=/\w+/g,o=null;for(;(o=y.exec(a))&&!(o.index+1+p+o[0].length>=i););o&&(a=a.substring(0,y.lastIndex))}return a?{start:p,end:p+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(c))}e.isUri=m;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return R.URI.parse(r.path);if(k.isAbsolute(r.path))return R.URI.file(r.path)}return r.path}function w(r){if(typeof r.path=="object"){const n=R.URI.revive(r.path);if(n)return n.scheme===A.Schemas.file?n.fsPath:n.toString()}return r.path}function E(r,n){const i=n?_:w,a=S.deepClone(r);return d(a,(p,h)=>{p&&h&&(h.path=i(h))}),a}e.convertToDAPaths=E;function u(r,n){const i=n?_:w,a=S.deepClone(r);return d(a,(p,h)=>{!p&&h&&(h.path=i(h))}),a}e.convertToVSCPaths=u;function d(r,n){switch(r.type){case"event":const i=r;switch(i.event){case"output":n(!1,i.body.source);break;case"loadedSource":n(!1,i.body.source);break;case"breakpoint":n(!1,i.body.breakpoint.source);break;default:break}break;case"request":const a=r;switch(a.command){case"setBreakpoints":n(!0,a.arguments.source);break;case"breakpointLocations":n(!0,a.arguments.source);break;case"source":n(!0,a.arguments.source);break;case"gotoTargets":n(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(h=>n(!1,h));break;default:break}break;case"response":const p=r;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(h=>n(!1,h.source));break;case"loadedSources":p.body.sources.forEach(h=>n(!1,h));break;case"scopes":p.body.scopes.forEach(h=>n(!1,h.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(h=>n(!1,h.source));break;case"setBreakpoints":p.body.breakpoints.forEach(h=>n(!1,h.source));break;default:break}break}}function f(r){return r.filter(n=>{var i;return!((i=n.presentation)===null||i===void 0?void 0:i.hidden)}).sort((n,i)=>n.presentation?i.presentation?n.presentation.group?i.presentation.group?n.presentation.group!==i.presentation.group?n.presentation.group.localeCompare(i.presentation.group):t(n.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(n.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=f;function t(r,n){return typeof r!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:r-n}}),define(ge[196],pe([0,1,28,38,167,120,9,8,25,11,176,119]),function(X,e,v,R,k,S,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(E,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,E.on("data",d=>this.handleData(d))}sendMessage(E){if(this.outputStream){const u=JSON.stringify(E);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(E){for(this.rawData=Buffer.concat([this.rawData,E]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const f=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const t of f){const r=t.split(l.HEADER_FIELDSEPARATOR);r[0]==="Content-Length"&&(this.contentLength=Number(r[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class g extends l{startSession(){return new Promise((E,u)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),E(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",f=>{d?this._onError.fire(f):u(f)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=g;class c extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",E)}}e.SocketDebugAdapter=c;class m extends g{constructor(E){super();this.adapterServer=E}createConnection(E){return S.createConnection(this.adapterServer.path,E)}}e.NamedPipeDebugAdapter=m;class _ extends l{constructor(E,u,d){super();this.adapterExecutable=E,this.debugType=u,this.outputService=d}async startSession(){const E=this.adapterExecutable.command,u=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(E)if(A.isAbsolute(E)){if(!await v.exists(E))throw new Error(k.localize(0,null,E))}else E.indexOf("/")<0&&E.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.debugType));let f=process.env;if(d.env&&Object.keys(d.env).length>0&&(f=D.mixin(D.deepClone(process.env),d.env)),E==="node")if(Array.isArray(u)&&u.length>0){const r=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:f,execArgv:r?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(n.cwd=d.cwd);const i=R.fork(u[0],u.slice(1),n);if(!i.pid)throw new Error(k.localize(2,null,u[0]));this.serverProcess=i}else throw new Error(k.localize(3,null));else{const r={env:f};d.cwd&&(r.cwd=d.cwd),this.serverProcess=R.spawn(E,u,r)}this.serverProcess.on("error",r=>{this._onError.fire(r)}),this.serverProcess.on("exit",(r,n)=>{this._onExit.fire(r)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",r=>{this._onError.fire(r)}),this.serverProcess.stdin.on("error",r=>{this._onError.fire(r)});const t=this.outputService;if(t){const r=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const i=t.getChannel(s.ExtensionsChannelId);i&&i.append(r(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(f){this._onError.fire(f)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((E,u)=>{const d=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(f,t,r){if(f)return u(f)});d.on("exit",E),d.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(E,u){if(!E)return;const d=Object.create(null);E.runtime&&(E.runtime.indexOf("./")===0?d.runtime=A.join(u,E.runtime):d.runtime=E.runtime),E.runtimeArgs&&(d.runtimeArgs=E.runtimeArgs),E.program&&(A.isAbsolute(E.program)?d.program=E.program:d.program=A.join(u,E.program)),E.args&&(d.args=E.args);const f=E;return f.win&&(d.win=_.extract(f.win,u)),f.winx86&&(d.winx86=_.extract(f.winx86,u)),f.windows&&(d.windows=_.extract(f.windows,u)),f.osx&&(d.osx=_.extract(f.osx,u)),f.linux&&(d.linux=_.extract(f.linux,u)),d}static platformAdapterExecutable(E,u){let d=Object.create(null);u=u.toLowerCase();for(const a of E)if(a.contributes){const p=a.contributes.debuggers;p&&p.length>0&&p.filter(h=>typeof h.type=="string"&&C.equalsIgnoreCase(h.type,u)).forEach(h=>{const b=_.extract(h,a.extensionLocation.fsPath);d=D.mixin(d,b,a.isBuiltin)})}let f;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=d.winx86||d.win||d.windows:P.isWindows?f=d.win||d.windows:P.isMacintosh?f=d.osx:P.isLinux&&(f=d.linux),f=f||d;let t=f.program||d.program;const r=f.args||d.args;let n=f.runtime||d.runtime;const i=f.runtimeArgs||d.runtimeArgs;if(n)return{type:"executable",command:n,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(r||[])};if(t)return{type:"executable",command:t,args:r||[]}}}e.ExecutableDebugAdapter=_}),define(ge[197],pe([0,1,38,11,29,179]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,g){return new Promise((c,m)=>{let _="";const w=v.spawn(l,g);w.pid&&w.stdout.on("data",E=>{_+=E.toString()}),w.on("error",E=>{m(E)}),w.on("close",E=>{c(_)})})}let C;function D(l,g){if(!C)if(R.isWindows)C=new S.WindowsExternalTerminalService;else if(R.isMacintosh)C=new S.MacExternalTerminalService;else if(R.isLinux)C=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=g.getConfiguration("terminal");return C.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=D;function P(l){return l?R.isWindows?new Promise(async g=>{(await new Promise((m,_)=>{X(["windows-process-tree"],m,_)})).getProcessTree(l,m=>{g(m.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(g=>{const c=g.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},g=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var s;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(s||(s={}));function I(l,g,c,m){l=l.trim().toLowerCase();let _;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?_=1:l.indexOf("cmd.exe")>=0?_=0:l.indexOf("bash")>=0?_=2:R.isWindows?_=0:_=2;let w,E=" ";switch(_){case 1:if(w=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=k.getDriveLetter(c);d&&(E+=`${d}:; `),E+=`cd ${w(c)}; `}if(m)for(let d in m){const f=m[d];f===null?E+=`Remove-Item env:${d}; `:E+=`\${env:${d}}='${f}'; `}if(g.length>0){const d=w(g.shift());E+=d[0]==="'"?`& ${d} `:`${d} `;for(let f of g)E+=`${w(f)} `}break;case 0:if(w=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=k.getDriveLetter(c);d&&(E+=`${d}: && `),E+=`cd ${w(c)} && `}if(m){E+='cmd /C "';for(let d in m){let f=m[d];f===null?E+=`set "${d}=" && `:(f=f.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),E+=`set "${d}=${f}" && `)}}for(let d of g)E+=`${w(d)} `;m&&(E+='"');break;case 2:w=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(E+=`cd ${w(c)} ; `),m){E+="/usr/bin/env";for(let d in m){const f=m[d];f===null?E+=` -u ${u(d)}`:E+=` ${u(`${d}=${f}`)}`}E+=" "}for(let d of g)E+=`${w(d)} `;break}return E}e.prepareCommand=I}),define(ge[60],pe([0,1,30,10,9,11,110]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var s;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(s=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(I=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.CellClearOutput=3]="CellClearOutput",o[o.CellsClearOutput=4]="CellsClearOutput",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));function m(o,L){if(L)return o.toString();const O=_.parse(o);return O?O.notebook.toString():o.toString()}e.getCellUndoRedoComparisonKey=m;var _;(function(o){o.scheme=R.Schemas.vscodeNotebookCell;const L=/^ch(\d{7,})/;function O(x,V){return x.with({scheme:o.scheme,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}o.generate=O;function W(x){if(x.scheme!==o.scheme)return;const V=L.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parse=W;function ee(x){if(x.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const V=L.exec(x.fragment);return V?{handle:Number(V[1]),notebook:x.with({scheme:x.fragment.substr(V[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=ee;function ce(x,V,T){return x.with({scheme:T,fragment:`ch${V.toString().padStart(7,"0")}${x.scheme!==R.Schemas.file?x.scheme:""}`})}o.generateCellUri=ce;function G(x,V){if(x.scheme!==V)return;const T=L.exec(x.fragment);return T?{handle:Number(T[1]),notebook:x.with({scheme:x.fragment.substr(T[0].length)||R.Schemas.file,fragment:null})}:void 0}o.parseCellUri=G})(_=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function E(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.alwaysSecure)!==null&&O!==void 0?O:!1}e.mimeTypeIsAlwaysSecure=E;function u(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.supportedByCore)!==null&&O!==void 0?O:!1}e.mimeTypeSupportedByCore=u;function d(o){var L,O;return(O=(L=w.get(o))===null||L===void 0?void 0:L.mergeable)!==null&&O!==void 0?O:!1}e.mimeTypeIsMergeable=d;function f(o,L){return S.isWindows&&(o=o.replace(/\//g,"\\"),L=L.replace(/\//g,"\\")),v.match(o,L)}function t(o,L,O){let W=0;for(let ee=0;ee<L.length;ee++){if(f(L[ee],o))return W;W++}for(let ee=0;ee<O.length;ee++){if(f(O[ee],o))return W;W++}return W}function r(o,L,O){return o.sort((W,ee)=>t(W,L,O)-t(ee,L,O))}e.sortMimeTypes=r;function n(o,L,O,W=(ee,ce)=>ee===ce){const ee=[];function ce(V,T,N){if(T===0&&N.length===0)return;const F=ee[ee.length-1];F&&F.start+F.deleteCount===V?(F.deleteCount+=T,F.toInsert.push(...N)):ee.push({start:V,deleteCount:T,toInsert:N})}let G=0,x=0;for(;;){if(G===o.length){ce(G,0,L.slice(x));break}if(x===L.length){ce(G,o.length-G,[]);break}const V=o[G],T=L[x];if(W(V,T)){G+=1,x+=1;continue}O(T)?(ce(G,1,[]),G+=1):(ce(G,0,[T]),x+=1)}return ee}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new A.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(o){o.default="default",o.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(o){const L=o;return!!((typeof L.include=="string"||v.isRelativePattern(L.include))&&(typeof L.exclude=="string"||v.isRelativePattern(L.exclude)))}e.isDocumentExcludePattern=a;function p(o,L,O){if(Array.isArray(o.viewType)&&o.viewType.indexOf(L)>=0||o.viewType===L)return!0;if(o.filenamePattern){let W=a(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,ee=a(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(v.match(W,k.basename(O.fsPath).toLowerCase()))return!(ee&&v.match(ee,k.basename(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class h{constructor(L){this.textModel=L}getElements(){const L=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)L[O]=this.textModel.cells[O].getHashValue();return L}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var b;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(L){return`${y._prefix}${L}`}static parse(L){if(L.startsWith(y._prefix))return L.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(ge[198],pe([0,1,169,4,110]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new k.RawContextKey("customExecutionSupported",!0,v.localize(0,null)),e.ShellExecutionSupportedContext=new k.RawContextKey("shellExecutionSupported",!1,v.localize(1,null)),e.ProcessExecutionSupportedContext=new k.RawContextKey("processExecutionSupported",!1,v.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ge[199],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function v(k){return[...k.entries()]}e.serializeEnvironmentVariableCollection=v;function R(k){return new Map(k)}e.deserializeEnvironmentVariableCollection=R}),define(ge[121],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var v;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=R;var k;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(k=e.TestDiffOpType||(e.TestDiffOpType={}));const S=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=S;class A{add(P){}update(P){}remove(P,s){}complete(){}}e.IncrementalChangeCollector=A;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const s=this.createChangeCollector();for(const I of P)switch(I[0]){case 0:{const l=I[1];if(l.parent){if(this.items.has(l.parent)){const g=this.items.get(l.parent);g.children.add(l.item.extId);const c=this.createItem(l,g);this.items.set(l.item.extId,c),s.add(c)}}else{this.roots.add(l.item.extId);const g=this.createItem(l);this.items.set(l.item.extId,g),s.add(g)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=I[1],g=this.items.get(l.extId);if(!g)break;l.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(g,l),s.update(g);break}case 2:{const l=this.items.get(I[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l.item.extId);const g=[[I[1]]];for(;g.length;)for(const c of g.pop()){const m=this.items.get(c);m&&(g.push(m.children),this.items.delete(c),s.remove(m,m!==l),m.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}s.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=C}),define(ge[200],pe([0,1,9,37,13,25,11,76,170]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(I,l,g){this._contributedVariables=new Map,this._context=I,this._labelService=l,g&&(this._envVariablesPromise=g.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(A.isWindows){const l=Object.create(null);return Object.keys(I).forEach(g=>{l[g.toLowerCase()]=I[g]}),l}return I}resolveWithEnvironment(I,l,g){return this.recursiveResolve(this.prepareEnv(I),l?l.uri:void 0,g)}async resolveAsync(I,l){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,l)}async resolveAnyBase(I,l,g,c){const m=S.deepClone(l);return A.isWindows&&m.windows?Object.keys(m.windows).forEach(_=>m[_]=m.windows[_]):A.isMacintosh&&m.osx?Object.keys(m.osx).forEach(_=>m[_]=m.osx[_]):A.isLinux&&m.linux&&Object.keys(m.linux).forEach(_=>m[_]=m.linux[_]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,m,g,c)}async resolveAnyAsync(I,l,g){return this.resolveAnyBase(I,l,g)}async resolveAnyMap(I,l,g){const c=new Map;return{newConfig:await this.resolveAnyBase(I,l,g,c),resolvedVariables:c}}resolveWithInteractionReplace(I,l,g,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,l,g,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,l){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,l)}recursiveResolve(I,l,g,c,m){if(k.isString(g))return this.resolveString(I,l,g,c,m);if(k.isArray(g))return g.map(_=>this.recursiveResolve(I,l,_,c,m));if(k.isObject(g)){let _=Object.create(null);return Object.keys(g).forEach(w=>{const E=this.resolveString(I,l,w,c,m);_[E]=this.recursiveResolve(I,l,g[w],c,m)}),_}return g}resolveString(I,l,g,c,m){return g.replace(P.VARIABLE_REGEXP,(w,E)=>{if(E.includes(P.VARIABLE_LHS))return w;let u=this.evaluateSingleVariable(I,w,E,l,c);return m&&m.set(E,u),u!==w&&k.isString(u)&&u.match(P.VARIABLE_REGEXP)&&(u=this.resolveString(I,l,u,c,m)),u})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,l,g,c,m){let _;const w=g.split(":");w.length>1&&(g=w[0],_=w[1]);const E=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error(D.localize(0,null,l))},u=()=>{const f=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(D.localize(1,null,l,v.basename(f)))},d=()=>{if(_){const f=this._context.getFolderUri(_);if(f)return f;throw new Error(D.localize(2,null,l,_))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(D.localize(3,null,l)):new Error(D.localize(4,null,l))};switch(g){case"env":if(_){if(I){const f=I[A.isWindows?_.toLowerCase():_];if(k.isString(f))return f}return""}throw new Error(D.localize(5,null,l));case"config":if(_){const f=this._context.getConfigurationValue(c,_);if(k.isUndefinedOrNull(f))throw new Error(D.localize(6,null,l,_));if(k.isObject(f))throw new Error(D.localize(7,null,l,_));return f}throw new Error(D.localize(8,null,l));case"command":return this.resolveFromMap(l,_,m,"command");case"input":return this.resolveFromMap(l,_,m,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return C.normalizeDriveLetter(this.fsPath(d()));case"cwd":return c||_?C.normalizeDriveLetter(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return v.basename(this.fsPath(d()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error(D.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(D.localize(10,null,l));case"file":return E();case"fileWorkspaceFolder":return u();case"relativeFile":return c||_?v.relative(this.fsPath(d()),E()):E();case"relativeFileDirname":const r=v.dirname(E());if(c||_){const p=v.relative(this.fsPath(d()),r);return p.length===0?".":p}return r;case"fileDirname":return v.dirname(E());case"fileExtname":return v.extname(E());case"fileBasename":return v.basename(E());case"fileBasenameNoExtension":const n=v.basename(E());return n.slice(0,n.length-v.extname(n).length);case"fileDirnameBasename":return v.basename(v.dirname(E()));case"execPath":const i=this._context.getExecPath();return i||l;case"execInstallFolder":const a=this._context.getAppRoot();return a||l;case"pathSeparator":return v.sep;default:try{const p=_?`${g}:${_}`:g;return this.resolveFromMap(l,p,m,void 0)}catch(p){return l}}}}resolveFromMap(I,l,g,c){if(l&&g){const m=c===void 0?g[l]:g[c+":"+l];if(typeof m=="string")return m;throw new Error(D.localize(11,null,I))}return I}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ge[201],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=v.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var k;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(k=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var s;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(s=e.OpenEditorContext||(e.OpenEditorContext={}));function I(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ge[202],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=v.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ge[18],pe([0,1,17,94,273,53,25,13,2,41,79,171,112,60,202,7]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var _;(function(Ee){function De(q){const{selectionStartLineNumber:Ue,selectionStartColumn:Le,positionLineNumber:Ge,positionColumn:Je}=q,lt=new m.Position(Ue-1,Le-1),ct=new m.Position(Ge-1,Je-1);return new m.Selection(lt,ct)}Ee.to=De;function de(q){const{anchor:Ue,active:Le}=q;return{selectionStartLineNumber:Ue.line+1,selectionStartColumn:Ue.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Ee.from=de})(_=e.Selection||(e.Selection={}));var w;(function(Ee){function De(q){if(!q)return;const{start:Ue,end:Le}=q;return{startLineNumber:Ue.line+1,startColumn:Ue.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Ee.from=De;function de(q){if(!q)return;const{startLineNumber:Ue,startColumn:Le,endLineNumber:Ge,endColumn:Je}=q;return new m.Range(Ue-1,Le-1,Ge-1,Je-1)}Ee.to=de})(w=e.Range||(e.Range={}));var E;(function(Ee){function De(de){switch(de){case 1:return m.StandardTokenType.Comment;case 0:return m.StandardTokenType.Other;case 4:return m.StandardTokenType.RegEx;case 2:return m.StandardTokenType.String}}Ee.to=De})(E=e.TokenType||(e.TokenType={}));var u;(function(Ee){function De(q){return new m.Position(q.lineNumber-1,q.column-1)}Ee.to=De;function de(q){return{lineNumber:q.line+1,column:q.character+1}}Ee.from=de})(u=e.Position||(e.Position={}));var d;(function(Ee){function De(q){switch(q){case m.DiagnosticTag.Unnecessary:return 1;case m.DiagnosticTag.Deprecated:return 2}}Ee.from=De;function de(q){switch(q){case 1:return m.DiagnosticTag.Unnecessary;case 2:return m.DiagnosticTag.Deprecated;default:return}}Ee.to=de})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(Ee){function De(q){let Ue;return q.code&&(C.isString(q.code)||C.isNumber(q.code)?Ue=String(q.code):Ue={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},w.from(q.range)),{message:q.message,source:q.source,code:Ue,severity:r.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?v.coalesce(q.tags.map(d.from)):void 0})}Ee.from=De;function de(q){var Ue;const Le=new m.Diagnostic(w.to(q),q.message,r.to(q.severity));return Le.source=q.source,Le.code=C.isString(q.code)?q.code:(Ue=q.code)===null||Ue===void 0?void 0:Ue.value,Le.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Le.tags=q.tags&&v.coalesce(q.tags.map(d.to)),Le}Ee.to=de})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function De(q){return Object.assign(Object.assign({},w.from(q.location.range)),{message:q.message,resource:q.location.uri})}Ee.from=De;function de(q){return new m.DiagnosticRelatedInformation(new m.Location(q.resource,w.to(q)),q.message)}Ee.to=de})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(Ee){function De(q){switch(q){case m.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case m.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case m.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case m.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=De;function de(q){switch(q){case l.MarkerSeverity.Info:return m.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return m.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return m.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return m.DiagnosticSeverity.Hint;default:return m.DiagnosticSeverity.Error}}Ee.to=de})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var n;(function(Ee){function De(q){return typeof q=="number"&&q>=m.ViewColumn.One?q-1:q===m.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Ee.from=De;function de(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(n=e.ViewColumn||(e.ViewColumn={}));function i(Ee){return typeof Ee.range!="undefined"}function a(Ee){return Ee.length===0?!0:!!i(Ee[0])}e.isDecorationOptionsArr=a;var p;(function(Ee){function De(Je){return Je.map(Ee.from)}Ee.fromMany=De;function de(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function q(Je){let lt;if(de(Je)){const{language:St,value:vt}=Je;lt={value:"```"+St+`
`+vt+"\n```\n"}}else m.MarkdownString.isMarkdownString(Je)?lt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons}:typeof Je=="string"?lt={value:Je}:lt={value:""};const ct=Object.create(null);lt.uris=ct;const it=St=>{try{let vt=D.URI.parse(St,!0);vt=vt.with({query:Ue(vt.query,ct)}),ct[St]=vt}catch(vt){}return""},mt=new k.Renderer;return mt.link=it,mt.image=St=>it(R.parseHrefAndDimensions(St).href),k(lt.value,{renderer:mt}),lt}Ee.from=q;function Ue(Je,lt){if(!Je)return Je;let ct;try{ct=S.parse(Je)}catch(mt){}if(!ct)return Je;let it=!1;return ct=A.cloneAndChange(ct,mt=>{if(D.URI.isUri(mt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[St]=mt,it=!0,St}else return}),it?JSON.stringify(ct):Je}function Le(Je){const lt=new m.MarkdownString(Je.value,Je.supportThemeIcons);return lt.isTrusted=Je.isTrusted,lt}Ee.to=Le;function Ge(Je){if(!!Je)return typeof Je=="string"?Je:Ee.from(Je)}Ee.fromStrict=Ge})(p=e.MarkdownString||(e.MarkdownString={}));function h(Ee){return a(Ee)?Ee.map(De=>({range:w.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?p.fromMany(De.hoverMessage):De.hoverMessage?p.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Ee.map(De=>({range:w.from(De)}))}e.fromRangeOrRangeWithMessage=h;function b(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?D.URI.file(Ee):Ee}e.pathOrURIToURI=b;var y;(function(Ee){function De(de){return typeof de=="undefined"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?b(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=De})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(Ee){function De(de){return typeof de=="undefined"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?b(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?y.from(de.before):void 0,after:de.after?y.from(de.after):void 0}}Ee.from=De})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var L;(function(Ee){function De(de){if(typeof de=="undefined")return de;switch(de){case m.DecorationRangeBehavior.OpenOpen:return 0;case m.DecorationRangeBehavior.ClosedClosed:return 1;case m.DecorationRangeBehavior.OpenClosed:return 2;case m.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=De})(L=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(Ee){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?L.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?o.from(de.light):void 0,dark:de.dark?o.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?b(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?y.from(de.before):void 0,after:de.after?y.from(de.after):void 0}}Ee.from=De})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(Ee){function De(q){return{text:q.newText,eol:q.newEol&&Q.from(q.newEol),range:w.from(q.range)}}Ee.from=De;function de(q){const Ue=new m.TextEdit(w.to(q.range),q.text);return Ue.newEol=typeof q.eol=="undefined"?void 0:Q.to(q.eol),Ue}Ee.to=de})(W=e.TextEdit||(e.TextEdit={}));var ee;(function(Ee){function De(q,Ue,Le){var Ge,Je,lt;const ct={edits:[]};if(q instanceof m.WorkspaceEdit)for(let it of q._allEntries())if(it._type===1)ct.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const mt=Ue==null?void 0:Ue.getDocument(it.uri);ct.edits.push({_type:2,resource:it.uri,edit:W.from(it.edit),modelVersionId:mt==null?void 0:mt.version,metadata:it.metadata})}else it._type===3?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ge=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Ge===void 0?void 0:Ge.apiNotebook.version}):it._type===4?(it.newOutputs&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(ue.from)}}),it.newMetadata&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(Je=Le==null?void 0:Le.getNotebookDocument(it.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(H.from)}}):it._type===6&&ct.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((lt=it.newOutputItems)===null||lt===void 0?void 0:lt.map(Z.from))||[],append:it.append}});return ct}Ee.from=De;function de(q){const Ue=new m.WorkspaceEdit;for(const Le of q.edits)Le.edit?Ue.replace(D.URI.revive(Le.resource),w.to(Le.edit.range),Le.edit.text):Ue.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ue}Ee.to=de})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(Ee){const De=Object.create(null);De[m.SymbolKind.File]=0,De[m.SymbolKind.Module]=1,De[m.SymbolKind.Namespace]=2,De[m.SymbolKind.Package]=3,De[m.SymbolKind.Class]=4,De[m.SymbolKind.Method]=5,De[m.SymbolKind.Property]=6,De[m.SymbolKind.Field]=7,De[m.SymbolKind.Constructor]=8,De[m.SymbolKind.Enum]=9,De[m.SymbolKind.Interface]=10,De[m.SymbolKind.Function]=11,De[m.SymbolKind.Variable]=12,De[m.SymbolKind.Constant]=13,De[m.SymbolKind.String]=14,De[m.SymbolKind.Number]=15,De[m.SymbolKind.Boolean]=16,De[m.SymbolKind.Array]=17,De[m.SymbolKind.Object]=18,De[m.SymbolKind.Key]=19,De[m.SymbolKind.Null]=20,De[m.SymbolKind.EnumMember]=21,De[m.SymbolKind.Struct]=22,De[m.SymbolKind.Event]=23,De[m.SymbolKind.Operator]=24,De[m.SymbolKind.TypeParameter]=25;function de(Ue){return typeof De[Ue]=="number"?De[Ue]:6}Ee.from=de;function q(Ue){for(const Le in De)if(De[Le]===Ue)return Number(Le);return m.SymbolKind.Property}Ee.to=q})(ce=e.SymbolKind||(e.SymbolKind={}));var G;(function(Ee){function De(q){switch(q){case m.SymbolTag.Deprecated:return 1}}Ee.from=De;function de(q){switch(q){case 1:return m.SymbolTag.Deprecated}}Ee.to=de})(G=e.SymbolTag||(e.SymbolTag={}));var x;(function(Ee){function De(q){return{name:q.name,kind:ce.from(q.kind),tags:q.tags&&q.tags.map(G.from),containerName:q.containerName,location:M.from(q.location)}}Ee.from=De;function de(q){const Ue=new m.SymbolInformation(q.name,ce.to(q.kind),q.containerName,M.to(q.location));return Ue.tags=q.tags&&q.tags.map(G.to),Ue}Ee.to=de})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var V;(function(Ee){function De(q){var Ue,Le;const Ge={name:q.name||"!!MISSING: name!!",detail:q.detail,range:w.from(q.range),selectionRange:w.from(q.selectionRange),kind:ce.from(q.kind),tags:(Le=(Ue=q.tags)===null||Ue===void 0?void 0:Ue.map(G.from))!==null&&Le!==void 0?Le:[]};return q.children&&(Ge.children=q.children.map(De)),Ge}Ee.from=De;function de(q){const Ue=new m.DocumentSymbol(q.name,q.detail,ce.to(q.kind),w.to(q.range),w.to(q.selectionRange));return v.isNonEmptyArray(q.tags)&&(Ue.tags=q.tags.map(G.to)),q.children&&(Ue.children=q.children.map(de)),Ue}Ee.to=de})(V=e.DocumentSymbol||(e.DocumentSymbol={}));var T;(function(Ee){function De(de){const q=new m.CallHierarchyItem(ce.to(de.kind),de.name,de.detail||"",D.URI.revive(de.uri),w.to(de.range),w.to(de.selectionRange));return q._sessionId=de._sessionId,q._itemId=de._itemId,q}Ee.to=De})(T=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Ee){function De(de){return new m.CallHierarchyIncomingCall(T.to(de.from),de.fromRanges.map(q=>w.to(q)))}Ee.to=De})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ee){function De(de){return new m.CallHierarchyOutgoingCall(T.to(de.to),de.fromRanges.map(q=>w.to(q)))}Ee.to=De})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function De(q){return{range:q.range&&w.from(q.range),uri:q.uri}}Ee.from=De;function de(q){return new m.Location(D.URI.revive(q.uri),w.to(q.range))}Ee.to=de})(M=e.location||(e.location={}));var U;(function(Ee){function De(q){const Ue=q,Le=q;return{originSelectionRange:Ue.originSelectionRange?w.from(Ue.originSelectionRange):void 0,uri:Ue.targetUri?Ue.targetUri:Le.uri,range:w.from(Ue.targetRange?Ue.targetRange:Le.range),targetSelectionRange:Ue.targetSelectionRange?w.from(Ue.targetSelectionRange):void 0}}Ee.from=De;function de(q){return{targetUri:D.URI.revive(q.uri),targetRange:w.to(q.range),targetSelectionRange:q.targetSelectionRange?w.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?w.to(q.originSelectionRange):void 0}}Ee.to=de})(U=e.DefinitionLink||(e.DefinitionLink={}));var B;(function(Ee){function De(q){return{range:w.from(q.range),contents:p.fromMany(q.contents)}}Ee.from=De;function de(q){return new m.Hover(q.contents.map(p.to),w.to(q.range))}Ee.to=de})(B=e.Hover||(e.Hover={}));var K;(function(Ee){function De(q){return{range:w.from(q.range),expression:q.expression}}Ee.from=De;function de(q){return new m.EvaluatableExpression(w.to(q.range),q.expression)}Ee.to=de})(K=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ie;(function(Ee){function De(q){if(q instanceof m.InlineValueText)return{type:"text",range:w.from(q.range),text:q.text};if(q instanceof m.InlineValueVariableLookup)return{type:"variable",range:w.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof m.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=De;function de(q){switch(q.type){case"text":return{range:w.to(q.range),text:q.text};case"variable":return{range:w.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:w.to(q.range),expression:q.expression}}}Ee.to=de})(ie=e.InlineValue||(e.InlineValue={}));var we;(function(Ee){function De(q){return{frameId:q.frameId,stoppedLocation:w.from(q.stoppedLocation)}}Ee.from=De;function de(q){return new m.InlineValueContext(q.frameId,w.to(q.stoppedLocation))}Ee.to=de})(we=e.InlineValueContext||(e.InlineValueContext={}));var Te;(function(Ee){function De(q){return{range:w.from(q.range),kind:q.kind}}Ee.from=De;function de(q){return new m.DocumentHighlight(w.to(q.range),q.kind)}Ee.to=de})(Te=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Ee){function De(de){switch(de){case 1:return m.CompletionTriggerKind.TriggerCharacter;case 2:return m.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return m.CompletionTriggerKind.Invoke}}Ee.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(Ee){function De(de){return{triggerKind:ye.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=De})(Oe=e.CompletionContext||(e.CompletionContext={}));var je;(function(Ee){function De(q){switch(q){case m.CompletionItemTag.Deprecated:return 1}}Ee.from=De;function de(q){switch(q){case 1:return m.CompletionItemTag.Deprecated}}Ee.to=de})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const De=new Map([[m.CompletionItemKind.Method,0],[m.CompletionItemKind.Function,1],[m.CompletionItemKind.Constructor,2],[m.CompletionItemKind.Field,3],[m.CompletionItemKind.Variable,4],[m.CompletionItemKind.Class,5],[m.CompletionItemKind.Interface,7],[m.CompletionItemKind.Struct,6],[m.CompletionItemKind.Module,8],[m.CompletionItemKind.Property,9],[m.CompletionItemKind.Unit,12],[m.CompletionItemKind.Value,13],[m.CompletionItemKind.Constant,14],[m.CompletionItemKind.Enum,15],[m.CompletionItemKind.EnumMember,16],[m.CompletionItemKind.Keyword,17],[m.CompletionItemKind.Snippet,27],[m.CompletionItemKind.Text,18],[m.CompletionItemKind.Color,19],[m.CompletionItemKind.File,20],[m.CompletionItemKind.Reference,21],[m.CompletionItemKind.Folder,23],[m.CompletionItemKind.Event,10],[m.CompletionItemKind.Operator,11],[m.CompletionItemKind.TypeParameter,24],[m.CompletionItemKind.Issue,26],[m.CompletionItemKind.User,25]]);function de(Le){var Ge;return(Ge=De.get(Le))!==null&&Ge!==void 0?Ge:9}Ee.from=de;const q=new Map([[0,m.CompletionItemKind.Method],[1,m.CompletionItemKind.Function],[2,m.CompletionItemKind.Constructor],[3,m.CompletionItemKind.Field],[4,m.CompletionItemKind.Variable],[5,m.CompletionItemKind.Class],[7,m.CompletionItemKind.Interface],[6,m.CompletionItemKind.Struct],[8,m.CompletionItemKind.Module],[9,m.CompletionItemKind.Property],[12,m.CompletionItemKind.Unit],[13,m.CompletionItemKind.Value],[14,m.CompletionItemKind.Constant],[15,m.CompletionItemKind.Enum],[16,m.CompletionItemKind.EnumMember],[17,m.CompletionItemKind.Keyword],[27,m.CompletionItemKind.Snippet],[18,m.CompletionItemKind.Text],[19,m.CompletionItemKind.Color],[20,m.CompletionItemKind.File],[21,m.CompletionItemKind.Reference],[23,m.CompletionItemKind.Folder],[10,m.CompletionItemKind.Event],[11,m.CompletionItemKind.Operator],[24,m.CompletionItemKind.TypeParameter],[25,m.CompletionItemKind.User],[26,m.CompletionItemKind.Issue]]);function Ue(Le){var Ge;return(Ge=q.get(Le))!==null&&Ge!==void 0?Ge:m.CompletionItemKind.Property}Ee.to=Ue})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function(Ee){function De(de,q){var Ue;const Le=new m.CompletionItem(typeof de.label=="string"?de.label:de.label.name);return typeof de.label!="string"&&(Le.label2=de.label),Le.insertText=de.insertText,Le.kind=ze.to(de.kind),Le.tags=(Ue=de.tags)===null||Ue===void 0?void 0:Ue.map(je.to),Le.detail=de.detail,Le.documentation=R.isMarkdownString(de.documentation)?p.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,P.Range.isIRange(de.range)?Le.range=w.to(de.range):typeof de.range=="object"&&(Le.range={inserting:w.to(de.range.insert),replacing:w.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules=="undefined"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules!="undefined"&&de.insertTextRules&4?Le.insertText=new m.SnippetString(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof m.Range?new m.TextEdit(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ge=>W.to(Ge))),Le.command=q&&de.command?q.fromInternal(de.command):void 0,Le}Ee.to=De})(qe=e.CompletionItem||(e.CompletionItem={}));var j;(function(Ee){function De(q){return{label:q.label,documentation:q.documentation?p.fromStrict(q.documentation):void 0}}Ee.from=De;function de(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?p.to(q.documentation):q.documentation}}Ee.to=de})(j=e.ParameterInformation||(e.ParameterInformation={}));var J;(function(Ee){function De(q){return{label:q.label,documentation:q.documentation?p.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(j.from):[],activeParameter:q.activeParameter}}Ee.from=De;function de(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?p.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(j.to):[],activeParameter:q.activeParameter}}Ee.to=de})(J=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(Ee){function De(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(J.from):[]}}Ee.from=De;function de(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(J.to):[]}}Ee.to=de})(ne=e.SignatureHelp||(e.SignatureHelp={}));var oe;(function(Ee){function De(q){var Ue;return{text:q.text,position:u.from(q.position),kind:Y.from((Ue=q.kind)!==null&&Ue!==void 0?Ue:m.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}Ee.from=De;function de(q){const Ue=new m.InlayHint(q.text,u.to(q.position),Y.to(q.kind));return Ue.whitespaceAfter=q.whitespaceAfter,Ue.whitespaceBefore=q.whitespaceBefore,Ue}Ee.to=de})(oe=e.InlayHint||(e.InlayHint={}));var Y;(function(Ee){function De(q){return q}Ee.from=De;function de(q){return q}Ee.to=de})(Y=e.InlayHintKind||(e.InlayHintKind={}));var le;(function(Ee){function De(q){return{range:w.from(q.range),url:q.target,tooltip:q.tooltip}}Ee.from=De;function de(q){let Ue;if(q.url)try{Ue=typeof q.url=="string"?D.URI.parse(q.url,!0):D.URI.revive(q.url)}catch(Le){}return new m.DocumentLink(w.to(q.range),Ue)}Ee.to=de})(le=e.DocumentLink||(e.DocumentLink={}));var me;(function(Ee){function De(q){const Ue=new m.ColorPresentation(q.label);return q.textEdit&&(Ue.textEdit=W.to(q.textEdit)),q.additionalTextEdits&&(Ue.additionalTextEdits=q.additionalTextEdits.map(Le=>W.to(Le))),Ue}Ee.to=De;function de(q){return{label:q.label,textEdit:q.textEdit?W.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ue=>W.from(Ue)):void 0}}Ee.from=de})(me=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(Ee){function De(q){return new m.Color(q[0],q[1],q[2],q[3])}Ee.to=De;function de(q){return[q.red,q.green,q.blue,q.alpha]}Ee.from=de})(Re=e.Color||(e.Color={}));var We;(function(Ee){function De(q){return{range:w.from(q.range)}}Ee.from=De;function de(q){return new m.SelectionRange(w.to(q.range))}Ee.to=de})(We=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function De(de){switch(de){case 2:return m.TextDocumentSaveReason.AfterDelay;case 1:return m.TextDocumentSaveReason.Manual;case 3:case 4:return m.TextDocumentSaveReason.FocusOut}}Ee.to=De})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Xe;(function(Ee){function De(q){switch(q){case m.TextEditorLineNumbersStyle.Off:return 0;case m.TextEditorLineNumbersStyle.Relative:return 2;case m.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=De;function de(q){switch(q){case 0:return m.TextEditorLineNumbersStyle.Off;case 2:return m.TextEditorLineNumbersStyle.Relative;case 1:default:return m.TextEditorLineNumbersStyle.On}}Ee.to=de})(Xe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Q;(function(Ee){function De(q){if(q===m.EndOfLine.CRLF)return 1;if(q===m.EndOfLine.LF)return 0}Ee.from=De;function de(q){if(q===1)return m.EndOfLine.CRLF;if(q===0)return m.EndOfLine.LF}Ee.to=de})(Q=e.EndOfLine||(e.EndOfLine={}));var re;(function(Ee){function De(de){if(typeof de=="object")return de.viewId;switch(de){case m.ProgressLocation.SourceControl:return 3;case m.ProgressLocation.Window:return 10;case m.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=De})(re=e.ProgressLocation||(e.ProgressLocation={}));var ve;(function(Ee){function De(de){const q={start:de.start+1,end:de.end+1};return de.kind&&(q.kind=Me.from(de.kind)),q}Ee.from=De})(ve=e.FoldingRange||(e.FoldingRange={}));var Me;(function(Ee){function De(de){if(de)switch(de){case m.FoldingRangeKind.Comment:return s.FoldingRangeKind.Comment;case m.FoldingRangeKind.Imports:return s.FoldingRangeKind.Imports;case m.FoldingRangeKind.Region:return s.FoldingRangeKind.Region}}Ee.from=De})(Me=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(Ee){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?w.from(de.selection):void 0,override:typeof de.override=="boolean"?I.EditorOverride.DISABLED:void 0}}Ee.from=De})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(Ee){function De(q){return q instanceof m.RelativePattern||typeof q=="string"?q:de(q)?new m.RelativePattern(q.base,q.pattern):q}Ee.from=De;function de(q){const Ue=q;return Ue&&typeof Ue.base=="string"&&typeof Ue.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var Se;(function(Ee){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const q=de;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ye.from(q.pattern),exclusive:q.exclusive}}}else return}Ee.from=De})(Se=e.LanguageSelector||(e.LanguageSelector={}));var _e;(function(Ee){function De(q){return{start:q.start,end:q.end}}Ee.from=De;function de(q){return new m.NotebookRange(q.start,q.end)}Ee.to=de})(_e=e.NotebookRange||(e.NotebookRange={}));var ke;(function(Ee){function De(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Ee.to=De;function de(q){var Ue,Le;return{lastRunSuccess:q.success,runStartTime:(Ue=q.timing)===null||Ue===void 0?void 0:Ue.startTime,runEndTime:(Le=q.timing)===null||Le===void 0?void 0:Le.endTime,executionOrder:q.executionOrder}}Ee.from=de})(ke=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ae;(function(Ee){function De(q){switch(q){case m.NotebookCellKind.Markup:return g.CellKind.Markup;case m.NotebookCellKind.Code:default:return g.CellKind.Code}}Ee.from=De;function de(q){switch(q){case g.CellKind.Markup:return m.NotebookCellKind.Markup;case g.CellKind.Code:default:return m.NotebookCellKind.Code}}Ee.to=de})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(Ee){function De(q){var Ue;const Le={metadata:(Ue=q.metadata)!==null&&Ue!==void 0?Ue:Object.create(null),cells:[]};for(let Ge of q.cells)m.NotebookCellData.validate(Ge),Le.cells.push(H.from(Ge));return Le}Ee.from=De;function de(q){const Ue=new m.NotebookData(q.cells.map(H.to));return C.isEmptyObject(q.metadata)||(Ue.metadata=q.metadata),Ue}Ee.to=de})(fe=e.NotebookData||(e.NotebookData={}));var H;(function(Ee){function De(q){var Ue;return{cellKind:ae.from(q.kind),language:q.languageId,source:q.value,metadata:q.metadata,internalMetadata:ke.from((Ue=q.executionSummary)!==null&&Ue!==void 0?Ue:{}),outputs:q.outputs?q.outputs.map(ue.from):[]}}Ee.from=De;function de(q){return new m.NotebookCellData(ae.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ue.to):void 0,q.metadata,q.internalMetadata?ke.to(q.internalMetadata):void 0)}Ee.to=de})(H=e.NotebookCellData||(e.NotebookCellData={}));var Z;(function(Ee){function De(q){return{mime:q.mime,valueBytes:Array.from(q.data)}}Ee.from=De;function de(q){return new m.NotebookCellOutputItem(new Uint8Array(q.valueBytes),q.mime)}Ee.to=de})(Z=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ue;(function(Ee){function De(q){return{outputId:q.id,outputs:q.items.map(Z.from),metadata:q.metadata}}Ee.from=De;function de(q){const Ue=q.outputs.map(Z.to);return new m.NotebookCellOutput(Ue,q.outputId,q.metadata)}Ee.to=de})(ue=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(Ee){function De(Le){if(Le!=null){if(Le instanceof m.RelativePattern||typeof Le=="string")return Le;if(Ue(Le))return new m.RelativePattern(Le.base,Le.pattern);if(q(Le))return{include:Ye.from(Le.include)||void 0,exclude:Ye.from(Le.exclude)||void 0}}}Ee.from=De;function de(Le){return typeof Le=="string"?Le:Ue(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}Ee.to=de;function q(Le){const Ge=Le,Je=Ye.from(Ge.include);if(!(Je&&Je instanceof m.RelativePattern||typeof Je=="string"))return!1;const lt=Ye.from(Ge.exclude);return!!(lt&&lt instanceof m.RelativePattern||typeof lt=="string")}function Ue(Le){const Ge=Le;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(Ee){function De(de){return{backgroundColor:de.backgroundColor,borderColor:de.borderColor,top:de.top?y.from(de.top):void 0}}Ee.from=De})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(Ee){function De(de,q,Ue){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===m.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ue),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=De})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Be;(function(Ee){function De(de){var q,Ue,Le;return{transientOutputs:(q=de==null?void 0:de.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:(Ue=de==null?void 0:de.transientCellMetadata)!==null&&Ue!==void 0?Ue:{},transientDocumentMetadata:(Le=de==null?void 0:de.transientDocumentMetadata)!==null&&Le!==void 0?Le:{}}}Ee.from=De})(Be=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Qe;(function(Ee){function De(q){return{uri:q.uri,provides:q.provides}}Ee.from=De;function de(q){return new m.NotebookRendererScript(D.URI.revive(q.uri),q.provides)}Ee.to=de})(Qe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(Ee){function De(q){return{message:p.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?M.from(q.location):void 0}}Ee.from=De;function de(q){const Ue=new m.TestMessage(typeof q.message=="string"?q.message:p.to(q.message));return Ue.severity=q.severity,Ue.actualOutput=q.actualOutput,Ue.expectedOutput=q.expectedOutput,Ue}Ee.to=de})(rt=e.TestMessage||(e.TestMessage={}));var nt;(function(Ee){function De(Le){var Ge,Je;return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:(Ge=Le.debuggable)!==null&&Ge!==void 0?Ge:!1,description:Le.description||null,runnable:(Je=Le.runnable)!==null&&Je!==void 0?Je:!0,error:Le.error&&p.fromStrict(Le.error)||null}}Ee.from=De;function de(Le){return{extId:Le.id,label:Le.label,uri:Le.uri,range:w.from(Le.range)||null,debuggable:!1,description:Le.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=de;function q(Le){return{id:Le.extId,label:Le.label,uri:D.URI.revive(Le.uri),range:w.to(Le.range||void 0),addChild:()=>{},dispose:()=>{},status:m.TestItemStatus.Pending,data:void 0,debuggable:Le.debuggable,description:Le.description||void 0,runnable:Le.runnable}}Ee.toPlain=q;function Ue(Le){const Ge=new m.TestItemImpl(Le.extId,Le.label,D.URI.revive(Le.uri),void 0);return Ge.range=w.to(Le.range||void 0),Ge.debuggable=Le.debuggable,Ge.description=Le.description||void 0,Ge.runnable=Le.runnable,Ge}Ee.to=Ue})(nt=e.TestItem||(e.TestItem={}));var Ze;(function(Ee){const De=(q,Ue)=>Object.assign(Object.assign({},nt.toPlain(q.item)),{taskStates:q.tasks.map(Le=>({state:Le.state,duration:Le.duration,messages:Le.messages.map(rt.to)})),children:q.children.map(Le=>Ue.get(Le)).filter(C.isDefined).map(Le=>De(Le,Ue))});function de(q){const Ue=[],Le=new Map;for(const Ge of q.items)Le.set(Ge.item.extId,Ge),Ge.direct&&Ue.push(Ge);return{completedAt:q.completedAt,results:Ue.map(Ge=>De(Ge,Le))}}Ee.to=de})(Ze=e.TestResults||(e.TestResults={}));var ot;(function(Ee){function De(de){switch(de){case 1:return m.CodeActionTriggerKind.Invoke;case 2:return m.CodeActionTriggerKind.Automatic}}Ee.to=De})(ot=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ge[203],pe([0,1,2,16,7,18,72]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(P,s,I,l={timeout:1500,errors:3}){this._logService=P,this._documents=s,this._mainThreadBulkEdits=I,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(s,I,l)=>{const c={dispose:this._callbacks.push([s,I,P])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(P,s){const I=v.URI.revive(P);let l=!1;const g=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let m of[...this._callbacks]){if(l)break;const _=this._documents.getDocument(I),w=await this._deliverEventAsyncAndBlameBadListeners(m,{document:_,reason:S.TextDocumentSaveReason.to(s)});c.push(w)}}finally{clearTimeout(g)}return c}_deliverEventAsyncAndBlameBadListeners([P,s,I],l){const g=this._badListeners.get(P);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,P,s,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const m=this._badListeners.get(P);this._badListeners.set(P,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,s,I,l){const g=[],c=Date.now(),{document:m,reason:_}=l,{version:w}=m,E=Object.freeze({document:m,reason:_,waitUntil(u){if(Object.isFrozen(g))throw R.illegalState("waitUntil can not be called async");g.push(Promise.resolve(u))}});try{s.apply(I,[E])}catch(u){return Promise.reject(u)}return Object.freeze(g),new Promise((u,d)=>{const f=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(f),u(t)}).catch(t=>{clearTimeout(f),d(t)})}).then(u=>{const d={edits:[]};for(const f of u)if(Array.isArray(f)&&f.every(t=>t instanceof k.TextEdit))for(const{newText:t,newEol:r,range:n}of f)d.edits.push({_type:2,resource:m.uri,edit:{range:n&&S.Range.from(n),text:t,eol:r&&S.EndOfLine.from(r)}});if(d.edits.length!==0)return w===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(ge[204],pe([0,1,3,14,30,2,18,7]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,l,g,c,m){this._onDidCreate=new v.Emitter,this._onDidChange=new v.Emitter,this._onDidDelete=new v.Emitter,this._config=0,g&&(this._config+=1),c&&(this._config+=2),m&&(this._config+=4);const _=k.parse(l),w=I(E=>{if(!g)for(let u of E.created){const d=S.URI.revive(u);_(d.fsPath)&&this._onDidCreate.fire(d)}if(!c)for(let u of E.changed){const d=S.URI.revive(u);_(d.fsPath)&&this._onDidChange.fire(d)}if(!m)for(let u of E.deleted){const d=S.URI.revive(u);_(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(I,l,g){this._logService=l,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new v.Emitter,this._onDidRenameFile=new v.Emitter,this._onDidCreateFile=new v.Emitter,this._onDidDeleteFile=new v.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,l,g,c){return new D(this._onFileSystemEvent.event,I,l,g,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,l){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(g=>({oldUri:S.URI.revive(g.source),newUri:S.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(g=>S.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(g=>S.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,l){return(g,c,m)=>{const _=function(E){g.call(c,E)};return _.extension=I,l.event(_,void 0,m)}}async $onWillRunFileOperation(I,l,g,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(m=>({oldUri:S.URI.revive(m.source),newUri:S.URI.revive(m.target)}))},g,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(m=>S.URI.revive(m.target))},g,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(m=>S.URI.revive(m.target))},g,c)}}async _fireWillEvent(I,l,g,c){const m=new Set,_=[];if(await I.fireAsync(l,c,async(E,u)=>{var d;const f=Date.now(),t=await Promise.resolve(E);t instanceof C.WorkspaceEdit&&(_.push(t),m.add((d=u.extension.displayName)!==null&&d!==void 0?d:u.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||_.length===0)return;const w={edits:[]};for(let E of _){let{edits:u}=A.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(u)}return{edit:w,extensionNames:Array.from(m)}}}e.ExtHostFileSystemEventService=P}),define(ge[205],pe([0,1,10,25,2,18,7,60]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(l,g,c,m){this.start=l,this.deletedCount=g,this.deletedItems=c,this.items=m}static asApiEvents(l){return l.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(c=>c.apiCell)}))}}class P{constructor(l,g,c){var m,_,w;this.notebook=l,this._extHostDocument=g,this._cellData=c,this.handle=c.handle,this.uri=k.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=(m=c.internalMetadata)!==null&&m!==void 0?m:{},this._metadata=(_=c.metadata)!==null&&_!==void 0?_:{},this._previousResult=S.NotebookCellExecutionSummary.to((w=c.internalMetadata)!==null&&w!==void 0?w:{})}static asModelAddData(l,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(S.NotebookCellOutput.to)}setOutputItems(l,g,c){const m=c.map(S.NotebookCellOutputItem.to),_=this._outputs.find(w=>w.id===l);_&&(g||(_.items.length=0),_.items.push(...m))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=S.NotebookCellExecutionSummary.to(l)}}e.ExtHostCell=P;class s{constructor(l,g,c,m,_,w,E){this._proxy=l,this._textDocumentsAndEditors=g,this._textDocuments=c,this._emitter=m,this._notebookType=_,this._metadata=w,this.uri=E,this.handle=s._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===v.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(g){return g=l._validateIndex(g),l._cells[g].apiCell},getCells(g){return(g?l._getCells(g):l._cells).map(m=>m.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptModelChanged(l,g){this._versionId=l.versionId,this._isDirty=g;for(const c of l.rawEvents)c.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(c.changes,!0),c.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===C.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let g=l.start|0,c=l.end|0;return g<0&&(g=0),c>this._cells.length&&(c=this._cells.length),l.with({start:g,end:c})}_getCells(l){l=this._validateRange(l);const g=[];for(let c=l.start;c<l.end;c++)g.push(this._cells[c]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,g){if(this._disposed)return;const c=[],m=[],_=[];l.reverse().forEach(w=>{const u=w[2].map(t=>{const r=new P(this,this._textDocumentsAndEditors,t);return g||m.push(P.asModelAddData(this.apiNotebook,t)),r}),d=new D(w[0],w[1],[],u),f=this._cells.splice(w[0],w[1],...u);for(const t of f)_.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:_}),g||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(c)}))}_moveCell(l,g){const c=this._cells.splice(l,1);this._cells.splice(g,0,...c);const m=[new D(l,1,c.map(_=>_.apiCell),[]),new D(g,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:D.asApiEvents(m)}))}_setCellOutputs(l,g){const c=this._cells[l];c.setOutputs(g),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,g,c,m){const _=this._cells[l];_.setOutputItems(g,c,m),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(l,g){const c=this._cells[l];c.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(c.uri,g)}_changeCellMetadata(l,g){const c=this._cells[l],m=c.apiCell.metadata;c.setMetadata(g);const _=c.apiCell.metadata;R.equals(m,_)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,g){var c;const m=this._cells[l],_=m.internalMetadata;if(m.setInternalMetadata(g),_.runState!==g.runState){const w=(c=g.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:m.apiCell,state:w}))}}getCellFromApiCell(l){return this._cells.find(g=>g.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(g=>g.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=s,s._handlePool=0}),define(ge[122],pe([0,1,7,18]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class k{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,P){this._throwIfFinalized(),!(C===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:P.map(R.NotebookCellData.from)})}}class S{constructor(C,D,P,s,I,l){this.id=C,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=s,this._viewColumn=l}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,P){C._proxy.$tryRevealRange(C.id,R.NotebookRange.from(D),P??v.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const P=new k(this.document.version);return D(P),C._applyEdit(P.finalize())},setDecorations(D,P){return C.setDecorations(D,P)}},S.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let s=0;s<C.cellEdits.length;s++){if(P<0){D.push(C.cellEdits[s]),P++;continue}const l=D[P],g=C.cellEdits[s];if(l.editType===1&&g.editType===1&&l.index===g.index){l.cells.push(...C.cellEdits[s].cells),l.count+=C.cellEdits[s].count;continue}D.push(C.cellEdits[s]),P++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=S,S.apiEditorsToExtHost=new WeakMap}),define(ge[206],pe([0,1,18,113,160,21,50]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,l,g){const c=this._handles++,{title:m,location:_,cancellable:w}=l,E={label:k.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:v.ProgressLocation.from(_),title:m,source:E,cancellable:w},I),this._withProgress(c,g,!!w)}_withProgress(I,l,g){let c;g&&(c=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const m=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let _;try{_=l(new P(this._proxy,I),g&&c?c.token:S.CancellationToken.None)}catch(w){throw m(I),w}return _.then(w=>m(I),w=>m(I)),_}$acceptProgressCanceled(I){const l=this._mapHandleToCancellationSource.get(I);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function D(s,I){return s.message=I.message,typeof I.increment=="number"&&(typeof s.increment=="number"?s.increment+=I.increment:s.increment=I.increment),s}class P extends R.Progress{constructor(I,l){super(g=>this.throttledReport(g));this._proxy=I,this._handle=l}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([A.throttle(100,(s,I)=>D(s,I),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(ge[123],pe([0,1,49,16,70,18,7]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(l,g,c){const m=C._Keys.nextId();l.$registerTextEditorDecorationType(g.identifier,m,S.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:m,dispose(){l.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=C,C._Keys=new k.IdGenerator("TextEditorDecorationType");class D{constructor(l,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,g){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,g,!1)}insert(l,g){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),g,!0)}delete(l){this._throwIfFinalized();let g=null;if(l instanceof A.Range)g=l;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(l,g,c){const m=this._document.validateRange(l);this._collectedEdits.push({range:m,text:g,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=D;class P{constructor(l,g,c,m){this._proxy=l,this._id=g,this._accept(c),this._logService=m;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(w){_._setTabSize(w)},get insertSpaces(){return _._insertSpaces},set insertSpaces(w){_._setInsertSpaces(w)},get cursorStyle(){return _._cursorStyle},set cursorStyle(w){_._setCursorStyle(w)},get lineNumbers(){return _._lineNumbers},set lineNumbers(w){_._setLineNumbers(w)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const g=Math.floor(l);return g>0?g:null}if(typeof l=="string"){const g=parseInt(l,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(l){const g=this._validateTabSize(l);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const g=this._validateInsertSpaces(l);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(l)})))}assign(l){const g={};let c=!1;if(typeof l.tabSize!="undefined"){const m=this._validateTabSize(l.tabSize);m==="auto"?(c=!0,g.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,c=!0,g.tabSize=m)}if(typeof l.insertSpaces!="undefined"){const m=this._validateInsertSpaces(l.insertSpaces);m==="auto"?(c=!0,g.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,c=!0,g.insertSpaces=m)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,g.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,g.lineNumbers=S.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(l){l.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=P;class s{constructor(l,g,c,m,_,w,E,u){this.id=l,this._proxy=g,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new P(this._proxy,this.id,w,c),this._visibleRanges=E,this._viewColumn=u;const d=this;this.value=Object.freeze({get document(){return m.getValue()},set document(f){throw R.readonly("document")},get selection(){return d._selections&&d._selections[0]},set selection(f){if(!(f instanceof A.Selection))throw R.illegalArgument("selection");d._selections=[f],d._trySetSelection()},get selections(){return d._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");d._selections=f,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(f){throw R.readonly("visibleRanges")},get options(){return d._options.value},set options(f){d._disposed||d._options.assign(f)},get viewColumn(){return d._viewColumn},set viewColumn(f){throw R.readonly("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new D(m.getValue(),t);return f(r),d._applyEdit(r)},insertSnippet(f,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=d._selections.map(i=>S.Range.from(i));else if(t instanceof A.Position){const{lineNumber:i,column:a}=S.Position.from(t);n=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof A.Range)n=[S.Range.from(t)];else{n=[];for(const i of t)if(i instanceof A.Range)n.push(S.Range.from(i));else{const{lineNumber:a,column:p}=S.Position.from(i);n.push({startLineNumber:a,startColumn:p,endLineNumber:a,endColumn:p})}}return g.$tryInsertSnippet(l,f.value,n,r)},setDecorations(f,t){const r=t.length===0;r&&!d._hasDecorationsForKey.has(f.key)||(r?d._hasDecorationsForKey.delete(f.key):d._hasDecorationsForKey.add(f.key),d._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return g.$trySetDecorations(l,f.key,S.fromRangeOrRangeWithMessage(t));{const n=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const p=t[i];n[4*i]=p.start.line+1,n[4*i+1]=p.start.character+1,n[4*i+2]=p.end.line+1,n[4*i+3]=p.end.character+1}return g.$trySetDecorationsFast(l,f.key,n)}}))},revealRange(f,t){d._runOnProxy(()=>g.$tryRevealRange(l,S.Range.from(f),t||A.TextEditorRevealType.Default))},show(f){g.$tryShowEditor(l,S.ViewColumn.from(f))},hide(){g.$tryHideEditor(l)}})}dispose(){v.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){v.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){v.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){v.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){v.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const g=l.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const c=g.edits.map(_=>_.range);c.sort((_,w)=>_.end.line===w.end.line?_.end.character===w.end.character?_.start.line===w.start.line?_.start.character-w.start.character:_.start.line-w.start.line:_.end.character-w.end.character:_.end.line-w.end.line);for(let _=0,w=c.length-1;_<w;_++){const E=c[_].end;if(c[_+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=g.edits.map(_=>({range:S.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,m,{setEndOfLine:typeof g.setEndOfLine=="number"?S.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=s}),define(ge[207],pe([0,1,163,24,2,3,6,14,7,13,17,18,21]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(_,w){if(P.isString(_))return{label:_};if(_&&typeof _=="object"&&typeof _.label=="string"){let E;return Array.isArray(_.highlights)&&(E=_.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),E=E.length?E:void 0),{label:_.label,highlights:E}}}class c{constructor(w,E,u){this._proxy=w,this.commands=E,this.logService=u,this.treeViews=new Map;function d(f){return f&&f.$treeViewId&&f.$treeItemHandle}E.registerArgumentProcessor({processArgument:f=>d(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>d(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(w,E,u){const d=this.createTreeView(w,{treeDataProvider:E},u);return{dispose:()=>d.dispose()}}createTreeView(w,E,u){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=E.dragAndDropController!==void 0,f=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(w,E,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(r){t.message=r},get title(){return t.title},set title(r){t.title=r},get description(){return t.description},set description(r){t.description=r},reveal:(r,n)=>t.reveal(r,n),dispose:async()=>{await f,this.treeViews.delete(w),t.dispose()}}}$getChildren(w,E){const u=this.treeViews.get(w);return u?u.getChildren(E):Promise.reject(new Error(v.localize(0,null,w)))}$onDrop(w,E,u){const d=this.treeViews.get(w);return d?d.onDrop(E,u):Promise.reject(new Error(v.localize(1,null,w)))}async $hasResolve(w){const E=this.treeViews.get(w);if(!E)throw new Error(v.localize(2,null,w));return E.hasResolve}$resolve(w,E,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(3,null,w));return d.resolveTreeItem(E,u)}$setExpanded(w,E,u){const d=this.treeViews.get(w);if(!d)throw new Error(v.localize(4,null,w));d.setExpanded(E,u)}$setSelection(w,E){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(5,null,w));u.setSelection(E)}$setVisible(w,E){const u=this.treeViews.get(w);if(!u)throw new Error(v.localize(6,null,w));u.setVisible(E)}createExtHostTreeView(w,E,u){const d=new m(w,E,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(w,d),d}convertArgument(w){const E=this.treeViews.get(w.$treeViewId);return E?E.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=c;class m extends A.Disposable{constructor(w,E,u,d,f,t){super();if(this.viewId=w,this.proxy=u,this.commands=d,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const a of t.contributes.views[i])a.id===w&&(this._title=a.name);this.dataProvider=E.treeDataProvider,this.dndController=E.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let r,n;this._register(S.Event.debounce(this._onDidChangeData.event,(i,a)=>(i||(i={message:!1,elements:[]}),a.element!==!1&&(r||(r=new Promise(p=>n=p),this.refreshPromise=this.refreshPromise.then(()=>r)),i.elements.push(a.element)),a.message&&(i.message=!0),i),200,!0)(({message:i,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=n;return r=null,this.refresh(a).then(()=>p())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!P.isUndefinedOrNull(w))}getChildren(w){const E=w?this.getExtensionElement(w):void 0;if(w&&!E)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(w);return(u?Promise.resolve(u):this.fetchChildrenNodes(E)).then(d=>d.map(f=>f.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,E){E=E||{select:!0,focus:!1};const u=P.isUndefinedOrNull(E.select)?!0:E.select,d=P.isUndefinedOrNull(E.focus)?!1:E.focus,f=P.isUndefinedOrNull(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(n=>n.item)},{select:u,focus:d,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:d,expand:f})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,E){const u=this.getExtensionElement(w);u&&(E?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(w){s.equals(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(w,E){const u=w.map(f=>this.getExtensionElement(f)).filter(f=>!P.isUndefinedOrNull(f)),d=this.getExtensionElement(E);return u&&d?C.asPromise(()=>{var f;return(f=this.dndController)===null||f===void 0?void 0:f.onDrop(u,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,E){var u;if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(w);if(d){const f=this.nodes.get(d);if(f){const t=(u=await this.dataProvider.resolveTreeItem(f.extensionItem,d,E))!==null&&u!==void 0?u:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(E=>E?this.resolveUnknownParentChain(E).then(u=>this.resolveTreeNode(E,u[u.length-1]).then(d=>(u.push(d),u))):Promise.resolve([]))}resolveParent(w){const E=this.nodes.get(w);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):C.asPromise(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,E){const u=this.nodes.get(w);return u?Promise.resolve(u):C.asPromise(()=>this.dataProvider.getTreeItem(w)).then(d=>this.createHandle(w,d,E,!0)).then(d=>this.getChildren(E?E.item.handle:void 0).then(()=>{const f=this.getExtensionElement(d);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(w){if(w){let E;if(typeof w=="string"){const u=this.getExtensionElement(w);E=u?this.nodes.get(u):void 0}else E=w;return E&&E.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const E=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=w?this.nodes.get(w):void 0,d=await this.dataProvider.getChildren(w);if(E.token.isCancellationRequested)return[];const f=await Promise.all(s.coalesce(d||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,u):null}));return E.token.isCancellationRequested?[]:s.coalesce(f)}finally{E.dispose()}}refresh(w){if(w.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(w);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const E=new Set,u=w.map(f=>this.nodes.get(f));for(const f of u)if(f&&!E.has(f.item.handle)){let t=f;for(;t&&t.parent&&u.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&E.add(f.item.handle)}const d=[];return E.forEach(f=>{const t=this.elements.get(f);if(t){const r=this.nodes.get(t);r&&(!r.parent||!E.has(r.parent.item.handle))&&d.push(f)}}),d}refreshHandles(w){const E={};return Promise.all(w.map(u=>this.refreshNode(u).then(d=>{d&&(E[u]=d.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(w){const E=this.getExtensionElement(w);if(E){const u=this.nodes.get(E);if(u)return this.clearChildren(E),C.asPromise(()=>this.dataProvider.getTreeItem(E)).then(d=>{if(d){const f=this.createTreeNode(E,d,u.parent);return this.updateNodeCache(E,f,u,u.parent),u.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,E,u){const d=this.createTreeNode(w,E,u);if(E.id&&this.elements.has(d.item.handle))throw new Error(v.localize(7,null,E.id));return this.addNodeToCache(w,d),this.addNodeToParentCache(d,u),d}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?I.MarkdownString.from(w):w}getCommand(w,E){return E?this.commands.toInternal(E,w):void 0}createTreeNode(w,E,u){const d=new A.DisposableStore,f=this.createHandle(w,E,u),t=this.getLightIconPath(E);return{item:{handle:f,parentHandle:u?u.item.handle:void 0,label:g(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(d,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:P.isUndefinedOrNull(E.collapsibleState)?D.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:u,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:E,label:u,resourceUri:d},f,t){if(E)return`${m.ID_HANDLE_PREFIX}/${E}`;const r=g(u,this.extension),n=f?f.item.handle:m.LABEL_HANDLE_PREFIX;let i=r?r.label:d?R.basename(d):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,p=this.getChildrenNodes(f)||[];let h,b=0;do{if(h=`${n}/${b}:${i}`,t||!this.elements.has(h)||a===h)break;b++}while(b<=p.length);return h}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||k.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return k.URI.isUri(w)?w:k.URI.file(w)}addNodeToCache(w,E){this.elements.set(E.item.handle,w),this.nodes.set(w,E)}updateNodeCache(w,E,u,d){this.elements.delete(E.item.handle),this.nodes.delete(w),E.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(w,E);const f=this.getChildrenNodes(d)||[],t=f.filter(r=>r.item.handle===u.item.handle)[0];t&&f.splice(f.indexOf(t),1,E)}addNodeToParentCache(w,E){E?(E.children||(E.children=[]),E.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const E=this.nodes.get(w);if(E){if(E.children)for(const u of E.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}E.children=void 0}}else this.clearAll()}clear(w){const E=this.nodes.get(w);if(E){if(E.children)for(const u of E.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}this.nodes.delete(w),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}m.LABEL_HANDLE_PREFIX="0",m.ID_HANDLE_PREFIX="1"}),define(ge[208],pe([0,1,17,14,21,13,83,18,7,121]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class s{constructor(){this.testIdsToInternal=new Map}getTestById(_,w){if(w!==void 0){const E=this.testIdsToInternal.get(w),u=E==null?void 0:E.get(_);if(u)return[E,u]}return v.mapFind(this.testIdsToInternal.values(),E=>{const u=E.get(_);return u&&[E,u]})}createForHierarchy(_=()=>{}){return new c(this.createIdMap(l++),_)}createIdMap(_){const w=new g(_);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=s;var I;(function(m){m[m.Disconnected=0]="Disconnected",m[m.IsChild=1]="IsChild",m[m.IsParent=2]="IsParent",m[m.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let l=0;class g{constructor(_){this.id=_,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(_){if(this.map.has(_.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${_.item.extId}`);this.map.set(_.item.extId,_),_.parent||this._roots.add(_)}has(_){return this.map.has(_)}delete(_){const w=this.map.get(_);return w?(this.map.delete(_),this._roots.delete(w),!0):!1}get(_){return this.map.get(_)}comparePositions(_,w){const E=typeof _=="string"?this.map.get(_):_,u=typeof w=="string"?this.map.get(w):w;if(!E||!u)return 0;if(E===u)return 3;for(let d=this.map.get(u.parent);d;d=this.map.get(d.parent))if(d===E)return 1;for(let d=this.map.get(E.parent);d;d=this.map.get(d.parent))if(d===u)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class c{constructor(_,w){this.testIdToInternal=_,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(_,w){this.addItem(_,w,null)}getTestByReference(_){return this.testItemToInternal.get(_)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const w=this.diff[this.diff.length-1];if(w&&_[0]===1){if(w[0]===1&&w[1].extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}if(w[0]===0&&w[1].item.extId===_[1].extId){P.applyTestItemUpdate(w[1],_[1]);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,w){var E;const u=this.testIdToInternal.object.get(_);if(!!u){if((u.expandLevels===void 0||w>u.expandLevels)&&(u.expandLevels=w),u.expand===1){const d=this.refreshChildren(u);return d.isSettled?this.expandChildren(u,w-1):d.p.then(()=>this.expandChildren(u,w-1))}else if(u.expand===3)return((E=u.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?u.initialExpand.p.then(()=>this.expandChildren(u,w-1)):this.expandChildren(u,w-1)}}dispose(){var _;for(const w of this.testItemToInternal.values())(_=w.discoverCts)===null||_===void 0||_.dispose(!0),A.getPrivateApiFor(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(_,w){const E=_==null?void 0:_.actual.id;switch(w[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(_);break;case 0:this.addItem(w[1],_.src.controller,_);break;case 3:const[u,d,f]=w;switch(d){case"status":this.updateExpandability(_);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[d]:f??null}}]);break}break;default:S.assertNever(w[0])}}addItem(_,w,E){if(!(_ instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${_.id} did not`);if(this.testItemToInternal.has(_))throw new Error(`Attempted to add a single TestItem ${_.id} multiple times to the tree`);if(this.testIdToInternal.object.has(_.id))throw new Error(`Attempted to insert a duplicate test item ID ${_.id}`);const u=E?E.item.extId:null,d=_.resolveHandler?1:0,f=E?E.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},r={actual:_,parent:u,item:C.TestItem.from(_),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(r),this.testItemToInternal.set(_,r),this.pushDiff([0,{parent:u,src:t,expand:d,item:r.item}]);const n=A.getPrivateApiFor(_);n.parent=E==null?void 0:E.actual,n.bus.event(this.onTestItemEvent.bind(this,r)),this.updateExpandability(r);for(const i of n.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,r)}updateExpandability(_){var w;let E;_.actual.resolveHandler?_.actual.status===D.TestItemStatus.Pending?E=_.discoverCts?2:1:((w=_.initialExpand)===null||w===void 0||w.complete(),E=3):E=0,E!==_.expand&&(_.expand=E,this.pushDiff([1,{extId:_.actual.id,expand:E}]),E===1&&_.expandLevels!==void 0&&this.refreshChildren(_))}expandChildren(_,w){if(w<0)return;const E=[..._.actual.children.values()].map(u=>this.expand(u.id,w)).filter(R.isThenable);if(E.length)return Promise.all(E).then(()=>{})}refreshChildren(_){if(_.discoverCts&&_.discoverCts.dispose(!0),!_.actual.resolveHandler){const w=new R.DeferredPromise;return w.complete(),w}return _.expand=2,_.discoverCts=new k.CancellationTokenSource,this.pushExpandStateUpdate(_),_.initialExpand=new R.DeferredPromise,_.actual.resolveHandler(_.discoverCts.token),_.initialExpand}pushExpandStateUpdate(_){this.pushDiff([1,{extId:_.actual.id,expand:_.expand}])}removeItem(_){var w;this.pushDiff([2,_.actual.id]);const E=[_];for(;E.length;){const u=E.pop();if(!!u){(w=u.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(u.item.extId),this.testItemToInternal.delete(u.actual);for(const d of u.actual.children.values())E.push(this.testIdToInternal.object.get(d.id))}}}flushDiff(){const _=this.collectDiff();_.length&&this.publishDiff(_)}}e.SingleUseTestCollection=c}),define(ge[209],pe([0,1,26,3,9]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(s){this.removedDueToLooping=s}}e.DeltaExtensionsResult=S;class A{constructor(s){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=s,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const s of this._extensionDescriptions){if(this._extensionsMap.has(v.ExtensionIdentifier.toKey(s.identifier))){console.error("Extension `"+s.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(v.ExtensionIdentifier.toKey(s.identifier),s),this._extensionsArr.push(s),Array.isArray(s.activationEvents))for(let I of s.activationEvents)I==="onUri"&&(I=`onUri:${v.ExtensionIdentifier.toKey(s.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(s)}}keepOnly(s){const I=new Set;s.forEach(l=>I.add(v.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>I.has(v.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(s,I){s.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(s));const l=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(l.map(g=>g.identifier)),I.length>0){const g=new Set;I.forEach(c=>g.add(v.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!g.has(v.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(l)}static _findLoopingExtensions(s){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,w){this.addNode(_),this.addNode(w),this._arcs.has(_)?this._arcs.get(_).push(w):this._arcs.set(_,[w])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,w){const E=I.getArcs(_);for(let u=0;u<E.length;u++)if(!w.has(E[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let _ of s){const w=v.ExtensionIdentifier.toKey(_.identifier);if(l.set(w,_),_.extensionDependencies)for(let E of _.extensionDependencies){const u=v.ExtensionIdentifier.toKey(E);I.addArc(w,u)}}let g=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>g.add(_));let c=I.getNodes().filter(_=>!g.has(_)),m;do{m=!1;for(let _=0;_<c.length;_++){const w=c[_];I.hasOnlyGoodArcs(w,g)&&(c.splice(_,1),_--,g.add(w),m=!0)}}while(m);return c.map(_=>l.get(_))}containsActivationEvent(s){return this._activationMap.has(s)}containsExtension(s){return this._extensionsMap.has(v.ExtensionIdentifier.toKey(s))}getExtensionDescriptionsForActivationEvent(s){const I=this._activationMap.get(s);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(s){const I=this._extensionsMap.get(v.ExtensionIdentifier.toKey(s));return I||void 0}}e.ExtensionDescriptionRegistry=A;var C;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(C||(C={}));function D(P,s){const I=P.isBuiltin?0:P.isUnderDevelopment?2:1,l=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(I!==l)return I-l;const g=k.posix.basename(P.extensionLocation.path),c=k.posix.basename(s.extensionLocation.path);return g<c?-1:g>c?1:0}}),define(ge[210],pe([0,1,22]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var k;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(k=e.MessageType||(e.MessageType={}));function S(C){const D=v.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=S;function A(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=A}),define(ge[35],pe([0,1,3,2,4,26,177]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=k.createDecorator("extensionService");class C{constructor(E){this.dependency=E}}e.MissingExtensionDependency=C;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(E,u,d,f){this.codeLoadingTime=E,this.activateCallTime=u,this.activateResolvedTime=d,this.activationReason=f}}e.ActivationTimes=P;class s{constructor(E,u){this.description=E,this.value=u}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var I;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function l(w){w.enableProposedApi||g(w)}e.checkProposedApiEnabled=l;function g(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=g;function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function m(w){return Object.assign(Object.assign({identifier:new S.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=m;class _{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,u){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,u,d,f,t){}_onDidActivateExtensionError(E,u){}_onExtensionRuntimeError(E,u){}_onExtensionHostExit(E){}}e.NullExtensionService=_}),define(ge[211],pe([0,1,26,35,15]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class A{constructor(c,m,_,w){this.startup=c,this.codeLoadingTime=m,this.activateCallTime=_,this.activateResolvedTime=w}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,m){return c===-1||m===-1?-1:m-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(c,m,_,w,E,u){this.activationFailed=c,this.activationFailedError=m,this.activationTimes=_,this.module=w,this.exports=E,this.subscriptions=u}}e.ActivatedExtension=D;class P extends D{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class s extends D{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=s;class I extends D{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let l=class{constructor(c,m,_,w,E){this._logService=E,this._registry=c,this._resolvedExtensionsSet=new Set,m.forEach(u=>this._resolvedExtensionsSet.add(v.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,_.forEach(u=>this._hostExtensionsMap.set(v.ExtensionIdentifier.toKey(u),u)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const m=v.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(m)}getActivatedExtension(c){const m=v.ExtensionIdentifier.toKey(c),_=this._activatedExtensions.get(m);if(!_)throw new Error("Extension `"+c.value+"` is not known or not activated");return _}activateByEvent(c,m){if(this._alreadyActivatedEvents[c])return S;const _=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(_.map(w=>({id:w.identifier,reason:{startup:m,extensionId:w.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,m){const _=this._registry.getExtensionDescription(c);if(!_)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:_.identifier,reason:m}])}_handleActivateRequest(c,m,_){if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(c.id))){m[v.ExtensionIdentifier.toKey(c.id)]=c;return}const w=this._registry.getExtensionDescription(c.id);if(!w){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(c.id),new I(d));return}const E=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let u=!0;for(let d=0,f=E.length;d<f;d++){const t=E[d];if(this._resolvedExtensionsSet.has(v.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(v.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const p=w.displayName||w.identifier.value,h=this._registry.getExtensionDescription(t),b=h&&h.displayName||t,y=new Error(`Cannot activate the '${p}' extension because its dependency '${b}' failed to activate`);y.detail=r.activationFailedError,this._host.onExtensionActivationError(w.identifier,y,null),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(y));return}if(this._hostExtensionsMap.has(v.ExtensionIdentifier.toKey(t))){u=!1,m[v.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(v.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const n=this._registry.getExtensionDescription(t);if(n){u=!1,m[v.ExtensionIdentifier.toKey(t)]={id:n.identifier,reason:c.reason};continue}const i=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(v.ExtensionIdentifier.toKey(w.identifier),new I(a));return}u?m[v.ExtensionIdentifier.toKey(w.identifier)]=c:_.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(E=>!this._activatedExtensions.has(v.ExtensionIdentifier.toKey(E.id))),c.length===0))return Promise.resolve(void 0);const m=Object.create(null),_=[];for(let E=0,u=c.length;E<u;E++)this._handleActivateRequest(c[E],m,_);for(let E=0,u=_.length;E<u;E++){const d=v.ExtensionIdentifier.toKey(_[E].id);m[d]&&delete m[d]}const w=Object.keys(m).map(E=>m[E]);return _.length===0?Promise.all(w.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(w).then(E=>this._activateExtensions(_))}_activateExtension(c,m){const _=v.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const w=this._activatingExtensions.get(_);if(w)return w;const E=this._host.actualActivateExtension(c,m).then(void 0,u=>{const d=new Error;return u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${c.value}' failed: ${u.message}.`:d.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new I(u)}).then(u=>{this._activatedExtensions.set(_,u),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,E),E}};l=Ve([He(4,k.ILogService)],l),e.ExtensionsActivator=l}),define(ge[212],pe([0,1,15,35,27,10,111]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends v.LogService{constructor(P){if(P.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};C=Ve([He(0,k.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ge[213],pe([0,1,16]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,A)=>{this._actualOk=S,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):v.onUnexpectedError(S))}then(S,A){return this._ensureActual().then(S,A)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=R}),define(ge[124],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class v{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++v.count}}e.ProxyIdentifier=v,v.count=0;const R=[];function k(C){const D=new v(!0,C);return R[D.nid]=D,D}e.createMainContextProxyIdentifier=k;function S(C){const D=new v(!1,C);return R[D.nid]=D,D}e.createExtHostContextProxyIdentifier=S;function A(C){return R[C].sid}e.getStringIdentifierForProxy=A}),define(ge[5],pe([0,1,53,2,124]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var s;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(s=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function d(t,r){return Object.defineProperty(t,u.name,{value:r,enumerable:!0}),t}u.mixin=d;function f(t){return t[u.name]}u.of=f})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(d){return d._id=g._n++,d}}e.IdObject=g,g._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(u){if(u&&u.edits)for(const d of u.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=v.revive(d.metadata));return u}e.reviveWorkspaceEditDto=w;var E;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:k.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:k.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:k.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:k.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:k.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:k.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:k.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:k.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:k.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:k.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:k.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:k.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:k.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:k.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:k.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:k.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:k.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:k.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:k.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:k.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:k.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:k.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:k.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:k.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:k.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:k.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:k.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:k.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:k.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:k.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:k.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:k.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:k.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:k.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:k.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:k.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:k.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:k.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:k.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:k.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:k.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:k.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:k.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:k.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:k.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:k.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:k.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:k.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:k.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:k.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:k.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:k.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:k.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:k.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:k.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:k.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:k.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:k.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:k.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:k.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:k.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:k.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:k.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:k.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:k.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:k.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:k.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:k.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:k.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:k.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:k.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:k.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:k.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:k.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:k.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:k.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:k.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:k.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:k.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:k.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:k.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:k.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:k.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:k.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:k.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:k.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:k.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:k.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:k.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:k.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:k.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:k.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:k.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:k.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:k.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:k.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:k.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:k.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:k.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:k.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:k.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:k.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(ge[85],pe([0,1,5,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(C){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(v.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,P){return this._proxy.$setPassword(C,D,P)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=S,e.IExtHostSecretState=k.createDecorator("IExtHostSecretState")}),define(ge[61],pe([0,1,4,15,5,12]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=v.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(k.MainContext.MainThreadTelemetry)}report(D,P,s){const I=this.getUsageKey(D,P);this._reportedUsages.has(I)||(this._reportedUsages.add(I),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${s}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};A=Ve([He(0,S.IExtHostRpcService),He(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,P){}})}),define(ge[214],pe([0,1,3,5,7,26]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new v.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new v.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,s,I={}){const l=S.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(l)||[],c=[...s].sort().join(" ");let m=g.find(_=>_.scopes===c);if(m)return m.result;{const _=this._getSession(D,l,P,s,I);m={scopes:c,result:_},g.push(m),this._inFlightRequests.set(l,g);try{await _}finally{const w=g.findIndex(E=>E.scopes===c);w>-1&&(g.splice(w),this._inFlightRequests.set(l,g))}return _}}async _getSession(D,P,s,I,l={}){await this._proxy.$ensureProvider(s);const g=D.displayName||D.name;return this._proxy.$getSession(s,I,P,g,l)}async removeSession(D,P){const s=this._authenticationProviders.get(D);return s?s.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,s,I){var l;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:s,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===D)||this._providers.push({id:D,label:P});const g=s.onDidChangeSessions(c=>{var m,_,w;this._proxy.$sendDidChangeSessions(D,{added:(m=c.added)!==null&&m!==void 0?m:[],changed:(_=c.changed)!==null&&_!==void 0?_:[],removed:(w=c.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(l=I==null?void 0:I.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new k.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(D);const c=this._providers.findIndex(m=>m.id===D);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const s=this._authenticationProviders.get(D);if(s)return Promise.resolve(s.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(s=>{this._providers.some(I=>I.id===s.id)||this._providers.push(s)}),P.forEach(s=>{const I=this._providers.findIndex(l=>l.id===s.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(ge[215],pe([0,1,5,12,18]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(v.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=k.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};S=Ve([He(0,R.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(ge[216],pe([0,1,5]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(S){const A=S.getProxy(v.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(C){return A.$writeText(C)}})}}e.ExtHostClipboard=R}),define(ge[47],pe([0,1,13,7,18,25,5,17,15,53,41,44,2,6,4,12]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let _=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=r,this.converter=new w(this,n=>{const i=this._apiCommands.get(n);return(i==null?void 0:i.result)===u.Void?i:void 0},r),this._argumentProcessors=[{processArgument(n){return P.revive(n)}},{processArgument(n){return S.cloneAndChange(n,function(i){if(s.Range.isIRange(i))return k.Range.to(i);if(I.Position.isIPosition(i))return k.Position.to(i);if(s.Range.isIRange(i.range)&&l.URI.isUri(i.uri))return k.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...n)=>{const i=t.args.map((p,h)=>{if(!p.validate(n[h]))throw new Error(`Invalid argument '${p.name}' when running '${t.id}', received: ${n[h]}`);return p.convert(n[h])}),a=await this.executeCommand(t.internalId,...i);return t.result.convert(a,n,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,n,i,a){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:n,thisArg:i,description:a}),t&&this._proxy.$registerCommand(r),new R.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,n){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=S.cloneAndChange(r,function(a){if(a instanceof R.Position)return k.Position.from(a);if(a instanceof R.Range)return k.Range.from(a);if(a instanceof R.Location)return k.location.from(a);if(R.NotebookRange.isNotebookRange(a))return k.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,i,n);return P.revive(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw a}}}async _executeContributedCommand(t,r){const n=this._commands.get(t);if(!n)throw new Error("Unknown command");let{callback:i,thisArg:a,description:p}=n;if(p)for(let h=0;h<p.args.length;h++)try{v.validateConstraint(r[h],p.args[h].constraint)}catch(b){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${p.args[h].name}' - ${p.args[h].description}`)}try{return await i.apply(a,r)}catch(h){if(t===this.converter.delegatingCommandId){const b=this.converter.getActualCommand(...r);b&&(t=b.command)}throw this._logService.error(h,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(n=>this._argumentProcessors.reduce((i,a)=>a.processArgument(i),n)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(n=>n[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,n]of this._commands){let{description:i}=n;i&&(t[r]=i)}return Promise.resolve(t)}};_=Ve([He(0,m.IExtHostRpcService),He(1,D.ILogService)],_),e.ExtHostCommands=_,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class w{constructor(t,r,n){this._commands=t,this._lookupApiCommand=r,this._logService=n,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const n={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return n;const i=this._lookupApiCommand(t.command);if(i)n.id=i.internalId,n.arguments=i.args.map((a,p)=>a.convert(t.arguments&&t.arguments[p]));else if(C.isNonEmptyArray(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),r.add(g.toDisposable(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),n.$ident=a,n.id=this.delegatingCommandId,n.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return n}fromInternal(t){const r=A.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class E{constructor(t,r,n,i){this.name=t,this.description=r,this.validate=n,this.convert=i}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new E(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",f=>l.URI.isUri(f),f=>f),E.Position=new E("position","A position in a text document",f=>R.Position.isPosition(f),k.Position.from),E.Range=new E("range","A range in a text document",f=>R.Range.isRange(f),k.Range.from),E.Selection=new E("selection","A selection in a text document",f=>R.Selection.isSelection(f),k.Selection.from),E.Number=new E("number","",f=>typeof f=="number",f=>f),E.String=new E("string","",f=>typeof f=="string",f=>f),E.CallHierarchyItem=new E("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,k.CallHierarchyItem.to);class u{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class d{constructor(t,r,n,i,a){this.id=t,this.internalId=r,this.description=n,this.args=i,this.result=a}}e.ApiCommand=d}),define(ge[217],pe([0,1,18,7,79,47,17,106]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",s(v.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,g)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(_){const w=new c(_.name,v.SymbolKind.to(_.kind),_.containerName||"",new R.Location(g[0],v.Range.to(_.range)));return w.detail=_.detail,w.range=w.location.range,w.selectionRange=v.Range.to(_.selectionRange),w.children=_.children?_.children.map(c.to):[],w}}return l.map(c.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",s(v.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",s(v.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",s(v.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(g=>R.Position.isPosition(g)),l=>l.map(v.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(g=>{let c;for(const m of g.reverse())c=new R.SelectionRange(v.Range.to(m),c);return c}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const g=[];if(Array.isArray(l))for(let c of l)g.push(...c[1].map(v.WorkspaceSymbol.to));return g})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(v.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return v.WorkspaceEdit.to(l)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(v.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=C.decodeSemanticTokensDto(l);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const g=C.decodeSemanticTokensDto(l);if(g.type==="full")return new R.SemanticTokens(g.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,g,c)=>{if(!l)return new R.CompletionList([]);const m=l.suggestions.map(_=>v.CompletionItem.to(_,c));return new R.CompletionList(m,l.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return v.SignatureHelp.to(l)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,g,c)=>s(m=>new R.CodeLens(v.Range.to(m.range),m.command&&c.fromInternal(m.command)))(l))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?v.Selection.from(l):v.Range.from(l)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,g,c)=>s(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(m.command)}else{const _=new R.CodeAction(m.title,m.kind?new R.CodeActionKind(m.kind):void 0);return m.edit&&(_.edit=v.WorkspaceEdit.to(m.edit)),m.command&&(_.command=c.fromInternal(m.command)),_.isPreferred=m.isPreferred,_}})(l))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(g=>new R.ColorInformation(v.Range.to(g.range),v.Color.to(g.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,v.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:v.Range.from(l.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(v.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(v.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",s(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(g=>v.NotebookExclusiveDocumentPattern.to(g))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(v.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[v.ViewColumn.from(l.viewColumn),v.TextEditorOpenOptions.from(l)]).optional()],S.ApiCommandResult.Void)];class P{static register(g){D.forEach(g.registerApiCommand,g)}}e.ExtHostApiCommands=P;function s(l){return g=>{if(Array.isArray(g))return g.map(l)}}function I(l){if(!Array.isArray(l))return;const g=[];for(const c of l)k.isLocationLink(c)?g.push(v.DefinitionLink.to(c)):g.push(v.location.to(c));return g}}),define(ge[218],pe([0,1,14,50,3,6,2,79,26,18,7,5]),function(X,e,v,R,k,S,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(d,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const n=this._commentControllers.get(r.handle);return n||r}else if(r&&r.$mid===7){const n=this._commentControllers.get(r.commentControlHandle);if(!n)return r;const i=n.getCommentThread(r.commentThreadHandle);return i||r}else if(r&&r.$mid===8){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const i=n.getCommentThread(r.thread.commentThreadHandle);return i?{thread:i,text:r.text}:r}else if(r&&r.$mid===9){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const i=n.getCommentThread(r.thread.commentThreadHandle);if(!i)return r;let a=r.commentUniqueId,p=i.getCommentByUniqueId(a);return p||r}else if(r&&r.$mid===10){const n=this._commentControllers.get(r.thread.commentControlHandle);if(!n)return r;const i=n.getCommentThread(r.thread.commentThreadHandle);if(!i)return r;let a=r.text,p=r.commentUniqueId,h=i.getCommentByUniqueId(p);return h?(h.body=a,h):r}return r}})}createCommentController(d,f,t){const r=l.handlePool++,n=new c(d,r,this._proxy,f,t);this._commentControllers.set(n.handle,n);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(d.identifier))||[];return i.push(n),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(d.identifier),i),n}$createCommentThreadTemplate(d,f,t){const r=this._commentControllers.get(d);!r||r.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(d,f,t){const r=this._commentControllers.get(d);!r||r.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(d,f){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(d,f,t){const r=this._commentControllers.get(d);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const n=this._documents.getDocument(A.URI.revive(f));return v.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(n,t)).then(i=>i?i.map(a=>P.Range.from(a)):void 0)}$toggleReaction(d,f,t,r,n){const i=this._commentControllers.get(d);return!i||!i.reactionHandler?Promise.resolve(void 0):v.asPromise(()=>{const a=i.getCommentThread(f);if(a){const p=a.getCommentByUniqueId(r.uniqueIdInThread);if(i!==void 0&&p&&i.reactionHandler)return i.reactionHandler(p,w(n))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class g{constructor(d,f,t,r,n,i,a){this._proxy=d,this._commentController=f,this._id=t,this._uri=r,this._range=n,this._comments=i,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new k.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};d("range")&&(f.range=P.Range.from(this._range)),d("label")&&(f.label=this.label),d("contextValue")&&(f.contextValue=this.contextValue),d("comments")&&(f.comments=this._comments.map(t=>m(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(f.collapseState=E(this._collapseState)),d("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(d){for(let f of this._commentsMap){let t=f[0],r=f[1];if(d===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,Ve([R.debounce(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class c{constructor(d,f,t,r,n){this._extension=d,this._handle=f,this._proxy=t,this._id=r,this._label=n,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,n)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,f,t,r){if(typeof d=="string"){const n=new g(this._proxy,this,d,f,t,r,this._extension.identifier);return this._threads.set(n.handle,n),n}else{const n=new g(this._proxy,this,void 0,d,f,t,this._extension.identifier);return this._threads.set(n.handle,n),n}}$createCommentThreadTemplate(d,f){const t=new g(this._proxy,this,void 0,A.URI.revive(d),P.Range.to(f),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,f){let t=this._threads.get(d);t&&(t.range=P.Range.to(f))}$deleteCommentThread(d){let f=this._threads.get(d);f&&f.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function m(u,d,f,t){let r=t.get(f);r||(r=++u.commentHandle,t.set(f,r));const n=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:r,body:P.MarkdownString.from(f.body),userName:f.author.name,userIconPath:n,label:f.label,commentReactions:f.reactions?f.reactions.map(i=>_(i)):void 0}}function _(u){return{label:u.label,iconPath:u.iconPath?P.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function w(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function E(u){if(u!==void 0)switch(u){case s.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case s.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(ge[125],pe([0,1,2,5,7,4,12,15,17,8,9]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class vn{constructor(g,c){this._logService=c,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,c){const m=vn._handlePool++;this._provider.set(m,{provider:g,extensionId:c}),this._proxy.$registerDecorationProvider(m,c.value);const _=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(m,null);return}let E=D.asArray(w);if(E.length<=vn._maxEventSize){this._proxy.$onDidChange(m,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,E.length);const u=E.map(t=>({uri:t,rank:P.count(t.path,"/")})),d=D.groupBy(u,(t,r)=>t.rank-r.rank||P.compare(t.uri.path,r.uri.path));let f=[];e:for(let t of d){let r;for(let n of t){let i=s.dirname(n.uri.path);if(r!==i&&(r=i,f.push(n.uri)>=vn._maxEventSize))break e}}this._proxy.$onDidChange(m,f)});return new k.Disposable(()=>{_==null||_.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(g,c,m){if(!this._provider.has(g))return Object.create(null);const _=Object.create(null),{provider:w,extensionId:E}=this._provider.get(g);return await Promise.all(c.map(async u=>{try{const{uri:d,id:f}=u,t=await Promise.resolve(w.provideFileDecoration(v.URI.revive(d),m));if(!t)return;try{k.FileDecoration.validate(t),_[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${E.value}': ${r}`)}}catch(d){this._logService.error(d)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([He(0,A.IExtHostRpcService),He(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=S.createDecorator("IExtHostDecorations")}),define(ge[219],pe([0,1,158,112,2,5,7,18,3,15,23]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,m,_,w,E){this._name=c,this._owner=m,this._maxDiagnosticsPerFile=_,this._proxy=w,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new s.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,m){if(!c){this.clear();return}this._checkDisposed();let _=[];if(k.URI.isUri(c)){if(!m){this.delete(c);return}this._data.set(c,m.slice()),_=[c]}else if(Array.isArray(c)){_=[];let E;c=[...c].sort(I._compareIndexedTuplesByUri);for(const u of c){const[d,f]=u;if((!E||d.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=d,_.push(d),this._data.set(d,[])),f){const t=this._data.get(d);t&&t.push(...f)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(_),!this._proxy)return;const w=[];for(let E of _){let u=[];const d=this._data.get(E);if(d)if(d.length>this._maxDiagnosticsPerFile){u=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of d)if(r.severity===f[t]&&u.push(C.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:v.localize(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=d.map(f=>C.Diagnostic.from(f));w.push([E,u])}this._proxy.$changeMany(this._owner,w)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,m){this._checkDisposed();for(let _ of this._data.keys())c.apply(m,[_,this.get(_),this])}get(c){this._checkDisposed();const m=this._data.get(c);return Array.isArray(m)?Object.freeze(m.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,m){return c[0].toString()<m[0].toString()?-1:c[0].toString()>m[0].toString()?1:0}}e.DiagnosticCollection=I;let l=class zt{constructor(c,m){this._logService=m,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=c.getProxy(S.MainContext.MainThreadDiagnostics)}static _debouncer(c,m){return c?c.concat(m):m}static _mapper(c){const m=new s.ResourceMap;for(const _ of c)m.set(_,_);return{uris:Object.freeze(Array.from(m.values()))}}createDiagnosticCollection(c,m){const{_collections:_,_proxy:w,_onDidChangeDiagnostics:E,_logService:u}=this,d=new class{$changeMany(r,n){w.$changeMany(r,n),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,n.length===0?"CLEARING":n)}$clear(r){w.$clear(r),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){w.dispose()}};let f;if(!m)m="_generated_diagnostic_collection_name_#"+zt._idPool++,f=m;else if(!_.has(m))f=m;else{this._logService.warn(`DiagnosticCollection with name '${m}' does already exist.`);do f=m+zt._idPool++;while(_.has(f))}return new class extends I{constructor(){super(m,f,zt._maxDiagnosticsPerFile,d,E);_.set(f,this)}dispose(){super.dispose(),_.delete(f)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const m=new Map,_=[];for(const w of this._collections.values())w.forEach((E,u)=>{let d=m.get(E.toString());typeof d=="undefined"&&(d=_.length,m.set(E.toString(),d),_.push([E,[]])),_[d][1]=_[d][1].concat(...u)});return _}}_getDiagnostics(c){let m=[];for(let _ of this._collections.values())_.has(c)&&(m=m.concat(_.get(c)));return m}$acceptMarkersChange(c){if(!this._mirrorCollection){const m="_generated_mirror",_=new I(m,m,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(m,_),this._mirrorCollection=_}for(const[m,_]of c)this._mirrorCollection.set(k.URI.revive(m),_.map(C.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=Ve([He(1,P.ILogService)],l),e.ExtHostDiagnostics=l}),define(ge[220],pe([0,1,2,5]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class k{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(C=>C?C.map(D=>v.URI.revive(D)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(C=>C?v.URI.revive(C):void 0)}}e.ExtHostDialogs=k}),define(ge[221],pe([0,1,16,2,7,5,10,21,8]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(I,l,g){this._documentsAndEditors=l,this._logService=g,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,l){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const g=P._handlePool++;this._documentContentProviders.set(g,l),this._proxy.$registerTextContentProvider(g,I);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(m=>{if(m.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(g,m).then(_=>{if(!_&&typeof _!="string")return;const w=this._documentsAndEditors.getDocument(m);if(!w)return;const E=D.splitLines(_);if(!w.equalLines(E))return this._proxy.$onVirtualDocumentChange(m,_)},v.onUnexpectedError)})),new k.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,l){const g=this._documentContentProviders.get(I);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(l),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(ge[222],pe([0,1,3,6,2,5,118,18,13,25]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class s{constructor(l,g){this._onDidAddDocument=new v.Emitter,this._onDidRemoveDocument=new v.Emitter,this._onDidChangeDocument=new v.Emitter,this._onDidSaveDocument=new v.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const m of c)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const m of c)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const g=this._documentsAndEditors.getDocument(l);if(g)return g}getDocument(l){const g=this.getDocumentData(l);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return g.document}ensureDocumentData(l){const g=this._documentsAndEditors.getDocument(l);if(g)return Promise.resolve(g);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(m=>{this._documentLoader.delete(l.toString());const _=k.URI.revive(m);return D.assertIsDefined(this._documentsAndEditors.getDocument(_))},m=>(this._documentLoader.delete(l.toString()),Promise.reject(m))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(g=>k.URI.revive(g))}$acceptModelModeChanged(l,g){const c=k.URI.revive(l),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(g),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(l){const g=k.URI.revive(l),c=this._documentsAndEditors.getDocument(g);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,g){const c=k.URI.revive(l),m=this._documentsAndEditors.getDocument(c);if(!m)throw new Error("unknown document");m._acceptIsDirty(g),this._onDidChangeDocument.fire({document:m.document,contentChanges:[]})}$acceptModelChanged(l,g,c){const m=k.URI.revive(l),_=this._documentsAndEditors.getDocument(m);if(!_)throw new Error("unknown document");_._acceptIsDirty(c),_.onEvents(g),this._onDidChangeDocument.fire(P.deepFreeze({document:_.document,contentChanges:g.changes.map(w=>({range:C.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(l,g){A.setWordDefinitionFor(l,g)}}e.ExtHostDocuments=s}),define(ge[39],pe([0,1,49,3,6,2,4,5,118,12,123,18,15,23,10,71,133]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(d,f){this._extHostRpc=d,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const f=[],t=[],r=[];if(d.removedDocuments)for(const n of d.removedDocuments){const i=S.URI.revive(n),a=this._documents.get(i);(a==null?void 0:a.unref())&&(this._documents.delete(i),f.push(a.value))}if(d.addedDocuments)for(const n of d.addedDocuments){const i=S.URI.revive(n.uri);let a=this._documents.get(i);if(a&&i.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);a||(a=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.modeId,n.isDirty,n.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(d.removedEditors)for(const n of d.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&r.push(i)}if(d.addedEditors)for(const n of d.addedEditors){const i=S.URI.revive(n.documentUri);v.ok(this._documents.has(i),`document '${i}' does not exist`),v.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const a=this._documents.get(i).value,p=new s.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>a.document),n.selections.map(I.Selection.to),n.options,n.visibleRanges.map(h=>I.Range.to(h)),typeof n.editorPosition=="number"?I.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,p)}d.newActiveEditor!==void 0&&(v.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),k.dispose(f),k.dispose(r),d.removedDocuments&&this._onDidRemoveDocuments.fire(f),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var f;return(f=this._documents.get(d))===null||f===void 0?void 0:f.value}allDocuments(){return m.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const f=this._editors.get(this._activeEditorId);return d?f:f==null?void 0:f.value}allEditors(){return[...this._editors.values()]}};E=Ve([He(0,P.IExtHostRpcService),He(1,l.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(ge[223],pe([0,1,2,5,6,7,18,142,8,22]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class s{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const c=this._schemes.indexOf(g);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),c=[];let m,_,w=14,E=14;for(const u of g){let d=m?D.commonPrefixLength(m,u):0;for(d===0?_=1:_=E;d<u.length;d++)d+1===u.length?(w=E,E=9):E+=1,c.push([_,u.toUpperCase().charCodeAt(d),E]),c.push([_,u.toLowerCase().charCodeAt(d),E]),_=E;m=u,E=w}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new C.StateMachine(c)}}provideDocumentLinks(g){this._initStateMachine();const c=[],m=C.LinkComputer.computeLinks({getLineContent(_){return g.lineAt(_-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const _ of m){const w=A.DocumentLink.to(_);w.target&&c.push(w)}return c}}class I{constructor(g,c){this._extHostLanguageFeatures=c,this._linkProvider=new s,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,c,m,_={},w){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const E=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(E,m),this._enableProposedApi.set(E,w??!1);let u=2;_.isCaseSensitive&&(u+=1024),_.isReadonly&&(u+=2048),typeof m.copy=="function"&&(u+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(E,c,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${c}`),console.error(f)});const d=m.onDidChangeFile(f=>{const t=[];for(const r of f){let{uri:n,type:i}=r;if(n.scheme!==c)continue;let a;switch(i){case S.FileChangeType.Changed:a=0;break;case S.FileChangeType.Created:a=1;break;case S.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:n,type:a})}this._proxy.$onFileSystemChange(E,t)});return k.toDisposable(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(E),this._enableProposedApi.delete(E),this._proxy.$unregisterProvider(E)})}static _asIStat(g,c){const{type:m,ctime:_,mtime:w,size:E,permissions:u}=g;return c?{type:m,ctime:_,mtime:w,size:E,permissions:u}:{type:m,ctime:_,mtime:w,size:E}}$stat(g,c){return Promise.resolve(this._getFsProvider(g).stat(v.URI.revive(c))).then(m=>{var _;return I._asIStat(m,(_=this._enableProposedApi.get(g))!==null&&_!==void 0?_:!1)})}$readdir(g,c){return Promise.resolve(this._getFsProvider(g).readDirectory(v.URI.revive(c)))}$readFile(g,c){return Promise.resolve(this._getFsProvider(g).readFile(v.URI.revive(c))).then(m=>P.VSBuffer.wrap(m))}$writeFile(g,c,m,_){return Promise.resolve(this._getFsProvider(g).writeFile(v.URI.revive(c),m.buffer,_))}$delete(g,c,m){return Promise.resolve(this._getFsProvider(g).delete(v.URI.revive(c),m))}$rename(g,c,m,_){return Promise.resolve(this._getFsProvider(g).rename(v.URI.revive(c),v.URI.revive(m),_))}$copy(g,c,m,_){const w=this._getFsProvider(g);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(v.URI.revive(c),v.URI.revive(m),_))}$mkdir(g,c){return Promise.resolve(this._getFsProvider(g).createDirectory(v.URI.revive(c)))}$watch(g,c,m,_){const w=this._getFsProvider(g).watch(v.URI.revive(m),_);this._watches.set(c,w)}$unwatch(g,c){const m=this._watches.get(c);m&&(m.dispose(),this._watches.delete(c))}$open(g,c,m){const _=this._getFsProvider(g);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(v.URI.revive(c),m))}$close(g,c){const m=this._getFsProvider(g);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(c))}$read(g,c,m,_){const w=this._getFsProvider(g);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(_);return Promise.resolve(w.read(c,m,E.buffer,0,_)).then(u=>E.slice(0,u))}$write(g,c,m,_){const w=this._getFsProvider(g);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(c,m,_.buffer,0,_.byteLength))}_getFsProvider(g){const c=this._fsProvider.get(g);if(!c){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return c}}e.ExtHostFileSystem=I}),define(ge[86],pe([0,1,5,42,7,22,4,12,58]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Ut{constructor(I,l){const g=I.getProxy(v.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return g.$stat(c).catch(Ut._handleError)},readDirectory(c){return g.$readdir(c).catch(Ut._handleError)},createDirectory(c){return g.$mkdir(c).catch(Ut._handleError)},async readFile(c){return g.$readFile(c).then(m=>m.buffer).catch(Ut._handleError)},writeFile(c,m){return g.$writeFile(c,S.VSBuffer.wrap(m)).catch(Ut._handleError)},delete(c,m){return g.$delete(c,Object.assign({recursive:!1,useTrash:!1},m)).catch(Ut._handleError)},rename(c,m,_){return g.$rename(c,m,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},copy(c,m,_){return g.$copy(c,m,Object.assign({overwrite:!1},_)).catch(Ut._handleError)},isWritableFileSystem(c){const m=l.getCapabilities(c);if(typeof m=="number")return!(m&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new k.FileSystemError(String(I));if(I.name==="ENOPRO")throw k.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw k.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw k.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw k.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw k.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw k.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw k.FileSystemError.Unavailable(I.message);default:throw new k.FileSystemError(I.message,I.name)}}};P=Ve([He(0,C.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(ge[224],pe([0,1,6,5]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class k{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,A),v.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=k}),define(ge[225],pe([0,1,2,25,18,7,14,5,8,41,17,13,139,6,106,70,82,43,16,3]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,J){this._documents=j,this._provider=J}provideDocumentSymbols(j,J){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ne,J)).then(oe=>{if(!s.isFalsyOrEmpty(oe))return oe[0]instanceof S.DocumentSymbol?oe.map(k.DocumentSymbol.from):d._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(j){var J;j=j.slice(0).sort((Y,le)=>{let me=Y.location.range.start.compareTo(le.location.range.start);return me===0&&(me=le.location.range.end.compareTo(Y.location.range.end)),me});const ne=[],oe=[];for(const Y of j){const le={name:Y.name||"!!MISSING: name!!",kind:k.SymbolKind.from(Y.kind),tags:((J=Y.tags)===null||J===void 0?void 0:J.map(k.SymbolTag.from))||[],detail:"",containerName:Y.containerName,range:k.Range.from(Y.location.range),selectionRange:k.Range.from(Y.location.range),children:[]};for(;;){if(oe.length===0){oe.push(le),ne.push(le);break}const me=oe[oe.length-1];if(P.Range.containsRange(me.range,le.range)&&!P.Range.equalsRange(me.range,le.range)){me.children&&me.children.push(le),oe.push(le);break}oe.pop()}}return ne}}class f{constructor(j,J,ne){this._documents=j,this._commands=J,this._provider=ne,this._cache=new _.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,J){const ne=this._documents.getDocument(j),oe=await this._provider.provideCodeLenses(ne,J);if(!oe||J.isCancellationRequested)return;const Y=this._cache.add(oe),le=new g.DisposableStore;this._disposables.set(Y,le);const me={cacheId:Y,lenses:[]};for(let Re=0;Re<oe.length;Re++)me.lenses.push({cacheId:[Y,Re],range:k.Range.from(oe[Re].range),command:this._commands.toInternal(oe[Re].command,le)});return me}async resolveCodeLens(j,J){var ne;const oe=j.cacheId&&this._cache.get(...j.cacheId);if(!oe)return;let Y;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?Y=oe:Y=await this._provider.resolveCodeLens(oe,J),Y||(Y=oe),J.isCancellationRequested)return;const le=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!le)return j.command=this._commands.toInternal((ne=Y.command)!==null&&ne!==void 0?ne:f._badCmd,le),j}releaseCodeLenses(j){var J;(J=this._disposables.get(j))===null||J===void 0||J.dispose(),this._disposables.delete(j),this._cache.delete(j)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(qe){return Array.isArray(qe)?qe.map(k.DefinitionLink.from):qe?[k.DefinitionLink.from(qe)]:[]}class r{constructor(j,J){this._documents=j,this._provider=J}provideDefinition(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDefinition(oe,Y,ne)).then(t)}}class n{constructor(j,J){this._documents=j,this._provider=J}provideDeclaration(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDeclaration(oe,Y,ne)).then(t)}}class i{constructor(j,J){this._documents=j,this._provider=J}provideImplementation(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideImplementation(oe,Y,ne)).then(t)}}class a{constructor(j,J){this._documents=j,this._provider=J}provideTypeDefinition(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideTypeDefinition(oe,Y,ne)).then(t)}}class p{constructor(j,J){this._documents=j,this._provider=J}provideHover(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideHover(oe,Y,ne)).then(le=>{if(!(!le||s.isFalsyOrEmpty(le.contents)))return le.range||(le.range=oe.getWordRangeAtPosition(Y)),le.range||(le.range=new S.Range(Y,Y)),k.Hover.from(le)})}}class h{constructor(j,J){this._documents=j,this._provider=J}provideEvaluatableExpression(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideEvaluatableExpression(oe,Y,ne)).then(le=>{if(le)return k.EvaluatableExpression.from(le)})}}class b{constructor(j,J){this._documents=j,this._provider=J}provideInlineValues(j,J,ne,oe){const Y=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(Y,k.Range.to(J),k.InlineValueContext.to(ne),oe)).then(le=>{if(Array.isArray(le))return le.map(me=>k.InlineValue.from(me))})}}class y{constructor(j,J){this._documents=j,this._provider=J}provideDocumentHighlights(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideDocumentHighlights(oe,Y,ne)).then(le=>{if(Array.isArray(le))return le.map(k.DocumentHighlight.from)})}}class o{constructor(j,J){this._documents=j,this._provider=J}provideLinkedEditingRanges(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(oe,Y,ne)).then(le=>{if(le&&Array.isArray(le.ranges))return{ranges:s.coalesce(le.ranges.map(k.Range.from)),wordPattern:le.wordPattern}})}}class L{constructor(j,J){this._documents=j,this._provider=J}provideReferences(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Position.to(J);return A.asPromise(()=>this._provider.provideReferences(Y,le,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.location.from)})}}class O{constructor(j,J,ne,oe,Y,le,me){this._documents=j,this._commands=J,this._diagnostics=ne,this._provider=oe,this._logService=Y,this._extension=le,this._apiDeprecation=me,this._cache=new _.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,J,ne,oe){const Y=this._documents.getDocument(j),le=l.Selection.isISelection(J)?k.Selection.to(J):k.Range.to(J),me=[];for(const We of this._diagnostics.getDiagnostics(j))if(le.intersection(We.range)&&me.push(We)>O._maxCodeActionsPerFile)break;const Re={diagnostics:me,only:ne.only?new S.CodeActionKind(ne.only):void 0,triggerKind:k.CodeActionTriggerKind.to(ne.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(Y,le,Re,oe)).then(We=>{var be;if(!s.isNonEmptyArray(We)||oe.isCancellationRequested)return;const Xe=this._cache.add(We),Q=new g.DisposableStore;this._disposables.set(Xe,Q);const re=[];for(let ve=0;ve<We.length;ve++){const Me=We[ve];!Me||(O._isCommand(Me)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),re.push({_isSynthetic:!0,title:Me.title,command:this._commands.toInternal(Me,Q)})):(Re.only&&(Me.kind?Re.only.contains(Me.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Me.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),re.push({cacheId:[Xe,ve],title:Me.title,command:Me.command&&this._commands.toInternal(Me.command,Q),diagnostics:Me.diagnostics&&Me.diagnostics.map(k.Diagnostic.from),edit:Me.edit&&k.WorkspaceEdit.from(Me.edit),kind:Me.kind&&Me.kind.value,isPreferred:Me.isPreferred,disabled:(be=Me.disabled)===null||be===void 0?void 0:be.reason})))}return{cacheId:Xe,actions:re}})}async resolveCodeAction(j,J){var ne;const[oe,Y]=j,le=this._cache.get(oe,Y);if(!le||O._isCommand(le)||!this._provider.resolveCodeAction)return;const me=(ne=await this._provider.resolveCodeAction(le,J))!==null&&ne!==void 0?ne:le;return(me==null?void 0:me.edit)?k.WorkspaceEdit.from(me.edit):void 0}releaseCodeActions(j){var J;(J=this._disposables.get(j))===null||J===void 0||J.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}O._maxCodeActionsPerFile=1e3;class W{constructor(j,J){this._documents=j,this._provider=J}provideDocumentFormattingEdits(j,J,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(oe,J,ne)).then(Y=>{if(Array.isArray(Y))return Y.map(k.TextEdit.from)})}}class ee{constructor(j,J){this._documents=j,this._provider=J}provideDocumentRangeFormattingEdits(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Range.to(J);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(Y,le,ne,oe)).then(me=>{if(Array.isArray(me))return me.map(k.TextEdit.from)})}}class ce{constructor(j,J){this._documents=j,this._provider=J,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,J,ne,oe,Y){const le=this._documents.getDocument(j),me=k.Position.to(J);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(le,me,ne,oe,Y)).then(Re=>{if(Array.isArray(Re))return Re.map(k.TextEdit.from)})}}class G{constructor(j,J){this._provider=j,this._logService=J,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,J){const ne=C.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,J)).then(oe=>{if(s.isNonEmptyArray(oe))for(const Y of oe){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const le=C.IdObject.mixin(k.WorkspaceSymbol.from(Y));this._symbolCache.set(le._id,Y),ne.symbols.push(le)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(j,J){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ne=this._symbolCache.get(j._id);if(ne){const oe=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ne,J));return oe&&R.mixin(j,k.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(j){const J=this._resultCache.get(j);if(J){for(let[ne,oe]=J;ne<=oe;ne++)this._symbolCache.delete(ne);this._resultCache.delete(j)}}}class x{constructor(j,J,ne){this._documents=j,this._provider=J,this._logService=ne}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Position.to(J);return A.asPromise(()=>this._provider.provideRenameEdits(Y,le,ne,oe)).then(me=>{if(!!me)return k.WorkspaceEdit.from(me)},me=>{const Re=x._asMessage(me);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(me)})}resolveRenameLocation(j,J,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(j),Y=k.Position.to(J);return A.asPromise(()=>this._provider.prepareRename(oe,Y,ne)).then(le=>{let me,Re;if(S.Range.isRange(le)?(me=le,Re=oe.getText(le)):I.isObject(le)&&(me=le.range,Re=le.placeholder),!!me){if(me.start.line>Y.line||me.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:k.Range.from(me),text:Re}}},le=>{const me=x._asMessage(le);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(le)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class V{constructor(j,J){this.resultId=j,this.tokens=J}}class T{constructor(j,J){this._documents=j,this._provider=J,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,J,ne){const oe=this._documents.getDocument(j),Y=J!==0?this._previousResults.get(J):null;return A.asPromise(()=>Y&&typeof Y.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,Y.resultId,ne):this._provider.provideDocumentSemanticTokens(oe,ne)).then(le=>(Y&&this._previousResults.delete(J),le?(le=T._fixProvidedSemanticTokens(le),this._send(T._convertToEdits(Y,le),le)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return T._isSemanticTokens(j)?T._isCorrectSemanticTokens(j)?j:new S.SemanticTokens(new Uint32Array(j.data),j.resultId):T._isSemanticTokensEdits(j)?T._isCorrectSemanticTokensEdits(j)?j:new S.SemanticTokensEdits(j.edits.map(J=>new S.SemanticTokensEdit(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const J of j.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,J){if(!T._isSemanticTokens(J)||!j||!j.tokens)return J;const ne=j.tokens,oe=ne.length,Y=J.data,le=Y.length;let me=0;const Re=Math.min(oe,le);for(;me<Re&&ne[me]===Y[me];)me++;if(me===oe&&me===le)return new S.SemanticTokensEdits([],J.resultId);let We=0;const be=Re-me;for(;We<be&&ne[oe-We-1]===Y[le-We-1];)We++;return new S.SemanticTokensEdits([{start:me,deleteCount:oe-me-We,data:Y.subarray(me,le-We)}],J.resultId)}_send(j,J){if(T._isSemanticTokens(j)){const ne=this._nextResultId++;return this._previousResults.set(ne,new V(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ne,type:"full",data:j.data})}if(T._isSemanticTokensEdits(j)){const ne=this._nextResultId++;return T._isSemanticTokens(J)?this._previousResults.set(ne,new V(J.resultId,J.data)):this._previousResults.set(ne,new V(j.resultId)),c.encodeSemanticTokensDto({id:ne,type:"delta",deltas:(j.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=T;class N{constructor(j,J){this._documents=j,this._provider=J}provideDocumentRangeSemanticTokens(j,J,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(oe,k.Range.to(J),ne)).then(Y=>Y?this._send(Y):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=N;class F{constructor(j,J,ne,oe,Y){this._documents=j,this._commands=J,this._provider=ne,this._apiDeprecation=oe,this._extension=Y,this._cache=new _.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Position.to(J),me=Y.getWordRangeAtPosition(le)||new S.Range(le,le),Re=me.with({end:le}),We=new w.StopWatch(!0),be=await A.asPromise(()=>this._provider.provideCompletionItems(Y,le,oe,k.CompletionContext.to(ne)));if(!be||oe.isCancellationRequested)return;const Xe=Array.isArray(be)?new S.CompletionList(be):be,Q=F.supportsResolving(this._provider)?this._cache.add(Xe.items):this._cache.add([]),re=new g.DisposableStore;this._disposables.set(Q,re);const ve=[],Me={x:Q,b:ve,a:{replace:k.Range.from(me),insert:k.Range.from(Re)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let Ne=0;Ne<Xe.items.length;Ne++){const Ye=Xe.items[Ne],Se=this._convertCompletionItem(Ye,[Q,Ne],Re,me);ve.push(Se)}return Me}async resolveCompletionItem(j,J){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...j);if(!ne)return;const oe=await A.asPromise(()=>this._provider.resolveCompletionItem(ne,J));if(!!oe)return this._convertCompletionItem(oe,j)}releaseCompletionItems(j){var J;(J=this._disposables.get(j))===null||J===void 0||J.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,J,ne,oe){var Y;const le=this._disposables.get(J[0]);if(!le)throw Error("DisposableStore is missing...");const me={x:J,a:(Y=j.label)!==null&&Y!==void 0?Y:"",o:j.label2,b:j.kind!==void 0?k.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(k.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:k.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(k.TextEdit.from),m:this._commands.toInternal(j.command,le)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=j.textEdit.newText):typeof j.insertText=="string"?me.h=j.insertText:j.insertText instanceof S.SnippetString&&(me.h=j.insertText.value,me.i|=4);let Re;return j.textEdit?Re=j.textEdit.range:j.range&&(Re=j.range),S.Range.isRange(Re)?me.j=k.Range.from(Re):Re&&(!(ne==null?void 0:ne.isEqual(Re.inserting))||!(oe==null?void 0:oe.isEqual(Re.replacing)))&&(me.j={insert:k.Range.from(Re.inserting),replace:k.Range.from(Re.replacing)}),me}}class M{constructor(j,J,ne){this._documents=j,this._provider=J,this._commands=ne,this._cache=new _.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Position.to(J),me=await A.asPromise(()=>this._provider.provideInlineCompletionItems(Y,le,ne,oe));if(!me||oe.isCancellationRequested)return;const Re=I.isArray(me)?{items:me}:me,We=this._cache.add(Re.items);let be;return{pid:We,items:Re.items.map((Xe,Q)=>{let re;return Xe.command&&(be||(be=new g.DisposableStore,this._disposables.set(We,be)),re=this._commands.toInternal(Xe.command,be)),{text:Xe.text,range:Xe.range?k.Range.from(Xe.range):void 0,command:re,idx:Q}})}}disposeCompletions(j){this._cache.delete(j);const J=this._disposables.get(j);J&&J.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,J){const ne=this._cache.get(j,J);ne&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let J=U.map.get(j);return J||(J=new U,U.map.set(j,J)),J}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=U,U.map=new WeakMap;class B{constructor(j,J){this._documents=j,this._provider=J,this._cache=new _.Cache("SignatureHelp")}provideSignatureHelp(j,J,ne,oe){const Y=this._documents.getDocument(j),le=k.Position.to(J),me=this.reviveContext(ne);return A.asPromise(()=>this._provider.provideSignatureHelp(Y,le,oe,me)).then(Re=>{if(Re){const We=this._cache.add([Re]);return Object.assign(Object.assign({},k.SignatureHelp.from(Re)),{id:We})}})}reviveContext(j){let J;if(j.activeSignatureHelp){const ne=k.SignatureHelp.to(j.activeSignatureHelp),oe=this._cache.get(j.activeSignatureHelp.id,0);oe?(J=oe,J.activeSignature=ne.activeSignature,J.activeParameter=ne.activeParameter):J=ne}return Object.assign(Object.assign({},j),{activeSignatureHelp:J})}releaseSignatureHelp(j){this._cache.delete(j)}}class K{constructor(j,J){this._documents=j,this._provider=J}provideInlayHints(j,J,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(oe,k.Range.to(J),ne)).then(Y=>Y?{hints:Y.map(k.InlayHint.from)}:void 0)}}class ie{constructor(j,J){this._documents=j,this._provider=J,this._cache=new _.Cache("DocumentLink")}provideLinks(j,J){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentLinks(ne,J)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!J.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(k.DocumentLink.from)};{const Y=this._cache.add(oe),le={links:[],id:Y};for(let me=0;me<oe.length;me++){const Re=k.DocumentLink.from(oe[me]);Re.cacheId=[Y,me],le.links.push(Re)}return le}}})}resolveLink(j,J){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...j);return ne?A.asPromise(()=>this._provider.resolveDocumentLink(ne,J)).then(oe=>oe&&k.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(j){this._cache.delete(j)}}class we{constructor(j,J){this._documents=j,this._provider=J}provideColors(j,J){const ne=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ne,J)).then(oe=>Array.isArray(oe)?oe.map(le=>({color:k.Color.from(le.color),range:k.Range.from(le.range)})):[])}provideColorPresentations(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Range.to(J.range),le=k.Color.to(J.color);return A.asPromise(()=>this._provider.provideColorPresentations(le,{document:oe,range:Y},ne)).then(me=>{if(!!Array.isArray(me))return me.map(k.ColorPresentation.from)})}}class Te{constructor(j,J){this._documents=j,this._provider=J}provideFoldingRanges(j,J,ne){const oe=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(oe,J,ne)).then(Y=>{if(!!Array.isArray(Y))return Y.map(k.FoldingRange.from)})}}class ye{constructor(j,J,ne){this._documents=j,this._provider=J,this._logService=ne}provideSelectionRanges(j,J,ne){const oe=this._documents.getDocument(j),Y=J.map(k.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(oe,Y,ne)).then(le=>{if(!s.isNonEmptyArray(le))return[];if(le.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Re=0;Re<Y.length;Re++){const We=[];me.push(We);let be=Y[Re],Xe=le[Re];for(;;){if(!Xe.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(We.push(k.SelectionRange.from(Xe)),!Xe.parent)break;be=Xe.range,Xe=Xe.parent}}return me})}}class Oe{constructor(j,J){this._documents=j,this._provider=J,this._idPool=new m.IdGenerator(""),this._cache=new Map}async prepareSession(j,J,ne){const oe=this._documents.getDocument(j),Y=k.Position.to(J),le=await this._provider.prepareCallHierarchy(oe,Y,ne);if(!le)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(le)?le.map(Re=>this._cacheAndConvertItem(me,Re)):[this._cacheAndConvertItem(me,le)]}async provideCallsTo(j,J,ne){const oe=this._itemFromCache(j,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(oe,ne);if(!!Y)return Y.map(le=>({from:this._cacheAndConvertItem(j,le.from),fromRanges:le.fromRanges.map(me=>k.Range.from(me))}))}async provideCallsFrom(j,J,ne){const oe=this._itemFromCache(j,J);if(!oe)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(oe,ne);if(!!Y)return Y.map(le=>({to:this._cacheAndConvertItem(j,le.to),fromRanges:le.fromRanges.map(me=>k.Range.from(me))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,J){var ne;const oe=this._cache.get(j),Y={_sessionId:j,_itemId:oe.size.toString(36),name:J.name,detail:J.detail,kind:k.SymbolKind.from(J.kind),uri:J.uri,range:k.Range.from(J.range),selectionRange:k.Range.from(J.selectionRange),tags:(ne=J.tags)===null||ne===void 0?void 0:ne.map(k.SymbolTag.from)};return oe.set(Y._itemId,J),Y}_itemFromCache(j,J){const ne=this._cache.get(j);return ne==null?void 0:ne.get(J)}}class je{constructor(j,J){this.adapter=j,this.extension=J}}class ze{constructor(j,J,ne,oe,Y,le,me){this._adapter=new Map,this._uriTransformer=J,this._proxy=j.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=oe,this._diagnostics=Y,this._logService=le,this._apiDeprecation=me}_transformDocumentSelector(j){return s.coalesce(s.asArray(j).map(J=>this._doTransformDocumentSelector(J)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:k.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new S.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ze._handlePool++}_withAdapter(j,J,ne,oe,Y=!1){const le=this._adapter.get(j);if(!le)return Promise.resolve(oe);if(le.adapter instanceof J){let me;le.extension&&(me=Date.now(),this._logService.trace(`[${le.extension.identifier.value}] INVOKE provider '${J.name}'`));const Re=ne(le.adapter,le.extension),We=le.extension;return We&&Promise.resolve(Re).then(()=>this._logService.trace(`[${We.identifier.value}] provider DONE after ${Date.now()-me}ms`),be=>{Y&&be instanceof E.CancellationError||(this._logService.error(`[${We.identifier.value}] provider FAILED`),this._logService.error(be))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,J){const ne=this._nextHandle();return this._adapter.set(ne,new je(j,J)),ne}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,J,ne,oe){const Y=this._addNewAdapter(new d(this._documents,ne),j),le=oe&&oe.label||ze._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(J),le),this._createDisposable(Y)}$provideDocumentSymbols(j,J,ne){return this._withAdapter(j,d,oe=>oe.provideDocumentSymbols(v.URI.revive(J),ne),void 0)}registerCodeLensProvider(j,J,ne){const oe=this._nextHandle(),Y=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new je(new f(this._documents,this._commands.converter,ne),j)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(J),Y);let le=this._createDisposable(oe);if(Y!==void 0){const me=ne.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(Y));le=S.Disposable.from(le,me)}return le}$provideCodeLenses(j,J,ne){return this._withAdapter(j,f,oe=>oe.provideCodeLenses(v.URI.revive(J),ne),void 0)}$resolveCodeLens(j,J,ne){return this._withAdapter(j,f,oe=>oe.resolveCodeLens(J,ne),void 0)}$releaseCodeLenses(j,J){this._withAdapter(j,f,ne=>Promise.resolve(ne.releaseCodeLenses(J)),void 0)}registerDefinitionProvider(j,J,ne){const oe=this._addNewAdapter(new r(this._documents,ne),j);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDefinition(j,J,ne,oe){return this._withAdapter(j,r,Y=>Y.provideDefinition(v.URI.revive(J),ne,oe),[])}registerDeclarationProvider(j,J,ne){const oe=this._addNewAdapter(new n(this._documents,ne),j);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDeclaration(j,J,ne,oe){return this._withAdapter(j,n,Y=>Y.provideDeclaration(v.URI.revive(J),ne,oe),[])}registerImplementationProvider(j,J,ne){const oe=this._addNewAdapter(new i(this._documents,ne),j);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideImplementation(j,J,ne,oe){return this._withAdapter(j,i,Y=>Y.provideImplementation(v.URI.revive(J),ne,oe),[])}registerTypeDefinitionProvider(j,J,ne){const oe=this._addNewAdapter(new a(this._documents,ne),j);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideTypeDefinition(j,J,ne,oe){return this._withAdapter(j,a,Y=>Y.provideTypeDefinition(v.URI.revive(J),ne,oe),[])}registerHoverProvider(j,J,ne,oe){const Y=this._addNewAdapter(new p(this._documents,ne),j);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideHover(j,J,ne,oe){return this._withAdapter(j,p,Y=>Y.provideHover(v.URI.revive(J),ne,oe),void 0)}registerEvaluatableExpressionProvider(j,J,ne,oe){const Y=this._addNewAdapter(new h(this._documents,ne),j);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(J)),this._createDisposable(Y)}$provideEvaluatableExpression(j,J,ne,oe){return this._withAdapter(j,h,Y=>Y.provideEvaluatableExpression(v.URI.revive(J),ne,oe),void 0)}registerInlineValuesProvider(j,J,ne,oe){const Y=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new b(this._documents,ne),j);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(J),Y);let me=this._createDisposable(le);if(Y!==void 0){const Re=ne.onDidChangeInlineValues(We=>this._proxy.$emitInlineValuesEvent(Y));me=S.Disposable.from(me,Re)}return me}$provideInlineValues(j,J,ne,oe,Y){return this._withAdapter(j,b,le=>le.provideInlineValues(v.URI.revive(J),ne,oe,Y),void 0)}registerDocumentHighlightProvider(j,J,ne){const oe=this._addNewAdapter(new y(this._documents,ne),j);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentHighlights(j,J,ne,oe){return this._withAdapter(j,y,Y=>Y.provideDocumentHighlights(v.URI.revive(J),ne,oe),void 0)}registerLinkedEditingRangeProvider(j,J,ne){const oe=this._addNewAdapter(new o(this._documents,ne),j);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideLinkedEditingRanges(j,J,ne,oe){return this._withAdapter(j,o,async Y=>{const le=await Y.provideLinkedEditingRanges(v.URI.revive(J),ne,oe);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?ze._serializeRegExp(le.wordPattern):void 0}},void 0)}registerReferenceProvider(j,J,ne){const oe=this._addNewAdapter(new L(this._documents,ne),j);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideReferences(j,J,ne,oe,Y){return this._withAdapter(j,L,le=>le.provideReferences(v.URI.revive(J),ne,oe,Y),void 0)}registerCodeActionProvider(j,J,ne,oe){var Y,le;const me=new g.DisposableStore,Re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(J),{providedKinds:(Y=oe==null?void 0:oe.providedCodeActionKinds)===null||Y===void 0?void 0:Y.map(We=>We.value),documentation:(le=oe==null?void 0:oe.documentation)===null||le===void 0?void 0:le.map(We=>({kind:We.kind.value,command:this._commands.converter.toInternal(We.command,me)}))},ze._extLabel(j),Boolean(ne.resolveCodeAction)),me.add(this._createDisposable(Re)),me}$provideCodeActions(j,J,ne,oe,Y){return this._withAdapter(j,O,le=>le.provideCodeActions(v.URI.revive(J),ne,oe,Y),void 0)}$resolveCodeAction(j,J,ne){return this._withAdapter(j,O,oe=>oe.resolveCodeAction(J,ne),void 0)}$releaseCodeActions(j,J){this._withAdapter(j,O,ne=>Promise.resolve(ne.releaseCodeActions(J)),void 0)}registerDocumentFormattingEditProvider(j,J,ne){const oe=this._addNewAdapter(new W(this._documents,ne),j);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(J),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(j,J,ne,oe){return this._withAdapter(j,W,Y=>Y.provideDocumentFormattingEdits(v.URI.revive(J),ne,oe),void 0)}registerDocumentRangeFormattingEditProvider(j,J,ne){const oe=this._addNewAdapter(new ee(this._documents,ne),j);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(J),j.identifier,j.displayName||j.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(j,J,ne,oe,Y){return this._withAdapter(j,ee,le=>le.provideDocumentRangeFormattingEdits(v.URI.revive(J),ne,oe,Y),void 0)}registerOnTypeFormattingEditProvider(j,J,ne,oe){const Y=this._addNewAdapter(new ce(this._documents,ne),j);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(J),oe,j.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(j,J,ne,oe,Y,le){return this._withAdapter(j,ce,me=>me.provideOnTypeFormattingEdits(v.URI.revive(J),ne,oe,Y,le),void 0)}registerWorkspaceSymbolProvider(j,J){const ne=this._addNewAdapter(new G(J,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(j,J,ne){return this._withAdapter(j,G,oe=>oe.provideWorkspaceSymbols(J,ne),{symbols:[]})}$resolveWorkspaceSymbol(j,J,ne){return this._withAdapter(j,G,oe=>oe.resolveWorkspaceSymbol(J,ne),void 0)}$releaseWorkspaceSymbols(j,J){this._withAdapter(j,G,ne=>ne.releaseWorkspaceSymbols(J),void 0)}registerRenameProvider(j,J,ne){const oe=this._addNewAdapter(new x(this._documents,ne,this._logService),j);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(J),x.supportsResolving(ne)),this._createDisposable(oe)}$provideRenameEdits(j,J,ne,oe,Y){return this._withAdapter(j,x,le=>le.provideRenameEdits(v.URI.revive(J),ne,oe,Y),void 0)}$resolveRenameLocation(j,J,ne,oe){return this._withAdapter(j,x,Y=>Y.resolveRenameLocation(v.URI.revive(J),ne,oe),void 0)}registerDocumentSemanticTokensProvider(j,J,ne,oe){const Y=this._nextHandle(),le=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Y,new je(new T(this._documents,ne),j)),this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(J),oe,le);let me=this._createDisposable(Y);if(le){const Re=ne.onDidChangeSemanticTokens(We=>this._proxy.$emitDocumentSemanticTokensEvent(le));me=S.Disposable.from(me,Re)}return me}$provideDocumentSemanticTokens(j,J,ne,oe){return this._withAdapter(j,T,Y=>Y.provideDocumentSemanticTokens(v.URI.revive(J),ne,oe),null,!0)}$releaseDocumentSemanticTokens(j,J){this._withAdapter(j,T,ne=>ne.releaseDocumentSemanticColoring(J),void 0)}registerDocumentRangeSemanticTokensProvider(j,J,ne,oe){const Y=this._addNewAdapter(new N(this._documents,ne),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(J),oe),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(j,J,ne,oe){return this._withAdapter(j,N,Y=>Y.provideDocumentRangeSemanticTokens(v.URI.revive(J),ne,oe),null,!0)}registerCompletionItemProvider(j,J,ne,oe){const Y=this._addNewAdapter(new F(this._documents,this._commands.converter,ne,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(J),oe,F.supportsResolving(ne),`${j.identifier.value}(${oe.join("")})`),this._createDisposable(Y)}$provideCompletionItems(j,J,ne,oe,Y){return this._withAdapter(j,F,le=>le.provideCompletionItems(v.URI.revive(J),ne,oe,Y),void 0)}$resolveCompletionItem(j,J,ne){return this._withAdapter(j,F,oe=>oe.resolveCompletionItem(J,ne),void 0)}$releaseCompletionItems(j,J){this._withAdapter(j,F,ne=>ne.releaseCompletionItems(J),void 0)}registerInlineCompletionsProvider(j,J,ne){const oe=this._addNewAdapter(new M(this._documents,ne,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideInlineCompletions(j,J,ne,oe,Y){return this._withAdapter(j,M,le=>le.provideInlineCompletions(v.URI.revive(J),ne,oe,Y),void 0)}$handleInlineCompletionDidShow(j,J,ne){this._withAdapter(j,M,async oe=>{oe.handleDidShowCompletionItem(J,ne)},void 0)}$freeInlineCompletionsList(j,J){this._withAdapter(j,M,async ne=>{ne.disposeCompletions(J)},void 0)}registerSignatureHelpProvider(j,J,ne,oe){const Y=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,le=this._addNewAdapter(new B(this._documents,ne),j);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(J),Y),this._createDisposable(le)}$provideSignatureHelp(j,J,ne,oe,Y){return this._withAdapter(j,B,le=>le.provideSignatureHelp(v.URI.revive(J),ne,oe,Y),void 0)}$releaseSignatureHelp(j,J){this._withAdapter(j,B,ne=>ne.releaseSignatureHelp(J),void 0)}registerInlayHintsProvider(j,J,ne){const oe=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new K(this._documents,ne),j);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(J),oe);let le=this._createDisposable(Y);if(oe!==void 0){const me=ne.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(oe));le=S.Disposable.from(le,me)}return le}$provideInlayHints(j,J,ne,oe){return this._withAdapter(j,K,Y=>Y.provideInlayHints(v.URI.revive(J),ne,oe),void 0)}registerDocumentLinkProvider(j,J,ne){const oe=this._addNewAdapter(new ie(this._documents,ne),j);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(J),typeof ne.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(j,J,ne){return this._withAdapter(j,ie,oe=>oe.provideLinks(v.URI.revive(J),ne),void 0)}$resolveDocumentLink(j,J,ne){return this._withAdapter(j,ie,oe=>oe.resolveLink(J,ne),void 0)}$releaseDocumentLinks(j,J){this._withAdapter(j,ie,ne=>ne.releaseLinks(J),void 0)}registerColorProvider(j,J,ne){const oe=this._addNewAdapter(new we(this._documents,ne),j);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideDocumentColors(j,J,ne){return this._withAdapter(j,we,oe=>oe.provideColors(v.URI.revive(J),ne),[])}$provideColorPresentations(j,J,ne,oe){return this._withAdapter(j,we,Y=>Y.provideColorPresentations(v.URI.revive(J),ne,oe),void 0)}registerFoldingRangeProvider(j,J,ne){const oe=this._nextHandle(),Y=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new je(new Te(this._documents,ne),j)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(J),Y);let le=this._createDisposable(oe);if(Y!==void 0){const me=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));le=S.Disposable.from(le,me)}return le}$provideFoldingRanges(j,J,ne,oe){return this._withAdapter(j,Te,Y=>Y.provideFoldingRanges(v.URI.revive(J),ne,oe),void 0)}registerSelectionRangeProvider(j,J,ne){const oe=this._addNewAdapter(new ye(this._documents,ne,this._logService),j);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$provideSelectionRanges(j,J,ne,oe){return this._withAdapter(j,ye,Y=>Y.provideSelectionRanges(v.URI.revive(J),ne,oe),[])}registerCallHierarchyProvider(j,J,ne){const oe=this._addNewAdapter(new Oe(this._documents,ne),j);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(J)),this._createDisposable(oe)}$prepareCallHierarchy(j,J,ne,oe){return this._withAdapter(j,Oe,Y=>Promise.resolve(Y.prepareSession(v.URI.revive(J),ne,oe)),void 0)}$provideCallHierarchyIncomingCalls(j,J,ne,oe){return this._withAdapter(j,Oe,Y=>Y.provideCallsTo(J,ne,oe),void 0)}$provideCallHierarchyOutgoingCalls(j,J,ne,oe){return this._withAdapter(j,Oe,Y=>Y.provideCallsFrom(J,ne,oe),void 0)}$releaseCallHierarchy(j,J){this._withAdapter(j,Oe,ne=>Promise.resolve(ne.releaseSession(J)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:D.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ze._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ze._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ze._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ze._serializeRegExp(j.beforeText),afterText:j.afterText?ze._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ze._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ze._serializeOnEnterRule)}setLanguageConfiguration(j,J,ne){let{wordPattern:oe}=ne;if(oe&&D.regExpLeadsToEndlessLoop(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(J,oe):this._documents.setWordDefinitionFor(J,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const Y=this._nextHandle(),le={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?ze._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?ze._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?ze._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,J,le),this._createDisposable(Y)}$setWordDefinitions(j){for(const J of j)this._documents.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(ge[226],pe([0,1,5,18,7]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(C,D){this._proxy=C.getProxy(v.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const P=this._documents.getDocumentData(C);if(!P)throw new Error(`document '${C.toString}' NOT found`);return P.document}async tokenAtPosition(C,D){var P;const s=C.version,I=R.Position.from(D),l=await this._proxy.$tokensAtPosition(C.uri,I),g={type:k.StandardTokenType.Other,range:(P=C.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new k.Range(D.line,D.character,D.line,D.character)};if(!l)return g;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(D)||s!==C.version?g:c}}e.ExtHostLanguages=S}),define(ge[227],pe([0,1,5,15,35]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(C){return C&&C.title}let A=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(v.MainContext.MainThreadMessageService)}showMessage(D,P,s,I,l){const g={extension:D};let c;typeof I=="string"||S(I)?c=[I,...l]:(g.modal=I&&I.modal,g.useCustom=I&&I.useCustom,c=l),g.useCustom&&k.checkProposedApiEnabled(D);const m=[];for(let _=0;_<c.length;_++){const w=c[_];if(typeof w=="string")m.push({title:w,handle:_,isCloseAffordance:!1});else if(typeof w=="object"){let{title:E,isCloseAffordance:u}=w;m.push({title:E,isCloseAffordance:!!u,handle:_})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,s,g,m).then(_=>{if(typeof _=="number")return c[_]})}};A=Ve([He(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(ge[228],pe([0,1,22,3,74,70,6,23,8,13,2,82,5,18,7,60,205,122]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(f,t){const r=E._Keys.nextId();f.$registerNotebookEditorDecorationType(r,g.NotebookDecorationRenderOptions.from(t)),this.value={key:r,dispose(){f.$removeNotebookEditorDecorationType(r)}}}}e.NotebookEditorDecorationType=E,E._Keys=new S.IdGenerator("NotebookEditorDecorationType");class u{constructor(f,t,r,n,i,a){this._textDocumentsAndEditors=r,this._textDocuments=n,this.logService=i,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(l.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(l.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(l.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:p=>{var h;if(p&&p.$mid===12){const b=(h=p.notebookEditor)===null||h===void 0?void 0:h.notebookUri,y=p.cell.handle,o=this._documents.get(b),L=o==null?void 0:o.getCell(y);if(L)return L.apiCell}return p}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,r]of this._editors)if(r.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const r=this._documents.get(f);if(!r&&!t)throw new Error(`NO notebook document for '${f}'`);return r}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,r,n,i){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:r});let a;return r.onDidChangeNotebookContentOptions&&(a=r.onDidChangeNotebookContentOptions(()=>{const p=g.NotebookDocumentContentOptions.from(r.options);this._notebookProxy.$updateNotebookProviderOptions(t,p)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(n),u._convertNotebookRegistrationData(f,i)),new c.Disposable(()=>{a==null||a.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!t)return;const r=t.filenamePattern.map(n=>g.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(t.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:r,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,t,r){const n=u._notebookStatusBarItemProviderHandlePool++,i=typeof r.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,r),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,i,t);let a;return i!==void 0&&(a=r.onDidChangeCellStatusBarItems(p=>this._notebookProxy.$emitCellStatusBarEvent(i))),new c.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,i),a&&a.dispose()})}createNotebookEditorDecorationType(f){return new E(this._notebookEditorsProxy,f).value}async createNotebookDocument(f){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:f.viewType,content:f.content&&g.NotebookData.from(f.content)});return s.URI.revive(t)}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const r=await this._notebookDocumentsProxy.$tryOpenNotebook(f),n=this._documents.get(s.URI.revive(r));return P.assertIsDefined(n==null?void 0:n.apiNotebook)}async showNotebookDocument(f,t){var r;s.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let n;typeof t=="object"?n={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:n={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.notebookType,n),a=i&&((r=this._editors.get(i))===null||r===void 0?void 0:r.apiEditor);if(a)return a;throw i?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,r,n){const i=this._notebookStatusBarItemProviders.get(f),a=s.URI.revive(t),p=this._documents.get(a);if(!p||!i)return;const h=p.getCellFromIndex(r);if(!h)return;const b=await i.provideCellStatusBarItems(h.apiCell,n);if(!b)return;const y=new A.DisposableStore,o=this._statusBarCache.add([y]),O=(Array.isArray(b)?b:[b]).map(W=>g.NotebookStatusBarItem.from(W,this._commandsConverter,y));return{cacheId:o,items:O}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,r,n,i){if(D.isFalsyOrWhitespace(t))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,r),this._notebookProxy.$registerNotebookSerializer(a,{id:f.identifier,location:f.extensionLocation},t,g.NotebookDocumentContentOptions.from(n),u._convertNotebookRegistrationData(f,i)),A.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(f,t,r){const n=this._notebookSerializer.get(f);if(!n)throw new Error("NO serializer found");const i=await n.deserializeNotebook(t.buffer,r);return g.NotebookData.from(i)}async $notebookToData(f,t,r){const n=this._notebookSerializer.get(f);if(!n)throw new Error("NO serializer found");const i=await n.serializeNotebook(g.NotebookData.to(t),r);return v.VSBuffer.wrap(i)}async $openNotebook(f,t,r,n,i){var a;const{provider:p}=this._getProviderData(f),h=await p.openNotebook(s.URI.revive(t),{backupId:r,untitledDocumentData:n==null?void 0:n.buffer},i);return{metadata:(a=h.metadata)!==null&&a!==void 0?a:Object.create(null),cells:h.cells.map(g.NotebookCellData.from)}}async $saveNotebook(f,t,r){const n=this.getNotebookDocument(s.URI.revive(t)),{provider:i}=this._getProviderData(f);return await i.saveNotebook(n.apiNotebook,r),!0}async $saveNotebookAs(f,t,r,n){const i=this.getNotebookDocument(s.URI.revive(t)),{provider:a}=this._getProviderData(f);return await a.saveNotebookAs(s.URI.revive(r),i.apiNotebook,n),!0}async $backupNotebook(f,t,r){var n;const i=this.getNotebookDocument(s.URI.revive(t)),a=this._getProviderData(f),p=(n=this._extensionStoragePaths.workspaceValue(a.extension))!==null&&n!==void 0?n:this._extensionStoragePaths.globalValue(a.extension),h=String(k.hash([i.uri.toString(),this._backupIdPool++])),b=s.URI.joinPath(p,h),y=await a.provider.backupNotebook(i.apiNotebook,{destination:b},r);return i.updateBackup(y),y.id}$acceptModelChanged(f,t,r){this.getNotebookDocument(s.URI.revive(f)).acceptModelChanged(t,r)}$acceptDirtyStateChanged(f,t){const r=this.getNotebookDocument(s.URI.revive(f));r.acceptModelChanged({rawEvents:[],versionId:r.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(s.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const r=this._editors.get(f);if(!r)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&r._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&r._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:r.apiEditor,visibleRanges:r.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:r.apiEditor,selections:r.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const r=this._editors.get(t);if(!r)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);r._acceptViewColumn(g.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const r=this.getNotebookDocument(s.URI.revive(f));r.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:r.apiNotebook})}_createExtHostEditor(f,t,r){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const n=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,r.visibleRanges.map(g.NotebookRange.to),r.selections.map(g.NotebookRange.to),typeof r.viewColumn=="number"?g.ViewColumn.to(r.viewColumn):void 0);this._editors.set(t,n)}$acceptDocumentAndEditorsDelta(f){var t,r,n,i;if(f.removedDocuments)for(const p of f.removedDocuments){const h=s.URI.revive(p),b=this._documents.get(h);b&&(b.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(y=>y.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const y of this._editors.values())y.notebookData.uri.toString()===h.toString()&&this._editors.delete(y.id)}if(f.addedDocuments){const p=[];for(const h of f.addedDocuments){const b=s.URI.revive(h.uri),y=h.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const o=this,L=new _.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(O){o._onDidChangeNotebookCells.fire(O)},emitCellOutputsChange(O){o._onDidChangeCellOutputs.fire(O)},emitCellMetadataChange(O){o._onDidChangeCellMetadata.fire(O)},emitCellExecutionStateChange(O){o._onDidChangeCellExecutionState.fire(O)}},y,(t=h.metadata)!==null&&t!==void 0?t:Object.create({}),b);L.acceptModelChanged({versionId:h.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,h.cells]]}]},!1),p.push(...h.cells.map(O=>_.ExtHostCell.asModelAddData(L.apiNotebook,O))),(r=this._documents.get(b))===null||r===void 0||r.dispose(),this._documents.set(b,L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(L.apiNotebook)}}if(f.addedEditors)for(const p of f.addedEditors){if(this._editors.has(p.id))return;const h=s.URI.revive(p.documentUri),b=this._documents.get(h);b&&this._createExtHostEditor(b,p.id,p)}const a=[];if(f.removedEditors)for(const p of f.removedEditors){const h=this._editors.get(p);h&&(this._editors.delete(p),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===h.id&&(this._activeNotebookEditor=void 0),a.push(h))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const p=new Set;this._visibleNotebookEditors.forEach(h=>p.add(h.id));for(const h of this._editors.values()){const b=p.has(h.id);h._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((i=this._activeNotebookEditor)===null||i===void 0?void 0:i.apiEditor)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(ge[229],pe([0,1,3,6,5,26,2,18,84,23,14,60,21,17,15,7,35]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(t,r,n,i){this._mainContext=t,this._initData=r,this._extHostNotebook=n,this._logService=i,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(k.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,n,i,a,p){for(let F of this._kernelData.values())if(F.controller.id===r&&S.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const h=this._handlePool++,b=this;this._logService.trace(`NotebookController[${h}], CREATED by ${t.identifier.value}, ${r}`);const y=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${t.identifier}'`);let o=!1;const L=new R.DisposableStore,O=new v.Emitter,W=new v.Emitter,ee={id:`${t.identifier.value}/${r}`,notebookType:n,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:p?p.map(C.NotebookRendererScript.from):[]};let ce=a??y,G;this._proxy.$addKernel(h,ee).catch(F=>{console.log(F),o=!0});let x=0;const V=()=>{if(o)return;const F=++x;Promise.resolve().then(()=>{F===x&&this._proxy.$updateKernel(h,ee)})},T=new P.ResourceMap,N={get id(){return r},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(F){var M;ee.label=(M=F??t.displayName)!==null&&M!==void 0?M:t.name,V()},get detail(){var F;return(F=ee.detail)!==null&&F!==void 0?F:""},set detail(F){ee.detail=F,V()},get description(){var F;return(F=ee.description)!==null&&F!==void 0?F:""},set description(F){ee.description=F,V()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(F){ee.supportedLanguages=F,V()},get supportsExecutionOrder(){var F;return(F=ee.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set supportsExecutionOrder(F){ee.supportsExecutionOrder=F,V()},get rendererScripts(){return ee.preloads?ee.preloads.map(C.NotebookRendererScript.to):[]},get executeHandler(){return ce},set executeHandler(F){ce=F??y},get interruptHandler(){return G},set interruptHandler(F){G=F,ee.supportsInterrupt=Boolean(F),V()},createNotebookCellExecution(F){if(o)throw new Error("notebook controller is DISPOSED");if(!T.has(F.notebook.uri))throw b._logService.trace(`NotebookController[${h}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(T.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return b._createNotebookCellExecution(F)},dispose:()=>{o||(this._logService.trace(`NotebookController[${h}], DISPOSED`),o=!0,this._kernelData.delete(h),L.dispose(),O.dispose(),W.dispose(),this._proxy.$removeKernel(h))},updateNotebookAffinity(F,M){b._proxy.$updateNotebookPriority(h,F.uri,M)},onDidReceiveMessage:W.event,postMessage(F,M){return _.checkProposedApiEnabled(t),b._proxy.$postMessage(h,M&&b._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return _.checkProposedApiEnabled(t),D.asWebviewUri(F,b._initData.remote)}};return this._kernelData.set(h,{extensionId:t.identifier,controller:N,onDidReceiveMessage:W,onDidChangeSelection:O,associatedNotebooks:T}),N}$acceptNotebookAssociation(t,r,n){const i=this._kernelData.get(t);if(i){const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));n?i.associatedNotebooks.set(a.uri,!0):i.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,a.uri.toString(),n),i.onDidChangeSelection.fire({selected:n,notebook:a.apiNotebook})}}async $executeCells(t,r,n){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getNotebookDocument(A.URI.revive(r)),p=[];for(let h of n){const b=a.getCell(h);b&&p.push(b.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,a.uri.toString(),p.length),await i.controller.executeHandler.call(i.controller,p,a.apiNotebook,i.controller)}catch(h){this._logService.error(`NotebookController[${t}] execute cells FAILED`,h),console.error(h)}}async $cancelCells(t,r,n){var i;const a=this._kernelData.get(t);if(!a)return;const p=this._extHostNotebook.getNotebookDocument(A.URI.revive(r));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,p.apiNotebook);else for(let h of n){const b=p.getCell(h);b&&((i=this._activeExecutions.get(b.uri))===null||i===void 0||i.cancel())}}$acceptKernelMessageFromRenderer(t,r,n){const i=this._kernelData.get(t);if(!i)return;const a=this._extHostNotebook.getEditorById(r);if(!a)throw new Error(`send message for UNKNOWN editor: ${r}`);i.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:n}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const i=new u(n.notebook,n,this._mainContext.getProxy(k.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(n.uri,i);const a=i.onDidChangeState(()=>{i.state===E.Resolved&&(i.dispose(),a.dispose(),this._activeExecutions.delete(n.uri))});return i.asApiObject()}};w=Ve([He(3,c.ILogService)],w),e.ExtHostNotebookKernels=w;var E;(function(f){f[f.Init=0]="Init",f[f.Started=1]="Started",f[f.Resolved=2]="Resolved"})(E||(E={}));class u extends R.Disposable{constructor(t,r,n){super();this._document=t,this._cell=r,this._proxy=n,this._onDidChangeState=new v.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=E.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new d(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyEdits(this._document.uri,t,!1)}verifyStateForOutput(){if(this._state===E.Init)throw new Error("Must call start before modifying cell output");if(this._state===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){const r={editType:9,handle:this._cell.handle,internalMetadata:t};this.applyEdits([r])}cellIndexToHandle(t){let r=this._cell;if(typeof t=="number"?r=this._document.getCellFromIndex(t):t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const n=m.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return n===r.items?C.NotebookCellOutput.from(r):C.NotebookCellOutput.from({items:n,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,n){const i=this.cellIndexToHandle(r),a=this.validateAndConvertOutputs(g.asArray(t));return this.applyEditSoon({editType:2,handle:i,append:n,outputs:a})}async updateOutputItems(t,r,n){return m.NotebookCellOutput.isNotebookCellOutput(r)&&(r=r.id),t=m.NotebookCellOutput.ensureUniqueMimeTypes(g.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(C.NotebookCellOutputItem.from),outputId:r,append:n})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(n){t._executionOrder=n,t.mixinMetadata({executionOrder:n})},start(n){if(t._state===E.Resolved||t._state===E.Started)throw new Error("Cannot call start again");t._state=E.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:n??null})},end(n,i){if(t._state===E.Resolved)throw new Error("Cannot call resolve twice");t._state=E.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:n??null,runEndTime:i??null})},clearOutput(n){return t.verifyStateForOutput(),t.updateOutputs([],n,!1)},appendOutput(n,i){return t.verifyStateForOutput(),t.updateOutputs(n,i,!0)},replaceOutput(n,i){return t.verifyStateForOutput(),t.updateOutputs(n,i,!1)},appendOutputItems(n,i){return t.verifyStateForOutput(),t.updateOutputItems(n,i,!0)},replaceOutputItems(n,i){return t.verifyStateForOutput(),t.updateOutputItems(n,i,!1)}})}}class d{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=s.timeout(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(ge[230],pe([0,1,3,5,122]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(C,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,D,P){var s;const I=this._extHostNotebook.getEditorById(C);!I||(s=this._rendererMessageEmitters.get(D))===null||s===void 0||s.fire({editor:I.apiEditor,message:P})}createRendererMessaging(C){return{onDidReceiveMessage:(...P)=>this.getOrCreateEmitterFor(C).event(...P),postMessage:(P,s)=>{const I=k.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,C,s)}}}getOrCreateEmitterFor(C){let D=this._rendererMessageEmitters.get(C);return D||(D=new v.Emitter({onLastListenerRemove:()=>{D==null||D.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,D),D)}}e.ExtHostNotebookRenderers=S}),define(ge[62],pe([0,1,5,3,6,22,4,12]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends k.Disposable{constructor(c,m,_,w){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=w,this._id=w.$register(this.name,m,_),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?S.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(m=>this._proxy.$clear(m,c))}show(c,m){this.validate(),this._id.then(_=>this._proxy.$reveal(_,!!(typeof c=="boolean"?c:m)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(c,m){super(c,!1,void 0,m)}append(c){super.append(c),this._id.then(m=>this._proxy.$append(m,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class s extends D{constructor(c,m,_){super(c,!0,m,_)}append(c){throw new Error("Not supported")}}class I{constructor(c,m){this.name=c,this._channel=m}append(c){this._channel.then(m=>m.append(c))}appendLine(c){this._channel.then(m=>m.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,m){this._channel.then(_=>_.show(c,m))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let l=class{constructor(c){this._proxy=c.getProxy(v.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new P(c,this._proxy)}createOutputChannelFromLogFile(c,m){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!m)throw new Error("illegal argument `file`. must not be falsy");return new s(c,m,this._proxy)}};l=Ve([He(0,C.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(ge[231],pe([0,1,14,21,3,6,5,2,7,16,17,52]),function(X,e,v,R,k,S,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(g,c,m){const _=g.getProxy(A.MainContext.MainThreadQuickOpen);class w{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,p,h=R.CancellationToken.None){this._onDidSelectItem=void 0;const b=Promise.resolve(i),y=++this._instances,o=_.$show(y,{title:p==null?void 0:p.title,placeHolder:p==null?void 0:p.placeHolder,matchOnDescription:p==null?void 0:p.matchOnDescription,matchOnDetail:p==null?void 0:p.matchOnDetail,ignoreFocusLost:p==null?void 0:p.ignoreFocusOut,canPickMany:p==null?void 0:p.canPickMany},h),L={},O=o.then(()=>L);return Promise.race([O,b]).then(W=>{if(W!==L)return b.then(ee=>{const ce=[];for(let G=0;G<ee.length;G++){const x=ee[G];let V,T,N,F,M;typeof x=="string"?V=x:(V=x.label,T=x.description,N=x.detail,F=x.picked,M=x.alwaysShow),ce.push({label:V,description:T,handle:G,detail:N,picked:F,alwaysShow:M})}return p&&typeof p.onDidSelectItem=="function"&&(this._onDidSelectItem=G=>{p.onDidSelectItem(ee[G])}),_.$setItems(y,ce),o.then(G=>{if(typeof G=="number")return ee[G];if(Array.isArray(G))return G.map(x=>ee[x])})})}).then(void 0,W=>{if(!P.isPromiseCanceledError(W))return _.$setError(y,W),Promise.reject(W)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=R.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,_.$input(i,typeof this._validateInput=="function",a).then(void 0,p=>{if(!P.isPromiseCanceledError(p))return Promise.reject(p)})}$validateInput(i){return this._validateInput?v.asPromise(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=R.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!p)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(b=>b.uri.toString()===p.uri.toString())}createQuickPick(i,a){const p=new t(i,a,()=>this._sessions.delete(p._id));return this._sessions.set(p._id,p),p}createInputBox(i){const a=new r(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const p=this._sessions.get(i);p&&p._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const p=this._sessions.get(i);p instanceof t&&p._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const p=this._sessions.get(i);p&&p._fireDidTriggerButton(a)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class E{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new k.Emitter,this._onDidChangeValueEmitter=new k.Emitter,this._onDidTriggerButtonEmitter=new k.Emitter,this._onDidHideEmitter=new k.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,p)=>{const h=a===D.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(h,a)}),this.update({buttons:i.map((a,p)=>({iconPath:u(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=S.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const p=i[a];this._pendingUpdate[a]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function u(n){if(n instanceof D.ThemeIcon)return{id:n.id};const i=f(n),a=d(n);return{dark:typeof i=="string"?C.URI.file(i):i,light:typeof a=="string"?C.URI.file(a):a}}function d(n){return typeof n=="object"&&"light"in n?n.light:n}function f(n){return typeof n=="object"&&"dark"in n?n.dark:n}class t extends E{constructor(i,a,p){super(i,p);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new k.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new k.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((a,p)=>{this._handlesToItems.set(p,a),this._itemsToHandles.set(a,p)}),this.update({items:i.map((a,p)=>({label:a.label,description:a.description,handle:p,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=s.coalesce(i.map(p=>this._handlesToItems.get(p)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=s.coalesce(i.map(p=>this._handlesToItems.get(p)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class r extends E{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?I.default.Error:I.default.Ignore})}}return new w(c,m)}e.createExtHostQuickOpen=l}),define(ge[232],pe([0,1,2,3,50,6,14,5,17,95,15,26,35]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(i){if(i)return typeof i.iconPath=="string"?v.URI.file(i.iconPath):i.iconPath}function c(i,a){if(!i.iconPath&&!a.iconPath)return 0;if(i.iconPath){if(!a.iconPath)return 1}else return-1;const p=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,h=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return P.comparePaths(p,h)}function m(i,a){let p=0;if(i.strikeThrough!==a.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==a.faded)return i.faded?1:-1;if(i.tooltip!==a.tooltip)return(i.tooltip||"").localeCompare(a.tooltip||"");if(p=c(i,a),p!==0)return p;if(i.light&&a.light)p=c(i.light,a.light);else{if(i.light)return 1;if(a.light)return-1}if(p!==0)return p;if(i.dark&&a.dark)p=c(i.dark,a.dark);else{if(i.dark)return 1;if(a.dark)return-1}return p}function _(i,a){if(i.command!==a.command)return i.command<a.command?-1:1;if(i.title!==a.title)return i.title<a.title?-1:1;if(i.tooltip!==a.tooltip){if(i.tooltip!==void 0&&a.tooltip!==void 0)return i.tooltip<a.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(i.arguments===a.arguments)return 0;if(i.arguments)if(a.arguments){if(i.arguments.length!==a.arguments.length)return i.arguments.length-a.arguments.length}else return 1;else return-1;for(let p=0;p<i.arguments.length;p++){const h=i.arguments[p],b=a.arguments[p];if(h!==b)return h<b?-1:1}return 0}function w(i,a){let p=P.comparePaths(i.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(p!==0)return p;if(i.command&&a.command)p=_(i.command,a.command);else{if(i.command)return 1;if(a.command)return-1}if(p!==0)return p;if(i.decorations&&a.decorations)p=m(i.decorations,a.decorations);else{if(i.decorations)return 1;if(a.decorations)return-1}return p}function E(i,a){for(let p=0;p<i.length;p++)if(i[p]!==a[p])return!1;return!0}function u(i,a){return i.command===a.command&&i.title===a.title&&i.tooltip===a.tooltip&&(i.arguments&&a.arguments?E(i.arguments,a.arguments):i.arguments===a.arguments)}function d(i,a){return D.equals(i,a,u)}class f{constructor(a,p,h){this._extension=a,this._proxy=p,this._sourceControlHandle=h,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(a){if(l.checkProposedApiEnabled(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,p){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,p)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=f;class t{constructor(a,p,h,b,y){this._proxy=a,this._commands=p,this._sourceControlHandle=h,this._id=b,this._label=y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,p){const h=this._resourceStatesCommandsMap.get(a);return h?A.asPromise(()=>this._commands.executeCommand(h.command,...h.arguments||[],p)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const p=[...this._resourceStates].sort(w),b=D.sortedDiff(this._resourceSnapshot,p,w).map(L=>{const O=L.toInsert.map(W=>{const ee=this._resourceHandlePool++;this._resourceStatesMap.set(ee,W);const ce=W.resourceUri,G=g(W.decorations),x=W.decorations&&g(W.decorations.light)||G,V=W.decorations&&g(W.decorations.dark)||G,T=[];let N;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ie=new S.DisposableStore;N=this._commands.converter.toInternal(W.command,ie),this._resourceStatesDisposablesMap.set(ee,ie)}else this._resourceStatesCommandsMap.set(ee,W.command);x&&T.push(x),V&&V.toString()!==(x==null?void 0:x.toString())&&T.push(V);const F=W.decorations&&W.decorations.tooltip||"",M=W.decorations&&!!W.decorations.strikeThrough,U=W.decorations&&!!W.decorations.faded,B=W.contextValue||"";return{rawResource:[ee,ce,T,F,M,U,B,N],handle:ee}});return{start:L.start,deleteCount:L.deleteCount,toInsert:O}}),y=b.map(({start:L,deleteCount:O,toInsert:W})=>[L,O,W.map(ee=>ee.rawResource)]),o=b.reverse();for(const{start:L,deleteCount:O,toInsert:W}of o){const ee=W.map(G=>G.handle),ce=this._handlesSnapshot.splice(L,O,...ee);for(const G of ce)this._resourceStatesMap.delete(G),this._resourceStatesCommandsMap.delete(G),(a=this._resourceStatesDisposablesMap.get(G))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(G)}return this._resourceSnapshot=p,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(a,p,h,b,y,o){this._proxy=p,this._commands=h,this._id=b,this._label=y,this._rootUri=o,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,b,y,o)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=a;const p=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:p})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&d(this._statusBarCommands,a))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=a;const p=(a||[]).map(h=>this._commands.converter.toInternal(h,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:p})}get selected(){return this._selected}createResourceGroup(a,p){const h=new t(this._proxy,this._commands,this.handle,a,p),b=R.Event.once(h.onDidDispose)(()=>this.createdResourceGroups.delete(h));return this.createdResourceGroups.set(h,b),this.eventuallyAddResourceGroups(),h}eventuallyAddResourceGroups(){const a=[],p=[];for(const[h,b]of this.createdResourceGroups){b.dispose();const y=h.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(h),this.eventuallyUpdateResourceStates()});R.Event.once(h.onDidDispose)(()=>{this.updatedResourceGroups.delete(h),y.dispose(),this._groups.delete(h.handle),this._proxy.$unregisterGroup(this.handle,h.handle)}),a.push([h.handle,h.id,h.label,h.features]);const o=h._takeResourceStateSnapshot();o.length>0&&p.push([h.handle,o]),this._groups.set(h.handle,h)}this._proxy.$registerGroups(this.handle,a,p),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(p=>{const h=p._takeResourceStateSnapshot();h.length!==0&&a.push([p.handle,h])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([k.debounce(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([k.debounce(100)],r.prototype,"eventuallyUpdateResourceStates",null);let n=class Fn{constructor(a,p,h){this._commands=p,this.logService=h,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=a.getProxy(C.MainContext.MainThreadSCM),this._telemetry=a.getProxy(C.MainContext.MainThreadTelemetry),p.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===3){const y=this._sourceControls.get(b.sourceControlHandle);if(!y)return b;const o=y.getResourceGroup(b.groupHandle);return o?o.getResourceState(b.handle):b}else if(b&&b.$mid===4){const y=this._sourceControls.get(b.sourceControlHandle);return y?y.getResourceGroup(b.groupHandle):b}else if(b&&b.$mid===5){const y=this._sourceControls.get(b.handle);return y||b}return b}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,p,h,b){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,p,h,b),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const y=Fn._handlePool++,o=new r(a,this._proxy,this._commands,p,h,b);this._sourceControls.set(y,o);const L=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(a.identifier))||[];return L.push(o),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(a.identifier),L),o}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const p=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(a.identifier)),h=p&&p[p.length-1];return h&&h.inputBox}$provideOriginalResource(a,p,h){const b=v.URI.revive(p);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,b.toString());const y=this._sourceControls.get(a);return!y||!y.quickDiffProvider||!y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>y.quickDiffProvider.provideOriginalResource(b,h)).then(o=>o||null)}$onInputBoxValueChange(a,p){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const h=this._sourceControls.get(a);return h&&h.inputBox.$onInputBoxValueChange(p),Promise.resolve(void 0)}$executeResourceCommand(a,p,h,b){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,p,h);const y=this._sourceControls.get(a);if(!y)return Promise.resolve(void 0);const o=y.getResourceGroup(p);return o?o.$executeResourceCommand(h,b):Promise.resolve(void 0)}$validateInput(a,p,h){this.logService.trace("ExtHostSCM#$validateInput",a);const b=this._sourceControls.get(a);return!b||!b.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>b.inputBox.validateInput(p,h)).then(y=>y?Promise.resolve([y.message,y.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var p,h;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((p=this._sourceControls.get(a))===null||p===void 0||p.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((h=this._sourceControls.get(this._selectedSourceControlHandle))===null||h===void 0||h.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};n._handlePool=0,n=Ve([He(2,s.ILogService)],n),e.ExtHostSCM=n});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[233],pe([0,1,7,5,161,6]),function(X,e,v,R,k,S){"use strict";var A,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(l,g,c,m,_=v.StatusBarAlignment.Left,w){A.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,tt(this,A,l,"f"),tt(this,C,g,"f"),this._entryId=D.ID_GEN++,this._extension=c,this._id=m,this._alignment=_,this._priority=w}get id(){var l;return(l=this._id)!==null&&l!==void 0?l:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var l;return(l=this._command)===null||l===void 0?void 0:l.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!D.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:$e(this,C,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:$e(this,C,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,A,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var l;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let c;this._name?c=this._name:c=k.localize(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),$e(this,A,"f").$setEntry(this._entryId,g,c,this._text,this._tooltip,(l=this._command)===null||l===void 0?void 0:l.internal,m,this._backgroundColor,this._alignment===v.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,A=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new v.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=k.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const g={message:l};return this._messages.unshift(g),this._update(),new v.Disposable(()=>{const c=this._messages.indexOf(g);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class s{constructor(l,g){this._proxy=l.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new P(this)}createStatusBarEntry(l,g,c,m){return new D(this._proxy,this._commands,l,g,c,m)}setStatusBarMessage(l,g){const c=this._statusMessage.setMessage(l);let m;return typeof g=="number"?m=setTimeout(()=>c.dispose(),g):typeof g!="undefined"&&g.then(()=>c.dispose(),()=>c.dispose()),new v.Disposable(()=>{c.dispose(),clearTimeout(m)})}}e.ExtHostStatusBar=s}),define(ge[87],pe([0,1,5,3,4]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(C){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(v.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,P){return this._proxy.$getValue(C,D).then(s=>s||P)}setValue(C,D,P){return this._proxy.$setValue(C,D,P)}$acceptValue(C,D,P){this._onDidChangeStorage.fire({shared:C,key:D,value:P})}}e.ExtHostStorage=S,e.IExtHostStorage=k.createDecorator("IExtHostStorage")}),define(ge[88],pe([0,1,4,27,15,86,2]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=v.createDecorator("IExtensionStoragePaths");let C=class{constructor(P,s,I){var l;this._logService=s,this._extHostFileSystem=I,this._workspace=(l=P.workspace)!==null&&l!==void 0?l:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const s=this._workspace.id,I=A.URI.joinPath(this._environment.workspaceStorageHome,s);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=A.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),I}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(P){if(this._value)return A.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return A.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};C=Ve([He(0,R.IExtHostInitDataService),He(1,k.ILogService),He(2,S.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(ge[33],pe([0,1,3,5,4,2,12,6,7,162,16,199,21,32,187,13]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=k.createDecorator("IExtHostTerminalService");class _{constructor(n,i,a,p){this._proxy=n,this._id=i,this._creationOptions=a,this._name=p,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const h=this;this.value={get name(){return h._name||""},get processId(){return h._pidPromise},get creationOptions(){return h._creationOptions},get exitStatus(){return h._exitStatus},sendText(b,y=!0){h._checkDisposed(),h._proxy.$sendText(h._id,b,y)},show(b){h._checkDisposed(),h._proxy.$show(h._id,b)},hide(){h._checkDisposed(),h._proxy.$hide(h._id)},dispose(){h._disposed||(h._disposed=!0,h._proxy.$dispose(h._id))},get dimensions(){if(!(h._cols===void 0||h._rows===void 0))return{columns:h._cols,rows:h._rows}}}}async create(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:m.withNullAsUndefined(n.shellPath),shellArgs:m.withNullAsUndefined(n.shellArgs),cwd:m.withNullAsUndefined(n.cwd),env:m.withNullAsUndefined(n.env),icon:m.withNullAsUndefined(t(n.iconPath)),initialText:m.withNullAsUndefined(n.message),strictEnv:m.withNullAsUndefined(n.strictEnv),hideFromUser:m.withNullAsUndefined(n.hideFromUser),isFeatureTerminal:m.withNullAsUndefined(i==null?void 0:i.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:m.withNullAsUndefined(i==null?void 0:i.useShellEnvironment),isSplitTerminal:m.withNullAsUndefined(i==null?void 0:i.isSplitTerminal)})}async createExtensionTerminal(n,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:i,isSplitTerminal:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,i){return n===this._cols&&i===this._rows||n===0||i===0?!1:(this._cols=n,this._rows=i,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=_;class w{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new v.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new v.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new v.Emitter,this._onProcessTitleChanged=new v.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new v.Emitter,this._onProcessShellTypeChanged=new v.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,i){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:i})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=w;let E=1,u=class extends C.Disposable{constructor(n,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new v.Emitter,this._onDidOpenTerminal=new v.Emitter,this._onDidChangeActiveTerminal=new v.Emitter,this._onDidChangeTerminalDimensions=new v.Emitter,this._proxy=i.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new v.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[a,p]of this._terminalProcesses)p.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(n){const i=n?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[]}createExtensionTerminal(n,i){const a=new _(this._proxy,g.generateUuid(),n,n.name),p=new w(n.pty);return a.createExtensionTerminal(i==null?void 0:i.isSplitTerminal,t(n.iconPath)).then(h=>{const b=this._setupExtHostProcessListeners(h,p);this._terminalProcessDisposables[h]=b}),this._terminals.push(a),a.value}attachPtyToTerminal(n,i){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const p=new w(i),h=this._setupExtHostProcessListeners(n,p);this._terminalProcessDisposables[n]=h}async $acceptActiveTerminalChanged(n){const i=this._activeTerminal;if(n===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(n);a&&(this._activeTerminal=a,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,i){const a=this._getTerminalById(n);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:i})}async $acceptTerminalDimensions(n,i,a){const p=this._getTerminalById(n);p&&p.setDimensions(i,a)&&this._onDidChangeTerminalDimensions.fire({terminal:p.value,dimensions:p.value.dimensions})}async $acceptTerminalMaximumDimensions(n,i,a){var p;(p=this._terminalProcesses.get(n))===null||p===void 0||p.resize(i,a)}async $acceptTerminalTitleChange(n,i){const a=this._getTerminalById(n);a&&(a.name=i)}async $acceptTerminalClosed(n,i){const a=this._getTerminalObjectIndexById(this._terminals,n);if(a!==null){const p=this._terminals.splice(a,1)[0];p.setExitCode(i),this._onDidCloseTerminal.fire(p.value)}}$acceptTerminalOpened(n,i,a,p){if(i){const y=this._getTerminalObjectIndexById(this._terminals,i);if(y!==null){this._terminals[y]._id=n,this._onDidOpenTerminal.fire(this.terminals[y]),this._terminals[y].isOpen=!0;return}}const h={name:p.name,shellPath:p.executable,shellArgs:p.args,cwd:typeof p.cwd=="string"?p.cwd:S.URI.revive(p.cwd),env:p.env,hideFromUser:p.hideFromUser},b=new _(this._proxy,n,h,a);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(n,i){const a=this._getTerminalById(n);a&&a._setProcessId(i)}async $startExtensionTerminal(n,i){const a=this._getTerminalById(n);if(!a)return{message:P.localize(0,null,n)};a.isOpen||await new Promise(h=>{const b=this.onDidOpenTerminal(async y=>{y===a.value&&(b.dispose(),h())})});const p=this._terminalProcesses.get(n);p?p.startSendingEvents(i):this._extensionTerminalAwaitingStart[n]={initialDimensions:i}}_setupExtHostProcessListeners(n,i){const a=new C.DisposableStore;a.add(i.onProcessReady(h=>this._proxy.$sendProcessReady(n,h.pid,h.cwd))),a.add(i.onProcessTitleChanged(h=>this._proxy.$sendProcessTitle(n,h))),this._bufferer.startBuffering(n,i.onProcessData),a.add(i.onProcessExit(h=>this._onProcessExit(n,h))),i.onProcessOverrideDimensions&&a.add(i.onProcessOverrideDimensions(h=>this._proxy.$sendOverrideDimensions(n,h))),this._terminalProcesses.set(n,i);const p=this._extensionTerminalAwaitingStart[n];return p&&i instanceof w&&(i.startSendingEvents(p.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),a}$acceptProcessAckDataEvent(n,i){var a;(a=this._terminalProcesses.get(n))===null||a===void 0||a.acknowledgeDataEvent(i)}$acceptProcessInput(n,i){var a;(a=this._terminalProcesses.get(n))===null||a===void 0||a.input(i)}$acceptProcessResize(n,i,a){var p;try{(p=this._terminalProcesses.get(n))===null||p===void 0||p.resize(i,a)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(n,i){var a;(a=this._terminalProcesses.get(n))===null||a===void 0||a.shutdown(i)}$acceptProcessRequestInitialCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(n,a))}$acceptProcessRequestCwd(n){var i;(i=this._terminalProcesses.get(n))===null||i===void 0||i.getCwd().then(a=>this._proxy.$sendProcessCwd(n,a))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,i){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,i),this._proxy.$registerProfileProvider(n),new D.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(n,i){var a;const p=new l.CancellationTokenSource().token,h=await((a=this._profileProviders.get(n))===null||a===void 0?void 0:a.provideProfileOptions(p));if(!p.isCancellationRequested){if(!h)throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in h){this.createExtensionTerminal(h,{isSplitTerminal:i});return}this.createTerminalFromOptions(h,{isSplitTerminal:i})}}async $provideLinks(n,i){const a=this._getTerminalById(n);if(!a)return[];this._terminalLinkCache.delete(n);const p=this._terminalLinkCancellationSource.get(n);p&&p.dispose(!0);const h=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,h);const b=[],y={terminal:a.value,line:i},o=[];for(const W of this._linkProviders)o.push(new Promise(async ee=>{h.token.onCancellationRequested(()=>ee({provider:W,links:[]}));const ce=await W.provideTerminalLinks(y,h.token)||[];h.token.isCancellationRequested||ee({provider:W,links:ce})}));const L=await Promise.all(o);if(h.token.isCancellationRequested)return[];const O=new Map;for(const W of L)W&&W.links.length>0&&b.push(...W.links.map(ee=>{const ce={id:E++,startIndex:ee.startIndex,length:ee.length,label:ee.tooltip};return O.set(ce.id,{provider:W.provider,link:ee}),ce}));return this._terminalLinkCache.set(n,O),b}$activateLink(n,i){var a;const p=(a=this._terminalLinkCache.get(n))===null||a===void 0?void 0:a.get(i);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(n,i){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const a=this._terminalProcessDisposables[n];a&&(a.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,i)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,i){const a=this._getTerminalObjectIndexById(n,i);return a!==null?n[a]:null}_getTerminalObjectIndexById(n,i){let a=null;return n.some((p,h)=>p._id===i?(a=h,!0):!1),a}getEnvironmentVariableCollection(n){let i=this._environmentVariableCollections.get(n.identifier.value);return i||(i=new d,this._setEnvironmentVariableCollection(n.identifier.value,i)),i}_syncEnvironmentVariableCollection(n,i){const a=I.serializeEnvironmentVariableCollection(i.map);this._proxy.$setEnvironmentVariableCollection(n,i.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(n){n.forEach(i=>{const a=i[0],p=new d(i[1]);this._setEnvironmentVariableCollection(a,p)})}$acceptDefaultProfile(n,i){this._defaultProfile=n,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(n,i){this._environmentVariableCollections.set(n,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,i)})}};u=Ve([He(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class d{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new v.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Replace})}append(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Append})}prepend(n,i){this._setIfDiffers(n,{value:i,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,i){const a=this.map.get(n);(!a||a.value!==i.value||a.type!==i.type)&&(this.map.set(n,i),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,i){this.map.forEach((a,p)=>n.call(i,p,a,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let f=class extends u{constructor(n){super(!1,n)}createTerminal(n,i,a){throw new s.NotSupportedError}createTerminalFromOptions(n,i){throw new s.NotSupportedError}};f=Ve([He(0,A.IExtHostRpcService)],f),e.WorkerExtHostTerminalService=f;function t(r){if(!!r)return"id"in r?{id:r.id,color:r.color}:r}}),define(ge[234],pe([0,1,3,17,5,123,18,7]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(s,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new v.Emitter,this._onDidChangeTextEditorOptions=new v.Emitter,this._onDidChangeTextEditorVisibleRanges=new v.Emitter,this._onDidChangeTextEditorViewColumn=new v.Emitter,this._onDidChangeActiveTextEditor=new v.Emitter,this._onDidChangeVisibleTextEditors=new v.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=s.getProxy(k.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(s){const I=this._extHostDocumentsAndEditors.allEditors();return s?I:I.map(l=>l.value)}async showTextDocument(s,I,l){let g;typeof I=="number"?g={position:A.ViewColumn.from(I),preserveFocus:l}:typeof I=="object"?g={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:g={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(s.uri,g),m=c&&this._extHostDocumentsAndEditors.getEditor(c);if(m)return m.value;throw c?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}createTextEditorDecorationType(s,I){return new S.TextEditorDecorationType(this._proxy,s,I).value}$acceptEditorPropertiesChanged(s,I){const l=this._extHostDocumentsAndEditors.getEditor(s);if(!l)throw new Error("unknown text editor");if(I.options&&l._acceptOptions(I.options),I.selections){const g=I.selections.selections.map(A.Selection.to);l._acceptSelections(g)}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(g)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const g=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:g})}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:g})}}$acceptEditorPositionData(s){for(const I in s){const l=this._extHostDocumentsAndEditors.getEditor(I);if(!l)throw new Error("Unknown text editor");const g=A.ViewColumn.to(s[I]);l.value.viewColumn!==g&&(l._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:g}))}}getDiffInformation(s){return Promise.resolve(this._proxy.$getDiffInformation(s))}}e.ExtHostEditors=D});var wn=this&&this.__rest||function(X,e){var v={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(v[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(X);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(X,R[k])&&(v[R[k]]=X[R[k]]);return v};define(ge[235],pe([0,1,2,4,5,6,7]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class C{constructor(s,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=s.getProxy(k.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:l=>{var g,c;if(l&&l.$mid===11){const m=l.uri===void 0?void 0:v.URI.revive(l.uri);return(c=(g=this._itemsBySourceAndUriMap.get(l.source))===null||g===void 0?void 0:g.get(D(m)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(s,I,l,g,c){const m=this._providers.get(s);return m==null?void 0:m.provideTimeline(v.URI.revive(I),l,g,c)}registerTimelineProvider(s,I,l,g){const c=new S.DisposableStore,m=this.convertTimelineItem(I.id,g,c).bind(this);let _;I.onDidChange&&(_=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:s,onDidChange:void 0,async provideTimeline(E,u,d,f){var t;(f==null?void 0:f.resetCache)&&(c.clear(),(t=w.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(E,u,d);if(r==null)return;const n=m(E,f);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(n)})},dispose(){var E;for(const u of w.values())(E=u.get(I.id))===null||E===void 0||E.clear();_==null||_.dispose(),c.dispose()}}))}convertTimelineItem(s,I,l){return(g,c)=>{let m;if(c==null?void 0:c.cacheResults){let _=this._itemsBySourceAndUriMap.get(s);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(s,_));const w=D(g);m=_.get(w),m===void 0&&(m=new Map,_.set(w,m))}return _=>{var w,E;const{iconPath:u}=_,d=wn(_,["iconPath"]),f=`${s}|${(w=_.id)!==null&&w!==void 0?w:_.timestamp}`;m==null||m.set(f,_);let t,r,n;return _.iconPath&&(u instanceof A.ThemeIcon?n={id:u.id}:v.URI.isUri(u)?(t=u,r=u):{light:t,dark:r}=u),Object.assign(Object.assign({},d),{id:(E=d.id)!==null&&E!==void 0?E:void 0,handle:f,source:s,command:_.command?I.toInternal(_.command,l):void 0,icon:t,iconDark:r,themeIcon:n,accessibilityInformation:_.accessibilityInformation})}}}registerTimelineProviderCore(s){if(this._providers.get(s.id))throw new Error(`Timeline Provider ${s.id} already exists.`);return this._proxy.$registerTimelineProvider({id:s.id,label:s.label,scheme:s.scheme}),this._providers.set(s.id,s),S.toDisposable(()=>{var l;for(const g of this._itemsBySourceAndUriMap.values())(l=g.get(s.id))===null||l===void 0||l.clear();this._providers.delete(s.id),this._proxy.$unregisterTimelineProvider(s.id),s.dispose()})}}e.ExtHostTimeline=C;function D(P){return P==null?void 0:P.toString()}}),define(ge[236],pe([0,1,6,10,2,5]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this._openers=new Map,this._proxy=D.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,s,I){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const l=I.schemes.find(g=>!A.supportedSchemes.has(g));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,s),this._proxy.$registerUriOpener(P,I.schemes,D,I.label),v.toDisposable(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const l=k.URI.revive(P);return I.canOpenExternalUri(l,s)}async $openUri(D,P,s){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(k.URI.revive(P.resolvedUri),{sourceUri:k.URI.revive(P.sourceUri)},s)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(ge[237],pe([0,1,5,2,6,16,26]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(v.MainContext.MainThreadUrls)}registerUriHandler(P,s){if(this.handles.has(A.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const I=C.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(P)),this.handlers.set(I,s),this._proxy.$registerUriHandler(I,P),k.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(P)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(P,s){const I=this.handlers.get(P);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(s))}catch(l){S.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(P){return R.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[63],pe([0,1,3,2,172,193,84,5]),function(X,e,v,R,k,S,A,C){"use strict";var D,P,s,I,l,g,c,m,_,w,E,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(h,b,y,o,L,O,W){D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),g.set(this,void 0),c.set(this,""),m.set(this,void 0),_.set(this,!1),w.set(this,!1),E.set(this,!1),this._onMessageEmitter=new v.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new v.Emitter),this._onDidDispose=$e(this,u,"f").event,tt(this,D,h,"f"),tt(this,P,b,"f"),tt(this,m,y,"f"),tt(this,I,o,"f"),tt(this,l,L,"f"),tt(this,g,O,"f"),tt(this,E,f(O),"f"),tt(this,s,W,"f")}dispose(){tt(this,_,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return tt(this,w,!0,"f"),A.asWebviewUri(h,$e(this,I,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,c,"f")}set html(h){this.assertNotDisposed(),$e(this,c,"f")!==h&&(tt(this,c,h,"f"),!$e(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(tt(this,w,!0,"f"),$e(this,s,"f").report("Webview vscode-resource: uris",$e(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,P,"f").$setHtml($e(this,D,"f"),h))}get options(){return this.assertNotDisposed(),$e(this,m,"f")}set options(h){this.assertNotDisposed(),$e(this,P,"f").$setOptions($e(this,D,"f"),n($e(this,g,"f"),$e(this,l,"f"),h)),tt(this,m,h,"f")}async postMessage(h){if($e(this,_,"f"))return!1;const b=S.serializeWebviewMessage(h,{serializeBuffersForPostMessage:$e(this,E,"f")});return $e(this,P,"f").$postMessage($e(this,D,"f"),b.message,...b.buffers)}assertNotDisposed(){if($e(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,m=new WeakMap,_=new WeakMap,w=new WeakMap,E=new WeakMap,u=new WeakMap;function f(p){try{const h=k.normalizeVersion(k.parseVersion(p.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch(h){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(h,b,y,o,L){this.initData=b,this.workspace=y,this._logService=o,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=h.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(h,b,...y){const o=this.getWebview(h);if(o){const{message:L}=S.deserializeWebviewMessage(b,y);o._onMessageEmitter.fire(L)}}$onMissingCsp(h,b){this._logService.warn(`${b} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,b,y){const o=new d(h,this._webviewProxy,i(b),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(h,o),o._onDidDispose(()=>{this._webviews.delete(h)}),o}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=t;function r(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=r;function n(p,h,b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots||a(p,h)}}e.serializeWebviewOptions=n;function i(p){var h;return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:(h=p.localResourceRoots)===null||h===void 0?void 0:h.map(b=>R.URI.from(b))}}e.reviveOptions=i;function a(p,h){return[...((h==null?void 0:h.getWorkspaceFolders())||[]).map(b=>b.uri),p.extensionLocation]}}),define(ge[238],pe([0,1,21,74,6,10,24,2,18,63,82,5,7]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new s.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,n){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const a=new g(r,n);return this._documents.set(i,a),a}delete(t,r){const n=this.key(t,r.uri);this._documents.delete(n)}key(t,r){return`${t}@@@${r}`}}var m;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(m||(m={}));class _{constructor(){this._providers=new Map}addTextProvider(t,r,n){return this.add(0,t,r,n)}addCustomProvider(t,r,n){return this.add(1,t,r,n)}get(t){return this._providers.get(t)}add(t,r,n,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:n,provider:i}),new l.Disposable(()=>this._providers.delete(r))}}class w{constructor(t,r,n,i,a){this._extHostDocuments=r,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=a,this._editorProviders=new _,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,n,i){const a=new k.DisposableStore;return E(n)?(a.add(this._editorProviders.addTextProvider(r,t,n)),this._proxy.$registerTextEditorProvider(P.toExtensionData(t),r,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},P.shouldSerializeBuffersForPostMessage(t))):(a.add(this._editorProviders.addCustomProvider(r,t,n)),this.supportEditing(n)&&a.add(n.onDidChangeCustomDocument(p=>{const h=this.getCustomDocumentEntry(r,p.document.uri);if(u(p)){const b=h.addEdit(p);this._proxy.$onDidEdit(p.document.uri,r,b,p.label)}else this._proxy.$onContentChange(p.document.uri,r)})),this._proxy.$registerCustomEditorProvider(P.toExtensionData(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,P.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(a,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,n,i,a){var p;const h=this._editorProviders.get(r);if(!h)throw new Error(`No provider found for '${r}'`);if(h.type!==1)throw new Error(`Invalid provide type for '${r}'`);const b=C.URI.revive(t),y=await h.provider.openCustomDocument(b,{backupId:n,untitledDocumentData:i==null?void 0:i.buffer},a);let o;return this.supportEditing(h.provider)&&this._extensionStoragePaths&&(o=(p=this._extensionStoragePaths.workspaceValue(h.extension))!==null&&p!==void 0?p:this._extensionStoragePaths.globalValue(h.extension)),this._documents.add(r,y,o),{editable:this.supportEditing(h.provider)}}async $disposeCustomDocument(t,r){const n=this._editorProviders.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=C.URI.revive(t),{document:a}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,a),a.dispose()}async $resolveWebviewEditor(t,r,n,i,a,p){const h=this._editorProviders.get(n);if(!h)throw new Error(`No provider found for '${n}'`);const b=D.ViewColumn.to(a),y=this._extHostWebview.createNewWebview(r,i.webviewOptions,h.extension),o=this._extHostWebviewPanels.createNewWebviewPanel(r,n,i.title,b,i.panelOptions,y),L=C.URI.revive(t);switch(h.type){case 1:{const{document:O}=this.getCustomDocumentEntry(n,L);return h.provider.resolveCustomEditor(O,o,p)}case 0:{const O=this._extHostDocuments.getDocument(L);return h.provider.resolveCustomTextEditor(O,o,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,n){this.getCustomDocumentEntry(r,t).disposeEdits(n)}async $onMoveCustomEditor(t,r,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const p=C.URI.revive(r),h=this._extHostDocuments.getDocument(p);await i.provider.moveCustomTextEditor(h,a,v.CancellationToken.None)}async $undo(t,r,n,i){return this.getCustomDocumentEntry(r,t).undo(n,i)}async $redo(t,r,n,i){return this.getCustomDocumentEntry(r,t).redo(n,i)}async $revert(t,r,n){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(t,r,n){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(t,r,n,i){const a=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(a.document,C.URI.revive(n),i)}async $backup(t,r,n){const i=this.getCustomDocumentEntry(r,t),p=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(p),p.id}getCustomDocumentEntry(t,r){const n=this._documents.get(t,C.URI.revive(r));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(t){const r=this._editorProviders.get(t),n=r==null?void 0:r.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function E(f){return typeof f.resolveCustomTextEditor=="function"}function u(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function d(f){const t=f.scheme===S.Schemas.file||f.scheme===S.Schemas.untitled?f.fsPath:f.toString();return R.hash(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[239],pe([0,1,3,6,2,32,18,63,5,7]),function(X,e,v,R,k,S,A,C,D,P){"use strict";var s,I,l,g,c,m,_,w,E,u,d,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends R.Disposable{constructor(p,h,b,y,o,L,O){super();s.set(this,void 0),I.set(this,void 0),l.set(this,void 0),g.set(this,void 0),c.set(this,void 0),m.set(this,void 0),_.set(this,void 0),w.set(this,void 0),E.set(this,!0),u.set(this,!0),d.set(this,!1),f.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,f,"f").event,t.set(this,this._register(new v.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,tt(this,s,p,"f"),tt(this,I,h,"f"),tt(this,l,b,"f"),tt(this,c,L,"f"),tt(this,w,o,"f"),tt(this,m,y,"f"),tt(this,g,O,"f")}dispose(){$e(this,d,"f")||(tt(this,d,!0,"f"),$e(this,f,"f").fire(),$e(this,I,"f").$disposeWebview($e(this,s,"f")),$e(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,g,"f")}get viewType(){return this.assertNotDisposed(),$e(this,l,"f")}get title(){return this.assertNotDisposed(),$e(this,m,"f")}set title(p){this.assertNotDisposed(),$e(this,m,"f")!==p&&(tt(this,m,p,"f"),$e(this,I,"f").$setTitle($e(this,s,"f"),p))}get iconPath(){return this.assertNotDisposed(),$e(this,_,"f")}set iconPath(p){this.assertNotDisposed(),$e(this,_,"f")!==p&&(tt(this,_,p,"f"),$e(this,I,"f").$setIconPath($e(this,s,"f"),k.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return $e(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,w,"f")=="number"&&$e(this,w,"f")<0))return $e(this,w,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,E,"f")}_updateViewState(p){$e(this,d,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(tt(this,u,p.active,"f"),tt(this,E,p.visible,"f"),tt(this,w,p.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(p,h){this.assertNotDisposed(),$e(this,I,"f").$reveal($e(this,s,"f"),{viewColumn:p?A.ViewColumn.from(p):void 0,preserveFocus:!!h})}assertNotDisposed(){if($e(this,d,"f"))throw new Error("Webview is disposed")}}s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,m=new WeakMap,_=new WeakMap,w=new WeakMap,E=new WeakMap,u=new WeakMap,d=new WeakMap,f=new WeakMap,t=new WeakMap;class n{constructor(p,h,b){this.webviews=h,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return S.generateUuid()}createWebviewPanel(p,h,b,y,o={}){const L=typeof y=="object"?y.viewColumn:y,O={viewColumn:A.ViewColumn.from(L),preserveFocus:typeof y=="object"&&!!y.preserveFocus},W=C.shouldSerializeBuffersForPostMessage(p),ee=n.newHandle();this._proxy.$createWebviewPanel(C.toExtensionData(p),ee,h,{title:b,panelOptions:i(o),webviewOptions:C.serializeWebviewOptions(p,this.workspace,o),serializeBuffersForPostMessage:W},O);const ce=this.webviews.createNewWebview(ee,o,p);return this.createNewWebviewPanel(ee,h,b,L,o,ce)}$onDidChangeWebviewPanelViewStates(p){const h=Object.keys(p);h.sort((b,y)=>{const o=p[b],L=p[y];return o.active?1:L.active?-1:+o.visible-+L.visible});for(const b of h){const y=this.getWebviewPanel(b);if(!y)continue;const o=p[b];y._updateViewState({active:o.active,visible:o.visible,viewColumn:A.ViewColumn.to(o.position)})}}async $onDidDisposeWebviewPanel(p){const h=this.getWebviewPanel(p);h==null||h.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,h,b){if(this._serializers.has(h))throw new Error(`Serializer for '${h}' already registered`);return this._serializers.set(h,{serializer:b,extension:p}),this._proxy.$registerSerializer(h,{serializeBuffersForPostMessage:C.shouldSerializeBuffersForPostMessage(p)}),new P.Disposable(()=>{this._serializers.delete(h),this._proxy.$unregisterSerializer(h)})}async $deserializeWebviewPanel(p,h,b,y){const o=this._serializers.get(h);if(!o)throw new Error(`No serializer found for '${h}'`);const{serializer:L,extension:O}=o,W=this.webviews.createNewWebview(p,b.webviewOptions,O),ee=this.createNewWebviewPanel(p,h,b.title,y,b.panelOptions,W);await L.deserializeWebviewPanel(ee,b.state)}createNewWebviewPanel(p,h,b,y,o,L){const O=new r(p,this._proxy,h,b,y,o,L);return this._webviewPanels.set(p,O),O}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=n;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[240],pe([0,1,3,6,63,5,7]),function(X,e,v,R,k,S,A){"use strict";var C,D,P,s,I,l,g,c,m,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends R.Disposable{constructor(d,f,t,r,n,i){super();C.set(this,void 0),D.set(this,void 0),P.set(this,void 0),s.set(this,void 0),I.set(this,!1),l.set(this,void 0),g.set(this,void 0),c.set(this,void 0),m.set(this,this._register(new v.Emitter)),this.onDidChangeVisibility=$e(this,m,"f").event,_.set(this,this._register(new v.Emitter)),this.onDidDispose=$e(this,_,"f").event,tt(this,P,t,"f"),tt(this,g,r,"f"),tt(this,C,d,"f"),tt(this,D,f,"f"),tt(this,s,n,"f"),tt(this,l,i,"f")}dispose(){$e(this,I,"f")||(tt(this,I,!0,"f"),$e(this,_,"f").fire(),$e(this,s,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,g,"f")}set title(d){this.assertNotDisposed(),$e(this,g,"f")!==d&&(tt(this,g,d,"f"),$e(this,D,"f").$setWebviewViewTitle($e(this,C,"f"),d))}get description(){return this.assertNotDisposed(),$e(this,c,"f")}set description(d){this.assertNotDisposed(),$e(this,c,"f")!==d&&(tt(this,c,d,"f"),$e(this,D,"f").$setWebviewViewDescription($e(this,C,"f"),d))}get visible(){return $e(this,l,"f")}get webview(){return $e(this,s,"f")}get viewType(){return $e(this,P,"f")}_setVisible(d){d===$e(this,l,"f")||$e(this,I,"f")||(tt(this,l,d,"f"),$e(this,m,"f").fire())}show(d){this.assertNotDisposed(),$e(this,D,"f").$show($e(this,C,"f"),!!d)}assertNotDisposed(){if($e(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,P=new WeakMap,s=new WeakMap,I=new WeakMap,l=new WeakMap,g=new WeakMap,c=new WeakMap,m=new WeakMap,_=new WeakMap;class E{constructor(d,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,f,t,r){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider(k.toExtensionData(d),f,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(d,f,t,r,n){const i=this._viewProviders.get(f);if(!i)throw new Error(`No view provider found for '${f}'`);const{provider:a,extension:p}=i,h=this._extHostWebview.createNewWebview(d,{},p),b=new w(d,this._proxy,f,t,h,!0);this._webviewViews.set(d,b),await a.resolveWebviewView(b,{state:r},n)}async $onDidChangeWebviewViewVisibility(d,f){this.getWebviewView(d)._setVisible(f)}async $disposeWebviewView(d){const f=this.getWebviewView(d);this._webviewViews.delete(d),f.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const f=this._webviewViews.get(d);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=E}),define(ge[126],pe([0,1,3,5,2,10,8,4,12]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Mn{constructor(I){this._onDidChangeWindowState=new v.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Mn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,l){let g;if(typeof I=="string"){g=I;try{I=k.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return A.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,g,l)}async asExternalUri(I,l){if(A.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(I,l);return k.URI.from(g)}};P.InitialState={focused:!0},P=Ve([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=C.createDecorator("IExtHostWindow")}),define(ge[241],pe([0,1,9,99,32,47,6,5,2,12]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let s=class extends A.Disposable{constructor(l,g){super();const c=l.getProxy(C.MainContext.MainThreadDownloadService);g.registerCommand(!1,"_workbench.downloadResource",async m=>{const _=D.URI.file(v.join(R.tmpdir(),k.generateUuid()));return await c.$download(m,_),_})}};s=Ve([He(0,P.IExtHostRpcService),He(1,S.IExtHostCommands)],s),e.ExtHostDownloadService=s}),define(ge[242],pe([0,1,2,9,146,28,62,27,12,6,15,111,42]),function(X,e,v,R,k,S,A,C,D,P,s,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class g{constructor(w,E,u){this.name=w,this.file=E,this.appender=u}static async create(w,E){const u=await I.createRotatingLogger(w,E,30*l.ByteSize.MB,1);return u.clearFormatters(),new g(w,E,u)}append(w){this.appender.critical(w)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(w,E,u){super(w,!1,v.URI.file(E.file),u);this._appender=E}append(w){super.append(w),this._appender.append(w),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(w,E){this._appender.flush(),super.show(w,E)}clear(){this._appender.flush(),super.clear()}}let m=class extends A.ExtHostOutputService{constructor(w,E,u){super(w);this.logService=E,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new P.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(w){if(w){const E=this._channels.get(w);E&&(this._visibleChannelDisposable.value=E.onDidAppend(()=>E.update()))}}createOutputChannel(w){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const E=this._doCreateOutChannel(w);return E.then(u=>u._id.then(d=>this._channels.set(d,u))),new A.LazyOutputChannel(w,E)}async _doCreateOutChannel(w){try{const E=R.join(this._logsLocation.fsPath,`output_logging_${k.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(E)||await S.Promises.mkdir(E,{recursive:!0});const d=`${this._namePool++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}`,f=v.URI.file(R.join(E,`${d}.log`)),t=await g.create(d,f.fsPath);return new c(w,t,this._proxy)}catch(E){return this.logService.error(E),new A.ExtHostPushOutputChannel(w,this._proxy)}}};m=Ve([He(0,D.IExtHostRpcService),He(1,s.ILogService),He(2,C.IExtHostInitDataService)],m),e.ExtHostOutputService2=m}),define(ge[243],pe([0,1,32,12,33]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends k.BaseExtHostTerminalService{constructor(C){super(!0,C)}createTerminal(C,D,P){return this.createTerminalFromOptions({name:C,shellPath:D,shellArgs:P})}createTerminalFromOptions(C,D){const P=new k.ExtHostTerminal(this._proxy,v.generateUuid(),C,C.name);return this._terminals.push(P),P.create(C,D),P.value}};S=Ve([He(0,R.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(ge[244],pe([0,1,5,12,6,27,2,38,24,28,7,11,46,3,73,15]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class _{constructor(p,h,b){this.remoteAddress=p,this.localAddress=h,this._dispose=b,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(a){const p=a.trim().split(`
`),h=[];return p.forEach(y=>{const o=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(y);o&&o.length>=3&&h.push({pid:parseInt(o[1],10),socket:parseInt(o[2],10)})}),h.reduce((y,o)=>(y[o.socket]=o,y),{})}e.getSockets=w;function E(...a){const p=[].concat(...a.map(d));return[...new Map(p.filter(h=>h.st==="0A").map(h=>{const b=h.local_address.split(":");return{socket:parseInt(h.inode,10),ip:u(b[0]),port:parseInt(b[1],16)}}).map(h=>[h.ip+":"+h.port,h])).values()]}e.loadListeningPorts=E;function u(a){let p="";if(a.length===8)for(let h=a.length-2;h>=0;h-=2)p+=parseInt(a.substr(h,2),16),h!==0&&(p+=".");else for(let h=a.length-4;h>=0;h-=4)p+=parseInt(a.substr(h,4),16).toString(16),h!==0&&(p+=":");return p}e.parseIpAddress=u;function d(a){const p=a.trim().split(`
`),h=p.shift().trim().split(/\s+/).filter(y=>y!=="rx_queue"&&y!=="tm->when");return p.map(y=>y.trim().split(/\s+/).reduce((o,L,O)=>(o[h[O]||O]=L,o),{}))}e.loadConnectionTable=d;function f(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function t(a){const p=a.trim().split(`
`),h=[];return p.forEach(b=>{const y=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(b);y&&y.length>=4&&h.push({pid:parseInt(y[1],10),ppid:parseInt(y[2]),cmd:y[3]})}),h}e.getRootProcesses=t;async function r(a,p,h){const b=h.reduce((o,L)=>(o[L.pid]=L,o),{}),y=[];return a.forEach(({socket:o,ip:L,port:O})=>{var W;const ee=p[o]?p[o].pid:void 0,ce=ee?(W=b[ee])===null||W===void 0?void 0:W.cmd:void 0;ee&&ce&&!f(ce)&&y.push({host:L,port:O,detail:ce,pid:ee})}),y}e.findPorts=r;function n(a,p,h){const b=new Map,y=t(p);for(const o of a){const L=h.get(o.port);if(L){b.set(o.port,L);continue}const O=y.find(W=>W.cmd.includes(`${o.port}`));if(O){let W=O,ee;do ee=y.find(ce=>ce.ppid===W.pid),ee&&(W=ee);while(ee);b.set(o.port,{host:o.ip,port:o.port,pid:W.pid,detail:W.cmd,ppid:W.ppid})}else b.set(o.port,{host:o.ip,port:o.port,ppid:Number.MAX_VALUE})}return b}e.tryFindRootPorts=n;let i=class extends k.Disposable{constructor(p,h,b){super();this.logService=b,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(v.MainContext.MainThreadTunnelService),I.isLinux&&h.remote.isRemote&&h.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,h){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const b=await this._proxy.$openTunnel(h,p.displayName);if(b){const y=new _(b.remoteAddress,b.localAddress,()=>this._proxy.$closeTunnel(b.remoteAddress));return this._register(y),y}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,h){const b=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(b,{selector:p,provider:h}),this._proxy.$registerPortsAttributesProvider(p,b),new s.Disposable(()=>{this._portAttributesProviders.delete(b),this._proxy.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(p,h,b,y,o){const L=[];for(const W of p){const ee=this._portAttributesProviders.get(W);if(!ee)return[];L.push(...await Promise.all(h.map(async ce=>ee.provider.providePortAttributes(ce,b,y,o))))}const O=L.filter(W=>!!W);return O.length>0?O.map(W=>({autoForwardAction:W.autoForwardAction,port:W.port})):[]}async $registerCandidateFinder(p){if(p&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=p;let h=new c.MovingAverage,b;for(;this._candidateFindingEnabled;){const y=new Date().getTime(),o=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${o.map(O=>O.port).join(", ")}`);const L=new Date().getTime()-y;h.update(L),(!b||JSON.stringify(b)!==JSON.stringify(o))&&(b=o,await this._proxy.$onFoundNewCandidates(b)),await new Promise(O=>setTimeout(()=>O(),this.calculateDelay(h.value)))}}async setTunnelExtensionFunctions(p){var h;return p?(p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter()),p.tunnelFactory&&(this._forwardPortProvider=p.tunnelFactory,this._proxy.$setTunnelProvider((h=p.tunnelFeatures)!==null&&h!==void 0?h:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,k.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,h){if(this._extensionTunnels.has(p.host)){const b=this._extensionTunnels.get(p.host);b.has(p.port)&&(h&&b.get(p.port).disposeListener.dispose(),await b.get(p.port).tunnel.dispose(),b.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,h){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this._forwardPortProvider(p,h);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const y=await b;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const o=this._register(y.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(y.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:y,disposeListener:o}),l.TunnelDto.fromApiTunnel(y)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const h=await Promise.all(p.map(y=>{var o;return this._showCandidatePort(y.host,y.port,(o=y.detail)!==null&&o!==void 0?o:"")})),b=p.filter((y,o)=>h[o]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(y=>y.port).join(", ")} to ${b.map(y=>y.port).join(", ")}`),b}async findCandidatePorts(){let p="",h="";try{p=await P.Promises.readFile("/proc/net/tcp","utf8"),h=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(x){}const b=E(p,h),y=await new Promise(x=>{C.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,T,N)=>{x(T)})}),o=w(y),L=await P.readdir("/proc"),O=[];for(let x of L)try{const V=Number(x),T=D.joinPath(A.URI.file("/proc"),x);if((await P.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(V)){const F=await P.Promises.readlink(D.joinPath(T,"cwd").fsPath),M=await P.Promises.readFile(D.joinPath(T,"cmdline").fsPath,"utf8");O.push({pid:V,cwd:F,cmd:M})}}catch(V){}const W=[],ee=b.filter(x=>{const V=o[x.socket];return V||W.push(x),V}),ce=r(ee,o,O);let G;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${W.length}`),W.length>0){const x=await new Promise(V=>{C.exec("ps -F -A -l | grep root",(T,N,F)=>{V(N)})});this._foundRootPorts=n(W,x,this._foundRootPorts),G=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.join(", ")}`)}return ce.then(x=>G?x.concat(G):x)}};i=Ve([He(0,R.IExtHostRpcService),He(1,S.IExtHostInitDataService),He(2,m.ILogService)],i),e.ExtHostTunnelService=i}),define(ge[245],pe([0,1,14,21,16,3,6,97,213,124,22]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(i,a){try{return JSON.stringify(i,a)}catch(p){return"null"}}function g(i,a){return JSON.stringify(i,a)}function c(i){return i?(a,p)=>p&&p.$mid===1?i.transformOutgoing(p):p:null}var m;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},E=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(a,p=null,h=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=p,this._uriTransformer=h,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let b=0,y=P.ProxyIdentifier.count;b<y;b++)this._locals[b]=null,this._proxies[b]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new v.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(b=>this._receiveOneMessage(b))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(k.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?C.transformIncomingURIs(a,this._uriTransformer):a}getProxy(a){const{nid:p,sid:h}=a;return this._proxies[p]||(this._proxies[p]=this._createProxy(p,h)),this._proxies[p]}_createProxy(a,p){let h={get:(b,y)=>(typeof y=="string"&&!b[y]&&y.charCodeAt(0)===36&&(b[y]=(...o)=>this._remoteCall(a,y,o)),y===u?p:b[y])};return new Proxy(Object.create(null),h)}set(a,p){return this._locals[a.nid]=p,p}assertRegistered(a){for(let p=0,h=a.length;p<h;p++){const b=a[p];if(!this._locals[b.nid])throw new Error(`Missing actor ${b.sid} (isMain: ${b.isMain})`)}}_receiveOneMessage(a){if(this._isDisposed)return;const p=a.byteLength,h=f.read(a,0),b=h.readUInt8(),y=h.readUInt32();switch(b){case 1:case 2:{let{rpcId:o,method:L,args:O}=t.deserializeRequestJSONArgs(h);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(p,y,o,L,O,b===2);break}case 3:case 4:{let{rpcId:o,method:L,args:O}=t.deserializeRequestMixedArgs(h);this._uriTransformer&&(O=C.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(p,y,o,L,O,b===4);break}case 5:{this._logger&&this._logger.logIncoming(p,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(p,y);break}case 7:{this._receiveReply(p,y,void 0);break}case 9:{let o=t.deserializeReplyOKJSON(h);this._uriTransformer&&(o=C.transformIncomingURIs(o,this._uriTransformer)),this._receiveReply(p,y,o);break}case 8:{let o=t.deserializeReplyOKVSBuffer(h);this._receiveReply(p,y,o);break}case 10:{let o=t.deserializeReplyErrError(h);this._uriTransformer&&(o=C.transformIncomingURIs(o,this._uriTransformer)),this._receiveReplyErr(p,y,o);break}case 11:{this._receiveReplyErr(p,y,void 0);break}default:console.error("received unexpected message"),console.error(a)}}_receiveRequest(a,p,h,b,y,o){this._logger&&this._logger.logIncoming(a,p,1,`receiveRequest ${P.getStringIdentifierForProxy(h)}.${b}(`,y);const L=String(p);let O,W;if(o){const ce=new R.CancellationTokenSource;y.push(ce.token),O=this._invokeHandler(h,b,y),W=()=>ce.cancel()}else O=this._invokeHandler(h,b,y),W=w;this._cancelInvokedHandlers[L]=W;const ee=t.serializeAcknowledged(p);this._logger&&this._logger.logOutgoing(ee.byteLength,p,1,"ack"),this._protocol.send(ee),O.then(ce=>{delete this._cancelInvokedHandlers[L];const G=t.serializeReplyOK(p,ce,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,p,1,"reply:",ce),this._protocol.send(G)},ce=>{delete this._cancelInvokedHandlers[L];const G=t.serializeReplyErr(p,ce);this._logger&&this._logger.logOutgoing(G.byteLength,p,1,"replyErr:",ce),this._protocol.send(G)})}_receiveCancel(a,p){this._logger&&this._logger.logIncoming(a,p,1,"receiveCancel");const h=String(p);this._cancelInvokedHandlers[h]&&this._cancelInvokedHandlers[h]()}_receiveReply(a,p,h){this._logger&&this._logger.logIncoming(a,p,0,"receiveReply:",h);const b=String(p);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const y=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b],y.resolveOk(h)}_receiveReplyErr(a,p,h){this._logger&&this._logger.logIncoming(a,p,0,"receiveReplyErr:",h);const b=String(p);if(!this._pendingRPCReplies.hasOwnProperty(b))return;const y=this._pendingRPCReplies[b];delete this._pendingRPCReplies[b];let o;h&&(h.$isError?(o=new Error,o.name=h.name,o.message=h.message,o.stack=h.stack):o=h),y.resolveErr(o)}_invokeHandler(a,p,h){try{return Promise.resolve(this._doInvokeHandler(a,p,h))}catch(b){return Promise.reject(b)}}_doInvokeHandler(a,p,h){const b=this._locals[a];if(!b)throw new Error("Unknown actor "+P.getStringIdentifierForProxy(a));let y=b[p];if(typeof y!="function")throw new Error("Unknown method "+p+" on actor "+P.getStringIdentifierForProxy(a));return y.apply(b,h)}_remoteCall(a,p,h){if(this._isDisposed)return Promise.reject(k.canceled());let b=null;if(h.length>0&&R.CancellationToken.isCancellationToken(h[h.length-1])&&(b=h.pop()),b&&b.isCancellationRequested)return Promise.reject(k.canceled());const y=t.serializeRequestArguments(h,this._uriReplacer),o=++this._lastMessageId,L=String(o),O=new D.LazyPromise;b&&b.onCancellationRequested(()=>{const ee=t.serializeCancel(o);this._logger&&this._logger.logOutgoing(ee.byteLength,o,0,"cancel"),this._protocol.send(t.serializeCancel(o))}),this._pendingRPCReplies[L]=O,this._onWillSendRequest(o);const W=t.serializeRequest(o,a,p,y,!!b);return this._logger&&this._logger.logOutgoing(W.byteLength,o,0,`request: ${P.getStringIdentifierForProxy(a)}.${p}(`,h),this._protocol.send(W),O}}e.RPCProtocol=d,I=E,d.UNRESPONSIVE_TIME=3*1e3;class f{constructor(a,p){this._buff=a,this._offset=p}static alloc(a,p,h){let b=new f(s.VSBuffer.alloc(h+1+4),0);return b.writeUInt8(a),b.writeUInt32(p),b}static read(a,p){return new f(a,p)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const h=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,h}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,h}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,p}static sizeMixedArray(a,p){let h=0;h+=1;for(let b=0,y=a.length;b<y;b++){const o=a[b],L=p[b];switch(h+=1,L){case 1:h+=this.sizeLongString(o);break;case 2:h+=this.sizeVSBuffer(o);break;case 3:break}}return h}writeMixedArray(a,p){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let h=0,b=a.length;h<b;h++){const y=a[h];switch(p[h]){case 1:this.writeUInt8(1),this.writeLongString(y);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let p=new Array(a);for(let h=0;h<a;h++)switch(this.readUInt8()){case 1:p[h]=this.readLongString();break;case 2:p[h]=this.readVSBuffer();break;case 3:p[h]=void 0;break}return p}}class t{static _arrayContainsBufferOrUndefined(a){for(let p=0,h=a.length;p<h;p++)if(a[p]instanceof s.VSBuffer||typeof a[p]=="undefined")return!0;return!1}static serializeRequestArguments(a,p){if(this._arrayContainsBufferOrUndefined(a)){let h=[],b=[];for(let y=0,o=a.length;y<o;y++){const L=a[y];L instanceof s.VSBuffer?(h[y]=L,b[y]=2):typeof L=="undefined"?(h[y]=s.VSBuffer.alloc(0),b[y]=3):(h[y]=s.VSBuffer.fromString(g(L,p)),b[y]=1)}return{type:"mixed",args:h,argsType:b}}return{type:"simple",args:g(a,p)}}static serializeRequest(a,p,h,b,y){return b.type==="mixed"?this._requestMixedArgs(a,p,h,b.args,b.argsType,y):this._requestJSONArgs(a,p,h,b.args,y)}static _requestJSONArgs(a,p,h,b,y){const o=s.VSBuffer.fromString(h),L=s.VSBuffer.fromString(b);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(o),O+=f.sizeLongString(L);let W=f.alloc(y?2:1,a,O);return W.writeUInt8(p),W.writeShortString(o),W.writeLongString(L),W.buffer}static deserializeRequestJSONArgs(a){const p=a.readUInt8(),h=a.readShortString(),b=a.readLongString();return{rpcId:p,method:h,args:JSON.parse(b)}}static _requestMixedArgs(a,p,h,b,y,o){const L=s.VSBuffer.fromString(h);let O=0;O+=f.sizeUInt8(),O+=f.sizeShortString(L),O+=f.sizeMixedArray(b,y);let W=f.alloc(o?4:3,a,O);return W.writeUInt8(p),W.writeShortString(L),W.writeMixedArray(b,y),W.buffer}static deserializeRequestMixedArgs(a){const p=a.readUInt8(),h=a.readShortString(),b=a.readMixedArray(),y=new Array(b.length);for(let o=0,L=b.length;o<L;o++){const O=b[o];typeof O=="string"?y[o]=JSON.parse(O):y[o]=O}return{rpcId:p,method:h,args:y}}static serializeAcknowledged(a){return f.alloc(5,a,0).buffer}static serializeCancel(a){return f.alloc(6,a,0).buffer}static serializeReplyOK(a,p,h){return typeof p=="undefined"?this._serializeReplyOKEmpty(a):p instanceof s.VSBuffer?this._serializeReplyOKVSBuffer(a,p):this._serializeReplyOKJSON(a,l(p,h))}static _serializeReplyOKEmpty(a){return f.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,p){let h=0;h+=f.sizeVSBuffer(p);let b=f.alloc(8,a,h);return b.writeVSBuffer(p),b.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,p){const h=s.VSBuffer.fromString(p);let b=0;b+=f.sizeLongString(h);let y=f.alloc(9,a,b);return y.writeLongString(h),y.buffer}static deserializeReplyOKJSON(a){const p=a.readLongString();return JSON.parse(p)}static serializeReplyErr(a,p){return p?this._serializeReplyErrEror(a,p):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,p){const h=s.VSBuffer.fromString(l(k.transformErrorForSerialization(p),null));let b=0;b+=f.sizeLongString(h);let y=f.alloc(10,a,b);return y.writeLongString(h),y.buffer}static deserializeReplyErrError(a){const p=a.readLongString();return JSON.parse(p)}static _serializeReplyErrEmpty(a){return f.alloc(11,a,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var n;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(n||(n={}))}),define(ge[246],pe([0,1,4]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=v.createDecorator("remoteAgentService")}),define(ge[247],pe([0,1,10,9,11,2,4,246]),function(X,e,v,R,k,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let D=class{constructor(s,I){this.localUserHome=s,this.remoteAgentService=I,this.resolveOS=(async()=>{const l=await this.remoteAgentService.getEnvironment();return(l==null?void 0:l.os)||k.OS})(),this.resolveUserHome=(async()=>{const l=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(l==null?void 0:l.userHome)||s})()}async userHome(s){return(s==null?void 0:s.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?R.win32:R.posix)}async fileURI(s){let I="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const g=s.indexOf("/",2);g===-1?(I=s.substring(2),s="/"):(I=s.substring(2,g),s=s.substring(g)||"/")}return S.URI.from({scheme:v.Schemas.file,authority:I,path:s,query:"",fragment:""})}};D=Ve([He(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(ge[64],pe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class v{constructor(A,C){this.line=A,this.character=C}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,C){return new v(0,0)}with(A){return new v(0,0)}}e.Position=v;class R{constructor(A,C,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new v(A,C),this.end=new v(D,P)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var k;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(k=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ge[31],pe([0,1,17,30,25,29,8,4,9,16,64]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return s.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",l=" characters skipped \u27EB",g=(I.length+l.length+5)*2;e.ISearchService=C.createDecorator("searchService");var c;(function(T){T[T.file=0]="file",T[T.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(T){T[T.File=1]="File",T[T.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function _(T){return!!T.preview}e.resultIsMatch=_;function w(T){return!!T.resource}e.isFileMatch=w;function E(T){return!!T.message}e.isProgressMessage=E;var u;(function(T){T[T.Normal=0]="Normal",T[T.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(N){this.resource=N,this.results=[]}}e.FileMatch=d;class f{constructor(N,F,M){this.ranges=F;const U=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(U)){N=A.getNLines(N,M.matchLines);let B="",K=0,ie=0;const we=Math.floor(M.charsPerLine/5),Te=[];for(const ye of U){const Oe=Math.max(ye.startColumn-we,0),je=ye.startColumn+M.charsPerLine;if(Oe>ie+we+g){const ze=I+(Oe-ie)+l;B+=ze+N.slice(Oe,je),K+=Oe-(ie+ze.length)}else B+=N.slice(ie,je);Te.push(new n(0,ye.startColumn-K,ye.endColumn-K)),ie=je}this.preview={text:B,matches:Array.isArray(this.ranges)?Te:Te[0]}}else{const B=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:N,matches:v.mapArrayOrNot(F,K=>new r(K.startLineNumber-B,K.startColumn,K.endLineNumber-B,K.endColumn))}}}}e.TextSearchMatch=f;function t(T){const N=T[0].startLineNumber;for(const F of T)if(F.startLineNumber!==N||F.endLineNumber!==N)return!1;return!0}class r{constructor(N,F,M,U){this.startLineNumber=N,this.startColumn=F,this.endLineNumber=M,this.endColumn=U}}e.SearchRange=r;class n extends r{constructor(N,F,M){super(N,F,N,M)}}e.OneLineRange=n;var i;(function(T){T.Default="default",T.FileNames="fileNames",T.Type="type",T.Modified="modified",T.CountDescending="countDescending",T.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function a(T,N=!0){const F=T&&T.files&&T.files.exclude,M=N&&T&&T.search&&T.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let U=Object.create(null);return U=k.mixin(U,k.deepClone(F)),U=k.mixin(U,k.deepClone(M),!0),U}e.getExcludes=a;function p(T,N){return T.excludePattern&&R.match(T.excludePattern,N)?!1:T.includePattern||T.usingSearchPaths?T.includePattern&&R.match(T.includePattern,N)?!0:T.usingSearchPaths?!!T.folderQueries&&T.folderQueries.some(F=>{const M=F.folder.fsPath;if(S.isEqualOrParent(N,M)){const U=D.relative(M,N);return!F.includePattern||!!R.match(F.includePattern,U)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var h;(function(T){T[T.unknownEncoding=1]="unknownEncoding",T[T.regexParseError=2]="regexParseError",T[T.globParseError=3]="globParseError",T[T.invalidLiteral=4]="invalidLiteral",T[T.rgProcessError=5]="rgProcessError",T[T.other=6]="other",T[T.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class b extends Error{constructor(N,F){super(N);this.code=F}}e.SearchError=b;function y(T){const N=T.message;if(P.isPromiseCanceledError(T))return new b(N,h.canceled);try{const F=JSON.parse(N);return new b(F.message,F.code)}catch(F){return new b(N,h.other)}}e.deserializeSearchError=y;function o(T){const N={message:T.message,code:T.code};return new Error(JSON.stringify(N))}e.serializeSearchError=o;function L(T){return T.type==="error"?!0:T.type==="success"}e.isSerializedSearchComplete=L;function O(T){return T.type==="success"}e.isSerializedSearchSuccess=O;function W(T){return!!T.path}e.isSerializedFileMatch=W;function ee(T,N){const F=T.searchPath?T.searchPath:T.relativePath;return A.fuzzyContains(F,N)}e.isFilePatternMatch=ee;class ce{constructor(N){this.path=N,this.results=[]}addMatch(N){this.results.push(N)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=ce;function G(T,N){const F=Object.assign(Object.assign({},T||{}),N||{});return Object.keys(F).filter(M=>{const U=F[M];return typeof U=="boolean"&&U})}e.resolvePatternsForProvider=G;class x{constructor(N,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},N.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=N.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(N,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(N,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(N,F,M))}includedInQuery(N,F,M){return Promise.resolve(this._parsedExcludeExpression(N,F,M)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(N,F,M)).then(K=>!!K):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=x;function V(T){for(const N in T)if(typeof T[N]!="boolean")return!0;return!1}}),define(ge[34],pe([0,1,17,14,21,3,23,10,73,24,8,13,2,164,4,15,181,57,58,27,12,7,31,5]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d,f,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(L,O,W){return new P.ExtUri(ee=>h(ee,W)).isEqual(L,O)}function i(L,O,W){return n(L.uri,O.uri,W)?0:s.compare(L.uri.toString(),O.uri.toString())}function a(L,O,W){return L.index!==O.index?L.index<O.index?-1:1:n(L.uri,O.uri,W)?s.compare(L.name,O.name):s.compare(L.uri.toString(),O.uri.toString())}function p(L,O,W,ee){const ce=L.slice(0).sort((x,V)=>W(x,V,ee)),G=O.slice(0).sort((x,V)=>W(x,V,ee));return v.delta(ce,G,(x,V)=>W(x,V,ee))}function h(L,O){const W=O.getCapabilities(L.scheme);return!(W&&W&1024)}class b extends w.Workspace{constructor(O,W,ee,ce,G,x){super(O,ee.map(V=>new w.WorkspaceFolder(V)),ce,x);this._name=W,this._isUntitled=G,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(x),ee.forEach(V=>{this._workspaceFolders.push(V),this._structure.set(V.uri,V)})}static toExtHostWorkspace(O,W,ee,ce){if(!O)return{workspace:null,added:[],removed:[]};const{id:G,name:x,folders:V,configuration:T,isUntitled:N}=O,F=[],M=W;W?V.forEach((ie,we)=>{const Te=l.URI.revive(ie.uri),ye=b._findFolder(ee||W,Te,ce);ye?(ye.name=ie.name,ye.index=ie.index,F.push(ye)):F.push({uri:Te,name:ie.name,index:we})}):F.push(...V.map(({uri:ie,name:we,index:Te})=>({uri:l.URI.revive(ie),name:we,index:Te}))),F.sort((ie,we)=>ie.index<we.index?-1:1);const U=new b(G,x,F,T?l.URI.revive(T):null,!!N,ie=>h(ie,ce)),{added:B,removed:K}=p(M?M.workspaceFolders:[],U.workspaceFolders,i,ce);return{workspace:U,added:B,removed:K}}static _findFolder(O,W,ee){for(let ce=0;ce<O.folders.length;ce++){const G=O.workspaceFolders[ce];if(n(G.uri,W,ee))return G}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,W){return W&&this._structure.get(O)&&(O=P.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let y=class{constructor(O,W,ee,ce){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=ce,this._extHostFileSystemInfo=ee,this._requestIdProvider=new D.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(r.MainContext.MainThreadMessageService);const G=W.workspace;this._confirmedWorkspace=G?new b(G.id,G.name,[],G.configuration?l.URI.revive(G.configuration):null,!!G.isUntitled,x=>h(x,ee)):void 0}$initializeWorkspace(O,W){this._trusted=W,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:C.Schemas.untitled,path:P.basename(P.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,W,ee,...ce){const G=[];if(Array.isArray(ce)&&ce.forEach(F=>{l.URI.isUri(F.uri)&&!G.some(M=>n(M.uri,F.uri,this._extHostFileSystemInfo))&&G.push({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[W,ee].some(F=>typeof F!="number"||F<0)||ee===0&&G.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(W+ee>x.length)return!1;const V=x.slice(0);V.splice(W,ee,...G.map(F=>({uri:F.uri,name:F.name||P.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<V.length;F++){const M=V[F];if(V.some((U,B)=>B!==F&&n(M.uri,U.uri,this._extHostFileSystemInfo)))return!1}V.forEach((F,M)=>F.index=M);const{added:T,removed:N}=p(x,V,a,this._extHostFileSystemInfo);if(T.length===0&&N.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,W,ee,G).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,g.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(O,W){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async getWorkspaceFolder2(O,W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,W)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,W){let ee,ce="";if(typeof O=="string"?(ee=l.URI.file(O),ce=O):typeof O!="undefined"&&(ee=O,ce=O.fsPath),!ee)return ce;const G=this.getWorkspaceFolder(ee,!0);if(!G)return ce;typeof W=="undefined"&&this._actualWorkspace&&(W=this._actualWorkspace.folders.length>1);let x=P.relativePath(G.uri,ee);return W&&G.name&&(x=`${G.name}/${x}`),x}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:W,added:ee,removed:ce}=b.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=W||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ee,removed:ce}))}findFiles(O,W,ee,ce,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${ce.value}, entryPoint: findFiles`);let x;if(W===null?x=!1:W&&(typeof W=="string"?x=W:x=W.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:T}=o(O);return this._proxy.$startFileSearch(I.withUndefinedAsNull(V),I.withUndefinedAsNull(T),I.withUndefinedAsNull(x),I.withUndefinedAsNull(ee),G).then(N=>Array.isArray(N)?N.map(F=>l.URI.revive(F)):[])}async findTextInFiles(O,W,ee,ce,G=k.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${ce.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),V=typeof W.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:T,folder:N}=o(W.include),F=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,M={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:V,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:T,excludePattern:F},U=!1;if(this._activeSearchCallbacks[x]=B=>{if(U)return;const K=l.URI.revive(B.resource);B.results.forEach(ie=>{t.resultIsMatch(ie)?ee({uri:K,preview:{text:ie.preview.text,matches:v.mapArrayOrNot(ie.preview.matches,we=>new f.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:v.mapArrayOrNot(ie.ranges,we=>new f.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):ee({uri:K,text:ie.text,lineNumber:ie.lineNumber})})},G.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(O,I.withUndefinedAsNull(N),M,x,G);return delete this._activeSearchCallbacks[x],B||{}}catch(B){throw delete this._activeSearchCallbacks[x],B}}$handleTextSearchResult(O,W){this._activeSearchCallbacks[W]&&this._activeSearchCallbacks[W](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ve([He(0,d.IExtHostRpcService),He(1,u.IExtHostInitDataService),He(2,E.IExtHostFileSystemInfo),He(3,m.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function o(L){let O,W;return L&&(typeof L=="string"?O=L:(O=L.pattern,W=L.baseFolder||l.URI.file(L.base))),{includePattern:O,folder:W}}}),define(ge[36],pe([0,1,25,3,34,5,7,185,81,13,14,4,12,15,2]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(r,n){if(n){const i=n.split(".");let a=r;for(let p=0;a&&p<i.length;p++)a=a[i[p]];return a}}function _(r){return r instanceof c.URI}function w(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function E(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function u(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function d(r){if(_(r))return{resource:r};if(w(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(E(r))return{overrideIdentifier:r.languageId};if(u(r))return{resource:r.uri};if(r===null)return{resource:null}}let f=class{constructor(n,i,a){this._proxy=n.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new s.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new t(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(n,i))}};f=Ve([He(0,l.IExtHostRpcService),He(1,k.IExtHostWorkspace),He(2,g.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(n,i,a,p){this._onDidChangeConfiguration=new R.Emitter,this._proxy=n,this._logService=p,this._extHostWorkspace=i,this._configuration=C.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(n,i,a){const p=d(i)||{},h=this._toReadonlyValue(n?m(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,p,a==null?void 0:a.identifier);function b(o){if(o==null)return null;if(typeof o=="boolean")return o?1:4;switch(o){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(o){return typeof m(h,o)!="undefined"},get:(o,L)=>{this._validateConfigurationAccess(n?`${n}.${o}`:o,p,a==null?void 0:a.identifier);let O=m(h,o);if(typeof O=="undefined")O=L;else{let W;const ee=(ce,G)=>{let x;const V=()=>{W=W||v.deepClone(h),x=x||m(W,G)};return P.isObject(ce)?new Proxy(ce,{get:(T,N)=>{if(typeof N=="string"&&N.toLowerCase()==="tojson")return V(),()=>x;if(W)return x=x||m(W,G),x[N];const F=T[N];return typeof N=="string"?ee(F,`${G}.${N}`):F},set:(T,N,F)=>(V(),x&&(x[N]=F),!0),deleteProperty:(T,N)=>(V(),x&&delete x[N],!0),defineProperty:(T,N,F)=>(V(),x&&Object.defineProperty(x,N,F),!0)}):ce};O=ee(O,o)}return O},update:(o,L,O,W)=>{o=n?`${n}.${o}`:o;const ee=b(O);return L!==void 0?this._proxy.$updateConfigurationOption(ee,o,L,p,W):this._proxy.$removeConfigurationOption(ee,o,p,W)},inspect:o=>{var L,O,W,ee,ce,G,x,V;o=n?`${n}.${o}`:o;const T=v.deepClone(this._configuration.inspect(o,p,this._extHostWorkspace.workspace));if(T)return{key:o,defaultValue:(L=T.default)===null||L===void 0?void 0:L.value,globalValue:(O=T.user)===null||O===void 0?void 0:O.value,workspaceValue:(W=T.workspace)===null||W===void 0?void 0:W.value,workspaceFolderValue:(ee=T.workspaceFolder)===null||ee===void 0?void 0:ee.value,defaultLanguageValue:(ce=T.default)===null||ce===void 0?void 0:ce.override,globalLanguageValue:(G=T.user)===null||G===void 0?void 0:G.override,workspaceLanguageValue:(x=T.workspace)===null||x===void 0?void 0:x.override,workspaceFolderLanguageValue:(V=T.workspaceFolder)===null||V===void 0?void 0:V.override,languageIds:T.overrideIdentifiers}}};return typeof h=="object"&&v.mixin(y,h,!1),Object.freeze(y)}_toReadonlyValue(n){const i=a=>P.isObject(a)?new Proxy(a,{get:(p,h)=>i(p[h]),set:(p,h,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(h)}' of object`)},deleteProperty:(p,h)=>{throw new Error(`TypeError: Cannot delete read only property '${String(h)}' of object`)},defineProperty:(p,h)=>{throw new Error(`TypeError: Cannot define property '${String(h)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(n)}_validateConfigurationAccess(n,i,a){const p=D.OVERRIDE_PROPERTY_PATTERN.test(n)?4:this._configurationScopes.get(n),h=a?`[${a.value}] `:"";if(p===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${h}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){(i==null?void 0:i.resource)&&this._logService.warn(`${h}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const a=new C.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,h)=>a.affectsConfiguration(p,d(h))})}_toMap(n){return n.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[65],pe([0,1,2,14,3,5,7,34,39,36,21,33,12,27,4,10,11,15,61,198,16]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(ce){function G(V){if(V!=null)return V}ce.from=G;function x(V){if(V!=null)return V}ce.to=x})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(ce){function G(V){if(V!=null)return V}ce.from=G;function x(V){if(V!=null)return V}ce.to=x})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(ce){function G(V){if(V!=null)return V}ce.from=G;function x(V){if(V!=null)return V}ce.to=x})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(ce){function G(T){if(T){const N=T;return N&&!!N.process}else return!1}ce.is=G;function x(T){if(T==null)return;const N={process:T.process,args:T.args};return T.options&&(N.options=n.from(T.options)),N}ce.from=x;function V(T){if(T!=null)return new A.ProcessExecution(T.process,T.args,T.options)}ce.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(ce){function G(V){if(V!=null)return V}ce.from=G;function x(V){if(V!=null)return V}ce.to=x})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var p;(function(ce){function G(T){if(T){const N=T;return N&&(!!N.commandLine||!!N.command)}else return!1}ce.is=G;function x(T){if(T==null)return;const N={};return T.commandLine!==void 0?N.commandLine=T.commandLine:(N.command=T.command,N.args=T.args),T.options&&(N.options=a.from(T.options)),N}ce.from=x;function V(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new A.ShellExecution(T.commandLine,T.options):new A.ShellExecution(T.command,T.args?T.args:[],T.options)}ce.to=V})(p=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var h;(function(ce){function G(T){if(T){let N=T;return N&&N.customExecution==="customExecution"}else return!1}ce.is=G;function x(T){return{customExecution:"customExecution"}}ce.from=x;function V(T,N){return N.get(T)}ce.to=V})(h=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(ce){function G(x,V){let T;return x.scope!==void 0&&typeof x.scope!="number"?T=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===A.TaskScope.Workspace&&V&&V.workspaceFile?T=V.workspaceFile:T=u.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:T}}ce.from=G})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(ce){function G(T,N){if(T==null)return[];const F=[];for(let M of T){const U=x(M,N);U&&F.push(U)}return F}ce.fromMany=G;function x(T,N){if(T==null)return;let F;T.execution instanceof A.ProcessExecution?F=i.from(T.execution):T.execution instanceof A.ShellExecution?F=p.from(T.execution):T.execution&&T.execution instanceof A.CustomExecution&&(F=h.from(T.execution));const M=t.from(T.definition);let U;if(T.scope?typeof T.scope=="number"?U=T.scope:U=T.scope.uri:U=A.TaskScope.Workspace,!M||!U)return;const B=T.group?T.group.id:void 0;return{_id:T._id,definition:M,name:T.name,source:{extensionId:N.identifier.value,label:T.source,scope:U},execution:F,isBackground:T.isBackground,group:B,presentationOptions:r.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}ce.from=x;async function V(T,N,F){if(T==null)return;let M;i.is(T.execution)?M=i.to(T.execution):p.is(T.execution)?M=p.to(T.execution):h.is(T.execution)&&(M=h.to(T._id,F));const U=t.to(T.definition);let B;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?B=T.source.scope:B=await N.resolveWorkspaceFolder(v.URI.revive(T.source.scope)):B=A.TaskScope.Workspace),!U||!B)return;const K=new A.Task(U,B,T.name,T.source.label,M,T.problemMatchers);return T.isBackground!==void 0&&(K.isBackground=T.isBackground),T.group!==void 0&&(K.group=A.TaskGroup.from(T.group)),T.presentationOptions&&(K.presentationOptions=r.to(T.presentationOptions)),T._id&&(K._id=T._id),T.detail&&(K.detail=T.detail),K}ce.to=V})(y=e.TaskDTO||(e.TaskDTO={}));var o;(function(ce){function G(V){return V}ce.from=G;function x(V){if(!!V)return Object.assign(Object.create(null),V)}ce.to=x})(o=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(G,x,V){this._id=x,this._task=V,f.set(this,void 0),tt(this,f,G,"f")}get task(){return this._task}terminate(){$e(this,f,"f").terminateTask(this)}fireDidStartProcess(G){}fireDidEndProcess(G){}}f=new WeakMap;var O;(function(ce){function G(x){return{id:x._id,task:void 0}}ce.from=G})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let W=class{constructor(G,x,V,T,N,F,M,U){this._onDidExecuteTask=new k.Emitter,this._onDidTerminateTask=new k.Emitter,this._onDidTaskProcessStarted=new k.Emitter,this._onDidTaskProcessEnded=new k.Emitter,this._proxy=G.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=T,this._configurationService=N,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=U,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(G,x,V){if(!V)return new A.Disposable(()=>{});const T=this.nextHandle();return this._handlers.set(T,{type:x,provider:V,extension:G}),this._proxy.$registerTaskProvider(T,x),new A.Disposable(()=>{this._handlers.delete(T),this._proxy.$unregisterTaskProvider(T)})}registerTaskSystem(G,x){this._proxy.$registerTaskSystem(G,x)}fetchTasks(G){return this._proxy.$fetchTasks(o.from(G)).then(async x=>{const V=[];for(let T of x){const N=await y.to(T,this._workspaceProvider,this._providedCustomExecutions2);N&&V.push(N)}return V})}get taskExecutions(){const G=[];return this._taskExecutions.forEach(x=>G.push(x)),G}terminateTask(G){if(!(G instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(G._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(G,x,V){const T=this._providedCustomExecutions2.get(G.id);if(T){if(this._activeCustomExecutions2.get(G.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(G.id,T),this._terminalService.attachPtyToTerminal(x,await T.callback(V))}this._lastStartedTask=G.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(G)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(G){const x=await this.getTaskExecution(G);this._taskExecutionPromises.delete(G.id),this._taskExecutions.delete(G.id),this.customExecutionComplete(G),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(G){const x=await this.getTaskExecution(G.id);this._onDidTaskProcessStarted.fire({execution:x,processId:G.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(G){const x=await this.getTaskExecution(G.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:G.exitCode})}$provideTasks(G,x){const V=this._handlers.get(G);if(!V)return Promise.reject(new Error("no handler found"));const T=[],N=R.asPromise(()=>V.provider.provideTasks(s.CancellationToken.None)).then(F=>this.provideTasksInternal(x,T,V,F));return new Promise(F=>{N.then(M=>{Promise.all(T).then(()=>{F(M)})})})}async $resolveTask(G,x){const V=this._handlers.get(G);if(!V)return Promise.reject(new Error("no handler found"));if(x.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${V.type}].`);const T=await y.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const N=await V.provider.resolveTask(T,s.CancellationToken.None);if(!N)return;this.checkDeprecation(N,V);const F=y.from(N,V.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(N.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(F.execution)&&await this.addCustomExecution(F,N,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(G,x,V){const T=await this._proxy.$createTaskId(G);!V&&!this._providedCustomExecutions2.has(T)&&this._notProvidedCustomExecutions.add(T),this._providedCustomExecutions2.set(T,x.execution)}async getTaskExecution(G,x){if(typeof G=="string"){const N=this._taskExecutionPromises.get(G);if(!N)throw new Error("Unexpected: The specified task is missing an execution");return N}let V=this._taskExecutionPromises.get(G.id);if(V)return V;const T=new Promise(async(N,F)=>{const M=x||await y.to(G.task,this._workspaceProvider,this._providedCustomExecutions2);M?N(new L(this,G.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(G.id,T),T.then(N=>(this._taskExecutions.set(G.id,N),N),N=>Promise.reject(N))}checkDeprecation(G,x){G._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(G){this._activeCustomExecutions2.get(G.id)&&this._activeCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.has(G.id)&&this._lastStartedTask!==G.id&&(this._providedCustomExecutions2.delete(G.id),this._notProvidedCustomExecutions.delete(G.id));let V=this._notProvidedCustomExecutions.values(),T=V.next();for(;!T.done;)!this._activeCustomExecutions2.has(T.value)&&this._lastStartedTask!==T.value&&(this._providedCustomExecutions2.delete(T.value),this._notProvidedCustomExecutions.delete(T.value)),T=V.next()}};W=Ve([He(0,l.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],W),e.ExtHostTaskBase=W;let ee=class extends W{constructor(G,x,V,T,N,F,M,U){super(G,x,V,T,N,F,M,U);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(G,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const V=y.from(x,G);if(V===void 0)throw new Error("Task is not valid");if(h.is(V.execution))await this.addCustomExecution(V,x,!1);else throw new d.NotSupportedError;const T=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),x);return this._proxy.$executeTask(V).catch(N=>{throw new Error(N)}),T}provideTasksInternal(G,x,V,T){const N=[];if(T)for(let F of T){this.checkDeprecation(F,V),(!F.definition||!G[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=y.from(F,V.extension);M&&h.is(M.execution)?(N.push(M),x.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:N,extension:V.extension}}async resolveTaskInternal(G){if(h.is(G.execution))return G;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(G,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(G,x,V){}};ee=Ve([He(0,l.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,C.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,I.IExtHostTerminalService),He(6,w.ILogService),He(7,E.IExtHostApiDeprecationService)],ee),e.WorkerExtHostTask=ee,e.IExtHostTask=c.createDecorator("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)},wn=this&&this.__rest||function(X,e){var v={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(v[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var k=0,R=Object.getOwnPropertySymbols(X);k<R.length;k++)e.indexOf(R[k])<0&&Object.prototype.propertyIsEnumerable.call(X,R[k])&&(v[R[k]]=X[R[k]]);return v};define(ge[248],pe([0,1,17,14,22,21,3,69,71,6,25,13,2,32,5,39,12,83,18,7,34,208,121]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d,f,t){"use strict";var r,n,i,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const p=(V,T)=>`${V}:${T.toString()}`;let h=class{constructor(T,N,F){this.documents=N,this.workspace=F,this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=T.getProxy(c.MainContext.MainThreadTesting),this.runQueue=new b(this.proxy),this.workspaceObservers=new G(this.proxy),this.textDocumentObservers=new x(this.proxy,N)}registerTestController(T,N){const F=g.generateUuid();this.controllers.set(F,{instance:N,extensionId:T}),this.proxy.$registerTestController(F);const M=[...this.testControllers.keys()];return setTimeout(()=>{var U;for(const B of M)(U=this.testControllers.get(B))===null||U===void 0||U.subscribeFn(F,N)},0),new u.Disposable(()=>{this.controllers.delete(F),this.proxy.$unregisterTestController(F)})}createTextDocumentTestObserver(T){return this.textDocumentObservers.checkout(T.uri)}createWorkspaceTestObserver(T){return this.workspaceObservers.checkout(T.uri)}async runTests(T,N=S.CancellationToken.None){const F=M=>M.map(this.getInternalTestForReference,this).filter(I.isDefined).map(U=>({src:U.src,testId:U.item.extId}));await this.proxy.$runTests({exclude:T.exclude?F(T.exclude).map(M=>M.testId):void 0,tests:F(T.tests),debug:T.debug},N)}createTestRun(T,N,F,M=!0){return this.runQueue.createTestRun(T,N,F,M)}$publishTestResults(T){this.results=Object.freeze(T.map(N=>s.deepFreeze(E.TestResults.to(N))).concat(this.results).sort((N,F)=>F.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(T,N){const F=l.URI.revive(N),M=p(T,F);if(this.testControllers.has(M))return;const U=new S.CancellationTokenSource;let B;if(T===1){let ye=this.documents.getDocument(F);if(!ye){const Oe=new P.DisposableStore;ye=await new Promise(je=>{Oe.add(R.disposableTimeout(()=>je(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(ze=>{const qe=ze.find(j=>j.document.uri.toString()===F.toString());qe&&je(qe)}))}).finally(()=>Oe.dispose())}if(ye){const Oe=await this.workspace.getWorkspaceFolder2(F,!1);B=je=>je.createDocumentTestRoot?je.createDocumentTestRoot(ye.document,U.token):e.createDefaultDocumentTestRoot(je,ye.document,Oe,U.token)}}else{const ye=await this.workspace.getWorkspaceFolder2(F,!1);ye&&(B=Oe=>Oe.createWorkspaceTestRoot(ye,U.token))}if(!B)return;const K=async(ye,Oe)=>{try{const je=await B(Oe);je&&we.addRoot(je,ye)}catch(je){console.error(je)}},ie=new P.DisposableStore,we=ie.add(this.ownedTests.createForHierarchy(ye=>this.proxy.$publishDiff(T,N,ye)));ie.add(P.toDisposable(()=>U.dispose(!0)));const Te=[];for(const[ye,Oe]of this.controllers)Te.push(K(ye,Oe.instance));Promise.all(Te).then(()=>we.pushDiff([3,-1])),this.testControllers.set(M,{store:ie,collection:we,subscribeFn:K})}async $expandTest(T,N){const F=v.mapFind(this.testControllers.values(),M=>M.collection.treeId===T.src.tree?M:void 0);await(F==null?void 0:F.collection.expand(T.testId,N<0?Infinity:N)),this.flushCollectionDiffs()}$unsubscribeFromTests(T,N){var F;const M=l.URI.revive(N),U=p(T,M);(F=this.testControllers.get(U))===null||F===void 0||F.store.dispose(),this.testControllers.delete(U)}$acceptDiff(T,N,F){T===1?this.textDocumentObservers.acceptDiff(l.URI.revive(N),F):this.workspaceObservers.acceptDiff(l.URI.revive(N),F)}async $runTestsForProvider(T,N){const F=this.controllers.get(T.tests[0].src.controller);if(!F)return;const M=T.tests.map(({testId:K,src:ie})=>this.ownedTests.getTestById(K,ie==null?void 0:ie.tree)).filter(I.isDefined).map(([K,ie])=>ie),U=T.excludeExtIds.map(K=>this.ownedTests.getTestById(K)).filter(I.isDefined).filter(([K,ie])=>M.some(we=>K.comparePositions(we,ie)===1));if(!M.length)return;const B={tests:M.map(K=>O.unwrap(K.actual)),exclude:U.map(([,K])=>O.unwrap(K.actual)),debug:T.debug};await this.runQueue.enqueueRun({dto:y.fromInternal(T),token:N,extensionId:F.extensionId,req:B,doRun:()=>F.instance.runTests(B,N)})}$lookupTest(T){const N=this.ownedTests.getTestById(T.testId);if(!N)return Promise.resolve(void 0);const F=N[1],{actual:M,discoverCts:U,expandLevels:B}=F,K=wn(F,["actual","discoverCts","expandLevels"]);return Promise.resolve(K)}flushCollectionDiffs(){for(const{collection:T}of this.testControllers.values())T.flushDiff()}getInternalTestForReference(T){var N,F;return(F=(N=this.workspaceObservers.getMirroredTestDataByReference(T))!==null&&N!==void 0?N:v.mapFind(this.testControllers.values(),M=>M.collection.getTestByReference(T)))!==null&&F!==void 0?F:this.textDocumentObservers.getMirroredTestDataByReference(T)}};h=Ve([He(0,_.IExtHostRpcService),He(1,m.IExtHostDocumentsAndEditors),He(2,d.IExtHostWorkspace)],h),e.ExtHostTesting=h;class b{constructor(T){this.proxy=T,this.state=new Map}enqueueRun(T){let N=this.state.get(T.extensionId);N||(N={queue:[],current:void 0},this.state.set(T.extensionId,N));const F=new R.DeferredPromise,M=()=>{const U=[],B=new Set;N.current={publicReq:T.req,factory:K=>{const ie=new o(K,T.dto,B,this.proxy);return U.push(ie),T.token.onCancellationRequested(()=>ie.end()),ie}},this.invokeRunner(T.extensionId,T.dto.id,T.doRun,U).finally(()=>F.complete())};return N.queue.push(M),N.queue.length===1&&M(),F.p}createTestRun(T,N,F,M){var U,B;const K=this.state.get(T);if((K==null?void 0:K.current.publicReq)===N)return K.current.factory(F);const ie=y.fromPublic(N),we=new o(F,ie,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:N.debug,exclude:(B=(U=N.exclude)===null||U===void 0?void 0:U.map(Te=>Te.id))!==null&&B!==void 0?B:[],id:ie.id,tests:N.tests.map(Te=>Te.id),persist:M}),we.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(ie.id)),we}invokeRunner(T,N,F,M){try{const U=F();return R.isThenable(U)?U.then(()=>this.handleInvokeResult(T,N,M,void 0)).catch(B=>this.handleInvokeResult(T,N,M,B)):this.handleInvokeResult(T,N,M,void 0)}catch(U){return this.handleInvokeResult(T,N,M,U)}}async handleInvokeResult(T,N,F,M){const U=this.state.get(T);!U||(U.queue.shift(),U.queue.length>0?U.queue[0]():this.state.delete(T),await Promise.all(F.map(B=>B.onEnd.wait())))}}class y{constructor(T,N,F){this.id=T,this.include=N,this.exclude=F}static fromPublic(T){var N,F;return new y(g.generateUuid(),new Set(T.tests.map(M=>M.id)),new Set((F=(N=T.exclude)===null||N===void 0?void 0:N.map(M=>M.id))!==null&&F!==void 0?F:D.Iterable.empty()))}static fromInternal(T){return new y(T.runId,new Set(T.tests.map(N=>N.testId)),new Set(T.excludeExtIds))}isIncluded(T){for(let N=T;N;N=N.parent){if(this.include.has(N.id))return!0;if(this.exclude.has(N.id))return!1}return!0}}class o{constructor(T,N,F,M){this.name=T,r.set(this,void 0),n.set(this,void 0),i.set(this,g.generateUuid()),a.set(this,void 0),this.onEnd=new R.Barrier,tt(this,r,M,"f"),tt(this,n,N,"f"),tt(this,a,F,"f"),M.$startedTestRunTask(N.id,{id:$e(this,i,"f"),name:T,running:!0})}setState(T,N,F){$e(this,n,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),$e(this,r,"f").$updateTestStateInRun($e(this,n,"f").id,$e(this,i,"f"),T.id,N,F))}appendMessage(T,N){$e(this,n,"f").isIncluded(T)&&(this.ensureTestIsKnown(T),$e(this,r,"f").$appendTestMessageInRun($e(this,n,"f").id,$e(this,i,"f"),T.id,E.TestMessage.from(N)))}appendOutput(T){$e(this,r,"f").$appendOutputToRun($e(this,n,"f").id,$e(this,i,"f"),k.VSBuffer.fromString(T))}end(){$e(this,r,"f").$finishedTestRunTask($e(this,n,"f").id,$e(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(T){const N=$e(this,a,"f");if(N.has(T.id))return;const F=[];for(;F.unshift(E.TestItem.from(T)),!(N.has(T.id)||(N.add(T.id),!T.parent));)T=T.parent;$e(this,r,"f").$addTestsToRun($e(this,n,"f").id,F)}}r=new WeakMap,n=new WeakMap,i=new WeakMap,a=new WeakMap;const L=async(V,T,N,F)=>{if(!N)return;const M=await V.createWorkspaceTestRoot(N,F);if(!M)return;F.onCancellationRequested(()=>{O.removeFilter(T)});const U=O.getWrapperForTestItem(M,T);return U.refreshMatch(),U};e.createDefaultDocumentTestRoot=L;class O extends u.TestItemImpl{constructor(T,N,F){super(T.id,T.label,T.uri,void 0);if(this.actual=T,this.filterDocument=N,this.actualParent=F,!(T instanceof u.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${T.id} did not`);this.debuggable=T.debuggable,this.runnable=T.runnable,this.description=T.description,this.error=T.error,this.status=T.status,this.range=T.range,this.resolveHandler=T.resolveHandler;const M=w.getPrivateApiFor(this);w.getPrivateApiFor(T).bus.event(B=>{switch(B[0]){case 3:this[B[1]]=B[2];break;case 0:const K=O.getWrapperForTestItem(B[1],this.filterDocument,this);w.getPrivateApiFor(K).parent=T,K.refreshMatch();break;default:M.bus.fire(B)}})}static removeFilter(T){this.wrapperMap.delete(T)}static getWrapperForTestItem(T,N,F){let M=this.wrapperMap.get(N);if(M==null?void 0:M.has(T))return M.get(T);M||(M=new WeakMap,this.wrapperMap.set(N,M));const U=new O(T,N,F);return M.set(T,U),U}static unwrap(T){return T instanceof O?T.actual:T}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var T,N;const F=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const B=O.getWrapperForTestItem(U,this.filterDocument,this);B.hasNodeMatchingFilter?this.children.has(B.id)||this.addChild(B):B.dispose()}const M=this.children.size>0||((T=this.actual.uri)===null||T===void 0?void 0:T.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==F&&((N=this.actualParent)===null||N===void 0||N.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&w.getPrivateApiFor(this.actualParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}}e.TestItemFilteredWrapper=O,O.wrapperMap=new WeakMap;class W extends t.IncrementalChangeCollector{constructor(T){super();this.emitter=T,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(T){this.added.add(T)}update(T){Object.assign(T.revived,E.TestItem.toPlain(T.item)),this.added.has(T)||this.updated.add(T)}remove(T){if(this.added.has(T)){this.added.delete(T);return}if(this.updated.delete(T),T.parent&&this.alreadyRemoved.has(T.parent)){this.alreadyRemoved.add(T.item.extId);return}this.removed.add(T)}getChangeEvent(){const{added:T,updated:N,removed:F}=this;return{get added(){return[...T].map(M=>M.revived)},get updated(){return[...N].map(M=>M.revived)},get removed(){return[...F].map(M=>M.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ee extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(T){let N=[];for(const F of T){const M=this.items.get(F);M&&N.push(M.revived)}return N}getMirroredTestDataById(T){return this.items.get(T)}getMirroredTestDataByReference(T){return this.items.get(T.id)}createItem(T,N){return Object.assign(Object.assign({},T),{revived:E.TestItem.toPlain(T.item),depth:N?N.depth+1:0,children:new Set})}createChangeCollector(){return new W(this.changeEmitter)}}e.MirroredTestCollection=ee;class ce{constructor(){this.resources=new Map}checkout(T){var N,F;const M=T.toString(),U=(N=this.resources.get(M))!==null&&N!==void 0?N:this.createObserverData(T);return(F=U.pendingDeletion)===null||F===void 0||F.dispose(),U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return U.tests.rootTestItems},dispose:C.once(()=>{--U.observers||(U.pendingDeletion=this.eventuallyDispose(T))})}}getMirroredTestDataByReference(T){for(const{tests:N}of this.resources.values()){const F=N.getMirroredTestDataByReference(T);if(F)return F}}eventuallyDispose(T){return R.disposableTimeout(()=>this.unlisten(T),10*1e3)}createObserverData(T){const N=new ee,F=this.listen(T,U=>N.apply(U)),M={observers:0,tests:N,listener:F};return this.resources.set(T.toString(),M),M}unlisten(T){var N;const F=T.toString(),M=this.resources.get(F);M&&(M.observers=-1,(N=M.pendingDeletion)===null||N===void 0||N.dispose(),M.listener.dispose(),this.resources.delete(F))}}class G extends ce{constructor(T){super();this.proxy=T,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){this.proxy.$subscribeToDiffs(0,T);const F=T.toString();return this.diffListeners.set(F,N),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,T),this.diffListeners.delete(F)})}}class x extends ce{constructor(T,N){super();this.proxy=T,this.documents=N,this.diffListeners=new Map}acceptDiff(T,N){var F;(F=this.diffListeners.get(T.toString()))===null||F===void 0||F(N)}listen(T,N){if(!this.documents.getDocument(T))return new u.Disposable(()=>{});const M=T.toString();return this.diffListeners.set(M,N),this.proxy.$subscribeToDiffs(1,T),new u.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,T),this.diffListeners.delete(M)})}}}),define(ge[249],pe([0,1,17,68,30,76,23,10,9,24,8,13,2,140,168,114,57,201,247,31]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(b,y,o,L){this.configurationService=b,this.workspaceContextService=y,this.editorGroupsService=o,this.pathService=L}text(b,y,o={}){b=this.getContentPattern(b,o);const L=this.configurationService.getValue(),O=y&&y.some(ee=>!this.configurationService.getValue({resource:ee}).search.useRipgrep),W=this.commonQuery(y==null?void 0:y.map(_.toWorkspaceFolder),o);return Object.assign(Object.assign({},W),{type:2,contentPattern:b,previewOptions:o.previewOptions,maxFileSize:o.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:o.beforeContext,afterContext:o.afterContext,userDisabledExcludesAndIgnoreFiles:o.disregardExcludeSettings&&o.disregardIgnoreFiles})}getContentPattern(b,y){const o=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const L=Object.assign(Object.assign({},b),{wordSeparators:o.editor.wordSeparators});return this.isCaseSensitive(b,y)&&(L.isCaseSensitive=!0),this.isMultiline(b)&&(L.isMultiline=!0),L}file(b,y={}){const o=this.commonQuery(b,y);return Object.assign(Object.assign({},o),{type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey})}handleIncludeExclude(b,y){return b?(b=Array.isArray(b)?b.map(i):i(b),y?this.parseSearchPaths(b):{pattern:t(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],y={}){const o=this.handleIncludeExclude(y.includePattern,y.expandPatterns),L=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),O=b.length>1,W=(o.searchPaths&&o.searchPaths.length?o.searchPaths.map(G=>this.getFolderQueryForSearchPath(G,y,L)):b.map(G=>this.getFolderQueryForRoot(G,y,L,O))).filter(G=>!!G),ee={_reason:y._reason,folderQueries:W,usingSearchPaths:!!(o.searchPaths&&o.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:L.pattern,includePattern:o.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const x=v.coalesce(v.flatten(this.editorGroupsService.groups.map(T=>T.editors.map(N=>N.resource)))).filter(T=>u.pathIncludedInQuery(ee,T.fsPath)),V=this.commonQueryFromFileList(x);return Object.assign(Object.assign({},ee),V)}const ce=y.extraFileResources&&y.extraFileResources.filter(G=>u.pathIncludedInQuery(ee,G.fsPath));return ee.extraFileResources=ce&&ce.length?ce:void 0,ee}commonQueryFromFileList(b){const y=[],o=new A.ResourceMap,L={};let O=!1;return b.forEach(W=>{var ee,ce;if(W.scheme===C.Schemas.walkThrough)return;if(P.isAbsolutePath(W)){const x=(ce=(ee=this.workspaceContextService.getWorkspaceFolder(W))===null||ee===void 0?void 0:ee.uri)!==null&&ce!==void 0?ce:W.with({path:D.dirname(W.fsPath)});let V=o.get(x);V||(O=!0,V={folder:x,includePattern:{}},y.push(V),o.set(x,V));const T=D.relative(x.fsPath,W.fsPath);I.assertIsDefined(V.includePattern)[T.replace(/\\/g,"/")]=!0}else W.fsPath&&(O=!0,L[W.fsPath]=!0)}),{folderQueries:y,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(b,y){if(y.isSmartCase){if(b.isRegExp){if(s.containsUppercaseCharacter(b.pattern,!0))return!0}else if(s.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&g.isMultilineRegexSource(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const y=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),L=(Array.isArray(b)?b:r(b)).map(V=>{const T=this.pathService.resolvedUserHome;return T?S.untildify(V,T.scheme===C.Schemas.file?T.fsPath:T.path):V}),O=R.groupBy(L,V=>y(V)?"searchPaths":"exprSegments"),W=(O.exprSegments||[]).map(V=>s.rtrim(V,"/")).map(V=>s.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),n(V))),ee={},ce=this.expandSearchPathPatterns(O.searchPaths||[]);ce&&ce.length&&(ee.searchPaths=ce);const G=v.flatten(W),x=t(...G);return x&&(ee.pattern=x),ee}getExcludesForFolder(b,y){return y.disregardExcludeSettings?void 0:u.getExcludes(b,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const y=v.flatten(b.map(L=>{let{pathPortion:O,globPortion:W}=f(L);W&&(W=a(W));const ee=this.expandOneSearchPath(O);return v.flatten(ee.map(ce=>this.resolveOneSearchPathPattern(ce,W)))})),o=new Map;return y.forEach(L=>{const O=L.searchPath.toString(),W=o.get(O);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):o.set(O,{searchPath:L.searchPath,pattern:L.pattern?t(L.pattern):void 0})}),Array.from(o.values())}expandOneSearchPath(b){if(D.isAbsolute(b)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==C.Schemas.file?[{searchPath:y[0].uri.with({path:b})}]:[{searchPath:l.URI.file(D.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const L=D.posix.resolve(y.path,b);return[{searchPath:y.with({path:L})}]}const o=a(b);return[{searchPath:y,pattern:o}]}else{if(b==="./"||b===".\\")return[];{const y=b.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const W=y.match(new RegExp(`^${O.name}(?:/(.*))?`));return W?{match:W,folder:O}:null}).filter(I.isDefined);if(L.length)return L.map(O=>{const W=O.match[1];return{searchPath:O.folder.uri,pattern:W&&a(W)}});{const O=b.match(/\.[\/\\](.+)[\/\\]?/),W=O?O[1]:b,ee=c.localize(0,null,W);throw new Error(ee)}}}}resolveOneSearchPathPattern(b,y){const o=b.pattern&&y?`${b.pattern}/${y}`:b.pattern||y,L=[{searchPath:b.searchPath,pattern:o}];return o&&!o.endsWith("**")&&L.push({searchPath:b.searchPath,pattern:o+"/**"}),L}getFolderQueryForSearchPath(b,y,o){const L=this.getFolderQueryForRoot(_.toWorkspaceFolder(b.searchPath),y,o,!1);return L?Object.assign(Object.assign({},L),{includePattern:b.pattern}):null}getFolderQueryForRoot(b,y,o,L){let O;const W=l.URI.isUri(b)?b:b.uri;if(o.searchPaths){const V=o.searchPaths.filter(T=>P.isEqual(T.searchPath,W))[0];if(V&&!V.pattern)return null;V&&(O=V.pattern)}const ee=this.configurationService.getValue({resource:W}),ce=this.getExcludesForFolder(ee,y),G=Object.assign(Object.assign({},ce||{}),O||{}),x=l.URI.isUri(b)?P.basename(b):b.name;return{folder:W,folderName:L?x:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:ee.files&&ee.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!ee.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!ee.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!ee.search.followSymlinks}}};d=Ve([He(0,m.IConfigurationService),He(1,_.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,E.IPathService)],d),e.QueryBuilder=d;function f(h){const b=h.match(/[\*\{\}\(\)\[\]\?]/);if(b){const y=b.index,o=h.substr(0,y).match(/[/|\\][^/\\]*$/);if(o){let L=h.substr(0,o.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:h.substr((o.index||0)+1)}}}return{pathPortion:h}}function t(...h){return h.length?h.reduce((b,y)=>(b[y]=!0,b),Object.create(null)):void 0}function r(h){return k.splitGlobAware(h,",").map(b=>b.trim()).filter(b=>!!b.length)}function n(h){return[`**/${h}/**`,`**/${h}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(h){return h.replace(/\\/g,"/")}function a(h){return i(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(h,b){h=v.distinct(h,L=>L.toString());const y=[],o=b.getWorkspace();return h&&h.forEach(L=>{let O;if(b.getWorkbenchState()===2)O=P.relativePath(o.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const W=b.getWorkspaceFolder(L);if(W){const ee=W.name;if(o.folders.filter(G=>G.name===ee).length===1){const G=P.relativePath(W.uri,L);G===""?O=`./${W.name}`:O=`./${W.name}/${G}`}else O=L.fsPath}}O&&y.push(O)}),y}e.resolveResourcesForSearchIncludes=p}),define(ge[250],pe([0,1,24,2,21,16,4,249,31,57]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const s=7e3;function I(m,_){const w=_.activationEvents;if(!w)return Promise.resolve(void 0);const E=[],u=[];for(const i of w)if(/^workspaceContains:/.test(i)){const a=i.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||m.forceUsingSearch?u.push(a):E.push(a)}if(E.length===0&&u.length===0)return Promise.resolve(void 0);let d;const f=new Promise((i,a)=>{d=i}),t=i=>d({activationEvent:i}),r=Promise.all(E.map(i=>l(m,i,t))).then(()=>{}),n=g(m,_.identifier,u,t);return Promise.all([r,n]).then(()=>{d(void 0)}),f}e.checkActivateWorkspaceContainsExtension=I;async function l(m,_,w){for(const E of m.folders)if(await m.exists(v.joinPath(R.URI.revive(E),_))){w(`workspaceContains:${_}`);return}}async function g(m,_,w,E){if(w.length===0)return Promise.resolve(void 0);const u=new k.CancellationTokenSource,d=m.checkExists(m.folders,w,u.token),f=setTimeout(async()=>{u.cancel(),E(`workspaceContainsTimeout:${w.join(",")}`)},s);let t=!1;try{t=await d}catch(r){S.isPromiseCanceledError(r)||S.onUnexpectedError(r)}u.dispose(),clearTimeout(f),t&&E(`workspaceContains:${w.join(",")}`)}function c(m,_,w,E){const u=m.get(A.IInstantiationService),d=m.get(D.ISearchService),t=u.createInstance(C.QueryBuilder).file(_.map(r=>P.toWorkspaceFolder(R.URI.revive(r))),{_reason:"checkExists",includePattern:w,exists:!0});return d.fileSearch(t,E).then(r=>!!r.limitHit,r=>S.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var tt=this&&this.__classPrivateFieldSet||function(X,e,v,R,k){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!k:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?k.call(X,v):k?k.value=v:e.set(X,v),v},$e=this&&this.__classPrivateFieldGet||function(X,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(X):R?R.value:e.get(X)};define(ge[40],pe([0,1,159,9,66,24,14,6,23,2,15,5,36,211,87,34,35,209,16,26,22,189,7,115,4,27,88,12,80,46,33,3,250,85,190]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d,f,t,r,n,i,a,p,h,b,y,o,L,O,W){"use strict";var ee,ce,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=n.createDecorator("IHostUtils");let x=class On extends C.Disposable{constructor(F,M,U,B,K,ie,we,Te,ye,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new o.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=U,this._initData=we,this._extHostWorkspace=B,this._extHostConfiguration=K,this._logService=ie,this._extHostTunnelService=ye,this._extHostTerminalService=Oe,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=F.createChild(new h.ServiceCollection([c.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(ze=>je.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,qe,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,E.transformErrorForSerialization(qe),j)},actualActivateExtension:async(ze,qe)=>{if(je.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,qe),new g.HostExtension;const j=this._registry.getExtensionDescription(ze);return this._activateExtension(j,qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),k.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){E.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(K=>K.identifier).filter(K=>this.isActivated(K)).map(K=>this._deactivate(K))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const U=this._activator.getActivatedExtension(F);if(U.activationFailed)return Promise.reject(U.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=D.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(U=>{if(!!this._getEntryPoint(U))return this._hostUtils.realpath(U.extensionLocation.fsPath).then(B=>F.set(P.URI.file(B).fsPath,U))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const U=this._activator.getActivatedExtension(F);if(!U)return M;try{typeof U.module.deactivate=="function"&&(M=Promise.resolve(U.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{C.dispose(U.subscriptions)}catch(B){this._logService.error(B)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(U=>{const B=U.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",B),U},U=>{throw this._logExtensionActivationTimes(F,M,"failure"),U})}_logExtensionActivationTimes(F,M,U,B){const K=V(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},K),B||{}),{outcome:U}))}_doActivateExtension(F,M){const U=V(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",U);const B=this._getEntryPoint(F);if(!B)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const K=new g.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,S.joinPath(F.extensionLocation,B),K),this._loadExtensionContext(F)]).then(ie=>(k.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),On._callActivate(this._logService,F.identifier,ie[0],ie[1],K))).then(ie=>(k.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),ie))}_loadExtensionContext(F){const M=new f.ExtensionGlobalMemento(F,this._storage),U=new f.ExtensionMemento(F.identifier.value,!1,this._storage),B=new W.ExtensionSecrets(F,this._secretState),K=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ie=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,U.whenReady,this._storagePath.whenReady]).then(()=>{const we=this;let Te;return Object.freeze({globalState:M,workspaceState:U,secrets:B,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ye){return R.join(F.extensionLocation.fsPath,ye)},get storagePath(){var ye;return(ye=we._storagePath.workspaceValue(F))===null||ye===void 0?void 0:ye.fsPath},get globalStoragePath(){return we._storagePath.globalValue(F).fsPath},get logPath(){return R.join(we._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return P.URI.joinPath(we._initData.logsLocation,F.identifier.value)},get storageUri(){return we._storagePath.workspaceValue(F)},get globalStorageUri(){return we._storagePath.globalValue(F)},get extensionMode(){return K},get extension(){return Te===void 0&&(Te=new T(we,F.identifier,F,ie)),Te},get extensionRuntime(){return _.checkProposedApiEnabled(F),we.extensionRuntime},get environmentVariableCollection(){return we._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,U,B,K){return U=U||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,U,B,K).then(ie=>new g.ActivatedExtension(!1,null,K.build(),U,ie,B.subscriptions))}static _callActivateOptional(F,M,U,B,K){if(typeof U.activate=="function")try{K.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const ie=typeof global=="object"?global:self,we=U.activate.apply(ie,[B]);return K.activateCallStop(),K.activateResolveStart(),Promise.resolve(we).then(Te=>(K.activateResolveStop(),Te))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(U)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,U=>{this._logService.error(U)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(k.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,K=>{this._logService.error(K)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(K=>this._handleWorkspaceContainsEagerExtensions(K.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],U=this._handleWorkspaceContainsEagerExtensions(M),B=Promise.all([F,U]).then(()=>{});return Promise.race([B,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const U=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:F.map(ie=>ie.uri),forceUsingSearch:U,exists:ie=>this._hostUtils.exists(ie.fsPath),checkExists:(ie,we,Te)=>this._mainThreadWorkspaceProxy.$checkExists(ie,we,Te)},K=await L.checkActivateWorkspaceContainsExtension(B,M);if(!!K)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:K.activationEvent}).then(void 0,ie=>this._logService.error(ie))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(v.localize(0,null));const U=await this._loadCommonJSModule(null,M,new g.ExtensionActivationTimesBuilder(!1));if(!U||typeof U.run!="function")throw new Error(v.localize(1,null,M.toString()));return new Promise((B,K)=>{const ie=(ye,Oe)=>{ye?K(ye):B(typeof Oe=="number"&&Oe>0?1:0)},we=S.originalFSPath(M),Te=U.run(we,ie);Te&&Te.then&&Te.then(()=>{B(0)}).catch(ye=>{K(ye.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,C.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const U=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${U}`,!1),{authorityPrefix:U,resolver:this._resolvers[U]}}async $resolveAuthority(F,M){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(F);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${U}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),k.mark(`code/extHost/willResolveAuthority/${U}`);const K=await B.resolve(F,{resolveAttempt:M});k.mark(`code/extHost/didResolveAuthorityOK/${U}`);const ie={authority:F,host:K.host,port:K.port,connectionToken:K.connectionToken},we={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted};return{type:"ok",value:{authority:ie,options:we,tunnelInformation:{environmentTunnels:K.environmentTunnels}}}}catch(K){if(k.mark(`code/extHost/didResolveAuthorityError/${U}`),K instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K}}async $getCanonicalURI(F,M){const{authorityPrefix:U,resolver:B}=await this._activateAndGetResolver(F);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${U}`);const K=P.URI.revive(M);if(typeof B.getCanonicalURI=="undefined")return K;const ie=await A.asPromise(()=>B.getCanonicalURI(K));return ie||K}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(U=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(B=>B.extensionLocation=P.URI.revive(B.extensionLocation));const U=await this.getExtensionPathIndex();return await Promise.all(M.map(async B=>{const K=this._registry.getExtensionDescription(B);if(!K)return;const ie=await this._hostUtils.realpath(K.extensionLocation.fsPath);U.delete(P.URI.file(ie).fsPath)})),await Promise.all(F.map(async B=>{const K=await this._hostUtils.realpath(B.extensionLocation.fsPath);U.set(P.URI.file(K).fsPath,B)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=d.VSBuffer.alloc(F),U=Math.random()%256;for(let B=0;B<F;B++)M.writeUInt8(U,B);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};x=Ve([He(0,n.IInstantiationService),He(1,e.IHostUtils),He(2,p.IExtHostRpcService),He(3,m.IExtHostWorkspace),He(4,l.IExtHostConfiguration),He(5,s.ILogService),He(6,i.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,b.IExtHostTunnelService),He(9,y.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function V(N,F){return{id:N.identifier.value,name:N.name,extensionVersion:N.version,publisherDisplayName:N.publisher,activationEvents:N.activationEvents?N.activationEvents.join(","):null,isBuiltin:N.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=n.createDecorator("IExtHostExtensionService");class T{constructor(F,M,U,B){ee.set(this,void 0),ce.set(this,void 0),G.set(this,void 0),tt(this,ee,F,"f"),tt(this,ce,M,"f"),tt(this,G,U.identifier,"f"),this.id=U.identifier.value,this.extensionUri=U.extensionLocation,this.extensionPath=R.normalize(S.originalFSPath(U.extensionLocation)),this.packageJSON=U,this.extensionKind=B}get isActive(){return $e(this,ee,"f").isActivated($e(this,G,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,ee,"f").getExtensionExports($e(this,G,"f"))}activate(){return $e(this,ee,"f").activateByIdWithErrors($e(this,G,"f"),{startup:!1,extensionId:$e(this,ce,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=T,ee=new WeakMap,ce=new WeakMap,G=new WeakMap}),define(ge[48],pe([0,1,9,2,3,14,5,7,119,34,40,39,200,36,195,12,4,13,37,45]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=_.createDecorator("IExtHostDebugService");let d=class{constructor(h,b,y,o,L,O){this._workspaceService=b,this._extensionService=y,this._editorsService=o,this._configurationService=L,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new k.Emitter,this._onDidTerminateDebugSession=new k.Emitter,this._onDidChangeActiveDebugSession=new k.Emitter,this._onDidReceiveDebugSessionCustomEvent=new k.Emitter,this._debugServiceProxy=h.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new k.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(ee=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,b){const y=h;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let o=`debug:${encodeURIComponent(y.path||"")}`,L="?";return b&&(o+=`${L}session=${encodeURIComponent(b.id)}`,L="&"),o+=`${L}ref=${y.sourceReference}`,R.URI.parse(o)}else{if(y.path)return R.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const b=[];for(const y of h.getAllExtensionDescriptions())if(y.contributes){const o=y.contributes.debuggers;if(o&&o.length>0)for(const L of o)c.isDebuggerMainContribution(L)&&b.push(L.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(b=>h.push(b)),h}addBreakpoints(h){this.startBreakpoints();const b=h.filter(L=>{const O=L.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,L),!0)});this.fireBreakpointChanges(b,[],[]);const y=[],o=new Map;for(const L of b)if(L instanceof C.SourceBreakpoint){let O=o.get(L.location.uri.toString());O||(O={type:"sourceMulti",uri:L.location.uri,lines:[]},o.set(L.location.uri.toString(),O),y.push(O)),O.lines.push({id:L.id,enabled:L.enabled,condition:L.condition,hitCondition:L.hitCondition,logMessage:L.logMessage,line:L.location.range.start.line,character:L.location.range.start.character})}else L instanceof C.FunctionBreakpoint&&y.push({type:"function",id:L.id,enabled:L.enabled,hitCondition:L.hitCondition,logMessage:L.logMessage,condition:L.condition,functionName:L.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(h){this.startBreakpoints();const b=h.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],b,[]);const y=b.filter(O=>O instanceof C.SourceBreakpoint).map(O=>O.id),o=b.filter(O=>O instanceof C.FunctionBreakpoint).map(O=>O.id),L=b.filter(O=>O instanceof C.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(y,o,L)}startDebugging(h,b,y){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,b,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,y){if(!b)return new C.Disposable(()=>{});const o=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:o,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,y,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,o),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(L=>L.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(o)})}registerDebugAdapterDescriptorFactory(h,b,y){if(!y)return new C.Disposable(()=>{});if(!this.definesDebugType(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const o=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:o,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,o),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(L=>L.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(o)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new C.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:y,factory:b}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(o=>o.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){if(!this._variableResolver){const[L,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(L||[],this._editorsService,O)}let y;const o=await this.getFolder(h);return o&&(y={uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,b)}createDebugAdapter(h,b){if(h.type==="implementation")return new i(h.implementation)}createSignService(){}async $startDASession(h,b){const y=this,o=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(o.type),o).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}' (extension might have failed to activate)`);const O=this.convertToDto(L),W=this.createDebugAdapter(O,o);if(!W)throw new Error(`Couldn't create a debug adapter for type '${o.type}'.`);const ee=W;return this._debugAdapters.set(h,ee),this.getDebugAdapterTrackers(o).then(ce=>(ce&&this._debugAdaptersTrackers.set(h,ce),ee.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const x=G,V={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const T=await this._signService.sign(x.arguments.value);V.body={signature:T},ee.sendResponse(V)}else throw new Error("no signer")}catch(T){V.success=!1,V.message=T.message,ee.sendResponse(V)}}else ce&&ce.onDidSendMessage&&ce.onDidSendMessage(G),G=c.convertToVSCPaths(G,!0),y._debugServiceProxy.$acceptDAMessage(h,G)}),ee.onError(G=>{ce&&ce.onError&&ce.onError(G),this._debugServiceProxy.$acceptDAError(h,G.name,G.message,G.stack)}),ee.onExit(G=>{ce&&ce.onExit&&ce.onExit(w.withNullAsUndefined(G),void 0),this._debugServiceProxy.$acceptDAExit(h,w.withNullAsUndefined(G),void 0)}),ce&&ce.onWillStartSession&&ce.onWillStartSession(),ee.startSession()))})}$sendDAMessage(h,b){b=c.convertToDAPaths(b,!1);const y=this._debugAdaptersTrackers.get(h);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(b);const o=this._debugAdapters.get(h);o&&o.sendMessage(b)}$stopDASession(h){const b=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const y=this._debugAdapters.get(h);return this._debugAdapters.delete(h),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],y=[],o=[];if(h.added)for(const L of h.added){const O=L.id;if(O&&!this._breakpoints.has(O)){let W;if(L.type==="function")W=new C.FunctionBreakpoint(L.functionName,L.enabled,L.condition,L.hitCondition,L.logMessage);else if(L.type==="data")W=new C.DataBreakpoint(L.label,L.dataId,L.canPersist,L.enabled,L.hitCondition,L.condition,L.logMessage);else{const ee=R.URI.revive(L.uri);W=new C.SourceBreakpoint(new C.Location(ee,new C.Position(L.line,L.character)),L.enabled,L.condition,L.hitCondition,L.logMessage)}W._id=O,this._breakpoints.set(O,W),b.push(W)}}if(h.removed)for(const L of h.removed){const O=this._breakpoints.get(L);O&&(this._breakpoints.delete(L),y.push(O))}if(h.changed){for(const L of h.changed)if(L.id){const O=this._breakpoints.get(L.id);if(O){if(O instanceof C.FunctionBreakpoint&&L.type==="function"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.functionName=L.functionName}else if(O instanceof C.SourceBreakpoint&&L.type==="source"){const W=O;W.enabled=L.enabled,W.condition=L.condition,W.hitCondition=L.hitCondition,W.logMessage=L.logMessage,W.location=new C.Location(R.URI.revive(L.uri),new C.Position(L.line,L.character))}o.push(O)}}}this.fireBreakpointChanges(b,y,o)}$provideDebugConfigurations(h,b,y){return S.asPromise(async()=>{const o=this.getConfigProviderByHandle(h);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const L=await this.getFolder(b);return o.provideDebugConfigurations(L,y)}).then(o=>{if(!o)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return o})}$resolveDebugConfiguration(h,b,y,o){return S.asPromise(async()=>{const L=this.getConfigProviderByHandle(h);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(b);return L.resolveDebugConfiguration(O,y,o)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,y,o){return S.asPromise(async()=>{const L=this.getConfigProviderByHandle(h);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(b);return L.resolveDebugConfigurationWithSubstitutedVariables(O,y,o)})}async $provideDebugAdapter(h,b){const y=this.getAdapterDescriptorFactoryByHandle(h);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const o=await this.getSession(b);return this.getAdapterDescriptor(y,o).then(L=>{if(!L)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${o.type}'`);return this.convertToDto(L)})}async $acceptDebugSessionStarted(h){const b=await this.getSession(h);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(h){const b=await this.getSession(h);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,b){const y=await this.getSession(h);y&&y._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const o={session:await this.getSession(h),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(o)}convertToDto(h){if(h instanceof C.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof C.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const b=this._adapterFactories.filter(y=>y.type===h);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(h){const b=this._adapterFactories.filter(y=>y.handle===h);if(b.length>0)return b[0].factory}getConfigProviderByHandle(h){const b=this._configProviders.filter(y=>y.handle===h);if(b.length>0)return b[0].provider}definesDebugType(h,b){if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0){for(const o of y)if(o.label&&o.type&&o.type===b)return!0}}return!1}getDebugAdapterTrackers(h){const y=h.configuration.type,o=this._trackerFactories.filter(L=>L.type===y||L.type==="*").map(L=>S.asPromise(()=>L.factory.createDebugAdapterTracker(h)).then(O=>O,O=>null));return Promise.race([Promise.all(o).then(L=>{const O=L.filter(W=>!!W);if(O.length>0)return new n(O)}),new Promise((L,O)=>{const W=setTimeout(()=>{clearTimeout(W),O(new Error("timeout"))},1e3)})]).catch(L=>{})}async getAdapterDescriptor(h,b){const y=b.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new C.DebugAdapterServer(y));if(h){const L=await this._extensionService.getExtensionRegistry();return S.asPromise(()=>h.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,L))).then(O=>{if(O)return O})}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,o))}daExecutableFromPackage(h,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,b,y){(h.length>0||b.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:b,changed:y}))}async getSession(h){if(h)if(typeof h=="string"){const b=this._debugSessions.get(h);if(b)return b}else{let b=this._debugSessions.get(h.id);if(!b){const y=await this.getFolder(h.folderUri),o=h.parent?this._debugSessions.get(h.parent):void 0;b=new f(this._debugServiceProxy,h.id,h.type,h.name,y,h.configuration,o),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(h){if(h){const b=R.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};d=Ve([He(0,m.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class f{constructor(h,b,y,o,L,O,W){this._debugServiceProxy=h,this._id=b,this._type=y,this._name=o,this._workspaceFolder=L,this._configuration=O,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}get parentSession(){return this._parentSession}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,b)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=f;class t{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=t;class r extends l.AbstractVariableResolverService{constructor(h,b,y,o,L){function O(){if(b){const W=b.activeEditor();if(W)return W.document.uri;const ee=o.tabs.filter(ce=>ce.isActive);if(ee.length>0)return ee[0].resource}}super({getFolderUri:W=>{const ee=h.filter(ce=>ce.name===W);if(ee&&ee.length>0)return ee[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(W,ee)=>y.getConfiguration(void 0,W).get(ee),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{const W=O();if(W)return v.normalize(W.fsPath)},getWorkspaceFolderPathForFile:()=>{if(L){const W=O();if(W){const ee=L.getWorkspaceFolder(W);if(ee)return v.normalize(ee.uri.fsPath)}}},getSelectedText:()=>{if(b){const W=b.activeEditor();if(W&&!W.selection.isEmpty)return W.document.getText(W.selection)}},getLineNumber:()=>{if(b){const W=b.activeEditor();if(W)return String(W.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=r;class n{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.trackers.forEach(y=>y.onExit?y.onExit(h,b):void 0)}}class i extends D.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(h,b,y,o,L,O){super(h,b,y,o,L,O)}createVariableResolver(h,b,y){return new r(h,b,y,this._editorTabs)}};a=Ve([He(0,m.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,s.IExtHostExtensionService),He(3,I.IExtHostDocumentsAndEditors),He(4,g.IExtHostConfiguration),He(5,u.IExtHostEditorTabs)],a),e.WorkerExtHostDebugService=a}),define(ge[251],pe([0,1,66,2,5,36,35,26,12,27,4,40,37,15]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,d,f,t,r,n,i){this._apiFactory=u,this._extensionRegistry=d,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=n,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),v.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,d,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(_)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,d,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let d of u.nodeModuleName)this._factories.set(d,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(d=>u.alternativeModuleName(d))}};c=Ve([He(2,s.IInstantiationService),He(3,S.IExtHostConfiguration),He(4,I.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,g.ILogService)],c),e.RequireInterceptor=c;class m{constructor(u,d,f,t,r){this._apiFactory=u,this._extensionPaths=d,this._extensionRegistry=f,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,d){const f=this._extensionPaths.findSubstr(d.fsPath);if(f){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,n)=>t+=`	${n} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(u,d){this.nodeModuleName="keytar";const{environment:f}=d,t=u.getProxy(k.MainContext.MainThreadKeytar);if(f.appRoot){let r=f.appRoot.fsPath;l.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,n)=>t.$getPassword(r,n),setPassword:(r,n,i)=>t.$setPassword(r,n,i),deletePassword:(r,n)=>t.$deletePassword(r,n),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(u,d){return this._impl}alternativeModuleName(u){const d=u.length;if(d<=7||!this.alternativeNames)return;const f=d-7;if((u.charAt(f)==="/"||u.charAt(f)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};_=Ve([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],_);let w=class{constructor(u,d,f){this._extensionPaths=u,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(k.MainContext.MainThreadTelemetry);const t=f.getProxy(k.MainContext.MainThreadWindow);this._impl=(r,n)=>{const i=R.URI.parse(r);return n?this.callOriginal(r,n):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,n)}}load(u,d,f){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(u),this._impl}callOriginal(u,d){return this.sendNoForwardTelemetry(),this._original(u,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=Ve([He(2,D.IExtHostRpcService)],w)}),define(ge[252],pe([0,1,165,11,7,196,34,40,39,36,33,12,48,186,14,197,45]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let w=class extends l.ExtHostDebugServiceBase{constructor(d,f,t,r,n,i,a){super(d,f,t,r,n,a);this._terminalService=i,this._integratedTerminalInstances=new E}createDebugAdapter(d,f){switch(d.type){case"server":return new S.SocketDebugAdapter(d);case"pipeServer":return new S.NamedPipeDebugAdapter(d);case"executable":return new S.ExecutableDebugAdapter(d,f.type)}return super.createDebugAdapter(d,f)}daExecutableFromPackage(d,f){const t=S.ExecutableDebugAdapter.platformAdapterExecutable(f.getAllExtensionDescriptions(),d.type);if(t)return new k.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new g.SignService}async $runInTerminal(d,f){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(L=>{this._integratedTerminalInstances.onTerminalClosed(L)}));const t=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),i=JSON.stringify({shell:r,shellArgs:n});let a=await this._integratedTerminalInstances.checkout(i),p,h=!1;if(a)p=d.cwd;else{const L={shellPath:r,shellArgs:n,cwd:d.cwd,name:d.title||v.localize(0,null)};h=!0,a=this._terminalService.createTerminalFromOptions(L,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(a,i)}a.show(!0);const b=await a.processId;h?await new Promise(L=>setTimeout(L,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?a.sendText("cls"):r.indexOf("bash")>=0?a.sendText("clear"):R.isWindows?a.sendText("cls"):a.sendText("clear"));const y=m.prepareCommand(r,d.args,p,d.env);a.sendText(y);const o=this.onDidTerminateDebugSession(L=>{L.id===f&&(this._integratedTerminalInstances.free(a),o.dispose())});return b}else if(d.kind==="external")return m.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,f)}createVariableResolver(d,f,t){return new l.ExtHostVariableResolverService(d,f,t,this._editorTabs,this._workspaceService)}};w=Ve([He(0,I.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,C.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,s.IExtHostTerminalService),He(6,_.IExtHostEditorTabs)],w),e.ExtHostDebugService=w;class E{constructor(){this._terminalInstances=new Map}async checkout(d){const t=[...this._terminalInstances.entries()].map(([r,n])=>c.createCancelablePromise(async i=>{if(n.lastUsedAt!==-1&&await m.hasChildProcesses(await r.processId))return null;const a=Date.now();return n.lastUsedAt+E.minUseDelay>a||i.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=a,r)}));return await c.firstParallel(t,r=>!!r)}insert(d,f){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:f})}free(d){const f=this._terminalInstances.get(d);f&&(f.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}E.minUseDelay=1e3}),define(ge[253],pe([0,1,9,2,108,34,48,39,36,33,12,27,65,10,15,61,45]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let w=class extends l.ExtHostTaskBase{constructor(u,d,f,t,r,n,i,a,p){super(u,d,f,t,r,n,i,a);this.workspaceService=f,this.editorTabs=p,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,d){const f=d;if(!d.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const t=l.TaskHandleDTO.from(f,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(r,d);return this._proxy.$executeTask(t).catch(()=>{}),n}else{const t=l.TaskDTO.from(d,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(u,d,f,t){const r=[];if(t)for(let n of t){this.checkDeprecation(n,f),(!n.definition||!u[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const i=l.TaskDTO.from(n,f.extension);i&&(r.push(i),l.CustomExecutionDTO.is(i.execution)&&d.push(this.addCustomExecution(i,n,!0)))}return{tasks:r,extension:f.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,d){const f=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(f),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!r)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const i=await this.getVariableResolver(n),a={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}};for(let p of d.variables)t.variables[p]=await i.resolveAsync(a,p);if(d.process!==void 0){let p;if(d.process.path!==void 0){p=d.process.path.split(v.delimiter);for(let h=0;h<p.length;h++)p[h]=await i.resolveAsync(a,p[h])}t.process=await k.win32.findExecutable(await i.resolveAsync(a,d.process.name),d.process.cwd!==void 0?await i.resolveAsync(a,d.process.cwd):void 0,p)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,d,f){return k.win32.findExecutable(u,d,f)}};w=Ve([He(0,s.IExtHostRpcService),He(1,I.IExtHostInitDataService),He(2,S.IExtHostWorkspace),He(3,C.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,c.ILogService),He(7,m.IExtHostApiDeprecationService),He(8,_.IExtHostEditorTabs)],w),e.ExtHostTask=w}),define(ge[254],pe([0,1,14,16,66,6,2,5,245,15,78,80,27,180,12,59,40,33]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(d,f,t,r){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new D.RPCProtocol(d,null,r),f=E._transform(f,this._rpcProtocol);const n=new I.ServiceCollection(...s.getSingletonServiceDescriptors());n.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),n.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),n.set(m.IURITransformerService,new m.URITransformerService(r)),n.set(_.IHostUtils,t);const i=new g.InstantiationService(n,!0),a=i.invokeFunction(y=>y.get(w.IExtHostTerminalService));this._disposables.add(a),this._logService=i.invokeFunction(y=>y.get(P.ILogService)),k.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=i.invokeFunction(y=>y.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(o,L)=>{let O="",W,ee;for(const ce of L)O+=`
	at ${ce.toString()}`,ee=ce.getFileName(),!W&&ee&&(W=y.findSubstr(ee));return p.set(o,W),`${o.name||"Error"}: ${o.message||""}${O}`}});const h=this._rpcProtocol.getProxy(C.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(C.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(y=>{const o=R.transformErrorForSerialization(y),L=p.get(y);L?h.$onExtensionRuntimeError(L.identifier,o):b.$onUnexpectedError(o)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([v.timeout(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,f){d.extensions.forEach(r=>r.extensionLocation=A.URI.revive(f.transformIncomingURIs(r.extensionLocation))),d.environment.appRoot=A.URI.revive(f.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(r=>A.URI.revive(f.transformIncomingURIs(r)))),d.environment.extensionTestsLocationURI=A.URI.revive(f.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=A.URI.revive(f.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=A.URI.revive(f.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=A.URI.revive(f.transformIncomingURIs(d.logsLocation)),d.logFile=A.URI.revive(f.transformIncomingURIs(d.logFile)),d.workspace=f.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=E}),define(ge[255],pe([0,1,9,21,55,30,24,43,31]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(l,g,c){this.config=l,this.provider=g,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const g=this.config.folderQueries||[];return new Promise((c,m)=>{const _=w=>{this.resultCount++,l(w)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const E=w.toString(),u=v.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,u)||this.matchFile(_,{base:w,basename:u})}),Promise.all(g.map(w=>this.searchInFolder(w,_))).then(w=>{c({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{m(new Error(k.toErrorMessage(w)))})})}async searchInFolder(l,g){const c=new R.CancellationTokenSource,m=this.getSearchOptionsForFolder(l),_=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,l),E=!w.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=C.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,c.token),f=u.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(r=>{const n=v.posix.relative(l.folder.path,r.path);if(E){const i=v.basename(r.path);this.matchFile(g,{base:l.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(_,l.folder,n,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,w,g),{providerTime:f,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const g=D.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=D.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:g,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},g,c,m){if(c===this.filePattern){const w=v.basename(this.filePattern);this.matchFile(m,{base:g,relativePath:this.filePattern,basename:w})}function _(w){const E=v.basename(w),u=v.dirname(w);let d=l[u];d||(d=l[u]=[],_(u)),d.push({base:g,relativePath:w,basename:E})}_(c)}matchDirectoryTree({rootEntries:l,pathToEntries:g},c,m){const _=this,w=this.filePattern;function E(u){const d=S.hasSiblingFn(()=>u.map(f=>f.basename));for(let f=0,t=u.length;f<t;f++){const r=u[f],{relativePath:n,basename:i}=r;if(!c.includedInQuerySync(n,i,w!==i?d:void 0))continue;const a=g[n];if(a)E(a);else{if(n===w)continue;_.matchFile(m,r)}if(_.isLimitHit)break}}E(l)}matchFile(l,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(g))}}class s{constructor(){this.sessions=new Map}fileSearch(l,g,c,m){const _=this.getSessionTokenSource(l.cacheKey),w=new P(l,g,_&&_.token);let E=0;const u=d=>{E+=d.length,c(d.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(w,s.BATCH_SIZE,u,m).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:d.stats}}))}clearCache(l){const g=this.getSessionTokenSource(l);g&&g.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,g,c,m){m.onCancellationRequested(()=>{l.cancel()});const _=E=>{E&&(w.push(E),g>0&&w.length>=g&&(c(w),w=[]))};let w=[];return l.search(_).then(E=>(w.length&&c(w),E),E=>(w.length&&c(w),Promise.reject(E)))}}e.FileSearchManager=s,s.BATCH_SIZE=512}),define(ge[127],pe([0,1,9,17,21,55,24,30,2,31,10,13]),function(X,e,v,R,k,S,A,C,D,P,s,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,d,f){this.query=u,this.provider=d,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,d){const f=this.query.folderQueries||[],t=new k.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((r,n)=>{this.collector=new c(u);let i=!1;const a=(p,h)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(p);_(p)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const y=this.resultSize(p);this.resultCount+=y,(y>0||!_(p))&&this.collector.add(p,h)}};Promise.all(f.map((p,h)=>this.searchInFolder(p,b=>a(b,h),t.token))).then(p=>{t.dispose(),this.collector.flush();const h=p.some(b=>!!b&&!!b.limitHit);r({limitHit:this.isLimitHit||h,messages:R.flatten(p.map(b=>(b==null?void 0:b.message)?I.isArray(b.message)?b.message:[b.message]:[])),stats:{type:"textSearchProvider"}})},p=>{t.dispose();const h=S.toErrorMessage(p);n(new Error(h))})})}resultSize(u){return _(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,d){const f=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:f.slice(0,d),preview:{matches:t.slice(0,d),text:u.preview.text},uri:u.uri}}async searchInFolder(u,d,f){const t=new P.QueryGlobTester(this.query,u),r=[],n={report:p=>{if(!this.validateProviderResult(p))return;const h=u.folder.scheme===s.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(p.uri))):void 0,b=A.relativePath(u.folder,p.uri);b&&r.push(t.includedInQuery(b,v.basename(b),h).then(y=>{y&&d(p)}))}},i=this.getSearchOptionsForFolder(u),a=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,n,f);return await Promise.all(r),a}validateProviderResult(u){if(_(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const d=P.resolvePatternsForProvider(this.query.includePattern,u.includePattern),f=P.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:D.URI.from(u.folder),excludes:f,includes:d,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function g(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,d=>this.sendItems(d))}add(u,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(m(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function m(E){return _(E)?{preview:{matches:R.mapArrayOrNot(E.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:E.preview.text},ranges:R.mapArrayOrNot(E.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function _(E){return!!E.preview}e.extensionResultIsMatch=_;class w{constructor(u,d){this.maxBatchSize=u,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,d){!u||this.addItemToBatch(u,d)}addItems(u,d){!u||this.addItemsToBatch(u,d)}addItemToBatch(u,d){this.batch.push(u),this.batchSize+=d,this.onUpdate()}addItemsToBatch(u,d){this.batch=this.batch.concat(u),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(ge[67],pe([0,1,6,5,4,255,12,59,15,2,127]),function(X,e,v,R,k,S,A,C,D,P,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=k.createDecorator("IExtHostSearch");let I=class{constructor(m,_,w){this.extHostRpc=m,this._uriTransformer=_,this._logService=w,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,_){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const w=this._handlePool++;return this._textSearchProvider.set(w,_),this._proxy.$registerTextSearchProvider(w,this._transformScheme(m)),v.toDisposable(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(m,_){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const w=this._handlePool++;return this._fileSearchProvider.set(w,_),this._proxy.$registerFileSearchProvider(w,this._transformScheme(m)),v.toDisposable(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(m,_,w,E){const u=l(w),d=this._fileSearchProvider.get(m);if(d)return this._fileSearchManager.fileSearch(u,d,f=>{this._proxy.$handleFileMatch(m,_,f.map(t=>t.resource))},E);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,_,w,E){const u=this._textSearchProvider.get(m);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const d=l(w);return this.createTextSearchManager(d,u).search(t=>this._proxy.$handleTextMatch(m,_,t),E)}createTextSearchManager(m,_){return new s.TextSearchManager(m,_,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};I=Ve([He(0,A.IExtHostRpcService),He(1,C.IURITransformerService),He(2,D.ILogService)],I),e.ExtHostSearch=I;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(g),extraFileResources:c.extraFileResources&&c.extraFileResources.map(m=>P.URI.revive(m))})}e.reviveQuery=l;function g(c){return Object.assign(Object.assign({},c),{folder:P.URI.revive(c.folder)})}}),define(ge[256],pe([0,1,21,16,3,52,2,150,104,141,77,42,5,217,216,47,218,36,219,220,221,203,222,39,40,223,204,225,226,227,62,206,231,232,233,87,33,234,207,18,7,237,63,126,34,35,68,194,224,116,125,65,48,67,15,59,12,27,228,192,46,61,214,235,191,88,86,240,238,239,215,58,248,236,85,45,117,229,64,230,10,182]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d,f,t,r,n,i,a,p,h,b,y,o,L,O,W,ee,ce,G,x,V,T,N,F,M,U,B,K,ie,we,Te,ye,Oe,je,ze,qe,j,J,ne,oe,Y,le,me,Re,We,be,Xe,Q,re,ve,Me,Ne,Ye,Se,_e,ke,ae,fe,H,Z,ue,Pe,Ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function xe(Be){const Qe=Be.get(ne.IExtHostInitDataService),rt=Be.get(Ye.IExtHostFileSystemInfo),nt=Be.get(Q.IExtHostConsumerFileSystem),Ze=Be.get(n.IExtHostExtensionService),ot=Be.get(U.IExtHostWorkspace),Ee=Be.get(fe.IExtHostTelemetry),De=Be.get(w.IExtHostConfiguration),de=Be.get(j.IURITransformerService),q=Be.get(J.IExtHostRpcService),Ue=Be.get(ee.IExtHostStorage),Le=Be.get(Xe.IExtensionStoragePaths),Ge=Be.get(qe.ILogService),Je=Be.get(le.IExtHostTunnelService),lt=Be.get(me.IExtHostApiDeprecationService),ct=Be.get(M.IExtHostWindow),it=Be.get(ke.IExtHostSecretState),mt=Be.get(ae.IExtHostEditorTabs);q.set(l.ExtHostContext.ExtHostFileSystemInfo,rt),q.set(l.ExtHostContext.ExtHostLogService,Ge),q.set(l.ExtHostContext.ExtHostWorkspace,ot),q.set(l.ExtHostContext.ExtHostConfiguration,De),q.set(l.ExtHostContext.ExtHostExtensionService,Ze),q.set(l.ExtHostContext.ExtHostStorage,Ue),q.set(l.ExtHostContext.ExtHostTunnelService,Je),q.set(l.ExtHostContext.ExtHostWindow,ct),q.set(l.ExtHostContext.ExtHostSecretState,it),q.set(l.ExtHostContext.ExtHostTelemetry,Ee),q.set(l.ExtHostContext.ExtHostEditorTabs,mt);const St=q.set(l.ExtHostContext.ExtHostDecorations,Be.get(ye.IExtHostDecorations)),vt=q.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Be.get(r.IExtHostDocumentsAndEditors)),bt=q.set(l.ExtHostContext.ExtHostCommands,Be.get(m.IExtHostCommands)),gt=q.set(l.ExtHostContext.ExtHostTerminalService,Be.get(ce.IExtHostTerminalService)),ht=q.set(l.ExtHostContext.ExtHostDebugService,Be.get(je.IExtHostDebugService)),kt=q.set(l.ExtHostContext.ExtHostSearch,Be.get(ze.IExtHostSearch)),_t=q.set(l.ExtHostContext.ExtHostTask,Be.get(Oe.IExtHostTask)),It=q.set(l.ExtHostContext.ExtHostOutputService,Be.get(y.IExtHostOutputService)),Lt=q.set(l.ExtHostContext.ExtHostUrls,new N.ExtHostUrls(q)),Et=q.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(q,vt)),qt=q.set(l.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(q,vt,Ge)),Gt=q.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new f.ExtHostDocumentSaveParticipant(Ge,Et,q.getProxy(l.MainContext.MainThreadBulkEdits))),ft=q.set(l.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(q,bt,vt,Et,Ge,Le)),Kt=q.set(l.ExtHostContext.ExtHostNotebookKernels,new H.ExtHostNotebookKernels(q,Qe,ft,Ge)),Qt=q.set(l.ExtHostContext.ExtHostNotebookRenderers,new ue.ExtHostNotebookRenderers(q,ft)),Dt=q.set(l.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(q,vt)),ln=q.set(l.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(q.getProxy(l.MainContext.MainThreadTreeViews),bt,Ge)),Xt=q.set(l.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(q.getProxy(l.MainContext.MainThreadEditorInsets),Dt,Qe)),xt=q.set(l.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(q,Ge)),ut=q.set(l.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(q,de,Et,bt,xt,Ge,lt)),Yt=q.set(l.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(q,ut)),Ft=q.set(l.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(q,Ge,vt)),Mt=q.set(l.ExtHostContext.ExtHostQuickOpen,L.createExtHostQuickOpen(q,ot,bt)),Vt=q.set(l.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(q,bt,Ge)),bn=q.set(l.ExtHostContext.ExtHostComments,new _.ExtHostComments(q,bt,Et)),cn=q.set(l.ExtHostContext.ExtHostProgress,new o.ExtHostProgress(q.getProxy(l.MainContext.MainThreadProgress))),En=q.set(l.ExtHostContext.ExtHosLabelService,new we.ExtHostLabelService(q)),un=q.set(l.ExtHostContext.ExtHostTheming,new Y.ExtHostTheming(q)),Bt=q.set(l.ExtHostContext.ExtHostAuthentication,new Re.ExtHostAuthentication(q)),Jt=q.set(l.ExtHostContext.ExtHostTimeline,new We.ExtHostTimeline(q,bt)),Ht=q.set(l.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(q,{remote:Qe.remote},ot,Ge,lt)),Zt=q.set(l.ExtHostContext.ExtHostWebviewPanels,new Me.ExtHostWebviewPanels(q,Ht,ot)),_n=q.set(l.ExtHostContext.ExtHostCustomEditors,new ve.ExtHostCustomEditors(q,Et,Le,Ht,Zt)),Sn=q.set(l.ExtHostContext.ExtHostWebviewViews,new re.ExtHostWebviewViews(q,Ht)),Ot=q.set(l.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(q,vt,ot)),jt=q.set(l.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(q)),yn=K.values(l.ExtHostContext);q.assertRegistered(yn);const Dn=new Ne.ExtHostBulkEdits(q,vt),en=new c.ExtHostClipboard(q),tn=new b.ExtHostMessageService(q,Ge),$t=new u.ExtHostDialogs(q),Tt=new W.ExtHostStatusBar(q,bt.converter),nn=new h.ExtHostLanguages(q,Et);return g.ExtHostApiCommands.register(bt),function(Fe,Wt,dn){const pt=function(){let te=!Fe.isUnderDevelopment;function he(Ie){te||(Ge.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")he(st);else{const wt=st;typeof wt.scheme=="undefined"&&he(st),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&B.throwProposedApiError(Fe)}return st}}(),Cn={getSession(te,he,Ie){return Bt.getSession(Fe,te,he,Ie)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ie,st){return Bt.registerAuthenticationProvider(te,he,Ie,st)},get onDidChangeAuthenticationProviders(){return B.checkProposedApiEnabled(Fe),Bt.onDidChangeAuthenticationProviders},get providers(){return B.checkProposedApiEnabled(Fe),Bt.providers},logout(te,he){return B.checkProposedApiEnabled(Fe),Bt.removeSession(te,he)}},kn={registerCommand(te,he,Ie){return bt.registerCommand(!0,te,he,Ie)},registerTextEditorCommand(te,he,Ie){return bt.registerCommand(!0,te,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ct=>{he.apply(Ie,[wt,Ct,...st])}).then(Ct=>{Ct||Ge.warn("Edits from command "+te+" were not applied.")},Ct=>{Ge.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,he,Ie)=>(B.checkProposedApiEnabled(Fe),bt.registerCommand(!0,te,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(wt.id);he.apply(Ie,[Ct,...st])})),executeCommand(te,...he){return bt.executeCommand(te,...he)},getCommands(te=!1){return bt.getCommands(te)}},hn={get machineId(){return Qe.telemetryInfo.machineId},get sessionId(){return Qe.telemetryInfo.sessionId},get language(){return Qe.environment.appLanguage},get appName(){return Qe.environment.appName},get appRoot(){var te,he;return(he=(te=Qe.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Qe.environment.appUriScheme},get clipboard(){return en.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ee.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ee.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(Qe.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return ct.openUri(te,{allowTunneling:!!Qe.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Qe.environment.appUriScheme)return Lt.createAppUri(te);const he=Ae.matchesScheme(te,Pe.Schemas.http)||Ae.matchesScheme(te,Pe.Schemas.https);he||B.checkProposedApiEnabled(Fe);try{return await ct.asExternalUri(te,{allowTunneling:!!Qe.remote.authority})}catch(Ie){if(he)return te;throw Ie}},get remoteName(){return Te.getRemoteName(Qe.remote.authority)},get uiKind(){return Qe.uiKind}};Qe.environment.extensionTestsLocationURI||Object.freeze(hn);const fn=Qe.remote.isRemote?T.ExtensionKind.Workspace:T.ExtensionKind.UI,rn={registerTestController(te){return B.checkProposedApiEnabled(Fe),Ot.registerTestController(Fe.identifier.value,te)},createDocumentTestObserver(te){return B.checkProposedApiEnabled(Fe),Ot.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return B.checkProposedApiEnabled(Fe),Ot.createWorkspaceTestObserver(te)},runTests(te){return B.checkProposedApiEnabled(Fe),Ot.runTests(te)},createTestItem(te,he){return new T.TestItemImpl(te.id,te.label,te.uri,he)},createTestRun(te,he,Ie){return B.checkProposedApiEnabled(Fe),Ot.createTestRun(Fe.identifier.value,te,he,Ie)},get onDidChangeTestResults(){return B.checkProposedApiEnabled(Fe),Ot.onResultsChanged},get testResults(){return B.checkProposedApiEnabled(Fe),Ot.results}};rn.createTestRunTask=rn.createTestRun;const sn={getExtension(te){const he=Wt.getExtensionDescription(te);if(he)return new n.Extension(Ze,Fe.identifier,he,fn)},get all(){return Wt.getAllExtensionDescriptions().map(te=>new n.Extension(Ze,Fe.identifier,te,fn))},get onDidChange(){return Wt.onDidChange}},Pn={createDiagnosticCollection(te){return xt.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return xt.onDidChangeDiagnostics},getDiagnostics:te=>xt.getDiagnostics(te),getLanguages(){return nn.getLanguages()},setTextDocumentLanguage(te,he){return nn.changeLanguage(te.uri,he)},match(te,he){return s.score(V.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ie){return ut.registerCodeActionProvider(Fe,pt(te),he,Ie)},registerCodeLensProvider(te,he){return ut.registerCodeLensProvider(Fe,pt(te),he)},registerDefinitionProvider(te,he){return ut.registerDefinitionProvider(Fe,pt(te),he)},registerDeclarationProvider(te,he){return ut.registerDeclarationProvider(Fe,pt(te),he)},registerImplementationProvider(te,he){return ut.registerImplementationProvider(Fe,pt(te),he)},registerTypeDefinitionProvider(te,he){return ut.registerTypeDefinitionProvider(Fe,pt(te),he)},registerHoverProvider(te,he){return ut.registerHoverProvider(Fe,pt(te),he,Fe.identifier)},registerEvaluatableExpressionProvider(te,he){return ut.registerEvaluatableExpressionProvider(Fe,pt(te),he,Fe.identifier)},registerInlineValuesProvider(te,he){return ut.registerInlineValuesProvider(Fe,pt(te),he,Fe.identifier)},registerDocumentHighlightProvider(te,he){return ut.registerDocumentHighlightProvider(Fe,pt(te),he)},registerLinkedEditingRangeProvider(te,he){return ut.registerLinkedEditingRangeProvider(Fe,pt(te),he)},registerReferenceProvider(te,he){return ut.registerReferenceProvider(Fe,pt(te),he)},registerRenameProvider(te,he){return ut.registerRenameProvider(Fe,pt(te),he)},registerDocumentSymbolProvider(te,he,Ie){return ut.registerDocumentSymbolProvider(Fe,pt(te),he,Ie)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,he){return ut.registerDocumentFormattingEditProvider(Fe,pt(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return ut.registerDocumentRangeFormattingEditProvider(Fe,pt(te),he)},registerOnTypeFormattingEditProvider(te,he,Ie,...st){return ut.registerOnTypeFormattingEditProvider(Fe,pt(te),he,[Ie].concat(st))},registerDocumentSemanticTokensProvider(te,he,Ie){return ut.registerDocumentSemanticTokensProvider(Fe,pt(te),he,Ie)},registerDocumentRangeSemanticTokensProvider(te,he,Ie){return ut.registerDocumentRangeSemanticTokensProvider(Fe,pt(te),he,Ie)},registerSignatureHelpProvider(te,he,Ie,...st){return typeof Ie=="object"?ut.registerSignatureHelpProvider(Fe,pt(te),he,Ie):ut.registerSignatureHelpProvider(Fe,pt(te),he,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(te,he,...Ie){return ut.registerCompletionItemProvider(Fe,pt(te),he,Ie)},registerInlineCompletionItemProvider(te,he){return B.checkProposedApiEnabled(Fe),ut.registerInlineCompletionsProvider(Fe,pt(te),he)},registerDocumentLinkProvider(te,he){return ut.registerDocumentLinkProvider(Fe,pt(te),he)},registerColorProvider(te,he){return ut.registerColorProvider(Fe,pt(te),he)},registerFoldingRangeProvider(te,he){return ut.registerFoldingRangeProvider(Fe,pt(te),he)},registerSelectionRangeProvider(te,he){return ut.registerSelectionRangeProvider(Fe,te,he)},registerCallHierarchyProvider(te,he){return ut.registerCallHierarchyProvider(Fe,te,he)},setLanguageConfiguration:(te,he)=>ut.setLanguageConfiguration(Fe,te,he),getTokenInformationAtPosition(te,he){return B.checkProposedApiEnabled(Fe),nn.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return B.checkProposedApiEnabled(Fe),ut.registerInlayHintsProvider(Fe,te,he)}},In={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,he,Ie){const st=await(A.URI.isUri(te)?Promise.resolve(mn.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,he,Ie)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,he,Ie){return Dt.onDidChangeActiveTextEditor(te,he,Ie)},onDidChangeVisibleTextEditors(te,he,Ie){return Dt.onDidChangeVisibleTextEditors(te,he,Ie)},onDidChangeTextEditorSelection(te,he,Ie){return Dt.onDidChangeTextEditorSelection(te,he,Ie)},onDidChangeTextEditorOptions(te,he,Ie){return Dt.onDidChangeTextEditorOptions(te,he,Ie)},onDidChangeTextEditorVisibleRanges(te,he,Ie){return Dt.onDidChangeTextEditorVisibleRanges(te,he,Ie)},onDidChangeTextEditorViewColumn(te,he,Ie){return Dt.onDidChangeTextEditorViewColumn(te,he,Ie)},onDidCloseTerminal(te,he,Ie){return gt.onDidCloseTerminal(te,he,Ie)},onDidOpenTerminal(te,he,Ie){return gt.onDidOpenTerminal(te,he,Ie)},onDidChangeActiveTerminal(te,he,Ie){return gt.onDidChangeActiveTerminal(te,he,Ie)},onDidChangeTerminalDimensions(te,he,Ie){return B.checkProposedApiEnabled(Fe),gt.onDidChangeTerminalDimensions(te,he,Ie)},onDidWriteTerminalData(te,he,Ie){return B.checkProposedApiEnabled(Fe),gt.onDidWriteTerminalData(te,he,Ie)},get state(){return ct.state},onDidChangeWindowState(te,he,Ie){return ct.onDidChangeWindowState(te,he,Ie)},showInformationMessage(te,...he){return tn.showMessage(Fe,S.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return tn.showMessage(Fe,S.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return tn.showMessage(Fe,S.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ie){return Mt.showQuickPick(te,!!Fe.enableProposedApi,he,Ie)},showWorkspaceFolderPick(te){return Mt.showWorkspaceFolderPick(te)},showInputBox(te,he){return Mt.showInput(te,he)},showOpenDialog(te){return $t.showOpenDialog(te)},showSaveDialog(te){return $t.showSaveDialog(te)},createStatusBarItem(te,he,Ie){let st,wt,Ct;return typeof te=="string"?(st=te,wt=he,Ct=Ie):(wt=te,Ct=he),Tt.createStatusBarEntry(Fe,st,wt,Ct)},setStatusBarMessage(te,he){return Tt.setStatusBarMessage(te,he)},withScmProgress(te){return lt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),cn.withProgress(Fe,{location:T.ProgressLocation.SourceControl},(he,Ie)=>te({report(st){}}))},withProgress(te,he){return cn.withProgress(Fe,te,he)},createOutputChannel(te){return It.createOutputChannel(te)},createWebviewPanel(te,he,Ie,st){return Zt.createWebviewPanel(Fe,te,he,Ie,st)},createWebviewTextEditorInset(te,he,Ie,st){return B.checkProposedApiEnabled(Fe),Xt.createWebviewEditorInset(te,he,Ie,st,Fe)},createTerminal(te,he,Ie){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):(te.iconPath&&B.checkProposedApiEnabled(Fe),gt.createTerminalFromOptions(te)):gt.createTerminal(te,he,Ie)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return gt.registerProfileProvider(te,he)},registerTreeDataProvider(te,he){return ln.registerTreeDataProvider(te,he,Fe)},createTreeView(te,he){return ln.createTreeView(te,he,Fe)},registerWebviewPanelSerializer:(te,he)=>Zt.registerWebviewPanelSerializer(Fe,te,he),registerCustomEditorProvider:(te,he,Ie={})=>_n.registerCustomEditorProvider(Fe,te,he,Ie),registerFileDecorationProvider(te){return St.registerFileDecorationProvider(te,Fe.identifier)},registerUriHandler(te){return Lt.registerUriHandler(Fe.identifier,te)},createQuickPick(){return Mt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return Mt.createInputBox(Fe.identifier)},get activeColorTheme(){return un.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ie){return un.onDidChangeActiveColorTheme(te,he,Ie)},registerWebviewViewProvider(te,he,Ie){return Sn.registerWebviewViewProvider(Fe,te,he,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return B.checkProposedApiEnabled(Fe),ft.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeActiveNotebookEditor(te,he,Ie)},get visibleNotebookEditors(){return B.checkProposedApiEnabled(Fe),ft.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return B.checkProposedApiEnabled(Fe),ft.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookEditorSelection(te,he,Ie)},onDidChangeNotebookEditorVisibleRanges(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookEditorVisibleRanges(te,he,Ie)},showNotebookDocument(te,he){return B.checkProposedApiEnabled(Fe),ft.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ie){return B.checkProposedApiEnabled(Fe),jt.registerExternalUriOpener(Fe.identifier,te,he,Ie)},get openEditors(){return B.checkProposedApiEnabled(Fe),mt.tabs},get onDidChangeOpenEditors(){return B.checkProposedApiEnabled(Fe),mt.onDidChangeTabs},getInlineCompletionItemController(te){return B.checkProposedApiEnabled(Fe),p.InlineCompletionController.get(te)}},mn={get rootPath(){return lt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw R.readonly()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw R.readonly()},updateWorkspaceFolders:(te,he,...Ie)=>ot.updateWorkspaceFolders(Fe,te,he||0,...Ie),onDidChangeWorkspaceFolders:function(te,he,Ie){return ot.onDidChangeWorkspace(te,he,Ie)},asRelativePath:(te,he)=>ot.getRelativePath(te,he),findFiles:(te,he,Ie,st)=>ot.findFiles(V.GlobPattern.from(te),V.GlobPattern.from(he),Ie,Fe.identifier,st),findTextInFiles:(te,he,Ie,st)=>{let wt,Ct;return typeof he=="object"?(wt=he,Ct=Ie):(wt={},Ct=he,st=Ie),ot.findTextInFiles(te,wt||{},Ct,Fe.identifier,st)},saveAll:te=>ot.saveAll(te),applyEdit(te){return Dn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ie,st)=>Ft.createFileSystemWatcher(V.GlobPattern.from(te),he,Ie,st),get textDocuments(){return Et.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.readonly()},openTextDocument(te){let he;const Ie=te;if(typeof te=="string")he=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))he=Promise.resolve(te);else if(!Ie||typeof Ie=="object")he=Et.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>Et.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(te,he,Ie)=>Et.onDidAddDocument(te,he,Ie),onDidCloseTextDocument:(te,he,Ie)=>Et.onDidRemoveDocument(te,he,Ie),onDidChangeTextDocument:(te,he,Ie)=>Et.onDidChangeDocument(te,he,Ie),onDidSaveTextDocument:(te,he,Ie)=>Et.onDidSaveDocument(te,he,Ie),onWillSaveTextDocument:(te,he,Ie)=>Gt.getOnWillSaveTextDocumentEvent(Fe)(te,he,Ie),get notebookDocuments(){return ft.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ie;if(A.URI.isUri(te))Ie=te,await ft.openNotebookDocument(te);else if(typeof te=="string")Ie=A.URI.revive(await ft.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return ft.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return ft.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ft.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ie,st){return ft.registerNotebookSerializer(Fe,te,he,Ie,Fe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(te,he,Ie,st)=>(B.checkProposedApiEnabled(Fe),ft.registerNotebookContentProvider(Fe,te,he,Ie,Fe.enableProposedApi?st:void 0)),onDidChangeConfiguration:(te,he,Ie)=>dn.onDidChangeConfiguration(te,he,Ie),getConfiguration(te,he){return he=arguments.length===1?void 0:he,dn.getConfiguration(te,he,Fe)},registerTextDocumentContentProvider(te,he){return qt.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(lt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Fe,te,he)),registerFileSystemProvider(te,he,Ie){return Yt.registerFileSystemProvider(Fe.identifier,te,he,Ie,Fe.enableProposedApi)},get fs(){return nt.value},registerFileSearchProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),kt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),kt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>(B.checkProposedApiEnabled(Fe),Ze.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>(B.checkProposedApiEnabled(Fe),En.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ie)=>Ft.onDidCreateFile(te,he,Ie),onDidDeleteFiles:(te,he,Ie)=>Ft.onDidDeleteFile(te,he,Ie),onDidRenameFiles:(te,he,Ie)=>Ft.onDidRenameFile(te,he,Ie),onWillCreateFiles:(te,he,Ie)=>Ft.getOnWillCreateFileEvent(Fe)(te,he,Ie),onWillDeleteFiles:(te,he,Ie)=>Ft.getOnWillDeleteFileEvent(Fe)(te,he,Ie),onWillRenameFiles:(te,he,Ie)=>Ft.getOnWillRenameFileEvent(Fe)(te,he,Ie),openTunnel:te=>(B.checkProposedApiEnabled(Fe),Je.openTunnel(Fe,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return B.checkProposedApiEnabled(Fe),Je.getTunnels()},onDidChangeTunnels:(te,he,Ie)=>(B.checkProposedApiEnabled(Fe),Je.onDidChangeTunnels(te,he,Ie)),registerPortAttributesProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),Je.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>(B.checkProposedApiEnabled(Fe),Jt.registerTimelineProvider(te,he,Fe.identifier,bt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>(B.checkProposedApiEnabled(Fe),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ie)=>ot.onDidGrantWorkspaceTrust(te,he,Ie)},An={get inputBox(){return lt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Fe)},createSourceControl(te,he,Ie){return Vt.createSourceControl(Fe,te,he,Ie)}},Tn={createCommentController(te,he){return bn.createCommentController(Fe,te,he)}},Rn={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},onDidStartDebugSession(te,he,Ie){return ht.onDidStartDebugSession(te,he,Ie)},onDidTerminateDebugSession(te,he,Ie){return ht.onDidTerminateDebugSession(te,he,Ie)},onDidChangeActiveDebugSession(te,he,Ie){return ht.onDidChangeActiveDebugSession(te,he,Ie)},onDidReceiveDebugSessionCustomEvent(te,he,Ie){return ht.onDidReceiveDebugSessionCustomEvent(te,he,Ie)},onDidChangeBreakpoints(te,he,Ie){return ht.onDidChangeBreakpoints(te,he,Ie)},registerDebugConfigurationProvider(te,he,Ie){return ht.registerDebugConfigurationProvider(te,he,Ie||T.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return ht.registerDebugAdapterDescriptorFactory(Fe,te,he)},registerDebugAdapterTrackerFactory(te,he){return ht.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?ht.startDebugging(te,he,{parentSession:Ie}):ht.startDebugging(te,he,Ie||{})},stopDebugging(te){return ht.stopDebugging(te)},addBreakpoints(te){return ht.addBreakpoints(te)},removeBreakpoints(te){return ht.removeBreakpoints(te)},asDebugSourceUri(te,he){return ht.asDebugSourceUri(te,he)}},gn={registerTaskProvider:(te,he)=>_t.registerTaskProvider(Fe,te,he),fetchTasks:te=>_t.fetchTasks(te),executeTask:te=>_t.executeTask(Fe,te),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(te,he,Ie)=>_t.onDidStartTask(te,he,Ie),onDidEndTask:(te,he,Ie)=>_t.onDidEndTask(te,he,Ie),onDidStartTaskProcess:(te,he,Ie)=>_t.onDidStartTaskProcess(te,he,Ie),onDidEndTaskProcess:(te,he,Ie)=>_t.onDidEndTaskProcess(te,he,Ie)},pn={createNotebookController(te,he,Ie,st,wt){return Kt.createNotebookController(Fe,te,he,Ie,st,Fe.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>ft.registerNotebookCellStatusBarItemProvider(Fe,te,he),get onDidSaveNotebookDocument(){return B.checkProposedApiEnabled(Fe),ft.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return B.checkProposedApiEnabled(Fe),ft.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return B.checkProposedApiEnabled(Fe),Qt.createRendererMessaging(te)},onDidChangeNotebookDocumentMetadata(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookDocumentMetadata(te,he,Ie)},onDidChangeNotebookCells(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookCells(te,he,Ie)},onDidChangeNotebookCellExecutionState(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeNotebookCellExecutionState(te,he,Ie)},onDidChangeCellOutputs(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeCellOutputs(te,he,Ie)},onDidChangeCellMetadata(te,he,Ie){return B.checkProposedApiEnabled(Fe),ft.onDidChangeCellMetadata(te,he,Ie)},createConcatTextDocument(te,he){return B.checkProposedApiEnabled(Fe),new be.ExtHostNotebookConcatDocument(ft,Et,te,he)}};return{version:Qe.version,authentication:Cn,commands:kn,comments:Tn,debug:Rn,env:hn,extensions:sn,languages:Pn,notebooks:pn,scm:An,tasks:gn,test:rn,window:In,workspace:mn,Breakpoint:T.Breakpoint,CallHierarchyIncomingCall:T.CallHierarchyIncomingCall,CallHierarchyItem:T.CallHierarchyItem,CallHierarchyOutgoingCall:T.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:v.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:T.CodeAction,CodeActionKind:T.CodeActionKind,CodeActionTriggerKind:T.CodeActionTriggerKind,CodeLens:T.CodeLens,Color:T.Color,ColorInformation:T.ColorInformation,ColorPresentation:T.ColorPresentation,ColorThemeKind:T.ColorThemeKind,CommentMode:T.CommentMode,CommentThreadCollapsibleState:T.CommentThreadCollapsibleState,CompletionItem:T.CompletionItem,CompletionItemKind:T.CompletionItemKind,CompletionItemTag:T.CompletionItemTag,CompletionList:T.CompletionList,CompletionTriggerKind:T.CompletionTriggerKind,ConfigurationTarget:T.ConfigurationTarget,CustomExecution:T.CustomExecution,DebugAdapterExecutable:T.DebugAdapterExecutable,DebugAdapterInlineImplementation:T.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:T.DebugAdapterNamedPipeServer,DebugAdapterServer:T.DebugAdapterServer,DebugConfigurationProviderTriggerKind:T.DebugConfigurationProviderTriggerKind,DebugConsoleMode:T.DebugConsoleMode,DecorationRangeBehavior:T.DecorationRangeBehavior,Diagnostic:T.Diagnostic,DiagnosticRelatedInformation:T.DiagnosticRelatedInformation,DiagnosticSeverity:T.DiagnosticSeverity,DiagnosticTag:T.DiagnosticTag,Disposable:T.Disposable,DocumentHighlight:T.DocumentHighlight,DocumentHighlightKind:T.DocumentHighlightKind,DocumentLink:T.DocumentLink,DocumentSymbol:T.DocumentSymbol,EndOfLine:T.EndOfLine,EnvironmentVariableMutatorType:T.EnvironmentVariableMutatorType,EvaluatableExpression:T.EvaluatableExpression,InlineValueText:T.InlineValueText,InlineValueVariableLookup:T.InlineValueVariableLookup,InlineValueEvaluatableExpression:T.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:T.InlineCompletionTriggerKind,EventEmitter:k.Emitter,ExtensionKind:T.ExtensionKind,ExtensionMode:T.ExtensionMode,ExternalUriOpenerPriority:T.ExternalUriOpenerPriority,FileChangeType:T.FileChangeType,FileDecoration:T.FileDecoration,FileSystemError:T.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:T.FoldingRange,FoldingRangeKind:T.FoldingRangeKind,FunctionBreakpoint:T.FunctionBreakpoint,InlineCompletionItem:T.InlineSuggestion,InlineCompletionList:T.InlineSuggestions,Hover:T.Hover,IndentAction:P.IndentAction,Location:T.Location,MarkdownString:T.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:T.ParameterInformation,PortAutoForwardAction:T.PortAutoForwardAction,Position:T.Position,ProcessExecution:T.ProcessExecution,ProgressLocation:T.ProgressLocation,QuickInputButtons:T.QuickInputButtons,Range:T.Range,RelativePattern:T.RelativePattern,Selection:T.Selection,SelectionRange:T.SelectionRange,SemanticTokens:T.SemanticTokens,SemanticTokensBuilder:T.SemanticTokensBuilder,SemanticTokensEdit:T.SemanticTokensEdit,SemanticTokensEdits:T.SemanticTokensEdits,SemanticTokensLegend:T.SemanticTokensLegend,ShellExecution:T.ShellExecution,ShellQuoting:T.ShellQuoting,SignatureHelp:T.SignatureHelp,SignatureHelpTriggerKind:T.SignatureHelpTriggerKind,SignatureInformation:T.SignatureInformation,SnippetString:T.SnippetString,SourceBreakpoint:T.SourceBreakpoint,StandardTokenType:T.StandardTokenType,StatusBarAlignment:T.StatusBarAlignment,SymbolInformation:T.SymbolInformation,SymbolKind:T.SymbolKind,SymbolTag:T.SymbolTag,Task:T.Task,TaskGroup:T.TaskGroup,TaskPanelKind:T.TaskPanelKind,TaskRevealKind:T.TaskRevealKind,TaskScope:T.TaskScope,TextDocumentSaveReason:T.TextDocumentSaveReason,TextEdit:T.TextEdit,TextEditorCursorStyle:C.TextEditorCursorStyle,TextEditorLineNumbersStyle:T.TextEditorLineNumbersStyle,TextEditorRevealType:T.TextEditorRevealType,TextEditorSelectionChangeKind:T.TextEditorSelectionChangeKind,ThemeColor:T.ThemeColor,ThemeIcon:T.ThemeIcon,TreeItem:T.TreeItem,TreeItemCollapsibleState:T.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:T.ViewColumn,WorkspaceEdit:T.WorkspaceEdit,InlayHint:T.InlayHint,InlayHintKind:T.InlayHintKind,RemoteAuthorityResolverError:T.RemoteAuthorityResolverError,ResolvedAuthority:T.ResolvedAuthority,SourceControlInputBoxValidationType:T.SourceControlInputBoxValidationType,ExtensionRuntime:T.ExtensionRuntime,TimelineItem:T.TimelineItem,NotebookRange:T.NotebookRange,NotebookCellKind:T.NotebookCellKind,NotebookCellExecutionState:T.NotebookCellExecutionState,NotebookCellData:T.NotebookCellData,NotebookData:T.NotebookData,NotebookRendererScript:T.NotebookRendererScript,NotebookCellStatusBarAlignment:T.NotebookCellStatusBarAlignment,NotebookEditorRevealType:T.NotebookEditorRevealType,NotebookCellOutput:T.NotebookCellOutput,NotebookCellOutputItem:T.NotebookCellOutputItem,NotebookCellStatusBarItem:T.NotebookCellStatusBarItem,NotebookControllerAffinity:T.NotebookControllerAffinity,PortAttributes:T.PortAttributes,LinkedEditingRanges:T.LinkedEditingRanges,TestItemStatus:T.TestItemStatus,TestResultState:T.TestResultState,TestMessage:T.TestMessage,TextSearchCompleteMessageType:Z.TextSearchCompleteMessageType,TestMessageSeverity:T.TestMessageSeverity,WorkspaceTrustState:T.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=xe}),define(ge[257],pe([0,1,78,62,34,125,36,47,39,33,65,48,67,88,87,46,61,126,86,58,85,117,45]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E,u,d,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(g.IExtensionStoragePaths,g.ExtensionStoragePaths),v.registerSingleton(_.IExtHostApiDeprecationService,_.ExtHostApiDeprecationService),v.registerSingleton(C.IExtHostCommands,C.ExtHostCommands),v.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),v.registerSingleton(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),v.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),v.registerSingleton(S.IExtHostDecorations,S.ExtHostDecorations),v.registerSingleton(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),v.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),v.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),v.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),v.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),v.registerSingleton(s.IExtHostTask,s.WorkerExtHostTask),v.registerSingleton(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),v.registerSingleton(m.IExtHostTunnelService,m.ExtHostTunnelService),v.registerSingleton(w.IExtHostWindow,w.ExtHostWindow),v.registerSingleton(k.IExtHostWorkspace,k.ExtHostWorkspace),v.registerSingleton(d.IExtHostSecretState,d.ExtHostSecretState),v.registerSingleton(f.IExtHostTelemetry,f.ExtHostTelemetry),v.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(ge[89],pe([0,1,17,15,31,64]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function C(I,l,g,c){const m=v.mapArrayOrNot(g,D),_=new k.TextSearchMatch(l,m,c),w=_.preview.matches;return{ranges:v.mapArrayOrNot(m,P),uri:I,preview:{text:_.preview.text,matches:v.mapArrayOrNot(w,P)}}}e.createTextSearchResult=C;function D(I){return new k.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function P(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let s=class{constructor(l,g){this.prefix=l,this.logService=g}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};s=Ve([He(1,R.ILogService)],s),e.OutputChannel=s}),define(ge[258],pe([0,1,91,22]),function(X,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function k(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(r=>r===t)}e.isUTFEncoding=k,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,A=512,C=512*8,D=512*128;class P{constructor(r){this.iconvLiteDecoder=r}static async create(r){let n;if(r!==e.UTF8)n=(await new Promise((a,p)=>{X(["iconv-lite-umd"],a,p)})).getDecoder(g(r));else{const i=new TextDecoder;n={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new P(n)}write(r){return this.iconvLiteDecoder.write(r)}end(){return this.iconvLiteDecoder.end()}}function s(t,r){var n;const i=((n=r.minBytesRequiredForDetection)!==null&&n!==void 0?n:r.guessEncoding)?C:A;return new Promise((a,p)=>{const h=v.newWriteableStream(O=>O.join("")),b=[];let y=0,o;const L=async()=>{try{const O=await f({buffer:R.VSBuffer.concat(b),bytesRead:y},r.guessEncoding);O.encoding=await r.overwriteEncoding(O.encoding),o=await P.create(O.encoding);const W=o.write(R.VSBuffer.concat(b).buffer);h.write(W),b.length=0,y=0,a({stream:h,detected:O})}catch(O){p(O)}};v.listenStream(t,{onData:async O=>{o?h.write(o.write(O.buffer)):(b.push(O),y+=O.byteLength,y>=i&&(t.pause(),await L(),setTimeout(()=>t.resume())))},onError:O=>h.error(O),onEnd:async()=>{o||await L(),h.end(o==null?void 0:o.end())}})})}e.toDecodeStream=s;async function I(t,r,n){const a=(await new Promise((b,y)=>{X(["iconv-lite-umd"],b,y)})).getEncoder(g(r),n);let p=!1,h=!1;return{read(){if(h)return null;const b=t.read();if(typeof b!="string"){if(h=!0,!p&&(n==null?void 0:n.addBOM))switch(r){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=a.end();return y&&y.length>0?(p=!0,R.VSBuffer.wrap(y)):null}return p=!0,R.VSBuffer.wrap(a.write(b))}}}e.toEncodeReadable=I;async function l(t){return(await new Promise((n,i)=>{X(["iconv-lite-umd"],n,i)})).encodingExists(g(t))}e.encodingExists=l;function g(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=g;function c(t,r){if(!t||r<e.UTF16be_BOM.length)return null;const n=t.readUInt8(0),i=t.readUInt8(1);if(n===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(n===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(r<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return n===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const m=["ascii","utf-16","utf-32"];async function _(t){const r=await new Promise((h,b)=>{X(["jschardet"],h,b)}),n=t.slice(0,D),i=u(n.buffer),a=r.detect(i);if(!a||!a.encoding)return null;const p=a.encoding.toLowerCase();return 0<=m.indexOf(p)?null:E(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function E(t){const r=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[r]||r}function u(t){let r="";for(let n=0;n<t.length;n++)r+=String.fromCharCode(t[n]);return r}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const r=t.match(/windows(\d+)/);return r?"windows-"+r[1]:t}}e.toCanonicalName=d;function f({buffer:t,bytesRead:r},n){let i=c(t,r),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let p=!0,h=!0,b=!1;for(let y=0;y<r&&y<S;y++){const o=y%2==1,L=t.readUInt8(y)===0;if(L&&(b=!0),p&&(o&&!L||!o&&L)&&(p=!1),h&&(o&&L||!o&&!L)&&(h=!1),L&&!p&&!h)break}b&&(p?i=e.UTF16le:h?i=e.UTF16be:a=!0)}return n&&!a&&!i&&t?_(t.slice(0,r)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=f,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ge[128],pe([0,1,258,28,127]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends k.TextSearchManager{constructor(C,D,P=R){super(C,D,{readdir:s=>P.readdir(s.fsPath),toCanonicalName:s=>v.toCanonicalName(s)})}}e.NativeTextSearchManager=S}),define(ge[259],pe([0,1,260,274,275,2,276]),function(X,e,v,R,k,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function C(I,l,g,c,m,_){const w=_.environment.useHostProxy,E=typeof w=="boolean"?w:!_.remote.isRemote,u=A.createProxyResolver({resolveProxy:f=>I.resolveProxy(f),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(f,t,...r)=>{switch(f){case A.LogLevel.Trace:c.trace(t,...r);break;case A.LogLevel.Debug:c.debug(t,...r);break;case A.LogLevel.Info:c.info(t,...r);break;case A.LogLevel.Warning:c.warn(t,...r);break;case A.LogLevel.Error:c.error(t,...r);break;case A.LogLevel.Critical:c.critical(t,...r);break;case A.LogLevel.Off:break;default:n(f,t,r);break}function n(i,a,...p){c.error("Unknown log level",i),c.error(a,...p)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:f=>{m.$publicLog2("resolveProxy",f)},useHostProxy:E,env:process.env}),d=D(l,u);return s(g,d)}e.connectProxyResolver=C;function D(I,l){const g={config:I.getConfiguration("http").get("proxySupport")||"off"};I.onDidChangeConfiguration(m=>{g.config=I.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!I.getConfiguration("http").get("systemCertificates")};return I.onDidChangeConfiguration(m=>{c.config=!!I.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},v,A.createHttpPatch(v,l,{config:"off"},c,!0)),on:Object.assign({},v,A.createHttpPatch(v,l,{config:"on"},c,!0)),override:Object.assign({},v,A.createHttpPatch(v,l,{config:"override"},c,!0)),onRequest:Object.assign({},v,A.createHttpPatch(v,l,g,c,!0)),default:Object.assign(v,A.createHttpPatch(v,l,g,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,g,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,g,c,!1))},tls:Object.assign(k,A.createTlsPatch(k))}}const P=new Map;function s(I,l){return I.getExtensionPathIndex().then(g=>{const c=X.__$__nodeRequire("module"),m=c._load;c._load=function(w,E,u){if(w==="tls")return l.tls;if(w!=="http"&&w!=="https")return m.apply(this,arguments);const d=l[w],f=g.findSubstr(S.URI.file(E.filename).fsPath);let t=P.get(f);if(t||P.set(f,t={}),!t[w]){let r=d.default;f&&f.enableProposedApi&&(r=d[f.proxySupport]||d.onRequest),t[w]=Object.assign({},r)}return t[w]}})}}),define(ge[261],pe([0,1,38,9,75,29,11,8,89,262]),function(X,e,v,R,k,S,A,C,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const s=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(u,d,f,t){const r=l(u,d,f,t),n=d.folder.fsPath;return{cmd:v.spawn(s,r.args,{cwd:n}),rgDiskPath:s,siblingClauses:r.siblingClauses,rgArgs:r,cwd:n}}e.spawnRipgrepCmd=I;function l(u,d,f,t){const r=["--files","--hidden","--case-sensitive"];c([d],f,!1).forEach(i=>{const a=D.anchorGlob(i);if(r.push("-g",a),A.isMacintosh){const p=k.normalizeNFD(a);p!==a&&r.push("-g",p)}});const n=g([d],t,void 0,!1);return n.globArgs.forEach(i=>{const a=`!${D.anchorGlob(i)}`;if(r.push("-g",a),A.isMacintosh){const p=k.normalizeNFD(a);p!==a&&r.push("-g",p)}}),d.disregardIgnoreFiles!==!1?r.push("--no-ignore"):r.push("--no-ignore-parent"),d.ignoreSymlinks||r.push("--follow"),u.exists&&r.push("--quiet"),r.push("--no-config"),d.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:n.siblingClauses}}function g(u,d,f,t=!0){const r=[];let n={};return u.forEach(i=>{const a=Object.assign({},i.excludePattern||{},d||{}),p=m(a,t?i.folder.fsPath:void 0,f);r.push(...p.globArgs),p.siblingClauses&&(n=Object.assign(n,p.siblingClauses))}),{globArgs:r,siblingClauses:n}}e.foldersToRgExcludeGlobs=g;function c(u,d,f=!0){const t=[];return u.forEach(r=>{const n=Object.assign({},d||{},r.includePattern||{}),i=m(n,f?r.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=c;function m(u,d,f){const t=[],r={};return Object.keys(u).forEach(n=>{if(f&&f.has(n)||!n)return;const i=u[n];n=w(d?_(d,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof i=="boolean"&&i?(n.startsWith("\\\\")&&(n+="**"),t.push(E(n))):i&&i.when&&(r[n]=i)}),{globArgs:t,siblingClauses:r}}function _(u,d){return R.isAbsolute(d)?d:R.join(u,d)}e.getAbsoluteGlob=_;function w(u){return u=C.rtrim(u,"\\"),C.rtrim(u,"/")}function E(u){return S.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=E}),define(ge[263],pe([0,1,38,54,9,98,17,55,30,75,29,11,43,8,13,28,31,261,96]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(n=>n())});class d{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=E.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const p=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),h=a.folder.fsPath;i.folderQueries.map(b=>b.folder.fsPath).filter(b=>b!==h).forEach(b=>{s.isEqualOrParent(b,h)&&(p[k.relative(h,b)]=!0)}),this.folderExcludePatterns.set(h,new t(p,h))})}cancel(){this.isCanceled=!0}walk(i,a,p,h,b){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return b(null,this.isLimitHit);a.forEach(y=>{const o=k.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,o)||this.matchFile(p,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(i,(y,o)=>{this.call(this.cmdTraversal,this,y,p,h,L=>{if(L){const O=C.toErrorMessage(L);console.error(O),this.errors.push(O),o(L,void 0)}else o(null,void 0)})},(y,o)=>{this.fileWalkSW.stop();const L=y?A.coalesce(y)[0]:null;b(L,this.isLimitHit)})}parallel(i,a,p){const h=new Array(i.length),b=new Array(i.length);let y=!1,o=0;if(i.length===0)return p(null,[]);i.forEach((L,O)=>{a(L,(W,ee)=>{if(W?(y=!0,h[O]=null,b[O]=W):(h[O]=ee,b[O]=null),++o===i.length)return p(y?b:null,h)})})}call(i,a,...p){try{i.apply(a,p)}catch(h){p[p.length-1](h)}}cmdTraversal(i,a,p,h){const b=i.folder.fsPath,y=I.isMacintosh;let o;const L=()=>o&&o.kill();u.add(L);let O=T=>{u.delete(L),O=()=>{},h(T)},W="";const ee=this.initDirectoryTree();let ce;const G=w.spawnRipgrepCmd(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);o=G.cmd,ce=!Object.keys(G.siblingClauses).length;const x=G.rgArgs.args.map(T=>T.match(/^-/)?T:`'${T}'`).join(" ");let V=`${G.rgDiskPath} ${x}
 - cwd: ${G.cwd}`;G.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(G.rgArgs.siblingClauses)}`),p({message:V}),this.cmdResultCount=0,this.collectStdout(o,"utf8",p,(T,N,F)=>{if(T){O(T);return}if(this.isLimitHit){O();return}const U=(W+(y?P.normalizeNFC(N||""):N)).split(`
`);if(F){const B=U.length;U[B-1]=U[B-1].trim(),U[B-1]||U.pop()}else W=U.pop()||"";if(U.length&&U[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=U.length,ce){for(const B of U)if(this.matchFile(a,{base:b,relativePath:B,searchPath:this.getSearchPath(i,B)}),this.isLimitHit){L();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(i,ee,b,U,a),F&&(this.matchDirectoryTree(ee,b,a),O())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),p=a.getBasenameTerms(),h=a.getPathTerms(),b=["-L","."];if(p.length||h.length){b.push("-not","(","(");for(const y of p)b.push("-name",y),b.push("-o");for(const y of h)b.push("-path",y),b.push("-o");b.pop(),b.push(")","-prune",")")}return b.push("-type","f"),v.spawn("find",b,{cwd:i.folder.fsPath})}readStdout(i,a,p){let h="";this.collectStdout(i,a,()=>{},(b,y,o)=>{if(b){p(b);return}h+=y,o&&p(null,h)})}collectStdout(i,a,p,h){let b=(L,O,W)=>{(L||W)&&(b=()=>{},this.cmdSW&&this.cmdSW.stop()),h(L,O,W)},y=!1;i.stdout?(this.forwardData(i.stdout,a,b),i.stdout.once("data",()=>y=!0)):p({message:"stdout is null"});let o;i.stderr?o=this.collectData(i.stderr):p({message:"stderr is null"}),i.on("error",L=>{b(L)}),i.on("close",L=>{let O;!y&&(O=this.decodeData(o,a))&&r(O)?b(new Error(`command failed with error code ${L}: ${this.decodeData(o,a)}`)):(this.exists&&L===0&&(this.isLimitHit=!0),b(null,"",!0))})}forwardData(i,a,p){const h=new S.StringDecoder(a);return i.on("data",b=>{p(null,h.write(b))}),h}collectData(i){const a=[];return i.on("data",p=>{a.push(p)}),a}decodeData(i,a){const p=new S.StringDecoder(a);return i.map(h=>p.write(h)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},p,h,b){h.indexOf(this.filePattern)!==-1&&this.matchFile(b,{base:p,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const y=o=>{const L=k.basename(o),O=k.dirname(o);let W=a[O];W||(W=a[O]=[],y(O)),W.push({base:p,relativePath:o,basename:L,searchPath:this.getSearchPath(i,o)})};h.forEach(y)}matchDirectoryTree({rootEntries:i,pathToEntries:a},p,h){const b=this,y=this.folderExcludePatterns.get(p),o=this.filePattern;function L(O){b.directoriesWalked++;const W=D.hasSiblingFn(()=>O.map(ee=>ee.basename));for(let ee=0,ce=O.length;ee<ce;ee++){const G=O[ee],{relativePath:x,basename:V}=G;if(y.test(x,V,o!==V?W:void 0))continue;const T=a[x];if(T)L(T);else{if(b.filesWalked++,x===o)continue;b.matchFile(h,G)}if(b.isLimitHit)break}}L(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,p,h,b){const y=i.folder,o=D.hasSiblingFn(()=>p);this.parallel(p,(L,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const W=a?[a,L].join(k.sep):L;if(this.folderExcludePatterns.get(i.folder.fsPath).test(W,L,this.config.filePattern!==L?o:void 0))return O(null);const ee=[y.fsPath,W].join(k.sep);R.lstat(ee,(ce,G)=>{if(ce||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(ee,G,(x,V)=>x||this.isCanceled||this.isLimitHit?O(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ee,G,(T,N)=>T||this.isCanceled||this.isLimitHit||(N=N||"",this.walkedPaths[N])?O(null):(this.walkedPaths[N]=!0,m.readdir(ee).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(i,W,F,h,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,W===this.filePattern||this.maxFilesize&&c.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(h,{base:y.fsPath,relativePath:W,searchPath:this.getSearchPath(i,W)}),O(null,void 0)))})},L=>{const O=L&&A.coalesce(L);return b(O&&O.length>0?O[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,k.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return _.isFilePatternMatch(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,p){return a.isSymbolicLink()?R.stat(i,p):p(null,a)}realPathIfNeeded(i,a,p){return a.isSymbolicLink()?R.realpath(i,(h,b)=>h?p(h):p(null,b)):p(null,i)}getSearchPath(i,a){return i.folderName?k.join(i.folderName,a):a}}e.FileWalker=d;class f{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new d(i)}search(i,a,p){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(h,b)=>{p(h,{limitHit:b,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=f;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,p;Object.keys(i).filter(h=>i[h]).forEach(h=>{k.isAbsolute(h)?(a=a||D.getEmptyExpression(),a[h]=i[h]):(p=p||D.getEmptyExpression(),p[h]=i[h])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=p&&D.parse(p,{trimForExclusions:!0})}test(i,a,p){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,p)||this.absoluteParsedExpr&&this.absoluteParsedExpr(k.join(this.root,i),a,p)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function r(n){const i=n.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return g.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=r}),define(ge[129],pe([0,1,38,277,98,17,68,30,9,8,2,31,64,278,262,89]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(y){this.outputChannel=y}provideTextSearchResults(y,o,L,O){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify(Object.assign(Object.assign({},o),{folder:o.folder.toString()}))}`),new Promise((W,ee)=>{O.onCancellationRequested(()=>M());const ce=r(y,o),G=o.folder.fsPath,x=ce.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.outputChannel.appendLine(`${_} ${x}
 - cwd: ${G}`);let V=v.spawn(_,ce,{cwd:G});V.on("error",we=>{console.error(we),this.outputChannel.appendLine("Error: "+(we&&we.message)),ee(I.serializeSearchError(new I.SearchError(we&&we.message,I.SearchErrorCode.rgProcessError)))});let T=!1;const N=new d(o.maxResults,G,o.previewOptions);N.on("result",we=>{T=!0,B="",L.report(we)});let F=!1;const M=()=>{F=!0,V&&V.kill(),N&&N.cancel()};let U=!1;N.on("hitLimit",()=>{U=!0,M()});let B="";V.stdout.on("data",we=>{N.handleData(we),T||(B+=we)});let K=!1;V.stdout.once("data",()=>K=!0);let ie="";V.stderr.on("data",we=>{const Te=we.toString();this.outputChannel.appendLine(Te),ie+=Te}),V.on("close",()=>{if(this.outputChannel.appendLine(K?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(T?"Got result from parser":"No result from parser"),B&&this.outputChannel.appendLine(`Got data without result: ${B}`),this.outputChannel.appendLine(""),F)W({limitHit:U});else{N.flush(),V=null;let we;ie&&!K&&(we=E(ie))?ee(I.serializeSearchError(new I.SearchError(we.message,we.code))):W({limitHit:U})}})})}}e.RipgrepTextSearchEngine=w;function E(b){const y=b.split(`
`),o=y[0].trim();if(y.some(O=>O.startsWith("regex parse error")))return new I.SearchError(u(y),I.SearchErrorCode.regexParseError);const L=o.match(/grep config error: unknown encoding: (.*)/);if(L)return new I.SearchError(`Unknown encoding: ${L[1]}`,I.SearchErrorCode.unknownEncoding);if(o.startsWith("error parsing glob"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.globParseError);if(o.startsWith("the literal"))return new I.SearchError(o.charAt(0).toUpperCase()+o.substr(1),I.SearchErrorCode.invalidLiteral);if(o.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(o,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=E;function u(b){const y=["Regex parse error"],o=b.filter(L=>L.startsWith("PCRE2:"));if(o.length>=1){const L=o[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const O=L.split(":")[1];y.push(":"+O)}}return y.join("")}e.buildRegexParseError=u;class d extends R.EventEmitter{constructor(y,o,L){super();this.maxResults=y,this.rootFolder=o,this.previewOptions=L,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new k.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,o){return super.on(y,o),this}handleData(y){if(this.isDone)return;const o=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(o)}handleDecodedData(y){let o=y.indexOf(`
`);const L=this.remainder+y;if(o>=0)o+=this.remainder.length;else{this.remainder=L;return}let O=0;for(;o>=0;)this.handleLine(L.substring(O,o).trim()),O=o+1,o=L.indexOf(`
`,O);this.remainder=L.substring(O)}handleLine(y){if(this.isDone||!y)return;let o;try{o=JSON.parse(y)}catch(L){throw new Error(`malformed line from rg: ${y}`)}if(o.type==="match"){const L=f(o.data.path),O=s.URI.file(D.join(this.rootFolder,L)),W=this.createTextSearchMatch(o.data,O);this.onResult(W),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(o.type==="context"){const L=f(o.data.path),O=s.URI.file(D.join(this.rootFolder,L));this.createTextSearchContext(o.data,O).forEach(ee=>this.onResult(ee))}}createTextSearchMatch(y,o){const L=y.line_number-1;let O=!1,W=f(y.lines);L===0&&P.startsWithUTF8BOM(W)&&(O=!0,W=P.stripUTF8BOM(W));const ee=Buffer.from(W);let ce=0,G=0,x=L;y.submatches.length===0&&y.submatches.push(W.length?{start:0,end:1,match:{text:W[0]}}:{start:0,end:0,match:{text:""}});const V=S.coalesce(y.submatches.map((T,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=f(T.match);L===0&&N===0&&O&&(F=P.stripUTF8BOM(F),T.start=T.start<=3?0:T.start-3,T.end=T.end<=3?0:T.end-3);const M=ee.slice(ce,T.start).toString().length,U=G+M,B=t(F),K=x,ie=B.numLines+K,we=B.numLines>0?B.lastLineLength:B.lastLineLength+U;return ce=T.end,G=we,x=ie,new l.Range(K,U,ie,we)}));return m.createTextSearchResult(o,W,V,this.previewOptions)}createTextSearchContext(y,o){const L=f(y.lines),O=y.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((W,ee)=>({text:W,uri:o,lineNumber:O+ee}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=d;function f(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const y=/\n/g;let o=0,L=-1,O;for(;O=y.exec(b);)o++,L=O.index;const W=L>=0?b.length-L-1:b.length;return{numLines:o,lastLineLength:W}}function r(b,y){const o=["--hidden"];o.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:O}=A.groupBy(y.includes,ee=>ee.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const ee=new Set;O.forEach(ce=>{ee.add(ce)}),o.push("-g","!*"),ee.forEach(ce=>{n(ce).map(m.anchorGlob).forEach(G=>{o.push("-g",G)})})}L&&L.length&&L.forEach(ee=>{o.push("-g",ee)}),y.excludes.map(m.anchorGlob).forEach(ee=>o.push("-g",`!${ee}`)),y.maxFileSize&&o.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?o.push("--no-ignore-parent"):o.push("--no-ignore"),y.followSymlinks&&o.push("--follow"),y.encoding&&y.encoding!=="utf8"&&o.push("--encoding",y.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=P.escapeRegExpCharacters(b.pattern),b.isRegExp=!0),y.usePCRE2&&o.push("--pcre2"),o.push("--crlf"),b.isRegExp&&(b.pattern=i(b.pattern),o.push("--auto-hybrid-regex"));let W;if(b.isWordMatch){const ce=P.createRegExp(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");o.push("--regexp",ce)}else if(b.isRegExp){let ee=p(b.pattern);ee=h(ee),o.push("--regexp",ee)}else W=b.pattern,o.push("--fixed-strings");return o.push("--no-config"),y.useGlobalIgnoreFiles||o.push("--no-ignore-global"),o.push("--json"),b.isMultiline&&o.push("--multiline"),y.beforeContext&&o.push("--before-context",y.beforeContext+""),y.afterContext&&o.push("--after-context",y.afterContext+""),o.push("--"),W&&o.push(W),o.push("."),o}function n(b){const y=C.splitGlobAware(b,"/");return y.map((o,L)=>y.slice(0,L+1).join("/"))}e.spreadGlobComponents=n;function i(b){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");const o=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(o);)b=b.replace(o,"$1\\x{$2}");return b}e.unicodeEscapesToPCRE2=i;const a=b=>b.type==="Assertion"&&b.kind==="lookbehind";function p(b){let y;try{y=new g.RegExpParser().parsePattern(b)}catch(ce){return b}let o="",L=0;const O=(ce,G,x)=>{o+=b.slice(L,ce)+x,L=G},W=[];return new g.RegExpVisitor({onCharacterEnter(ce){if(ce.raw!=="\\n")return;const G=W[0];if(!G)O(ce.start,ce.end,"\\r?\\n");else if(!W.some(a))if(G.type==="CharacterClass")if(G.negate){const x=b.slice(G.start+2,ce.start)+b.slice(ce.end,G.end-1);O(G.start,G.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=b.slice(G.start+1,ce.start)+b.slice(ce.end,G.end-1);O(G.start,G.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else G.type==="Quantifier"&&O(ce.start,ce.end,"(?:\\r?\\n)")},onQuantifierEnter(ce){W.unshift(ce)},onQuantifierLeave(){W.shift()},onCharacterClassRangeEnter(ce){W.unshift(ce)},onCharacterClassRangeLeave(){W.shift()},onCharacterClassEnter(ce){W.unshift(ce)},onCharacterClassLeave(){W.shift()},onAssertionEnter(ce){a(ce)&&W.push(ce)},onAssertionLeave(ce){W[0]===ce&&W.shift()}}).visit(y),o+=b.slice(L),o}e.fixRegexNewline=p;function h(b){return b.replace(/\n/g,"\\r?\\n")}e.fixNewline=h}),define(ge[264],pe([0,1,21,129,113,10]),function(X,e,v,R,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,s,I,l){const g=new R.RipgrepTextSearchEngine(this.outputChannel);if(s.folder.scheme===S.Schemas.userData){const c=Object.assign(Object.assign({},s),{folder:s.folder.with({scheme:S.Schemas.file})}),m=new k.Progress(_=>I.report(Object.assign(Object.assign({},_),{uri:_.uri.with({scheme:s.folder.scheme})})));return this.withToken(l,_=>g.provideTextSearchResults(P,c,m,_))}else return this.withToken(l,c=>g.provideTextSearchResults(P,s,I,c))}async withToken(P,s){const I=C(P);this.inProgress.add(I);const l=await s(I.token);return this.inProgress.delete(I),l}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=A;function C(D){const P=new v.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(ge[265],pe([0,1,28,129,128]),function(X,e,v,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(D){this.query=D}search(D,P,s){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(g){s({message:g})}},l=new k.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(I),v);return new Promise((g,c)=>l.search(m=>{P(m.map(A))},D).then(m=>g({limitHit:m.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=S;function A(C){return{path:C.resource&&C.resource.fsPath,results:C.results,numMatches:(C.results||[]).reduce((D,P)=>{if(P.ranges){const s=P;return D+(Array.isArray(s.ranges)?s.ranges.length:1)}else return D+1},0)}}}),define(ge[266],pe([0,1,54,279,17,14,16,3,96,9,43,2,42,31,263,265]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(v);class _{constructor(){this.caches=Object.create(null)}fileSearch(t){let r;const n=u(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=S.createCancelablePromise(a=>this.doFileSearchWithEngine(c.Engine,n,p=>i.fire(p),a)),r.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}textSearch(t){let r;const n=u(t),i=new C.Emitter({onFirstListenerDidAdd:()=>{r=S.createCancelablePromise(a=>this.ripgrepTextSearch(n,p=>i.fire(p),a)),r.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{r.cancel()}});return i.event}ripgrepTextSearch(t,r,n){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new m.TextSearchEngineAdapter(t).search(n,r,r)}doFileSearch(t,r,n){return this.doFileSearchWithEngine(c.Engine,t,r,n)}doFileSearchWithEngine(t,r,n,i,a=_.BATCH_SIZE){let p=0;const h=y=>{Array.isArray(y)?(p+=y.length,n(y.map(o=>this.rawMatchToSearchItem(o)))):y.relativePath?(p++,n(this.rawMatchToSearchItem(y))):n(y)};if(r.sortByScore){let y=this.trySortedSearchFromCache(r,h,i);if(!y){const o=r.maxResults?Object.assign({},r,{maxResults:null}):r,L=new t(o);y=this.doSortedSearch(L,r,n,h,i)}return new Promise((o,L)=>{y.then(([O,W])=>{const ee=W.map(ce=>this.rawMatchToSearchItem(ce));this.sendProgress(ee,n,a),o(O)},L)})}const b=new t(r);return this.doSearch(b,h,a,i).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:"searchProcess",fromCache:!1,resultCount:p,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?P.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,r,n,i,a){const p=new C.Emitter;let h=S.createCancelablePromise(y=>{let o=[];const L=O=>{Array.isArray(O)?o=O:(i(O),p.fire(O))};return this.doSearch(t,L,-1,y).then(O=>[O,o])}),b;if(r.cacheKey){b=this.getOrCreateCache(r.cacheKey);const y={promise:h,event:p.event,resolved:!1};b.resultsToSearchCache[r.filePattern||""]=y,h.then(()=>{y.resolved=!0},o=>{delete b.resultsToSearchCache[r.filePattern||""]}),h=this.preventCancellation(h)}return h.then(([y,o])=>{const L=b?b.scorerCache:Object.create(null),O=(typeof r.maxResults!="number"||r.maxResults>0)&&s.StopWatch.create(!1);return this.sortResults(r,o,L,a).then(W=>{const ee=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:ee,fromCache:!1,type:"searchProcess",workspaceFolderCount:r.folderQueries.length,resultCount:W.length},messages:y.messages,limitHit:y.limitHit||typeof r.maxResults=="number"&&o.length>r.maxResults},W]})})}getOrCreateCache(t){const r=this.caches[t];return r||(this.caches[t]=new w)}trySortedSearchFromCache(t,r,n){const i=t.cacheKey&&this.caches[t.cacheKey];if(!i)return;const a=this.getResultsFromCache(i,t.filePattern||"",r,n);if(a)return a.then(([p,h,b])=>{const y=s.StopWatch.create(!1);return this.sortResults(t,h,i.scorerCache,n).then(o=>{const L=y.elapsed(),O={fromCache:!0,detailStats:b,type:"searchProcess",resultCount:h.length,sortingTime:L};return[{type:"success",limitHit:p.limitHit||typeof t.maxResults=="number"&&h.length>t.maxResults,stats:O},o]})})}sortResults(t,r,n,i){const a=D.prepareQuery(t.filePattern||""),p=(b,y)=>D.compareItemsByFuzzyScore(b,y,a,!0,E,n),h=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return k.topAsync(r,p,h,1e4,i)}sendProgress(t,r,n){if(n&&n>0)for(let i=0;i<t.length;i+=n)r(t.slice(i,i+n));else r(t)}getResultsFromCache(t,r,n,i){const a=s.StopWatch.create(!1),p=r.indexOf(P.sep)>=0;let h;for(const L in t.resultsToSearchCache)if(r.startsWith(L)){if(p&&L.indexOf(P.sep)<0&&L!=="")continue;const O=t.resultsToSearchCache[L];h={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!h)return null;const b=a.elapsed(),y=s.StopWatch.create(!1),o=h.event(n);return i&&i.onCancellationRequested(()=>{o.dispose()}),h.promise.then(([L,O])=>{if(i&&i.isCancellationRequested)throw A.canceled();const W=[],ee=D.prepareQuery(r).normalizedLowercase;for(const ce of O)!g.isFilePatternMatch(ce,ee)||W.push(ce);return[L,W,{cacheWasResolved:h.resolved,cacheLookupTime:b,cacheFilterTime:y.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,r,n,i){return new Promise((a,p)=>{let h=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(b=>{b&&(n?(h.push(b),n>0&&h.length>=n&&(r(h),h=[])):r(b))},b=>{r(b)},(b,y)=>{h.length&&r(h),b?p(b):a(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(r,n){return t.then(r,n)}catch(r){return this.then(void 0,r)}finally(r){return t.finally(r)}}}}e.SearchService=_,_.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(f){return P.basename(f.relativePath)}getItemDescription(f){return P.dirname(f.relativePath)}getItemPath(f){return f.relativePath}};function u(f){return Object.assign(Object.assign({},f),{folderQueries:f.folderQueries&&f.folderQueries.map(d),extraFileResources:f.extraFileResources&&f.extraFileResources.map(t=>I.URI.revive(t))})}function d(f){return Object.assign(Object.assign({},f),{folder:I.URI.revive(f.folder)})}}),define(ge[267],pe([0,1,6,2,28,15,31,266,264,89,12,59,27,67,10,128]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends g.ExtHostSearch{constructor(E,u,d,f){super(E,d,f);this._pfs=k,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new D.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const E=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new D.RipgrepSearchProvider(E)),this.registerInternalFileSearchProvider(c.Schemas.file,new C.SearchService)}registerInternalFileSearchProvider(E,u){const d=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(E)),v.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(E,u,d,f){const t=g.reviveQuery(d);return E===this._internalFileSearchHandle?this.doInternalFileSearch(E,u,t,f):super.$provideFileSearchResults(E,u,d,f)}doInternalFileSearch(E,u,d,f){const t=r=>{if(A.isSerializedFileMatch(r)&&(r=[r]),Array.isArray(r)){this._proxy.$handleFileMatch(E,u,r.map(n=>R.URI.file(n.path)));return}r.message&&this._logService.debug("ExtHostSearch",r.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,f)}$clearCache(E){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(E),super.$clearCache(E)}createTextSearchManager(E,u){return new m.NativeTextSearchManager(E,u)}};_=Ve([He(0,s.IExtHostRpcService),He(1,l.IExtHostInitDataService),He(2,I.IURITransformerService),He(3,S.ILogService)],_),e.NativeExtHostSearch=_}),define(ge[130],pe([0,1,280,120,281,3,101,9,99,32,6,22,102,16,11]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(h){this.socket=h,this._errorListener=b=>{if(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(h){const b=y=>h(I.VSBuffer.wrap(y));return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(h){return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(h){return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(h){if(!this.socket.destroyed)try{this.socket.write(h.buffer,b=>{if(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}})}catch(b){if(b.code==="EPIPE")return;g.onUnexpectedError(b)}}end(){this.socket.end()}drain(){return new Promise((h,b)=>{if(this.socket.bufferSize===0){h();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),h()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=m;var _;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var w;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(w||(w={}));class E extends s.Disposable{constructor(h,b,y,o){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=h,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=b,this._recordInflateBytes=o,b?(this._zlibInflate=k.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibInflate.on("data",L=>{this._pendingInflateData.push(L)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=k.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{console.error(L),g.onUnexpectedError(L),this._onClose.fire()}),this._zlibDeflate.on("data",L=>{this._pendingDeflateData.push(L)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(L=>this._acceptChunk(L))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?I.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):I.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(h){return this._onData.event(h)}onClose(h){return this._onClose.event(h)}onEnd(h){return this.socket.onEnd(h)}write(h){this._totalOutgoingDataBytes+=h.byteLength,this._zlibDeflate?(this._zlibDeflate.write(h.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let b=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.length-4),this._isEnded||this._write(I.VSBuffer.wrap(b),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(h,!1)}_write(h,b){let y=2;h.byteLength<126?y+=0:h.byteLength<2**16?y+=2:y+=8;const o=I.VSBuffer.alloc(y);if(b?o.writeUInt8(194,0):o.writeUInt8(130,0),h.byteLength<126)o.writeUInt8(h.byteLength,1);else if(h.byteLength<2**16){o.writeUInt8(126,1);let L=1;o.writeUInt8(h.byteLength>>>8&255,++L),o.writeUInt8(h.byteLength>>>0&255,++L)}else{o.writeUInt8(127,1);let L=1;o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(0,++L),o.writeUInt8(h.byteLength>>>24&255,++L),o.writeUInt8(h.byteLength>>>16&255,++L),o.writeUInt8(h.byteLength>>>8&255,++L),o.writeUInt8(h.byteLength>>>0&255,++L)}this._totalOutgoingWireBytes+=o.byteLength+h.byteLength,this.socket.write(I.VSBuffer.concat([o,h]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(h){if(h.byteLength!==0){for(this._totalIncomingWireBytes+=h.byteLength,this._incomingData.acceptChunk(h);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),o=(b.readUInt8(0)&128)>>>7,L=b.readUInt8(1),O=(L&128)>>>7,W=L&127;this._state.state=2,this._state.readLen=2+(O?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),y=b.readUInt8(1),o=(y&128)>>>7;let L=y&127,O=1;L===126?L=b.readUInt8(++O)*2**8+b.readUInt8(++O):L===127&&(L=b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*0+b.readUInt8(++O)*2**24+b.readUInt8(++O)*2**16+b.readUInt8(++O)*2**8+b.readUInt8(++O));let W=0;o&&(W=b.readUInt8(++O)*2**24+b.readUInt8(++O)*2**16+b.readUInt8(++O)*2**8+b.readUInt8(++O)),this._state.state=3,this._state.readLen=L,this._state.mask=W}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);u(b,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(b.buffer)),this._zlibInflate.write(b.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(I.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=b.byteLength,this._onData.fire(b))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=E;function u(p,h){if(h===0)return;let b=p.byteLength>>>2;for(let ee=0;ee<b;ee++){const ce=p.readUInt32BE(ee*4);p.writeUInt32BE(ce^h,ee*4)}let y=b*4,o=p.byteLength-y;const L=h>>>24&255,O=h>>>16&255,W=h>>>8&255;o>=1&&p.writeUInt8(p.readUInt8(y)^L,y),o>=2&&p.writeUInt8(p.readUInt8(y+1)^O,y+1),o>=3&&p.writeUInt8(p.readUInt8(y+2)^W,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function f(){const p=P.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let h;return e.XDG_RUNTIME_DIR?h=C.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):h=C.join(D.tmpdir(),`vscode-ipc-${p}.sock`),r(h),h}e.createRandomIPCHandle=f;function t(p,h,b){const y=v.createHash("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${b}-${h}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=C.join(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${b}-${h}.sock`):o=C.join(p,`${b}-${h}.sock`),r(o),o}e.createStaticIPCHandle=t;function r(p){const h=d[c.platform];typeof h=="number"&&p.length>=h&&console.warn(`WARNING: IPC handle "${p}" is longer than ${h} chars, try a shorter --user-data-dir`)}class n extends A.IPCServer{constructor(h){super(n.toClientConnectionEvent(h));this.server=h}static toClientConnectionEvent(h){const b=S.Event.fromNodeEventEmitter(h,"connection");return S.Event.map(b,y=>({protocol:new l.Protocol(new m(y)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(p){return new Promise((h,b)=>{const y=R.createServer();y.on("error",b),y.listen(p,()=>{y.removeListener("error",b),h(new n(y))})})}e.serve=i;function a(p,h){return new Promise((b,y)=>{const o=R.createConnection(p,()=>{o.removeListener("error",y),b(l.Client.fromSocket(new m(o),h))});o.once("error",y)})}e.connect=a}),define(ge[268],pe([0,1,130,260,54,47,2,188,15]),function(X,e,v,R,k,S,A,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(l,g,c){this._commands=l,this.logService=g,this._ipcHandlePath=c,this._server=R.createServer((m,_)=>this.onRequest(m,_)),this.setup().catch(m=>(g.error(m),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,g){const c=[];l.setEncoding("utf8"),l.on("data",m=>c.push(m)),l.on("end",()=>{const m=JSON.parse(c.join(""));switch(m.type){case"open":this.open(m,g);break;case"openExternal":this.openExternal(m,g);break;case"status":this.getStatus(m,g);break;case"extensionManagement":this.manageExtensions(m,g).catch(this.logService.error);break;default:g.writeHead(404),g.write(`Unknown message type: ${m.type}`,_=>{_&&this.logService.error(_)}),g.end();break}})}open(l,g){let{fileURIs:c,folderURIs:m,forceNewWindow:_,diffMode:w,addMode:E,forceReuseWindow:u,gotoLineMode:d,waitMarkerFilePath:f}=l;const t=[];if(Array.isArray(m))for(const r of m)try{t.push({folderUri:A.URI.parse(r)})}catch(n){}if(Array.isArray(c))for(const r of c)try{C.hasWorkspaceFileExtension(r)?t.push({workspaceUri:A.URI.parse(r)}):t.push({fileUri:A.URI.parse(r)})}catch(n){}if(t.length){const r=f?A.URI.file(f):void 0,i={forceNewWindow:_,diffMode:w,addMode:E,gotoLineMode:d,forceReuseWindow:u,preferNewWindow:!u&&!r&&!E,waitMarkerFileURI:r};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}g.writeHead(200),g.end()}async openExternal(l,g){for(const c of l.uris){const m=A.URI.parse(c),_=m.scheme==="file"?m:c;await this._commands.executeCommand("_remoteCLI.openExternal",_)}g.writeHead(200),g.end()}async manageExtensions(l,g){try{const c=w=>w==null?void 0:w.map(E=>/\.vsix$/i.test(E)?A.URI.parse(E):E),m={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",m);g.writeHead(200),g.write(_)}catch(c){g.writeHead(500),g.write(String(c),m=>{m&&this.logService.error(m)})}g.end()}async getStatus(l,g){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");g.writeHead(200),g.write(c),g.end()}catch(c){g.writeHead(500),g.write(String(c),m=>{m&&this.logService.error(m)}),g.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&k.existsSync(this._ipcHandlePath)&&k.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let s=class extends P{constructor(l,g){super(l,g,v.createRandomIPCHandle())}};s=Ve([He(0,S.IExtHostCommands),He(1,D.ILogService)],s),e.CLIServer=s}),define(ge[269],pe([0,1,66,256,251,5,259,40,241,2,10,7,268,100]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends k.RequireInterceptor{_installInterceptor(){const w=this,E=X.__$__nodeRequire("module"),u=E._load;E._load=function(f,t,r){for(let n of w._alternatives){let i=n(f);if(i){f=i;break}}return w._factories.has(f)?w._factories.get(f).load(f,P.URI.file(g.realpathSync(t.filename)),n=>u.apply(this,[n,t,r])):u.apply(this,arguments)}}}class m extends C.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,w,this._registry).install(),v.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),v.mark("code/extHost/didInitProxyResolver");const d=process.send,f=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(f.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,E,u){if(E.scheme!==s.Schemas.file)throw new Error(`Cannot load URI: '${E}', must be of file-scheme`);let d=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${E.toString(!0)}`),this._logService.flush();try{w&&v.mark(`code/extHost/willLoadExtensionCode/${w.value}`),d=X.__$__nodeRequire(E.fsPath)}catch(f){return Promise.reject(f)}finally{w&&v.mark(`code/extHost/didLoadExtensionCode/${w.value}`),u.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const E in w){const u=w[E];u===null?delete process.env[E]:process.env[E]=u}}}e.ExtHostExtensionService=m}),define(ge[270],pe([0,1,78,242,243,253,252,267,269,212,244,48,40,62,67,65,33,46,15]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m,_,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.registerSingleton(l.IExtHostExtensionService,D.ExtHostExtensionService),v.registerSingleton(E.ILogService,P.ExtHostLogService),v.registerSingleton(I.IExtHostDebugService,A.ExtHostDebugService),v.registerSingleton(g.IExtHostOutputService,R.ExtHostOutputService2),v.registerSingleton(c.IExtHostSearch,C.NativeExtHostSearch),v.registerSingleton(m.IExtHostTask,S.ExtHostTask),v.registerSingleton(_.IExtHostTerminalService,k.ExtHostTerminalService),v.registerSingleton(w.IExtHostTunnelService,s.ExtHostTunnelService)}),define(ge[271],pe([0,1,120,282,66,16,102,130,183,210,254,22,97,28,100,14,257,270]),function(X,e,v,R,k,S,A,C,D,P,s,I,l,g,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const _=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const n=X.__$__nodeRequire("module"),i=n._load;n._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function E(n){process.exit=function(i){if(n)w(i);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let u=function(n){w()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((n,i)=>{let a=null,p=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const h=108e5,b=3e5,y=new m.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),h),o=new m.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),b);process.on("message",(O,W)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ee=I.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let ce;if(O.skipWebSocketFrames)ce=new C.NodeSocket(W);else{const G=I.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));ce=new C.WebSocketNodeSocket(new C.NodeSocket(W),O.permessageDeflate,G,!1)}a?(y.cancel(),o.cancel(),a.beginAcceptReconnection(ce,ee),a.endAcceptReconnection()):(clearTimeout(p),a=new A.PersistentProtocol(ce,ee),a.onDidDispose(()=>u("renderer disconnected")),n(a),a.onSocketClose(()=>{y.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(o.isScheduled())return;y.isScheduled()&&o.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const n=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,a)=>{const p=v.createConnection(n,()=>{p.removeListener("error",a),i(new A.PersistentProtocol(new C.NodeSocket(p)))});p.once("error",a),p.on("close",()=>{u("renderer closed the socket")})})}}async function f(){const n=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,n.onMessage(i=>{P.isMessageOfType(i,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||n.send(i)}drain(){return n.drain()}}}function t(n){return new Promise(i=>{const a=n.onMessage(p=>{a.dispose();const h=JSON.parse(p.toString()),b=h.commit,y=D.default.commit;b&&y&&b!==y&&w(55);const o=[];process.on("unhandledRejection",(W,ee)=>{o.push(ee),setTimeout(()=>{const ce=o.indexOf(ee);ce>=0&&ee.catch(G=>{o.splice(ce,1),console.warn(`rejected promise not handled within 1 second: ${G}`),G&&G.stack&&console.warn(`stack trace: ${G.stack}`),S.onUnexpectedError(W)})},1e3)}),process.on("rejectionHandled",W=>{const ee=o.indexOf(W);ee>=0&&o.splice(ee,1)}),process.on("uncaughtException",function(W){S.onUnexpectedError(W)});let L=0;setInterval(function(){try{process.kill(h.parentPid,0),L=0}catch(W){W&&W.code==="EPERM"?(L++,L>=3&&u(`parent process ${h.parentPid} does not exist anymore (3 x EPERM): ${W.message} (code: ${W.code}) (errno: ${W.errno})`)):u(`parent process ${h.parentPid} does not exist anymore: ${W.message} (code: ${W.code}) (errno: ${W.errno})`)}},1e3);let O;try{O=X.__$__nodeRequire("native-watchdog"),O.start(h.parentPid)}catch(W){S.onUnexpectedError(W)}n.send(P.createMessageOfType(0)),i({protocol:n,initData:h})});n.send(P.createMessageOfType(1))})}async function r(){k.mark("code/extHost/willConnectToRenderer");const n=await f();k.mark("code/extHost/didConnectToRenderer");const i=await t(n);k.mark("code/extHost/didWaitForInitData");const{initData:a}=i;E(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=_.useHostProxy!==void 0?_.useHostProxy!=="false":void 0;const p=new class{exit(o){w(o)}exists(o){return g.exists(o)}realpath(o){return c.realpath(o)}};let h=null;if(a.remote.authority&&_.uriTransformerPath)try{const o=X.__$__nodeRequire(_.uriTransformerPath)(a.remote.authority);h=new l.URITransformer(o)}catch(y){console.error(y)}const b=new s.ExtensionHostMain(i.protocol,a,p,h);u=y=>b.terminate(y)}e.startExtensionHostProcess=r}),define(ge[283],pe([0,1,271]),function(X,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/507ce72a4466fbb27b715c3722558bb15afa9f48/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
